/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],T=0,_=J.length;T<_;T++)e[T]=te[J[T]];return e};define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function T(_,D){if(!_)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=T}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const T=Object.prototype.hasOwnProperty;function _(I){const C=[];for(let d in I)T.call(I,d)&&C.push(I[d]);return C}e.values=_;function D(I,C){for(let d in I)if(T.call(I,d)&&C({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=D;function L(I,C){const d=Object.create(null);for(const v of I){const h=C(v);let y=d[h];y||(y=d[h]=[]),y.push(v)}return d}e.groupBy=L;function i(I){const C=Object.create(null);return I&&I.forEach((d,v)=>{C[v]=d}),C}e.fromMap=i;function R(I,C){const d=[],v=[];for(let h of I)C.has(h)||d.push(h);for(let h of C)I.has(h)||v.push(h);return{removed:d,added:v}}e.diffSets=R;function w(I,C){const d=[],v=[];for(let[h,y]of I)C.has(h)||d.push(y);for(let[h,y]of C)I.has(h)||v.push(y);return{removed:d,added:v}}e.diffMaps=w;class b{constructor(){this.map=new Map}add(C,d){let v=this.map.get(C);v||(v=new Set,this.map.set(C,v)),v.add(d)}delete(C,d){const v=this.map.get(C);!v||(v.delete(d),v.size===0&&this.map.delete(C))}forEach(C,d){const v=this.map.get(C);!v||v.forEach(d)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function T(i){return(R,w,b)=>{let I=null,C=null;if(typeof b.value=="function"?(I="value",C=b.value):typeof b.get=="function"&&(I="get",C=b.get),!C)throw new Error("not supported");b[I]=i(C,w)}}e.createDecorator=T;function _(i,R,w){let b=null,I=null;if(typeof w.value=="function"?(b="value",I=w.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(b="get",I=w.get),!I)throw new Error("not supported");const C=`$memoize$${R}`;w[b]=function(...d){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[C]}}e.memoize=_;function D(i,R,w){return T((b,I)=>{const C=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...v){this[d]||(this[d]=w?w():void 0),clearTimeout(this[C]),R&&(this[d]=R(this[d],...v),v=[this[d]]),this[C]=setTimeout(()=>{b.apply(this,v),this[d]=w?w():void 0},i)}})}e.debounce=D;function L(i,R,w){return T((b,I)=>{const C=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...y){if(this[d]||(this[d]=w?w():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...y)),this[h])return;const p=this[v]+i;p<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[d]]),this[d]=w?w():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),b.apply(this,[this[d]]),this[d]=w?w():void 0},p-Date.now()))}})}e.throttle=L}),define(te[9],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class T{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(a=>{a(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=T,e.errorHandler=new T;function _(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=_;function D(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function L(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function i(l){if(l instanceof Error){let{name:s,message:a}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:s,message:a,stack:n}}return l}e.transformErrorForSerialization=i;const R="Canceled";function w(l){return l instanceof Error&&l.name===R&&l.message===R}e.isPromiseCanceledError=w;class b extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=b;function I(){const l=new Error(R);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(l){const s=new Error(`${l} has been disposed`);return s.name="DISPOSED",s}e.disposed=h;function y(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=y;class p extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=p;class m extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=m;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function f(l){const s=l;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=f;function c(l,s=Object.create(null)){const a=new Error(l);return s.actions&&(a.actions=s.actions),a}e.createErrorWithActions=c}),define(te[17],ne([0,1,9]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function _(M,N=0){return M[M.length-(1+N)]}e.tail=_;function D(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=D;function L(M,N,q=(x,K)=>x===K){if(M===N)return!0;if(!M||!N||M.length!==N.length)return!1;for(let x=0,K=M.length;x<K;x++)if(!q(M[x],N[x]))return!1;return!0}e.equals=L;function i(M,N,q){let x=0,K=M.length-1;for(;x<=K;){const ee=(x+K)/2|0,H=q(M[ee],N);if(H<0)x=ee+1;else if(H>0)K=ee-1;else return ee}return-(x+1)}e.binarySearch=i;function R(M,N){let q=0,x=M.length;if(x===0)return 0;for(;q<x;){const K=Math.floor((q+x)/2);N(M[K])?x=K:q=K+1}return q}e.findFirstInSorted=R;function w(M,N,q){if(M=M|0,M>=N.length)throw new TypeError("invalid index");let x=N[Math.floor(N.length*Math.random())],K=[],ee=[],H=[];for(let X of N){const re=q(X,x);re<0?K.push(X):re>0?ee.push(X):H.push(X)}return M<K.length?w(M,K,q):M<K.length+H.length?H[0]:w(M-(K.length+H.length),ee,q)}e.quickSelect=w;function b(M,N){const q=[];let x;for(const K of M.slice(0).sort(N))!x||N(x[0],K)!==0?(x=[K],q.push(x)):x.push(K);return q}e.groupBy=b;function I(M,N,q){const x=[];function K(X,re,oe){if(re===0&&oe.length===0)return;const le=x[x.length-1];le&&le.start+le.deleteCount===X?(le.deleteCount+=re,le.toInsert.push(...oe)):x.push({start:X,deleteCount:re,toInsert:oe})}let ee=0,H=0;for(;;){if(ee===M.length){K(ee,0,N.slice(H));break}if(H===N.length){K(ee,M.length-ee,[]);break}const X=M[ee],re=N[H],oe=q(X,re);oe===0?(ee+=1,H+=1):oe<0?(K(ee,1,[]),ee+=1):oe>0&&(K(ee,0,[re]),H+=1)}return x}e.sortedDiff=I;function C(M,N,q){const x=I(M,N,q),K=[],ee=[];for(const H of x)K.push(...M.slice(H.start,H.start+H.deleteCount)),ee.push(...H.toInsert);return{removed:K,added:ee}}e.delta=C;function d(M,N,q){if(q===0)return[];const x=M.slice(0,q).sort(N);return h(M,N,x,q,M.length),x}e.top=d;function v(M,N,q,x,K){return q===0?Promise.resolve([]):new Promise((ee,H)=>{(async()=>{const X=M.length,re=M.slice(0,q).sort(N);for(let oe=q,le=Math.min(q+x,X);oe<X;oe=le,le=Math.min(le+x,X)){if(oe>q&&await new Promise(he=>setTimeout(he)),K&&K.isCancellationRequested)throw(0,T.canceled)();h(M,N,re,oe,le)}return re})().then(ee,H)})}e.topAsync=v;function h(M,N,q,x,K){for(const ee=q.length;x<K;x++){const H=M[x];if(N(H,q[ee-1])<0){q.pop();const X=R(q,re=>N(H,re)<0);q.splice(X,0,H)}}}function y(M){return M.filter(N=>!!N)}e.coalesce=y;function p(M){let N=0;for(let q=0;q<M.length;q++)M[q]&&(M[N]=M[q],N+=1);M.length=N}e.coalesceInPlace=p;function m(M,N,q){M.splice(q,0,M.splice(N,1)[0])}e.move=m;function E(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=E;function f(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=f;function c(M,N=q=>q){const q=new Set;return M.filter(x=>{const K=N(x);return q.has(K)?!1:(q.add(K),!0)})}e.distinct=c;function l(M){const N=Object.create(null);return q=>{const x=M(q);return N[x]?!1:(N[x]=!0,!0)}}e.uniqueFilter=l;function s(M,N){const q=a(M,N);if(q!==-1)return M[q]}e.findLast=s;function a(M,N){for(let q=M.length-1;q>=0;q--){const x=M[q];if(N(x))return q}return-1}e.lastIndex=a;function n(M,N){return M.length>0?M[0]:N}e.firstOrDefault=n;function t(M,N,q=(x,K)=>x===K){let x=0;for(let K=0,ee=Math.min(M.length,N.length);K<ee&&q(M[K],N[K]);K++)x++;return x}e.commonPrefixLength=t;function r(M){return[].concat(...M)}e.flatten=r;function o(M,N){let q=typeof N=="number"?M:0;typeof N=="number"?q=M:(q=0,N=M);const x=[];if(q<=N)for(let K=q;K<N;K++)x.push(K);else for(let K=q;K>N;K--)x.push(K);return x}e.range=o;function u(M,N,q){return M.reduce((x,K)=>(x[N(K)]=q?q(K):K,x),Object.create(null))}e.index=u;function g(M,N){return M.push(N),()=>S(M,N)}e.insert=g;function S(M,N){const q=M.indexOf(N);if(q>-1)return M.splice(q,1),N}e.remove=S;function P(M,N,q){const x=M.slice(0,N),K=M.slice(N);return x.concat(q,K)}e.arrayInsert=P;function O(M,N){let q;if(typeof N=="number"){let x=N;q=()=>{const K=Math.sin(x++)*179426549;return K-Math.floor(K)}}else q=Math.random;for(let x=M.length-1;x>0;x-=1){const K=Math.floor(q()*(x+1)),ee=M[x];M[x]=M[K],M[K]=ee}}e.shuffle=O;function U(M,N){const q=M.indexOf(N);q>-1&&(M.splice(q,1),M.unshift(N))}e.pushToStart=U;function W(M,N){const q=M.indexOf(N);q>-1&&(M.splice(q,1),M.push(N))}e.pushToEnd=W;function $(M,N){return Array.isArray(M)?M.map(N):N(M)}e.mapArrayOrNot=$;function k(M){return Array.isArray(M)?M:[M]}e.asArray=k;function z(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=z;function A(M,N){for(const q of M){const x=N(q);if(x!==void 0)return x}}e.mapFind=A;function F(M,N,q){const x=Z(M,N),K=M.length,ee=q.length;M.length=K+ee;for(let H=K-1;H>=x;H--)M[H+ee]=M[H];for(let H=0;H<ee;H++)M[H+x]=q[H]}e.insertInto=F;function B(M,N,q,x){const K=Z(M,N),ee=M.splice(K,q);return F(M,K,x),ee}e.splice=B;function Z(M,N){return N<0?Math.max(N+M.length,0):Math.min(N,M.length)}function V(M,N){let q=Number.MAX_SAFE_INTEGER,x=0;return M.forEach((K,ee)=>{const H=N(K);H<q&&(q=H,x=ee)}),x}e.minIndex=V;function j(M,N){let q=Number.MIN_SAFE_INTEGER,x=0;return M.forEach((K,ee)=>{const H=N(K);H>q&&(q=H,x=ee)}),x}e.maxIndex=j;class Q{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let q=this.firstIdx;for(;q<this.items.length&&N(this.items[q]);)q++;const x=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,x}takeFromEndWhile(N){let q=this.lastIdx;for(;q>=0&&N(this.items[q]);)q--;const x=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,x}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const q=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,q}}e.ArrayQueue=Q}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function T(_){const D=this;let L=!1,i;return function(){return L||(L=!0,i=_.apply(D,arguments)),i}}e.once=T}),define(te[56],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var T;(function(_){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}_.is=D;const L=Object.freeze([]);function i(){return L}_.empty=i;function*R(l){yield l}_.single=R;function w(l){return l||L}_.from=w;function b(l){return!l||l[Symbol.iterator]().next().done===!0}_.isEmpty=b;function I(l){return l[Symbol.iterator]().next().value}_.first=I;function C(l,s){for(const a of l)if(s(a))return!0;return!1}_.some=C;function d(l,s){for(const a of l)if(s(a))return a}_.find=d;function*v(l,s){for(const a of l)s(a)&&(yield a)}_.filter=v;function*h(l,s){let a=0;for(const n of l)yield s(n,a++)}_.map=h;function*y(...l){for(const s of l)for(const a of s)yield a}_.concat=y;function*p(l){for(const s of l)for(const a of s)yield a}_.concatNested=p;function m(l,s,a){let n=a;for(const t of l)n=s(n,t);return n}_.reduce=m;function*E(l,s,a=l.length){for(s<0&&(s+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);s<a;s++)yield l[s]}_.slice=E;function f(l,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,l];const n=l[Symbol.iterator]();for(let t=0;t<s;t++){const r=n.next();if(r.done)return[a,_.empty()];a.push(r.value)}return[a,{[Symbol.iterator](){return n}}]}_.consume=f;function c(l,s,a=(n,t)=>n===t){const n=l[Symbol.iterator](),t=s[Symbol.iterator]();for(;;){const r=n.next(),o=t.next();if(r.done!==o.done)return!1;if(r.done)return!0;if(!a(r.value,o.value))return!1}}_.equals=c})(T=e.Iterable||(e.Iterable={}))}),define(te[31],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var _;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(_=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function i(s,a=!1){let n=0,t=s.length,r="",o=0,u=16,g=0;function S(z){let A=0,F=0;for(;A<z;){const B=s.charCodeAt(n);if(B>=48&&B<=57)F=F*16+B-48;else if(B>=65&&B<=70)F=F*16+B-65+10;else if(B>=97&&B<=102)F=F*16+B-97+10;else break;n++,A++}return A<z&&(F=-1),F}function P(z){n=z,r="",o=0,u=16,g=0}function O(){const z=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&b(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&b(s.charCodeAt(n)))for(n++;n<s.length&&b(s.charCodeAt(n));)n++;else return g=3,s.substring(z,n);let A=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&b(s.charCodeAt(n))){for(n++;n<s.length&&b(s.charCodeAt(n));)n++;A=n}else g=3;return s.substring(z,A)}function U(){let z="",A=n;for(;;){if(n>=t){z+=s.substring(A,n),g=2;break}const F=s.charCodeAt(n);if(F===34){z+=s.substring(A,n),n++;break}if(F===92){if(z+=s.substring(A,n),n++,n>=t){g=2;break}switch(s.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const Z=S(4);Z>=0?z+=String.fromCharCode(Z):g=4;break;default:g=5}A=n;continue}if(F>=0&&F<=31)if(w(F)){z+=s.substring(A,n),g=2;break}else g=6;n++}return z}function W(){if(r="",g=0,o=n,n>=t)return o=t,u=17;let z=s.charCodeAt(n);if(R(z)){do n++,r+=String.fromCharCode(z),z=s.charCodeAt(n);while(R(z));return u=15}if(w(z))return n++,r+=String.fromCharCode(z),z===13&&s.charCodeAt(n)===10&&(n++,r+=`
`),u=14;switch(z){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,r=U(),u=10;case 47:const A=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<t&&!w(s.charCodeAt(n));)n++;return r=s.substring(A,n),u=12}if(s.charCodeAt(n+1)===42){n+=2;const F=t-1;let B=!1;for(;n<F;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,g=1),r=s.substring(A,n),u=13}return r+=String.fromCharCode(z),n++,u=16;case 45:if(r+=String.fromCharCode(z),n++,n===t||!b(s.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=O(),u=11;default:for(;n<t&&$(z);)n++,z=s.charCodeAt(n);if(o!==n){switch(r=s.substring(o,n),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(z),n++,u=16}}function $(z){if(R(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let z;do z=W();while(z>=12&&z<=15);return z}return{setPosition:P,getPosition:()=>n,scan:a?k:W,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>g}}e.createScanner=i;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function w(s){return s===10||s===13||s===8232||s===8233}function b(s){return s>=48&&s<=57}var I;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(I||(I={}));function C(s,a){const n=[],t=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(S,P,O,U){o.value=S,o.offset=P,o.length=O,o.type=U,o.colonOffset=void 0,r=o}try{f(s,{onObjectBegin:(S,P)=>{if(a<=S)throw t;r=void 0,u=a>S,n.push("")},onObjectProperty:(S,P,O)=>{if(a<P||(g(S,P,O,"property"),n[n.length-1]=S,a<=P+O))throw t},onObjectEnd:(S,P)=>{if(a<=S)throw t;r=void 0,n.pop()},onArrayBegin:(S,P)=>{if(a<=S)throw t;r=void 0,n.push(0)},onArrayEnd:(S,P)=>{if(a<=S)throw t;r=void 0,n.pop()},onLiteralValue:(S,P,O)=>{if(a<P||(g(S,P,O,l(S)),a<=P+O))throw t},onSeparator:(S,P,O)=>{if(a<=P)throw t;if(S===":"&&r&&r.type==="property")r.colonOffset=P,u=!1,r=void 0;else if(S===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(u=!0,n[n.length-1]=""),r=void 0}}})}catch(S){if(S!==t)throw S}return{path:n,previousNode:r,isAtPropertyKey:u,matches:S=>{let P=0;for(let O=0;P<S.length&&O<n.length;O++)if(S[P]===n[O]||S[P]==="*")P++;else if(S[P]!=="**")return!1;return P===S.length}}}e.getLocation=C;function d(s,a=[],n=L.DEFAULT){let t=null,r=[];const o=[];function u(S){Array.isArray(r)?r.push(S):t!==null&&(r[t]=S)}return f(s,{onObjectBegin:()=>{const S={};u(S),o.push(r),r=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const S=[];u(S),o.push(r),r=S,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:u,onError:(S,P,O)=>{a.push({error:S,offset:P,length:O})}},n),r[0]}e.parse=d;function v(s,a=[],n=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){t.type==="property"&&(t.length=S-t.offset,t=t.parent)}function o(S){return t.children.push(S),S}f(s,{onObjectBegin:S=>{t=o({type:"object",offset:S,length:-1,parent:t,children:[]})},onObjectProperty:(S,P,O)=>{t=o({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:S,offset:P,length:O,parent:t})},onObjectEnd:(S,P)=>{t.length=S+P-t.offset,t=t.parent,r(S+P)},onArrayBegin:(S,P)=>{t=o({type:"array",offset:S,length:-1,parent:t,children:[]})},onArrayEnd:(S,P)=>{t.length=S+P-t.offset,t=t.parent,r(S+P)},onLiteralValue:(S,P,O)=>{o({type:l(S),offset:P,length:O,parent:t,value:S}),r(P+O)},onSeparator:(S,P,O)=>{t.type==="property"&&(S===":"?t.colonOffset=P:S===","&&r(P))},onError:(S,P,O)=>{a.push({error:S,offset:P,length:O})}},n);const g=t.children[0];return g&&delete g.parent,g}e.parseTree=v;function h(s,a){if(!s)return;let n=s;for(let t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===t){n=o.children[1],r=!0;break}if(!r)return}else{const r=t;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=h;function y(s){if(!s.parent||!s.parent.children)return[];const a=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.getNodePath=y;function p(s){switch(s.type){case"array":return s.children.map(p);case"object":const a=Object.create(null);for(let n of s.children){const t=n.children[1];t&&(a[n.children[0].value]=p(t))}return a;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=p;function m(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.contains=m;function E(s,a,n=!1){if(m(s,a,n)){const t=s.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=a;r++){const o=E(t[r],a,n);if(o)return o}return s}}e.findNodeAtOffset=E;function f(s,a,n=L.DEFAULT){const t=i(s,!1);function r(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(q){return q?x=>q(x,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=r(a.onObjectBegin),g=o(a.onObjectProperty),S=r(a.onObjectEnd),P=r(a.onArrayBegin),O=r(a.onArrayEnd),U=o(a.onLiteralValue),W=o(a.onSeparator),$=r(a.onComment),k=o(a.onError),z=n&&n.disallowComments,A=n&&n.allowTrailingComma;function F(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(q){case 12:case 13:z?B(10):$();break;case 16:B(1);break;case 15:case 14:break;default:return q}}}function B(q,x=[],K=[]){if(k(q),x.length+K.length>0){let ee=t.getToken();for(;ee!==17;){if(x.indexOf(ee)!==-1){F();break}else if(K.indexOf(ee)!==-1)break;ee=F()}}}function Z(q){const x=t.getTokenValue();return q?U(x):g(x),F(),!0}function V(){switch(t.getToken()){case 11:let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(B(2),q=0)}catch(x){B(2)}U(q);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return F(),!0}function j(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(W(":"),F(),N()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){u(),F();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||B(4,[],[]),W(","),F(),t.getToken()===2&&A)break}else q&&B(6,[],[]);j()||B(4,[],[2,5]),q=!0}return S(),t.getToken()!==2?B(7,[2],[]):F(),!0}function M(){P(),F();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||B(4,[],[]),W(","),F(),t.getToken()===4&&A)break}else q&&B(6,[],[]);N()||B(4,[],[4,5]),q=!0}return O(),t.getToken()!==4?B(8,[4],[]):F(),!0}function N(){switch(t.getToken()){case 3:return M();case 1:return Q();case 10:return Z(!0);default:return V()}}return F(),t.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):N()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=f;function c(s,a){let n=i(s),t=[],r,o=0,u;do switch(u=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:o!==u&&t.push(s.substring(o,u)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(r!==17);return t.join("")}e.stripComments=c;function l(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,31]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function _(w,b,I){let C,d,v,h,y;if(b){for(h=b.offset,y=h+b.length,v=h;v>0&&!R(w,v-1);)v--;let o=y;for(;o<w.length&&!R(w,o);)o++;d=w.substring(v,o),C=L(d,I)}else d=w,C=0,v=0,h=0,y=w.length;const p=i(I,w);let m=!1,E=0,f;I.insertSpaces?f=D(" ",I.tabSize||4):f="	";const c=(0,T.createScanner)(d,!1);let l=!1;function s(){return p+D(f,C+E)}function a(){let o=c.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=c.scan();return l=o===16||c.getTokenError()!==0,o}const n=[];function t(o,u,g){!l&&u<y&&g>h&&w.substring(u,g)!==o&&n.push({offset:u,length:g-u,content:o})}let r=a();if(r!==17){const o=c.getTokenOffset()+v,u=D(f,C);t(u,v,o)}for(;r!==17;){let o=c.getTokenOffset()+c.getTokenLength()+v,u=a(),g="";for(;!m&&(u===12||u===13);){const P=c.getTokenOffset()+v;t(" ",o,P),o=c.getTokenOffset()+c.getTokenLength()+v,g=u===12?s():"",u=a()}if(u===2)r!==1&&(E--,g=s());else if(u===4)r!==3&&(E--,g=s());else{switch(r){case 3:case 1:E++,g=s();break;case 5:case 12:g=s();break;case 13:m?g=s():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}m&&(u===12||u===13)&&(g=s())}const S=c.getTokenOffset()+v;t(g,o,S),r=u}return n}e.format=_;function D(w,b){let I="";for(let C=0;C<b;C++)I+=w;return I}function L(w,b){let I=0,C=0;const d=b.tabSize||4;for(;I<w.length;){const v=w.charAt(I);if(v===" ")C++;else if(v==="	")C+=d;else break;I++}return Math.floor(C/d)}function i(w,b){for(let I=0;I<b.length;I++){const C=b.charAt(I);if(C==="\r")return I+1<b.length&&b.charAt(I+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=i;function R(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=R}),define(te[39],ne([0,1,31,48]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,I,C){return L(b,I,void 0,C)}e.removeProperty=D;function L(b,I,C,d,v){const h=I.slice(),y=[],p=(0,T.parseTree)(b,y);let m,E;for(;h.length>0&&(E=h.pop(),m=(0,T.findNodeAtLocation)(p,h),m===void 0&&C!==void 0);)typeof E=="string"?C={[E]:C}:C=[C];if(m)if(m.type==="object"&&typeof E=="string"&&Array.isArray(m.children)){const f=(0,T.findNodeAtLocation)(m,[E]);if(f!==void 0)if(C===void 0){if(!f.parent)throw new Error("Malformed AST");const c=m.children.indexOf(f.parent);let l,s=f.parent.offset+f.parent.length;if(c>0){const a=m.children[c-1];l=a.offset+a.length}else l=m.offset+1,m.children.length>1&&(s=m.children[1].offset);return i(b,{offset:l,length:s-l,content:""},d)}else return i(b,{offset:f.offset,length:f.length,content:JSON.stringify(C)},d);else{if(C===void 0)return[];const c=`${JSON.stringify(E)}: ${JSON.stringify(C)}`,l=v?v(m.children.map(a=>a.children[0].value)):m.children.length;let s;if(l>0){const a=m.children[l-1];s={offset:a.offset+a.length,length:0,content:","+c}}else m.children.length===0?s={offset:m.offset+1,length:0,content:c}:s={offset:m.offset+1,length:0,content:c+","};return i(b,s,d)}}else if(m.type==="array"&&typeof E=="number"&&Array.isArray(m.children))if(C!==void 0){const f=`${JSON.stringify(C)}`;let c;if(m.children.length===0||E===0)c={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const l=E===-1||E>m.children.length?m.children.length:E,s=m.children[l-1];c={offset:s.offset+s.length,length:0,content:","+f}}return i(b,c,d)}else{const f=E,c=m.children[f];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const s=m.children[f-1],a=s.offset+s.length,n=m.offset+m.length;l={offset:a,length:n-2-a,content:""}}else l={offset:c.offset,length:m.children[f+1].offset-c.offset,content:""};return i(b,l,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${m.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return i(b,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(C)},d)}}e.setProperty=L;function i(b,I,C){let d=R(b,I),v=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;v>0&&!(0,_.isEOL)(d,v-1);)v--;for(;h<d.length&&!(0,_.isEOL)(d,h);)h++}const y=(0,_.format)(d,{offset:v,length:h-v},C);for(let m=y.length-1;m>=0;m--){const E=y[m];d=R(d,E),v=Math.min(v,E.offset),h=Math.max(h,E.offset+E.length),h+=E.content.length-E.length}const p=b.length-(d.length-h)-v;return[{offset:v,length:p,content:d.substring(v,h)}]}e.withFormatting=i;function R(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=R;function w(b,I){let C=I.slice(0).sort((v,h)=>{const y=v.offset-h.offset;return y===0?v.length-h.length:y}),d=b.length;for(let v=C.length-1;v>=0;v--){let h=C[v];if(h.offset+h.length<=d)b=R(b,h);else throw new Error("Overlapping edit");d=h.offset}return b}e.applyEdits=w}),define(te[2],ne([0,1,68,56]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let L=null;function i(t){L=t}if(e.setDisposableTracker=i,D){const t="__is_disposable_tracked__";i(new class{trackDisposable(r){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[t]||console.log(o)},3e3)}setParent(r,o){if(r&&r!==E.None)try{r[t]=!0}catch{}}markAsDisposed(r){if(r&&r!==E.None)try{r[t]=!0}catch{}}markAsSingleton(r){}})}function R(t){return L?.trackDisposable(t),t}function w(t){L?.markAsDisposed(t)}function b(t,r){L?.setParent(t,r)}function I(t,r){if(!!L)for(const o of t)L.setParent(o,r)}function C(t){return L?.markAsSingleton(t),t}e.markAsSingleton=C;class d extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=d;function v(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=v;function h(t){if(_.Iterable.is(t)){let r=[];for(const o of t)if(o)try{o.dispose()}catch(u){r.push(u)}if(r.length===1)throw r[0];if(r.length>1)throw new d(r);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function y(...t){const r=p(()=>h(t));return I(t,r),r}e.combinedDisposable=y;function p(t){const r=R({dispose:(0,T.once)(()=>{w(r),t()})});return r}e.toDisposable=p;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return b(r,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new m,R(this),b(this._store,this)}dispose(){w(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&b(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&b(r,null),r}}e.MutableDisposable=f;class c{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(r,...o){let u=this.references.get(r);u||(u={counter:0,object:this.createReferencedObject(r,...o)},this.references.set(r,u));const{object:g}=u,S=(0,T.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(r,u.object),this.references.delete(r))});return u.counter++,{object:g,dispose:S}}}e.ReferenceCollection=l;class s{constructor(r){this.referenceCollection=r}async acquire(r,...o){const u=this.referenceCollection.acquire(r,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=s;class a{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=a;function n(t){const r=new m;try{t(r)}finally{r.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class T{constructor(L){this.element=L,this.next=T.Undefined,this.prev=T.Undefined}}T.Undefined=new T(void 0);class _{constructor(){this._first=T.Undefined,this._last=T.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===T.Undefined}clear(){let L=this._first;for(;L!==T.Undefined;){const i=L.next;L.prev=T.Undefined,L.next=T.Undefined,L=i}this._first=T.Undefined,this._last=T.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,i){const R=new T(L);if(this._first===T.Undefined)this._first=R,this._last=R;else if(i){const b=this._last;this._last=R,R.prev=b,b.next=R}else{const b=this._first;this._first=R,R.next=b,b.prev=R}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(R))}}shift(){if(this._first!==T.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==T.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==T.Undefined&&L.next!==T.Undefined){const i=L.prev;i.next=L.next,L.next.prev=i}else L.prev===T.Undefined&&L.next===T.Undefined?(this._first=T.Undefined,this._last=T.Undefined):L.next===T.Undefined?(this._last=this._last.prev,this._last.next=T.Undefined):L.prev===T.Undefined&&(this._first=this._first.next,this._first.prev=T.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==T.Undefined;)yield L.element,L=L.next}}e.LinkedList=_}),function(){function J(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function i(w){L.push(w,Date.now())}function R(){const w=[];for(let b=0;b<L.length;b+=2)w.push({name:L[b],startTime:L[b+1]});return w}return{mark:i,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const i of performance.getEntriesByType("mark"))L.push({name:i.name,startTime:Math.round(D+i.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function T(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var _;typeof global=="object"?_=global:typeof self=="object"?_=self:_={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(_)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(_):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),_.perf=T(_))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const T="en";let _=!1,D=!1,L=!1,i=!1,R=!1,w=!1,b=!1,I=!1,C,d=T,v,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const p=typeof y?.versions?.electron=="string",m=p&&y?.type==="renderer";if(e.isElectronSandboxed=m&&y?.sandboxed,typeof navigator=="object"&&!m)h=navigator.userAgent,_=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,w=!0,C=navigator.language,d=C;else if(typeof y=="object"){_=y.platform==="win32",D=y.platform==="darwin",L=y.platform==="linux",i=L&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,b=p,C=T,d=T;const r=y.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),u=o.availableLanguages["*"];C=o.locale,d=u||T,v=o._translationsConfigFile}catch(o){}R=!0}else console.error("Unable to resolve platform.");var E;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function f(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let c=0;D?c=1:_?c=3:L&&(c=2),e.isWindows=_,e.isMacintosh=D,e.isLinux=L,e.isLinuxSnap=i,e.isNative=R,e.isElectron=b,e.isWeb=w,e.isIOS=I,e.platform=c,e.userAgent=h,e.language=d;var l;(function(r){function o(){return e.language}r.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=u;function g(){return e.language==="en"}r.isDefault=g})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=v,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let g=0,S=r.length;g<S;g++){const P=r[g];if(P.id===u.data.vscodeScheduleAsyncWork){r.splice(g,1),P.callback();return}}});let o=0;return u=>{const g=++o;r.push({id:g,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return r=>setTimeout(r)})();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||I?2:_?1:3;let a=!0,n=!1;function t(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,a=new Uint16Array(r.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(te[32],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let _;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.process!="undefined"){const D=T.globals.vscode.process;_={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return T.isWindows?"win32":T.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=_.cwd,e.env=_.env,e.platform=_.platform,e.arch=_.arch}),define(te[10],ne([0,1,32]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const _=65,D=97,L=90,i=122,R=46,w=47,b=92,I=58,C=63;class d extends Error{constructor(c,l,s){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const n=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${n} ${a} of type ${l}`;t+=`. Received type ${typeof s}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function v(f,c){if(typeof f!="string")throw new d(c,"string",f)}function h(f){return f===w||f===b}function y(f){return f===w}function p(f){return f>=_&&f<=L||f>=D&&f<=i}function m(f,c,l,s){let a="",n=0,t=-1,r=0,o=0;for(let u=0;u<=f.length;++u){if(u<f.length)o=f.charCodeAt(u);else{if(s(o))break;o=w}if(s(o)){if(!(t===u-1||r===1))if(r===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const g=a.lastIndexOf(l);g===-1?(a="",n=0):(a=a.slice(0,g),n=a.length-1-a.lastIndexOf(l)),t=u,r=0;continue}else if(a.length!==0){a="",n=0,t=u,r=0;continue}}c&&(a+=a.length>0?`${l}..`:"..",n=2)}else a.length>0?a+=`${l}${f.slice(t+1,u)}`:a=f.slice(t+1,u),n=u-t-1;t=u,r=0}else o===R&&r!==-1?++r:r=-1}return a}function E(f,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const l=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${s}`:`${l}${f}${s}`:s}e.win32={resolve(...f){let c="",l="",s=!1;for(let a=f.length-1;a>=-1;a--){let n;if(a>=0){if(n=f[a],v(n,"path"),n.length===0)continue}else c.length===0?n=T.cwd():(n=T.env[`=${c}`]||T.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${c}\\`));const t=n.length;let r=0,o="",u=!1;const g=n.charCodeAt(0);if(t===1)h(g)&&(r=1,u=!0);else if(h(g))if(u=!0,h(n.charCodeAt(1))){let S=2,P=S;for(;S<t&&!h(n.charCodeAt(S));)S++;if(S<t&&S!==P){const O=n.slice(P,S);for(P=S;S<t&&h(n.charCodeAt(S));)S++;if(S<t&&S!==P){for(P=S;S<t&&!h(n.charCodeAt(S));)S++;(S===t||S!==P)&&(o=`\\\\${O}\\${n.slice(P,S)}`,r=S)}}}else r=1;else p(g)&&n.charCodeAt(1)===I&&(o=n.slice(0,2),r=2,t>2&&h(n.charCodeAt(2))&&(u=!0,r=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(s){if(c.length>0)break}else if(l=`${n.slice(r)}\\${l}`,s=u,u&&c.length>0)break}return l=m(l,!s,"\\",h),s?`${c}\\${l}`:`${c}${l}`||"."},normalize(f){v(f,"path");const c=f.length;if(c===0)return".";let l=0,s,a=!1;const n=f.charCodeAt(0);if(c===1)return y(n)?"\\":f;if(h(n))if(a=!0,h(f.charCodeAt(1))){let r=2,o=r;for(;r<c&&!h(f.charCodeAt(r));)r++;if(r<c&&r!==o){const u=f.slice(o,r);for(o=r;r<c&&h(f.charCodeAt(r));)r++;if(r<c&&r!==o){for(o=r;r<c&&!h(f.charCodeAt(r));)r++;if(r===c)return`\\\\${u}\\${f.slice(o)}\\`;r!==o&&(s=`\\\\${u}\\${f.slice(o,r)}`,l=r)}}}else l=1;else p(n)&&f.charCodeAt(1)===I&&(s=f.slice(0,2),l=2,c>2&&h(f.charCodeAt(2))&&(a=!0,l=3));let t=l<c?m(f.slice(l),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(f.charCodeAt(c-1))&&(t+="\\"),s===void 0?a?`\\${t}`:t:a?`${s}\\${t}`:`${s}${t}`},isAbsolute(f){v(f,"path");const c=f.length;if(c===0)return!1;const l=f.charCodeAt(0);return h(l)||c>2&&p(l)&&f.charCodeAt(1)===I&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,l;for(let n=0;n<f.length;++n){const t=f[n];v(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let s=!0,a=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++a;const n=l.length;n>1&&h(l.charCodeAt(1))&&(++a,n>2&&(h(l.charCodeAt(2))?++a:s=!1))}if(s){for(;a<c.length&&h(c.charCodeAt(a));)a++;a>=2&&(c=`\\${c.slice(a)}`)}return e.win32.normalize(c)},relative(f,c){if(v(f,"from"),v(c,"to"),f===c)return"";const l=e.win32.resolve(f),s=e.win32.resolve(c);if(l===s||(f=l.toLowerCase(),c=s.toLowerCase(),f===c))return"";let a=0;for(;a<f.length&&f.charCodeAt(a)===b;)a++;let n=f.length;for(;n-1>a&&f.charCodeAt(n-1)===b;)n--;const t=n-a;let r=0;for(;r<c.length&&c.charCodeAt(r)===b;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===b;)o--;const u=o-r,g=t<u?t:u;let S=-1,P=0;for(;P<g;P++){const U=f.charCodeAt(a+P);if(U!==c.charCodeAt(r+P))break;U===b&&(S=P)}if(P!==g){if(S===-1)return s}else{if(u>g){if(c.charCodeAt(r+P)===b)return s.slice(r+P+1);if(P===2)return s.slice(r+P)}t>g&&(f.charCodeAt(a+P)===b?S=P:P===2&&(S=3)),S===-1&&(S=0)}let O="";for(P=a+S+1;P<=n;++P)(P===n||f.charCodeAt(P)===b)&&(O+=O.length===0?"..":"\\..");return r+=S,O.length>0?`${O}${s.slice(r,o)}`:(s.charCodeAt(r)===b&&++r,s.slice(r,o))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const l=c.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===I&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return f},dirname(f){v(f,"path");const c=f.length;if(c===0)return".";let l=-1,s=0;const a=f.charCodeAt(0);if(c===1)return h(a)?f:".";if(h(a)){if(l=s=1,h(f.charCodeAt(1))){let r=2,o=r;for(;r<c&&!h(f.charCodeAt(r));)r++;if(r<c&&r!==o){for(o=r;r<c&&h(f.charCodeAt(r));)r++;if(r<c&&r!==o){for(o=r;r<c&&!h(f.charCodeAt(r));)r++;if(r===c)return f;r!==o&&(l=s=r+1)}}}}else p(a)&&f.charCodeAt(1)===I&&(l=c>2&&h(f.charCodeAt(2))?3:2,s=l);let n=-1,t=!0;for(let r=c-1;r>=s;--r)if(h(f.charCodeAt(r))){if(!t){n=r;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return f.slice(0,n)},basename(f,c){c!==void 0&&v(c,"ext"),v(f,"path");let l=0,s=-1,a=!0,n;if(f.length>=2&&p(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(l=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,r=-1;for(n=f.length-1;n>=l;--n){const o=f.charCodeAt(n);if(h(o)){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(s=n):(t=-1,s=r))}return l===s?s=r:s===-1&&(s=f.length),f.slice(l,s)}for(n=f.length-1;n>=l;--n)if(h(f.charCodeAt(n))){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1);return s===-1?"":f.slice(l,s)},extname(f){v(f,"path");let c=0,l=-1,s=0,a=-1,n=!0,t=0;f.length>=2&&f.charCodeAt(1)===I&&p(f.charCodeAt(0))&&(c=s=2);for(let r=f.length-1;r>=c;--r){const o=f.charCodeAt(r);if(h(o)){if(!n){s=r+1;break}continue}a===-1&&(n=!1,a=r+1),o===R?l===-1?l=r:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===s+1?"":f.slice(l,a)},format:E.bind(null,"\\"),parse(f){v(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.length;let s=0,a=f.charCodeAt(0);if(l===1)return h(a)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(h(a)){if(s=1,h(f.charCodeAt(1))){let S=2,P=S;for(;S<l&&!h(f.charCodeAt(S));)S++;if(S<l&&S!==P){for(P=S;S<l&&h(f.charCodeAt(S));)S++;if(S<l&&S!==P){for(P=S;S<l&&!h(f.charCodeAt(S));)S++;S===l?s=S:S!==P&&(s=S+1)}}}}else if(p(a)&&f.charCodeAt(1)===I){if(l<=2)return c.root=c.dir=f,c;if(s=2,h(f.charCodeAt(2))){if(l===3)return c.root=c.dir=f,c;s=3}}s>0&&(c.root=f.slice(0,s));let n=-1,t=s,r=-1,o=!0,u=f.length-1,g=0;for(;u>=s;--u){if(a=f.charCodeAt(u),h(a)){if(!o){t=u+1;break}continue}r===-1&&(o=!1,r=u+1),a===R?n===-1?n=u:g!==1&&(g=1):n!==-1&&(g=-1)}return r!==-1&&(n===-1||g===0||g===1&&n===r-1&&n===t+1?c.base=c.name=f.slice(t,r):(c.name=f.slice(t,n),c.base=f.slice(t,r),c.ext=f.slice(n,r))),t>0&&t!==s?c.dir=f.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",l=!1;for(let s=f.length-1;s>=-1&&!l;s--){const a=s>=0?f[s]:T.cwd();v(a,"path"),a.length!==0&&(c=`${a}/${c}`,l=a.charCodeAt(0)===w)}return c=m(c,!l,"/",y),l?`/${c}`:c.length>0?c:"."},normalize(f){if(v(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===w,l=f.charCodeAt(f.length-1)===w;return f=m(f,!c,"/",y),f.length===0?c?"/":l?"./":".":(l&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return v(f,"path"),f.length>0&&f.charCodeAt(0)===w},join(...f){if(f.length===0)return".";let c;for(let l=0;l<f.length;++l){const s=f[l];v(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(v(f,"from"),v(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const l=1,s=f.length,a=s-l,n=1,t=c.length-n,r=a<t?a:t;let o=-1,u=0;for(;u<r;u++){const S=f.charCodeAt(l+u);if(S!==c.charCodeAt(n+u))break;S===w&&(o=u)}if(u===r)if(t>r){if(c.charCodeAt(n+u)===w)return c.slice(n+u+1);if(u===0)return c.slice(n+u)}else a>r&&(f.charCodeAt(l+u)===w?o=u:u===0&&(o=0));let g="";for(u=l+o+1;u<=s;++u)(u===s||f.charCodeAt(u)===w)&&(g+=g.length===0?"..":"/..");return`${g}${c.slice(n+o)}`},toNamespacedPath(f){return f},dirname(f){if(v(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===w;let l=-1,s=!0;for(let a=f.length-1;a>=1;--a)if(f.charCodeAt(a)===w){if(!s){l=a;break}}else s=!1;return l===-1?c?"/":".":c&&l===1?"//":f.slice(0,l)},basename(f,c){c!==void 0&&v(c,"ext"),v(f,"path");let l=0,s=-1,a=!0,n;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,r=-1;for(n=f.length-1;n>=0;--n){const o=f.charCodeAt(n);if(o===w){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(s=n):(t=-1,s=r))}return l===s?s=r:s===-1&&(s=f.length),f.slice(l,s)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===w){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1);return s===-1?"":f.slice(l,s)},extname(f){v(f,"path");let c=-1,l=0,s=-1,a=!0,n=0;for(let t=f.length-1;t>=0;--t){const r=f.charCodeAt(t);if(r===w){if(!a){l=t+1;break}continue}s===-1&&(a=!1,s=t+1),r===R?c===-1?c=t:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||s===-1||n===0||n===1&&c===s-1&&c===l+1?"":f.slice(c,s)},format:E.bind(null,"/"),parse(f){v(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.charCodeAt(0)===w;let s;l?(c.root="/",s=1):s=0;let a=-1,n=0,t=-1,r=!0,o=f.length-1,u=0;for(;o>=s;--o){const g=f.charCodeAt(o);if(g===w){if(!r){n=o+1;break}continue}t===-1&&(r=!1,t=o+1),g===R?a===-1?a=o:u!==1&&(u=1):a!==-1&&(u=-1)}if(t!==-1){const g=n===0&&l?1:n;a===-1||u===0||u===1&&a===t-1&&a===n+1?c.base=c.name=f.slice(g,t):(c.name=f.slice(g,a),c.base=f.slice(g,t),c.ext=f.slice(a,t))}return n>0?c.dir=f.slice(0,n-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=T.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=T.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=T.platform==="win32"?e.win32.join:e.posix.join,e.resolve=T.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=T.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=T.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=T.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=T.platform==="win32"?e.win32.extname:e.posix.extname,e.format=T.platform==="win32"?e.win32.format:e.posix.format,e.parse=T.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=T.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=T.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=T.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(T=e.Source||(e.Source={}));var _;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(_=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(L,...i){const R=i.reduce((I,C)=>(I[C]=!0,I),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(I=>!R[I]).forEach(I=>{for(let C=0;C<w.length;C++)if(I.search(w[C])!==-1){delete L[I];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var _ in T)(typeof exports=="object"?exports:J)[_]=T[_]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function T(_){if(e[_])return e[_].exports;var D=e[_]={i:_,l:!1,exports:{}};return J[_].call(D.exports,D,D.exports,T),D.l=!0,D.exports}return T.m=J,T.c=e,T.d=function(_,D,L){T.o(_,D)||Object.defineProperty(_,D,{enumerable:!0,get:L})},T.r=function(_){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(_,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(_,"__esModule",{value:!0})},T.t=function(_,D){if(1&D&&(_=T(_)),8&D||4&D&&typeof _=="object"&&_&&_.__esModule)return _;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:_}),2&D&&typeof _!="string")for(var i in _)T.d(L,i,function(R){return _[R]}.bind(null,i));return L},T.n=function(_){var D=_&&_.__esModule?function(){return _.default}:function(){return _};return T.d(D,"a",D),D},T.o=function(_,D){return Object.prototype.hasOwnProperty.call(_,D)},T.p="",T(T.s=0)}([function(J,e,T){(function(_){var D;e=J.exports=K,D=typeof _=="object"&&_.env&&_.env.NODE_DEBUG&&/\bsemver\b/i.test(_.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],w=e.src=[],b=0,I=b++;w[I]="0|[1-9]\\d*";var C=b++;w[C]="[0-9]+";var d=b++;w[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=b++;w[v]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var h=b++;w[h]="("+w[C]+")\\.("+w[C]+")\\.("+w[C]+")";var y=b++;w[y]="(?:"+w[I]+"|"+w[d]+")";var p=b++;w[p]="(?:"+w[C]+"|"+w[d]+")";var m=b++;w[m]="(?:-("+w[y]+"(?:\\."+w[y]+")*))";var E=b++;w[E]="(?:-?("+w[p]+"(?:\\."+w[p]+")*))";var f=b++;w[f]="[0-9A-Za-z-]+";var c=b++;w[c]="(?:\\+("+w[f]+"(?:\\."+w[f]+")*))";var l=b++,s="v?"+w[v]+w[m]+"?"+w[c]+"?";w[l]="^"+s+"$";var a="[v=\\s]*"+w[h]+w[E]+"?"+w[c]+"?",n=b++;w[n]="^"+a+"$";var t=b++;w[t]="((?:<|>)?=?)";var r=b++;w[r]=w[C]+"|x|X|\\*";var o=b++;w[o]=w[I]+"|x|X|\\*";var u=b++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[c]+"?)?)?";var g=b++;w[g]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[E]+")?"+w[c]+"?)?)?";var S=b++;w[S]="^"+w[t]+"\\s*"+w[u]+"$";var P=b++;w[P]="^"+w[t]+"\\s*"+w[g]+"$";var O=b++;w[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=b++;w[U]="(?:~>?)";var W=b++;w[W]="(\\s*)"+w[U]+"\\s+",R[W]=new RegExp(w[W],"g");var $=b++;w[$]="^"+w[U]+w[u]+"$";var k=b++;w[k]="^"+w[U]+w[g]+"$";var z=b++;w[z]="(?:\\^)";var A=b++;w[A]="(\\s*)"+w[z]+"\\s+",R[A]=new RegExp(w[A],"g");var F=b++;w[F]="^"+w[z]+w[u]+"$";var B=b++;w[B]="^"+w[z]+w[g]+"$";var Z=b++;w[Z]="^"+w[t]+"\\s*("+a+")$|^$";var V=b++;w[V]="^"+w[t]+"\\s*("+s+")$|^$";var j=b++;w[j]="(\\s*)"+w[t]+"\\s*("+a+"|"+w[u]+")",R[j]=new RegExp(w[j],"g");var Q=b++;w[Q]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var M=b++;w[M]="^\\s*("+w[g]+")\\s+-\\s+("+w[g]+")\\s*$";var N=b++;w[N]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)D(q,w[q]),R[q]||(R[q]=new RegExp(w[q]));function x(ie,ae){if(ie instanceof K)return ie;if(typeof ie!="string"||ie.length>L||!(ae?R[n]:R[l]).test(ie))return null;try{return new K(ie,ae)}catch(ce){return null}}function K(ie,ae){if(ie instanceof K){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof K))return new K(ie,ae);D("SemVer",ie,ae),this.loose=ae;var ce=ie.trim().match(ae?R[n]:R[l]);if(!ce)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<i)return Pe}return Se}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=x,e.valid=function(ie,ae){var ce=x(ie,ae);return ce?ce.version:null},e.clean=function(ie,ae){var ce=x(ie.trim().replace(/^[=v]+/,""),ae);return ce?ce.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ie){return D("SemVer.compare",this.version,this.loose,ie),ie instanceof K||(ie=new K(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},K.prototype.compareMain=function(ie){return ie instanceof K||(ie=new K(ie,this.loose)),H(this.major,ie.major)||H(this.minor,ie.minor)||H(this.patch,ie.patch)},K.prototype.comparePre=function(ie){if(ie instanceof K||(ie=new K(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var ce=this.prerelease[ae],Se=ie.prerelease[ae];if(D("prerelease compare",ae,ce,Se),ce===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(ce===void 0)return-1;if(ce!==Se)return H(ce,Se)}while(++ae)},K.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,ce,Se){typeof ce=="string"&&(Se=ce,ce=void 0);try{return new K(ie,ce).inc(ae,Se).version}catch(Pe){return null}},e.diff=function(ie,ae){if(le(ie,ae))return null;var ce=x(ie),Se=x(ae);if(ce.prerelease.length||Se.prerelease.length){for(var Pe in ce)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ce[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ce)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ce[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=H;var ee=/^[0-9]+$/;function H(ie,ae){var ce=ee.test(ie),Se=ee.test(ae);return ce&&Se&&(ie=+ie,ae=+ae),ce&&!Se?-1:Se&&!ce?1:ie<ae?-1:ie>ae?1:0}function X(ie,ae,ce){return new K(ie,ce).compare(new K(ae,ce))}function re(ie,ae,ce){return X(ie,ae,ce)>0}function oe(ie,ae,ce){return X(ie,ae,ce)<0}function le(ie,ae,ce){return X(ie,ae,ce)===0}function he(ie,ae,ce){return X(ie,ae,ce)!==0}function be(ie,ae,ce){return X(ie,ae,ce)>=0}function Ce(ie,ae,ce){return X(ie,ae,ce)<=0}function we(ie,ae,ce,Se){var Pe;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof ce=="object"&&(ce=ce.version),Pe=ie===ce;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof ce=="object"&&(ce=ce.version),Pe=ie!==ce;break;case"":case"=":case"==":Pe=le(ie,ce,Se);break;case"!=":Pe=he(ie,ce,Se);break;case">":Pe=re(ie,ce,Se);break;case">=":Pe=be(ie,ce,Se);break;case"<":Pe=oe(ie,ce,Se);break;case"<=":Pe=Ce(ie,ce,Se);break;default:throw new TypeError("Invalid operator: "+ae)}return Pe}function ve(ie,ae){if(ie instanceof ve){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof ve))return new ve(ie,ae);D("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===De?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ie,ae){return H(ae,ie)},e.major=function(ie,ae){return new K(ie,ae).major},e.minor=function(ie,ae){return new K(ie,ae).minor},e.patch=function(ie,ae){return new K(ie,ae).patch},e.compare=X,e.compareLoose=function(ie,ae){return X(ie,ae,!0)},e.rcompare=function(ie,ae,ce){return X(ae,ie,ce)},e.sort=function(ie,ae){return ie.sort(function(ce,Se){return e.compare(ce,Se,ae)})},e.rsort=function(ie,ae){return ie.sort(function(ce,Se){return e.rcompare(ce,Se,ae)})},e.gt=re,e.lt=oe,e.eq=le,e.neq=he,e.gte=be,e.lte=Ce,e.cmp=we,e.Comparator=ve;var De={};function ye(ie,ae){if(ie instanceof ye)return ie.loose===ae?ie:new ye(ie.raw,ae);if(ie instanceof ve)return new ye(ie.value,ae);if(!(this instanceof ye))return new ye(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ie(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Me(ie,ae,ce,Se,Pe,Ae,Te,Fe,_e,Ue,Y,se,ue){return((ae=Ie(ce)?"":Ie(Se)?">="+ce+".0.0":Ie(Pe)?">="+ce+"."+Se+".0":">="+ae)+" "+(Fe=Ie(_e)?"":Ie(Ue)?"<"+(+_e+1)+".0.0":Ie(Y)?"<"+_e+"."+(+Ue+1)+".0":se?"<="+_e+"."+Ue+"."+Y+"-"+se:"<="+Fe)).trim()}function je(ie,ae){for(var ce=0;ce<ie.length;ce++)if(!ie[ce].test(ae))return!1;if(ae.prerelease.length){for(ce=0;ce<ie.length;ce++)if(D(ie[ce].semver),ie[ce].semver!==De&&ie[ce].semver.prerelease.length>0){var Se=ie[ce].semver;if(Se.major===ae.major&&Se.minor===ae.minor&&Se.patch===ae.patch)return!0}return!1}return!0}function Ne(ie,ae,ce){try{ae=new ye(ae,ce)}catch(Se){return!1}return ae.test(ie)}function qe(ie,ae,ce,Se){var Pe,Ae,Te,Fe,_e;switch(ie=new K(ie,Se),ae=new ye(ae,Se),ce){case">":Pe=re,Ae=Ce,Te=oe,Fe=">",_e=">=";break;case"<":Pe=oe,Ae=be,Te=re,Fe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ie,ae,Se))return!1;for(var Ue=0;Ue<ae.set.length;++Ue){var Y=ae.set[Ue],se=null,ue=null;if(Y.forEach(function(fe){fe.semver===De&&(fe=new ve(">=0.0.0")),se=se||fe,ue=ue||fe,Pe(fe.semver,se.semver,Se)?se=fe:Te(fe.semver,ue.semver,Se)&&(ue=fe)}),se.operator===Fe||se.operator===_e||(!ue.operator||ue.operator===Fe)&&Ae(ie,ue.semver)||ue.operator===_e&&Te(ie,ue.semver))return!1}return!0}ve.prototype.parse=function(ie){var ae=this.loose?R[Z]:R[V],ce=ie.match(ae);if(!ce)throw new TypeError("Invalid comparator: "+ie);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new K(ce[2],this.loose):this.semver=De},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ie){return D("Comparator.test",ie,this.loose),this.semver===De||(typeof ie=="string"&&(ie=new K(ie,this.loose)),we(ie,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ie,ae){if(!(ie instanceof ve))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new ye(ie.value,ae),Ne(this.value,ce,ae);if(ie.operator==="")return ce=new ye(this.value,ae),Ne(ie.semver,ce,ae);var Se=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Ae=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Fe=we(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),_e=we(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return Se||Pe||Ae&&Te||Fe||_e},e.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),D("range",ie,ae);var ce=ae?R[M]:R[Q];ie=ie.replace(ce,Me),D("hyphen replace",ie),ie=ie.replace(R[j],"$1$2$3"),D("comparator trim",ie,R[j]),ie=(ie=(ie=ie.replace(R[W],"$1~")).replace(R[A],"$1^")).split(/\s+/).join(" ");var Se=ae?R[Z]:R[V],Pe=ie.split(" ").map(function(Ae){return function(Te,Fe){return D("comp",Te),Te=function(_e,Ue){return _e.trim().split(/\s+/).map(function(Y){return function(se,ue){D("caret",se,ue);var fe=ue?R[B]:R[F];return se.replace(fe,function(pe,ge,Ee,Re,ke){var Le;return D("caret",se,pe,ge,Ee,Re,ke),Ie(ge)?Le="":Ie(Ee)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(Re)?Le=ge==="0"?">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+".0 <"+(+ge+1)+".0.0":ke?(D("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+Ee+"."+(+Re+1):">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Re+ke+" <"+(+ge+1)+".0.0"):(D("no pr"),Le=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Re+" <"+ge+"."+Ee+"."+(+Re+1):">="+ge+"."+Ee+"."+Re+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Re+" <"+(+ge+1)+".0.0"),D("caret return",Le),Le})}(Y,Ue)}).join(" ")}(Te,Fe),D("caret",Te),Te=function(_e,Ue){return _e.trim().split(/\s+/).map(function(Y){return function(se,ue){var fe=ue?R[k]:R[$];return se.replace(fe,function(pe,ge,Ee,Re,ke){var Le;return D("tilde",se,pe,ge,Ee,Re,ke),Ie(ge)?Le="":Ie(Ee)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(Re)?Le=">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":ke?(D("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+(+Ee+1)+".0"):Le=">="+ge+"."+Ee+"."+Re+" <"+ge+"."+(+Ee+1)+".0",D("tilde return",Le),Le})}(Y,Ue)}).join(" ")}(Te,Fe),D("tildes",Te),Te=function(_e,Ue){return D("replaceXRanges",_e,Ue),_e.split(/\s+/).map(function(Y){return function(se,ue){se=se.trim();var fe=ue?R[P]:R[S];return se.replace(fe,function(pe,ge,Ee,Re,ke,Le){D("xRange",se,pe,ge,Ee,Re,ke,Le);var $e=Ie(Ee),Ye=$e||Ie(Re),He=Ye||Ie(ke);return ge==="="&&He&&(ge=""),$e?pe=ge===">"||ge==="<"?"<0.0.0":"*":ge&&He?(Ye&&(Re=0),He&&(ke=0),ge===">"?(ge=">=",Ye?(Ee=+Ee+1,Re=0,ke=0):He&&(Re=+Re+1,ke=0)):ge==="<="&&(ge="<",Ye?Ee=+Ee+1:Re=+Re+1),pe=ge+Ee+"."+Re+"."+ke):Ye?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":He&&(pe=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),D("xRange return",pe),pe})}(Y,Ue)}).join(" ")}(Te,Fe),D("xrange",Te),Te=function(_e,Ue){return D("replaceStars",_e,Ue),_e.trim().replace(R[N],"")}(Te,Fe),D("stars",Te),Te}(Ae,ae)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Se)})),Pe=Pe.map(function(Ae){return new ve(Ae,ae)})},ye.prototype.intersects=function(ie,ae){if(!(ie instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Se){return ie.set.some(function(Pe){return Pe.every(function(Ae){return Se.intersects(Ae,ae)})})})})},e.toComparators=function(ie,ae){return new ye(ie,ae).set.map(function(ce){return ce.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new K(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(je(this.set[ae],ie))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ie,ae,ce){var Se=null,Pe=null;try{var Ae=new ye(ae,ce)}catch(Te){return null}return ie.forEach(function(Te){Ae.test(Te)&&(Se&&Pe.compare(Te)!==-1||(Pe=new K(Se=Te,ce)))}),Se},e.minSatisfying=function(ie,ae,ce){var Se=null,Pe=null;try{var Ae=new ye(ae,ce)}catch(Te){return null}return ie.forEach(function(Te){Ae.test(Te)&&(Se&&Pe.compare(Te)!==1||(Pe=new K(Se=Te,ce)))}),Se},e.validRange=function(ie,ae){try{return new ye(ie,ae).range||"*"}catch(ce){return null}},e.ltr=function(ie,ae,ce){return qe(ie,ae,"<",ce)},e.gtr=function(ie,ae,ce){return qe(ie,ae,">",ce)},e.outside=qe,e.prerelease=function(ie,ae){var ce=x(ie,ae);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ie,ae,ce){return ie=new ye(ie,ce),ae=new ye(ae,ce),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof K)return ie;if(typeof ie!="string")return null;var ae=ie.match(R[O]);return ae==null?null:x((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,T(1))},function(J,e){var T,_,D=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function R(p){if(T===setTimeout)return setTimeout(p,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(p,0);try{return T(p,0)}catch(m){try{return T.call(null,p,0)}catch(E){return T.call(this,p,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch(p){T=L}try{_=typeof clearTimeout=="function"?clearTimeout:i}catch(p){_=i}})();var w,b=[],I=!1,C=-1;function d(){I&&w&&(I=!1,w.length?b=w.concat(b):C=-1,b.length&&v())}function v(){if(!I){var p=R(d);I=!0;for(var m=b.length;m;){for(w=b,b=[];++C<m;)w&&w[C].run();C=-1,m=b.length}w=null,I=!1,function(E){if(_===clearTimeout)return clearTimeout(E);if((_===i||!_)&&clearTimeout)return _=clearTimeout,clearTimeout(E);try{_(E)}catch(f){try{return _.call(null,E)}catch(c){return _.call(this,E)}}}(p)}}function h(p,m){this.fun=p,this.array=m}function y(){}D.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)m[E-1]=arguments[E];b.push(new h(p,m)),b.length!==1||I||R(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(p){return[]},D.binding=function(p){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(p){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[103],ne([0,1]),function(J,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class _{constructor(R,w,b){this.level=R,this.key=w,this.value=b,this.forward=[]}}const D=void 0;class L{constructor(R,w=2**16){this.comparator=R,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(w)|0),this._header=new _(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new _(this._maxLevel,D,D)}has(R){return Boolean(L._search(this,R,this.comparator))}get(R){return L._search(this,R,this.comparator)?.value}set(R,w){return L._insert(this,R,w,this.comparator)&&(this._size+=1),this}delete(R){const w=L._delete(this,R,this.comparator);return w&&(this._size-=1),w}forEach(R,w){let b=this._header.forward[0];for(;b;)R.call(w,b.value,b.key,this),b=b.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",w=this._header.forward[0];for(;w;)R+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return R}static _search(R,w,b){let I=R._header;for(let C=R._level-1;C>=0;C--)for(;I.forward[C]&&b(I.forward[C].key,w)<0;)I=I.forward[C];if(I=I.forward[0],I&&b(I.key,w)===0)return I}static _insert(R,w,b,I){let C=[],d=R._header;for(let v=R._level-1;v>=0;v--){for(;d.forward[v]&&I(d.forward[v].key,w)<0;)d=d.forward[v];C[v]=d}if(d=d.forward[0],d&&I(d.key,w)===0)return d.value=b,!1;{let v=L._randomLevel(R);if(v>R._level){for(let h=R._level;h<v;h++)C[h]=R._header;R._level=v}d=new _(v,w,b);for(let h=0;h<v;h++)d.forward[h]=C[h].forward[h],C[h].forward[h]=d;return!0}}static _randomLevel(R,w=.5){let b=1;for(;Math.random()<w&&b<R._maxLevel;)b+=1;return b}static _delete(R,w,b){let I=[],C=R._header;for(let d=R._level-1;d>=0;d--){for(;C.forward[d]&&b(C.forward[d].key,w)<0;)C=C.forward[d];I[d]=C}if(C=C.forward[0],!C||b(C.key,w)!==0)return!1;for(let d=0;d<R._level&&I[d].forward[d]===C;d++)I[d].forward[d]=C.forward[d];for(;R._level>0&&R._header.forward[R._level-1]===D;)R._level-=1;return!0}}e.SkipList=L}),define(te[104],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=T.globals.performance&&typeof T.globals.performance.now=="function";class D{constructor(i){this._highResolution=_&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new D(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?T.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,9,68,2,101,104]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(c){c.None=()=>D.Disposable.None;function l(A){return(F,B=null,Z)=>{let V=!1,j;return j=A(Q=>{if(!V)return j?j.dispose():V=!0,F.call(B,Q)},null,Z),V&&j.dispose(),j}}c.once=l;function s(A,F){return u((B,Z=null,V)=>A(j=>B.call(Z,F(j)),null,V))}c.map=s;function a(A,F){return u((B,Z=null,V)=>A(j=>{F(j),B.call(Z,j)},null,V))}c.forEach=a;function n(A,F){return u((B,Z=null,V)=>A(j=>F(j)&&B.call(Z,j),null,V))}c.filter=n;function t(A){return A}c.signal=t;function r(...A){return(F,B=null,Z)=>(0,D.combinedDisposable)(...A.map(V=>V(j=>F.call(B,j),null,Z)))}c.any=r;function o(A,F,B){let Z=B;return s(A,V=>(Z=F(Z,V),Z))}c.reduce=o;function u(A){let F;const B=new d({onFirstListenerAdd(){F=A(B.fire,B)},onLastListenerRemove(){F.dispose()}});return B.event}function g(A,F,B=100,Z=!1,V){let j,Q,M,N=0;const q=new d({leakWarningThreshold:V,onFirstListenerAdd(){j=A(x=>{N++,Q=F(Q,x),Z&&!M&&(q.fire(Q),Q=void 0),clearTimeout(M),M=setTimeout(()=>{const K=Q;Q=void 0,M=void 0,(!Z||N>1)&&q.fire(K),N=0},B)})},onLastListenerRemove(){j.dispose()}});return q.event}c.debounce=g;function S(A,F=(B,Z)=>B===Z){let B=!0,Z;return n(A,V=>{const j=B||!F(V,Z);return B=!1,Z=V,j})}c.latch=S;function P(A,F){return[c.filter(A,F),c.filter(A,B=>!F(B))]}c.split=P;function O(A,F=!1,B=[]){let Z=B.slice(),V=A(M=>{Z?Z.push(M):Q.fire(M)});const j=()=>{Z&&Z.forEach(M=>Q.fire(M)),Z=null},Q=new d({onFirstListenerAdd(){V||(V=A(M=>Q.fire(M)))},onFirstListenerDidAdd(){Z&&(F?setTimeout(j):j())},onLastListenerRemove(){V&&V.dispose(),V=null}});return Q.event}c.buffer=O;class U{constructor(F){this.event=F}map(F){return new U(s(this.event,F))}forEach(F){return new U(a(this.event,F))}filter(F){return new U(n(this.event,F))}reduce(F,B){return new U(o(this.event,F,B))}latch(){return new U(S(this.event))}debounce(F,B=100,Z=!1,V){return new U(g(this.event,F,B,Z,V))}on(F,B,Z){return this.event(F,B,Z)}once(F,B,Z){return l(this.event)(F,B,Z)}}function W(A){return new U(A)}c.chain=W;function $(A,F,B=Z=>Z){const Z=(...M)=>Q.fire(B(...M)),V=()=>A.on(F,Z),j=()=>A.removeListener(F,Z),Q=new d({onFirstListenerAdd:V,onLastListenerRemove:j});return Q.event}c.fromNodeEventEmitter=$;function k(A,F,B=Z=>Z){const Z=(...M)=>Q.fire(B(...M)),V=()=>A.addEventListener(F,Z),j=()=>A.removeEventListener(F,Z),Q=new d({onFirstListenerAdd:V,onLastListenerRemove:j});return Q.event}c.fromDOMEventEmitter=k;function z(A){return new Promise(F=>l(A)(F))}c.toPromise=z})(R=e.Event||(e.Event={}));class w{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${w._idPool++}`}start(l){this._stopWatch=new i.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let b=-1;function I(c){const l=b;return b=c,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=I;class C{constructor(l,s=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let s=b;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||l<s)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(a)||0;if(this._stacks.set(a,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let t,r=0;for(const[o,u]of this._stacks)(!t||r<u)&&(t=o,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=b>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(l,s,a)=>{this._listeners||(this._listeners=new L.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(s?[l,s]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,s);const r=this._leakageMon?.check(this._listeners.size),o=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,a]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(n){(0,T.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class v extends d{async fireAsync(l,s,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),r=[],o={...t,waitUntil:u=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");a&&(u=a(u,typeof n=="function"?n:n[0])),r.push(u)}};try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(u){(0,T.onUnexpectedError)(u);continue}Object.freeze(r),await Promise.allSettled(r).then(u=>{for(const g of u)g.status==="rejected"&&(0,T.onUnexpectedError)(g.reason)})}}}}e.AsyncEmitter=v;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class y extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=y;class p extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=p;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const s={event:l,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const a=()=>{this.hasListeners&&this.unhook(s);const n=this.events.indexOf(s);this.events.splice(n,1)};return(0,D.toDisposable)((0,_.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(s=>this.emitter.fire(s))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class E{constructor(){this.buffers=[]}wrapEvent(l){return(s,a,n)=>l(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>s.call(a,t)):s.call(a,t)},void 0,n)}bufferEvents(l){const s=[];this.buffers.push(s);const a=l();return this.buffers.pop(),s.forEach(n=>n()),a}}e.EventBufferer=E;class f{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(te[27],ne([0,1,3]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const _=Object.freeze(function(R,w){const b=setTimeout(R.bind(w),0);return{dispose(){clearTimeout(b)}}});var D;(function(R){function w(b){return b===R.None||b===R.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=w,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:T.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(D=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?_:(this._emitter||(this._emitter=new T.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=i}),define(te[49],ne([0,1,3]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class _{constructor(){this._icons=new Map,this._onDidRegister=new T.Emitter}add(I){const C=this._icons.get(I.id);C?I.description?C.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new _;e.iconRegistry=D;function L(b){return b?b.replace(/\$\((.*?)\)/g,(I,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(I,C,d){this.id=I,this.definition=C,this.description=d,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function R(b,I){const C=["codicon","codicon-"+b];return I&&C.push("codicon-modifier-"+I),C}e.getClassNamesArray=R;var w;(function(b){b.iconNameSegment="[A-Za-z0-9]+",b.iconNameExpression="[A-Za-z0-9-]+",b.iconModifierExpression="~[A-Za-z]+",b.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${b.iconNameExpression})(${b.iconModifierExpression})?$`);function C(h){if(h instanceof i)return["codicon","codicon-"+h.id];const y=I.exec(h.id);if(!y)return C(i.error);let[,p,m]=y;const E=["codicon","codicon-"+p];return m&&E.push("codicon-modifier-"+m.substr(1)),E}b.asClassNameArray=C;function d(h){return C(h).join(" ")}b.asClassName=d;function v(h){return"."+C(h).join(".")}b.asCSSSelector=v})(w=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,9,2]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function L(f){const c=f;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=L;function i(f,c){return new R(f,c)}e.newWriteableStream=i;class R{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,T.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const a=s.indexOf(l);a>=0&&s.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(f,c){const l=[];let s;for(;(s=f.read())!==null;)l.push(s);return c(l)}e.consumeReadable=w;function b(f,c,l){const s=[];let a;for(;(a=f.read())!==null&&s.length<l;)s.push(a);return a===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return f.read()}}}e.peekReadable=b;function I(f,c){return new Promise((l,s)=>{const a=[];C(f,{onData:n=>{c&&a.push(n)},onError:n=>{c?s(n):l(void 0)},onEnd:()=>{l(c?c(a):void 0)}})})}e.consumeStream=I;function C(f,c){f.on("error",l=>c.onError(l)),f.on("end",()=>c.onEnd()),f.on("data",l=>c.onData(l))}e.listenStream=C;function d(f,c){return new Promise((l,s)=>{const a=new _.DisposableStore,n=[],t=u=>{if(n.push(u),n.length>c)return a.dispose(),f.pause(),l({stream:f,buffer:n,ended:!1})},r=u=>s(u),o=()=>l({stream:f,buffer:n,ended:!0});a.add((0,_.toDisposable)(()=>f.removeListener("error",r))),f.on("error",r),a.add((0,_.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),a.add((0,_.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}e.peekStream=d;function v(f,c){const l=i(c);return l.end(f),l}e.toStream=v;function h(){const f=i(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function y(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=y;function p(f,c,l){const s=i(l);return C(f,{onData:a=>s.write(c.data(a)),onError:a=>s.error(c.error?c.error(a):a),onEnd:()=>s.end()}),s}e.transform=p;function m(f,c,l){let s=!1;return{read:()=>{const a=c.read();return s?a:(s=!0,a!==null?l([f,a]):f)}}}e.prefixedReadable=m;function E(f,c,l){let s=!1;const a=i(l);return C(c,{onData:n=>s?a.write(n):(s=!0,a.write(l([f,n]))),onError:n=>a.error(n),onEnd:()=>{s||(s=!0,a.write(f)),a.end()}}),a}e.prefixedStream=E}),define(te[19],ne([0,1,50]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer!="undefined";let D,L;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return _?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return _&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&_?new i(Buffer.from(t)):(D||(D=new TextEncoder),new i(D.encode(t)))}static fromByteArray(t){const r=i.alloc(t.length);for(let o=0,u=t.length;o<u;o++)r.buffer[o]=t[o];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let g=0,S=t.length;g<S;g++)r+=t[g].byteLength}const o=i.alloc(r);let u=0;for(let g=0,S=t.length;g<S;g++){const P=t[g];o.set(P,u),u+=P.byteLength}return o}clone(){const t=i.alloc(this.byteLength);return t.set(this),t}toString(){return _?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(t,r){return new i(this.buffer.subarray(t,r))}set(t,r){if(t instanceof i)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,r){I(this.buffer,t,r)}readUInt32LE(t){return C(this.buffer,t)}writeUInt32LE(t,r){d(this.buffer,t,r)}readUInt8(t){return v(this.buffer,t)}writeUInt8(t,r){h(this.buffer,t,r)}}e.VSBuffer=i;function R(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=R;function w(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255}e.writeUInt16LE=w;function b(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=b;function I(n,t,r){n[r+3]=t,t=t>>>8,n[r+2]=t,t=t>>>8,n[r+1]=t,t=t>>>8,n[r]=t}e.writeUInt32BE=I;function C(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=C;function d(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255,t=t>>>8,n[r+2]=t&255,t=t>>>8,n[r+3]=t&255}e.writeUInt32LE=d;function v(n,t){return n[t]}e.readUInt8=v;function h(n,t,r){n[r]=t}e.writeUInt8=h;function y(n){return T.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=y;function p(n){return T.toReadable(n)}e.bufferToReadable=p;function m(n){return T.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=m;async function E(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=E;function f(n){return T.toStream(n,t=>i.concat(t))}e.bufferToStream=f;function c(n){return T.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=c;function l(n){return T.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=l;function s(n,t){return T.prefixedReadable(n,t,r=>i.concat(r))}e.prefixedBufferReadable=s;function a(n,t){return T.prefixedStream(n,t,r=>i.concat(r))}e.prefixedBufferStream=a}),define(te[25],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=_;const D=/{(\d+)}/g;function L(Y,...se){return se.length===0?Y:Y.replace(D,function(ue,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=se.length?ue:se[pe]})}e.format=L;const i=/{([^}]+)}/g;function R(Y,se){return Y.replace(i,(ue,fe)=>se[fe]??ue)}e.format2=R;function w(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=w;function b(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function I(Y,se){let ue=0;const fe=se.charCodeAt(0);for(let pe=Y.length-1;pe>=0;pe--)Y.charCodeAt(pe)===fe&&ue++;return ue}e.count=I;function C(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=C;function d(Y,se=" "){const ue=v(Y,se);return h(ue,se)}e.trim=d;function v(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let fe=0;for(;Y.indexOf(se,fe)===fe;)fe=fe+ue;return Y.substring(fe)}e.ltrim=v;function h(Y,se){if(!Y||!se)return Y;const ue=se.length,fe=Y.length;if(ue===0||fe===0)return Y;let pe=fe,ge=-1;for(;ge=Y.lastIndexOf(se,pe-1),!(ge===-1||ge+ue!==pe);){if(ge===0)return"";pe=ge}return Y.substring(0,pe)}e.rtrim=h;function y(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function m(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=b(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(Y,fe)}e.createRegExp=m;function E(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function f(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function c(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=c;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function s(Y){for(let se=0,ue=Y.length;se<ue;se++){const fe=Y.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=s;function a(Y,se=0,ue=Y.length){for(let fe=se;fe<ue;fe++){const pe=Y.charCodeAt(fe);if(pe!==32&&pe!==9)return Y.substring(se,fe)}return Y.substring(se,ue)}e.getLeadingWhitespace=a;function n(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const fe=Y.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(Y,se){return Y<se?-1:Y>se?1:0}e.compare=t;function r(Y,se,ue=0,fe=Y.length,pe=0,ge=se.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=Y.charCodeAt(ue),Le=se.charCodeAt(pe);if(ke<Le)return-1;if(ke>Le)return 1}const Ee=fe-ue,Re=ge-pe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstring=r;function o(Y,se){return u(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=o;function u(Y,se,ue=0,fe=Y.length,pe=0,ge=se.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=Y.charCodeAt(ue),Le=se.charCodeAt(pe);if(ke===Le)continue;if(ke>=128||Le>=128)return r(Y.toLowerCase(),se.toLowerCase(),ue,fe,pe,ge);g(ke)&&(ke-=32),g(Le)&&(Le-=32);const $e=ke-Le;if($e!==0)return $e}const Ee=fe-ue,Re=ge-pe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstringIgnoreCase=u;function g(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=g;function S(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=S;function P(Y,se){return Y.length===se.length&&u(Y,se)===0}e.equalsIgnoreCase=P;function O(Y,se){const ue=se.length;return se.length>Y.length?!1:u(Y,se,0,ue)===0}e.startsWithIgnoreCase=O;function U(Y,se){let ue,fe=Math.min(Y.length,se.length);for(ue=0;ue<fe;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=U;function W(Y,se){let ue,fe=Math.min(Y.length,se.length);const pe=Y.length-1,ge=se.length-1;for(ue=0;ue<fe;ue++)if(Y.charCodeAt(pe-ue)!==se.charCodeAt(ge-ue))return ue;return fe}e.commonSuffixLength=W;function $(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=$;function k(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=k;function z(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=z;function A(Y,se,ue){const fe=Y.charCodeAt(ue);if($(fe)&&ue+1<se){const pe=Y.charCodeAt(ue+1);if(k(pe))return z(fe,pe)}return fe}e.getNextCodePoint=A;function F(Y,se){const ue=Y.charCodeAt(se-1);if(k(ue)&&se>1){const fe=Y.charCodeAt(se-2);if($(fe))return z(fe,ue)}return ue}function B(Y,se){const ue=ae.getInstance(),fe=se,pe=Y.length,ge=A(Y,pe,se);se+=ge>=65536?2:1;let Ee=ue.getGraphemeBreakType(ge);for(;se<pe;){const Re=A(Y,pe,se),ke=ue.getGraphemeBreakType(Re);if(qe(Ee,ke))break;se+=Re>=65536?2:1,Ee=ke}return se-fe}e.nextCharLength=B;function Z(Y,se){const ue=ae.getInstance(),fe=se,pe=F(Y,se);se-=pe>=65536?2:1;let ge=ue.getGraphemeBreakType(pe);for(;se>0;){const Ee=F(Y,se),Re=ue.getGraphemeBreakType(Ee);if(qe(Re,ge))break;se-=Ee>=65536?2:1,ge=Re}return fe-se}e.prevCharLength=Z;function V(Y,se){const ue=ae.getInstance(),fe=Y.length,pe=se,ge=A(Y,fe,se),Ee=ue.getGraphemeBreakType(ge);se+=ge>=65536?2:1;let Re=Ee;for(;se<fe;){const Le=A(Y,fe,se),$e=ue.getGraphemeBreakType(Le);if(qe(Re,$e))break;se+=Le>=65536?2:1,Re=$e}const ke=se;for(se=pe,Re=Ee;se>0;){const Le=F(Y,se),$e=ue.getGraphemeBreakType(Le);if(qe($e,Re))break;se-=Le>=65536?2:1,Re=$e}return[se,ke]}function j(Y,se){return se>0&&k(Y.charCodeAt(se))?V(Y,se-1):V(Y,se)}e.getCharContainingOffset=j;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function M(Y){return Q.test(Y)}e.containsRTL=M;const N=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function q(Y){return N.test(Y)}e.containsEmoji=q;const x=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return x.test(Y)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=ee;function H(Y){for(let se=0,ue=Y.length;se<ue;se++)if(X(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=H;function X(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=X;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=re;function oe(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let fe=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)fe=ue.lastIndex,ue.lastIndex+=1;return Y.substring(fe).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Ce(Y){return Y&&(Y=Y.replace(le,""),Y=Y.replace(he,""),Y=Y.replace(be,"")),Y}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function ve(Y){return we(Y)?Y.substr(1):Y}e.stripUTF8BOM=ve;function De(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,fe=Y.toLowerCase();let pe=0,ge=-1;for(;pe<ue;){const Ee=fe.indexOf(se[pe],ge+1);if(Ee<0)return!1;ge=Ee,pe++}return!0}e.fuzzyContains=De;function ye(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ye;function Ie(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Ie;function Me(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Me;function je(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=je;function Ne(Y){return ae.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function qe(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=qe;var ie;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ce()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,fe=ue.length/3;let pe=1;for(;pe<=fe;)if(se<ue[3*pe])pe=2*pe;else if(se>ue[3*pe+1])pe=2*pe+1;else return ue[3*pe+2];return 0}}ae._INSTANCE=null;function ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(Y,se){if(Y===0)return 0;const ue=Pe(Y,se);if(ue!==void 0)return ue;const fe=F(se,Y);return Y-=Ae(fe),Y}e.getLeftDeleteOffset=Se;function Pe(Y,se){let ue=F(se,Y);for(Y-=Ae(ue);Te(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=F(se,Y),Y-=Ae(ue)}if(!!re(ue)){if(Y>=0){const fe=F(se,Y);fe===8205&&(Y-=Ae(fe))}return Y}}function Ae(Y){return Y>=65536?2:1}function Te(Y){return 127995<=Y&&Y<=127999}var Fe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!_e.map){let fe=function(Ee){const Re=new Map;for(let ke=0;ke<Ee.length;ke+=2)Re.set(Ee[ke],Ee[ke+1]);return Re};const se=_e.getData();let ue=T.locale;(!ue||!(ue in se))&&(ue=T.language),(!ue||!(ue in se))&&(ue="_default");const pe=fe(se._common),ge=fe(se[ue]);for(const[Ee,Re]of ge)pe.set(Ee,Re);_e.map=pe}return _e.map}static isAmbiguous(se){return _e.getConfusablesForCurrentLocale().has(se)}static getPrimaryConfusable(se){return _e.getConfusablesForCurrentLocale().get(se)}static getPrimaryConfusableCodePoints(){return new Set(_e.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=_e;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(se){return Ue.getData().has(se)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue,Ue._data=void 0}),define(te[105],ne([0,1,25]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function _(m){return D(m,0)}e.hash=_;function D(m,E){switch(typeof m){case"object":return m===null?L(349,E):Array.isArray(m)?w(m,E):b(m,E);case"string":return R(m,E);case"boolean":return i(m,E);case"number":return L(m,E);case"undefined":return L(937,E);default:return L(617,E)}}e.doHash=D;function L(m,E){return(E<<5)-E+m|0}e.numberHash=L;function i(m,E){return L(m?433:863,E)}function R(m,E){E=L(149417,E);for(let f=0,c=m.length;f<c;f++)E=L(m.charCodeAt(f),E);return E}e.stringHash=R;function w(m,E){return E=L(104579,E),m.reduce((f,c)=>D(c,f),E)}function b(m,E){return E=L(181387,E),Object.keys(m).sort().reduce((f,c)=>(f=R(c,f),D(m[c],f)),E)}class I{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=D(E,this._value),this._value}}e.Hasher=I;var C;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function d(m,E,f=32){const c=f-E,l=~((1<<c)-1);return(m<<E|(l&m)>>>c)>>>0}function v(m,E=0,f=m.byteLength,c=0){for(let l=0;l<f;l++)m[E+l]=c}function h(m,E,f="0"){for(;m.length<E;)m=f+m;return m}function y(m,E=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),E/4)}e.toHexString=y;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const f=E.length;if(f===0)return;const c=this._buff;let l=this._buffLen,s=this._leftoverHighSurrogate,a,n;for(s!==0?(a=s,n=-1,s=0):(a=E.charCodeAt(0),n=0);;){let t=a;if(T.isHighSurrogate(a))if(n+1<f){const r=E.charCodeAt(n+1);T.isLowSurrogate(r)?(n++,t=T.computeCodePoint(a,r)):t=65533}else{s=a;break}else T.isLowSurrogate(a)&&(t=65533);if(l=this._push(c,l,t),n++,n<f)a=E.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=s}_push(E,f,c){return c<128?E[f++]=c:c<2048?(E[f++]=192|(c&1984)>>>6,E[f++]=128|(c&63)>>>0):c<65536?(E[f++]=224|(c&61440)>>>12,E[f++]=128|(c&4032)>>>6,E[f++]=128|(c&63)>>>0):(E[f++]=240|(c&1835008)>>>18,E[f++]=128|(c&258048)>>>12,E[f++]=128|(c&4032)>>>6,E[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,f=this._buffDV;for(let u=0;u<64;u+=4)E.setUint32(u,f.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)E.setUint32(u,d(E.getUint32(u-12,!1)^E.getUint32(u-32,!1)^E.getUint32(u-56,!1)^E.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,s=this._h2,a=this._h3,n=this._h4,t,r,o;for(let u=0;u<80;u++)u<20?(t=l&s|~l&a,r=1518500249):u<40?(t=l^s^a,r=1859775393):u<60?(t=l&s|l&a|s&a,r=2400959708):(t=l^s^a,r=3395469782),o=d(c,5)+t+n+r+E.getUint32(u*4,!1)&4294967295,n=a,a=s,s=d(l,30),l=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(J,e,T,_,D){if(_==="m")throw new TypeError("Private method is not writable");if(_==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return _==="a"?D.call(J,T):D?D.value=T:e.set(J,T),T},Ve=this&&this.__classPrivateFieldGet||function(J,e,T,_){if(T==="a"&&!_)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!_:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return T==="m"?_:T==="a"?_.call(J):_?_.value:e.get(J)};define(te[40],ne([0,1,17,25]),function(J,e,T,_){"use strict";var D,L,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,t,r){let o=n.get(t);return o===void 0&&(o=r,n.set(t,o)),o}e.getOrSet=R;function w(n){const t=[];return n.forEach((r,o)=>{t.push(`${o} => ${r}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=w;function b(n){const t=[];return n.forEach(r=>{t.push(r)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=b;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,_.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class d{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,_.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var v;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,_.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,_.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,_.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,_.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(p||(p={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new C)}clear(){this._root=void 0}fill(t,r){if(r){const o=r.slice(0);(0,T.shuffle)(o);for(let u of o)this.set(u,t)}else{const o=t.slice(0);(0,T.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(t,r){const o=this._iter.reset(t);let u;this._root||(this._root=new y,this._root.segment=o.value());const g=[];for(u=this._root;;){const P=o.cmp(u.segment);if(P>0)u.left||(u.left=new y,u.left.segment=o.value()),g.push([-1,u]),u=u.left;else if(P<0)u.right||(u.right=new y,u.right.segment=o.value()),g.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new y,u.mid.segment=o.value()),g.push([0,u]),u=u.mid;else break}const S=u.value;u.value=r,u.key=t;for(let P=g.length-1;P>=0;P--){const O=g[P][1];O.updateHeight();const U=O.balanceFactor();if(U<-1||U>1){const W=g[P][0],$=g[P+1][0];if(W===1&&$===1)g[P][1]=O.rotateLeft();else if(W===-1&&$===-1)g[P][1]=O.rotateRight();else if(W===1&&$===-1)O.right=g[P+1][1]=g[P+1][1].rotateRight(),g[P][1]=O.rotateLeft();else if(W===-1&&$===1)O.left=g[P+1][1]=g[P+1][1].rotateLeft(),g[P][1]=O.rotateRight();else throw new Error;if(P>0)switch(g[P-1][0]){case-1:g[P-1][1].left=g[P][1];break;case 1:g[P-1][1].right=g[P][1];break;case 0:g[P-1][1].mid=g[P][1];break}else this._root=g[0][1]}}return S}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let o=this._root;for(;o;){const u=r.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const o=this._iter.reset(t),u=[];let g=this._root;for(;g;){const S=o.cmp(g.segment);if(S>0)u.push([-1,g]),g=g.left;else if(S<0)u.push([1,g]),g=g.right;else if(o.hasNext())o.next(),u.push([0,g]),g=g.mid;else break}if(!!g){if(r?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const S=this._min(g.right),{key:P,value:O,segment:U}=S;this._delete(S.key,!1),g.key=P,g.value=O,g.segment=U}else{const S=g.left??g.right;if(u.length>0){const[P,O]=u[u.length-1];switch(P){case-1:O.left=S;break;case 0:O.mid=S;break;case 1:O.right=S;break}}else this._root=S}for(let S=u.length-1;S>=0;S--){const P=u[S][1];P.updateHeight();const O=P.balanceFactor();if(O>1?(P.right.balanceFactor()>=0||(P.right=u[S+1][1]=u[S+1][1].rotateRight()),u[S][1]=P.rotateLeft()):O<-1&&(P.left.balanceFactor()<=0||(P.left=u[S+1][1]=u[S+1][1].rotateLeft()),u[S][1]=P.rotateRight()),S>0)switch(u[S-1][0]){case-1:u[S-1][1].left=u[S][1];break;case 1:u[S-1][1].right=u[S][1];break;case 0:u[S-1][1].mid=u[S][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let o=this._root,u;for(;o;){const g=r.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(r.hasNext())r.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(t){const r=this._iter.reset(t);let o=this._root;for(;o;){const u=r.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[r,o]of this)t(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=m;class E{constructor(t,r){this.uri=t,this.value=r}}class f{constructor(t,r){this[D]="ResourceMap",t instanceof f?(this.map=new Map(t.map),this.toKey=r??f.defaultToKey):(this.map=new Map,this.toKey=t??f.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new E(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[o,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const o=this._map.get(t);if(!!o)return r!==0&&this.touch(o,r),o.value}set(t,r,o=0){let u=this._map.get(t);if(u)u.value=r,o!==0&&this.touch(u,o);else{switch(u={key:t,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const o=this._state;let u=this._head;for(;u;){if(r?t.bind(r)(u.value,u.key,this):t(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:o.key,done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}values(){const t=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:o.value,done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}entries(){const t=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:[o.key,o.value],done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>t;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,o=t.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const o=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const o=t.next,u=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,o)=>{t.push([o,r])}),t}fromJSON(t){this.clear();for(const[r,o]of t)this.set(r,o)}}e.LinkedMap=l;class s extends l{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class a{constructor(t){i.set(this,void 0),bt(this,i,t,"f")}get size(){return Ve(this,i,"f").size}forEach(t,r){Ve(this,i,"f").forEach(t,r)}get(t){return Ve(this,i,"f").get(t)}has(t){return Ve(this,i,"f").has(t)}entries(){return Ve(this,i,"f").entries()}keys(){return Ve(this,i,"f").keys()}values(){return Ve(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ve(this,i,"f").entries()}}e.ReadonlyMapView=a}),define(te[69],ne([0,1,40]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const _=new T.LRUCache(1e4);function D(b){return w(b,"NFC",_)}e.normalizeNFC=D;const L=new T.LRUCache(1e4);function i(b){return w(b,"NFD",L)}e.normalizeNFD=i;const R=/[^\u0000-\u0080]/;function w(b,I,C){if(!b)return b;const d=C.get(b);if(d)return d;let v;return R.test(b)?v=b.normalize(I):v=b,C.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return i(I).replace(b,"")}}()}),define(te[15],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function T(g){return Array.isArray(g)}e.isArray=T;function _(g){return typeof g=="string"}e.isString=_;function D(g){return Array.isArray(g)&&g.every(S=>_(S))}e.isStringArray=D;function L(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=L;function i(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=i;function R(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=R;function w(g){return g===!0||g===!1}e.isBoolean=w;function b(g){return typeof g=="undefined"}e.isUndefined=b;function I(g){return!C(g)}e.isDefined=I;function C(g){return b(g)||g===null}e.isUndefinedOrNull=C;function d(g,S){if(!g)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=d;function v(g){if(C(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=v;function h(...g){const S=[];for(let P=0;P<g.length;P++){const O=g[P];if(C(O))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);S.push(O)}return S}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function p(g){if(!L(g))return!1;for(let S in g)if(y.call(g,S))return!1;return!0}e.isEmptyObject=p;function m(g){return typeof g=="function"}e.isFunction=m;function E(...g){return g.length>0&&g.every(m)}e.areFunctions=E;function f(g,S){const P=Math.min(g.length,S.length);for(let O=0;O<P;O++)c(g[O],S[O])}e.validateConstraints=f;function c(g,S){if(_(S)){if(typeof g!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(m(S)){try{if(g instanceof S)return}catch{}if(!C(g)&&g.constructor===S||S.length===1&&S.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(g){let S=[],P=Object.getPrototypeOf(g);for(;Object.prototype!==P;)S=S.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return S}e.getAllPropertyNames=l;function s(g){const S=[];for(const P of l(g))typeof g[P]=="function"&&S.push(P);return S}e.getAllMethodNames=s;function a(g,S){const P=U=>function(){const W=Array.prototype.slice.call(arguments,0);return S(U,W)};let O={};for(const U of g)O[U]=P(U);return O}e.createProxyObject=a;function n(g){return g===null?void 0:g}e.withNullAsUndefined=n;function t(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=t;function r(g){return class{constructor(){return new Proxy({},{get(S,P){if(S[P])return S[P];throw new Error(`Not Implemented: ${g}->${String(P)}`)}})}}}e.NotImplementedProxy=r;function o(g,S="Unreachable"){throw new Error(S)}e.assertNever=o;function u(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=u}),define(te[41],ne([0,1,10,4,25,15]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function R(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=R;function w(n){return n.indexOf("/")===-1&&(n=R(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=w;function b(n,t=T.posix.sep){if(!n)return"";const r=n.length,o=n.charCodeAt(0);if(i(o)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let g=3;const S=g;for(;g<r&&!i(n.charCodeAt(g));g++);if(S!==g&&!i(n.charCodeAt(g+1))){for(g+=1;g<r;g++)if(i(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,t)}}return t}else if(m(o)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let u=n.indexOf("://");if(u!==-1){for(u+=3;u<r;u++)if(i(n.charCodeAt(u)))return n.slice(0,u+1)}return""}e.getRoot=b;function I(n){if(!_.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let r=2;const o=r;for(;r<n.length&&(t=n.charCodeAt(r),t!==92);r++);return!(o===r||(t=n.charCodeAt(r+1),isNaN(t)||t===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=_.isWindows){const r=t?C:d;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||t&&v.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function y(n,t,r){const o=n===t;return!r||o?o:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=y;function p(n,t,r,o=T.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(r){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let g=t.length;return t.charAt(t.length-1)===o&&g--,n.charAt(g)===o}return t.charAt(t.length-1)!==o&&(t+=o),n.indexOf(t)===0}e.isEqualOrParent=p;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function E(n,t){return _.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(t,n)),n=(0,T.normalize)(n),_.isWindows?(n=(0,D.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,D.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=E;function f(n){const t=(0,T.normalize)(n);return _.isWindows?n.length>3?!1:c(t)&&(n.length===2||t.charCodeAt(2)===92):t===T.posix.sep}e.isRootOrDriveLetter=f;function c(n,t){return(t!==void 0?t:_.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(n){return c(n)?n[0]:void 0}e.getDriveLetter=l;function s(n,t,r){return t.length>n.length?-1:n===t?0:(r&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=s;function a(n){const t=n.split(":");let r,o,u;if(t.forEach(g=>{const S=Number(g);(0,L.isNumber)(S)?o===void 0?o=S:u===void 0&&(u=S):r=r?[r,g].join(":"):g}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(te[28],ne([0,1,15]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function _(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const p=Array.isArray(y)?[]:{};return Object.keys(y).forEach(m=>{y[m]&&typeof y[m]=="object"?p[m]=_(y[m]):p[m]=y[m]}),p}e.deepClone=_;function D(y){if(!y||typeof y!="object")return y;const p=[y];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const E in m)if(L.call(m,E)){const f=m[E];typeof f=="object"&&!Object.isFrozen(f)&&p.push(f)}}return y}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function i(y,p){return R(y,p,new Set)}e.cloneAndChange=i;function R(y,p,m){if((0,T.isUndefinedOrNull)(y))return y;const E=p(y);if(typeof E!="undefined")return E;if((0,T.isArray)(y)){const f=[];for(const c of y)f.push(R(c,p,m));return f}if((0,T.isObject)(y)){if(m.has(y))throw new Error("Cannot clone recursive data-structure");m.add(y);const f={};for(let c in y)L.call(y,c)&&(f[c]=R(y[c],p,m));return m.delete(y),f}return y}function w(y,p,m=!0){return(0,T.isObject)(y)?((0,T.isObject)(p)&&Object.keys(p).forEach(E=>{E in y?m&&((0,T.isObject)(y[E])&&(0,T.isObject)(p[E])?w(y[E],p[E],m):y[E]=p[E]):y[E]=p[E]}),y):p}e.mixin=w;function b(y,p){if(y===p)return!0;if(y==null||p===null||p===void 0||typeof y!=typeof p||typeof y!="object"||Array.isArray(y)!==Array.isArray(p))return!1;let m,E;if(Array.isArray(y)){if(y.length!==p.length)return!1;for(m=0;m<y.length;m++)if(!b(y[m],p[m]))return!1}else{const f=[];for(E in y)f.push(E);f.sort();const c=[];for(E in p)c.push(E);if(c.sort(),!b(f,c))return!1;for(m=0;m<f.length;m++)if(!b(y[f[m]],p[f[m]]))return!1}return!0}e.equals=b;function I(y){const p=new Set;return JSON.stringify(y,(m,E)=>{if((0,T.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=I;function C(y,p,m){const E=p(y);return typeof E=="undefined"?m:E}e.getOrDefault=C;function d(y,p){const m=Object.create(null);return!y||!p||Object.keys(p).forEach(f=>{const c=y[f],l=p[f];b(c,l)||(m[f]=l)}),m}e.distinct=d;function v(y,p){const m=p.toLowerCase(),E=Object.keys(y).find(f=>f.toLowerCase()===m);return E?y[E]:y[p]}e.getCaseInsensitive=v;function h(y,p){const m=Object.create(null);for(const[E,f]of Object.entries(y))p(E,f)&&(m[E]=f);return m}e.filter=h}),define(te[7],ne([0,1,10,4]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,i=/^\/\//;function R(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,t){return!n&&!t?"file":n}function b(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const I="",C="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(t,r,o,u,g,S=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=w(t,S),this.authority=r||I,this.path=b(this.scheme,o||I),this.query=u||I,this.fragment=g||I,R(this,S))}static isUri(t){return t instanceof v?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return f(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:u,query:g,fragment:S}=t;return r===void 0?r=this.scheme:r===null&&(r=I),o===void 0?o=this.authority:o===null&&(o=I),u===void 0?u=this.path:u===null&&(u=I),g===void 0?g=this.query:g===null&&(g=I),S===void 0?S=this.fragment:S===null&&(S=I),r===this.scheme&&o===this.authority&&u===this.path&&g===this.query&&S===this.fragment?this:new y(r,o,u,g,S)}static parse(t,r=!1){const o=d.exec(t);return o?new y(o[2]||I,a(o[4]||I),a(o[5]||I),a(o[7]||I),a(o[9]||I),r):new y(I,I,I,I,I)}static file(t){let r=I;if(_.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const o=t.indexOf(C,2);o===-1?(r=t.substring(2),t=C):(r=t.substring(2,o),t=t.substring(o)||C)}return new y("file",r,t,I,I)}static from(t){const r=new y(t.scheme,t.authority,t.path,t.query,t.fragment);return R(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return _.isWindows&&t.scheme==="file"?o=v.file(T.win32.join(f(t,!0),...r)).path:o=T.posix.join(t.path,...r),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof v)return t;{const r=new y(t);return r._formatted=t.external,r._fsPath=t._sep===h?t.fsPath:null,r}}else return t}}e.URI=v;const h=_.isWindows?1:void 0;class y extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let r,o=-1;for(let u=0;u<n.length;u++){const g=n.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||t&&g===47)o!==-1&&(r+=encodeURIComponent(n.substring(o,u)),o=-1),r!==void 0&&(r+=n.charAt(u));else{r===void 0&&(r=n.substr(0,u));const S=p[g];S!==void 0?(o!==-1&&(r+=encodeURIComponent(n.substring(o,u)),o=-1),r+=S):o===-1&&(o=u)}}return o!==-1&&(r+=encodeURIComponent(n.substring(o))),r!==void 0?r:n}function E(n){let t;for(let r=0;r<n.length;r++){const o=n.charCodeAt(r);o===35||o===63?(t===void 0&&(t=n.substr(0,r)),t+=p[o]):t!==void 0&&(t+=n[r])}return t!==void 0?t:n}function f(n,t){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,_.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=f;function c(n,t){const r=t?E:m;let o="",{scheme:u,authority:g,path:S,query:P,fragment:O}=n;if(u&&(o+=u,o+=":"),(g||u==="file")&&(o+=C,o+=C),g){let U=g.indexOf("@");if(U!==-1){const W=g.substr(0,U);g=g.substr(U+1),U=W.indexOf(":"),U===-1?o+=r(W,!1):(o+=r(W.substr(0,U),!1),o+=":",o+=r(W.substr(U+1),!1)),o+="@"}g=g.toLowerCase(),U=g.indexOf(":"),U===-1?o+=r(g,!1):(o+=r(g.substr(0,U),!1),o+=g.substr(U))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const U=S.charCodeAt(1);U>=65&&U<=90&&(S=`/${String.fromCharCode(U+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const U=S.charCodeAt(0);U>=65&&U<=90&&(S=`${String.fromCharCode(U+32)}:${S.substr(2)}`)}o+=r(S,!0)}return P&&(o+="?",o+=r(P,!1)),O&&(o+="#",o+=t?O:m(O,!1)),o}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(s)?n.replace(s,t=>l(t)):n}}),define(te[106],ne([0,1,7]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function _(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=_;function D(b){const I=[];let C;try{const d=JSON.parse(b.arguments),v=d[d.length-1];v&&v.__$stack&&(d.pop(),C=v.__$stack),I.push(...d)}catch(d){I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:C}}e.parse=D;function L(b){if(typeof b!="string")return L(D(b).stack);const I=b;if(I){const C=i(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(d&&d.length===4)return{uri:T.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=L;function i(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function R(b,I){const{args:C,stack:d}=D(b),v=typeof C[0]=="string"&&C.length===1;let h=i(d);h&&(h=`(${h.trim()})`);let y=[];if(typeof C[0]=="string"?h&&v?y=[`%c[${I}] %c${C[0]} %c${h}`,w("blue"),w(""),w("grey")]:y=[`%c[${I}] %c${C[0]}`,w("blue"),w(""),...C.slice(1)]:y=[`%c[${I}]%`,w("blue"),...C],h&&!v&&y.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,y)}e.log=R;function w(b){return`color: ${b}`}}),define(te[107],ne([0,1,19,25,7]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function L(I){return JSON.stringify(I,w)}e.stringify=L;function i(I){let C=JSON.parse(I);return C=b(C),C}e.parse=i;var R;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function w(I,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,_.regExpFlags)(C)}:C}function b(I,C=0){if(!I||C>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof T.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let d=0;d<I.length;++d)I[d]=b(I[d],C+1);else for(const d in I)Object.hasOwnProperty.call(I,d)&&(I[d]=b(I[d],C+1))}return I}e.revive=b}),define(te[16],ne([0,1,4,7]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,b,I){this._hosts[w]=b,this._ports[w]=I}setConnectionToken(w,b){this._connectionTokens[w]=b}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let I=this._hosts[b];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[b],d=this._connectionTokens[b];let v=`path=${encodeURIComponent(w.path)}`;return typeof d=="string"&&(v+=`&tkn=${encodeURIComponent(d)}`),_.URI.from({scheme:T.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${I}:${C}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new L;class i{asBrowserUri(w,b){const I=this.toUri(w,b);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(T.isNative||typeof T.globals.importScripts=="function"&&T.globals.origin===`${D.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,b){const I=this.toUri(w,b);return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(w,b){return _.URI.isUri(w)?w:_.URI.parse(b.toUrl(w))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,41,16,10,4,25,7]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=w;class b{constructor(h){this._ignorePathCasing=h}compare(h,y,p=!1){return h===y?0:(0,i.compare)(this.getComparisonKey(h,p),this.getComparisonKey(y,p))}isEqual(h,y,p=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,p)===this.getComparisonKey(y,p)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,p=!1){if(h.scheme===y.scheme){if(h.scheme===_.Schemas.file)return T.isEqualOrParent(w(h),w(y),this._ignorePathCasing(h))&&h.query===y.query&&(p||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return T.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(p||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===_.Schemas.file?y=R.URI.file(D.dirname(w(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===_.Schemas.file?y=R.URI.file(D.normalize(w(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===_.Schemas.file){const E=D.relative(w(h),w(y));return L.isWindows?T.toSlashes(E):E}let p=h.path||"/",m=y.path||"/";if(this._ignorePathCasing(h)){let E=0;for(const f=Math.min(p.length,m.length);E<f&&!(p.charCodeAt(E)!==m.charCodeAt(E)&&p.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);p=m.substr(0,E)+p.substr(E)}return D.posix.relative(p,m)}resolvePath(h,y){if(h.scheme===_.Schemas.file){const p=R.URI.file(D.resolve(w(h),y));return h.with({authority:p.authority,path:p.path})}return y=T.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,i.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===_.Schemas.file){const p=w(h);return p.length>T.getRoot(p).length&&p[p.length-1]===y}else{const p=h.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let p=!1;if(h.scheme===_.Schemas.file){const m=w(h);p=m!==void 0&&m.length===T.getRoot(m).length&&m[m.length-1]===y}else{y="/";const m=h.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===_.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(v,h){const y=[];for(let p=0;p<v.length;p++){const m=h(v[p]);v.some((E,f)=>f===p?!1:(0,e.isEqualOrParent)(m,h(E)))||y.push(v[p])}return y}e.distinctParents=I;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(y){const p=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,l]=f.split(":");c&&l&&p.set(c,l)});const E=y.path.substring(0,y.path.indexOf(";"));return E&&p.set(v.META_DATA_MIME,E),p}v.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function d(v,h,y){if(h){let p=v.path;return p&&p[0]!==D.posix.sep&&(p=D.posix.sep+p),v.with({scheme:y,authority:h,path:p})}return v.with({scheme:y})}e.toLocalResource=d}),define(te[5],ne([0,1,27,9,3,2,18,4]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(M){return!!M&&typeof M.then=="function"}e.isThenable=w;function b(M){const N=new T.CancellationTokenSource,q=M(N.token),x=new Promise((K,ee)=>{const H=N.token.onCancellationRequested(()=>{H.dispose(),N.dispose(),ee((0,_.canceled)())});Promise.resolve(q).then(X=>{H.dispose(),N.dispose(),K(X)},X=>{H.dispose(),N.dispose(),ee(X)})});return new class{cancel(){N.cancel()}then(K,ee){return x.then(K,ee)}catch(K){return this.then(void 0,K)}finally(K){return x.finally(K)}}}e.createCancelablePromise=b;function I(M,N,q){return Promise.race([M,new Promise(x=>N.onCancellationRequested(()=>x(q)))])}e.raceCancellation=I;async function C(M){let N=-1;const q=M.map((K,ee)=>K.then(H=>(N=ee,H))),x=await Promise.race(q);return M.forEach((K,ee)=>{ee!==N&&K.cancel()}),x}e.raceCancellablePromises=C;function d(M,N,q){let x;const K=setTimeout(()=>{x?.(void 0),q?.()},N);return Promise.race([M.finally(()=>clearTimeout(K)),new Promise(ee=>x=ee)])}e.raceTimeout=d;function v(M){return new Promise((N,q)=>{const x=M();w(x)?x.then(N,q):N(x)})}e.asPromise=v;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(q,q).then(x)})}return new Promise((q,x)=>{this.queuedPromise.then(q,x)})}return this.activePromise=N(),new Promise((q,x)=>{this.activePromise.then(K=>{this.activePromise=null,q(K)},K=>{this.activePromise=null,x(K)})})}}e.Throttler=h;class y{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=y;class p{constructor(){this.promiseMap=new Map}queue(N,q){const K=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(N)===K&&this.promiseMap.delete(N)});return this.promiseMap.set(N,K),K}}e.SequencerByKey=p;class m{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,q=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,K)=>{this.doResolve=x,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,_.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=m;class E{constructor(N){this.delayer=new m(N),this.throttler=new h}trigger(N,q){return this.delayer.trigger(()=>this.throttler.queue(N),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class f{constructor(){this._isOpen=!1,this._promise=new Promise((N,q)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class c extends f{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(M,N){return N?new Promise((q,x)=>{const K=setTimeout(()=>{ee.dispose(),q()},M),ee=N.onCancellationRequested(()=>{clearTimeout(K),ee.dispose(),x((0,_.canceled)())})}):b(q=>l(M,q))}e.timeout=l;function s(M,N=0){const q=setTimeout(M,N);return(0,L.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=s;function a(M){const N=[];let q=0;const x=M.length;function K(){return q<x?M[q++]():null}function ee(H){H!=null&&N.push(H);const X=K();return X?X.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.sequence=a;function n(M,N=x=>!!x,q=null){let x=0;const K=M.length,ee=()=>{if(x>=K)return Promise.resolve(q);const H=M[x++];return Promise.resolve(H()).then(re=>N(re)?Promise.resolve(re):ee())};return ee()}e.first=n;function t(M,N=x=>!!x,q=null){if(M.length===0)return Promise.resolve(q);let x=M.length;const K=()=>{x=-1;for(const ee of M)ee.cancel?.()};return new Promise((ee,H)=>{for(const X of M)X.then(re=>{--x>=0&&N(re)?(K(),ee(re)):x===0&&ee(q)}).catch(re=>{--x>=0&&(K(),H(re))})})}e.firstParallel=t;class r{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((q,x)=>{this.outstandingPromises.push({factory:N,c:q,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const q=N.factory();q.then(N.c,N.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class o extends r{constructor(){super(1)}}e.Queue=o;class u{constructor(){this.queues=new Map}queueFor(N,q=i.extUri){const x=q.getComparisonKey(N);let K=this.queues.get(x);return K||(K=new o,D.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(x)}),this.queues.set(x,K)),K}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=u;class g{constructor(N,q){this._token=-1,typeof N=="function"&&typeof q=="number"&&this.setIfNotSet(N,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},q)}setIfNotSet(N,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},q))}}e.TimeoutTimer=g;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,q){this.cancel(),this._token=setInterval(()=>{N()},q)}}e.IntervalTimer=S;class P{constructor(N,q){this.timeoutToken=-1,this.runner=N,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class O{constructor(N,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class U extends P{constructor(N,q){super(N,q);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class W extends L.Disposable{constructor(N,q,x,K){super();this.maxWorkChunkSize=N,this.maxPendingWork=q,this.throttleDelay=x,this.handler=K,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=M=>{(0,R.setTimeout0)(()=>{if(N)return;const q=Date.now()+3;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(M,N)=>{const q=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(q))}}}}();class ${constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function k(M,N,q){let x;for(let K=0;K<q;K++)try{return await M()}catch(ee){x=ee,await l(N)}throw x}e.retry=k;class z{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,q,x){return this._pending={taskId:N,cancel:()=>x?.(),promise:q},q.then(()=>this.donePending(N),()=>this.donePending(N)),q}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let q,x;const K=new Promise((ee,H)=>{q=ee,x=H});this._next={run:N,promise:K,promiseResolve:q,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=z;class A{constructor(N,q=()=>Date.now()){this.interval=N,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=A;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,q)=>{this.completeCallback=N,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(q=>{this.completeCallback(N),this.resolved=!0,q()})}error(N){return new Promise(q=>{this.errorCallback(N),this.rejected=!0,q()})}cancel(){new Promise(N=>{this.errorCallback((0,_.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=F;var B;(function(M){async function N(x){let K;const ee=await Promise.all(x.map(H=>H.then(X=>X,X=>{K||(K=X)})));if(typeof K!="undefined")throw K;return ee}M.settled=N;function q(x){return new Promise(async(K,ee)=>{try{await x(K,ee)}catch(H){ee(H)}})}M.withAsyncBody=q})(B=e.Promises||(e.Promises={}));var Z;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(Z||(Z={}));class V{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const q={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(N(q)),this.resolve()}catch(x){this.reject(x)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}static fromArray(N){return new V(q=>{q.emitMany(N)})}static fromPromise(N){return new V(async q=>{q.emitMany(await N)})}static fromPromises(N){return new V(async q=>{await Promise.all(N.map(async x=>q.emitOne(await x)))})}static merge(N){return new V(async q=>{await Promise.all(N.map(async x=>{for await(const K of x)q.emitOne(K)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,q){return new V(async x=>{for await(const K of N)x.emitOne(q(K))})}map(N){return V.map(this,N)}static filter(N,q){return new V(async x=>{for await(const K of N)q(K)&&x.emitOne(K)})}filter(N){return V.filter(this,N)}static coalesce(N){return V.filter(N,q=>!!q)}coalesce(){return V.coalesce(this)}static async toPromise(N){const q=[];for await(const x of N)q.push(x);return q}toPromise(){return V.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class j extends V{constructor(N,q){super(q);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function Q(M){const N=new T.CancellationTokenSource,q=M(N.token);return new j(N,async x=>{const K=N.token.onCancellationRequested(()=>{K.dispose(),N.dispose(),x.reject((0,_.canceled)())});try{for await(const ee of q){if(N.token.isCancellationRequested)return;x.emitOne(ee)}K.dispose(),N.dispose()}catch(ee){K.dispose(),N.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=Q}),define(te[108],ne([0,1,5,41,40,10,25]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const w="**",b="/",I="[/\\\\]",C="[^/\\\\]",d=/\//g;function v(j){switch(j){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}|${I}${C}+)*?`}}function h(j,Q){if(!j)return[];const M=[];let N=!1,q=!1,x="";for(const K of j){switch(K){case Q:if(!N&&!q){M.push(x),x="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":q=!0;break;case"]":q=!1;break}x+=K}return x&&M.push(x),M}e.splitGlobAware=h;function y(j){if(!j)return"";let Q="";const M=h(j,b);if(M.every(N=>N===w))Q=".*";else{let N=!1;M.forEach((q,x)=>{if(q===w){N||(Q+=v(2),N=!0);return}let K=!1,ee="",H=!1,X="";for(const re of q){if(re!=="}"&&K){ee+=re;continue}if(H&&(re!=="]"||!X)){let oe;re==="-"?oe=re:(re==="^"||re==="!")&&!X?oe="^":re===b?oe="":oe=i.escapeRegExpCharacters(re),X+=oe;continue}switch(re){case"{":K=!0;continue;case"[":H=!0;continue;case"}":Q+=`(?:${h(ee,",").map(he=>y(he)).join("|")})`,K=!1,ee="";break;case"]":Q+="["+X+"]",H=!1,X="";break;case"?":Q+=C;continue;case"*":Q+=v(1);continue;default:Q+=i.escapeRegExpCharacters(re)}}x<M.length-1&&(M[x+1]!==w||x+2<M.length)&&(Q+=I),N=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new D.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(j,Q){if(!j)return n;let M;typeof j!="string"?M=j.pattern:M=j,M=M.trim();const N=`${M}_${!!Q.trimForExclusions}`;let q=s.get(N);if(q)return r(q,j);let x;if(p.test(M)){const K=M.substr(4);q=function(ee,H){return typeof ee=="string"&&ee.endsWith(K)?M:null}}else(x=m.exec(o(M,Q)))?q=u(x[1],M):(Q.trimForExclusions?f:E).test(M)?q=g(M,Q):(x=c.exec(o(M,Q)))?q=S(x[1].substr(1),M,!0):(x=l.exec(o(M,Q)))?q=S(x[1],M,!1):q=P(M);return s.set(N,q),r(q,j)}function r(j,Q){return typeof Q=="string"?j:function(M,N){return _.isEqualOrParent(M,Q.base)?j(L.relative(Q.base,M),N):null}}function o(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function u(j,Q){const M=`/${j}`,N=`\\${j}`,q=function(K,ee){return typeof K!="string"?null:ee?ee===j?Q:null:K===j||K.endsWith(M)||K.endsWith(N)?Q:null},x=[j];return q.basenames=x,q.patterns=[Q],q.allBasenames=x,q}function g(j,Q){const M=V(j.slice(1,-1).split(",").map(ee=>t(ee,Q)).filter(ee=>ee!==n),j),N=M.length;if(!N)return n;if(N===1)return M[0];const q=function(ee,H){for(let X=0,re=M.length;X<re;X++)if(M[X](ee,H))return j;return null},x=M.find(ee=>!!ee.allBasenames);x&&(q.allBasenames=x.allBasenames);const K=M.reduce((ee,H)=>H.allPaths?ee.concat(H.allPaths):ee,[]);return K.length&&(q.allPaths=K),q}function S(j,Q,M){const N=L.sep===L.posix.sep,q=N?j:j.replace(d,L.sep),x=L.sep+q,K=L.posix.sep+j,ee=M?function(H,X){return typeof H=="string"&&(H===q||H.endsWith(x)||!N&&(H===j||H.endsWith(K)))?Q:null}:function(H,X){return typeof H=="string"&&(H===q||!N&&H===j)?Q:null};return ee.allPaths=[(M?"*/":"./")+j],ee}function P(j){try{const Q=new RegExp(`^${y(j)}$`);return function(M){return Q.lastIndex=0,typeof M=="string"&&Q.test(M)?j:null}}catch(Q){return n}}function O(j,Q,M){return!j||typeof Q!="string"?!1:U(j)(Q,void 0,M)}e.match=O;function U(j,Q={}){if(!j)return a;if(typeof j=="string"||z(j)){const M=t(j,Q);if(M===n)return a;const N=function(q,x){return!!M(q,x)};return M.allBasenames&&(N.allBasenames=M.allBasenames),M.allPaths&&(N.allPaths=M.allPaths),N}return B(j,Q)}e.parse=U;function W(j){if(!j)return;let Q;return M=>(Q||(Q=(j()||Promise.resolve([])).then(N=>N?k(N):{})),Q.then(N=>!!N[M]))}e.hasSiblingPromiseFn=W;function $(j){if(!j)return;let Q;return M=>{if(!Q){const N=j();Q=N?k(N):{}}return!!Q[M]}}e.hasSiblingFn=$;function k(j){const Q={};for(const M of j)Q[M]=!0;return Q}function z(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=z;function A(j){return j.allBasenames||[]}e.getBasenameTerms=A;function F(j){return j.allPaths||[]}e.getPathTerms=F;function B(j,Q){const M=V(Object.getOwnPropertyNames(j).map(ee=>Z(ee,j[ee],Q)).filter(ee=>ee!==n)),N=M.length;if(!N)return n;if(!M.some(ee=>!!ee.requiresSiblings)){if(N===1)return M[0];const ee=function(re,oe){for(let le=0,he=M.length;le<he;le++){const be=M[le](re,oe);if(be)return be}return null},H=M.find(re=>!!re.allBasenames);H&&(ee.allBasenames=H.allBasenames);const X=M.reduce((re,oe)=>oe.allPaths?re.concat(oe.allPaths):re,[]);return X.length&&(ee.allPaths=X),ee}const q=function(ee,H,X){let re;for(let oe=0,le=M.length;oe<le;oe++){const he=M[oe];he.requiresSiblings&&X&&(H||(H=L.basename(ee)),re||(re=H.substr(0,H.length-L.extname(ee).length)));const be=he(ee,H,re,X);if(be)return be}return null},x=M.find(ee=>!!ee.allBasenames);x&&(q.allBasenames=x.allBasenames);const K=M.reduce((ee,H)=>H.allPaths?ee.concat(H.allPaths):ee,[]);return K.length&&(q.allPaths=K),q}function Z(j,Q,M){if(Q===!1)return n;const N=t(j,M);if(N===n)return n;if(typeof Q=="boolean")return N;if(Q){const q=Q.when;if(typeof q=="string"){const x=(K,ee,H,X)=>{if(!X||!N(K,ee))return null;const re=q.replace("$(basename)",H),oe=X(re);return(0,T.isThenable)(oe)?oe.then(le=>le?j:null):oe?j:null};return x.requiresSiblings=!0,x}}return N}function V(j,Q){const M=j.filter(ee=>!!ee.basenames);if(M.length<2)return j;const N=M.reduce((ee,H)=>{const X=H.basenames;return X?ee.concat(X):ee},[]);let q;if(Q){q=[];for(let ee=0,H=N.length;ee<H;ee++)q.push(Q)}else q=M.reduce((ee,H)=>{const X=H.patterns;return X?ee.concat(X):ee},[]);const x=function(ee,H){if(typeof ee!="string")return null;if(!H){let re;for(re=ee.length;re>0;re--){const oe=ee.charCodeAt(re-1);if(oe===47||oe===92)break}H=ee.substr(re)}const X=N.indexOf(H);return X!==-1?q[X]:null};x.basenames=N,x.patterns=q,x.allBasenames=N;const K=j.filter(ee=>!ee.basenames);return K.push(x),K}}),define(te[109],ne([0,1,108,16,10,18,25]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let w=[],b=[],I=[];function C(t,r=!1){const o=d(t);w.push(o),o.userConfigured?I.push(o):b.push(o),r&&!o.userConfigured&&w.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=C;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,T.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function v(t){t?(w=w.filter(r=>!r.userConfigured),I=[]):(w=[],b=[],I=[])}e.clearTextMimes=v;function h(t,r){let o;if(t)switch(t.scheme){case _.Schemas.file:o=t.fsPath;break;case _.Schemas.data:o=L.DataUri.parseMetaData(t).get(L.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[R.unknown];o=o.toLowerCase();const u=(0,D.basename)(o),g=y(o,u,I);if(g)return[g,R.text];const S=y(o,u,b);if(S)return[S,R.text];if(r){const P=p(r);if(P)return[P,R.text]}return[R.unknown]}e.guessMimeTypes=h;function y(t,r,o){let u=null,g=null,S=null;for(let P=o.length-1;P>=0;P--){const O=o[P];if(r===O.filenameLowercase){u=O;break}if(O.filepattern&&(!g||O.filepattern.length>g.filepattern.length)){const U=O.filepatternOnPath?t:r;O.filepatternLowercase?.(U)&&(g=O)}O.extension&&(!S||O.extension.length>S.extension.length)&&r.endsWith(O.extensionLowercase)&&(S=O)}return u?u.mime:g?g.mime:S?S.mime:null}function p(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let r=w.length-1;r>=0;r--){const o=w[r];if(!o.firstline)continue;const u=t.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function m(t){return t?typeof t=="string"?t===R.binary||t===R.text||t===R.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const r=(0,D.extname)(t),o=E[r.toLowerCase()];return o!==void 0?o:l(t)}e.getMediaOrTextMime=c;function l(t){const r=(0,D.extname)(t);return f[r.toLowerCase()]}e.getMediaMime=l;function s(t){for(const r in f)if(f[r]===t)return r}e.getExtensionForMimeType=s;const a=/^(.+)\/(.+?)(;.+)?$/;function n(t,r){const o=a.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:r?void 0:t}e.normalizeMimeType=n}),define(te[110],ne([0,1,7]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function _(I){return I.toJSON()}class D{constructor(C){this._uriTransformer=C}transformIncoming(C){const d=this._uriTransformer.transformIncoming(C);return d===C?C:_(T.URI.from(d))}transformOutgoing(C){const d=this._uriTransformer.transformOutgoing(C);return d===C?C:_(T.URI.from(d))}transformOutgoingURI(C){const d=this._uriTransformer.transformOutgoing(C);return d===C?C:T.URI.from(d)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,C,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return C.transformOutgoing(I);for(let v in I)if(Object.hasOwnProperty.call(I,v)){const h=L(I[v],C,d+1);h!==null&&(I[v]=h)}}return null}function i(I,C){const d=L(I,C,0);return d===null?I:d}e.transformOutgoingURIs=i;function R(I,C,d,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?T.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const y=R(I[h],C,d,v+1);y!==null&&(I[h]=y)}}return null}function w(I,C){const d=R(I,C,!1,0);return d===null?I:d}e.transformIncomingURIs=w;function b(I,C){const d=R(I,C,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=b}),define(te[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function _(w){return T.test(w)}e.isUUID=_;const D=new Uint8Array(16),L=[];for(let w=0;w<256;w++)L.push(w.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};function R(){i(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,b="";return b+=L[D[w++]],b+=L[D[w++]],b+=L[D[w++]],b+=L[D[w++]],b+="-",b+=L[D[w++]],b+=L[D[w++]],b+="-",b+=L[D[w++]],b+=L[D[w++]],b+="-",b+=L[D[w++]],b+=L[D[w++]],b+="-",b+=L[D[w++]],b+=L[D[w++]],b+=L[D[w++]],b+=L[D[w++]],b+=L[D[w++]],b+=L[D[w++]],b}e.generateUuid=R}),define(te[111],ne([0,1,243]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class _{constructor(L="utf8"){this.stringDecoder=new T.StringDecoder(L),this.remaining=null}write(L){const i=[],R=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(R.length<1)return i;let w=0,b,I=w;for(;I<R.length;)if(b=R.charCodeAt(I),b===13||b===10){if(i.push(R.substring(w,I)),I++,I<R.length){const C=b;b=R.charCodeAt(I),(C===13&&b===10||C===10&&b===13)&&I++}w=I}else I++;return this.remaining=w<R.length?R.substr(w):null,i}end(){return this.remaining}}e.LineDecoder=_}),define(te[112],ne([0,1,33]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const _=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(i){const R=i.replace(/\-/g,":").toLowerCase();return!_.has(R)}function L(){const i=(0,T.networkInterfaces)();for(let R in i){const w=i[R];if(w){for(const{mac:b}of w)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(te[113],ne([0,1,33,9,40,29,112]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const d=(0,T.networkInterfaces)();for(let v in d){const h=d[v];if(h)for(const{mac:y,internal:p}of h)p||(C+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let R;async function w(){return R||(R=(async()=>await b()||L.generateUuid())()),R}e.getMachineId=w;async function b(){try{const I=await new Promise((d,v)=>{J(["crypto"],d,v)}),C=(0,i.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){_.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,244,5,41,69,10,4,18,7,29]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(A){A[A.UNLINK=0]="UNLINK",A[A.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(A,F=v.UNLINK){if((0,i.isRootOrDriveLetter)(A))throw new Error("rimraf - will refuse to recursively delete root");return F===v.UNLINK?p(A):y(A)}async function y(A){try{const F=(0,w.join)((0,_.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(A,F)}catch(B){return p(A)}p(F).catch(B=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function p(A){return e.Promises.rmdir(A,{recursive:!0,maxRetries:3})}function m(A){if((0,i.isRootOrDriveLetter)(A))throw new Error("rimraf - will refuse to recursively delete root");T.rmdirSync(A,{recursive:!0})}e.rimrafSync=m;async function E(A,F){return l(await(F?f(A):(0,D.promisify)(T.readdir)(A)))}async function f(A){try{return await(0,D.promisify)(T.readdir)(A,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const F=[],B=await E(A);for(const Z of B){let V=!1,j=!1,Q=!1;try{const M=await e.Promises.lstat((0,w.join)(A,Z));V=M.isFile(),j=M.isDirectory(),Q=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}F.push({name:Z,isFile:()=>V,isDirectory:()=>j,isSymbolicLink:()=>Q})}return F}function c(A){return l(T.readdirSync(A))}e.readdirSync=c;function l(A){return A.map(F=>typeof F=="string"?b.isMacintosh?(0,R.normalizeNFC)(F):F:(F.name=b.isMacintosh?(0,R.normalizeNFC)(F.name):F.name,F))}async function s(A){const F=await E(A),B=[];for(const Z of F)await n.existsDirectory((0,w.join)(A,Z))&&B.push(Z);return B}function a(A,F=1e3){return new Promise(B=>{let Z=!1;const V=setInterval(()=>{Z||(Z=!0,T.access(A,j=>{Z=!1,j&&(clearInterval(V),B(void 0))}))},F)})}e.whenDeleted=a;var n;(function(A){async function F(V){let j;try{if(j=await e.Promises.lstat(V),!j.isSymbolicLink())return{stat:j}}catch(Q){}try{return{stat:await e.Promises.stat(V),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(b.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw M}throw Q}}A.stat=F;async function B(V){try{const{stat:j,symbolicLink:Q}=await A.stat(V);return j.isFile()&&Q?.dangling!==!0}catch(j){}return!1}A.existsFile=B;async function Z(V){try{const{stat:j,symbolicLink:Q}=await A.stat(V);return j.isDirectory()&&Q?.dangling!==!0}catch(j){}return!1}A.existsDirectory=Z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function r(A,F,B){return t.queueFor(C.URI.file(A),I.extUriBiasedIgnorePathCase).queue(()=>{const Z=S(B);return new Promise((V,j)=>u(A,F,Z,Q=>Q?j(Q):V()))})}let o=!0;function u(A,F,B,Z){if(!o)return T.writeFile(A,F,{mode:B.mode,flag:B.flag},Z);T.open(A,B.flag,B.mode,(V,j)=>{if(V)return Z(V);T.writeFile(j,F,Q=>{if(Q)return T.close(j,()=>Z(Q));T.fdatasync(j,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),o=!1),T.close(j,N=>Z(N))))})})}function g(A,F,B){const Z=S(B);if(!o)return T.writeFileSync(A,F,{mode:Z.mode,flag:Z.flag});const V=T.openSync(A,Z.flag,Z.mode);try{T.writeFileSync(V,F);try{T.fdatasyncSync(V)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o=!1}}finally{T.closeSync(V)}}e.writeFileSync=g;function S(A){return A?{mode:typeof A.mode=="number"?A.mode:438,flag:typeof A.flag=="string"?A.flag:"w"}:{mode:438,flag:"w"}}async function P(A,F){if(A===F)return;async function B(Z){try{const V=await e.Promises.lstat(Z);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(Z,V.atime,new Date)}catch(V){}}try{await e.Promises.rename(A,F),await B(F)}catch(Z){if(A.toLowerCase()!==F.toLowerCase()&&Z.code==="EXDEV"||A.endsWith("."))await O(A,F,{preserveSymlinks:!1}),await h(A,v.MOVE),await B(F);else throw Z}}async function O(A,F,B){return W(A,F,{root:{source:A,target:F},options:B,handledSourcePaths:new Set})}const U=511;async function W(A,F,B){if(B.handledSourcePaths.has(A))return;B.handledSourcePaths.add(A);const{stat:Z,symbolicLink:V}=await n.stat(A);if(V){if(B.options.preserveSymlinks)try{return await z(A,F,B)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(V.dangling)return}return Z.isDirectory()?$(A,F,Z.mode&U,B):k(A,F,Z.mode&U)}async function $(A,F,B,Z){await e.Promises.mkdir(F,{recursive:!0,mode:B});const V=await E(A);for(const j of V)await W((0,w.join)(A,j),(0,w.join)(F,j),Z)}async function k(A,F,B){await e.Promises.copyFile(A,F),await e.Promises.chmod(F,B)}async function z(A,F,B){let Z=await e.Promises.readlink(A);(0,i.isEqualOrParent)(Z,B.root.source,!b.isLinux)&&(Z=(0,w.join)(B.root.target,Z.substr(B.root.source.length+1))),await e.Promises.symlink(Z,F)}e.Promises=new class{get access(){return(0,D.promisify)(T.access)}get stat(){return(0,D.promisify)(T.stat)}get lstat(){return(0,D.promisify)(T.lstat)}get utimes(){return(0,D.promisify)(T.utimes)}get read(){return(0,D.promisify)(T.read)}get readFile(){return(0,D.promisify)(T.readFile)}get write(){return(0,D.promisify)(T.write)}get appendFile(){return(0,D.promisify)(T.appendFile)}get fdatasync(){return(0,D.promisify)(T.fdatasync)}get truncate(){return(0,D.promisify)(T.truncate)}get rename(){return(0,D.promisify)(T.rename)}get copyFile(){return(0,D.promisify)(T.copyFile)}get open(){return(0,D.promisify)(T.open)}get close(){return(0,D.promisify)(T.close)}get symlink(){return(0,D.promisify)(T.symlink)}get readlink(){return(0,D.promisify)(T.readlink)}get chmod(){return(0,D.promisify)(T.chmod)}get mkdir(){return(0,D.promisify)(T.mkdir)}get unlink(){return(0,D.promisify)(T.unlink)}get rmdir(){return(0,D.promisify)(T.rmdir)}get realpath(){return(0,D.promisify)(T.realpath)}async exists(A){try{return await e.Promises.access(A),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return s}get writeFile(){return r}get rm(){return h}get move(){return P}get copy(){return O}}}),define(te[114],ne([0,1,51,10,25,20]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const C=(0,_.dirname)(I);if(I===C)return I;const d=((0,_.basename)(I)||I).toLowerCase();try{const h=(0,L.readdirSync)(C).filter(y=>y.toLowerCase()===d);if(h.length===1){const y=i(C);if(y)return(0,_.join)(y,h[0])}else if(h.length>1){const y=h.indexOf(d);if(y>=0){const p=i(C);if(p)return(0,_.join)(p,h[y])}}}catch(v){}return null}e.realcaseSync=i;async function R(I){try{return await L.Promises.realpath(I)}catch(C){const d=b(I);return await L.Promises.access(d,T.constants.R_OK),d}}e.realpath=R;function w(I){try{return T.realpathSync(I)}catch(C){const d=b(I);return T.accessSync(d,T.constants.R_OK),d}}e.realpathSync=w;function b(I){return(0,D.rtrim)((0,_.normalize)(I),_.sep)}}),define(te[115],ne([0,1,57]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function _(R,w,b,I=1){let C=!1;return new Promise(d=>{const v=setTimeout(()=>{if(!C)return C=!0,d(0)},b);D(R,w,I,h=>{if(!C)return C=!0,clearTimeout(v),d(h)})})}e.findFreePort=_;function D(R,w,b,I){if(w===0)return I(0);const C=new T.Socket;C.once("connect",()=>(i(C),D(R+b,w-1,b,I))),C.once("data",()=>{}),C.once("error",d=>(i(C),d.code!=="ECONNREFUSED"?D(R+b,w-1,b,I):I(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,w,b){let I=!1,C,d=1;const v=T.createServer({pauseOnConnect:!0});function h(y,p){I||(I=!0,v.removeAllListeners(),v.close(),C&&clearTimeout(C),p(y))}return new Promise(y=>{C=setTimeout(()=>{h(0,y)},b),v.on("listening",()=>{h(R,y)}),v.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&d<w?(R++,d++,v.listen(R,"127.0.0.1")):h(0,y)}),v.on("close",()=>{h(0,y)}),v.listen(R,"127.0.0.1")})}e.findFreePortFaster=L;function i(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(w){console.error(w)}}}),define(te[70],ne([0,1,33,10,20]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,i=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,s,a){this.exePath=l,this.displayName=s,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:c=!1,findPreview:l=!1}={}){const s=d({useAlternateBitness:c});if(!s)return null;const a=_.join(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let n=-1,t=null;for(const u of await D.Promises.readdir(a)){let g=-1;if(l){const P=u.indexOf("-");if(P<0)continue;const O=u.substring(0,P);if(!L.test(O)||u.substring(P+1)!=="preview")continue;g=parseInt(O,10)}else{if(!L.test(u))continue;g=parseInt(u,10)}if(g<=n)continue;const S=_.join(a,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(S)||(t=S,n=g)}if(!t)return null;const r=s.includes("x86")?" (x86)":"",o=l?" Preview":"";return new C(t,`PowerShell${o}${r}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=_.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:s,pwshMsixName:a}=c?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(l))if(s.test(n)){const t=_.join(l,n,"pwsh.exe");return new C(t,a)}return null}function y(){const c=_.join(T.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function p(){const c=_.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}async function*m(){let c=await v();c&&(yield c),c=await v({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=y(),c&&(yield c),c=await v({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await v({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=p(),c&&(yield c)}async function*E(){for await(const c of m())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=E;async function f(){for await(const c of E())return c;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[116],ne([0,1,45,16]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(i){return new Promise((R,w)=>{let b;const I=new Map;function C(v,h,y,p,m){const E=I.get(h);if(v===i||E){const f={name:d(y),cmd:y,pid:v,ppid:h,load:p,mem:m};I.set(v,f),v===i&&(b=f),E&&(E.children||(E.children=[]),E.children.push(f),E.children.length>1&&(E.children=E.children.sort((c,l)=>c.pid-l.pid)))}}function d(v){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,E=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(E.exec(v))return"electron-crash-reporter";if(f.exec(v))return"winpty-process";if(c.exec(v))return"console-window-host (Windows internal process)";let s=l.exec(v);if(s&&s.length===2)return s[1]==="renderer"?h.exec(v)?"shared-process":y.exec(v)?"issue-reporter":p.exec(v)?"process-explorer":"window":s[1]==="utility"&&m.exec(v)?"utility-network-service":s[1];const a=/[a-zA-Z-]+\.js/g;let n="";do s=a.exec(v),s&&(n+=s+" ");while(s);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{J(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(i,y=>{h.getProcessCpuUsage(y,p=>{const m=new Map;p.forEach(E=>{const f=v(E.commandLine||"");m.set(E.pid,{name:d(f),cmd:f,pid:E.pid,ppid:E.ppid,load:E.cpu||0,mem:E.memory||0})}),b=m.get(i),b?(m.forEach(E=>{const f=m.get(E.ppid);f&&(f.children||(f.children=[]),f.children.push(E))}),m.forEach(E=>{E.children&&(E.children=E.children.sort((f,c)=>f.pid-c.pid))}),R(b)):w(new Error(`Root process ${i} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[b];const y=[];for(;h.length;){const m=h.shift();m&&(y.push(m.pid),m.children&&(h=h.concat(m.children)))}let p=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);p+=" "+y.join(" "),(0,T.exec)(p,{},(m,E,f)=>{if(m||f)w(m||new Error(f.toString()));else{const c=E.toString().split(`
`);for(let l=0;l<y.length;l++){const s=I.get(y[l]);s.load=parseFloat(c[l])}if(!b){w(new Error(`Root process ${i} not found`));return}R(b)}})};(0,T.exec)("which ps",{},(h,y,p)=>{if(h||p)if(process.platform!=="linux")w(h||new Error(p.toString()));else{const m=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,T.exec)(m,{},(E,f,c)=>{E||c?w(E||new Error(c.toString())):(L(f,C),v())})}else{const m=y.toString().trim(),E="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,T.exec)(`${m} ${E}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,l)=>{f||l&&!l.includes("screen size is bogus")?w(f||new Error(l.toString())):(L(c,C),process.platform==="linux"?v():b?R(b):w(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=D;function L(i,R){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=i.toString().split(`
`);for(const I of b){const C=w.exec(I.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(te[117],ne([0,1,51,27,41,2,69,10,4,20]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,y,p){return d({path:h,isDirectory:!1},y,p)}e.watchFile=I;function C(h,y,p){return d({path:h,isDirectory:!0},y,p)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function d(h,y,p){if(w.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return p(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const m=(0,R.basename)(h.path),E=new Map;let f=!1,c=[(0,L.toDisposable)(()=>{E.forEach(l=>(0,L.dispose)(l)),E.clear()})];try{const l=(0,T.watch)(h.path);c.push((0,L.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const s=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(a=>a.forEach(n=>s.add(n))),l.on("error",(a,n)=>{f||p(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${n})`)}),l.on("change",(a,n)=>{if(f)return;let t="";if(n&&(t=n.toString(),w.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const r=h.isDirectory?(0,R.join)(h.path,t):h.path;if(h.isDirectory)if(a==="rename"){const o=E.get(r);o&&(0,L.dispose)(o);const u=setTimeout(async()=>{E.delete(r);const g=await b.Promises.exists(r);if(f)return;let S;g?s.has(t)?S="changed":(S="added",s.add(t)):(s.delete(t),S="deleted"),y(S,r)},e.CHANGE_BUFFER_DELAY);E.set(r,(0,L.toDisposable)(()=>clearTimeout(u)))}else{let o;s.has(t)?o="changed":(o="added",s.add(t)),y(o,r)}else if(a==="rename"||t!==m){const o=setTimeout(async()=>{const u=await b.Promises.exists(r);f||(u?(y("changed",r),c=[d(h,y,p)]):y("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(c),c=[(0,L.toDisposable)(()=>clearTimeout(o))]}else y("changed",r)})}catch(l){b.Promises.exists(h.path).then(s=>{s&&!f&&p(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,L.toDisposable)(()=>{f=!0,c=(0,L.dispose)(c)})}async function v(h,y,p,m=512){const E=await b.Promises.open(h,"r"),f=Buffer.allocUnsafe(m),c=new _.CancellationTokenSource(p);let l,s=!1;const a=I(h,async n=>{if(n==="changed"){if(s)return;s=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await b.Promises.read(E,f,0,m,null);if(!t||c.token.isCancellationRequested)break;y(f.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{s=!1}}},n=>{l=new Error(n),c.dispose(!0)});return new Promise((n,t)=>{c.token.onCancellationRequested(async()=>{a.dispose(),await b.Promises.close(E),l?t(l):n()})})}e.watchFileContents=v});var de=this&&this.__decorate||function(J,e,T,_){var D=arguments.length,L=D<3?e:_===null?_=Object.getOwnPropertyDescriptor(e,T):_,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,T,_);else for(var R=J.length-1;R>=0;R--)(i=J[R])&&(L=(D<3?i(L):D>3?i(e,T,L):i(e,T))||L);return D>3&&L&&Object.defineProperty(e,T,L),L};define(te[34],ne([0,1,17,5,19,27,67,9,3,2,107,25,15]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function p(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(m||(m={}));class E{constructor(j){this.buffer=j,this.pos=0}read(j){const Q=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Q.byteLength,Q}}class f{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var c;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(c||(c={}));function l(V){const j=D.VSBuffer.alloc(4);return j.writeUInt32BE(V,0),j}function s(V){return V.read(4).readUInt32BE(0)}function a(V){const j=D.VSBuffer.alloc(1);return j.writeUInt8(V,0),j}const n={Undefined:a(c.Undefined),String:a(c.String),Buffer:a(c.Buffer),VSBuffer:a(c.VSBuffer),Array:a(c.Array),Object:a(c.Object)},t=typeof Buffer!="undefined";function r(V,j){if(typeof j=="undefined")V.write(n.Undefined);else if(typeof j=="string"){const Q=D.VSBuffer.fromString(j);V.write(n.String),V.write(l(Q.byteLength)),V.write(Q)}else if(t&&Buffer.isBuffer(j)){const Q=D.VSBuffer.wrap(j);V.write(n.Buffer),V.write(l(Q.byteLength)),V.write(Q)}else if(j instanceof D.VSBuffer)V.write(n.VSBuffer),V.write(l(j.byteLength)),V.write(j);else if(Array.isArray(j)){V.write(n.Array),V.write(l(j.length));for(const Q of j)r(V,Q)}else{const Q=D.VSBuffer.fromString(JSON.stringify(j));V.write(n.Object),V.write(l(Q.byteLength)),V.write(Q)}}function o(V){switch(V.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return V.read(s(V)).toString();case c.Buffer:return V.read(s(V)).buffer;case c.VSBuffer:return V.read(s(V));case c.Array:{const Q=s(V),M=[];for(let N=0;N<Q;N++)M.push(o(V));return M}case c.Object:return JSON.parse(V.read(s(V)).toString())}}class u{constructor(j,Q,M=null,N=1e3){this.protocol=j,this.ctx=Q,this.logger=M,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(q=>this.onRawMessage(q)),this.sendResponse({type:200})}registerChannel(j,Q){this.channels.set(j,Q),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Q=this.send([j.type]);this.logger&&this.logger.logOutgoing(Q,0,1,p(j.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(Q,j.id,1,p(j.type),j.data);return}}}send(j,Q=void 0){const M=new f;return r(M,j),r(M,Q),this.sendBuffer(M.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Q){return 0}}onRawMessage(j){const Q=new E(j),M=o(Q),N=o(Q),q=M[0];switch(q){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,M[1],1,`${h(q)}: ${M[2]}.${M[3]}`,N),this.onPromise({type:q,id:M[1],channelName:M[2],name:M[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,M[1],1,`${h(q)}: ${M[2]}.${M[3]}`,N),this.onEventListen({type:q,id:M[1],channelName:M[2],name:M[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,M[1],1,`${h(q)}`),this.disposeActiveRequest({type:q,id:M[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,M[1],1,`${h(q)}`),this.disposeActiveRequest({type:q,id:M[1]})}}onPromise(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const M=new L.CancellationTokenSource;let N;try{N=Q.call(this.ctx,j.name,j.arg,M.token)}catch(K){N=Promise.reject(K)}const q=j.id;N.then(K=>{this.sendResponse({id:q,data:K,type:201}),this.activeRequests.delete(j.id)},K=>{K instanceof Error?this.sendResponse({id:q,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:q,data:K,type:203}),this.activeRequests.delete(j.id)});const x=(0,b.toDisposable)(()=>M.cancel());this.activeRequests.set(j.id,x)}onEventListen(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const M=j.id,q=Q.listen(this.ctx,j.name,j.arg)(x=>this.sendResponse({id:M,data:x,type:204}));this.activeRequests.set(j.id,q)}disposeActiveRequest(j){const Q=this.activeRequests.get(j.id);Q&&(Q.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Q=this.pendingRequests.get(j.channelName);Q||(Q=[],this.pendingRequests.set(j.channelName,Q));const M=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:j,timeoutTimer:M})}flushPendingRequests(j){const Q=this.pendingRequests.get(j);if(Q){for(const M of Q)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(j,Q=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=Q}getChannel(j){const Q=this;return{call(M,N,q){return Q.isDisposed?Promise.reject(R.canceled()):Q.requestPromise(j,M,N,q)},listen(M,N){return Q.isDisposed?Promise.reject(R.canceled()):Q.requestEvent(j,M,N)}}}requestPromise(j,Q,M,N=L.CancellationToken.None){const q=this.lastRequestId++,K={id:q,type:100,channelName:j,name:Q,arg:M};if(N.isCancellationRequested)return Promise.reject(R.canceled());let ee;return new Promise((X,re)=>{if(N.isCancellationRequested)return re(R.canceled());const oe=()=>{const Ce=we=>{switch(we.type){case 201:this.handlers.delete(q),X(we.data);break;case 202:this.handlers.delete(q);const ve=new Error(we.data.message);ve.stack=we.data.stack,ve.name=we.data.name,re(ve);break;case 203:this.handlers.delete(q),re(we.data);break}};this.handlers.set(q,Ce),this.sendRequest(K)};let le=null;this.state===m.Idle?oe():(le=(0,_.createCancelablePromise)(Ce=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const he=()=>{le?(le.cancel(),le=null):this.sendRequest({id:q,type:101}),re(R.canceled())},be=N.onCancellationRequested(he);ee=(0,b.combinedDisposable)((0,b.toDisposable)(he),be),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(j,Q,M){const N=this.lastRequestId++,x={id:N,type:102,channelName:j,name:Q,arg:M};let K=null;const ee=new w.Emitter({onFirstListenerAdd:()=>{K=(0,_.createCancelablePromise)(X=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(ee),this.sendRequest(x)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(ee),this.sendRequest({id:N,type:103}))}}),H=X=>ee.fire(X.data);return this.handlers.set(N,H),ee.event}sendRequest(j){switch(j.type){case 100:case 102:{const Q=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Q,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Q=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Q,j.id,0,h(j.type));return}}}send(j,Q=void 0){const M=new f;return r(M,j),r(M,Q),this.sendBuffer(M.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Q){return 0}}onBuffer(j){const Q=new E(j),M=o(Q),N=o(Q),q=M[0];switch(q){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,p(q)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,M[1],0,p(q),N),this.onResponse({type:M[0],id:M[1],data:N})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(j.id);Q&&Q(j)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([i.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class P{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Q,onDidClientDisconnect:M})=>{w.Event.once(Q.onMessage)(q=>{const x=new E(q),K=o(x),ee=new u(Q,K),H=new S(Q);this.channels.forEach((re,oe)=>ee.registerChannel(oe,re));const X={channelServer:ee,channelClient:H,ctx:K};this._connections.add(X),this._onDidAddConnection.fire(X),M(()=>{ee.dispose(),H.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const j=[];return this._connections.forEach(Q=>j.push(Q)),j}getChannel(j,Q){const M=this;return{call(N,q,x){let K;if((0,d.isFunction)(Q)){let H=(0,T.getRandomElement)(M.connections.filter(Q));K=H?Promise.resolve(H):w.Event.toPromise(w.Event.filter(M.onDidAddConnection,Q))}else K=Q.routeCall(M,N,q);const ee=K.then(H=>H.channelClient.getChannel(j));return U(ee).call(N,q,x)},listen(N,q){if((0,d.isFunction)(Q))return M.getMulticastEvent(j,Q,N,q);const x=Q.routeEvent(M,N,q).then(K=>K.channelClient.getChannel(j));return U(x).listen(N,q)}}}getMulticastEvent(j,Q,M,N){const q=this;let x=new b.DisposableStore;const K=new w.Emitter({onFirstListenerAdd:()=>{x=new b.DisposableStore;const ee=new w.EventMultiplexer,H=new Map,X=oe=>{const he=oe.channelClient.getChannel(j).listen(M,N),be=ee.add(he);H.set(oe,be)},re=oe=>{const le=H.get(oe);!le||(le.dispose(),H.delete(oe))};q.connections.filter(Q).forEach(X),w.Event.filter(q.onDidAddConnection,Q)(X,void 0,x),q.onDidRemoveConnection(re,void 0,x),ee.event(K.fire,K,x),x.add(ee)},onLastListenerRemove:()=>{x.dispose()}});return K.event}registerChannel(j,Q){this.channels.set(j,Q),this._connections.forEach(M=>{M.channelServer.registerChannel(j,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class O{constructor(j,Q,M=null){const N=new f;r(N,Q),j.send(N.buffer),this.channelClient=new S(j,M),this.channelServer=new u(j,Q,M)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Q){this.channelServer.registerChannel(j,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U(V){return{call(j,Q,M){return V.then(N=>N.call(j,Q,M))},listen(j,Q){const M=new w.Relay;return V.then(N=>M.input=N.listen(j,Q)),M.event}}}e.getDelayedChannel=U;function W(V){let j=!1;return{call(Q,M,N){return j?V.call(Q,M,N):(0,_.timeout)(0).then(()=>j=!0).then(()=>V.call(Q,M,N))},listen(Q,M){if(j)return V.listen(Q,M);const N=new w.Relay;return(0,_.timeout)(0).then(()=>j=!0).then(()=>N.input=V.listen(Q,M)),N.event}}}e.getNextTickChannel=W;class ${constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Q of j.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await w.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=$;var k;(function(V){function j(q,x){const K=q,ee=x&&x.disableMarshalling,H=new Map;for(const X in K)M(X)&&H.set(X,w.Event.buffer(K[X],!0));return new class{listen(X,re,oe){const le=H.get(re);if(le)return le;if(N(re)){const he=K[re];if(typeof he=="function")return he.call(K,oe)}throw new Error(`Event not found: ${re}`)}call(X,re,oe){const le=K[re];if(typeof le=="function"){if(!ee&&Array.isArray(oe))for(let he=0;he<oe.length;he++)oe[he]=(0,I.revive)(oe[he]);return le.apply(K,oe)}throw new Error(`Method not found: ${re}`)}}}V.fromService=j;function Q(q,x){const K=x&&x.disableMarshalling;return new Proxy({},{get(ee,H){if(typeof H=="string")return x?.properties?.has(H)?x.properties.get(H):N(H)?function(X){return q.listen(H,X)}:M(H)?q.listen(H):async function(...X){let re;x&&!(0,d.isUndefinedOrNull)(x.context)?re=[x.context,...X]:re=X;const oe=await q.call(H,re);return K?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(H)}`)}})}V.toService=Q;function M(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}function N(q){return/^onDynamic/.test(q)&&C.isUpperAsciiLetter(q.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function A(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let j=V.toString();if(j!=="[object Object]")return j}return V}function F(V){return Array.isArray(V)?V.map(A):A(V)}function B(V,j,Q,M,N,q,x){x=F(x);const K=z[N],ee=K[M%K.length];let H=[`%c[${V}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(q)?(H=H.concat(x),H.push(")")):H.push(x),console.log.apply(console,H)}e.logWithColors=B;class Z{constructor(j,Q){this._outgoingPrefix=j,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Q,M,N,q){this._totalOutgoing+=j,B(this._outgoingPrefix,this._totalOutgoing,j,Q,M,N,q)}logIncoming(j,Q,M,N,q){this._totalIncoming+=j,B(this._incomingPrefix,this._totalIncoming,j,Q,M,N,q)}}e.IPCLogger=Z}),define(te[118],ne([0,1,19,3,34]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(w){this.port=w,this.onMessage=_.Event.fromDOMEventEmitter(this.port,"message",b=>T.VSBuffer.wrap(b.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class i extends D.IPCClient{constructor(w,b){const I=new L(w);super(I,b);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[71],ne([0,1,19,3,2,34]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var i;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(i=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let o=0;function u(S,P){if(!r.has(S)){const O=String(++o);r.set(S,O)}return r.get(S)}function g(S,P,O,U){if(!t.enableDiagnostics)return;const W=u(S,P);if(U instanceof T.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const $=T.VSBuffer.alloc(U.byteLength);$.set(U),t.records.push({timestamp:Date.now(),id:W,label:P,type:O,buff:$})}else t.records.push({timestamp:Date.now(),id:W,label:P,type:O,data:U})}t.traceSocketEvent=g})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function I(){return b||(b=T.VSBuffer.alloc(0)),b}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return I();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const P=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),P}if(this._chunks[0].byteLength>r){const P=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),P}let u=T.VSBuffer.alloc(r),g=0,S=0;for(;r>0;){const P=this._chunks[S];if(P.byteLength>r){const O=P.slice(0,r);u.set(O,g),g+=r,o&&(this._chunks[S]=P.slice(r),this._totalLength-=r),r-=r}else u.set(P,g),g+=P.byteLength,o?(this._chunks.shift(),this._totalLength-=P.byteLength):S++,r-=P.byteLength}return u}}e.ChunkStream=C;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(d||(d={}));function v(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(r,o,u,g){this.type=r,this.id=o,this.ack=u,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends D.Disposable{constructor(r){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,g=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new y(u,g,S,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=T.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const u=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,u}_bufferTake(){const r=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class E extends D.Disposable{constructor(r){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new y(1,0,0,r))}}e.Protocol=E;class f extends L.IPCClient{constructor(r,o,u=null){super(r,o,u);this.protocol=r}static fromSocket(r,o){return new f(new E(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=f;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class l{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,u=this._first;for(;u;)r[o++]=u.data,u=u.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new l(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const r=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let u=0;for(let g=0;g<a._HISTORY_LENGTH;g++)r-this.lastRuns[g]<=o&&u++;return 1-u/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(r,o=null,u=a.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new y(5,0,0,I());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new y(7,0,0,I());this._socketWriter.write(r)}sendResume(){const r=new y(8,0,0,I());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let o=0,u=r.length;o<u;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new y(6,0,0,I())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let u=0,g=o.length;u<g;u++)this._socketWriter.write(o[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new y(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(r){const o=new y(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,u=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,500))}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new y(3,0,this._incomingAckId,I());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(te[119],ne([0,1,72,3,34,118]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends D.IPCServer{static getOnDidClientConnect(){const w=_.Event.fromNodeEventEmitter(T.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return _.Event.map(w,b=>{const{port1:I,port2:C}=new MessageChannel,v={protocol:new L.Protocol(I),onDidClientDisconnect:_.Event.fromDOMEventEmitter(I,"close")};return T.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),v})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[120],ne([0,1,19,9]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(R,w){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((I,C)=>{b.open(R.type||"GET",R.url||"",!0,R.user,R.password),L(b,R),b.responseType="arraybuffer",b.onerror=d=>C(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=d=>{I({res:{statusCode:b.status,headers:i(b)},stream:(0,T.bufferToStream)(T.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=d=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(b.timeout=R.timeout),b.send(R.data),w.onCancellationRequested(()=>{b.abort(),C((0,_.canceled)())})})}e.request=D;function L(R,w){if(w.headers){e:for(let b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(b,w.headers[b])}}}function i(R){const w=Object.create(null);for(const b of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const I=b.indexOf(":");w[b.substr(0,I).trim().toLowerCase()]=b.substr(I+1).trim()}return w}}),define(te[73],ne([0,1,5,3,2,15]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function R(C){const d=C;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var w;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(w||(w={}));class b extends D.Disposable{constructor(d,v=Object.create(null)){super();this.database=d,this.options=v,this._onDidChangeStorage=this._register(new _.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((v,h)=>this.accept(h,v)),d.deleted?.forEach(v=>this.accept(v,void 0))}accept(d,v){if(this.state===w.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(d):this.cache.get(d)!==v&&(this.cache.set(d,v),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,v){const h=this.cache.get(d);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(d,v){const h=this.get(d);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(d,v){const h=this.get(d);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(d,v){if(this.state===w.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(d);const h=String(v);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===w.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=_.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((v,h)=>this.items.set(h,v)),d.delete&&d.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[121],ne([12,13]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[58],ne([0,1,121]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const _=60,D=_*60,L=D*24,i=L*7,R=L*30,w=L*365;function b(C,d){typeof C!="number"&&(C=C.getTime());const v=Math.round((new Date().getTime()-C)/1e3);if(v<-30)return(0,T.localize)(0,null,b(new Date().getTime()+v*1e3,!1));if(v<30)return(0,T.localize)(1,null);let h;return v<_?(h=v,d?h===1?(0,T.localize)(2,null,h):(0,T.localize)(3,null,h):h===1?(0,T.localize)(4,null,h):(0,T.localize)(5,null,h)):v<D?(h=Math.floor(v/_),d?h===1?(0,T.localize)(6,null,h):(0,T.localize)(7,null,h):h===1?(0,T.localize)(8,null,h):(0,T.localize)(9,null,h)):v<L?(h=Math.floor(v/D),d?h===1?(0,T.localize)(10,null,h):(0,T.localize)(11,null,h):h===1?(0,T.localize)(12,null,h):(0,T.localize)(13,null,h)):v<i?(h=Math.floor(v/L),d?h===1?(0,T.localize)(14,null,h):(0,T.localize)(15,null,h):h===1?(0,T.localize)(16,null,h):(0,T.localize)(17,null,h)):v<R?(h=Math.floor(v/i),d?h===1?(0,T.localize)(18,null,h):(0,T.localize)(19,null,h):h===1?(0,T.localize)(20,null,h):(0,T.localize)(21,null,h)):v<w?(h=Math.floor(v/R),d?h===1?(0,T.localize)(22,null,h):(0,T.localize)(23,null,h):h===1?(0,T.localize)(24,null,h):(0,T.localize)(25,null,h)):(h=Math.floor(v/w),d?h===1?(0,T.localize)(26,null,h):(0,T.localize)(27,null,h):h===1?(0,T.localize)(28,null,h):(0,T.localize)(29,null,h))}e.fromNow=b;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[122],ne([12,13]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,15,122]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(b,I){return I&&(b.stack||b.stacktrace)?D.localize(0,null,R(b),i(b.stack)||i(b.stacktrace)):R(b)}function i(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function w(b=null,I=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const C=T.coalesce(b),d=w(C[0],I);return C.length>1?D.localize(4,null,d,C.length):d}if(_.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return L(C.error,I);if(C.exception)return L(C.exception,I)}return b.stack?L(b,I):b.message?b.message:D.localize(5,null)}e.toErrorMessage=w}),define(te[123],ne([12,13]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,45,41,16,28,10,4,32,102,15,111,20,123]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(s,a){if(R.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};a&&(n.cwd=a);const t=T.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(r=>{t.once("error",o=>{r({success:!1,error:o})}),t.once("exit",(o,u)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(R.isLinux||R.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{T.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,u)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function p(s){!s||(delete s.DEBUG,R.isMacintosh&&delete s.DYLD_LIBRARY_PATH,R.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=p;function m(s=w.env){return s.comspec||"cmd.exe"}e.getWindowsShell=m;class E{constructor(a,n,t,r){if(n!==void 0&&t!==void 0&&r!==void 0)this.cmd=a,this.args=n,this.shell=t,this.options=r;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(w.env).forEach(u=>{o[u]=w.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const n=a.lastIndexOf(i.sep);return n!==-1&&(a=a.substring(n+1)),E.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&_.isUNC(this.options.cwd)||!this.options&&_.isUNC(w.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(n=>{let t,r;const o=new Promise((u,g)=>{t=u,r=g});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=T.exec(u,this.options,(g,S,P)=>{this.childProcess=null;const O=g;O&&O.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:P.toString()}):this.handleExec(t,a,g,S,P)})}else{let u=null;const g=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,t,a,r);const P={terminated:this.terminateRequested};I.isNumber(S)&&(P.cmdCode=S),t(P)};if(this.shell&&R.isWindows){const S=L.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let P=!1,O=!1;const U=[];let W=this.ensureQuotes(this.cmd);U.push(W.value),P=W.quoted,this.args&&this.args.forEach(k=>{W=this.ensureQuotes(k),U.push(W.value),O=O&&W.quoted});const $=["/s","/c"];P?O?$.push('"'+U.join(" ")+'"'):U.length>1?$.push('"'+U[0]+'" '+U.slice(1).join(" ")):$.push('"'+U[0]+'"'):$.push(U.join(" ")),u=T.spawn(m(),$,S)}else this.cmd&&(u=T.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(I.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),u.pid&&(this.childProcess.on("close",g),this.handleSpawn(u,t,a,r,!0)))}return o})}handleClose(a,n,t,r){}ensureQuotes(a){return E.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,y(a,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const n=T.spawn(m(),["/s","/c"]);n.on("error",t=>a(!0)),n.on("exit",t=>a(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class f extends E{constructor(a,n,t,r){super(a,n,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,n,t,r,o){[r,o].forEach((u,g)=>{const S=new C.LineDecoder;S.write(u).forEach(U=>{n({line:U,source:g===0?0:1})});const O=S.end();O&&n({line:O,source:g===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,n,t,r,o){const u=new C.LineDecoder,g=new C.LineDecoder;a.stdout.on("data",S=>{u.write(S).forEach(O=>t({line:O,source:0}))}),a.stderr.on("data",S=>{g.write(S).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=g}handleClose(a,n,t,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=f;function c(s){let a=[],n=!1;const t=function(r){if(n){a.push(r);return}(!s.send(r,u=>{if(u&&console.error(u),n=!1,a.length>0){const g=a.slice(0);a=[],g.forEach(S=>t(S))}})||R.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(s){async function a(n,t,r){if(i.isAbsolute(n))return n;if(t===void 0&&(t=w.cwd()),i.dirname(n)!=="."||(r===void 0&&I.isString(w.env.PATH)&&(r=w.env.PATH.split(i.delimiter)),r===void 0||r.length===0))return i.join(t,n);async function u(g){if(await d.Promises.exists(g)){let S;try{S=await d.Promises.stat(g)}catch(P){P.message.startsWith("EACCES")&&(S=await d.Promises.lstat(g))}return S?!S.isDirectory():!1}return!1}for(let g of r){let S;if(i.isAbsolute(g)?S=i.join(g,n):S=i.join(t,g,n),await u(S))return S;let P=S+".com";if(await u(P)||(P=S+".exe",await u(P)))return P}return i.join(t,n)}s.findExecutable=a})(l=e.win32||(e.win32={}))}),define(te[124],ne([0,1,33,4,70,74]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(v,h){return v===1?_.isWindows?C():L.getWindowsShell(h):b(v,h)}e.getSystemShell=i;function R(v,h){return v===1?_.isWindows?d(h):L.getWindowsShell(h):b(v,h)}e.getSystemShellSync=R;let w=null;function b(v,h){if(_.isLinux&&v===2||_.isMacintosh&&v===3)return"/bin/bash";if(!w){let y;if(_.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,T.userInfo)().shell}catch(p){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}w=y}return w}let I=null;async function C(){return I||(I=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(v){if(I)return I;const h=_.isWindows&&parseFloat((0,T.release)())>=10,y=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${v.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?p:L.getWindowsShell(v)}}),define(te[52],ne([0,1,45,5,19,27,106,9,3,2,28,74,34]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends d.ChannelServer{constructor(p){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(E){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=v;class h{constructor(p,m){this.modulePath=p,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new _.Delayer(E),this.child=null,this._client=null}getChannel(p){const m=this;return{call(E,f,c){return m.requestPromise(p,E,f,c)},listen(E,f){return m.requestEvent(p,E,f)}}}requestPromise(p,m,E,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),l=(0,_.createCancelablePromise)(n=>c.call(m,E,n)),s=f.onCancellationRequested(()=>l.cancel()),a=(0,b.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{s.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(p,m,E){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let f;const c=new w.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(m,E)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,T.fork)(this.modulePath,p,m);const E=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}E.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),s=E.event,a={send:l,onMessage:s};this._client=new d.ChannelClient(a);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(p){let m=this.channels.get(p);return m||(m=this.client.getChannel(p),this.channels.set(p,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([12,13]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[130],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[131],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[132],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[133],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[134],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[135],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[136],ne([12,13]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[137],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[138],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[139],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[140],ne([12,13]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[141],ne([12,13]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[142],ne([12,13]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[143],ne([12,13]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[144],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var _;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(_=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class L{constructor(R,w,b,I){this.version=R,this.appName=w,this.machineId=b,this.targetPopulation=I}getFilterValue(R){switch(R){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return T.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,w=Object.values(D);for(let b of w)R.set(b,this.getFilterValue(b));return R}}e.AssignmentFilterProvider=L}),define(te[75],ne([0,1,58,67,16,10,32,18,7]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(y,p,m){this._args=y,this.paths=p,this.productService=m}get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(w.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=i.env.VSCODE_PORTABLE;return y?w.URI.file((0,L.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,L.resolve)(y):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,L.resolve)(y):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,L.resolve)(y);const p=i.env.VSCODE_EXTENSIONS;if(p)return p;const m=i.env.VSCODE_PORTABLE;return m?(0,L.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,L.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?w.URI.parse(y):w.URI.file((0,L.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([_.memoize],b.prototype,"appRoot",null),de([_.memoize],b.prototype,"userHome",null),de([_.memoize],b.prototype,"userDataPath",null),de([_.memoize],b.prototype,"appSettingsHome",null),de([_.memoize],b.prototype,"tmpDir",null),de([_.memoize],b.prototype,"cacheHome",null),de([_.memoize],b.prototype,"userRoamingDataHome",null),de([_.memoize],b.prototype,"settingsResource",null),de([_.memoize],b.prototype,"userDataSyncHome",null),de([_.memoize],b.prototype,"userDataSyncLogResource",null),de([_.memoize],b.prototype,"sync",null),de([_.memoize],b.prototype,"machineSettingsResource",null),de([_.memoize],b.prototype,"globalStorageHome",null),de([_.memoize],b.prototype,"workspaceStorageHome",null),de([_.memoize],b.prototype,"keybindingsResource",null),de([_.memoize],b.prototype,"keyboardLayoutResource",null),de([_.memoize],b.prototype,"argvResource",null),de([_.memoize],b.prototype,"snippetsHome",null),de([_.memoize],b.prototype,"isExtensionDevelopment",null),de([_.memoize],b.prototype,"untitledWorkspacesHome",null),de([_.memoize],b.prototype,"installSourcePath",null),de([_.memoize],b.prototype,"builtinExtensionsPath",null),de([_.memoize],b.prototype,"extensionsPath",null),de([_.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([_.memoize],b.prototype,"extensionDevelopmentKind",null),de([_.memoize],b.prototype,"extensionTestsLocationURI",null),de([_.memoize],b.prototype,"debugExtensionHost",null),de([_.memoize],b.prototype,"serviceMachineIdResource",null),de([_.memoize],b.prototype,"telemetryLogResource",null),de([_.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function I(h,y){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function C(h,y){return v(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=C;function d(h,y){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=d;function v(h,y,p,m,E,f){const l=Number(y||h)||(m?null:p),s=l?Boolean(!!y):!1;let a;if(f)try{a=JSON.parse(f)}catch{}return{port:l,break:s,debugId:E,env:a}}}),define(te[151],ne([0,1,245,4,127]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,y,p=i){const m={},E=[],f=[];for(let a in y){const n=y[a];n.alias&&(m[a]=n.alias),n.type==="string"||n.type==="string[]"?(E.push(a),n.deprecates&&E.push(n.deprecates)):n.type==="boolean"&&(f.push(a),n.deprecates&&f.push(n.deprecates))}const c=T(h,{string:E,boolean:f,alias:m}),l={},s=c;l._=c._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(let a in y){const n=y[a];n.alias&&delete s[n.alias];let t=s[a];n.deprecates&&s.hasOwnProperty(n.deprecates)&&(t||(t=s[n.deprecates],p.onDeprecatedOption(n.deprecates,a)),delete s[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),p.onMultipleValues(a,t)),l[a]=t),delete s[a]}for(let a in s)p.onUnknownOption(a);return l}e.parseArgs=R;function w(h,y){let p="";return y.args&&(Array.isArray(y.args)?p=` <${y.args.join("> <")}>`:p=` <${y.args}>`),y.alias?`-${y.alias} --${h}${p}`:`--${h}${p}`}function b(h,y){let p=0,m=[];for(const l in h){const s=h[l],a=w(l,s);p=Math.max(p,a.length),m.push([a,s.description])}let E=p+2+1;if(y-E<25)return m.reduce((l,s)=>l.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let f=y-E-1,c=[];for(const l of m){let s=l[0],a=C(l[1],f),n=I(E-s.length-2);c.push("  "+s+n+a[0]);for(let t=1;t<a.length;t++)c.push(I(E)+a[t])}return c}e.formatOptions=b;function I(h){return" ".repeat(h)}function C(h,y){let p=[];for(;h.length;){let m=h.length<y?h.length:h.lastIndexOf(" ",y),E=h.slice(0,m).trim();h=h.slice(m),p.push(E)}return p}function d(h,y,p,m,E){const f=process.stdout.isTTY&&process.stdout.columns||80,c=E?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${h} ${p}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${y} [${(0,D.localize)(35,null)}]${c}`),l.push(""),E?.noPipe!==!0&&(_.isWindows?l.push((0,D.localize)(36,null,y)):l.push((0,D.localize)(37,null,y)),l.push(""));const s={};for(const a in m){const n=m[a];if(n.description&&n.cat){let t=s[n.cat];t||(s[n.cat]=t={}),t[a]=n}}for(let a in s){const n=a;let t=s[n];t&&(l.push(L[n]),l.push(...b(t,f)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function v(h,y){return`${h||(0,D.localize)(38,null)}
${y||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=v}),function(){"use strict";function J(e,T,_,D){function L(R){const w=i(R),b=[w];return e.isAbsolute(w)||b.unshift(D),e.resolve(...b)}function i(R){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,_);const I=R["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(T.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,_)}return{getUserDataPath:L}}if(typeof define=="function")define(te[152],ne([0,153,33,16,18,32]),function(e,T,_,D,L,i){const R=L.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(L.joinPath(R,"package.json").fsPath);return J(T,_,w.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),T=require("path"),_=require("os");module.exports=J(T,_,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,33,75,152]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends _.AbstractNativeEnvironmentService{constructor(R,w){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R)},w)}}e.NativeEnvironmentService=L}),define(te[155],ne([0,1,7]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const _=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(p){const m=p.match(i);return m?m[1]:null}function I(p){if(p.indexOf("://")===-1){const m=p.match(_);return m?b(m[2]):null}try{const m=T.URI.parse(p);if(m.authority)return b(m.authority)}catch(m){}return null}function C(p,m){const E=new Set;let f;for(;f=R.exec(p);){const l=I(f[1]);l&&E.add(l)}const c=new Set(m);return Array.from(E).map(l=>c.has(l)?l:l.replace(w,"a"))}e.getDomainsOfRemotes=C;function d(p){const m=p.match(L);return m?m[2]:null}function v(p,m,E){return p&&m?(E&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${p}${m}`:`${p}/${m}`):null}function h(p,m){if(p.indexOf("://")===-1){const E=p.match(D);if(E)return v(E[2],E[3],m)}try{const E=T.URI.parse(p);if(E.authority)return v(d(E.authority),E.path,m)}catch(E){}return null}function y(p,m=!1){const E=[];let f;for(;f=R.exec(p);){const c=h(f[1],m);c&&E.push(c)}return E}e.getRemotes=y}),define(te[156],ne([0,1,28]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const _=/^%([\w\d.-]+)%$/i;function D(L,i){const R=w=>{if(typeof w!="string")return;const b=_.exec(w);if(!b)return;const I=i[b[1]]??w;return typeof I=="string"?I:typeof I.message=="string"?I.message:w};return(0,T.cloneAndChange)(L,R)}e.localizeManifest=D}),define(te[157],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class T{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,i,R,w){return this.channel.call("promptImportantExtensionsInstallNotification",[L,i,R,w])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=T;class _{constructor(L){this.service=L}listen(L,i){throw new Error(`Event not found: ${i}`)}call(L,i,R){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=_}),define(te[76],ne([0,1,136]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function L(d){return d=d.trim(),d==="*"||_.test(d)}e.isValidVersionStr=L;function i(d){if(!L(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=d.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=i;function R(d){if(!d)return null;let v=d.majorBase,h=d.majorMustEqual,y=d.minorBase,p=d.minorMustEqual,m=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(v===0||(p=!1),E=!1);let f=0;if(d.preRelease){const c=D.exec(d.preRelease);if(c){const[,l,s,a]=c;f=Date.UTC(Number(l),Number(s)-1,Number(a))}}return{majorBase:v,majorMustEqual:h,minorBase:y,minorMustEqual:p,patchBase:m,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:f}}e.normalizeVersion=R;function w(d,v,h){let y;typeof d=="string"?y=R(i(d)):y=d;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let m;if(typeof h=="string"?m=R(i(h)):m=h,!y||!m)return!1;let E=y.majorBase,f=y.minorBase,c=y.patchBase,l=m.majorBase,s=m.minorBase,a=m.patchBase,n=m.notBefore,t=m.majorMustEqual,r=m.minorMustEqual,o=m.patchMustEqual;return m.isMinimum?E>l?!0:E<l?!1:f>s?!0:f<s||p&&p<n?!1:c>=a:(E===1&&l===0&&(!t||!r||!o)&&(l=1,s=0,a=0,t=!0,r=!1,o=!1),E<l?!1:E>l?!t:f<s?!1:f>s?!r:c<a?!1:c>a?!o:!(p&&p<n))}e.isValidVersion=w;function b(d,v,h,y){return h.isBuiltin||typeof h.main=="undefined"?!0:C(d,v,h.engines.vscode,y)}e.isValidExtensionVersion=b;function I(d,v,h){return d==="*"||C(v,h,d)}e.isEngineValid=I;function C(d,v,h,y=[]){let p=R(i(h));if(!p)return y.push(T.localize(0,null,h)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return y.push(T.localize(1,null,h)),!1}else if(!p.majorMustEqual)return y.push(T.localize(2,null,h)),!1;return w(d,v,p)?!0:(y.push(T.localize(3,null,d,h)),!1)}}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(D,L=[],i=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=T}),define(te[77],ne([0,1,53]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const _=[];function D(i,R,w){R instanceof T.SyncDescriptor||(R=new T.SyncDescriptor(R,[],w)),_.push([i,R])}e.registerSingleton=D;function L(){return _}e.getSingletonServiceDescriptors=L}),define(te[158],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=T;class _{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let i of this._nodes.values())i.outgoing.size===0&&L.push(i);return L}insertEdge(L,i){const R=this.lookupOrInsertNode(L),w=this.lookupOrInsertNode(i);R.outgoing.set(this._hashFn(i),w),w.incoming.set(this._hashFn(L),R)}removeNode(L){const i=this._hashFn(L);this._nodes.delete(i);for(let R of this._nodes.values())R.outgoing.delete(i),R.incoming.delete(i)}lookupOrInsertNode(L){const i=this._hashFn(L);let R=this._nodes.get(i);return R||(R=new T(L),this._nodes.set(i,R)),R}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[i,R]of this._nodes)L.push(`${i}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,i]of this._nodes){const R=new Set([L]),w=this._findCycle(i,R);if(w)return w}}_findCycle(L,i){for(let[R,w]of L.outgoing){if(i.has(R))return[...i,R].join(" -> ");i.add(R);const b=this._findCycle(w,i);if(b)return b;i.delete(R)}}}e.Graph=_}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var T;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function R(w){return w[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=R})(T=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function _(i,R,w,b){R[T.DI_TARGET]===R?R[T.DI_DEPENDENCIES].push({id:i,index:w,optional:b}):(R[T.DI_DEPENDENCIES]=[{id:i,index:w,optional:b}],R[T.DI_TARGET]=R)}function D(i){if(T.serviceIds.has(i))return T.serviceIds.get(i);const R=function(w,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");_(R,w,I,!1)};return R.toString=()=>i,T.serviceIds.set(i,R),R}e.createDecorator=D;function L(i){return i}e.refineServiceDecorator=L}),define(te[159],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,T.createDecorator)("checksumService")}),define(te[21],ne([0,1,15,7,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof _.URI)}e.isConfigurationOverrides=L;function i(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||T.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof _.URI)}e.isConfigurationUpdateOverrides=i;var R;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=w;function b(p,m){const E=Object.create(null);for(let f in p)I(E,f,p[f],m);return E}e.toValuesTree=b;function I(p,m,E,f){const c=m.split("."),l=c.pop();let s=p;for(let a=0;a<c.length;a++){let n=c[a],t=s[n];switch(typeof t){case"undefined":t=s[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${m} as ${c.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}s=t}if(typeof s=="object"&&s!==null)try{s[l]=E}catch(a){f(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=I;function C(p,m){const E=m.split(".");d(p,E)}e.removeFromValueTree=C;function d(p,m){const E=m.shift();if(m.length===0){delete p[E];return}if(Object.keys(p).indexOf(E)!==-1){const f=p[E];typeof f=="object"&&!Array.isArray(f)&&(d(f,m),Object.keys(f).length===0&&delete p[E])}}function v(p,m,E){function f(s,a){let n=s;for(const t of a){if(typeof n!="object"||n===null)return;n=n[t]}return n}const c=m.split("."),l=f(p,c);return typeof l=="undefined"?E:l}e.getConfigurationValue=v;function h(p,m,E){Object.keys(m).forEach(f=>{f!=="__proto__"&&(f in p?T.isObject(p[f])&&T.isObject(m[f])?h(p[f],m[f],E):E&&(p[f]=m[f]):p[f]=m[f])})}e.merge=h;function y(p,m,E){const f=p.inspect(m),c=p.inspect(E);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:f.defaultValue}e.getMigratedSettingValue=y}),define(te[160],ne([0,1,4,25,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=T.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",T.isMacintosh),i.set("isLinux",T.isLinux),i.set("isWindows",T.isWindows),i.set("isWeb",T.isWeb),i.set("isMacNative",T.isMacintosh&&!T.isWeb),i.set("isEdge",L.indexOf("Edg/")>=0),i.set("isFirefox",L.indexOf("Firefox")>=0),i.set("isChrome",L.indexOf("Chrome")>=0),i.set("isSafari",L.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var w;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return d.INSTANCE}static true(){return v.INSTANCE}static has(k){return h.create(k)}static equals(k,z){return y.create(k,z)}static notEquals(k,z){return E.create(k,z)}static regex(k,z){return t.create(k,z)}static in(k,z){return p.create(k,z)}static not(k){return f.create(k)}static and(...k){return u.create(k,null)}static or(...k){return g.create(k,null,!0)}static greater(k,z){return l.create(k,z)}static greaterEquals(k,z){return s.create(k,z)}static smaller(k,z){return a.create(k,z)}static smallerEquals(k,z){return n.create(k,z)}static deserialize(k,z=!1){if(!!k)return this._deserializeOrExpression(k,z)}static _deserializeOrExpression(k,z){let A=k.split("||");return g.create(A.map(F=>this._deserializeAndExpression(F,z)),null,!0)}static _deserializeAndExpression(k,z){let A=k.split("&&");return u.create(A.map(F=>this._deserializeOne(F,z)),null)}static _deserializeOne(k,z){if(k=k.trim(),k.indexOf("!=")>=0){let A=k.split("!=");return E.create(A[0].trim(),this._deserializeValue(A[1],z))}if(k.indexOf("==")>=0){let A=k.split("==");return y.create(A[0].trim(),this._deserializeValue(A[1],z))}if(k.indexOf("=~")>=0){let A=k.split("=~");return t.create(A[0].trim(),this._deserializeRegexValue(A[1],z))}if(k.indexOf(" in ")>=0){let A=k.split(" in ");return p.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const A=k.split(">=");return s.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const A=k.split(">");return l.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const A=k.split("<=");return n.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const A=k.split("<");return a.create(A[0].trim(),A[1].trim())}return/^\!\s*/.test(k)?f.create(k.substr(1).trim()):h.create(k)}static _deserializeValue(k,z){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let A=/^'([^']*)'$/.exec(k);return A?A[1].trim():k}static _deserializeRegexValue(k,z){if((0,_.isFalsyOrWhitespace)(k)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let A=k.indexOf("/"),F=k.lastIndexOf("/");if(A===F||A<0){if(z)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let B=k.slice(A+1,F),Z=k[F+1]==="i"?"i":"";try{return new RegExp(B,Z)}catch(V){if(z)throw new Error(`bad regexp-value '${k}', parse error: ${V}`);return console.warn(`bad regexp-value '${k}', parse error: ${V}`),null}}}e.ContextKeyExpr=b;function I($,k){const z=$?$.substituteConstants():void 0,A=k?k.substituteConstants():void 0;return!z&&!A?!0:!z||!A?!1:z.equals(A)}e.expressionsAreEqualWithConstantSubstitution=I;function C($,k){return $.cmp(k)}class d{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class v{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class h{constructor(k,z){this.key=k,this.negated=z,this.type=2}static create(k,z=null){const A=i.get(k);return typeof A=="boolean"?A?v.INSTANCE:d.INSTANCE:new h(k,z)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=i.get(this.key);return typeof k=="boolean"?k?v.INSTANCE:d.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=4}static create(k,z,A=null){if(typeof z=="boolean")return z?h.create(k,A):f.create(k,A);const F=i.get(k);return typeof F=="boolean"?z===(F?"true":"false")?v.INSTANCE:d.INSTANCE:new y(k,z,A)}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=i.get(this.key);if(typeof k=="boolean"){const z=k?"true":"false";return this.value===z?v.INSTANCE:d.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class p{constructor(k,z){this.key=k,this.valueKey=z,this.type=10,this.negated=null}static create(k,z){return new p(k,z)}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const z=k.getValue(this.valueKey),A=k.getValue(this.key);return Array.isArray(z)?z.indexOf(A)>=0:typeof A=="string"&&typeof z=="object"&&z!==null?R.call(z,A):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=p;class m{constructor(k){this._actual=k,this.type=11}static create(k){return new m(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new m(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class E{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=5}static create(k,z,A=null){if(typeof z=="boolean")return z?f.create(k,A):h.create(k,A);const F=i.get(k);return typeof F=="boolean"?z===(F?"true":"false")?d.INSTANCE:v.INSTANCE:new E(k,z,A)}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=i.get(this.key);if(typeof k=="boolean"){const z=k?"true":"false";return this.value===z?d.INSTANCE:v.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class f{constructor(k,z){this.key=k,this.negated=z,this.type=3}static create(k,z=null){const A=i.get(k);return typeof A=="boolean"?A?d.INSTANCE:v.INSTANCE:new f(k,z)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=i.get(this.key);return typeof k=="boolean"?k?d.INSTANCE:v.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function c($,k){if(typeof $=="string"){const z=parseFloat($);isNaN(z)||($=z)}return typeof $=="string"||typeof $=="number"?k($):d.INSTANCE}class l{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=12}static create(k,z,A=null){return c(z,F=>new l(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class s{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=13}static create(k,z,A=null){return c(z,F=>new s(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=s;class a{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=14}static create(k,z,A=null){return c(z,F=>new a(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class n{constructor(k,z,A){this.key=k,this.value=z,this.negated=A,this.type=15}static create(k,z,A=null){return c(z,F=>new n(k,F,A))}cmp(k){return k.type!==this.type?this.type-k.type:O(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(k,z){this.key=k,this.regexp=z,this.type=7,this.negated=null}static create(k,z){return new t(k,z)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const z=this.regexp?this.regexp.source:"",A=k.regexp?k.regexp.source:"";return z<A?-1:z>A?1:0}equals(k){if(k.type===this.type){const z=this.regexp?this.regexp.source:"",A=k.regexp?k.regexp.source:"";return this.key===k.key&&z===A}return!1}substituteConstants(){return this}evaluate(k){let z=k.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{constructor(k){this._actual=k,this.type=8}static create(k){return new r(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new r(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function o($){let k=null;for(let z=0,A=$.length;z<A;z++){const F=$[z].substituteConstants();if($[z]!==F&&k===null){k=[];for(let B=0;B<z;B++)k[B]=$[B]}k!==null&&(k[z]=F)}return k===null?$:k}class u{constructor(k,z){this.expr=k,this.negated=z,this.type=6}static create(k,z){return u._normalizeArr(k,z)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let z=0,A=this.expr.length;z<A;z++){const F=C(this.expr[z],k.expr[z]);if(F!==0)return F}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].equals(k.expr[z]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:u.create(k,this.negated)}evaluate(k){for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].evaluate(k))return!1;return!0}static _normalizeArr(k,z){const A=[];let F=!1;for(const B of k)if(!!B){if(B.type===1){F=!0;continue}if(B.type===0)return d.INSTANCE;if(B.type===6){A.push(...B.expr);continue}A.push(B)}if(A.length===0&&F)return v.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];A.sort(C);for(let B=1;B<A.length;B++)A[B-1].equals(A[B])&&(A.splice(B,1),B--);if(A.length===1)return A[0];for(;A.length>1;){const B=A[A.length-1];if(B.type!==9)break;A.pop();const Z=A.pop(),V=A.length===0,j=g.create(B.expr.map(Q=>u.create([Q,Z],null)),null,V);j&&(A.push(j),A.sort(C))}return A.length===1?A[0]:new u(A,z)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let z of this.expr)k.push(...z.keys());return k}map(k){return new u(this.expr.map(z=>z.map(k)),null)}negate(){if(!this.negated){const k=[];for(let z of this.expr)k.push(z.negate());this.negated=g.create(k,this,!0)}return this.negated}}class g{constructor(k,z){this.expr=k,this.negated=z,this.type=9}static create(k,z,A){return g._normalizeArr(k,z,A)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let z=0,A=this.expr.length;z<A;z++){const F=C(this.expr[z],k.expr[z]);if(F!==0)return F}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].equals(k.expr[z]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:g.create(k,this.negated,!1)}evaluate(k){for(let z=0,A=this.expr.length;z<A;z++)if(this.expr[z].evaluate(k))return!0;return!1}static _normalizeArr(k,z,A){let F=[],B=!1;if(k){for(let Z=0,V=k.length;Z<V;Z++){const j=k[Z];if(!!j){if(j.type===0){B=!0;continue}if(j.type===1)return v.INSTANCE;if(j.type===9){F=F.concat(j.expr);continue}F.push(j)}}if(F.length===0&&B)return d.INSTANCE;F.sort(C)}if(F.length!==0){if(F.length===1)return F[0];for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];if(A){for(let Z=0;Z<F.length;Z++)for(let V=Z+1;V<F.length;V++)U(F[Z],F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0]}return new g(F,z)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let z of this.expr)k.push(...z.keys());return k}map(k){return new g(this.expr.map(z=>z.map(k)),null)}negate(){if(!this.negated){let k=[];for(let z of this.expr)k.push(z.negate());for(;k.length>1;){const z=k.shift(),A=k.shift(),F=[];for(const Z of W(z))for(const V of W(A))F.push(u.create([Z,V],null));const B=k.length===0;k.unshift(g.create(F,null,B))}this.negated=k[0]}return this.negated}}class S extends h{constructor(k,z,A){super(k,null);this._defaultValue=z,typeof A=="object"?S._info.push({...A,key:k}):A!==!0&&S._info.push({key:k,description:A,type:z!=null?typeof z:void 0})}static all(){return S._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return y.create(this.key,k)}notEqualsTo(k){return E.create(this.key,k)}}e.RawContextKey=S,S._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P($,k){return $<k?-1:$>k?1:0}function O($,k,z,A){return $<z?-1:$>z?1:k<A?-1:k>A?1:0}function U($,k){if(k.type===6&&$.type!==9&&$.type!==6){for(const F of k.expr)if($.equals(F))return!0}const z=$.negate(),A=W(z).concat(W(k));A.sort(C);for(let F=0;F<A.length;F++){const Z=A[F].negate();for(let V=F+1;V<A.length;V++){const j=A[V];if(Z.equals(j))return!0}}return!1}e.implies=U;function W($){return $.type===9?$.expr:[$]}}),define(te[78],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,T.createDecorator)(e.ID);function _(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=_}),define(te[79],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,16,131,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var L;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(L=e.TargetPlatform||(e.TargetPlatform={}));function i(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function w(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function b(f,c){return c==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function I(f,c,l){return b(c,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l?!0:C(l).includes(f)}e.isTargetPlatformCompatible=I;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function d(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=d;var v;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var h;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var y;(function(f){f.Install="install",f.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var p;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.UnsupportedPreRelease="UnsupportedPreRelease",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var G=this&&this.__param||function(J,e){return function(T,_){e(T,_,J)}};define(te[161],ne([0,1,2,30]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let D=class extends T.Disposable{constructor(i){super();i.removeDeprecatedExtensions(),i.migrateUnsupportedExtensions()}};D=de([G(0,_.IExtensionManagementService)],D),e.ExtensionsCleaner=D}),define(te[162],ne([0,1,3,2,28,7,110,30]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(y,p){return L.URI.revive(p?p.transformIncoming(y):y)}function b(y,p){return p?p.transformOutgoingURI(y):y}function I(y,p){p=p||i.DefaultURITransformer;const m=y.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...y,manifest:void 0},p),manifest:m}}function C(y,p){return p?(0,D.cloneAndChange)(y,m=>m instanceof L.URI?p.transformOutgoingURI(m):void 0):y}class d{constructor(p,m){this.service=p,this.getUriTransformer=m,this.onInstallExtension=T.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=T.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=T.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=T.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,m){const E=this.getUriTransformer(p);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return T.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?C(c.local,E):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,m,E){const f=this.getUriTransformer(p);switch(m){case"zip":return this.service.zip(I(E[0],f)).then(c=>b(c,f));case"unzip":return this.service.unzip(w(E[0],f));case"install":return this.service.install(w(E[0],f),E[1]);case"getManifest":return this.service.getManifest(w(E[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(I(E[0],f),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(E[0],f));case"getInstalled":return this.service.getInstalled(E[0]).then(c=>c.map(l=>C(l,f)));case"updateMetadata":return this.service.updateMetadata(I(E[0],f),E[1]).then(c=>C(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(I(E[0],f),E[1]).then(c=>C(c,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class v extends _.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?L.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(E=>({...E,local:E.local?I(E.local,null):E.local,source:this.isUriComponents(E.source)?L.URI.revive(E.source):E.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const m=await this.getTargetPlatform();return p.allTargetPlatforms.some(E=>(0,R.isTargetPlatformCompatible)(E,p.allTargetPlatforms,m))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(m=>L.URI.revive(m)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,m){return Promise.resolve(this.channel.call("install",[p,m])).then(E=>I(E,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,m){return Promise.resolve(this.channel.call("installFromGallery",[p,m])).then(E=>I(E,null))}uninstall(p,m){return Promise.resolve(this.channel.call("uninstall",[p,m]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null){return Promise.resolve(this.channel.call("getInstalled",[p])).then(m=>m.map(E=>I(E,null)))}updateMetadata(p,m){return Promise.resolve(this.channel.call("updateMetadata",[p,m])).then(E=>I(E,null))}updateExtensionScope(p,m){return Promise.resolve(this.channel.call("updateExtensionScope",[p,m])).then(E=>I(E,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=v;class h{constructor(p){this.service=p}listen(p,m){throw new Error("Invalid listen")}call(p,m,E){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var _;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(_=e.RecommendationSource||(e.RecommendationSource={}));function D(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var L;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,T.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,40,10,25,15,7,138,6]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function b(A){return A.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(A){A[A.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var d;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash",A[A.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=v;function h(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function p(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=p;var m;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.FileWriteLocked="EntryWriteLocked",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(F,B){super(F);this.code=B}}e.FileSystemProviderError=E;function f(A,F){const B=new E(A.toString(),F);return l(B,F),B}e.createFileSystemProviderError=f;function c(A){return A||f((0,R.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function l(A,F){return A.name=F?`${F} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=l;function s(A){if(!A)return m.Unknown;if(A instanceof E)return A.code;const F=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!F)return m.Unknown;switch(F[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=s;function a(A){if(A instanceof g)return A.fileOperationResult;switch(s(A)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(F,B,Z){this.resource=F,this.operation=B,this.target=Z}isOperation(F){return this.operation===F}}e.FileOperationEvent=t;var r;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class o{constructor(F,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Z=new Map;for(const V of F){const j=Z.get(V.type);j?j.push([V.resource,V]):Z.set(V.type,[[V.resource,V]])}for(const[V,j]of Z)switch(V){case 1:this.added=T.TernarySearchTree.forUris(()=>B),this.added.fill(j);break;case 0:this.updated=T.TernarySearchTree.forUris(()=>B),this.updated.fill(j);break;case 2:this.deleted=T.TernarySearchTree.forUris(()=>B),this.deleted.fill(j);break}}contains(F,...B){return this.doContains(F,{includeChildren:!1},...B)}affects(F,...B){return this.doContains(F,{includeChildren:!0},...B)}doContains(F,B,...Z){if(!F)return!1;const V=Z.length>0;return!!((!V||Z.includes(1))&&(this.added?.get(F)||B.includeChildren&&this.added?.findSuperstr(F))||(!V||Z.includes(0))&&(this.updated?.get(F)||B.includeChildren&&this.updated?.findSuperstr(F))||(!V||Z.includes(2))&&(this.deleted?.findSubstr(F)||B.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(A,F,B){return!A||!F||A===F||F.length>A.length?!1:(F.charAt(F.length-1)!==_.sep&&(F+=_.sep),B?(0,D.startsWithIgnoreCase)(A,F):A.indexOf(F)===0)}e.isParent=u;class g extends Error{constructor(F,B,Z){super(F);this.fileOperationResult=B,this.options=Z}}e.FileOperationError=g;class S extends g{constructor(F,B,Z){super(F,2,Z);this.stat=B}}e.NotModifiedSinceFileOperationError=S;var P;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=U;async function W(A,F){if(!F.hasProvider(i.URI.from({scheme:A.scheme})))return new Promise(B=>{const Z=F.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===A.scheme&&V.added&&(Z.dispose(),B())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(F){return(0,L.isNumber)(F)||(F=0),F<$.KB?(0,R.localize)(1,null,F.toFixed(0)):F<$.MB?(0,R.localize)(2,null,(F/$.KB).toFixed(2)):F<$.GB?(0,R.localize)(3,null,(F/$.MB).toFixed(2)):F<$.TB?(0,R.localize)(4,null,(F/$.GB).toFixed(2)):(0,R.localize)(5,null,(F/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var k;(function(A){A[A.IA32=0]="IA32",A[A.OTHER=1]="OTHER"})(k=e.Arch||(e.Arch={}));function z(A){return{maxFileSize:A===0?300*$.MB:16*$.GB,maxHeapSize:A===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=z}),define(te[163],ne([0,1,81,50,14]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(R){this.fileService=R}async checksum(R){const w=(await this.fileService.readFileStream(R)).value;return new Promise((b,I)=>{const C=(0,T.createHash)("md5");(0,_.listenStream)(w,{onData:d=>C.update(d.buffer),onError:d=>I(d),onEnd:()=>b(C.digest("base64").replace(/=+$/,""))})})}};L=de([G(0,D.IFileService)],L),e.ChecksumService=L}),define(te[164],ne([0,1,246,128,151,14]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(d,v){const h={onUnknownOption:p=>{console.warn((0,_.localize)(0,null,p))},onMultipleValues:(p,m)=>{console.warn((0,_.localize)(1,null,p,m))},onDeprecatedOption:(p,m)=>{console.warn((0,_.localize)(2,null,p,m))}},y=(0,D.parseArgs)(d,D.OPTIONS,v?h:void 0);return y.goto&&y._.forEach(p=>T(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,_.localize)(3,null))),y["max-memory"]&&T(parseInt(y["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function R(d){const v=d.findIndex(h=>!/^-/.test(h));if(v>-1)return[...d.slice(0,v),...d.slice(v+1)]}function w(d){let[,...v]=d;process.env.VSCODE_DEV&&(v=R(v)||[]);const h=!C(process.env);return i(v,h)}e.parseMainProcessArgv=w;function b(d){const[,,...v]=d;return i(v,!0)}e.parseCLIProcessArgv=b;function I(d,...v){const h=d.indexOf("--");return h===-1?d.push(...v):d.splice(h,0,...v),d}e.addArg=I;function C(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[165],ne([0,1,45,10,129,27,38,9,4,29,124,164,5]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function y(m,E,f){return E["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!E["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(c,l)=>{const s=new L.CancellationTokenSource,a=setTimeout(()=>{s.dispose(!0),l(new Error((0,D.localize)(0,null)))},v);try{c(await p(m,s.token))}catch(n){!(0,R.isPromiseCanceledError)(n)&&!s.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,i.toErrorMessage)(n)))):c({})}finally{clearTimeout(a),s.dispose()}})),h)}e.getResolvedShellEnv=y;async function p(m,E){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",c);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",a);const n=await(0,I.getSystemShell)(w.OS,a);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,r)=>{if(E.isCancellationRequested)return r((0,R.canceled)());const o=(0,_.basename)(n);let u,g;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${S} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,g=["-Login","-Command"]):(u=`'${process.execPath}' ${S} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),u);const P=(0,T.spawn)(n,[...g,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});E.onCancellationRequested(()=>(P.kill(),r((0,R.canceled)()))),P.on("error",W=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(W)),r(W)});const O=[];P.stdout.on("data",W=>O.push(W));const U=[];P.stderr.on("data",W=>U.push(W)),P.on("close",(W,$)=>{const k=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",k);const z=Buffer.concat(U).toString("utf8");if(z.trim()&&m.trace("getUnixShellEnvironment#stderr",z),W||$)return r(new Error((0,D.localize)(2,null,W,$)));const A=s.exec(k),F=A?A[1]:"{}";try{const B=JSON.parse(F);f?B.ELECTRON_RUN_AS_NODE=f:delete B.ELECTRON_RUN_AS_NODE,c?B.ELECTRON_NO_ATTACH_CONSOLE=c:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){m.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(B)),r(B)}})})}}),define(te[82],ne([0,1,19,9,139,14]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,C,d,v,h,y){let p;try{await R(I,C,d,v,h,y)}catch(m){p=m}finally{p&&h.errorTransformer&&(p=h.errorTransformer(p)),typeof p!="undefined"&&d.error(p),d.end()}}e.readFileIntoStream=i;async function R(I,C,d,v,h,y){w(y);const p=await I.open(C,{create:!1});try{w(y);let m=0,E=0,f=h&&typeof h.length=="number"?h.length:void 0,c=T.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,s=0;do E=await I.read(p,l,c.buffer,s,c.byteLength-s),l+=E,s+=E,m+=E,typeof f=="number"&&(f-=E),s===c.byteLength&&(await d.write(v(c)),c=T.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),s=0);while(E>0&&(typeof f!="number"||f>0)&&w(y)&&b(m,h));if(s>0){let a=s;typeof f=="number"&&(a=Math.min(s,f)),d.write(v(c.slice(0,a)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await I.close(p)}}function w(I){if(I.isCancellationRequested)throw(0,_.canceled)();return!0}function b(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,7,14]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class i extends T.Disposable{constructor(d,v,h){super();this.onFileChanges=d,this.onLogMessage=v,this.verboseLogging=h,this.serviceDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new T.DisposableStore;this.serviceDisposables.value=d,this.service=this.createService(d),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(v=>this.onFileChanges(v))),d.add(this.service.onDidLogMessage(v=>this.onLogMessage(v))),d.add(this.service.onDidError(v=>this.onError(v)))}onError(d){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=i,i.MAX_RESTARTS=5;class R extends T.Disposable{}e.WatcherService=R;function w(C){return C.map(d=>({type:d.type,resource:D.URI.file(d.path)}))}e.toFileChanges=w;function b(C){const d=new I;for(const v of C)d.processEvent(v);return d.coalesce()}e.coalesceEvents=b;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return _.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const v=this.mapPathToChange.get(this.toKey(d));let h=!1;if(v){const y=v.type,p=d.type;v.path!==d.path&&d.type===2?h=!0:y===1&&p===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(v)):y===2&&p===1?v.type=0:y===1&&p===0||(v.type=p)}else h=!0;h&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],v=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(d.push(h),!1):!0).sort((h,y)=>h.path.length-y.path.length).filter(h=>v.some(y=>(0,L.isParent)(h.path,y,!_.isLinux))?!1:(v.push(h.path),!0)).concat(d)}}}),define(te[166],ne([0,1,5,2,10,114,20,117,54]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends _.Disposable{constructor(C,d,v,h){super();this.path=C,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=h,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:d}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(d)try{v=await(0,L.realpath)(v)}catch(h){if(this.onError(h),d.dangling)return}C.isDirectory()?this._register((0,R.watchFolder)(v,(h,y)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(y))})},h=>this.onError(h))):this._register((0,R.watchFile)(v,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,w.coalesceEvents)(d);if(this.verboseLogging)for(const h of v)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[167],ne([0,1,16,34,52,54]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends L.WatcherService{constructor(w,b,I){super();this.onDidFilesChange=w,this.onLogMessage=b,this.verboseLogging=I,this.isDisposed=!1,this.startWatching()}startWatching(){const w=this._register(new D.Client(T.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=_.ProxyChannel.toService((0,_.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}async watch(w){this.isDisposed||await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(te[168],ne([0,1,16,34,52,54]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends L.AbstractWatcherService{constructor(w,b,I){super(w,b,I);this.init()}createService(w){const b=w.add(new D.Client(T.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(b.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),_.ProxyChannel.toService((0,_.getNextTickChannel)(b.getChannel("watcher")))}}e.FileWatcher=i}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...D){this._entries=new Map;for(let[L,i]of D)this.set(L,i)}set(D,L){const i=this._entries.get(D);return this._entries.set(D,L),i}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=T}),define(te[169],ne([0,1,5,9,53,158,6,83]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new R.ServiceCollection,y=!1,p){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=p,this._services.set(i.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...y){let p=d.traceInvocation(h),m=!1;try{return h({get:f=>{if(m)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,p);if(!c)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...y)}finally{m=!0,p.stop()}}createInstance(h,...y){let p,m;return h instanceof D.SyncDescriptor?(p=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(y),p)):(p=d.traceCreation(h),m=this._createInstance(h,y,p)),p.stop(),m}_createInstance(h,y=[],p){let m=i._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),E=[];for(const c of m){let l=this._getOrCreateServiceInstance(c.id,p);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);E.push(l)}let f=m.length>0?m[0].index:y.length;if(y.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${y.length} static arguments`);let c=f-y.length;c>0?y=y.concat(new Array(c)):y=y.slice(0,f)}return new h(...[...y,...E])}_setServiceInstance(h,y){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){let p=this._getServiceInstanceOrDescriptor(h);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,p,y.branch(h,!0)):(y.branch(h,!1),p)}_safeCreateAndCacheServiceInstance(h,y,p){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,p)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,p){const m=new L.Graph(c=>c.id.toString());let E=0;const f=[{id:h,desc:y,_trace:p}];for(;f.length;){const c=f.pop();if(m.lookupOrInsertNode(c),E++>1e3)throw new b(m);for(let l of i._util.getServiceDependencies(c.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(l.id);if(!s&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),s instanceof D.SyncDescriptor){const a={id:l.id,desc:s,_trace:c._trace.branch(l.id,!0)};m.insertEdge(c,a),f.push(a)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new b(m);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,p=[],m,E){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(y,p,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,p,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],p,m){if(p){const E=new T.IdleValue(()=>this._createInstance(h,y,m));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];let l=E.value,s=l[c];return typeof s!="function"||(s=s.bind(l),f[c]=s),s},set(f,c,l){return E.value[c]=l,!0}})}else return this._createInstance(h,y,m)}}e.InstantiationService=I;var C;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(C||(C={}));class d{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return w?new d(0,h.name):d._None}branch(h,y){let p=new d(2,h.toString());return this._dep.push([h,y,p]),p}stop(){let h=Date.now()-this._start;d._totals+=h;let y=!1;function p(E,f){let c=[],l=new Array(E+1).join("	");for(const[s,a,n]of f._dep)if(a&&n){y=!0,c.push(`${l}CREATES -> ${s}`);let t=p(E+1,n);t&&c.push(t)}else c.push(`${l}uses -> ${s}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[170],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class T{constructor(D,L){this.server=D,this.router=L}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,L){this.server.registerChannel(D,L)}}e.MessagePortMainProcessService=T}),define(te[171],ne([0,1,34,53,77,6]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(v,h,y){const p=y.getChannel(v);return R(h)?new h.channelClientCtor(p):T.ProxyChannel.toService(p,h?.proxyOptions)}}function R(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let w=class extends i{constructor(v,h,y){super(v,h,y)}};w=de([G(2,e.IMainProcessService)],w);function b(d,v,h){(0,D.registerSingleton)(d,new _.SyncDescriptor(w,[v,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends i{constructor(v,h,y){super(v,h,y)}};I=de([G(2,e.ISharedProcessService)],I);function C(d,v,h){(0,D.registerSingleton)(d,new _.SyncDescriptor(I,[v,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[59],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,T.createDecorator)("localizationsService");function _(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const L of D.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=_}),define(te[172],ne([0,1,2,59]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends T.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=de([G(0,_.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[8],ne([0,1,38,3,2,4,6]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function R(){return new Date().toISOString()}var w;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function b(a,n,t){switch(n){case w.Trace:a.trace(t);break;case w.Debug:a.debug(t);break;case w.Info:a.info(t);break;case w.Warning:a.warn(t);break;case w.Error:a.error(t);break;case w.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=b;function I(a){let n="";for(let t=0;t<a.length;t++){let r=a[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(t>0?" ":"")+r}return n}e.format=I;class C extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class d extends C{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(w.Trace)&&this.log(w.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(w.Debug)&&this.log(w.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(w.Info)&&this.log(w.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(w.Warning)&&this.log(w.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(w.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(w.Error,I(r))}else this.log(w.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(w.Critical)&&this.log(w.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class v extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!L.isWindows}trace(n,...t){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}debug(n,...t){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}info(n,...t){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}warn(n,...t){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,n,...t):console.warn(`[main ${R()}]`,n,...t))}error(n,...t){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}critical(n,...t){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends C{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,T.toErrorMessage)(n,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class p extends C{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const r of this.logServices)r.trace(n,...t)}debug(n,...t){for(const r of this.logServices)r.debug(n,...t)}info(n,...t){for(const r of this.logServices)r.info(n,...t)}warn(n,...t){for(const r of this.logServices)r.warn(n,...t)}error(n,...t){for(const r of this.logServices)r.error(n,...t)}critical(n,...t){for(const r of this.logServices)r.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=p;class m extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class E extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,t?.always?w.Trace:this.logLevel,t),this.loggers.set(n.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class f{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(n){}getLevel(){return w.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=f;function c(a){if(a.verbose)return w.Trace;if(typeof a.logLevel=="string"){const n=l(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(a){switch(a){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=l;function s(a){switch(a){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=s}),define(te[173],ne([0,1,5,9,2,10,20,11,8]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(C,d){super();this.environmentService=C,this.logService=d,this._register(new T.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,L.basename)(this.environmentService.logsPath),d=(0,L.dirname)(this.environmentService.logsPath),y=(await i.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==C),p=y.slice(0,Math.max(0,y.length-9));p.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(m=>i.Promises.rm((0,L.join)(d,m)))))}catch(C){(0,_.onUnexpectedError)(C)}}};b=de([G(0,R.IEnvironmentService),G(1,w.ILogService)],b),e.LogsDataCleaner=b}),define(te[174],ne([0,1,5,9,2,10,20,11,8]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class gt extends D.Disposable{constructor(C,d,v){super();this.backupWorkspacesPath=C,this.environmentService=d,this.logService=v,this._register(new T.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),v=JSON.parse(C).emptyWorkspaceInfos.map(y=>y.backupFolder),h=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async y=>{y.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||y===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||v.indexOf(y)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${y}.`),await i.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(C){(0,_.onUnexpectedError)(C)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=de([G(1,R.INativeEnvironmentService),G(2,w.ILogService)],b),e.StorageDataCleaner=b}),define(te[84],ne([0,1,5,19,31,39,11,14,6,8]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,w.createDecorator)(e.UserConfigurationFileServiceId);let C=class{constructor(v,h,y){this.environmentService=v,this.fileService=h,this.logService=y,this.queue=new T.Queue}async updateSettings(v,h){return this.queue.queue(()=>this.doWrite(v,h))}async doWrite(v,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),v);const{value:y,mtime:p,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let E=y.toString();const f=[];if((0,D.parse)(E,f,{allowTrailingComma:!0,allowEmptyContent:!0}),f.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(v,E,h)[0];if(c){E=E.substring(0,c.offset)+c.content+E.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,_.VSBuffer.fromString(E),{etag:m,mtime:p})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(v,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,v,h)})}getEdits({value:v,path:h},y,p){return h.length?(0,L.setProperty)(y,h,v,p):[{content:JSON.stringify(v,null,p.insertSpaces&&p.tabSize?" ".repeat(p.tabSize):"	"),length:y.length,offset:0}]}};C=de([G(0,i.IEnvironmentService),G(1,R.IFileService),G(2,b.ILogService)],C),e.UserConfigurationFileService=C}),define(te[175],ne([0,1,45,5,38,3,2,16,10,20,11,8]),function(J,e,T,_,D,L,i,R,w,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends i.Disposable{constructor(h,y){super();this.environmentService=h,this.logService=y,this.processesLimiter=new _.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${p}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(h,y){const p=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[p]=="string"){const m=h.manifest.scripts[p].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${p} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,y,p,m,E){return new Promise((f,c)=>{const l=this.start(h,y,p,E);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?c(n):f(void 0)};l.on("error",n=>{a((0,D.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),m&&(s=setTimeout(()=>{s=null,l.kill(),c("timed out")},5e3))})}start(h,y,p,m){const E={silent:!0,execArgv:void 0},f=(0,T.fork)(h,[`--type=extension-post-${y}`,...p],E);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(f.stdout,"data"),l=L.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${y}`,n)),l(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${y}`,n));const s=L.Event.any(L.Event.map(c,n=>({data:`%c${n}`,format:[""]})),L.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(s,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([G(0,I.IEnvironmentService),G(1,C.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[176],ne([0,1,17,5,9,3,2,10,54,8]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(d){super();this.logService=d,this._onDidErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new _.ThrottledDelayer(0))}watch(d,v){return v.recursive?this.watchRecursive(d,v):this.watchNonRecursive(d)}watchRecursive(d,v){const h={path:this.toFilePath(d),excludes:v.excludes},y=(0,T.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,D.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,w.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,v){return d.watch(v)}watchNonRecursive(d){const v=this.createNonRecursiveWatcher(this.toFilePath(d),y=>this._onDidChangeFile.fire((0,w.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{v.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,i.combinedDisposable)(v,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidErrorOccur.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,R.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[177],ne([0,1,17,5,19,27,3,56,2,40,16,178,18,50,137,14,82,8]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class Ke extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new _.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new y.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new _.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new y.FileChangesEvent(l,!0)))),this.watchedResources=b.TernarySearchTree.forUris(l=>{const s=this.getProvider(l.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new _.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const s=new w.DisposableStore;return s.add(l.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(l)))),s.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidErrorOccur=="function"&&s.add(l.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,w.dispose)(s)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(s){l.push(s)}}),!this.provider.has(c)&&await _.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const s=this.provider.get(c.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return R.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const s=new Error;throw s.name="ENOPRO",s.message=(0,h.localize)(1,null,c.toString()),s}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasReadWriteCapability)(l)||(0,y.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(s){throw(0,y.toFileSystemProviderErrorCode)(s)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,y.ensureFileSystemProviderError)(s)}}async doResolveFile(c,l){const s=await this.withProvider(c),a=this.isPathCaseSensitive(s),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,r=l?.resolveMetadata,o=await s.stat(c);let u;return this.toFileStat(s,c,o,void 0,!!r,(g,S)=>(u||(u=b.TernarySearchTree.forUris(()=>!a),u.set(c,!0),n&&u.fill(!0,n)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&t?S===1:!1))}async toFileStat(c,l,s,a,n,t){const{providerExtUri:r}=this.getExtUri(c),o={resource:l,name:r.basename(l),isFile:(s.type&y.FileType.File)!=0,isDirectory:(s.type&y.FileType.Directory)!=0,isSymbolicLink:(s.type&y.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&y.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,y.etag)({mtime:s.mtime,size:s.size})};if(o.isDirectory&&t(o,a)){try{const u=await c.readdir(l),g=await _.Promises.settled(u.map(async([S,P])=>{try{const O=r.joinPath(l,S),U=n?await c.stat(O):{type:P};return await this.toFileStat(c,O,U,u.length,n,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,T.coalesce)(g)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(c){return _.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(s){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(s){return s}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=D.VSBuffer.fromString(""),s){await this.doValidateCreateFile(c,s);const a=await this.writeFile(c,l);return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,a)),a}async writeFile(c,l,s){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,c,s)||await this.mkdirp(a,n.dirname(c));let r;if((0,y.hasReadWriteCapability)(a)&&!(l instanceof D.VSBuffer))if((0,v.isReadableStream)(l)){const o=await(0,v.peekStream)(l,3);o.ended?r=D.VSBuffer.concat(o.buffer):r=o}else r=(0,v.peekReadable)(l,o=>D.VSBuffer.concat(o),3);else r=l;!(0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)&&r instanceof D.VSBuffer?await this.doWriteUnbuffered(a,c,s,r):await this.doWriteBuffered(a,c,s,r instanceof D.VSBuffer?(0,D.bufferToReadable)(r):r)}catch(t){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),s)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,s){if(!!s?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch(t){return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,s);if(this.throwIfFileIsReadonly(l,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,y.etag)({mtime:s.mtime,size:n.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,s);return n}async readFile(c,l){const s=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(s,c,l):this.doReadFile(s,c,l)}async doReadFileAtomic(c,l,s){return new Promise((a,n)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(c,l,s);a(t)}catch(t){n(t)}})})}async doReadFile(c,l,s){const a=await this.doReadFileStream(c,l,{...s,preferUnbuffered:!0});return{...a,value:await(0,D.streamToBuffer)(a.value)}}async readFileStream(c,l){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,l)}async doReadFileStream(c,l,s){const a=new L.CancellationTokenSource,n=this.validateReadFile(l,s).then(r=>r,r=>{throw a.cancel(),r});let t;try{return typeof s?.etag=="string"&&s.etag!==y.ETAG_DISABLED&&await n,!((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasFileReadStreamCapability)(c))||(0,y.hasReadWriteCapability)(c)&&s?.preferUnbuffered?t=this.readFileUnbuffered(c,l,s):(0,y.hasFileReadStreamCapability)(c)?t=this.readFileStreamed(c,l,a.token,s):t=this.readFileBuffered(c,l,a.token,s),{...await n,value:t}}catch(r){t&&await(0,v.consumeStream)(t);const o=(0,h.localize)(8,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(r).toString());throw r instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(o,r.stat,s):new y.FileOperationError(o,(0,y.toFileOperationResult)(r),s)}}readFileStreamed(c,l,s,a=Object.create(null)){const n=c.readFileStream(l,a,s);return(0,v.transform)(n,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},t=>D.VSBuffer.concat(t))}readFileBuffered(c,l,s,a=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,l,n,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},s),n}readFileUnbuffered(c,l,s){const a=(0,v.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(l);typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(l,n.byteLength,s),a.end(D.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(c,l){const s=await this.resolve(c,{resolveMetadata:!0});if(s.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==y.ETAG_DISABLED&&l.etag===s.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),s,l);return this.validateReadFileLimits(c,s.size,l),s}validateReadFileLimits(c,l,s){if(s?.limits){let a;if(typeof s.limits.memory=="number"&&l>s.limits.memory&&(a=9),typeof s.limits.size=="number"&&l>s.limits.size&&(a=7),typeof a=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),a)}}async canMove(c,l,s){return this.doCanMoveCopy(c,l,"move",s)}async canCopy(c,l,s){return this.doCanMoveCopy(c,l,"copy",s)}async doCanMoveCopy(c,l,s,a){if(c.toString()!==l.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,c,t,l,s,a)}catch(n){return n}return!0}async move(c,l,s){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"move",!!s),r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="move"?2:3,r)),r}async copy(c,l,s){const a=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"copy",!!s),r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="copy"?3:2,r)),r}async doMoveCopy(c,l,s,a,n,t){if(l.toString()===a.toString())return n;const{exists:r,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,l,s,a,n,t);if(r&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(a)),n==="copy"){if(c===s&&(0,y.hasFileFolderCopyCapability)(c))await c.copy(l,a,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,s,a):await this.doCopyFile(c,l,s,a)}return n}else return c===s?(await c.rename(l,a,{overwrite:t}),n):(await this.doMoveCopy(c,l,s,a,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,s,a){if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(c,l,s,a);if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(c,l,s,a);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(c,l,s,a);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasReadWriteCapability)(s))return this.doPipeUnbuffered(c,l,s,a)}async doCopyFolder(c,l,s,a){await s.mkdir(a),Array.isArray(l.children)&&await _.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(s).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),s,t):this.doCopyFile(c,n.resource,s,t)}))}async doValidateMoveCopy(c,l,s,a,n,t){let r=!1;if(c===s){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(c);if(g||(r=u.isEqual(l,a)),r&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(a)));if(!r&&u.isEqualOrParent(a,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!r){if(!t)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(a)),4);if(c===s){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,a))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:r}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,s)),s}async mkdirp(c,l){const s=[],{providerExtUri:a}=this.getExtUri(c);for(;!a.isEqual(l,a.dirname(l));)try{if(((await c.stat(l)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(a.basename(l)),l=a.dirname(l)}for(let n=s.length-1;n>=0;n--){l=a.joinPath(l,s[n]);try{await c.mkdir(l)}catch(t){if((0,y.toFileSystemProviderErrorCode)(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(s){return s}return!0}async doValidateDelete(c,l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(s.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await s.stat(c)}catch(r){}if(n)this.throwIfFileIsReadonly(c,n);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const r=await this.resolve(c);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return s}async del(c,l){const s=await this.doValidateDelete(c,l),a=!!l?.useTrash,n=!!l?.recursive;await s.delete(c,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new y.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let s,a;{for(const n of c)this.watchedResources.has(n.resource)?(s||(s=[]),s.push(n)):(a||(a=[]),a.push(n));s&&this._onDidFilesChange.fire(new y.FileChangesEvent(s,!l))}if(a){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const s=new w.DisposableStore;let a=!1,n=()=>{a=!0};return s.add((0,w.toDisposable)(()=>n())),this.doWatch(c,l).then(t=>{a?(0,w.dispose)(t):n=()=>(0,w.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),s.add((0,w.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),s}async doWatch(c,l){const s=await this.withProvider(c),a=this.toWatchKey(s,c,l);let n=this.activeWatchers.get(a);return n||(n={count:0,disposable:s.watch(c,l)},this.activeWatchers.set(a,n)),n.count+=1,(0,w.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,w.dispose)(n.disposable),this.activeWatchers.delete(a)))})}toWatchKey(c,l,s){const{providerExtUri:a}=this.getExtUri(c);return[a.getComparisonKey(l),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,s,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,v.isReadableStream)(a)||(0,v.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(c,n,a):await this.doWriteReadableBufferedQueued(c,n,a)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,l,s){let a=0,n;if((0,v.isReadableBufferedStream)(s)){if(s.buffer.length>0){const t=D.VSBuffer.concat(s.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,a,0),a+=t.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((t,r)=>{(0,v.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(c,l,o,o.byteLength,a,0)}catch(u){return r(u)}a+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>r(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,s){let a=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(c,l,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(c,l,s,a,n,t){let r=0;for(;r<a;)r+=await c.write(l,n+r,s.buffer,t+r,a-r)}async doWriteUnbuffered(c,l,s,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,s,a))}async doWriteUnbufferedQueued(c,l,s,a){let n;a instanceof D.VSBuffer?n=a:(0,v.isReadableStream)(a)?n=await(0,D.streamToBuffer)(a):(0,v.isReadableBufferedStream)(a)?n=await(0,D.bufferedStreamToBuffer)(a):n=(0,D.readableToBuffer)(a),await c.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(c,l,s,a){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,s,a))}async doPipeBufferedQueued(c,l,s,a){let n,t;try{n=await c.open(l,{create:!1}),t=await s.open(a,{create:!0,unlock:!1});const r=D.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,g=0;do g=await c.read(n,o,r.buffer,u,r.byteLength-u),await this.doWriteBuffer(s,t,r,g,o,u),o+=g,u+=g,u===r.byteLength&&(u=0);while(g>0)}catch(r){throw(0,y.ensureFileSystemProviderError)(r)}finally{await _.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof t=="number"?s.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,s,a){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,s,a))}async doPipeUnbufferedQueued(c,l,s,a){return s.writeFile(a,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,s,a){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,s,a))}async doPipeUnbufferedToBufferedQueued(c,l,s,a){const n=await s.open(a,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(s,n,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(c,l,s,a){const n=await(0,D.streamToBuffer)(this.readFileBuffered(c,l,L.CancellationToken.None));await this.doWriteUnbuffered(s,a,void 0,n)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};E.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},E=de([G(0,m.ILogService)],E),e.FileService=E}),define(te[179],ne([0,1,51,247,5,19,3,41,10,4,18,50,20,140,14,82,166,167,168,176,38]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,_.gracefulify)(T)}catch(s){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(s)}`)}})();class l extends f.AbstractDiskFileSystemProvider{constructor(a,n){super(a);this.options=n,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:n,symbolicLink:t}=await d.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(n,t),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(a){try{const n=await d.Promises.readdir(this.toFilePath(a),{withFileTypes:!0}),t=[];return await Promise.all(n.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,I.joinPath)(a,r.name))).type:o=this.toType(r),t.push([r.name,o])}catch(o){this.logService.trace(o)}})),t}catch(n){throw this.toFileSystemProviderError(n)}}toType(a,n){let t;return n?.dangling?t=h.FileType.Unknown:a.isFile()?t=h.FileType.File:a.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,n&&(t|=h.FileType.SymbolicLink),t}async readFile(a){try{const n=this.toFilePath(a);return await d.Promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}}readFileStream(a,n,t){const r=(0,C.newWriteableStream)(o=>L.VSBuffer.concat(o.map(u=>L.VSBuffer.wrap(u))).buffer);return(0,y.readFileIntoStream)(this,a,r,o=>o.buffer,{...n,bufferSize:256*1024},t),r}async writeFile(a,n,t){let r;try{const o=this.toFilePath(a);if(!t.create||!t.overwrite){if(await d.Promises.exists(o)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(a,{create:!0,unlock:t.unlock}),await this.write(r,0,n,0,n.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(a,o)}finally{typeof r=="number"&&await this.close(r)}}async open(a,n){try{const t=this.toFilePath(a);if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(t);u.mode&128||await d.Promises.chmod(t,u.mode|128)}catch(u){this.logService.trace(u)}let r;if((0,h.isFileOpenForWriteOptions)(n)){if(b.isWindows)try{await d.Promises.truncate(t,0),r="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}r||(r="w")}else r="r";const o=await d.Promises.open(t,r);return this.mapHandleToPos.set(o,0),(0,h.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,a),o}catch(t){throw(0,h.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(a,t):this.toFileSystemProviderError(t)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await d.Promises.fdatasync(a)}catch(n){this.canFlush=!1,this.logService.error(n)}return await d.Promises.close(a)}catch(n){throw this.toFileSystemProviderError(n)}}async read(a,n,t,r,o){const u=this.normalizePos(a,n);let g=null;try{const S=await d.Promises.read(a,t,r,o,u);return typeof S=="number"?g=S:g=S.bytesRead,g}catch(S){throw this.toFileSystemProviderError(S)}finally{this.updatePos(a,u,g)}}normalizePos(a,n){return n===this.mapHandleToPos.get(a)?null:n}updatePos(a,n,t){const r=this.mapHandleToPos.get(a);typeof r=="number"&&(typeof n=="number"||(typeof t=="number"?this.mapHandleToPos.set(a,r+t):this.mapHandleToPos.delete(a)))}async write(a,n,t,r,o){return(0,D.retry)(()=>this.doWrite(a,n,t,r,o),100,3)}async doWrite(a,n,t,r,o){const u=this.normalizePos(a,n);let g=null;try{const S=await d.Promises.write(a,t,r,o,u);return typeof S=="number"?g=S:g=S.bytesWritten,g}catch(S){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),S)}finally{this.updatePos(a,u,g)}}async mkdir(a){try{await d.Promises.mkdir(this.toFilePath(a))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(a,n){try{const t=this.toFilePath(a);await this.doDelete(t,n)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(a,n){n.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}async rename(a,n,t){const r=this.toFilePath(a),o=this.toFilePath(n);if(r!==o)try{await this.validateTargetDeleted(a,n,"move",t.overwrite),await d.Promises.move(r,o)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,v.localize)(2,null,(0,w.basename)(r),(0,w.basename)((0,w.dirname)(o)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(a,n,t){const r=this.toFilePath(a),o=this.toFilePath(n);if(r!==o)try{await this.validateTargetDeleted(a,n,"copy",t.overwrite),await d.Promises.copy(r,o,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,v.localize)(3,null,(0,w.basename)(r),(0,w.basename)((0,w.dirname)(o)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(a,n,t,r){const o=this.toFilePath(a),u=this.toFilePath(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,R.isEqual)(o,u,!0)),g&&t==="copy")throw(0,h.createFileSystemProviderError)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!g&&await d.Promises.exists(u)){if(!r)throw(0,h.createFileSystemProviderError)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(a,n,t){let r,o=!1;return this.options?.watcher?.usePolling?o=!1:o=this.options?.legacyWatcher==="on",o?r=m.FileWatcher:r=E.FileWatcher,new r(u=>a(u),u=>n(u),t,this.options?.watcher)}doWatch(a,n){const t=this.options?.watcher?.usePolling;if(t===!0)for(const r of n)r.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const r of n)t.includes(r.path)&&(r.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(a,n)}createNonRecursiveWatcher(a,n,t,r){return new p.FileWatcher(a,o=>n(o),o=>t(o),r)}toFileSystemProviderError(a){if(a instanceof h.FileSystemProviderError)return a;let n;switch(a.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(a,n)}async toFileSystemProviderWriteError(a,n){let t=this.toFileSystemProviderError(n);if(a&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.toFilePath(a));r.mode&128||(t=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return t}}e.DiskFileSystemProvider=l}),define(te[85],ne([0,1,3,7,8]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(d){this.service=d,this.onDidChangeLogLevel=T.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(d,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class i{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){i.setLevel(this.channel,d)}static setLevel(d,v){return d.call("setLevel",v)}}e.LogLevelChannelClient=i;class R{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,v){throw new Error(`Event not found: ${v}`)}async call(d,v,h){switch(v){case"createLogger":this.createLogger(_.URI.revive(h[0]),h[1]);return;case"log":return this.log(_.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(d,v){this.loggers.set(d.toString(),this.loggerService.createLogger(d,v))}consoleLog(d,v){let h=console.log;switch(d){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(d,v){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,p]of v)(0,D.log)(h,y,p)}}e.LoggerChannel=R;class w extends D.AbstractLoggerService{constructor(d,v,h){super(d,v);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(d,v)=>{this.channel.call("consoleLog",[d,v])}})}doCreateLogger(d,v,h){return new b(this.channel,d,v,h)}}e.LoggerChannelClient=w;class b extends D.AbstractMessageLogger{constructor(d,v,h,y){super(y?.always);this.channel=d,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,v){const h=[[d,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class I extends D.LogService{constructor(d,v){super(v);this.parent=d,this._register(d.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=I}),define(te[60],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,T.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,16,4,32,18]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.context!="undefined"){const R=_.globals.vscode.context.configuration();if(R)i=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,L.dirname)(T.FileAccess.asFileUri("",J));i=J.__$__nodeRequire((0,L.joinPath)(R,"product.json").fsPath);const w=J.__$__nodeRequire((0,L.joinPath)(R,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:w.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[26],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService")}),define(te[180],ne([0,1,5,9,2,10,20,8,26]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(C,d,v){super();this.productService=d,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),v=(0,L.dirname)(C),h=(0,L.basename)(C),y=await i.Promises.readdir(v);await Promise.all(y.map(async p=>{if(p===h)return;const m=(0,L.join)(v,p),E=await i.Promises.stat(m);if(E.isDirectory()&&d-E.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),i.Promises.rm(m)}))}catch(d){(0,_.onUnexpectedError)(d)}}};b=de([G(1,w.IProductService),G(2,R.ILogService)],b),e.CodeCacheCleaner=b}),define(te[181],ne([0,1,5,9,2,10,20,11,8,26]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(d,v,h){super();this.environmentService=d,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),v=JSON.parse(await i.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let E of Object.keys(v)){const f=v[E];d[`${f.hash}.${E}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(h))return;const p=await i.Promises.readdir(h);for(const E of p){if(d[E]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${E}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${E}`),await i.Promises.rm((0,L.join)(h,E))}const m=Date.now();for(const E of Object.keys(d)){const f=(0,L.join)(h,E),c=await i.Promises.readdir(f);for(const l of c){if(l==="tcf.json")continue;const s=(0,L.join)(f,l),a=await i.Promises.stat(s);a.isDirectory()&&m-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(E,l)}`),await i.Promises.rm(s))}}}catch(d){(0,_.onUnexpectedError)(d)}}};I=de([G(0,R.INativeEnvironmentService),G(1,w.ILogService),G(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[37],ne([0,1,100,15]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(i,R){T.ok(_.isString(i)),T.ok(_.isObject(R)),T.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,R)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new D}),define(te[87],ne([0,1,3,37]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,b){this.schemasById[D(w)]=b,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new L;_.Registry.add(e.Extensions.JSONContribution,i)}),define(te[42],ne([0,1,17,3,15,126,87,37]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=R.Registry.as(i.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new _.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new _.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,s=!0){this.registerConfigurations([l],s)}registerConfigurations(l,s=!0){const a=this.doRegisterConfigurations(l,s);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const s=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:l,remove:s}){const a=[];a.push(...this.doDeregisterConfigurations(s)),a.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(a)})}registerDefaultConfigurations(l){const s=[],a=[];for(const{overrides:n,source:t}of l)for(const r in n)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const o={...this.configurationDefaultsOverrides.get(r)?.value||{},...n[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:o});const u={type:"object",default:o,description:L.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:D.isString(t)?void 0:t};a.push(...h(r)),this.configurationProperties[r]=u,this.defaultLanguageConfigurationOverridesNode.properties[r]=u}else{this.configurationDefaultsOverrides.set(r,{value:n[r],source:t});const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const s=[];for(const{overrides:a,source:n}of l)for(const t in a){const r=this.configurationDefaultsOverrides.get(t),o=D.isString(n)?n:n?.id,u=D.isString(r?.source)?r?.source:r?.source?.id;if(o===u)if(s.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const g=this.configurationProperties[t];g&&(this.updatePropertyDefaultValue(t,g),this.updateSchema(t,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const s of l)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,s){const a=[];return l.forEach(n=>{a.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),a}doDeregisterConfigurations(l){const s=[],a=n=>{if(n.properties)for(const t in n.properties)s.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>a(t))};for(const n of l){a(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return s}validateAndRegisterProperties(l,s=!0,a,n,t=3){t=D.isUndefinedOrNull(l.scope)?t:l.scope;let r=[],o=l.properties;if(o)for(let g in o){if(s&&E(g)){delete o[g];continue}const S=o[g];if(S.source=a,S.defaultDefaultValue=o[g].default,this.updatePropertyDefaultValue(g,S),e.OVERRIDE_PROPERTY_REGEX.test(g)?S.scope=void 0:(S.scope=D.isUndefinedOrNull(S.scope)?t:S.scope,S.restricted=D.isUndefinedOrNull(S.restricted)?!!n?.includes(g):S.restricted),o[g].hasOwnProperty("included")&&!o[g].included){this.excludedConfigurationProperties[g]=o[g],delete o[g];continue}else this.configurationProperties[g]=o[g];!o[g].deprecationMessage&&o[g].markdownDeprecationMessage&&(o[g].deprecationMessage=o[g].markdownDeprecationMessage),r.push(g)}let u=l.allOf;if(u)for(let g of u)r.push(...this.validateAndRegisterProperties(g,s,a,n,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const s=a=>{let n=a.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let t=a.allOf;t&&t.forEach(s)};s(l)}updateSchema(l,s){switch(e.allSettings.properties[l]=s,s.scope){case 1:e.applicationSettings.properties[l]=s;break;case 2:e.machineSettings.properties[l]=s;break;case 6:e.machineOverridableSettings.properties[l]=s;break;case 3:e.windowSettings.properties[l]=s;break;case 4:e.resourceSettings.properties[l]=s;break;case 5:e.resourceSettings.properties[l]=s,this.resourceLanguageSettingsSchema.properties[l]=s;break}}removeFromSchema(l,s){switch(delete e.allSettings.properties[l],s.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const s=`[${l}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,s){const a=this.configurationDefaultsOverrides.get(l);let n=a?.value,t=a?.source;D.isUndefined(n)&&(n=s.defaultDefaultValue,t=void 0),D.isUndefined(n)&&(n=p(s.type)),s.default=n,s.defaultValueSource=t}}const d="\\[([^\\]]+)\\]",v=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=v.exec(c);for(;s?.length;){const a=s[1].trim();a&&l.push(a),s=v.exec(c)}}return(0,T.distinct)(l)}e.overrideIdentifiersFromKey=h;function y(c){return c.reduce((l,s)=>`${l}[${s}]`,"")}e.keyFromOverrideIdentifiers=y;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const m=new C;R.Registry.add(e.Extensions.Configuration,m);function E(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?L.localize(7,null,c):m.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):null:L.localize(6,null)}e.validateProperty=E;function f(){const c=[],l=m.getConfigurationProperties();for(const s of Object.keys(l))c.push([s,l[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(te[88],ne([0,1,17,3,31,2,40,28,15,7,21,42,37]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,I.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return T.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=R.deepClone(this.contents),r=R.deepClone(this.overrides),o=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const g of u.overrides){const[S]=r.filter(P=>T.equals(P.identifiers,g.identifiers));S?(this.mergeContents(S.contents,g.contents),S.keys.push(...g.keys),S.keys=T.distinct(S.keys)):r.push(R.deepClone(g))}for(const g of u.keys)o.indexOf(g)===-1&&o.push(g)}return new v(t,o,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o],g=t[o];g&&(typeof u=="object"&&typeof g=="object"?(u=R.deepClone(u),this.mergeContents(u,g)):u=g),r[o]=u}return new v(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&w.isObject(n[r])&&w.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=R.deepClone(t[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?R.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const o=u=>{u&&(r?this.mergeContents(r,u):r=R.deepClone(u))};for(const u of this.overrides)T.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(n={}){const t=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),o=Object.create(null),u=[];for(const g in t){const S=n[g],P=S!==void 0?S:t[g].default;(0,I.addToValueTree)(o,g,P,O=>console.error(`Conflict in default settings: ${O}`))}for(const g of Object.keys(o))C.OVERRIDE_PROPERTY_REGEX.test(g)&&u.push({identifiers:(0,C.overrideIdentifiersFromKey)(g),keys:Object.keys(o[g]),contents:(0,I.toValuesTree)(o[g],S=>console.error(`Conflict in default settings file: ${S}`))});super(o,r,u)}}e.DefaultConfigurationModel=h;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!w.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:o,overrides:u,restricted:g}=this.doParseRaw(n,t);this._configurationModel=new v(r,o,u),this._restrictedConfigurations=g||[]}doParseContent(n){let t={},r=null,o=[],u=[],g=[];function S(O){Array.isArray(o)?o.push(O):r!==null&&(o[r]=O)}let P={onObjectBegin:()=>{let O={};S(O),u.push(o),o=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let O=[];S(O),u.push(o),o=O,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:S,onError:(O,U,W)=>{g.push({error:O,offset:U,length:W})}};if(n)try{D.visit(n,P),t=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const r=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,t);n=o.raw;const u=(0,I.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),g=Object.keys(n),S=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:u,keys:g,overrides:S,restricted:o.restricted}}filter(n,t,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const u={},g=[];for(let S in n)if(C.OVERRIDE_PROPERTY_REGEX.test(S)&&r){const P=this.filter(n[S],t,!1,o);u[S]=P.raw,g.push(...P.restricted)}else{const P=t[S],O=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&g.push(S),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&(o.skipRestricted&&P?.restricted||(u[S]=n[S]))}return{raw:u,restricted:g}}toOverrides(n,t){const r=[];for(const o of Object.keys(n))if(C.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const g in n[o])u[g]=n[o][g];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,I.toValuesTree)(u,t)})}return r}}e.ConfigurationModelParser=y;class p extends L.Disposable{constructor(n,t,r,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(n,t,r=new v,o=new v,u=new i.ResourceMap,g=new v,S=new i.ResourceMap,P=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=g,this._memoryConfigurationByResource=S,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const o=this.getConsolidateConfigurationModel(t,r),u=this.getFolderConfigurationModelForResource(t.resource,r),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,S=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),U=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),W=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,k=t.overrideIdentifier?g.override(t.overrideIdentifier).getValue(n):g.getValue(n),z=o.getValue(n),A=T.distinct(T.flatten(o.overrides.map(F=>F.identifiers))).filter(F=>o.getOverrideValue(n,F)!==void 0);return{defaultValue:S,userValue:P,userLocalValue:O,userRemoteValue:U,workspaceValue:W,workspaceFolderValue:$,memoryValue:k,value:z,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:k!==void 0?{value:g.getValue(n),override:t.overrideIdentifier?g.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:A.length?A:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=l(this._defaultConfiguration,n),g=[...t,...r,...o];return g.length&&this.updateDefaultConfiguration(n),{keys:g,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=l(this.localUserConfiguration,n),g=[...t,...r,...o];return g.length&&this.updateLocalUserConfiguration(n),{keys:g,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=l(this.remoteUserConfiguration,n);let g=[...t,...r,...o];return g.length&&this.updateRemoteUserConfiguration(n),{keys:g,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=l(this.workspaceConfiguration,n);let g=[...t,...r,...o];return g.length&&this.updateWorkspaceConfiguration(n),{keys:g,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:o,updated:u,removed:g,overrides:S}=l(r,t);let P=[...o,...u,...g];return(P.length||!r)&&this.updateFolderConfiguration(n,t),{keys:P,overrides:S}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:u,overrides:g}=l(t,void 0);return{keys:[...r,...o,...u],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const u=this._memoryConfigurationByResource.get(n);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=r.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((g,S)=>(g.set(b.URI.revive(S[0]),this.parseConfigurationModel(S[1])),g),new i.ResourceMap);return new m(t,r,new v,o,u,new v,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function E(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const o of a)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,g])=>{const S=(0,i.getOrSet)(t,u,new Set);g.forEach(P=>S.add(P))});const r=[];return t.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=E;class f{constructor(n,t,r,o){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(S=>u.add(S)),n.overrides.forEach(([,S])=>S.forEach(P=>u.add(P))),this.affectedKeys=[...u.values()];const g=new v;this.affectedKeys.forEach(S=>g.setValue(S,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!R.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,I.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=f;class c extends f{constructor(n,t,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c;function l(a,n){const{added:t,removed:r,updated:o}=s(n,a),u=[],g=a?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const P=S.filter(O=>!g.includes(O));for(const O of P)u.push([O,n.getKeysForOverrideIdentifier(O)])}if(a){const P=g.filter(O=>!S.includes(O));for(const O of P)u.push([O,a.getKeysForOverrideIdentifier(O)])}if(n&&a){for(const P of g)if(S.includes(P)){const O=s({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});u.push([P,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:r,updated:o,overrides:u}}function s(a,n){const t=a?n?a.keys.filter(u=>n.keys.indexOf(u)===-1):[...a.keys]:[],r=n?a?n.keys.filter(u=>a.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(a&&n){for(const u of n.keys)if(a.keys.indexOf(u)!==-1){const g=(0,I.getConfigurationValue)(n.contents,u),S=(0,I.getConfigurationValue)(a.contents,u);R.equals(g,S)||o.push(u)}}return{added:t,removed:r,updated:o}}}),define(te[182],ne([0,1,5,3,2,18,21,88,42,37]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(d,v){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(()=>this.onDidDefaultConfigurationChange())),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,v){const h=typeof d=="string"?d:void 0,y=(0,i.isConfigurationOverrides)(d)?d:(0,i.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,y,void 0)}updateValue(d,v,h,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,v,1)}onDidDefaultConfigurationChange(){const d=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel);this.trigger(v,d,6)}trigger(d,v,h){const y=new R.ConfigurationChangeEvent(d,{data:v},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[183],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var _;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(_=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(i,R=_.Unknown,w){super(i);this._message=i,this._code=R,this._detail=w,this.isHandled=R===_.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(i){return i instanceof D&&i._code===_.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof D&&i._code===_.NoResolverFound}static isHandled(i){return i instanceof D&&i.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[184],ne([0,1,5,19,27,9,3,2,29,71,183]),function(J,e,T,_,D,L,i,R,w,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var d;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function v(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(M){const N=new D.CancellationTokenSource;return setTimeout(()=>N.cancel(),M),N.token}function y(M,N){if(M.isCancellationRequested||N.isCancellationRequested)return D.CancellationToken.Cancelled;const q=new D.CancellationTokenSource;return M.onCancellationRequested(()=>q.cancel()),N.onCancellationRequested(()=>q.cancel()),q.token}class p{constructor(N){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((q,x)=>{this._resolvePromise=q,this._rejectPromise=x}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function m(M,N){const q=new p(N);return q.registerDisposable(M.onControlMessage(x=>{const K=JSON.parse(x.toString()),ee=B(K);ee?q.reject(ee):q.resolve(K)})),q.promise}function E(M,N,q,x,K,ee,H){const X=new p(H);return N.connect(q,x,K,ee,(re,oe)=>{X.didTimeout?(re&&M.error(re),oe?.dispose()):re||!oe?X.reject(re):X.resolve(oe)}),X.promise}function f(M,N){const q=new p(N);return M.then(x=>{q.didTimeout||q.resolve(x)},x=>{q.didTimeout||q.reject(x)}),q.promise}async function c(M,N,q,x){const K=j(M,N);M.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await E(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,`renderer-${v(N)}-${M.reconnectionToken}`,x)}catch(le){throw M.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),M.logService.error(le),le}M.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let H,X;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(ee,null),H=M.reconnectionProtocol,X=!1):(H=new b.PersistentProtocol(ee,null),X=!0),M.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const re=await f(M.signService.createNewMessage((0,w.generateUuid)()),x),oe={type:"auth",auth:M.connectionToken||"00000000000000000000",data:re.data};H.sendControl(_.VSBuffer.fromString(JSON.stringify(oe)));try{const le=await m(H,y(x,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(M.logService.trace(`${K} 4/6. received SignRequest control message.`),!await f(M.signService.validate(re,le.signedData),x)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const be=await f(M.signService.sign(le.data),x),Ce={type:"connectionType",commit:M.commit,signedData:be,desiredConnectionType:N};return q&&(Ce.args=q),M.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(_.VSBuffer.fromString(JSON.stringify(Ce))),{protocol:H,ownsProtocol:X}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(M.logService.error(`${K} the handshake timed out. Error:`),M.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${K} received error control message when negotiating connection. Error:`),M.logService.error(le)),X&&F(H),le}}async function l(M,N,q,x){const K=Date.now(),ee=j(M,N),{protocol:H,ownsProtocol:X}=await c(M,N,q,x),re=new p(x);return re.registerDisposable(H.onControlMessage(oe=>{const le=JSON.parse(oe.toString()),he=B(le);he?(M.logService.error(`${ee} received error control message when negotiating connection. Error:`),M.logService.error(he),X&&F(H),re.reject(he)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${Q(K)}!`),re.resolve({protocol:H,firstMessage:le}))})),re.promise}async function s(M,N){const{protocol:q}=await l(M,1,void 0,N);return{protocol:q}}async function a(M,N,q){const{protocol:x,firstMessage:K}=await l(M,2,N,q),ee=K&&K.debugPort;return{protocol:x,debugPort:ee}}async function n(M,N,q){const x=Date.now(),K=j(M,3),{protocol:ee}=await c(M,3,N,q);return M.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${Q(x)}!`),ee}async function t(M,N,q){const{host:x,port:K,connectionToken:ee}=await M.addressProvider.getAddress();return{commit:M.commit,host:x,port:K,connectionToken:ee,reconnectionToken:N,reconnectionProtocol:q,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function r(M,N,q){try{const x=(0,w.generateUuid)(),K=await t(M,x,null),{protocol:ee}=await s(K,D.CancellationToken.None);return new z(M,N,q,x,ee)}catch(x){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(x),k.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(x)),x}}e.connectRemoteAgentManagement=r;async function o(M,N){try{const q=(0,w.generateUuid)(),x=await t(M,q,null),{protocol:K,debugPort:ee}=await a(x,N,D.CancellationToken.None);return new A(M,N,q,K,ee)}catch(q){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(q),k.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentExtensionHost=o;async function u(M,N,q){const x=await t(M,(0,w.generateUuid)(),null);return await n(x,{host:N,port:q},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function g(M){return(0,T.createCancelablePromise)(N=>new Promise((q,x)=>{const K=setTimeout(q,M*1e3);N.onCancellationRequested(()=>{clearTimeout(K),q()})}))}var S;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(S=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class P{constructor(N,q){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.type=0}}e.ConnectionLostEvent=P;class O{constructor(N,q,x,K){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.durationSeconds=x,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class U{constructor(N,q,x){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.attempt=x,this.type=2}}e.ReconnectionRunningEvent=U;class W{constructor(N,q,x){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.attempt=x,this.type=4}}e.ConnectionGainEvent=W;class ${constructor(N,q,x,K){this.reconnectionToken=N,this.millisSinceLastIncomingData=q,this.attempt=x,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class k extends R.Disposable{constructor(N,q,x,K){super();this._connectionType=N,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=q,this.reconnectionToken=x,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new W(this.reconnectionToken,0,0)),this._register(K.onSocketClose(ee=>{const H=V(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const ee=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${ee} received socket timeout event.`),this._beginReconnecting()})),k._instances.push(this),k._permanentFailure&&this._gotoPermanentFailure(k._permanentFailureMillisSinceLastIncomingData,k._permanentFailureAttempt,k._permanentFailureHandled)}static triggerPermanentFailure(N,q,x){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=q,this._permanentFailureHandled=x,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(N=>N._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(N=>N._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(k._permanentFailure)return;const N=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const K=x<q.length?q[x]:q[q.length-1];try{if(K>0){const H=g(K);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,H)),this._options.logService.info(`${N} waiting for ${K} seconds before reconnecting...`);try{await H}catch{}}if(k._permanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this._options.logService.info(`${N} resolving connection...`);const ee=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,h(C)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,L.isPromiseCanceledError)(ee)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,I.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!k._permanentFailure)}_gotoPermanentFailure(N,q,x){this._onDidStateChange.fire(new $(this.reconnectionToken,N,q,x)),F(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=k,k._permanentFailure=!1,k._permanentFailureMillisSinceLastIncomingData=0,k._permanentFailureAttempt=0,k._permanentFailureHandled=!1,k._instances=[];class z extends k{constructor(N,q,x,K,ee){super(1,N,K,ee);this.client=this._register(new b.Client(ee,{remoteAuthority:q,clientId:x},N.ipcLogger))}async _reconnect(N,q){await s(N,q)}}e.ManagementPersistentConnection=z;class A extends k{constructor(N,q,x,K,ee){super(2,N,x,K);this._startArguments=q,this.debugPort=ee}async _reconnect(N,q){await a(N,this._startArguments,q)}}e.ExtensionHostPersistentConnection=A;function F(M){try{M.acceptDisconnect();const N=M.getSocket();M.dispose(),N.dispose()}catch(N){(0,L.onUnexpectedError)(N)}}function B(M){if(M&&M.type==="error"){const N=new Error(`Connection error: ${M.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function Z(M,N){for(;M.length<N;)M+=" ";return M}function V(M,N,q){return`[remote-connection][${Z(v(M),13)}][${N.substr(0,5)}\u2026][${q?"reconnect":"initial"}]`}function j(M,N){return`${V(N,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function Q(M){return`${Date.now()-M} ms`}}),define(te[185],ne([0,1,16]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function _(b){return b.scheme===T.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=_;function D(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=D;function L(b){return b.scheme!==T.Schemas.file&&b.scheme!==T.Schemas.vscodeRemote}e.isVirtualResource=L;function i(b){if(b.folders.length)return b.folders.every(I=>L(I.uri))?b.folders[0].uri:void 0;if(b.configuration&&L(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=i;function R(b){return i(b)?.scheme}e.getVirtualWorkspaceScheme=R;function w(b){return i(b)!==void 0}e.isVirtualWorkspace=w}),define(te[89],ne([0,1,25,6,185]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=L;function i(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class w{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,h){if(typeof v=="undefined"||v===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){let y=typeof v=="string"?v:v.value,p=typeof h=="string"?h:h.value;return T.equalsIgnoreCase(y,p)}return v._lower===h._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=w;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(d,v){if(v){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(v)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,_.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[35],ne([0,1,25,89]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,y){return h.uuid&&y.uuid?h.uuid===y.uuid:h.id===y.id?!0:(0,T.compareIgnoreCase)(h.id,y.id)===0}e.areSameExtensions=D;class L{constructor(y,p){this.version=p,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof L?D(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=L;function i(h,y){return`${h}.${y}`}e.getExtensionId=i;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function w(h,y){return R(i(h,y))}e.getGalleryExtensionId=w;function b(h,y){const p=[],m=E=>{for(const f of p)if(f.some(c=>D(y(c),y(E))))return f;return null};for(const E of h){const f=m(E);f?f.push(E):p.push([E])}return p}e.groupByExtension=b;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function C(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function d(h){const y=new Set;if(h.malicious)for(const p of h.malicious)y.add(p.id);return y}e.getMaliciousExtensionsSet=d;function v(h,y){const p=[],m=y.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const E=m.shift();if(E&&p.every(f=>!D(f.identifier,{id:E}))){const f=h.filter(c=>D(c.identifier,{id:E}));f.length===1&&(p.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=v}),define(te[186],ne([0,1,5,9,2,4,18,61,7,29,20,11,30,35,14,8]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends D.Disposable{constructor(f,c,l,s){super();this.fileService=c,this.extensionGalleryService=l,this.logService=s,this.extensionsDownloadDir=w.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,c){await this.cleanUpPromise;const l=this.getName(f),s=(0,i.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(s)){const a=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(f,a,c);try{await this.rename(a,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return s}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,c,l){try{await I.Promises.rename(f.fsPath,c.fsPath)}catch(s){if(L.isWindows&&s&&s.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${f} to ${c} with 'EPERM' error. Trying again...`),this.rename(f,c,l);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const c=[],l=[];for(const n of f.children){const t=this.parse(n.name);t&&l.push([t,n])}const s=(0,v.groupByExtension)(l,([n])=>n),a=[];for(const n of s)n.sort((t,r)=>R.rcompare(t[0].version,r[0].version)),c.push(...n.slice(1).map(t=>t[1].resource)),a.push(n[0][1]);a.sort((n,t)=>n.mtime-t.mtime),c.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new v.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(f){const c=p.exec(f);return c&&c[1]&&c[2]?new v.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};m=de([G(0,C.INativeEnvironmentService),G(1,h.IFileService),G(2,d.IExtensionGalleryService),G(3,y.ILogService)],m),e.ExtensionsDownloader=m}),define(te[187],ne([0,1,2,10,20,89]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends T.Disposable{constructor(w,b){super();this.environmentService=w,this.extensionsManifestCache=(0,_.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(w){w.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[188],ne([0,1,81,17,5,2,16,10,20,11,30,35,59,8]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends L.Disposable{constructor(m,E,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new y(E,f)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),E=["en",...Object.keys(m)];return(0,_.distinct)(E)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const E=await this.cache.getLanguagePacks();Object.keys(E).some(f=>E[f]&&E[f].extensions.some(c=>(0,C.areSameExtensions)(c.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(E);return!(0,_.equals)(Object.keys(m),Object.keys(f))}};h=de([G(0,I.IExtensionManagementService),G(1,b.INativeEnvironmentService),G(2,v.ILogService)],h),e.LocalizationsService=h;let y=class extends L.Disposable{constructor(m,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(E=>{Object.keys(E).forEach(f=>delete E[f]),this.createLanguagePacksFromExtensions(E,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...E){for(const f of E)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,E){const f=E.identifier,c=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const l of c)if(E.location.scheme===i.Schemas.file&&(0,d.isValidLocalization)(l)){let s=m[l.languageId];s||(s={hash:"",extensions:[],translations:{}},m[l.languageId]=s);let a=s.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,f))[0];a?a.version=E.manifest.version:s.extensions.push({extensionIdentifier:f,version:E.manifest.version});for(const n of l.translations)s.translations[n.id]=(0,R.join)(E.location.fsPath,n.path)}}updateHash(m){if(m){const E=(0,T.createHash)("md5");for(const f of m.extensions)E.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=E.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(c){return{}}}).then(f=>(E=m(f),f)).then(f=>{for(const l of Object.keys(f))f[l]||delete f[l];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),w.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>E,f=>this.logService.error(f))})}};y=de([G(0,b.INativeEnvironmentService),G(1,v.ILogService)],y)}),define(te[189],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,T.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=C;function d(h,y){return y?y!==1&&h<1024:!_.isWindows&&h<1024}e.isPortPrivileged=d;let v=class{constructor(y){this.logService=y,this._onTunnelOpened=new T.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new T.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new T.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,p){return this._tunnelProvider=y,y?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],p=Array.from(this._tunnels.values());for(let m of p){const E=Array.from(m.values());for(let f of E){const c=await f.value;c&&y.push(c)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:p}of y.values())await p.then(m=>m?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,p,m,E,f=!1,c=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${m} on local port ${E}.`),!y)return;p||(p="localhost");const s=this.retainOrCreateTunnel(y,p,m,E,f,c,l);return s?s.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(a);return(a.tunnelRemoteHost!==p||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const p=this._tunnels.get(y.tunnelRemoteHost);if(p){const m=p.get(y.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,m))}}}}async tryDisposeTunnel(y,p,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${p}.`);const E=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(p),E}}async closeTunnel(y,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${p} `);const m=this._tunnels.get(y);if(m&&m.has(p)){const E=m.get(p);E.refcount=0,await this.tryDisposeTunnel(y,p,E)}}addTunnelToMap(y,p,m){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(p,{refcount:1,value:m})}async removeEmptyTunnelFromMap(y,p){const m=this._tunnels.get(y);m&&(await m.get(p)||m.delete(p),m.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,p){let m=[y];I(y)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):C(y)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const E=m.map(f=>this._tunnels.get(f));for(const f of E){const c=f?.get(p);if(c)return c}}canTunnel(y){return!!b(y)}createWithProvider(y,p,m,E,f,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${m} on local port ${E}.`);const a={elevationRequired:f?d(E===void 0?m:E):!1},n={remoteAddress:{host:p,port:m},localAddressPort:E,privacy:c,public:c!==R.Private,protocol:l},t=y.forwardPort(n,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(p,m,t),t}};v=de([G(0,L.ILogService)],v),e.AbstractTunnelService=v}),define(te[190],ne([0,1,8,62,2,9,5]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let w=class Et extends D.Disposable{constructor(I,C){super();this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(I,C,d,v,h,y){const p=new R,m=await Promise.resolve(this._tunnelService.openTunnel(I,p,d,v,h,y));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${v} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),p.dispose(),await m.dispose(),(0,L.canceled)();return p.setTunnel(m),this._tunnels.set(C,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${m.localAddress} (local) to ${d}:${v} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,C){const d=this._tunnels.get(I);!d||d.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};w._lastId=0,w=de([G(0,_.ISharedTunnelsService),G(1,T.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[191],ne([0,1,120,21,8]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(R,w){this.configurationService=R,this.logService=w}request(R,w){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,T.request)(R,w)}async resolveProxy(R){}};L=de([G(0,_.IConfigurationService),G(1,D.ILogService)],L),e.RequestService=L}),define(te[43],ne([0,1,19,141,42,6,37]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function w(h){return h.res.statusCode===204}async function b(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,T.streamToBuffer)(h.stream)).toString()}e.asText=b;async function I(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const p=(await(0,T.streamToBuffer)(h.stream)).toString();try{return JSON.parse(p)}catch(m){throw m.message+=`:
`+p,m}}e.asJson=I;function C(h){v(h)}e.updateProxyConfigurationsScope=C;let d;function v(h){const y=i.Registry.as(D.Extensions.Configuration),p=d;d={id:"http",order:15,title:(0,_.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(4,null),(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null)],default:"override",description:(0,_.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[d],remove:p?[p]:[]})}v(2)}),define(te[192],ne([0,1,27,16,14,43]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(w,b){this.requestService=w,this.fileService=b}async download(w,b,I=T.CancellationToken.None){if(w.scheme===_.Schemas.file||w.scheme===_.Schemas.vscodeRemote){await this.fileService.copy(w,b);return}const C={type:"GET",url:w.toString()},d=await this.requestService.request(C,I);if(d.res.statusCode===200)await this.fileService.writeFile(b,d.stream);else{const v=await(0,L.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${v}`)}}};i=de([G(0,L.IRequestService),G(1,D.IFileService)],i),e.DownloadService=i}),define(te[193],ne([0,1,17,27,66,2,18,155,14,8,26,43]),function(J,e,T,_,D,L,i,R,w,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends L.Disposable{constructor(h,y,p,m){super();this.fileService=h,this.productService=y,this.requestService=p,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:E})=>this.allConfigBasedTips.set(E.configPath,E))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const y=[];for(const[p,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const E=await this.fileService.readFile((0,i.joinPath)(h,p)),f=new Map;(0,D.forEach)(m.recommendations,({key:l,value:s})=>{if((0,T.isNonEmptyArray)(s.remotes))for(const a of s.remotes)f.set(a,{extensionId:l,extensionName:s.name,configName:m.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack});else y.push({extensionId:l,extensionName:s.name,configName:m.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack})});const c=(0,R.getDomainsOfRemotes)(E.value.toString(),[...f.keys()]);for(const l of c){const s=f.get(l);s&&y.push(s)}}catch(E){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},_.CancellationToken.None);if(h.res.statusCode!==200)return[];const y=await(0,C.asJson)(h);return y?y.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([G(0,w.IFileService),G(1,I.IProductService),G(2,C.IRequestService),G(3,b.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,i,R){let w=R&&R.get("storage.serviceMachineId",0)||null;if(w)return w;try{const I=(await i.readFile(L.serviceMachineIdResource)).value.toString();w=(0,_.isUUID)(I)?I:null}catch(b){w=null}if(!w){w=(0,_.generateUuid)();try{await i.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(w))}catch(b){}}return R&&R.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(te[90],ne([0,1,105,6]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(L){return(0,T.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,_.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[194],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var T;(function(_){_.Spawn="vscode:shared-process->shared-process-worker=spawn",_.Terminate="vscode:shared-process->shared-process-worker=terminate",_.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",_.Ready="vscode:shared-process-worker->shared-process=ready",_.Ack="vscode:shared-process-worker->shared-process=ack",_.Trace="vscode:shared-process-worker->shared-process=trace",_.Info="vscode:shared-process-worker->shared-process=info",_.Warn="vscode:shared-process-worker->shared-process=warn",_.Error="vscode:shared-process-worker->shared-process=error"})(T=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[195],ne([0,1,72,153,5,27,3,2,16,4,29,11,8,26,90,194]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(f,c,l){this.logService=f,this.productService=c,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(f){const c=`window: ${f.reply.windowId}, moduleId: ${f.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${c})`);const l=(0,h.hash)(f);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.doDisposeWorker(f));const s=new L.CancellationTokenSource;let a,n,t;this.processeDisposables.set(l,g=>{s.dispose(!0),a?.terminate(f,L.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(l);const S=this.processResolvers.get(l);S&&(this.processResolvers.delete(l),S({reason:g}))}),a=await this.getOrCreateWebWorker(f);const r=new Promise(g=>{this.processResolvers.set(l,g)});if(s.token.isCancellationRequested)return r;const{port1:o,port2:u}=new MessageChannel;return n=o,t=u,await a.spawn(f,t,s.token),s.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${c})`),T.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",f,[n])),r}getOrCreateWebWorker(f){let c=this.workers.get(f.process.moduleId);if(!c){this.logService.trace(`SharedProcess: creating new web worker (${f.process.moduleId})`);const l=new m(f.process.type,this.logService,this.productService,this.environmentService);c=l.init(),l.onDidProcessSelfTerminate(({configuration:s,reason:a})=>{this.doDisposeWorker(s,a)}),this.workers.set(f.process.moduleId,c)}return c}async disposeWorker(f){return this.doDisposeWorker(f)}doDisposeWorker(f,c){const l=this.processeDisposables.get((0,h.hash)(f));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${f.reply.windowId}, moduleId: ${f.process.moduleId})`),l(c))}};p=de([G(0,d.ILogService),G(1,v.IProductService),G(2,C.INativeEnvironmentService)],p),e.SharedProcessWorkerService=p;class m extends R.Disposable{constructor(f,c,l,s){super();this.type=f,this.logService=c,this.productService=l,this.environmentService=s,this._onDidProcessSelfTerminate=this._register(new i.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const f=new D.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},c.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},c.onmessage=l=>{const{id:s,message:a,configuration:n,nonce:t}=l.data;switch(s){case y.SharedProcessWorkerMessages.Ready:f.complete(c);break;case y.SharedProcessWorkerMessages.Ack:if(t){const r=this.mapMessageNonceToPendingMessageResolve.get(t);r&&(this.mapMessageNonceToPendingMessageResolve.delete(t),r())}break;case y.SharedProcessWorkerMessages.SelfTerminated:n&&a&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(a)});break;case y.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case y.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),f.p}async send(f,c,l){const s=await this.workerReady;if(!c.isCancellationRequested)return new Promise(a=>{const n=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,a);const t={...f,nonce:n};l?s.postMessage(t,[l]):s.postMessage(t),c.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&a()})})}spawn(f,c,l){const s={id:y.SharedProcessWorkerMessages.Spawn,configuration:f,environment:this.getSharedProcessWorkerEnvironment()};return this.send(s,l,c)}getSharedProcessWorkerEnvironment(){const f={bootstrapPath:w.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(b.isLinux){const c={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],s=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&s&&l&&(0,I.isUUID)(l)){const t=s["linux-x64"];c.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),c.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;f.env.BREAKPAD_DUMP_LOCATION=(0,_.join)(n,this.type),f.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(c)}return f}terminate(f,c){const l={id:y.SharedProcessWorkerMessages.Terminate,configuration:f};return this.send(l,c)}}}),define(te[91],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,T.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[196],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class T{constructor(){this.validators=new Map}vsda(){return new Promise((D,L)=>J(["vsda"],D,L))}async createNewMessage(D){try{const L=await this.vsda(),i=new L.validator;if(i){const R=String(T._nextId++);return this.validators.set(R,i),{id:R,data:i.createNewMessage(D)}}}catch(L){}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const i=this.validators.get(D.id);if(!i)return!1;this.validators.delete(D.id);try{return i.validate(L)==="ok"}catch(R){return!1}}async sign(D){try{const L=await this.vsda(),i=new L.signer;if(i)return i.sign(D)}catch(L){}return D}}e.SignService=T,T._nextId=1}),define(te[23],ne([0,1,5,3,2,178,15,73,6]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var I;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class v extends D.Disposable{constructor(m={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new _.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new _.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new _.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,E){E===b?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:E,target:this.getKeyTargets(m)[E]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,E,f){return this.getStorage(E)?.get(m,f)}getBoolean(m,E,f){return this.getStorage(E)?.getBoolean(m,f)}getNumber(m,E,f){return this.getStorage(E)?.getNumber(m,f)}store(m,E,f,c){if((0,i.isUndefinedOrNull)(E)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,c),this.getStorage(f)?.set(m,E)})}remove(m,E){this.withPausedEmitters(()=>{this.updateKeyTarget(m,E,void 0),this.getStorage(E)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,E){const f=[],c=this.getKeyTargets(m);for(const l of Object.keys(c))c[l]===E&&f.push(l);return f}updateKeyTarget(m,E,f){const c=this.getKeyTargets(E);typeof f=="number"?c[m]!==f&&(c[m]=f,this.getStorage(E)?.set(b,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(E)?.set(b,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const E=this.get(b,m);if(E)try{return JSON.parse(E)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const E=this.getStorage(0),f=this.getStorage(1);switch(m){case I.NONE:await T.Promises.settled([E?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await T.Promises.settled([E?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return y(m,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends v{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function y(p,m,E,f){const c=o=>{try{return JSON.parse(o)}catch(u){return o}},l=new Map,s=new Map;p.forEach((o,u)=>{l.set(u,o),s.set(u,c(o))});const a=new Map,n=new Map;m.forEach((o,u)=>{a.set(u,o),n.set(u,c(o))}),console.group(`Storage: Global (path: ${E})`);let t=[];l.forEach((o,u)=>{t.push({key:u,value:o})}),console.table(t),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${f})`);let r=[];a.forEach((o,u)=>{r.push({key:u,value:o})}),console.table(r),console.groupEnd(),console.log(n)}e.logStorage=y}),define(te[197],ne([0,1,3,2,15,30,35,23]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends _.Disposable{constructor(C,d){super();this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(d.onDidInstallExtensions(v=>v.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(C,d){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:d}),!0):!1}async disableExtension(C,d){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let d=this.getDisabledExtensions();return d.every(v=>!(0,i.areSameExtensions)(v,C))?(d.push(C),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(C){let d=this.getDisabledExtensions();for(let v=0;v<d.length;v++){const h=d[v];if((0,i.areSameExtensions)(h,C))return d.splice(v,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(C){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,d){this.storageManger.set(C,d,0)}};w=de([G(0,R.IStorageService),G(1,L.IExtensionManagementService)],w),e.GlobalExtensionEnablementService=w;class b extends _.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(C,d){let v;return d===0?((0,D.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,d)),v=this.storage[C]):v=this._get(C,d),JSON.parse(v)}set(C,d,v){let h=JSON.stringify(d.map(({id:p,uuid:m})=>({id:p,uuid:m})));this._get(C,v)!==h&&(v===0&&(d.length?this.storage[C]=h:delete this.storage[C]),this._set(C,d.length?h:void 0,v))}onDidStorageChange(C){if(C.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const v=this.get(C.key,C.scope);delete this.storage[C.key];const h=this.get(C.key,C.scope),y=v.filter(m=>!h.some(E=>(0,i.areSameExtensions)(m,E))),p=h.filter(m=>!v.some(E=>(0,i.areSameExtensions)(E,m)));(y.length||p.length)&&this._onDidChange.fire([...y,...p])}}_get(C,d){return this.storageService.get(C,d,"[]")}_set(C,d,v){d?this.storageService.store(C,d,v,1):this.storageService.remove(C,v)}}e.StorageManager=b}),define(te[198],ne([0,1,3,2]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends _.Disposable{constructor(b,I){super();this.channel=b,this.workspace=I}async getItems(){const b={workspace:this.workspace},I=await this.channel.call("getItems",b);return new Map(I)}updateItems(b){const I={workspace:this.workspace};return b.insert&&(I.insert=Array.from(b.insert.entries())),b.delete&&(I.delete=Array.from(b.delete.values())),this.channel.call("updateItems",I)}}class L extends D{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new T.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class i extends D{constructor(b,I){super(b,I);this.onDidChangeItemsExternal=T.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class R extends _.Disposable{constructor(b,I){super();this.channel=b,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[199],ne([0,1,5,2,18,73,23,198]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends i.AbstractStorageService{constructor(I,C,d){super();this.mainProcessService=C,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new _.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new L.Storage(I.globalStorage);return this._register(C.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),C}createWorkspaceStorage(I){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(C.workspaceStorage){const d=new L.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(v=>this.emitDidChangeValue(1,v)),this.workspaceStorageId=I?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await T.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await T.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const C=this.workspaceStorage,d=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[v,h]of d)this.workspaceStorage.set(v,h)}}e.NativeStorageService=w}),define(te[200],ne([0,1,4,32,7,29]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(b){if(T.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function R(b,I,C,d,v,h,y,p,m,E){const f=Object.create(null);f["common.machineId"]=y,f.sessionID=(0,L.generateUuid)()+Date.now(),f.commitHash=v,f.version=h,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=_.platform,f["common.nodeArch"]=d,f["common.product"]=E||"desktop";const c=w(p||[]);c&&(f["common.msftInternal"]=c);let l=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const a=i(C);a&&(f["common.platformDetail"]=a);try{const n=await b.readFile(D.URI.file(m));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=R;function w(b){const I=_.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return b.some(d=>C===d)}e.verifyMicrosoftInternalDomain=w}),define(te[22],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var _;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(_=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[201],ne([0,1,33,56,5,31,16,10,4,7,113,20,116,78,14,26,22]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(s,a){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,r=new Map,o=2e4;function u(P,O,U,W){const $=O.substring(P.length+1);return D.Promises.withAsyncBody(async k=>{let z;try{z=await C.Promises.readdir(O,{withFileTypes:!0})}catch(B){k();return}if(W.count>=o){W.count+=z.length,W.maxReached=!0,k();return}let A=z.length;if(A===0){k();return}let F=z;W.count+z.length>o&&(W.maxReached=!0,A=o-W.count,F=z.slice(0,A)),W.count+=z.length;for(const B of F)if(B.isDirectory()){if(U.includes(B.name)||await u(P,(0,R.join)(O,B.name),U,W),--A==0){k();return}}else{const Z=B.name.lastIndexOf(".");if(Z>=0){const V=B.name.substring(Z+1);V&&t.set(V,(t.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test($)!==!1&&V.filePattern.test(B.name)&&r.set(V.tag,(r.get(V.tag)??0)+1);if(--A==0){k();return}}})}const g={count:0,maxReached:!1};await u(s,s,a,g);const S=await c(s);return{configFiles:E(r),fileTypes:E(t),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:S}}e.collectWorkspaceStats=m;function E(s){return[..._.Iterable.map(s.entries(),([a,n])=>({name:a,count:n}))].sort((a,n)=>n.count-a.count)}function f(){const s={os:`${T.type()} ${T.arch()} ${T.release()}`,memory:`${(T.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},a=T.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.getMachineInfo=f;async function c(s){try{const a=new Map,n=(0,R.join)(s,".vscode","launch.json"),t=await C.Promises.readFile(n),r=[],o=(0,L.parse)(t.toString(),r);if(r.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const g=u.type;g&&(a.has(g)?a.set(g,a.get(g)+1):a.set(g,1))}return E(a)}catch(a){return[]}}e.collectLaunchConfigs=c;let l=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${T.type()} ${T.arch()} ${T.release()}`);const t=T.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(T.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||n.push(`Load (avg):       ${T.loadavg().map(r=>Math.round(r)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,d.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[r,o]=t,u=this.formatProcessList(a,r);return n.forEach(g=>{if((0,v.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,o+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(a,g.processes)}`),g.workspaceMetadata){o+=`
|  Remote: ${g.hostName}`;for(const S of Object.keys(g.workspaceMetadata)){const P=g.workspaceMetadata[S];let O=`${P.fileCount} files`;P.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${S}): ${O}`,o+=this.formatWorkspaceStats(P)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(a,n){const{memory:t,vmHint:r,os:o,cpus:u}=f(),g={os:o,memory:t,cpus:u,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return w.isWindows||(g.load=`${T.loadavg().map(S=>Math.round(S)).join(", ")}`),w.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(a,n){const t=[];return(0,d.listProcesses)(a.mainPID).then(async r=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),n.forEach(o=>{if((0,v.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const g=o.workspaceMetadata[u];let S=`${g.fileCount} files`;g.maxFilesReached&&(S=`more than ${S}`),t.push(`Folder (${u}): ${S}`),t.push(this.formatWorkspaceStats(g))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const n=[],t=60;let r=0;const o=(P,O)=>{const U=` ${P}(${O})`;r+U.length>t?(n.push(u),u="|                 ",r=u.length):r+=U.length,u+=U};let u="|      File types:";const g=10;let S=a.fileTypes.length>g?g:a.fileTypes.length;for(let P=0;P<S;P++){const O=a.fileTypes[P];o(O.name,O.count)}if(n.push(u),a.configFiles.length>=0&&(u="|      Conf files:",r=0,a.configFiles.forEach(P=>{o(P.name,P.count)}),n.push(u)),a.launchConfigFiles.length>0){let P="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{P+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(P)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],t=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(n.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const u=b.URI.revive(o);if(u.scheme===i.Schemas.file){const g=u.fsPath;t.push(m(g,["node_modules",".git"]).then(S=>{let P=`${S.fileCount} files`;S.maxFilesReached&&(P=`more than ${P}`),n.push(`|    Folder (${(0,R.basename)(g)}): ${P}`),n.push(this.formatWorkspaceStats(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${g} (${S.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(r=>n.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(a,n){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,t,r,n,0),r.join(`
`)}formatProcessItem(a,n,t,r,o){const u=o===0;let g;u?g=r.pid===a?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(g=`${g} (${n.get(r.pid)})`));const S=process.platform==="win32"?r.mem:T.totalmem()*(r.mem/100);t.push(`${r.load.toFixed(0).padStart(5," ")}	${(S/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(r.children)&&r.children.forEach(P=>this.formatProcessItem(a,n,t,P,o+1))}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const t=b.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const r=t.fsPath;try{const o=await m(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=de([G(0,p.ITelemetryService),G(1,y.IProductService)],l),e.DiagnosticsService=l}),define(te[202],ne([0,1,17,5,27,9,3,2,4,15,7,130,30,35,8,26,22]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(a,n,t,r){super();this.galleryService=a,this.telemetryService=n,this.logService=t,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const n=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,d.isTargetPlatformCompatible)(t,a.allTargetPlatforms,n))}async installFromGallery(a,n={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(C.localize(0,null),d.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw c(this.telemetryService,"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),f(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const n=await this.getInstalled(1);for(const[t,r]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=n.find(S=>(0,v.areSameExtensions)(S.identifier,{id:t}));if(!o)continue;const u=await this.galleryService.getCompatibleExtension({id:r.id},!0,await this.getTargetPlatform());if(!u){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${r.id}' extension is not found`);continue}const g=await this.galleryService.getManifest(u,D.CancellationToken.None);if(!g){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${r.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${r.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(g,u,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${r.id}' extension.`)}catch(S){this.logService.error(S)}}}catch(a){this.logService.error(a)}}async uninstall(a,n={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,n)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const n=await this.findGalleryExtension(a);if(!n)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,n,t){if(!I.URI.isUri(n)){let S=this.installingExtensions.get(new v.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(S)return this.logService.info("Extensions is already requested to install",n.identifier.id),S.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],o=[],u=this.createInstallExtensionTask(a,n,t);I.URI.isUri(n)||this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:n}),this.logService.info("Installing extension:",u.identifier.id),r.push({task:u,manifest:a});let g=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:O,manifest:U}of P)if(g=g||!!U.extensionDependencies?.some(W=>(0,v.areSameExtensions)({id:W},u.identifier)),this.installingExtensions.has(new v.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const W=this.createInstallExtensionTask(U,O,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new v.ExtensionIdentifierWithVersion(W.identifier,U.version).key(),W),this._onInstallExtension.fire({identifier:W.identifier,source:O}),this.logService.info("Installing extension:",W.identifier.id),r.push({task:W,manifest:U})}}catch(P){if(I.URI.isUri(u.source))(0,T.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,P.message),(0,T.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),P}const S=r.reduce((P,{task:O,manifest:U})=>(P.set(O.identifier.id.toLowerCase(),{task:O,manifest:U}),P),new Map);for(;S.size;){let P;const O=[...S.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(W=>S.has(W.toLowerCase())));O.length?P=S.size===1?O:O.filter(({task:U})=>!(U===u&&!g)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:U})=>U.identifier.id)),P=[...S.values()]),await this.joinAllSettled(P.map(async({task:U})=>{const W=new Date().getTime(),$=(0,b.isUndefined)(t.operation)?U.operation:t.operation;try{const k=await U.run();if(await this.joinAllSettled(this.participants.map(z=>z.postInstall(k,U.source,t,D.CancellationToken.None))),!I.URI.isUri(U.source)&&(c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(U.source),new Date().getTime()-W,void 0),w.isWeb&&$!==3))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch(z){}o.push({local:k,identifier:U.identifier,operation:$,source:U.source})}catch(k){throw I.URI.isUri(U.source)||c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,v.getGalleryExtensionTelemetryData)(U.source),new Date().getTime()-W,k),this.logService.error("Error while installing the extension:",U.identifier.id),k}finally{S.delete(U.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:P})=>(0,v.areSameExtensions)(P,u.identifier))[0].local}catch(S){if(r.forEach(({task:P})=>P.cancel()),o.length)try{const P=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<P.length;O++){const U=P[O],{identifier:W}=o[O];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",W.id):this.logService.warn("Rollback: Error while uninstalling extension",W.id,(0,L.getErrorMessage)(U.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(P),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(r.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),S}finally{for(const{task:S,manifest:P}of r)if(!I.URI.isUri(S.source)){const O=new v.ExtensionIdentifierWithVersion(S.identifier,P.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(a){const n=[],t=[],r=await Promise.allSettled(a);for(const o of r)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw E(t);return n}async getAllDepsAndPackExtensionsToInstall(a,n,t,r){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const u=[a,...o.map(P=>P.identifier)],g=[],S=async(P,O)=>{const U=O.extensionDependencies||[],W=[...U];if(O.extensionPack){const $=t?o.find(k=>(0,v.areSameExtensions)(k.identifier,P)):void 0;for(const k of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(z=>(0,v.areSameExtensions)({id:z},{id:k}))||W.every(z=>!(0,v.areSameExtensions)({id:z},{id:k}))&&W.push(k)}if(W.length){const $=[...u,...g.map(z=>z.gallery.identifier)],k=W.filter(z=>$.every(A=>!(0,v.areSameExtensions)(A,{id:z})));if(k.length){const z=await this.galleryService.query({names:k,pageSize:W.length},D.CancellationToken.None);for(const A of z.firstPage){if($.find(Z=>(0,v.areSameExtensions)(Z,A.identifier)))continue;const F=U.some(Z=>(0,v.areSameExtensions)({id:Z},A.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(A,!0,r)}catch(Z){if(Z instanceof d.ExtensionManagementError&&Z.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!F){this.logService.info("Skipping the packed extension as it cannot be installed",A.identifier.id);continue}else throw Z}g.push({gallery:B.extension,manifest:B.manifest}),await S(B.extension.identifier,O)}}}};return await S(a,n),o=await this.getInstalled(),g.filter(P=>!o.some(O=>(0,v.areSameExtensions)(O.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(a,n,t){const r=await this.getExtensionsControlManifest();if((0,v.getMaliciousExtensionsSet)(r).has(a.identifier.id))throw new d.ExtensionManagementError(C.localize(3,null,a.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[a.identifier.id])throw new d.ExtensionManagementError(C.localize(4,null,a.identifier.id,r.unsupportedPreReleaseExtensions[a.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const g=await this.getTargetPlatform();throw new d.ExtensionManagementError(C.localize(5,null,a.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(g)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,n,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(C.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new d.ExtensionManagementError(C.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);const u=await this.galleryService.getManifest(o,D.CancellationToken.None);if(u===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new d.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async getCompatibleVersion(a,n,t){const r=await this.getTargetPlatform();let o=null;return n&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,r)),!o&&await this.galleryService.isExtensionCompatible(a,t,r)&&(o=a),!o&&n&&(o=await this.galleryService.getCompatibleExtension(a,t,r)),o}async unininstallExtension(a,n){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const r=(S,P)=>{const O=this.createUninstallExtensionTask(S,P);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),O},o=(S,P)=>{P?this.logService.error("Failed to uninstall extension:",S.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),c(this.telemetryService,"extensionGallery:uninstall",(0,v.getLocalExtensionTelemetryData)(S),void 0,P),this._onDidUninstallExtension.fire({identifier:S.identifier,error:P?.code})},u=[],g=[];try{u.push(r(a,{}));const S=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(a,S);for(const O of P)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):u.push(r(O,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(P=>P.extension),S,a),await this.joinAllSettled(u.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(P.extension,n,D.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch(O){}o(P.extension)}catch(O){const U=O instanceof d.ExtensionManagementError?O:new d.ExtensionManagementError((0,L.getErrorMessage)(O),d.ExtensionManagementErrorCode.Internal);throw o(P.extension,U),U}finally{g.push(P)}}))}catch(S){const P=S instanceof d.ExtensionManagementError?S:new d.ExtensionManagementError((0,L.getErrorMessage)(S),d.ExtensionManagementErrorCode.Internal);for(const O of u){try{O.cancel()}catch(U){}g.includes(O)||o(O.extension,P)}throw P}finally{for(const S of u)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(a,n,t){for(const r of a){const o=this.getDependents(r,n);if(o.length){const u=o.filter(g=>!a.some(S=>(0,v.areSameExtensions)(S.identifier,g.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(r,u,t))}}}getDependentsErrorMessage(a,n,t){return t===a?n.length===1?C.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?C.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):C.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?C.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?C.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):C.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(a,n,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const r=a.manifest.extensionPack?a.manifest.extensionPack:[];if(r.length){const o=n.filter(g=>!g.isBuiltin&&r.some(S=>(0,v.areSameExtensions)({id:S},g.identifier))),u=[];for(const g of o)u.push(...this.getAllPackExtensionsToUninstall(g,n,t));return[...o,...u]}return[]}getDependents(a,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,v.areSameExtensions)({id:r},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const n=await this.findGalleryExtensionById(a.identifier.uuid);return n||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=de([G(0,d.IExtensionGalleryService),G(1,p.ITelemetryService),G(2,h.ILogService),G(3,y.IProductService)],m),e.AbstractExtensionManagementService=m;function E(s){const a=Array.isArray(s)?s:[s];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=E;function f(s){if(s instanceof d.ExtensionManagementError)return s;const a=new d.ExtensionManagementError(s.message,d.ExtensionManagementErrorCode.Internal);return a.stack=s.stack,a}function c(s,a,n,t,r){const o=r?r instanceof d.ExtensionManagementError?r.code:d.ExtensionManagementErrorCode.Internal:void 0;s.publicLogError(a,{...n,success:!r,duration:t,errorcode:o})}e.reportTelemetry=c;class l{constructor(){this.barrier=new _.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>new Promise((n,t)=>{const r=a.onCancellationRequested(()=>{r.dispose(),t((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(te[203],ne([0,1,17,5,66,3,10,4,32,7,132,11,30,193,80,14,8,60,26,43,23,22]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const s="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends v.ExtensionTipsService{constructor(r,o,u,g,S,P,O,U,W,$){super(O,U,W,$);this.environmentService=r,this.telemetryService=o,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=S,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,D.forEach)(U.exeBasedExtensionTips,({key:k,value:z})=>{const A=[],F=[],B=[];(0,D.forEach)(z.recommendations,({key:Z,value:V})=>{V.important?z.important?A.push({extensionId:Z,extensionName:V.name,isExtensionPack:!!V.isExtensionPack}):F.push({extensionId:Z,extensionName:V.name,isExtensionPack:!!V.isExtensionPack}):B.push({extensionId:Z,extensionName:V.name,isExtensionPack:!!V.isExtensionPack})}),A.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:A}),F.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:F}),B.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:B})}),(0,_.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...r,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(r,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(r,o){const u=new Map;r.forEach(U=>u.set(U.extensionId.toLowerCase(),U));const{installed:g,uninstalled:S}=this.groupByInstalled([...u.keys()],o);for(const U of g){const W=u.get(U);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:W.exeName})}for(const U of S){const W=u.get(U);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:W.exeName})}const P=this.getPromptedExecutableTips(),O=new Map;for(const U of S){const W=u.get(U);if(W&&(!P[W.exeName]||!P[W.exeName].includes(W.extensionId))){let $=O.get(W.exeName);$||($=[],O.set(W.exeName,$)),$.push(W)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[r,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(r);break;case"incompatibleWindow":const g=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const S=this._register((0,_.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const r=this.getLastPromptedMediumExeTime(),o=Date.now()-r,u=7*24*60*60*1e3;if(o<u){const P=this._register((0,_.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[g,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(P=>{switch(P){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(S[0].exeName,S);const O=this._register((0,_.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const U=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const W=this._register((0,_.disposableTimeout)(()=>{W.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(r){const o=r.map(({extensionId:g})=>g.toLowerCase()),u=(0,I.localize)(0,null,r[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${r[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let r=this.storageService.getNumber(a,0);return r||(r=Date.now(),this.updateLastPromptedMediumExeTime(r)),r}updateLastPromptedMediumExeTime(r){this.storageService.store(a,r,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(s,0,"{}"))}addToRecommendedExecutables(r,o){const u=this.getPromptedExecutableTips();u[r]=o.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(s,JSON.stringify(u),0,0)}groupByInstalled(r,o){const u=[],g=[],S=o.reduce((P,O)=>(P.add(O.identifier.id.toLowerCase()),P),new Set);return r.forEach(P=>{S.has(P.toLowerCase())?u.push(P):g.push(P)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(r){const o=[],u=new Map;for(const g of r.keys()){const S=r.get(g);if(!S||!(0,T.isNonEmptyArray)(S.recommendations))continue;const P=[];R.isWindows?S.windowsPath&&P.push(S.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(P.push((0,i.join)("/usr/local/bin",g)),P.push((0,i.join)("/usr/bin",g)),P.push((0,i.join)(this.environmentService.userHome.fsPath,g)));for(const O of P){let U=u.get(O);if(U===void 0&&(U=await this.fileService.exists(b.URI.file(O)),u.set(O,U)),U)for(const{extensionId:W,extensionName:$,isExtensionPack:k}of S.recommendations)o.push({extensionId:W,extensionName:$,isExtensionPack:k,exeName:g,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return o}};n=de([G(0,C.INativeEnvironmentService),G(1,l.ITelemetryService),G(2,d.IExtensionManagementService),G(3,c.IStorageService),G(4,m.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,y.IFileService),G(7,E.IProductService),G(8,f.IRequestService),G(9,p.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class T{constructor(L){this.appenders=L}listen(L,i){throw new Error(`Event not found: ${i}`)}call(L,i,{eventName:R,data:w}){return this.appenders.forEach(b=>b.log(R,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=T;class _{constructor(L){this.channel=L}log(L,i){return this.channel.call("log",{eventName:L,data:i}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=_}),define(te[44],ne([0,1,28,15,21,22]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,E){return Promise.resolve(void 0)}publicLog2(m,E){return this.publicLog(m,E)}publicLogError(m,E){return Promise.resolve(void 0)}publicLogError2(m,E){return this.publicLogError(m,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class R{async publicLog(m,E,f){}async publicLogError(m,E,f){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(p,m){return m.onDidChangeConfiguration(E=>{E.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(E.source),configurationKeys:h(E.sourceConfig)})})}e.configurationTelemetry=w;function b(p,m){return!(m.disableTelemetry||!p.enableTelemetry)}e.supportsTelemetry=b;function I(p){const m=p.getValue(L.TELEMETRY_SETTING_ID),E=p.getValue("telemetry.enableCrashReporter");if(p.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function C(p){const m=Object.create(null),E=Object.create(null),f=Object.create(null);v(p,f);for(let c in f){c=c.length>150?c.substr(c.length-149):c;const l=f[c];typeof l=="number"?E[c]=l:typeof l=="boolean"?E[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),m[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[c]=l)}return{properties:m,measurements:E}}e.validateTelemetryData=C;function d(p){if(!p)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{p.indexOf(`${f}+`)===0&&(m=f)}),m}e.cleanRemoteAuthority=d;function v(p,m,E=0,f){if(!!p)for(let c of Object.getOwnPropertyNames(p)){const l=p[c],s=f?f+c:c;Array.isArray(l)?m[s]=(0,T.safeStringify)(l):l instanceof Date?m[s]=l.toISOString():(0,_.isObject)(l)?E<2?v(l,m,E+1,s+"."):m[s]=(0,T.safeStringify)(l):m[s]=l}}function h(p){if(!p)return[];const m=[];return y(m,"",p),m}function y(p,m,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(f=>y(p,m?`${m}.${f}`:f,E[f])):p.push(m)}}),define(te[204],ne([0,1,44,150]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(w,b){}postEvent(w,b){}}class L{constructor(w,b,I,C,d){this.getMachineId=w,this.configurationService=b,this.productService=I,this.telemetry=C,this.keyValueStorage=d,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,T.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const v=this.configurationService.getValue("experiments.overrideDelay"),h=typeof v=="number"?v:0;this.overrideInitDelay=new Promise(y=>setTimeout(y,h))}get experimentsEnabled(){return!0}async getTreatment(w){await this.overrideInitDelay;const b=this.configurationService.getValue("experiments.override."+w);if(b!==void 0)return b;if(!this.tasClient||!this.experimentsEnabled)return;let I;const C=await this.tasClient;return this.networkInitialized?I=C.getTreatmentVariable("vscode",w):I=await C.getTreatmentVariableAsync("vscode",w,!0),I=C.getTreatmentVariable("vscode",w),I}async setupTASClient(){const w=this.productService.quality==="stable"?_.TargetPopulation.Public:_.TargetPopulation.Insiders,b=await this.getMachineId(),I=new _.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,b,w),C=this.productService.tasConfig,d=new(await new Promise((v,h)=>{J(["tas-client-umd"],v,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:_.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:_.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=L;class i extends L{constructor(w,b,I){super(()=>Promise.resolve(w),b,I,new D)}}e.AssignmentService=i}),define(te[205],ne([0,1,17,27,9,28,4,32,15,7,21,11,30,35,76,14,8,26,43,46,23,22,44]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=i.isWeb?"web":(0,d.getTargetPlatform)(i.platform,R.arch);var n;(function(H){H[H.None=0]="None",H[H.IncludeVersions=1]="IncludeVersions",H[H.IncludeFiles=2]="IncludeFiles",H[H.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",H[H.IncludeSharedAccounts=8]="IncludeSharedAccounts",H[H.IncludeVersionProperties=16]="IncludeVersionProperties",H[H.ExcludeNonValidated=32]="ExcludeNonValidated",H[H.IncludeInstallationTargets=64]="IncludeInstallationTargets",H[H.IncludeAssetUri=128]="IncludeAssetUri",H[H.IncludeStatistics=256]="IncludeStatistics",H[H.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",H[H.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...H){return String(H.reduce((X,re)=>X|re,0))}var r;(function(H){H[H.Tag=1]="Tag",H[H.ExtensionId=4]="ExtensionId",H[H.Category=5]="Category",H[H.ExtensionName=7]="ExtensionName",H[H.Target=8]="Target",H[H.Featured=9]="Featured",H[H.SearchText=10]="SearchText",H[H.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class P{constructor(X=S){this.state=X}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(X,re=this.state.pageSize){return new P({...this.state,pageNumber:X,pageSize:re})}withFilter(X,...re){const oe=[...this.state.criteria,...re.length?re.map(le=>({filterType:X,value:le})):[{filterType:X}]];return new P({...this.state,criteria:oe})}withSortBy(X){return new P({...this.state,sortBy:X})}withSortOrder(X){return new P({...this.state,sortOrder:X})}withFlags(...X){return new P({...this.state,flags:X.reduce((re,oe)=>re|oe,0)})}withAssetTypes(...X){return new P({...this.state,assetTypes:X})}get raw(){const{criteria:X,pageNumber:re,pageSize:oe,sortBy:le,sortOrder:he,flags:be,assetTypes:Ce}=this.state;return{filters:[{criteria:X,pageNumber:re,pageSize:oe,sortBy:le,sortOrder:he}],assetTypes:Ce,flags:be}}get searchText(){const X=this.state.criteria.filter(re=>re.filterType===r.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(X=>String(X.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(H,X){const re=(H||[]).filter(oe=>oe.statisticName===X)[0];return re?re.value:0}function U(H){const X="Microsoft.VisualStudio.Code.Translation.";return H.files.filter(oe=>oe.assetType.indexOf(X)===0).reduce((oe,le)=>{const he=z(H,le.assetType);return he&&oe.push([le.assetType.substring(X.length),he]),oe},[])}function W(H){if(H.properties){const X=H.properties.filter(le=>le.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),oe=X.filter(le=>re.test(le.value))[0];return oe?{uri:oe.value,fallbackUri:oe.value}:null}return z(H,o.Repository)}function $(H){return{uri:`${H.fallbackAssetUri}/${o.VSIX}?redirect=true${H.targetPlatform?`&targetPlatform=${H.targetPlatform}`:""}`,fallbackUri:`${H.fallbackAssetUri}/${o.VSIX}${H.targetPlatform?`?targetPlatform=${H.targetPlatform}`:""}`}}function k(H){const X=z(H,o.Icon);if(X)return X;const re=d.DefaultIconPath;return{uri:re,fallbackUri:re}}function z(H,X){return H.files.filter(oe=>oe.assetType===X)[0]?{uri:`${H.assetUri}/${X}`,fallbackUri:`${H.fallbackAssetUri}/${X}`}:null}function A(H,X){const re=H.properties?H.properties.filter(le=>le.key===X):[],oe=re.length>0&&re[0].value;return oe?oe.split(",").map(le=>(0,v.adoptToGalleryExtensionId)(le)):[]}function F(H){const X=H.properties?H.properties.filter(re=>re.key===u.Engine):[];return X.length>0&&X[0].value||""}function B(H){const X=H.properties?H.properties.filter(re=>re.key===u.PreRelease):[];return X.length>0&&X[0].value==="true"}function Z(H){const X=H.properties?H.properties.filter(oe=>oe.key===u.LocalizedLanguages):[],re=X.length>0&&X[0].value||"";return re?re.split(","):[]}function V(H){return H.indexOf("preview")!==-1}function j(H){return H.targetPlatform?(0,d.toTargetPlatform)(H.targetPlatform):"undefined"}function Q(H){const X=(0,T.distinct)(H.versions.map(j)),re=!!H.tags?.includes(d.WEB_EXTENSION_TAG),oe=X.indexOf("web");return re?oe===-1&&X.push("web"):oe!==-1&&X.splice(oe,1),X}function M(H,X){const re=(0,d.getFallbackTargetPlarforms)(X);for(let oe=0;oe<H.length;oe++){const le=H[oe];if(le.version===H[oe-1]?.version){let he=oe;const be=j(le);if(be===X)for(;he>0&&H[he-1].version===le.version;)he--;else if(re.includes(be))for(;he>0&&H[he-1].version===le.version&&j(H[he-1])!==X;)he--;he!==oe&&(H.splice(oe,1),H.splice(he,0,le))}}return H}e.sortExtensionVersions=M;function N(H,X,re,oe){const le=H.versions[0],he={manifest:z(X,o.Manifest),readme:z(X,o.Details),changelog:z(X,o.Changelog),license:z(X,o.License),repository:W(X),download:$(X),icon:k(X),coreTranslations:U(X)};return{identifier:{id:(0,v.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},name:H.extensionName,version:X.version,displayName:H.displayName,publisherId:H.publisher.publisherId,publisher:H.publisher.publisherName,publisherDisplayName:H.publisher.displayName,publisherDomain:H.publisher.domain?{link:H.publisher.domain,verified:!!H.publisher.isDomainVerified}:void 0,description:H.shortDescription||"",installCount:O(H.statistics,"install"),rating:O(H.statistics,"averagerating"),ratingCount:O(H.statistics,"ratingcount"),categories:H.categories||[],tags:H.tags||[],releaseDate:Date.parse(H.releaseDate),lastUpdated:Date.parse(H.lastUpdated),allTargetPlatforms:re,assets:he,properties:{dependencies:A(X,u.Dependency),extensionPack:A(X,u.ExtensionPack),engine:F(X),localizedLanguages:Z(X),targetPlatform:j(X),isPreReleaseVersion:B(X)},hasPreReleaseVersion:B(le),preview:V(H.flags),telemetryData:oe}}let q=class{constructor(X,re,oe,le,he,be,Ce,we){this.requestService=re,this.logService=oe,this.environmentService=le,this.telemetryService=he,this.fileService=be,this.productService=Ce,this.configurationService=we;const ve=Ce.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=ee(Ce.version,Ce,this.environmentService,this.configurationService,this.fileService,X)}api(X=""){return`${this.extensionsGalleryUrl}${X}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(X,re,oe){const le=(0,w.isBoolean)(re)?re:!1,he=(0,w.isBoolean)(re)?oe:re;let be=new P().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,X.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...X.map(({id:ve})=>ve.toLowerCase()));X.every(ve=>!ve.version)&&(be=be.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:Ce}=await this.queryGallery(be,a,_.CancellationToken.None),we=Ce.map(ve=>{const De=(0,v.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName);return{rawGalleryExtension:ve,version:X.find(ye=>(0,v.areSameExtensions)(ye,{id:De}))?.version}});return this.converToGalleryExtensions(we,le,a,()=>{},he)}async getCompatibleExtension(X,re,oe){const le=(0,d.isIExtensionIdentifier)(X)?null:X;if(le){if((0,d.isNotWebExtensionInWebTargetPlatform)(le.allTargetPlatforms,oe))return null;if(await this.isExtensionCompatible(le,re,oe))return le}const{id:he,uuid:be}=le?le.identifier:X;let Ce=new P().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");be?Ce=Ce.withFilter(r.ExtensionId,be):Ce=Ce.withFilter(r.ExtensionName,he);const{galleryExtensions:we}=await this.queryGallery(Ce,oe,_.CancellationToken.None),[ve]=we;if(!ve||!ve.versions.length)return null;const De=Q(ve);if((0,d.isNotWebExtensionInWebTargetPlatform)(De,oe))return null;for(let ye of ve.versions){if(!F(ye)){const Ie=await this.getEngine(ye);ye={...ye,properties:[...ye.properties||[],{key:u.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ye,re,De,oe))return N(ve,ye,De)}return null}async isExtensionCompatible(X,re,oe){if(!(0,d.isTargetPlatformCompatible)(X.properties.targetPlatform,X.allTargetPlatforms,oe)||!re&&X.properties.isPreReleaseVersion)return!1;let le=X.properties.engine;if(!le){const he=await this.getManifest(X,_.CancellationToken.None);if(!he)throw new Error("Manifest was not found");le=he.engines.vscode}return(0,h.isEngineValid)(le,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(X,re,oe,le){if(!(0,d.isTargetPlatformCompatible)(j(X),oe,le)||!re&&B(X))return!1;const he=await this.getEngine(X);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(X,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=X.text||"";const le=(0,L.getOrDefault)(X,ye=>ye.pageSize,50);let he=new P().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,le).withFilter(r.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,Ie,Me)=>(he=he.withFilter(r.Category,Me||Ie),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ye,Ie,Me)=>(he=he.withFilter(r.Tag,Me||Ie),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(r.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),he=he.withFilter(r.SearchText,oe)),he=he.withSortBy(0)):X.ids?he=he.withFilter(r.ExtensionId,...X.ids):X.names?he=he.withFilter(r.ExtensionName,...X.names):he=he.withSortBy(4),typeof X.sortBy=="number"&&(he=he.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(he=he.withSortOrder(X.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(he,a,re),we=ye=>({index:(he.pageNumber-1)*he.pageSize+ye,querySource:X.source}),ve=await this.converToGalleryExtensions(be.map(ye=>({rawGalleryExtension:ye})),!!X.includePreRelease,a,we,re),De=async(ye,Ie)=>{if(Ie.isCancellationRequested)throw(0,D.canceled)();const Me=he.withPage(ye+1),{galleryExtensions:je}=await this.queryGallery(Me,a,Ie);return await this.converToGalleryExtensions(je.map(Ne=>({rawGalleryExtension:Ne})),!!X.includePreRelease,a,we,re)};return{firstPage:ve,total:Ce,pageSize:he.pageSize,getPage:De}}async converToGalleryExtensions(X,re,oe,le,he){const be=(ve,De)=>{const ye=Q(ve);let Ie=ve.versions[0];return Ie=ve.versions.find(Me=>Me.version===Ie.version&&(0,d.isTargetPlatformCompatible)(j(Me),ye,oe))||Ie,!re&&B(Ie)&&(Ie=ve.versions.find(Me=>Me.version!==Ie.version&&!B(Me))||Ie),N(ve,Ie,ye,le(De))},Ce=[],we=new Map;for(let ve=0;ve<X.length;ve++){const{rawGalleryExtension:De,version:ye}=X[ve];if(ye){const Ie=De.versions.find(Me=>Me.version===ye);Ie&&Ce.push([ve,N(De,Ie,Q(De))])}else{const Ie=be(De,ve);Ie.properties.isPreReleaseVersion&&!re?we.set(Ie.identifier.uuid,ve):Ce.push([ve,Ie])}}if(we.size){const ve=new P().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,we.size).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionId,...we.keys()),{galleryExtensions:De}=await this.queryGallery(ve,oe,he);if(De.length!==we.size)throw new Error("Not all extensions with latest versions are returned");for(const ye of De){const Ie=we.get(ye.extensionId),Me=be(ye,Ie);Ce.push([Ie,Me])}}return Ce.sort((ve,De)=>ve[0]-De[0]).map(([,ve])=>ve)}async queryGallery(X,re,oe){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,n.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,t(n.Unpublished));const le=await this.commonHeadersPromise,he=JSON.stringify(X.raw),be={...le,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},Ce=new Date().getTime();let we,ve,De=0;try{if(we=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:be},oe),we.res.statusCode&&we.res.statusCode>=400&&we.res.statusCode<500)return{galleryExtensions:[],total:De};const ye=await(0,E.asJson)(we);if(ye){const Ie=ye.results[0],Me=Ie.extensions;Me.forEach(Ne=>M(Ne.versions,re));const je=Ie.resultMetadata&&Ie.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return De=je&&je.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Me,total:De}}return{galleryExtensions:[],total:De}}catch(ye){throw ve=ye,ye}finally{this.telemetryService.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-Ce,success:!!we&&(0,E.isSuccess)(we),responseBodySize:we?.res.headers["Content-Length"],statusCode:we?String(we.res.statusCode):void 0,errorCode:ve?(0,D.isPromiseCanceledError)(ve)?"canceled":(0,D.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(De)})}}async reportStatistic(X,re,oe,le){if(!this.isEnabled())return;const he=i.isWeb?this.api(`/itemName/${X}.${re}/version/${oe}/statType/${le==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${X}/extensions/${re}/${oe}/stats?statType=${le}`),be=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:be};try{await this.requestService.request({type:"POST",url:he,headers:we},_.CancellationToken.None)}catch(ve){}}async download(X,re,oe){this.logService.trace("ExtensionGalleryService#download",X.identifier.id);const le=(0,v.getGalleryExtensionTelemetryData)(X),he=new Date().getTime(),be=De=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...le,duration:De}),Ce=oe===2?"install":oe===3?"update":"",we=Ce?{uri:`${X.assets.download.uri}${b.URI.parse(X.assets.download.uri).query?"&":"?"}${Ce}=true`,fallbackUri:`${X.assets.download.fallbackUri}${b.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${Ce}=true`}:X.assets.download,ve=await this.getAsset(we);await this.fileService.writeFile(re,ve.stream),be(new Date().getTime()-he)}async getReadme(X,re){if(X.assets.readme){const oe=await this.getAsset(X.assets.readme,{},re);return await(0,E.asText)(oe)||""}return""}async getManifest(X,re){if(X.assets.manifest){const oe=await this.getAsset(X.assets.manifest,{},re),le=await(0,E.asText)(oe);return le?JSON.parse(le):null}return null}async getManifestFromRawExtensionVersion(X,re){const oe=z(X,o.Manifest);if(!oe)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},he=await this.getAsset(oe,{headers:le});return await(0,E.asJson)(he)}async getCoreTranslation(X,re){const oe=X.assets.coreTranslations.filter(le=>le[0]===re.toUpperCase())[0];if(oe){const le=await this.getAsset(oe[1]),he=await(0,E.asText)(le);return he?JSON.parse(he):null}return null}async getChangelog(X,re){if(X.assets.changelog){const oe=await this.getAsset(X.assets.changelog,{},re);return await(0,E.asText)(oe)||""}return""}async getAllCompatibleVersions(X,re,oe){let le=new P().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");X.identifier.uuid?le=le.withFilter(r.ExtensionId,X.identifier.uuid):le=le.withFilter(r.ExtensionName,X.identifier.id);const{galleryExtensions:he}=await this.queryGallery(le,oe,_.CancellationToken.None);if(!he.length)return[];const be=Q(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(be,oe))return[];const Ce=[];for(const we of he[0].versions)try{Ce[Ce.length-1]?.version!==we.version&&await this.isRawExtensionVersionCompatible(we,re,be,oe)&&Ce.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:B(we)})}catch(ve){}return Ce}async getAsset(X,re={},oe=_.CancellationToken.None){const le=await this.commonHeadersPromise,he={type:"GET"},be={...le,...re.headers||{}};re={...re,...he,headers:be};const Ce=X.uri,we=X.fallbackUri,ve={...re,url:Ce};try{const De=await this.requestService.request(ve,oe);if(De.res.statusCode===200)return De;const ye=await(0,E.asText)(De);throw new Error(`Expected 200, got back ${De.res.statusCode} instead.

${ye}`)}catch(De){if((0,D.isPromiseCanceledError)(De))throw De;const ye=(0,D.getErrorMessage)(De);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Ce,message:ye});const Ie={...re,url:we};return this.requestService.request(Ie,oe)}}async getEngine(X){let re=F(X);if(!re){const oe=await this.getManifestFromRawExtensionVersion(X,_.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");re=oe.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const X=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},_.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,E.asJson)(X),oe=[],le={};if(re){for(const he of re.malicious)oe.push({id:he});if(re.unsupported)for(const he of Object.keys(re.unsupported)){const be=re.unsupported[he];(0,w.isBoolean)(be)||(le[he.toLowerCase()]=be.preReleaseExtension)}}return{malicious:oe,unsupportedPreReleaseExtensions:le}}};q=de([G(1,E.IRequestService),G(2,p.ILogService),G(3,C.IEnvironmentService),G(4,l.ITelemetryService),G(5,y.IFileService),G(6,m.IProductService),G(7,I.IConfigurationService)],q);let x=class extends q{constructor(X,re,oe,le,he,be,Ce,we){super(X,re,oe,le,he,be,Ce,we)}};x=de([G(0,c.IStorageService),G(1,E.IRequestService),G(2,p.ILogService),G(3,C.IEnvironmentService),G(4,l.ITelemetryService),G(5,y.IFileService),G(6,m.IProductService),G(7,I.IConfigurationService)],x),e.ExtensionGalleryService=x;let K=class extends q{constructor(X,re,oe,le,he,be,Ce){super(void 0,X,re,oe,le,he,be,Ce)}};K=de([G(0,E.IRequestService),G(1,p.ILogService),G(2,C.IEnvironmentService),G(3,l.ITelemetryService),G(4,y.IFileService),G(5,m.IProductService),G(6,I.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K;async function ee(H,X,re,oe,le,he){const be={"X-Market-Client-Id":`VSCode ${H}`,"User-Agent":`VSCode ${H}`},Ce=await(0,f.getServiceMachineId)(re,le,he);return(0,s.supportsTelemetry)(X,re)&&(0,s.getTelemetryLevel)(oe)===3&&(be["X-Market-User-Id"]=Ce),be}e.resolveMarketplaceHeaders=ee}),define(te[93],ne([0,1,2,11,8,44]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends T.Disposable{constructor(w,b,I=""){super();this.prefix=I;const C=w.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(w.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,b){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,L.validateTelemetryData)(b))}};i=de([G(0,D.ILoggerService),G(1,_.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[94],ne([0,1,2,28,4,25,142,21,42,86,37,22,44]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(p,m){this._configurationService=m,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(E=>{const f=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(p,m){this._experimentProperties[p]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const p=await this._commonProperties;let m=p.sessionID,E=p["common.machineId"],f=p["common.firstSessionDate"],c=p["common.msftInternal"];return{sessionId:m,machineId:E,firstSessionDate:f,msftInternal:c}}dispose(){this._disposables.dispose()}_log(p,m,E,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(c=>{E=(0,_.mixin)(E,c),E=(0,_.mixin)(E,this._experimentProperties),E=(0,_.cloneAndChange)(E,l=>{if(typeof l=="string")return this._cleanupInfo(l,f)}),this._appenders.forEach(l=>l.log(p,E))},c=>{console.error(c)})}publicLog(p,m,E){return this._log(p,3,m,E)}publicLog2(p,m,E){return this.publicLog(p,m,E)}publicLogError(p,m){return this.sendErrorTelemetry?this._log(p,2,m,!0):Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}_anonymizeFilePaths(p){let m=p;const E=[];for(let s of this._cleanupPatterns)for(;;){const a=s.exec(p);if(!a)break;E.push([a.index,s.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const s=c.exec(p);if(!s)break;!f.test(s[0])&&E.every(([a,n])=>s.index<a||s.index>=n)&&(m+=p.substring(l,s.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<p.length&&(m+=p.substr(l)),m}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const m=p.toLowerCase(),E=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":E.test(m)?"<REDACTED: email>":p}_cleanupInfo(p,m){let E=p;m&&(E=this._anonymizeFilePaths(E));for(let f of this._cleanupPatterns)E=E.replace(f,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=de([G(1,R.IConfigurationService)],v),e.TelemetryService=v;function h(){const y=(0,i.localize)(0,null,b.default.nameLong),p=b.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,i.localize)(3,null),E=(0,i.localize)(4,null),f=(0,i.localize)(5,null),c=(0,i.localize)(6,null),l=(0,i.localize)(7,null),s=`
|       | ${E} | ${f} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,i.localize)(8,null);return`
${y} ${p} ${m}

&nbsp;

${l}
${s}

&nbsp;

${a}
`}I.Registry.as(w.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(w.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,i.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,i.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[206],ne([0,1,9,28,44]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(R,w){const b=await new Promise((C,d)=>{J(["applicationinsights"],C,d)});let I;return b.defaultClient?(I=new b.TelemetryClient(R),I.channel.setUseDiskRetryCaching(!0)):(b.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=b.defaultClient),R.indexOf("AIF-")===0&&(I.config.endpointUrl=w?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(w,b,I,C,d){this._eventPrefix=w,this._defaultData=b,this.testCollector=C,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{w(b)},b=>{(0,T.onUnexpectedError)(b),console.error(b)})}}log(w,b){!this._aiClient||(b=(0,_.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+w,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[207],ne([0,1,16,52,21,11,8,22,92,93,94]),function(J,e,T,_,D,L,i,R,w,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(v,h,y,p){this.configurationService=v,this.telemetryService=h,this.loggerService=y,this.environmentService=p,this.customTelemetryServices=new Map}async getCustomTelemetryService(v){if(!this.customTelemetryServices.has(v.id)){const{machineId:h,sessionId:y}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=h,p["common.vscodesessionid"]=y;const m=[v.id,JSON.stringify(p),v.aiKey],f=new _.Client(T.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new w.TelemetryAppenderClient(f),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${v.id}] `)];this.customTelemetryServices.set(v.id,new I.TelemetryService({appenders:c,sendErrorTelemetry:v.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(v.id)}async publicLog(v,h,y){await(await this.getCustomTelemetryService(v)).publicLog(h,y)}async publicLogError(v,h,y){await(await this.getCustomTelemetryService(v)).publicLogError(h,y)}};C=de([G(0,D.IConfigurationService),G(1,R.ITelemetryService),G(2,i.ILoggerService),G(3,L.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[208],ne([0,1,5,27,3,2,8]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends L.Disposable{constructor(b,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((I,C)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,I),this._onCreateRequest.fire({requestId:d,...b});const v=new _.CancellationTokenSource;(0,T.timeout)(this._timeout,v.token).then(()=>C(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(b,I){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};R=de([G(1,i.ILogService)],R),e.RequestStore=R}),define(te[95],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var _;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(_=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Log="log",p.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,T.createDecorator)("ptyService");var w;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(p){p.TerminalView="view",p.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(p){p.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var v;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(v=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(te[209],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,T.createDecorator)("localPtyService")}),define(te[210],ne([0,1,33,28,10,4,32,15,20]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(T.release());let d=0;return C&&C.length===4&&(d=parseInt(C[3])),d}e.getWindowsBuildNumber=b;async function I(C,d,v,h=i.env,y=w.Promises.exists){if(D.isAbsolute(C))return await y(C)?C:void 0;if(d===void 0&&(d=i.cwd()),D.dirname(C)!=="."){const f=D.join(d,C);return await y(f)?f:void 0}const m=(0,_.getCaseInsensitive)(h,"PATH");if(v===void 0&&(0,R.isString)(m)&&(v=m.split(D.delimiter)),v===void 0||v.length===0){const f=D.join(d,C);return await y(f)?f:void 0}for(let f of v){let c;if(D.isAbsolute(f)?c=D.join(f,C):c=D.join(d,f,C),await y(c))return c;if(L.isWindows){let l=c+".com";if(await y(l)||(l=c+".exe",await y(l)))return l}}const E=D.join(d,C);return await y(E)?E:void 0}e.findExecutable=I}),define(te[211],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var T;(function(_){_.DARK="dark",_.LIGHT="light",_.HIGH_CONTRAST="hc"})(T=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,49,3,2,6,37,211]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var w;(function(p){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=m})(w=e.ThemeColor||(e.ThemeColor={}));function b(p){return{id:p}}e.themeColorFromId=b;var I;(function(p){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||w.isThemeColor(n.color))}p.isThemeIcon=m;const E=new RegExp(`^\\$\\((${T.CSSIcon.iconNameExpression}(?:${T.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const t=E.exec(n);if(!t)return;let[,r]=t;return{id:r}}p.fromString=f;function c(n,t){let r=n.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),t&&(r=`${r}~${t}`),{id:r}}p.modify=c;function l(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}p.getModifier=l;function s(n,t){return n.id===t.id&&n.color?.id===t.color?.id}p.isEqual=s;function a(n,t){return{id:n.id,color:t?b(t):void 0}}p.asThemeIcon=a,p.asClassNameArray=T.CSSIcon.asClassNameArray,p.asClassName=T.CSSIcon.asClassName,p.asCSSSelector=T.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=T.Codicon.file,e.FolderThemeIcon=T.Codicon.folder;function C(p){switch(p){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const E=this.themingParticipants.indexOf(m);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new d;i.Registry.add(e.Extensions.ThemingContribution,v);function h(p){return v.onColorThemeChange(p)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,E){let f=this.theme.getColor(m);return f&&E&&(f=E(f,this.theme)),f?f.toString():null}}e.Themable=y}),define(te[212],ne([0,1,49,7,96]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(C,d){const v=C.map(h=>({name:h.profileName,description:i(h)}));return d&&v.push(...d.map(h=>({name:h.title,description:R(h)}))),{values:v.map(h=>h.name),markdownDescriptions:v.map(h=>h.description)}}e.createProfileSchemaEnums=L;function i(C){let d=`$(${D.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:T.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?d+=`
- args: "${C.args}"`:d+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(d+=`
- overrideName: ${C.overrideName}`),C.color&&(d+=`
- color: ${C.color}`),C.env&&(d+=`
- env: ${JSON.stringify(C.env)}`),d}function R(C){return`$(${D.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:T.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function w(C,d){if(!C&&!d)return!0;if(typeof C=="string"&&typeof d=="string")return C===d;if(Array.isArray(C)&&Array.isArray(d)){if(C.length!==d.length)return!1;for(let v=0;v<C.length;v++)if(C[v]!==d[v])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function b(C,d){if(!C&&!d)return!0;if(!C||!d)return!1;if(D.ThemeIcon.isThemeIcon(C)&&D.ThemeIcon.isThemeIcon(d))return C.id===d.id&&C.color===d.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const v=C,h=d;if((_.URI.isUri(v.light)||I(v.light))&&(_.URI.isUri(v.dark)||I(v.dark))&&(_.URI.isUri(h.light)||I(h.light))&&(_.URI.isUri(h.dark)||I(h.dark)))return v.light.path===h.light.path&&v.dark.path===h.dark.path}if(_.URI.isUri(C)&&_.URI.isUri(d)||I(C)||I(d)){const v=C,h=d;return v.path===h.path&&v.scheme===h.scheme}return!1}e.terminalIconsEqual=b;function I(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=I}),define(te[213],ne([0,1,49,143,42,37,212]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,_.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,_.localize)(1,null),type:"boolean"},icon:{description:(0,_.localize)(2,null),type:"string",enum:Array.from(T.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(T.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,_.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,_.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},b=(0,_.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,_.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,_.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,_.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),v=(0,_.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,_.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,_.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,_.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,_.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,_.localize)(25,null)}},{type:"string",markdownDescription:(0,_.localize)(26,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,_.localize)(28,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(29,null),type:"string"},id:{description:(0,_.localize)(30,null),type:"string"},title:{description:(0,_.localize)(31,null),type:"string"},...R}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(33,null),type:"string"},id:{description:(0,_.localize)(34,null),type:"string"},title:{description:(0,_.localize)(35,null),type:"string"},...R}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(37,null),type:"string"},id:{description:(0,_.localize)(38,null),type:"string"},title:{description:(0,_.localize)(39,null),type:"string"},...R}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,_.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,_.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,_.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,_.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,_.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){L.Registry.as(D.Extensions.Configuration).registerConfiguration(y),E()}e.registerTerminalPlatformConfiguration=p;let m;function E(f,c){const l=L.Registry.as(D.Extensions.Configuration);let s;f&&(s=(0,i.createProfileSchemaEnums)(f?.profiles,c));const a=m;m={id:"terminal",order:100,title:(0,_.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?s?.values:void 0,markdownEnumDescriptions:f?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?s?.values:void 0,markdownEnumDescriptions:f?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?s?.values:void 0,markdownEnumDescriptions:f?.os===1?s?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:a?[a]:[]})}e.registerTerminalDefaultProfileConfiguration=E}),define(te[214],ne([0,1,45,49,10,4,20,70,210,96]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function d(a,n,t,r,o=process.env,u,g,S,P){return u=u||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},L.isWindows?v(t,u,o,g,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:r.getValue("terminal.integrated.defaultProfile.windows"),P,S):c(u,g,t,a&&typeof a=="object"?{...a}:r.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:r.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,S,o)}e.detectAvailableProfiles=d;async function v(a,n,t,r,o,u,g,S,P){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let W=!1;(0,w.getWindowsBuildNumber)()>=16299&&(W=!0),await p(S);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0})),l(u,$);const k=await h($.entries(),g,n,t,r,P);if(a||!a&&o)try{const z=await E(`${U}\\${W?"wsl":"bash"}.exe`,g);for(const A of z)(!u||!(A.profileName in u))&&k.push(A)}catch(z){C&&(r?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return k}async function h(a,n,t,r=process.env,o,u){const g=[];for(const[S,P]of a){if(P===null)continue;let O,U,W;if("source"in P){const z=I?.get(P.source);if(!z)continue;O=z.paths,U=P.args||z.args,P.icon?W=y(P.icon):z.icon&&(W=z.icon)}else O=Array.isArray(P.path)?P.path:[P.path],U=L.isWindows||Array.isArray(P.args)?P.args:void 0,W=y(P.icon)||void 0;const $=await u?.(O)||O.slice(),k=await s(S,n,$,t,r,U,P.env,P.overrideName,P.isAutoDetected,o);k?(k.isAutoDetected=P.isAutoDetected,k.icon=W,k.color=P.color,g.push(k)):o?.trace("profile not validated",S,O)}return g}function y(a){return typeof a=="string"?{id:a}:a}async function p(a){I&&!a||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:a||await m(),icon:b.ThemeIcon.asThemeIcon(_.Codicon.terminalPowershell)}))}async function m(){const a=[];for await(const n of(0,R.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function E(a,n){const t=[],r=await new Promise((g,S)=>{T.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,O)=>{if(P)return S("Problem occurred when getting wsl distros");g(O)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),u=r.split(o).filter(g=>g.trim().length>0&&g!=="");for(const g of u){if(g===""||g.startsWith("docker-desktop"))continue;const S=`${g} (WSL)`,P={profileName:S,path:a,args:["-d",`${g}`],isDefault:S===n,icon:f(g)};t.push(P)}return t}function f(a){return a.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(_.Codicon.terminalUbuntu):a.includes("Debian")?b.ThemeIcon.asThemeIcon(_.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(_.Codicon.terminalLinux)}async function c(a,n,t,r,o,u,g,S){const P=new Map;if(t){const O=(await a.readFile("/etc/shells")).toString(),U=u||O.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),W=new Map;for(const $ of U){let k=(0,D.basename)($),z=W.get(k)||0;z++,z>1&&(k=`${k} (${z})`),W.set(k,z),P.set(k,{path:$,isAutoDetected:!0})}}return l(r,P),await h(P.entries(),o,a,S,n,g)}function l(a,n){if(!!a)for(const[t,r]of Object.entries(a))r===null||!("path"in r)&&!("source"in r)?n.delete(t):n.set(t,r)}async function s(a,n,t,r,o,u,g,S,P,O){if(t.length===0)return Promise.resolve(void 0);const U=t.shift();if(U==="")return s(a,n,t,r,o,u,g,S,P);const W={profileName:a,path:U,args:u,env:g,overrideName:S,isAutoDetected:P,isDefault:a===n};if((0,D.basename)(U)===U){const k=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,w.findExecutable)(U,void 0,k,void 0,r.existsFile)?W:s(a,n,t,r,o,u)}return await r.existsFile((0,D.normalize)(U))?W:s(a,n,t,r,o,u,g,S,P)}}),define(te[215],ne([0,1,3,2,16,4,34,52,21,11,75,165,8,85,22,208,95,213,214]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(s){s[s.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=0,l=class extends _.Disposable{constructor(a,n,t,r,o){super();this._reconnectConstants=a,this._configurationService=n,this._environmentService=t,this._logService=r,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new T.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new T.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new T.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new T.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new T.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new T.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new T.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new T.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new T.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new T.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new T.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new T.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,_.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?a.debugBrk=n.port:!n.break&&n.port&&(a.debug=n.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(g=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(g.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}, giving up`))}));const o=t.getChannel(p.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=i.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(g=>this._onProcessData.fire(g))),this._register(u.onProcessReady(g=>this._onProcessReady.fire(g))),this._register(u.onProcessExit(g=>this._onProcessExit.fire(g))),this._register(u.onDidChangeProperty(g=>this._onDidChangeProperty.fire(g))),this._register(u.onProcessReplay(g=>this._onProcessReplay.fire(g))),this._register(u.onProcessOrphanQuestion(g=>this._onProcessOrphanQuestion.fire(g))),this._register(u.onDidRequestDetach(g=>this._onDidRequestDetach.fire(g))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,n,t,r,o,u,g,S,P,O,U){const W=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,n,t,r,o,u,g,S,P,O,U);return clearTimeout(W),c=Math.max(c,$),$}updateTitle(a,n,t){return this._proxy.updateTitle(a,n,t)}updateIcon(a,n,t){return this._proxy.updateIcon(a,n,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,n){return this._proxy.shutdown(a,n)}input(a,n){return this._proxy.input(a,n)}processBinary(a,n){return this._proxy.processBinary(a,n)}resize(a,n,t){return this._proxy.resize(a,n,t)}acknowledgeDataEvent(a,n){return this._proxy.acknowledgeDataEvent(a,n)}setUnicodeVersion(a,n){return this._proxy.setUnicodeVersion(a,n)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,n,t,r=!1){const o=await this._shellEnv;return(0,E.detectAvailableProfiles)(n,t,r,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,n){return this._proxy.requestDetachInstance(a,n)}async acceptDetachInstanceReply(a,n){return this._proxy.acceptDetachInstanceReply(a,n)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a){return this._proxy.reviveTerminalProcesses(a)}async refreshProperty(a,n){return this._proxy.refreshProperty(a,n)}async updateProperty(a,n,t){return this._proxy.updateProperty(a,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:n})}async acceptPtyHostResolvedVariables(a,n){this._resolveVariablesRequestStore.acceptReply(a,n)}};l=de([G(1,w.IConfigurationService),G(2,b.IEnvironmentService),G(3,d.ILogService),G(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[36],ne([0,1,6]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(te[216],ne([0,1,3,2,7,11,35,14,8,36]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends _.Disposable{constructor(d,v,h,y,p){super();this.extensionsManagementService=d,this.logService=y,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(E=>this.onInstallExtension(E))),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const m=D.URI.file(h.extensionsPath);this._register(v.watch(m)),this._register(T.Event.filter(v.onDidChangeFilesRaw,E=>E.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(d,v){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),v)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const v of d)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(v=>!(0,i.areSameExtensions)(v,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,i.areSameExtensions)(v,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),v=d.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,i.areSameExtensions)(p,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(p=>(0,i.areSameExtensions)(p,y))?!1:d.every(p=>!(0,i.areSameExtensions)(p.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=d.map(y=>y.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};I=de([G(1,R.IFileService),G(2,L.INativeEnvironmentService),G(3,w.ILogService),G(4,b.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[217],ne([0,1,36,77,14,18,103,3,2]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new w.DisposableStore,this._limit=2**16;const v=new Map,h=y=>{let p=v.get(y.scheme);return p===void 0&&(p=d.hasProvider(y)&&!this._fileService.hasCapability(y,1024),v.set(y.scheme,p)),p};this._dispooables.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{v.delete(y.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new i.SkipList((y,p)=>this.extUri.compare(y,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,L.normalizePath)(d));let v=this._canonicalUris.get(d);return v?v.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new b(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};I=de([G(0,D.IFileService)],I),e.UriIdentityService=I,(0,_.registerSingleton)(T.IUriIdentityService,I,!0)}),define(te[55],ne([0,1,39]),function(J,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function _(i,R,w,b){const I=(0,T.setProperty)(i,R,w,b)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=_;function D(i,R,w){let b=w;for(;b>=0;){if(i.charAt(b)===R.charAt(R.length-1)&&R.length===1)return b+1;if(b--,R.length===2&&b>=0&&i.charAt(b)===R.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function L(i,R,w){let b=w;for(;b>=0;)if(i.charAt(b)===R.charAt(R.length-1)&&R.length===1||(b++,R.length===2&&b>=0&&i.charAt(b)===R.charAt(1)))return b;return i.length-1}e.getLineEndOffset=L}),define(te[218],ne([0,1,28,61,15]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(d,v,h,y,p){const m=[],E=[],f=[];if(!v){const U=d.filter(({identifier:W})=>p.every($=>$.toLowerCase()!==W.id.toLowerCase()));return{local:{added:m,removed:E,updated:f},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}d=d.map(I),v=v.map(I),h=h?h.map(I):null;const c=new Map,l=U=>{U.uuid&&c.set(U.id.toLowerCase(),U.uuid)};d.forEach(({identifier:U})=>l(U)),v.forEach(({identifier:U})=>l(U)),h&&h.forEach(({identifier:U})=>l(U));const s=U=>{const W=U.identifier.uuid||c.get(U.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${U.identifier.id.toLowerCase()}`},a=(U,W)=>(U.set(s(W),W),U),n=d.reduce(a,new Map),t=v.reduce(a,new Map),r=v.reduce((U,W)=>{const $=s(W);W=(0,T.deepClone)(W);const k=n.get($);return k&&(k.installed&&(W.installed=!0),W.version||(W.version=k.version)),a(U,W)},new Map),o=h?h.reduce(a,new Map):null,u=y.reduce(a,new Map),g=p.reduce((U,W)=>{const $=c.get(W.toLowerCase());return U.add($?`uuid:${$}`:`id:${W.toLowerCase()}`)},new Set),S=i(n,t,g);if(S.added.size>0||S.removed.size>0||S.updated.size>0){const U=i(o,n,g),W=i(o,t,g),$=(k,z)=>{const A=n.get(k);if(A){const F=t.get(k),B=z?F:A;return{...B,version:(F.version&&_.gt(F.version,A.version),A.version),state:R(A,F,o?.get(k)),preRelease:(0,D.isUndefined)(B.preRelease)?A.preRelease:B.preRelease}}};for(const k of W.removed.values()){const z=n.get(k);z&&E.push(z.identifier)}for(const k of W.added.values())if(U.added.has(k)){if(S.updated.has(k)){const z=$(k,!0);z&&(f.push(C(z,k)),r.set(k,z))}}else{const z=t.get(k);z.installed&&m.push(C(z,k))}for(const k of W.updated.values()){const z=$(k,!0);z&&(f.push(C(z,k)),r.set(k,z))}for(const k of U.added.values())W.added.has(k)||r.set(k,n.get(k));for(const k of U.updated.values())if(!W.removed.has(k)&&!W.updated.has(k)){const z=$(k,!1);z&&(r.get(k)?.installed&&(z.installed=!0),r.set(k,z))}for(const k of U.removed.values())!u.has(k)&&!W.updated.has(k)&&o?.get(k)?.installed&&r.delete(k)}const P=[],O=i(t,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&r.forEach((U,W)=>P.push(C(U,W))),{local:{added:m,removed:E,updated:f},remote:P.length?{added:[...O.added].map(U=>r.get(U)),updated:[...O.updated].map(U=>r.get(U)),removed:[...O.removed].map(U=>t.get(U)),all:P}:null}}e.merge=L;function i(d,v,h,{checkInstalledProperty:y,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=d?[...d.keys()].filter(s=>!h.has(s)):[],E=[...v.keys()].filter(s=>!h.has(s)),f=E.filter(s=>m.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),c=m.filter(s=>E.indexOf(s)===-1).reduce((s,a)=>(s.add(a),s),new Set),l=new Set;for(const s of m){if(c.has(s))continue;const a=d.get(s),n=v.get(s);(!n||a.disabled!==n.disabled||a.preRelease!==n.preRelease||!b(a.state,n.state)||p&&a.version!==n.version||y&&a.installed!==n.installed)&&l.add(s)}return{added:f,removed:c,updated:l}}function R(d,v,h){const y=d.state,p=v.state,m=h?.state;if(!v.version||y&&_.gt(d.version,v.version))return y;if(p&&_.gt(v.version,d.version)||!y)return p;if(!p)return y;const E=(0,T.deepClone)(y),f=m?w(m,p):{added:Object.keys(p).reduce((l,s)=>(l.add(s),l),new Set),removed:new Set,updated:new Set},c=m?w(m,y):{added:Object.keys(y).reduce((l,s)=>(l.add(s),l),new Set),removed:new Set,updated:new Set};for(const l of[...f.added.values(),...f.updated.values()])E[l]=p[l];for(const l of f.removed.values())c.updated.has(l)||delete E[l];return E}function w(d,v){const h=Object.keys(d),y=Object.keys(v),p=y.filter(f=>h.indexOf(f)===-1).reduce((f,c)=>(f.add(c),f),new Set),m=h.filter(f=>y.indexOf(f)===-1).reduce((f,c)=>(f.add(c),f),new Set),E=new Set;for(const f of h){if(m.has(f))continue;const c=d[f],l=v[f];(0,T.equals)(c,l)||E.add(f)}return{added:p,removed:m,updated:E}}function b(d={},v={}){const{added:h,removed:y,updated:p}=w(d,v);return h.size===0&&y.size===0&&p.size===0}function I(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function C(d,v){const h={identifier:{id:d.identifier.id,uuid:v.startsWith("uuid:")?v.substring("uuid:".length):void 0},preRelease:!!d.preRelease};return d.version&&(h.version=d.version),d.disabled&&(h.disabled=!0),d.installed&&(h.installed=!0),d.state&&(h.state=d.state),h}}),define(te[97],ne([0,1,17,3,2,35,6,26,23]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends D.Disposable{constructor(d,v){super();this.storageService=d,this.productService=v,this._onDidChangeExtensionsStorage=this._register(new _.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const v=b.exec(d);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const d=this.storageService.keys(0,1);for(const v of d){const h=it.fromKey(v);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const v=it.fromKey(d.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,v){this.storageService.store(it.toKey(d),JSON.stringify(v),0,1)}getKeysForSync(d){const v=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),y=h?JSON.parse(h):void 0;return y&&v?(0,T.distinct)([...y,...v]):y||v}};I=de([G(0,w.IStorageService),G(1,R.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[98],ne([0,1,17,21,6]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==R&&I!==`-${R}`),w&&b.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(R,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==R&&I!==`-${R}`),w&&b.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(R){const w=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),I=[],C=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?C.push(d.substring(1)):I.push(d);return(0,T.distinct)([...w,...I].filter(d=>C.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};L=de([G(0,_.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(te[219],ne([0,1,17,31,28,160,55]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(c){return(0,_.parse)(c)||[]}e.parseKeybindings=R;async function w(c,l,s,a,n){const t=R(c),r=R(l),o=s?R(s):null,u=[...t,...r,...o||[]].map(F=>F.key),g=await n.resolveUserBindings(u);let S=I(t,r,o,g);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const P=d(t),O=d(r),U=o?d(o):null,W=h(P,O,g),$=U?h(U,P,g):{added:[...P.keys()].reduce((F,B)=>(F.add(B),F),new Set),removed:new Set,updated:new Set},k=U?h(U,O,g):{added:[...O.keys()].reduce((F,B)=>(F.add(B),F),new Set),removed:new Set,updated:new Set},z=b(W,$,k);let A=c;for(const F of z.removed.values())z.conflicts.has(F)||(A=E(A,F,a));for(const F of z.added.values()){if(z.conflicts.has(F))continue;const B=O.get(F);if(B.some(Z=>Z.command!==`-${F}`&&S.conflicts.has(g[Z.key]))){z.conflicts.add(F);continue}A=m(A,B,a)}for(const F of z.updated.values()){if(z.conflicts.has(F))continue;const B=O.get(F);if(B.some(Z=>Z.command!==`-${F}`&&S.conflicts.has(g[Z.key]))){z.conflicts.add(F);continue}A=f(A,F,B,a)}return{mergeContent:A,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=w;function b(c,l,s){const a=new Set,n=new Set,t=new Set,r=new Set;for(const o of l.removed.values())s.updated.has(o)&&r.add(o);for(const o of s.removed.values())r.has(o)||(l.updated.has(o)?r.add(o):n.add(o));for(const o of l.added.values())r.has(o)||s.added.has(o)&&c.updated.has(o)&&r.add(o);for(const o of s.added.values())r.has(o)||(l.added.has(o)?c.updated.has(o)&&r.add(o):a.add(o));for(const o of l.updated.values())r.has(o)||s.updated.has(o)&&c.updated.has(o)&&r.add(o);for(const o of s.updated.values())r.has(o)||(l.updated.has(o)?c.updated.has(o)&&r.add(o):t.add(o));return{added:a,removed:n,updated:t,conflicts:r}}function I(c,l,s,a){const n=new Set,t=C(c,a),r=C(l,a),o=s?C(s,a):null,u=v(t,r);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const g=o?v(o,t):{added:[...t.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=o?v(o,r):{added:[...r.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:P,removed:O,updated:U,conflicts:W}=b(u,g,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:O,updated:U,conflicts:W}}function C(c,l){const s=new Map;for(const a of c){const n=l[a.key];let t=s.get(n);t||(t=[],s.set(n,t)),t.push(a)}return s}function d(c){const l=new Map;for(const s of c){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=l.get(a);n||(n=[],l.set(a,n)),n.push(s)}return l}function v(c,l){const s=[...c.keys()],a=[...l.keys()],n=a.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),t=s.filter(o=>a.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),r=new Set;for(const o of s){if(t.has(o))continue;const u=c.get(o).map(S=>({...S,key:o})),g=l.get(o).map(S=>({...S,key:o}));(0,T.equals)(u,g,(S,P)=>p(S,P))||r.add(o)}return{added:n,removed:t,updated:r}}function h(c,l,s){const a=[...c.keys()],n=[...l.keys()],t=n.filter(u=>a.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),r=a.filter(u=>n.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),o=new Set;for(const u of a){if(r.has(u))continue;const g=c.get(u).map(P=>({...P,key:s[P.key]})),S=l.get(u).map(P=>({...P,key:s[P.key]}));y(g,S)||o.add(u)}return{added:t,removed:r,updated:o}}function y(c,l){return!(!(0,T.equals)(c.filter(({command:s})=>s[0]!=="-"),l.filter(({command:s})=>s[0]!=="-"),(s,a)=>p(s,a))||!(0,T.equals)(c.filter(({command:s})=>s[0]==="-"),l.filter(({command:s})=>s[0]==="-"),(s,a)=>p(s,a)))}function p(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const s=L.ContextKeyExpr.deserialize(c.when),a=L.ContextKeyExpr.deserialize(l.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!D.equals(c.args,l.args))}function m(c,l,s){for(const a of l)c=i.edit(c,[-1],a,s);return c}function E(c,l,s){const a=R(c);for(let n=a.length-1;n>=0;n--)(a[n].command===l||a[n].command===`-${l}`)&&(c=i.edit(c,[n],void 0,s));return c}function f(c,l,s,a){const n=R(c),t=n.findIndex(r=>r.command===l||r.command===`-${l}`);for(let r=n.length-1;r>=0;r--)(n[r].command===l||n[r].command===`-${l}`)&&(c=i.edit(c,[r],void 0,a));for(let r=s.length-1;r>=0;r--)c=i.edit(c,[t],s[r],a);return c}}),define(te[220],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function T(L,i,R){const w={},b={},I=new Set;if(!i)return{local:{added:w,updated:b,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const C=_(L,i);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:w,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=_(R,L),v=_(R,i),h={},y={},p=new Set,m=new Set;for(const E of d.removed.values())v.updated.has(E)?w[E]=i[E]:p.add(E);for(const E of v.removed.values())m.has(E)||(d.updated.has(E)?m.add(E):I.add(E));for(const E of d.updated.values())m.has(E)||(v.updated.has(E)?C.updated.has(E)&&m.add(E):y[E]=L[E]);for(const E of v.updated.values())m.has(E)||(d.updated.has(E)?C.updated.has(E)&&m.add(E):L[E]!==void 0&&(b[E]=i[E]));for(const E of d.added.values())m.has(E)||(v.added.has(E)?C.updated.has(E)&&m.add(E):h[E]=L[E]);for(const E of v.added.values())m.has(E)||(d.added.has(E)?C.updated.has(E)&&m.add(E):w[E]=i[E]);return{local:{added:w,removed:[...I.values()],updated:b},remote:{added:h,removed:[...p.values()],updated:y},conflicts:[...m.values()]}}e.merge=T;function _(L,i){const R=L?Object.keys(L):[],w=i?Object.keys(i):[],b=w.filter(d=>R.indexOf(d)===-1).reduce((d,v)=>(d.add(v),d),new Set),I=R.filter(d=>w.indexOf(d)===-1).reduce((d,v)=>(d.add(v),d),new Set),C=new Set;for(const d of R){if(I.has(d))continue;const v=L[d],h=i[d];v!==h&&C.add(d)}return{added:b,removed:I,updated:C}}function D(L,i){const{added:R,removed:w,updated:b}=_(L,i);return R.size===0&&w.size===0&&b.size===0}e.areSame=D}),define(te[24],ne([0,1,17,18,15,148,42,30,6,87,37]),function(J,e,T,_,D,L,i,R,w,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const o=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function d(){const o=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(P=>!!o[P].ignoreSync),g=Object.keys(o).filter(P=>o[P].scope===2||o[P].scope===6),S=C();return(0,T.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...S])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function v(){const o="vscode://schemas/ignoredSettings",u=I.Registry.as(i.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=I.Registry.as(b.Extensions.JSONContribution),S=()=>{const P=C(),O=d().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(i.allSettings.properties).filter(k=>O.indexOf(k)===-1),W=O.filter(k=>P.indexOf(k)===-1),$={items:{type:"string",enum:[...U,...W.map(k=>`-${k}`)]}};g.registerSchema(o,$)};return u.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=v;function h(o){return o&&(0,D.isObject)(o)&&(0,D.isString)(o.id)&&(0,D.isArray)(o.scopes)}e.isAuthenticationProvider=h;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function p(o,u,g){return g.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=p,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=m;var E;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(E=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(u,g,S,P){super(u);this.code=g,this.resource=S,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class c extends f{constructor(u,g,S,P,O){super(u,S,void 0,O);this.url=g,this.serverCode=P}}e.UserDataSyncStoreError=c;class l extends f{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=l,function(o){function u(g){if(g instanceof o)return g;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(S&&S[1]){const P=S[2]==="unknown"?void 0:S[2],O=S[3]==="unknown"?void 0:S[3];return new o(g.message,S[1],P,O)}return new o(g.message,"Unknown")}o.toUserDataSyncError=u}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function r(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,_.isEqualOrParent)(o,(0,_.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=r}),define(te[47],ne([0,1,17,5,19,27,3,31,2,25,15,7,144,21,11,14,8,46,23,22,36,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=s;let a=class extends w.Disposable{constructor(u,g,S,P,O,U,W,$,k,z,A){super();this.resource=u,this.fileService=g,this.environmentService=S,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=W,this.telemetryService=$,this.logService=k,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new _.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=A.extUri,this.syncFolder=this.extUri.joinPath(S.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(u,S,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(S,g,P)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const g=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(g)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,this.getUserDataSyncConfiguration(),L.CancellationToken.None)).resourcePreviews.some(({remoteChange:S})=>S!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const g=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),g==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,g={}){await this._sync(u,!0,this.getUserDataSyncConfiguration(),g)}async preview(u,g,S={}){return this._sync(u,!1,g,S)}async apply(u,g={}){try{this.syncHeaders={...g};const S=await this.doApply(u);return this.setStatus(S),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,g,S,P){try{if(this.syncHeaders={...P},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const U=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(u,U);return O=await this.performSync(W,U,g,S),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(u){const g=await this.resolveContent(u);if(!g)return!1;const S=this.parseSyncData(g);if(!S)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const P=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,P),U=await this.isRemoteDataFromCurrentMachine(O),W=await this.generateSyncPreview({ref:O.ref,syncData:S},P,U,this.getUserDataSyncConfiguration(),L.CancellationToken.None),$=[];for(const k of W){const z=await this.getAcceptResult(k,k.remoteResource,void 0,L.CancellationToken.None),{remoteChange:A}=await this.getAcceptResult(k,k.previewResource,k.remoteContent,L.CancellationToken.None);$.push([k,{...z,remoteChange:A!==0?A:2}])}await this.applyResult(O,P,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(u){const g=await this.currentMachineIdPromise;return!!u.syncData?.machineId&&u.syncData.machineId===g}async getLatestRemoteUserData(u,g){if(g){const S=u&&u.latest?u.latest[this.resource]:void 0;if(g.ref===S||S===void 0&&g.syncData===null)return g}return this.getRemoteUserData(g)}async performSync(u,g,S,P){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,u.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(u,g,S,P)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,g,S,P);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),g=await this.getLastSyncUserData(),this.performSync(u,g,S,P)}throw O}}async doSync(u,g,S,P){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,_.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(u,g,S,P,U)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":S?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(u){return await this.updateSyncResourcePreview(u,async g=>{const S=await this.getMergeResult(g,L.CancellationToken.None);await this.fileService.writeFile(g.previewResource,D.VSBuffer.fromString(S?.content||""));const P=S&&!S.hasConflicts?await this.getAcceptResult(g,g.previewResource,void 0,L.CancellationToken.None):void 0;return g.acceptResult=P,g.mergeState=S.hasConflicts?"conflict":P?"accepted":"preview",g.localChange=P?P.localChange:S.localChange,g.remoteChange=P?P.remoteChange:S.remoteChange,g}),this.syncPreviewPromise}async accept(u,g){return await this.updateSyncResourcePreview(u,async S=>{const P=await this.getAcceptResult(S,u,g,L.CancellationToken.None);return S.acceptResult=P,S.mergeState="accepted",S.localChange=P.localChange,S.remoteChange=P.remoteChange,S}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async g=>{const S=await this.getMergeResult(g,L.CancellationToken.None);return await this.fileService.writeFile(g.previewResource,D.VSBuffer.fromString(S.content||"")),g.acceptResult=void 0,g.mergeState="preview",g.localChange=S.localChange,g.remoteChange=S.remoteChange,g}),this.syncPreviewPromise}async updateSyncResourcePreview(u,g){if(!this.syncPreviewPromise)return;let S=await this.syncPreviewPromise;const P=S.resourcePreviews.findIndex(({localResource:O,remoteResource:U,previewResource:W})=>this.extUri.isEqual(O,u)||this.extUri.isEqual(U,u)||this.extUri.isEqual(W,u));P!==-1&&(this.syncPreviewPromise=(0,_.createCancelablePromise)(async O=>{const U=[...S.resourcePreviews];return U[P]=await g(U[P]),{...S,resourcePreviews:U}}),S=await this.syncPreviewPromise,this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const g=await this.syncPreviewPromise;return g.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":g.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.applyResult(g.remoteUserData,g.lastSyncUserData,g.resourcePreviews.map(S=>[S,S.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const g=u.filter(({mergeState:S})=>S==="conflict");(0,T.equals)(this._conflicts,g,(S,P)=>this.extUri.isEqual(S.previewResource,P.previewResource))||(this._conflicts=g,this._onDidChangeConflicts.fire(g))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:g,ref:S})=>({created:g,uri:this.toRemoteBackupResource(S)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:g,ref:S})=>({created:g,uri:this.toLocalBackupResource(S)}))}toRemoteBackupResource(u){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const g=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(g))){const{content:S}=await this.getUserData(g);if(S)return this.parseSyncData(S)?.machineId}}async resolveContent(u){const g=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(g))){const{content:S}=await this.getUserData(g);return S}return this.extUri.isEqual(u,this.toLocalBackupResource(g))?this.userDataSyncBackupStoreService.resolveContent(this.resource,g):null}async resolvePreviewContent(u){const g=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(g)for(const S of g.resourcePreviews){if(this.extUri.isEqual(S.acceptedResource,u))return S.acceptResult?S.acceptResult.content:null;if(this.extUri.isEqual(S.remoteResource,u))return S.remoteContent;if(this.extUri.isEqual(S.localResource,u))return S.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,g,S,P,O){const U=await this.isRemoteDataFromCurrentMachine(u),W=await this.generateSyncPreview(u,g,U,P,O),$=[];for(const k of W){const z=k.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(k.localChange===0&&k.remoteChange===0)$.push({...k,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const A=S?await this.getMergeResult(k,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(k.previewResource,D.VSBuffer.fromString(A?.content||""));const F=A&&!A.hasConflicts?await this.getAcceptResult(k,k.previewResource,void 0,O):void 0;$.push({...k,acceptResult:F,mergeState:A?.hasConflicts?"conflict":F?"accepted":"preview",localChange:F?F.localChange:A?A.localChange:k.localChange,remoteChange:F?F.remoteChange:A?A.remoteChange:k.remoteChange})}}return{remoteUserData:u,lastSyncUserData:g,resourcePreviews:$,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),g=JSON.parse(u.value.toString()),S=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=g.version&&S&&g.version!==S,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${g.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;const P=g;if(P.content===null)return{ref:g.ref,syncData:null};const O=JSON.parse(P.content);if(s(O))return{...g,syncData:O,content:void 0}}catch(u){u instanceof y.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,g={}){if(g.ref||g.content||g.version)throw new Error("Cannot have core properties as additional");const S=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),P={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:S,...g};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(P)))}async getRemoteUserData(u){const{ref:g,content:S}=await this.getUserData(u);let P=null;return S!==null&&(P=this.parseSyncData(S)),{ref:g,syncData:P}}parseSyncData(u){try{const g=JSON.parse(u);if(s(g))return g}catch(g){this.logService.error(g)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(u){if((0,I.isString)(u)){const g=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:g}}else{const g=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,g,this.syncHeaders)}}async updateRemoteUserData(u,g){const S=await this.currentMachineIdPromise,P={version:this.version,machineId:S,content:u};return g=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(P),g,this.syncHeaders),{ref:g,syncData:P}}async backupLocal(u){const g={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(g))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([G(1,y.IFileService),G(2,h.IEnvironmentService),G(3,E.IStorageService),G(4,l.IUserDataSyncStoreService),G(5,l.IUserDataSyncBackupStoreService),G(6,l.IUserDataSyncResourceEnablementService),G(7,f.ITelemetryService),G(8,l.IUserDataSyncLogService),G(9,v.IConfigurationService),G(10,c.IUriIdentityService)],a),e.AbstractSynchroniser=a;let n=class extends a{constructor(u,g,S,P,O,U,W,$,k,z,A,F){super(g,S,P,O,U,W,$,k,z,A,F);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,g,S){try{g?await this.writeFileContent(u,g,S):await this.fileService.createFile(this.file,D.VSBuffer.fromString(u),{overwrite:S})}catch(P){throw P instanceof y.FileOperationError&&P.fileOperationResult===1||P instanceof y.FileOperationError&&P.fileOperationResult===3?new l.UserDataSyncError(P.message,"LocalPreconditionFailed"):P}}async writeFileContent(u,g,S){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(u),S?void 0:g)}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=de([G(2,y.IFileService),G(3,h.IEnvironmentService),G(4,E.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncResourceEnablementService),G(8,f.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,v.IConfigurationService),G(11,c.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(u,g,S,P,O,U,W,$,k,z,A,F,B){super(u,g,S,P,O,U,W,$,k,z,F,B);this.userDataSyncUtilService=A,this._formattingOptions=void 0}hasErrors(u){const g=[];return(0,R.parse)(u,g,{allowEmptyContent:!0,allowTrailingComma:!0}),g.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([G(2,y.IFileService),G(3,h.IEnvironmentService),G(4,E.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncResourceEnablementService),G(8,f.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,l.IUserDataSyncUtilService),G(11,v.IConfigurationService),G(12,c.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let r=class{constructor(u,g,S,P,O){this.resource=u,this.environmentService=g,this.logService=S,this.fileService=P,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,g,this.extUri)}async initialize({ref:u,content:g}){if(!g){this.logService.info("Remote content does not exist.",this.resource);return}const S=this.parseSyncData(g);if(!!S)try{await this.doInitialize({ref:u,syncData:S})}catch(P){this.logService.error(P)}}parseSyncData(u){try{const g=JSON.parse(u);if(s(g))return g}catch(g){this.logService.error(g)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,g={}){const S={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,...g};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(S)))}};r=de([G(1,h.IEnvironmentService),G(2,p.ILogService),G(3,y.IFileService),G(4,c.IUriIdentityService)],r),e.AbstractInitializer=r}),define(te[221],ne([0,1,5,27,9,3,39,48,25,7,21,11,30,35,14,8,23,22,36,47,218,97,98,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(g,S){const P=JSON.parse(g.content);if(g.version===1||g.version===2){const O=(await S.getInstalled(0)).filter(U=>U.isBuiltin);for(const U of P)g.version===1&&(U.enabled===!1&&(U.disabled=!0),delete U.enabled),g.version===2&&O.every(W=>!(0,v.areSameExtensions)(W.identifier,U.identifier))&&(U.installed=!0)}return P}function t(g,S,P){const O=P.get((0,v.getExtensionId)(g,S),0)||"{}";return JSON.parse(O)}e.getExtensionStorageState=t;function r(g,S,P,O){O.store((0,v.getExtensionId)(g,S),JSON.stringify(P),0,1)}e.storeExtensionStorageState=r;let o=class mt extends f.AbstractSynchroniser{constructor(S,P,O,U,W,$,k,z,A,F,B,Z,V,j,Q){super("extensions",P,S,O,U,W,Z,V,A,B,Q);this.storageService=O,this.extensionManagementService=$,this.extensionEnablementService=k,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=F,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,M=>M.some(({local:N})=>!!N)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,M=>!M.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(S,P){const O=S.syncData?await n(S.syncData,this.extensionManagementService):null,U=P?.skippedExtensions||[],W=P?.syncData?await n(P.syncData,this.extensionManagementService):null,$=await this.extensionManagementService.getInstalled(void 0,!0),k=this.getLocalExtensions($),z=this.ignoredExtensionsManagementService.getIgnoredExtensions($);O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:A,remote:F}=(0,c.merge)(k,O,W,U,z),B={local:A,remote:F,content:this.getPreviewContent(k,A.added,A.updated,A.removed),localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:U,localResource:this.localResource,localContent:this.format(k),localExtensions:k,remoteResource:this.remoteResource,remoteContent:O?this.format(O):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(S,P,O,U){const W=[...P,...O],$=new Set,k=z=>{$.add(z.id.toLowerCase()),z.uuid&&$.add(z.uuid)};W.forEach(({identifier:z})=>k(z)),U.forEach(k);for(const z of S)$.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&$.has(z.identifier.uuid)||W.push(z);return this.format(W)}async getMergeResult(S,P){return{...S.previewResult,hasConflicts:!1}}async getAcceptResult(S,P,O,U){if(this.extUri.isEqual(P,this.localResource))return this.acceptLocal(S);if(this.extUri.isEqual(P,this.remoteResource))return this.acceptRemote(S);if(this.extUri.isEqual(P,this.previewResource))return S.previewResult;throw new Error(`Invalid Resource: ${P.toString()}`)}async acceptLocal(S){const P=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(P),U=(0,c.merge)(S.localExtensions,null,null,S.skippedExtensions,O),{local:W,remote:$}=U;return{content:S.localContent,local:W,remote:$,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:$!==null?2:0}}async acceptRemote(S){const P=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(P),U=S.remoteContent?JSON.parse(S.remoteContent):null;if(U!==null){const W=(0,c.merge)(S.localExtensions,U,S.localExtensions,[],O),{local:$,remote:k}=W;return{content:S.remoteContent,local:$,remote:k,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:S.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(S,P,O,U){let{skippedExtensions:W,localExtensions:$}=O[0][0],{local:k,remote:z,localChange:A,remoteChange:F}=O[0][1];if(A===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),A!==0&&(await this.backupLocal(JSON.stringify($)),W=await this.updateLocalExtensions(k.added,k.removed,k.updated,W)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify(z.all);S=await this.updateRemoteUserData(B,U?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(Z=>Z.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(Z=>Z.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(Z=>Z.identifier.id))}.`:""}`)}P?.ref!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(S,{skippedExtensions:W}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${W.length?` Skipped: ${JSON.stringify(W.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:S}){return[{resource:this.extUri.joinPath(S,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(S){if(this.extUri.isEqual(S,mt.EXTENSIONS_DATA_URI)){const O=await this.extensionManagementService.getInstalled(),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(O),W=this.getLocalExtensions(O).filter($=>!U.some(k=>(0,v.areSameExtensions)({id:k},$.identifier)));return this.format(W)}if(this.extUri.isEqual(this.remoteResource,S)||this.extUri.isEqual(this.localResource,S)||this.extUri.isEqual(this.acceptedResource,S))return this.resolvePreviewContent(S);let P=await super.resolveContent(S);if(P)return P;if(P=await super.resolveContent(this.extUri.dirname(S)),P){const O=this.parseSyncData(P);if(O)switch(this.extUri.basename(S)){case"extensions.json":return this.format(this.parseExtensions(O))}}return null}format(S){S.sort((U,W)=>!U.identifier.uuid&&W.identifier.uuid?-1:U.identifier.uuid&&!W.identifier.uuid?1:(0,w.compare)(U.identifier.id,W.identifier.id));const P=JSON.stringify(S),O=(0,R.format)(P,void 0,{});return(0,i.applyEdits)(P,O)}async hasLocalData(){try{const S=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(S).some(O=>O.installed||O.disabled))return!0}catch(S){}return!1}async updateLocalExtensions(S,P,O,U){const W=[],$=[],k=await this.extensionManagementService.getInstalled();if(P.length){const A=k.filter(({identifier:F,isBuiltin:B})=>!B&&P.some(Z=>(0,v.areSameExtensions)(F,Z)));await T.Promises.settled(A.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),W.push(F.identifier)}))}(S.length||O.length)&&await T.Promises.settled([...S,...O].map(async A=>{const F=k.find(Z=>(0,v.areSameExtensions)(Z.identifier,A.identifier));if(F&&F.isBuiltin){A.state&&F.manifest.version===A.version&&this.updateExtensionState(A.state,F.manifest.publisher,F.manifest.name,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(V=>(0,v.areSameExtensions)(V,A.identifier))!==!!A.disabled&&(A.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,A.identifier.id),await this.extensionEnablementService.disableExtension(A.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,A.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,A.identifier.id),await this.extensionEnablementService.enableExtension(A.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,A.identifier.id))),W.push(A.identifier);return}const B=(await this.extensionGalleryService.getExtensions([A.identifier],!!A.preRelease,_.CancellationToken.None))[0];if(A.state&&(F?F.manifest.version===A.version:!!B)){const Z=F?F.manifest.publisher:B.publisher,V=F?F.manifest.name:B.name;this.updateExtensionState(A.state,Z,V,F?.manifest.version)}if(B)try{this.extensionEnablementService.getDisabledExtensions().some(V=>(0,v.areSameExtensions)(V,A.identifier))!==!!A.disabled&&(A.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,A.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,A.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,A.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,A.identifier.id,B.version))),(!F||F.preRelease!==A.preRelease)&&(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,A.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:A.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,A.identifier.id,B.version),W.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),$.push(A)))}catch(Z){$.push(A),Z instanceof d.ExtensionManagementError&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatiblePreRelease,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(Z.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):(this.logService.error(Z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id))}else $.push(A),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,A.identifier.id)}));const z=[];for(const A of U)W.some(F=>(0,v.areSameExtensions)(F,A.identifier))||z.push(A);for(const A of $)z.some(F=>(0,v.areSameExtensions)(F.identifier,A.identifier))||z.push(A);return z}updateExtensionState(S,P,O,U){const W=t(P,O,this.storageService),$=U?this.extensionsStorageSyncService.getKeysForSync({id:(0,v.getGalleryExtensionId)(P,O),version:U}):void 0;$?$.forEach(k=>{W[k]=S[k]}):Object.keys(S).forEach(k=>W[k]=S[k]),r(P,O,W,this.storageService)}parseExtensions(S){return JSON.parse(S.content)}getLocalExtensions(S){const P=this.extensionEnablementService.getDisabledExtensions();return S.map(({identifier:O,isBuiltin:U,manifest:W,preRelease:$})=>{const k={identifier:O,version:W.version,preRelease:$};P.some(z=>(0,v.areSameExtensions)(z,O))&&(k.disabled=!0),U||(k.installed=!0);try{const z=this.extensionsStorageSyncService.getKeysForSync({id:O.id,version:W.version});if(z){const A=t(W.publisher,W.name,this.storageService);k.state=Object.keys(A).reduce((F,B)=>(z.includes(B)&&(F[B]=A[B]),F),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(z))}return k})}};o.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),o=de([G(0,C.IEnvironmentService),G(1,h.IFileService),G(2,p.IStorageService),G(3,a.IUserDataSyncStoreService),G(4,a.IUserDataSyncBackupStoreService),G(5,d.IExtensionManagementService),G(6,d.IGlobalExtensionEnablementService),G(7,s.IIgnoredExtensionsManagementService),G(8,a.IUserDataSyncLogService),G(9,d.IExtensionGalleryService),G(10,I.IConfigurationService),G(11,a.IUserDataSyncResourceEnablementService),G(12,m.ITelemetryService),G(13,l.IExtensionsStorageSyncService),G(14,E.IUriIdentityService)],o),e.ExtensionsSynchroniser=o;let u=class extends f.AbstractInitializer{constructor(S,P,O,U,W,$){super("extensions",U,W,O,$);this.extensionManagementService=S,this.ignoredExtensionsManagementService=P}async parseExtensions(S){return S.syncData?await n(S.syncData,this.extensionManagementService):null}generatePreview(S,P){const O=[],U=[],W=[];for(const $ of S){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension($.identifier.id))continue;const k=P.find(z=>(0,v.areSameExtensions)(z.identifier,$.identifier));k?(O.push(k),$.disabled&&W.push($.identifier)):$.installed&&(U.push($.identifier),$.disabled&&W.push($.identifier))}return{installedExtensions:O,newExtensions:U,disabledExtensions:W,remoteExtensions:S}}};u=de([G(0,d.IExtensionManagementService),G(1,s.IIgnoredExtensionsManagementService),G(2,h.IFileService),G(3,C.IEnvironmentService),G(4,y.ILogService),G(5,E.IUriIdentityService)],u),e.AbstractExtensionsInitializer=u}),define(te[222],ne([0,1,28,24]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,w,b,I,C){if(!w)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const d=L(R,w);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=b?L(b,w):{added:Object.keys(w).reduce((E,f)=>(E.add(f),E),new Set),removed:new Set,updated:new Set},h=b?L(b,R):{added:Object.keys(R).reduce((E,f)=>(E.add(f),E),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},p=T.deepClone(w),m=!b;for(const E of h.added.values())E!==_.SYNC_SERVICE_URL_TYPE&&m&&v.added.has(E)||(p[E]=R[E]);for(const E of h.updated.values())p[E]=R[E];for(const E of h.removed.values())I.unregistered.includes(E)||delete p[E];for(const E of v.added.values()){const f=w[E];if(I.machine.includes(E)){C.info(`GlobalState: Skipped adding ${E} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(E))continue;const c=R[E];c&&c.value===f.value||E===_.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(E)||(c?y.updated[E]=f:y.added[E]=f)}for(const E of v.updated.values()){const f=w[E];if(I.machine.includes(E)){C.info(`GlobalState: Skipped updating ${E} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(E)||h.removed.has(E))continue;const c=R[E];c&&c.value===f.value||(y.updated[E]=f)}for(const E of v.removed.values()){if(I.machine.includes(E)){C.trace(`GlobalState: Skipped removing ${E} in local storage because it is declared as machine scoped.`);continue}h.updated.has(E)||h.removed.has(E)||y.removed.push(E)}return{local:y,remote:i(p,w)?null:p}}e.merge=D;function L(R,w){const b=Object.keys(R),I=Object.keys(w),C=I.filter(h=>b.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),d=b.filter(h=>I.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),v=new Set;for(const h of b){if(d.has(h))continue;const y=R[h],p=w[h];T.equals(y,p)||v.add(h)}return{added:C,removed:d,updated:v}}function i(R,w){const{added:b,removed:I,updated:C}=L(R,w);return b.size===0&&I.size===0&&C.size===0}}),define(te[223],ne([0,1,19,9,3,31,39,48,4,7,29,21,11,14,8,46,23,22,36,47,55,222,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",n=["locale"];function t(S){const P=S.storage?Object.keys(S.storage).sort():[],O={};P.forEach($=>O[$]=S.storage[$]),S.storage=O;const U=JSON.stringify(S),W=(0,R.format)(U,void 0,{});return(0,i.applyEdits)(U,W)}const r=1;let o=class vt extends f.AbstractSynchroniser{constructor(P,O,U,W,$,k,z,A,F,B){super("globalState",P,$,F,O,U,k,z,W,A,B);this.storageService=F,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(P.onDidFilesChange,Z=>Z.contains(this.environmentService.argvResource)),D.Event.filter(F.onDidChangeValue,Z=>Z.scope===0&&Z.target!==void 0?Z.target===0:F.keys(0,0).includes(Z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(P,O,U){const W=P.syncData?JSON.parse(P.syncData.content):null;O=O===null&&U?P:O;const $=O&&O.syncData?JSON.parse(O.syncData.content):null,k=await this.getLocalGlobalState();W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys($),{local:A,remote:F}=(0,l.merge)(k.storage,W?W.storage:null,$?$.storage:null,z,this.logService),B={content:null,local:A,remote:F,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:F!==null?2:0};return[{localResource:this.localResource,localContent:t(k),localUserData:k,remoteResource:this.remoteResource,remoteContent:W?t(W):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(P,O){return{...P.previewResult,hasConflicts:!1}}async getAcceptResult(P,O,U,W){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(P);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(P);if(this.extUri.isEqual(O,this.previewResource))return P.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:P.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(P){if(P.remoteContent!==null){const O=JSON.parse(P.remoteContent),{local:U,remote:W}=(0,l.merge)(P.localUserData.storage,O.storage,null,P.storageKeys,this.logService);return{content:P.remoteContent,local:U,remote:W,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(P,O,U,W){let{localUserData:$}=U[0][0],{local:k,remote:z,localChange:A,remoteChange:F}=U[0][1];if(A===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),A!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify($)),await this.writeLocalGlobalState(k),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),F!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const B=JSON.stringify({storage:z});P=await this.updateRemoteUserData(B,W?null:P.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==P.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(P),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:P}){return[{resource:this.extUri.joinPath(P,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(P){if(this.extUri.isEqual(P,vt.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return t(U)}if(this.extUri.isEqual(this.remoteResource,P)||this.extUri.isEqual(this.localResource,P)||this.extUri.isEqual(this.acceptedResource,P))return this.resolvePreviewContent(P);let O=await super.resolveContent(P);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(P)),O){const U=this.parseSyncData(O);if(U)switch(this.extUri.basename(P)){case"globalState.json":return t(JSON.parse(U.content))}}return null}async hasLocalData(){try{const{storage:P}=await this.getLocalGlobalState();if(Object.keys(P).length>1||P[`${a}.locale`]?.value!=="en")return!0}catch(P){}return!1}async getLocalGlobalState(){const P={},O=await this.getLocalArgvContent(),U=(0,L.parse)(O);for(const W of n)U[W]!==void 0&&(P[`${a}${W}`]={version:1,value:U[W]});for(const W of this.storageService.keys(0,0)){const $=this.storageService.get(W,0);$&&(P[W]={version:1,value:$})}return{storage:P}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const P=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),P.value.toString()}catch(P){this.logService.debug((0,_.getErrorMessage)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:O,updated:U}){const W={},$={},k=(A,F)=>{for(const B of A){if(B.startsWith(a)){W[B.substring(a.length)]=F?F[B].value:void 0;continue}if(F){const Z=F[B];Z.value!==String(this.storageService.get(B,0))&&($[B]=Z.value)}else this.storageService.get(B,0)!==void 0&&($[B]=void 0)}};if(k(Object.keys(P),P),k(Object.keys(U),U),k(O),Object.keys(W).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(W),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys($).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const A of Object.keys($))this.storageService.store(A,$[A],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys($))}}async updateArgv(P){const O=await this.getLocalArgvContent();let U=O;for(const W of Object.keys(P))U=(0,c.edit)(U,[W],P[W],{});O!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(P){const O=this.storageService.keys(0,0),U=this.storageService.keys(0,1),W=[...O,...U],$=P?.storage?Object.keys(P.storage).filter(k=>!k.startsWith(a)&&!W.includes(k)&&this.storageService.get(k,0)!==void 0):[];if(!w.isWeb){const k=[...s.ALL_SYNC_RESOURCES.map(z=>(0,s.getEnablementKey)(z)),s.SYNC_SERVICE_URL_TYPE];$.push(...k),U.push(...k)}return{user:O,machine:U,unregistered:$}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([G(0,v.IFileService),G(1,s.IUserDataSyncStoreService),G(2,s.IUserDataSyncBackupStoreService),G(3,s.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,s.IUserDataSyncResourceEnablementService),G(6,m.ITelemetryService),G(7,C.IConfigurationService),G(8,p.IStorageService),G(9,E.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let u=class extends f.AbstractInitializer{constructor(P,O,U,W,$){super("globalState",U,W,O,$);this.storageService=P}async doInitialize(P){const O=P.syncData?JSON.parse(P.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},W={};for(const $ of Object.keys(O.storage))$.startsWith(a)?U[$.substring(a.length)]=O.storage[$].value:this.storageService.get($,0)===void 0&&(W[$]=O.storage[$].value);if(Object.keys(U).length){let $="{}";try{$=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(k){}for(const k of Object.keys(U))$=(0,c.edit)($,[k],U[k],{});await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString($))}if(Object.keys(W).length)for(const $ of Object.keys(W))this.storageService.store($,W[$],0,0)}};u=de([G(0,p.IStorageService),G(1,v.IFileService),G(2,d.IEnvironmentService),G(3,s.IUserDataSyncLogService),G(4,E.IUriIdentityService)],u),e.GlobalStateInitializer=u;let g=class{constructor(P,O,U,W,$){this.userDataSyncStoreClient=P,this.storageService=O,this.environmentService=U,this.fileService=W,this.logService=$}getSyncStoreType(P){return this.parseGlobalState(P)?.storage[s.SYNC_SERVICE_URL_TYPE]?.value}async sync(P){const O=(0,s.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(P,O)}catch(U){if(U instanceof s.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(P,O)}throw U}}async doSync(P,O){const U=await this.userDataSyncStoreClient.read("globalState",null,O),W=this.parseGlobalState(U)||{storage:{}};W.storage[s.SYNC_SERVICE_URL_TYPE]={value:P,version:r};const $=await(0,y.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),k={version:r,machineId:$,content:t(W)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(k),U.ref,O)}parseGlobalState({content:P}){if(!P)return null;const O=JSON.parse(P);if((0,f.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};g=de([G(1,p.IStorageService),G(2,d.IEnvironmentService),G(3,v.IFileService),G(4,h.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(te[224],ne([0,1,17,19,3,31,4,15,145,21,11,14,23,22,36,47,219,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(l,s,a){try{const n=JSON.parse(l);if(!s)return(0,R.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return a.error(n),null}}e.getKeybindingsContentFromSyncContent=E;let f=class extends y.AbstractJsonFileSynchroniser{constructor(s,a,n,t,r,o,u,g,S,P,O){super(u.keybindingsResource,"keybindings",o,u,g,s,a,r,P,n,S,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,a,n,t){const r=s.syncData?E(s.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&n?s:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,u=await this.getLocalFileContent(),g=await this.getFormattingOptions();let S=null,P=!1,O=!1,U=!1;if(r){let $=u?u.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new m.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const k=await(0,p.merge)($,r,o,g,this.userDataSyncUtilService);k.hasChanges&&(S=k.mergeContent,U=k.hasConflicts,P=U||k.mergeContent!==$,O=U||k.mergeContent!==r)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),S=u.value.toString(),O=!0);const W={content:S,localChange:P?u?2:1:0,remoteChange:O?2:0,hasConflicts:U};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async getMergeResult(s,a){return s.previewResult}async getAcceptResult(s,a,n,t){if(this.extUri.isEqual(a,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(s,a,n,t){const{fileContent:r}=n[0][0];let{content:o,localChange:u,remoteChange:g}=n[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new m.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(o||"[]",r,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const S=this.toSyncContent(o||"[]",s.syncData?.content);s=await this.updateRemoteUserData(S,t?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(S){}a?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const a=(0,L.parse)(s.value.toString());if((0,T.isNonEmptyArray)(a))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:a}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let a=await super.resolveContent(s);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(s)),a){const n=this.parseSyncData(a);if(n)switch(this.extUri.basename(s)){case"keybindings.json":return E(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:E(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,a){let n={};try{n=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=s,i.OS){case 2:n.mac=s;break;case 3:n.linux=s;break;case 1:n.windows=s;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=de([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncBackupStoreService),G(2,m.IUserDataSyncLogService),G(3,b.IConfigurationService),G(4,m.IUserDataSyncResourceEnablementService),G(5,C.IFileService),G(6,I.IEnvironmentService),G(7,d.IStorageService),G(8,m.IUserDataSyncUtilService),G(9,v.ITelemetryService),G(10,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends y.AbstractInitializer{constructor(s,a,n,t){super("keybindings",a,n,s,t)}async doInitialize(s){const a=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,_.VSBuffer.fromString(a)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,L.parse)(s.value.toString());return!(0,T.isNonEmptyArray)(a)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return E(s,!0,this.logService)}catch(a){return this.logService.error(a),null}}};c=de([G(0,C.IFileService),G(1,I.IEnvironmentService),G(2,m.IUserDataSyncLogService),G(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(te[225],ne([0,1,17,31,39,48,28,55,24]),function(J,e,T,_,D,L,i,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(o,u,g){let S=[];g?S=C(g):S=I(u);const P=[],O=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const U of S)U.startsWith("-")?O.push(U.substring(1)):P.push(U);return(0,T.distinct)([...o,...P].filter(U=>O.indexOf(U)===-1))}e.getIgnoredSettings=b;function I(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function C(o){const u=(0,_.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(o,u,g,S){if(g.length){const P=r(u),O=(0,_.parse)(u),U=(0,_.parse)(o),W=[];for(const $ of g){const k=O[$],z=U[$];k===void 0?o=R.edit(o,[$],void 0,S):z!==void 0?o=R.edit(o,[$],k,S):W.push(l($,P))}W.sort(($,k)=>$.startOffset-k.startOffset),W.forEach($=>o=m($.setting.key,u,o,S))}return o}e.updateIgnoredSettings=d;function v(o,u,g,S,P,O){const U=d(o,u,S,O),W=g!==U,$=g!==u;if(!W&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(W&&!$)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if($&&!W)return{conflictsSettings:[],localContent:d(u,o,S,O),remoteContent:null,hasConflicts:!1};if(g===null&&y(o)){const H=h(o,u,S)?null:d(u,o,S,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let k=o,z=u;const A=(0,_.parse)(o),F=(0,_.parse)(u),B=g?(0,_.parse)(g):null,Z=S.reduce((H,X)=>(H.add(X),H),new Set),V=p(A,F,Z),j=p(B,A,Z),Q=p(B,F,Z),M=new Map,N=new Set,q=H=>{N.add(H);const X=P.filter(({key:re})=>re===H)[0];X?(k=R.edit(k,[H],X.value,O),z=R.edit(z,[H],X.value,O)):M.set(H,{key:H,localValue:A[H],remoteValue:F[H]})};for(const H of j.removed.values())Q.updated.has(H)?q(H):z=R.edit(z,[H],void 0,O);for(const H of Q.removed.values())N.has(H)||(j.updated.has(H)?q(H):k=R.edit(k,[H],void 0,O));for(const H of j.updated.values())N.has(H)||(Q.updated.has(H)?V.updated.has(H)&&q(H):z=R.edit(z,[H],A[H],O));for(const H of Q.updated.values())N.has(H)||(j.updated.has(H)?V.updated.has(H)&&q(H):k=R.edit(k,[H],F[H],O));for(const H of j.added.values())N.has(H)||(Q.added.has(H)?V.updated.has(H)&&q(H):z=m(H,k,z,O));for(const H of Q.added.values())N.has(H)||(j.added.has(H)?V.updated.has(H)&&q(H):k=m(H,z,k,O));const x=M.size>0||!h(k,z,S),K=x||!h(k,o,[]),ee=x||!h(z,u,[]);return{localContent:K?k:null,remoteContent:ee?z:null,conflictsSettings:[...M.values()],hasConflicts:x}}e.merge=v;function h(o,u,g){if(o===u)return!0;const S=(0,_.parse)(o),P=(0,_.parse)(u),O=g.reduce(($,k)=>($.add(k),$),new Set),U=r(o).filter($=>!($.setting&&O.has($.setting.key))),W=r(u).filter($=>!($.setting&&O.has($.setting.key)));if(U.length!==W.length)return!1;for(let $=0;$<U.length;$++){const k=U[$],z=W[$];if(k.setting&&z.setting){if(k.setting.key!==z.setting.key||!i.equals(S[k.setting.key],P[k.setting.key]))return!1}else if(!k.setting&&!z.setting){if(k.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function y(o){return o?r(o).length===0:!0}e.isEmpty=y;function p(o,u,g){const S=o?Object.keys(o).filter($=>!g.has($)):[],P=Object.keys(u).filter($=>!g.has($)),O=P.filter($=>S.indexOf($)===-1).reduce(($,k)=>($.add(k),$),new Set),U=S.filter($=>P.indexOf($)===-1).reduce(($,k)=>($.add(k),$),new Set),W=new Set;if(o)for(const $ of S){if(U.has($))continue;const k=o[$],z=u[$];i.equals(k,z)||W.add($)}return{added:O,removed:U,updated:W}}function m(o,u,g,S){const P=(0,_.parse)(u),O=r(u),U=r(g),W=E(o,O,U);return f(g,o,P[o],W,U,S)}e.addSetting=m;function E(o,u,g){const S=u.findIndex(O=>O.setting?.key===o),P=u[S-1];if(P){if(P.setting){const U=l(P.setting.key,g);if(U)return{index:g.indexOf(U),insertAfter:!0}}else{const U=s(S,u);if(U){const W=l(U.setting.key,g);if(W){const $=a(g.indexOf(W),g),k=n(u,U,u[S]);if($){const z=n(g,W,$),A=t(k,z);return A?{index:g.indexOf(A),insertAfter:!0}:{index:g.indexOf($),insertAfter:!1}}else{const z=n(g,W,g[g.length-1]),A=t(k,z);return A?{index:g.indexOf(A),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const O=u[S+1];if(O)if(O.setting){const U=l(O.setting.key,g);if(U)return{index:g.indexOf(U),insertAfter:!1}}else{const U=a(S,u);if(U){const W=l(U.setting.key,g);if(W){const $=s(g.indexOf(W),g),k=n(u,u[S],U);if($){const z=n(g,$,W),A=t(k.reverse(),z.reverse());return A?{index:g.indexOf(A),insertAfter:!1}:{index:g.indexOf($),insertAfter:!0}}else{const z=n(g,g[0],W),A=t(k.reverse(),z.reverse());return A?{index:g.indexOf(A),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(o,u,g,S,P,O){let U;return S.index===-1?U=(0,D.setProperty)(o,[u],g,O):U=c(o,u,g,S,P,O).map(W=>(0,D.withFormatting)(o,W,O)[0]),(0,D.applyEdits)(o,U)}function c(o,u,g,S,P,O){const U=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,W=(0,L.getEOL)(O,o),$=P[S.index];if(S.insertAfter){const k=[];if($.setting)k.push({offset:$.endOffset,length:0,content:","+U});else{const z=a(S.index,P),A=s(S.index,P),F=A?.setting?.commaOffset;A&&F===void 0&&k.push({offset:A.endOffset,length:0,content:","});const B=F!==void 0&&F>$.endOffset;k.push({offset:B?F+1:$.endOffset,length:0,content:z?W+U+",":W+U})}return k}else{if($.setting)return[{offset:$.startOffset,length:0,content:U+","}];const k=(P[S.index-1]&&!P[S.index-1].setting?W:"")+U+(a(S.index,P)?",":"")+W;return[{offset:$.startOffset,length:0,content:k}]}}function l(o,u){return u.filter(g=>g.setting?.key===o)[0]}function s(o,u){for(let g=o-1;g>=0;g--)if(u[g].setting)return u[g]}function a(o,u){for(let g=o+1;g<u.length;g++)if(u[g].setting)return u[g]}function n(o,u,g){const S=o.indexOf(u),P=o.indexOf(g);return o.filter((O,U)=>S<U&&U<P)}function t(o,u){if(o.length&&u.length){let g=0;for(;g<u.length&&g<o.length;g++)if(o[g].value!==u[g].value)return u[g-1];return u[g-1]}}function r(o){const u=[];let g=-1,S,P;const O={onObjectBegin:U=>{g++},onObjectProperty:(U,W,$)=>{g===0&&(S=W,P=U)},onObjectEnd:(U,W)=>{g--,g===0&&u.push({startOffset:S,endOffset:U+W,value:o.substring(S,U+W),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(U,W)=>{g++},onArrayEnd:(U,W)=>{g--,g===0&&u.push({startOffset:S,endOffset:U+W,value:o.substring(S,U+W),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(U,W,$)=>{g===0&&u.push({startOffset:S,endOffset:W+$,value:o.substring(S,W+$),setting:{key:P,commaOffset:void 0}})},onSeparator:(U,W,$)=>{if(g===0&&U===","){let k=u.length-1;for(;k>=0&&!u[k].setting;k--);const z=u[k];z&&u.splice(k,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:W}})}},onComment:(U,W)=>{g===0&&u.push({startOffset:U,endOffset:U+W,value:o.substring(U,U+W)})}};return(0,_.visit)(o,O),u}}),define(te[226],ne([0,1,19,3,39,146,21,88,84,11,30,14,23,22,36,47,55,225,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const t=JSON.parse(n);return f(t)?t:{settings:n}}e.parseSettingsSyncContent=c;let l=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,o,u,g,S,P,O,U,W,$,k,z){super(r.settingsResource,"settings",t,r,o,u,g,U,W,S,P,O,z);this.extensionManagementService=$,this.userConfigurationFileService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(t,r),u=this.getSettingsSyncContent(o),g=new R.ConfigurationModelParser(E.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&g.parse(u.settings),g.configurationModel.getValue(E.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,r,o){const u=await this.getLocalFileContent(),g=await this.getFormattingOptions(),S=this.getSettingsSyncContent(t);r=r===null&&o?t:r;const P=r?this.getSettingsSyncContent(r):null,O=await this.getIgnoredSettings();let U=null,W=!1,$=!1,k=!1;if(S){let A=u?u.value.toString().trim():"{}";A=A||"{}",this.validateContent(A),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,m.merge)(A,S.settings,P?P.settings:null,O,[],g);U=F.localContent||F.remoteContent,W=F.localContent!==null,$=F.remoteContent!==null,k=F.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),U=u.value.toString(),$=!0);const z={content:U,localChange:W?2:0,remoteChange:$?2:0,hasConflicts:k};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:S?S.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",u,o):null}}async getAcceptResult(t,r,o,u){const g=await this.getFormattingOptions(),S=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",S,g):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",S,g):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return o===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:o!==null?(0,m.updateIgnoredSettings)(o,t.fileContent?t.fileContent.value.toString():"{}",S,g):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,o,u){const{fileContent:g}=o[0][0];let{content:S,localChange:P,remoteChange:O}=o[0][1];if(P===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),S=S?S.trim():"{}",S=S||"{}",this.validateContent(S),P!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),g&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(g.value.toString()))),await this.updateLocalFileContent(S,g,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),O!==0){const U=await this.getFormattingOptions(),W=this.getSettingsSyncContent(t),$=await this.getIgnoredSettings(S);S=(0,m.updateIgnoredSettings)(S,W?W.settings:"{}",$,U),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(S)),u?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(U){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),o=(0,p.edit)(t.value.toString(),[E.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,m.isEmpty)(o)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const o=this.parseSyncData(r);if(o){const u=this.parseSettingsSyncContent(o.content);if(u)switch(this.extUri.basename(t)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();r=(0,m.updateIgnoredSettings)(r,"{}",u,o)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return c(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:g})=>!!g)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(r,this.configurationService,t)}async writeFileContent(t,r,o){await this.userConfigurationFileService.write(T.VSBuffer.fromString(t),o?void 0:{etag:r.etag,mtime:r.mtime})}validateContent(t){if(this.hasErrors(t))throw new E.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const o=this.parseSettingsSyncContent(r.content);if(!o||!o.settings)return;let u=o.settings;const g=await this.getFormattingOptions();for(const S in r)if(["version","content","machineId"].indexOf(S)===-1&&r[S]!==void 0){const P=(0,D.setProperty)(u,[S],r[S],g);P.length&&(u=(0,D.applyEdits)(u,P))}await this.fileService.writeFile(this.file,T.VSBuffer.fromString(u))}catch(t){}}};l=de([G(0,C.IFileService),G(1,b.IEnvironmentService),G(2,d.IStorageService),G(3,E.IUserDataSyncStoreService),G(4,E.IUserDataSyncBackupStoreService),G(5,E.IUserDataSyncLogService),G(6,E.IUserDataSyncUtilService),G(7,i.IConfigurationService),G(8,E.IUserDataSyncResourceEnablementService),G(9,v.ITelemetryService),G(10,I.IExtensionManagementService),G(11,w.IUserConfigurationFileService),G(12,h.IUriIdentityService)],l),e.SettingsSynchroniser=l;let s=class extends y.AbstractInitializer{constructor(t,r,o,u){super("settings",r,o,t,u)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return c(t)}catch(r){this.logService.error(r)}return null}};s=de([G(0,C.IFileService),G(1,b.IEnvironmentService),G(2,E.IUserDataSyncLogService),G(3,h.IUriIdentityService)],s),e.SettingsInitializer=s;function a(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(te[227],ne([0,1,19,3,28,21,11,14,23,22,36,47,220,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends C.AbstractSynchroniser{constructor(m,E,f,c,l,s,a,n,t,r){super("snippets",E,m,f,c,l,n,t,s,a,r);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(_.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,E,f){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),s=m.syncData?this.parseSnippets(m.syncData):null;E=E===null&&f?m:E;const a=E&&E.syncData?this.parseSnippets(E.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(l,s,a);return this.getResourcePreviews(n,c,s||{})}async getMergeResult(m,E){return m.previewResult}async getAcceptResult(m,E,f,c){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(m,E,f,c){const l=f.map(([s,a])=>({...s,acceptResult:a}));l.every(({localChange:s,remoteChange:a})=>s===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:s})=>s!==0)&&(m=await this.updateRemoteSnippets(l,m,c)),E?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of l)try{await this.fileService.del(s)}catch(a){}}getResourcePreviews(m,E,f){const c=new Map;for(const l of Object.keys(m.local.added)){const s={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const s={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[l],localContent:E[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[l],localContent:E[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const s={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[l],localContent:E[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const s={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[l],localContent:E[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const s={content:E[l]?E[l].value.toString():null,hasConflicts:!0,localChange:E[l]?2:1,remoteChange:f[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[l]||null,localContent:E[l]?E[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(E))if(!c.has(l)){const s={content:E[l]?E[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[l]||null,localContent:E[l]?E[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:m}){let E=await super.resolveContent(m);if(E){const f=this.parseSyncData(E);if(f){const c=this.parseSnippets(f),l=[];for(const s of Object.keys(c)){const a=this.extUri.joinPath(m,s),n=this.extUri.joinPath(this.snippetsFolder,s),t=await this.fileService.exists(n);l.push({resource:a,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let E=await super.resolveContent(m);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(m)),E){const f=this.parseSyncData(E);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const E={};for(const f of m)f.fileContent&&(E[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(m,E){for(const{fileContent:f,acceptResult:c,localResource:l,remoteResource:s,localChange:a}of m)if(a!==0){const n=s?this.extUri.basename(s):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,T.VSBuffer.fromString(c.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,T.VSBuffer.fromString(c.content),E?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,E,f){const c=E.syncData?this.parseSnippets(E.syncData):{},l=(0,D.deepClone)(c);for(const{acceptResult:s,localResource:a,remoteResource:n,remoteChange:t}of m)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(n);t===3?delete l[r]:l[r]=s.content}return(0,d.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(l),f?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const E={};for(const f of Object.keys(m))E[f]=m[f].value.toString();return E}async getSnippetsFileContents(){const m={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof R.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of E.children||[]){const c=f.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,c),a=await this.fileService.readFile(c);m[s]=a}}return m}};h=de([G(0,i.IEnvironmentService),G(1,R.IFileService),G(2,w.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncBackupStoreService),G(5,v.IUserDataSyncLogService),G(6,L.IConfigurationService),G(7,v.IUserDataSyncResourceEnablementService),G(8,b.ITelemetryService),G(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let y=class extends C.AbstractInitializer{constructor(m,E,f,c){super("snippets",E,f,m,c)}async doInitialize(m){const E=m.syncData?JSON.parse(m.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(E)){const l=E[c];if(l){const s=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(s,T.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};y=de([G(0,R.IFileService),G(1,i.IEnvironmentService),G(2,v.IUserDataSyncLogService),G(3,I.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,T,_,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let i=class extends _.Disposable{constructor(w,b){super();this.userDataSyncStoreService=w,this.logService=b,this._onDidChangeAccount=this._register(new T.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};i=de([G(0,L.IUserDataSyncStoreService),G(1,L.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[228],ne([0,1,5,19,58,2,18,21,11,14,24]),function(J,e,T,_,D,L,i,R,w,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends L.Disposable{constructor(v,h,y,p){super();this.environmentService=v,this.fileService=h,this.configurationService=y,this.logService=p,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(v){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,v),y=await this.fileService.resolve(h);return y.children?y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(v,h){if(!h){const y=await this.getAllRefs(v);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,i.joinPath)(this.environmentService.userDataSyncHome,v,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(v,h){const y=(0,i.joinPath)(this.environmentService.userDataSyncHome,v),p=(0,i.joinPath)(y,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,_.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(v)}catch(m){}}async cleanUpBackup(v){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(h))return}catch(p){return}const y=await this.fileService.resolve(h);if(y.children){const p=y.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let E=p.filter(c=>Date.now()-this.getCreationTime(c)>m);const f=p.length-E.length;f<10&&(E=E.slice(10-f)),await T.Promises.settled(E.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};C=de([G(0,w.IEnvironmentService),G(1,b.IFileService),G(2,R.IConfigurationService),G(3,I.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[229],ne([0,1,2,7]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(d){this.service=d}listen(d,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class L{constructor(d){this.service=d}listen(d,v){throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(_.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class i{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=i;class R{constructor(d){this.service=d}listen(d,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(d,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class w{constructor(d){this.service=d}listen(d,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class b{constructor(d){this.service=d}listen(d,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(d,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends T.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:_.URI.revive(d.url),type:d.type,defaultUrl:_.URI.revive(d.defaultUrl),insidersUrl:_.URI.revive(d.insidersUrl),stableUrl:_.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[230],ne([0,1,11,8]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends _.AbstractLogger{constructor(i,R){super();this.logger=this._register(i.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...R){this.logger.trace(i,...R)}debug(i,...R){this.logger.debug(i,...R)}info(i,...R){this.logger.info(i,...R)}warn(i,...R){this.logger.warn(i,...R)}error(i,...R){this.logger.error(i,...R)}critical(i,...R){this.logger.critical(i,...R)}flush(){this.logger.flush()}};D=de([G(0,_.ILoggerService),G(1,T.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[64],ne([0,1,3,2,4,25,149,11,14,6,26,46,23,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let y=class et extends _.Disposable{constructor(m,E,f,c,l,s){super();this.storageService=f,this.userDataSyncStoreService=c,this.logService=l,this.productService=s,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(m,E,f)}async getMachines(m){const E=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(c=>({...c,isCurrent:c.id===E}))}async addCurrentMachine(m){const E=await this.currentMachineIdPromise,f=await this.readMachinesData(m);f.machines.some(({id:c})=>c===E)||(f.machines.push({id:E,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(m){const E=await this.currentMachineIdPromise,f=await this.readMachinesData(m),c=f.machines.filter(({id:l})=>l!==E);c.length!==f.machines.length&&(f.machines=c,await this.writeMachinesData(f))}async renameMachine(m,E,f){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(f),s=l.machines.find(({id:a})=>a===m);s&&(s.name=E,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===c)&&this.storageService.store(h,E,0,1))}async setEnablement(m,E){const f=await this.readMachinesData(),c=f.machines.find(({id:l})=>l===m);c&&(c.disabled=E?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(m){const E=this.storageService.get(h,0);if(E)return E;const f=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,L.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let l=0;for(const s of m){const a=c.exec(s.name),n=a?parseInt(a[1]):0;l=n>l?n:l}return`${f} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const E=this.parse(this.userData);if(E.version!==et.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return E}async writeMachinesData(m){const E=JSON.stringify(m),f=await this.userDataSyncStoreService.write(et.RESOURCE,E,this.userData?.ref||null);this.userData={ref:f,content:E},this._onDidChange.fire()}async readUserData(m){if(this.userData){const E=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===E)return this.userData;if(E===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(E){this.logService.error(E)}return{version:et.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=de([G(0,R.IEnvironmentService),G(1,w.IFileService),G(2,d.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncLogService),G(5,I.IProductService)],y),e.UserDataSyncMachinesService=y}),define(te[99],ne([0,1,5,58,38,9,3,2,4,18,7,147,11,26,23,22,24,63,64]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const f="sync.enable",c="sync.disableMachineEventually",l="sync.sessionId",s="sync.storeUrl",a="sync.productQuality";let n=class extends R.Disposable{constructor(u,g,S){super();this.storageService=u,this.environmentService=g,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new i.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(P=>this.onDidStorageChange(P)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(f,u,0,1)}onDidStorageChange(u){if(u.scope===0&&f===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=de([G(0,h.IStorageService),G(1,d.IEnvironmentService),G(2,p.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let t=class extends R.Disposable{constructor(u,g,S,P,O,U,W,$,k,z,A){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=P,this.userDataSyncService=O,this.logService=U,this.userDataSyncAccountService=W,this.telemetryService=$,this.userDataSyncMachinesService=k,this.storageService=z,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=A,this.syncTriggerDelayer=this._register(new T.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(W.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(O.onDidChangeLocal,(F,B)=>F?[...F,B]:[B],1e3)(F=>this.triggerSync(F,!1,!1))),this._register(i.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(s,0);return u?I.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(s,u.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(a,0)}set productQuality(u){u?this.storageService.store(a,u,0,1):this.storageService.remove(a,0)}updateAutoSync(){const{enabled:u,message:g}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,_.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,g,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(P){if(g)this.logService.error(P),this.updateEnablement(!1);else throw P}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(f,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const g=p.UserDataSyncError.toUserDataSyncError(u);g instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?w.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,T.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,g,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=de([G(0,v.IProductService),G(1,p.IUserDataSyncStoreManagementService),G(2,p.IUserDataSyncStoreService),G(3,p.IUserDataSyncResourceEnablementService),G(4,p.IUserDataSyncService),G(5,p.IUserDataSyncLogService),G(6,m.IUserDataSyncAccountService),G(7,y.ITelemetryService),G(8,E.IUserDataSyncMachinesService),G(9,h.IStorageService),G(10,p.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class r extends R.Disposable{constructor(u,g,S,P,O,U,W,$){super();this.lastSyncUrl=u,this.interval=g,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=P,this.userDataSyncService=O,this.userDataSyncMachinesService=U,this.logService=W,this.storageService=$,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,T.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(u,g){const S=(0,T.createCancelablePromise)(async P=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,L.isPromiseCanceledError)(O))return}return this.doSync(u,g,P)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!u&&(!(0,b.isEqual)(g.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(g.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(g.stableUrl,u.stableUrl))}async doSync(u,g,S){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let P;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),S.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(l,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const U=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(S.isCancellationRequested)return;const W=U.find($=>$.isCurrent);if(W?.disabled)throw new p.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch($){throw new p.UserDataAutoSyncError((0,D.toErrorMessage)($),$ instanceof p.UserDataSyncError?$.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(l,this.manifest.session,0,1),S.isCancellationRequested)return;W||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),P=O}this._onDidFinishSync.fire(P)}register(u){return super._register(u)}}r.INTERVAL_SYNCING="Interval"}),define(te[231],ne([0,1,3,2,4,23,22,24]),function(J,e,T,_,D,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends _.Disposable{constructor(I,C){super();this.storageService=I,this.telemetryService=C,this._onDidChangeResourceEnablement=new T.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(I){return this.storageService.getBoolean((0,R.getEnablementKey)(I),0,!0)}setResourceEnablement(I,C){if(this.isResourceEnabled(I)!==C){const d=(0,R.getEnablementKey)(I);this.telemetryService.publicLog2(d,{enabled:C}),this.storeResourceEnablement(d,C)}}getResourceSyncStateVersion(I){}storeResourceEnablement(I,C){this.storageService.store(I,C,0,D.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const C=R.ALL_SYNC_RESOURCES.filter(d=>(0,R.getEnablementKey)(d)===I.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};w=de([G(0,L.IStorageService),G(1,i.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[232],ne([0,1,17,5,38,9,3,2,18,29,21,6,23,22,221,223,224,226,227,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let l=class extends R.Disposable{constructor(t,r,o,u,g,S,P){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=r,this.instantiationService=o,this.configurationService=u,this.logService=g,this.telemetryService=S,this.storageService=P,this._status="uninitialized",this._onDidChangeStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new i.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new i.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new i.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new i.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(p.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(E.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(y.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,r){await this.checkEnablement();const o=(0,b.generateUuid)();try{const P=(0,f.createSyncHeaders)(o);r&&(P["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,P)}catch(P){const O=f.UserDataSyncError.toUserDataSyncError(P);throw this.reportUserDataSyncError(O,o),O}let u=!1;const g=this;let S;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return S=(0,_.createCancelablePromise)(P=>g.sync(t,o,P)),S.finally(()=>S=void 0)},async stop(){if(S&&S.cancel(),g.status!=="idle")return g.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,b.generateUuid)(),r=(0,f.createSyncHeaders)(t);let o;try{o=await this.userDataSyncStoreService.manifest(null,r)}catch(u){const g=f.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,t),g}return new s(t,o,r,this.synchronisers,this.configurationService,this.logService)}async sync(t,r,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const g=(0,f.createSyncHeaders)(r);for(const S of this.synchronisers){if(o.isCancellationRequested)return;try{await S.sync(t,g)}catch(P){let O=!1;if(P instanceof f.UserDataSyncError)switch(P.code){case"TooLarge":P=new f.UserDataSyncError(P.message,P.code,S.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const U=f.UserDataSyncError.toUserDataSyncError(P);if(this.reportUserDataSyncError(U,r),O)throw U;this.logService.error(P),this.logService.error(`${S.resource}: ${(0,D.toErrorMessage)(P)}`),this._syncErrors.push([S.resource,U])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(g){const S=f.UserDataSyncError.toUserDataSyncError(g);throw this.reportUserDataSyncError(S,r),S}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(r){this.logService.error(r)}}async replace(t){await this.checkEnablement();for(const r of this.synchronisers)if(await r.replace(t))return}async accept(t,r,o,u){await this.checkEnablement();const g=this.getSynchroniser(t);await g.accept(r,o),u&&await g.apply(!1,(0,f.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(t){for(const r of this.synchronisers){const o=await r.resolveContent(t);if(o)return o}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,r){return this.getSynchroniser(t).getAssociatedResources(r)}getMachineId(t,r){return this.getSynchroniser(t).getMachineId(r)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const r of t)if(await r.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(r){this.logService.error(`${t.resource}: ${(0,D.toErrorMessage)(r)}`),this.logService.error(r)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const r=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),r==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,T.equals)(this._conflicts,t,([r,o],[u,g])=>r===r&&(0,T.equals)(o,g,(S,P)=>(0,w.isEqual)(S.previewResource,P.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,r){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof f.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof f.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:r,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(a)])}getSynchroniser(t){return this.synchronisers.find(r=>r.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=de([G(0,f.IUserDataSyncStoreService),G(1,f.IUserDataSyncStoreManagementService),G(2,C.IInstantiationService),G(3,I.IConfigurationService),G(4,f.IUserDataSyncLogService),G(5,v.ITelemetryService),G(6,d.IStorageService)],l),e.UserDataSyncService=l;class s extends R.Disposable{constructor(t,r,o,u,g,S){super();this.id=t,this.manifest=r,this.syncHeaders=o,this.synchronisers=u,this.configurationService=g,this.logService=S,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new i.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,_.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,r){try{return await this.performAction(t,o=>o.accept(t,r))}catch(o){throw this.logService.error(o),o}}async merge(t){try{return t?await this.performAction(t,r=>r.merge(t)):await this.mergeAll()}catch(r){throw this.logService.error(r),r}}async discard(t){try{return await this.performAction(t,r=>r.discard(t))}catch(r){throw this.logService.error(r),r}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,r]of this.previews)for(const o of r.resourcePreviews)o.mergeState==="conflict"&&t.push(o.previewResource);for(const r of t)await this.discard(r);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[r,o]of this.previews){this.synchronizingResources.push([r,o.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(S=>S.resource===r);for(const S of o.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&await u.merge(S.previewResource);const g=await u.apply(!1,this.syncHeaders);g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,r]of this.previews){this.synchronizingResources.push([t,r.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of r.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,r]of this.previews){this.synchronizingResources.push([t,r.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of r.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(r){(0,L.isPromiseCanceledError)(r)||this.logService.error(r)}this.reset()}async performAction(t,r){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:k,previewResource:z,remoteResource:A})=>(0,w.isEqual)(t,k)||(0,w.isEqual)(t,z)||(0,w.isEqual)(t,A)));if(o===-1)return this.previews;const[u,g]=this.previews[o],S=g.resourcePreviews.find(({localResource:$,remoteResource:k,previewResource:z})=>(0,w.isEqual)($,t)||(0,w.isEqual)(k,t)||(0,w.isEqual)(z,t));if(!S)return this.previews;let P=this.synchronizingResources.find($=>$[0]===u);P||(P=[u,[]],this.synchronizingResources.push(P)),P[1].some($=>(0,w.isEqual)($,S.localResource))||(P[1].push(S.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find($=>$.resource===this.previews[o][0]),U=await r(O);U?this.previews.splice(o,1,this.toSyncResourcePreview(O.resource,U)):this.previews.splice(o,1);const W=this.synchronizingResources.findIndex($=>$[0]===u);return this.synchronizingResources[W][1].splice(P[1].findIndex($=>(0,w.isEqual)($,S.localResource)),1),P[1].length||(this.synchronizingResources.splice(W,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[r,o]of this.previews){this.synchronizingResources.push([r,o.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(S=>S.resource===r);let g=o;for(const S of o.resourcePreviews)(S.localChange!==0||S.remoteChange!==0)&&S.mergeState==="preview"&&(g=await u.merge(S.previewResource));g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const r=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const g=await u.preview(this.manifest,o,this.syncHeaders);g&&r.push(this.toSyncResourcePreview(u.resource,g))}return r}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE),r=await this.synchronisers.find(o=>o instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...r}}toSyncResourcePreview(t,r){return[t,{isLastSyncFromCurrentMachine:r.isLastSyncFromCurrentMachine,resourcePreviews:r.resourcePreviews.map(a)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function a(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(te[233],ne([0,1,3,2,15,7,24]),function(J,e,T,_,D,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,d){this.service=C,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new T.Emitter}listen(C,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(C,d,v){try{return await this._call(C,d,v)}catch(h){throw this.logService.error(h),h}}async _call(C,d,v){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],L.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:L.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:L.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),y=v[0],p=this.getManualSyncTask(y);switch(v=v.slice(1),h){case"preview":return p.preview();case"accept":return p.accept(L.URI.revive(v[0]),v[1]);case"merge":return p.merge(L.URI.revive(v[0]));case"discard":return p.discard(L.URI.revive(v[0]));case"discardConflicts":return p.discardConflicts();case"apply":return p.apply();case"pull":return p.pull();case"push":return p.push();case"stop":return p.stop();case"_getStatus":return p.status;case"dispose":return this.disposeManualSyncTask(p)}}throw new Error("Invalid call")}getManualSyncTask(C){const d=this.manualSyncTasks.get(this.createKey(C));if(!d)throw new Error(`Manual sync taks not found: ${C}`);return d.manualSyncTask}async createManualSyncTask(){const C=new _.DisposableStore,d=C.add(await this.service.createManualSyncTask());return C.add(d.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:v}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:C}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(C){C.dispose();const d=this.createKey(C.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class w extends _.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,v,h){return C.call(d,v,h).then(null,y=>{throw i.UserDataSyncError.toUserDataSyncError(y)})},listen(d,v){return C.listen(d,v)}},this.channel.call("_getInitialData").then(([d,v,h])=>{this.updateStatus(d),this.updateConflicts(v),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([v,h])=>[v,i.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:d,status:v}=await this.channel.call("createManualSyncTask"),h=this,y=new b(C,d,v,{async call(p,m,E){return h.channel.call(`manualSync/${p}`,[C,...(0,D.isArray)(m)?m:[m]],E)},listen(p,m){return T.Event.map(T.Event.filter(h.channel.listen(`manualSync/${p}`,m),E=>!y.isDiposed()&&E.manualSyncTaskId===C),E=>E.data)}});return y}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,d,v,h){return this.channel.call("accept",[C,d,v,h])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:v,uri:h})=>({created:v,uri:L.URI.revive(h)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:v,uri:h})=>({created:v,uri:L.URI.revive(h)}))}async getAssociatedResources(C,d){return(await this.channel.call("getAssociatedResources",[C,d])).map(({resource:h,comparableResource:y})=>({resource:L.URI.revive(h),comparableResource:L.URI.revive(y)}))}async getMachineId(C,d){return this.channel.call("getMachineId",[C,d])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([d,v])=>[d,v.map(h=>({...h,localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=w;class b extends _.Disposable{constructor(C,d,v,h){super();this.id=C,this.manifest=d,this._disposed=!1,this._status=v;const y=this;this.channel={async call(p,m,E){try{const f=await h.call(p,m,E);return y.isDiposed()||(y._status=await h.call("_getStatus")),f}catch(f){throw i.UserDataSyncError.toUserDataSyncError(f)}},listen(p,m){return h.listen(p,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,d){const v=await this.channel.call("accept",[C,d]);return this.deserializePreviews(v)}async merge(C){const d=await this.channel.call("merge",[C]);return this.deserializePreviews(d)}async discard(C){const d=await this.channel.call("discard",[C]);return this.deserializePreviews(d)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([d,v])=>[d,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(h=>({...h,localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource),acceptedResource:L.URI.revive(h.acceptedResource)}))}])}}}),define(te[234],ne([0,1,5,27,9,3,2,109,4,18,15,7,29,21,11,14,26,43,46,23,24]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",s="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends i.Disposable{constructor(U,W,$){super();this.productService=U,this.configurationService=W,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter($.onDidChangeValue,k=>k.key===c.SYNC_SERVICE_URL_TYPE&&k.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(U){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,U,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,W){U=w.isWeb&&U?.web?{...U,...U.web}:U;const $={...U||{},...W||{}};if($&&(0,I.isString)($.url)&&(0,I.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(k=>(0,I.isArray)($.authenticationProviders[k].scopes))){const k=$,z=!!k.canSwitch&&!W?.url,A=k.url===k.insidersUrl?"insiders":"stable",F=(z?this.userDataSyncStoreType:void 0)||A,B=W?.url||(F==="insiders"?k.insidersUrl:F==="stable"?k.stableUrl:k.url);return{url:C.URI.parse(B),type:F,defaultType:A,defaultUrl:C.URI.parse(k.url),stableUrl:C.URI.parse(k.stableUrl),insidersUrl:C.URI.parse(k.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(k.authenticationProviders).reduce((Z,V)=>(Z.push({id:V,scopes:k.authenticationProviders[V].scopes}),Z),[])}}}};o=de([G(0,p.IProductService),G(1,v.IConfigurationService),G(2,f.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(U,W,$){super(U,W,$);const k=this.storageService.get(l,0);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const z=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(l,JSON.stringify(z),0,1):this.storageService.remove(l,0)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([G(0,p.IProductService),G(1,v.IConfigurationService),G(2,f.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends i.Disposable{constructor(U,W,$,k,z,A,F){super();this.requestService=$,this.logService=k,this.storageService=F,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,E.getServiceMachineId)(z,A,F).then(B=>{const Z={"X-Client-Name":`${W.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":W.version};return W.commit&&(Z["X-Client-Commit"]=W.commit),Z}),this.session=new P(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,W){this.authToken={token:U,type:W}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,b.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(s,0);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,T.createCancelablePromise)(W=>(0,T.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),W).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,W=>null)):this.storageService.remove(s,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",U),$={},k=await this.request(W.toString(),{type:"GET",headers:$},[],_.CancellationToken.None);return(await(0,m.asJson)(k)||[]).map(({url:A,created:F})=>({ref:(0,b.relativePath)(W,W.with({path:A})),created:F*1e3}))}async resolveContent(U,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",U,W).toString(),k={};k["Cache-Control"]="no-cache";const z=await this.request($,{type:"GET",headers:k},[],_.CancellationToken.None);return await(0,m.asText)(z)}async delete(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),$={};await this.request(W,{type:"DELETE",headers:$},[],_.CancellationToken.None)}async read(U,W,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();$={...$},$["Cache-Control"]="no-cache",W&&($["If-None-Match"]=W.ref);const z=await this.request(k,{type:"GET",headers:$},[304],_.CancellationToken.None);let A=null;if(z.res.statusCode===304&&(A=W),A===null){const F=z.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);const B=await(0,m.asText)(z);if(!B&&z.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",k,"EmptyResponse",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);A={ref:F,content:B}}return A}async write(U,W,$,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();k={...k},k["Content-Type"]=R.Mimes.text,$&&(k["If-Match"]=$);const A=await this.request(z,{type:"POST",data:W,headers:k},[],_.CancellationToken.None),F=A.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",A.res.statusCode,A.res.headers[c.HEADER_OPERATION_ID]);return F}async manifest(U,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();W={...W},W["Content-Type"]="application/json",U&&(W["If-None-Match"]=U.ref);const k=await this.request($,{type:"GET",headers:W},[304],_.CancellationToken.None);let z=null;if(k.res.statusCode===304&&(z=U),!z){const F=k.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",k.res.statusCode,k.res.headers[c.HEADER_OPERATION_ID]);const B=await(0,m.asText)(k);if(!B&&k.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",k.res.statusCode,k.res.headers[c.HEADER_OPERATION_ID]);B&&(z={...JSON.parse(B),ref:F})}const A=this.storageService.get(a,0);return A&&z&&A!==z.session&&this.clearSession(),z===null&&A&&this.clearSession(),z&&this.storageService.store(a,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),W={"Content-Type":R.Mimes.text};await this.request(U,{type:"DELETE",headers:W},[],_.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(U,W,$,k){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;W.headers={...W.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(W.headers),this.logService.trace("Sending request to server",{url:U,type:W.type,headers:{...W.headers,authorization:void 0}});let A;try{A=await this.session.request(U,W,k)}catch(V){if(!(V instanceof c.UserDataSyncStoreError)){let j="RequestFailed";const Q=(0,D.getErrorMessage)(V).toLowerCase();Q.includes("xhr timeout")?j="RequestTimeout":Q.includes("protocol")&&Q.includes("not supported")?j="RequestProtocolNotSupported":Q.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Q.includes("headers must be an object")?j="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(V)&&(j="RequestCanceled"),V=new c.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,j,void 0,void 0)}throw this.logService.info("Request failed",U),V}const F=A.res.headers[c.HEADER_OPERATION_ID],B={url:U,status:A.res.statusCode,"execution-id":W.headers[c.HEADER_EXECUTION_ID],"operation-id":F},Z=(0,m.isSuccess)(A)||A.res.statusCode&&$.indexOf(A.res.statusCode)!==-1;if(Z?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),A.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",A.res.statusCode,F);if(this._onTokenSucceed.fire(),A.res.statusCode===409)throw new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",A.res.statusCode,F);if(A.res.statusCode===410)throw new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",A.res.statusCode,F);if(A.res.statusCode===412)throw new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",A.res.statusCode,F);if(A.res.statusCode===413)throw new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",A.res.statusCode,F);if(A.res.statusCode===426)throw new c.UserDataSyncStoreError(`${W.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",A.res.statusCode,F);if(A.res.statusCode===429){const V=A.res.headers["retry-after"];throw V?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(V)*1e3)),new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",A.res.statusCode,F)):new c.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",A.res.statusCode,F)}if(!Z)throw new c.UserDataSyncStoreError("Server returned "+A.res.statusCode,U,"Unknown",A.res.statusCode,F);return A}addSessionHeaders(U){let W=this.storageService.get(n,0);W===void 0&&(W=(0,d.generateUuid)(),this.storageService.store(n,W,0,1)),U["X-Machine-Session-Id"]=W;const $=this.storageService.get(a,0);$!==void 0&&(U["X-User-Session-Id"]=$)}};g=de([G(1,p.IProductService),G(2,m.IRequestService),G(3,c.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,y.IFileService),G(6,f.IStorageService)],g),e.UserDataSyncStoreClient=g;let S=class extends g{constructor(U,W,$,k,z,A,F){super(U.userDataSyncStore?.url,W,$,k,z,A,F);this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};S=de([G(0,c.IUserDataSyncStoreManagementService),G(1,p.IProductService),G(2,m.IRequestService),G(3,c.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,y.IFileService),G(6,f.IStorageService)],S),e.UserDataSyncStoreService=S;class P{constructor(U,W,$,k){this.limit=U,this.interval=W,this.requestService=$,this.logService=k,this.requests=[],this.startTime=void 0}request(U,W,$){if(this.isExpired()&&this.reset(),W.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(W,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(te[235],ne([0,1,3,60,26,23,22,99,24,63,64]),function(J,e,T,_,D,L,i,R,w,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(v,h,y,p,m,E,f,c,l,s,a,n){super(v,h,y,p,m,f,c,l,s,a,n);this._register(T.Event.debounce(T.Event.any(T.Event.map(E.onDidFocusWindow,()=>"windowFocus"),T.Event.map(E.onDidOpenWindow,()=>"windowOpen")),(t,r)=>t?[...t,r]:[r],1e3)(t=>this.triggerSync(t,!0,!1)))}};C=de([G(0,D.IProductService),G(1,w.IUserDataSyncStoreManagementService),G(2,w.IUserDataSyncStoreService),G(3,w.IUserDataSyncResourceEnablementService),G(4,w.IUserDataSyncService),G(5,_.INativeHostService),G(6,w.IUserDataSyncLogService),G(7,b.IUserDataSyncAccountService),G(8,i.ITelemetryService),G(9,I.IUserDataSyncMachinesService),G(10,L.IStorageService),G(11,w.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(te[236],ne([0,1,5,3,2]),function(J,e,T,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:w,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),_.Event.latch(_.Event.any(R,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,T.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(te[65],ne([0,1,51,5,10,15,20,125,248,249]),function(J,e,T,_,D,L,i,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(s,a){let n=a.message;switch(s){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=s,this.cause=a}}e.ExtractError=I;function C(l){const s=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>s&a).reduce((a,n)=>a+n,s&61440)}function d(l){if(l instanceof I)return l;let s;return/end of central directory record signature not found/.test(l.message)&&(s="CorruptZip"),new I(s,l)}function v(l,s,a,n,t,r){const o=D.dirname(s),u=D.join(n,o);if(!u.startsWith(n))return Promise.reject(new Error(R.localize(0,null,s)));const g=D.join(n,s);let S;return r.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(i.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((P,O)=>{if(!r.isCancellationRequested)try{S=(0,T.createWriteStream)(g,{mode:a}),S.once("close",()=>P()),S.once("error",O),l.once("error",O),l.pipe(S)}catch(U){O(U)}}))}function h(l,s,a,n){let t=(0,_.createCancelablePromise)(()=>Promise.resolve()),r=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,u)=>{const g=new _.Sequencer,S=P=>{P.isCancellationRequested||(r++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===r?o():u(new I("Incomplete",new Error(R.localize(1,null,r,l.entryCount))))},u)),l.readEntry(),l.on("entry",P=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(P.fileName)){S(n);return}const O=P.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const $=D.join(s,O);t=(0,_.createCancelablePromise)(k=>i.Promises.mkdir($,{recursive:!0}).then(()=>S(k)).then(void 0,u));return}const U=p(l,P),W=C(P);t=(0,_.createCancelablePromise)($=>g.queue(()=>U.then(k=>v(k,O,W,s,a,$).then(()=>S($)))).then(null,u))})})}function y(l,s=!1){return new Promise((a,n)=>{(0,w.open)(l,s?{lazyEntries:!0}:void 0,(t,r)=>{t?n(d(t)):a((0,L.assertIsDefined)(r))})})}function p(l,s){return new Promise((a,n)=>{l.openReadStream(s,(t,r)=>{t?n(d(t)):a((0,L.assertIsDefined)(r))})})}function m(l,s){return new Promise((a,n)=>{const t=new b.ZipFile;s.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,T.createWriteStream)(l);t.outputStream.pipe(r),t.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>a(l))})}e.zip=m;function E(l,s,a={},n){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=y(l,!0);return a.overwrite&&(r=r.then(o=>i.Promises.rm(s).then(()=>o))),r.then(o=>h(o,s,{sourcePathRegex:t},n))}e.extract=E;function f(l,s){return y(l).then(a=>new Promise((n,t)=>{a.on("entry",r=>{r.fileName===s&&p(a,r).then(o=>n(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,s))))}))}function c(l,s){return f(l,s).then(a=>new Promise((n,t)=>{const r=[];a.once("error",t),a.on("data",o=>r.push(o)),a.on("end",()=>n(Buffer.concat(r)))}))}e.buffer=c}),define(te[237],ne([0,1,65,134]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(L){return(0,T.buffer)(L,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(R){throw new Error((0,_.localize)(0,null))}})}e.getManifest=D}),define(te[238],ne([0,1,17,5,9,2,16,10,4,18,61,7,29,20,65,135,11,30,35,156,14,8,26]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends L.Disposable{constructor(t,r,o,u,g){super();this.beforeRemovingExtension=t,this.fileService=r,this.logService=o,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new _.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const r=[];(t===null||t===0)&&r.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&r.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(r);return(0,T.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[r,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!r[new E.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(o=(0,E.groupByExtension)(o,g=>g.identifier).map(g=>g.sort((S,P)=>I.rcompare(S.manifest.version,P.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,r,o,u){const g=t.key(),S=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),P=R.join(this.extensionsPath,g);try{await v.Promises.rm(P)}catch(U){try{await v.Promises.rm(P)}catch(W){}throw new m.ExtensionManagementError((0,y.localize)(0,null,P,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,r,S,u);let O=await this.scanExtension(C.URI.file(S),1);if(!O)throw new Error((0,y.localize)(1,null,S));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,S,P,Date.now()+2*60*1e3),this.logService.info("Renamed to",P)}catch(U){try{await v.Promises.rm(S)}catch(W){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(U)}. Deleted from extracted location`,S),U}try{O=await this.scanExtension(C.URI.file(P),1)}catch(U){}if(O)return O;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,r){return this.setMetadata(t,r),await this.storeMetadata(t,{...r,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,r){r.isMachineScoped=r.isMachineScoped||void 0,r.isBuiltin=r.isBuiltin||void 0,r.installedTimestamp=r.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),u=await v.Promises.readFile(o,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=r,await v.Promises.writeFile(o,JSON.stringify(g,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const r=t.map(o=>new E.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{r.forEach(u=>o[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const o=(await this.scanExtensions(1)).find(u=>new E.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let r;try{r=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(r)try{o=JSON.parse(r)}catch(u){}return t&&(t(o),Object.keys(o).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await v.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,r){this.logService.trace(`Deleting ${r} extension from disk`,t.identifier.id,t.location.fsPath),await v.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(r=>delete r[new E.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,r,o,u){this.logService.trace(`Started extracting the extension from ${r} to ${o}`);try{await v.Promises.rm(o)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(r,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(g){try{await v.Promises.rm(o)}catch(P){}let S=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?S=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(S=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,S)}}async rename(t,r,o,u){try{await v.Promises.rename(r,o)}catch(g){if(w.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${r} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,r,o,u);throw new m.ExtensionManagementError(g.message||(0,y.localize)(3,null,r,o),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const r=this.scanDevSystemExtensions(),[o,u]=await Promise.all([t,r]);return[...o,...u]}async scanExtensionsInDir(t,r){const o=new _.Limiter(10),u=await this.fileService.resolve(C.URI.file(t));return u.children?(await Promise.all(u.children.filter(S=>S.isDirectory).map(S=>o.queue(async()=>r===1&&(0,b.basename)(S.resource).indexOf(".")===0?null:this.scanExtension(S.resource,r))))).filter(S=>S&&S.identifier):[]}async scanExtension(t,r){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:u,metadata:g}=await this.readManifest(t.fsPath),S=o.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,P=o.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,O={id:(0,E.getGalleryExtensionId)(u.publisher,u.name)},U={type:r,identifier:O,manifest:u,location:t,readmeUrl:S,changelogUrl:P,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:r===0};return this.setMetadata(U,g),U}}catch(o){r!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const r=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",r.length),r.filter(o=>t.some(u=>(0,E.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(t,r){t.publisherDisplayName=r?.publisherDisplayName||null,t.publisherId=r?.publisherId||null,t.identifier.uuid=r?.id,t.isMachineScoped=!!r?.isMachineScoped,t.isPreReleaseVersion=!!r?.isPreReleaseVersion,t.preRelease=!!r?.preRelease,t.isBuiltin=t.type===0||!!r?.isBuiltin,t.installedTimestamp=r?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),r=await this.scanAllUserExtensions(),o=new Set;for(const S of r)t[new E.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]||o.add(S.identifier.id.toLowerCase());const u=(0,E.groupByExtension)(r,S=>S.identifier);await _.Promises.settled(u.map(async S=>{const P=S.sort((O,U)=>I.rcompare(O.manifest.version,U.manifest.version))[0];o.has(P.identifier.id.toLowerCase())||await this.beforeRemovingExtension(P)}));const g=r.filter(S=>t[new E.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]);await _.Promises.settled(g.map(S=>this.removeUninstalledExtension(S)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),r=[],o=(0,E.groupByExtension)(t,u=>u.identifier);r.push(...(0,T.flatten)(o.map(u=>u.sort((g,S)=>I.rcompare(g.manifest.version,S.manifest.version)).slice(1)))),await _.Promises.settled(r.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(i.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const r=[v.Promises.readFile(R.join(t,"package.json"),"utf8").then(S=>this.parseManifest(S)),v.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,S=>S.code!=="ENOENT"?Promise.reject(S):"{}").then(S=>JSON.parse(S))],[{manifest:o,metadata:u},g]=await Promise.all(r);return{manifest:(0,f.localizeManifest)(o,g),metadata:u}}parseManifest(t){return new Promise((r,o)=>{try{const u=JSON.parse(t),g=u.__metadata||null;r({manifest:u,metadata:g})}catch(u){o(new Error((0,y.localize)(4,null)))}})}};a=de([G(1,c.IFileService),G(2,l.ILogService),G(3,p.INativeEnvironmentService),G(4,s.IProductService)],a),e.ExtensionsScanner=a}),define(te[239],ne([0,1,38,9,16,10,4,32,18,61,7,29,20,65,133,79,11,202,30,35,186,175,237,187,238,216,76,14,6,8,26,22,36]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l,s,a,n,t,r,o,u,g,S,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends m.AbstractExtensionManagementService{constructor(F,B,Z,V,j,Q,M,N,q){super(F,B,Z,N);this.environmentService=V,this.downloadService=j,this.fileService=M;const x=this._register(Q.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(Q.createInstance(n.ExtensionsScanner,ee=>x.postUninstall(ee))),this.manifestCache=this._register(new a.ExtensionsManifestCache(V,this)),this.extensionsDownloader=this._register(Q.createInstance(c.ExtensionsDownloader));const K=this._register(new t.ExtensionsWatcher(this,M,V,Z,q));this._register(K.onDidChangeExtensionsByAnotherSource(({added:ee,removed:H})=>{ee.length&&this._onDidInstallExtensions.fire(ee.map(X=>({identifier:X.identifier,operation:1,local:X}))),H.forEach(X=>this._onDidUninstallExtension.fire({identifier:X}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const F=await this.isAlpineLinux(),B=(0,E.getTargetPlatform)(F?"alpine":i.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let F;try{F=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(B){try{F=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(Z){this.logService.debug("Error while getting the os-release file.",(0,_.getErrorMessage)(Z))}}return!!F&&(F.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const B=await this.collectFiles(F),Z=await(0,v.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,B);return I.URI.file(Z)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const B=await this.downloadVsix(F),Z=L.resolve(B.fsPath);return(0,s.getManifest)(Z)}getInstalled(F=null){return this.extensionsScanner.scanExtensions(F)}async install(F,B={}){this.logService.trace("ExtensionManagementService#install",F.toString());const Z=await this.downloadVsix(F),V=await(0,s.getManifest)(L.resolve(Z.fsPath));if(V.engines&&V.engines.vscode&&!(0,r.isEngineValid)(V.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,f.getGalleryExtensionId)(V.publisher,V.name),this.productService.version));return this.installExtension(V,Z,B)}async updateMetadata(F,B){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,{...F.manifest.__metadata||{},...B}),this.manifestCache.invalidate(),F}async updateExtensionScope(F,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,{...F.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),F}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(F){if(F.scheme===D.Schemas.file)return F;const B=(0,w.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(F,B),B}createInstallExtensionTask(F,B,Z){return I.URI.isUri(B)?new k(F,B,Z,this.galleryService,this.extensionsScanner,this.logService):new $(B,Z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(F,B){return new z(F,B,this.extensionsScanner)}async collectFiles(F){const B=async V=>{let j=await d.Promises.readdir(V);j=j.map(N=>L.join(V,N));const Q=await Promise.all(j.map(N=>d.Promises.stat(N)));let M=Promise.resolve([]);return Q.forEach((N,q)=>{const x=j[q];N.isFile()&&(M=M.then(K=>[...K,x])),N.isDirectory()&&(M=M.then(K=>B(x).then(ee=>[...K,...ee])))}),M};return(await B(F.location.fsPath)).map(V=>({path:`extension/${L.relative(F.location.fsPath,V)}`,localPath:V}))}};U=de([G(0,E.IExtensionGalleryService),G(1,P.ITelemetryService),G(2,g.ILogService),G(3,p.INativeEnvironmentService),G(4,y.IDownloadService),G(5,u.IInstantiationService),G(6,o.IFileService),G(7,S.IProductService),G(8,O.IUriIdentityService)],U),e.ExtensionManagementService=U;class W extends m.AbstractExtensionTask{constructor(F,B,Z,V){super();this.identifier=F,this.source=B,this.extensionsScanner=Z,this.logService=V,this._operation=2}get operation(){return this._operation}async installExtension(F,B){try{const Z=await this.unsetUninstalledAndGetLocal(F.identifierWithVersion);if(Z)return F.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Z,{...Z.manifest.__metadata||{},...F.metadata}):Z}catch(Z){throw i.isMacintosh?new E.ExtensionManagementError(h.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(h.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(F,B)}async unsetUninstalledAndGetLocal(F){if(!await this.isUninstalled(F))return null;this.logService.trace("Removing the extension from uninstalled list:",F.id);const Z=await this.extensionsScanner.setInstalled(F);return this.logService.info("Removed the extension from uninstalled list:",F.id),Z}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.key()]}async extract({zipPath:F,identifierWithVersion:B,metadata:Z},V){let j=await this.extensionsScanner.extractUserExtension(B,F,Z,V);return this.logService.info("Extracting completed.",B.id),j}}class $ extends W{constructor(F,B,Z,V,j){super(F.identifier,F,V,j);this.gallery=F,this.options=B,this.extensionsDownloader=Z}async doRun(F){const Z=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,f.areSameExtensions)(j.identifier,this.gallery.identifier));Z&&(this._operation=3);const V=await this.downloadInstallableExtension(this.gallery,this._operation);V.metadata.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,V.metadata.isBuiltin=this.options.isBuiltin||Z?.isBuiltin,V.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,V.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:Z?.preRelease;try{const j=await this.installExtension(V,F);return Z&&b.neq(Z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Z),j}catch(j){throw await this.deleteDownloadedVSIX(V.zipPath),j}}async deleteDownloadedVSIX(F){try{await this.extensionsDownloader.delete(I.URI.file(F))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",F.toString(),(0,_.getErrorMessage)(B))}}async downloadInstallableExtension(F,B){const Z={id:F.identifier.uuid,publisherId:F.publisherId,publisherDisplayName:F.publisherDisplayName};let V;try{this.logService.trace("Started downloading extension:",F.identifier.id),V=(await this.extensionsDownloader.downloadExtension(F,B)).fsPath,this.logService.info("Downloaded extension:",F.identifier.id,V)}catch(j){throw new E.ExtensionManagementError((0,m.joinErrors)(j).message,E.ExtensionManagementErrorCode.Download)}try{const j=await(0,s.getManifest)(V);return{zipPath:V,identifierWithVersion:new f.ExtensionIdentifierWithVersion(F.identifier,j.version),metadata:Z}}catch(j){throw await this.deleteDownloadedVSIX(V),new E.ExtensionManagementError((0,m.joinErrors)(j).message,E.ExtensionManagementErrorCode.Invalid)}}}class k extends W{constructor(F,B,Z,V,j,Q){super({id:(0,f.getGalleryExtensionId)(F.publisher,F.name)},B,j,Q);this.manifest=F,this.location=B,this.options=Z,this.galleryService=V}async doRun(F){const B=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),V=(await this.extensionsScanner.scanExtensions(1)).find(Q=>(0,f.areSameExtensions)(this.identifier,Q.identifier)),j=await this.getMetadata(this.identifier.id,F);if(j.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||V?.isBuiltin,V)if(this._operation=3,B.equals(new f.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version)))try{await this.extensionsScanner.removeExtension(V,"existing")}catch(Q){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(V.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(V);else{const Q=await this.unsetUninstalledAndGetLocal(B);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(M){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:B,metadata:j},F)}async getMetadata(F,B){try{const Z=(await this.galleryService.query({names:[F],pageSize:1},B)).firstPage[0];if(Z)return{id:Z.identifier.uuid,publisherDisplayName:Z.publisherDisplayName,publisherId:Z.publisherId}}catch(Z){}return{}}}class z extends m.AbstractExtensionTask{constructor(F,B,Z){super();this.extension=F,this.options=B,this.extensionsScanner=Z}async doRun(F){const B=[],Z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const V=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...Z.filter(j=>V.equals(new f.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else B.push(...Z.filter(V=>(0,f.areSameExtensions)(V.identifier,this.extension.identifier)));if(!B.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const V of B)try{F.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(V)}catch(j){throw new Error(h.localize(6,null,(0,T.toErrorMessage)(j)))}}}}),define(te[240],ne([0,1,81,57,33,19,9,3,2,10,4,29,34,71,250]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(P,O=""){this.debugLabel=O,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,i.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,O){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const O=U=>{this.traceSocketEvent("read",U),P(L.VSBuffer.wrap(U))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(P){const O=U=>{this.traceSocketEvent("close",{hadError:U}),P({type:0,hadError:U,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(P){const O=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,i.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,i.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=y;var p;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var m;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(m||(m={}));class E extends w.Disposable{constructor(P,O,U,W){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:U?.byteLength||0,recordInflateBytes:W}),this._flowManager=this._register(new f(this,O,U,W,this._onData,($,k)=>this._write($,k))),this._register(this._flowManager.onError($=>{console.error($),(0,i.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new v.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,O){this.socket.traceSocketEvent(P,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let U=2;P.byteLength<126?U+=0:P.byteLength<2**16?U+=2:U+=8;const W=L.VSBuffer.alloc(U);if(O?W.writeUInt8(194,0):W.writeUInt8(130,0),P.byteLength<126)W.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){W.writeUInt8(126,1);let $=1;W.writeUInt8(P.byteLength>>>8&255,++$),W.writeUInt8(P.byteLength>>>0&255,++$)}else{W.writeUInt8(127,1);let $=1;W.writeUInt8(0,++$),W.writeUInt8(0,++$),W.writeUInt8(0,++$),W.writeUInt8(0,++$),W.writeUInt8(P.byteLength>>>24&255,++$),W.writeUInt8(P.byteLength>>>16&255,++$),W.writeUInt8(P.byteLength>>>8&255,++$),W.writeUInt8(P.byteLength>>>0&255,++$)}this.socket.write(L.VSBuffer.concat([W,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),U=O.readUInt8(0),W=(U&128)>>>7,$=(U&64)>>>6,k=O.readUInt8(1),z=(k&128)>>>7,A=k&127;this._state.state=2,this._state.readLen=2+(z?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=W,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(W),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),U=O.readUInt8(1),W=(U&128)>>>7;let $=U&127,k=1;$===126?$=O.readUInt8(++k)*2**8+O.readUInt8(++k):$===127&&($=O.readUInt8(++k)*0+O.readUInt8(++k)*0+O.readUInt8(++k)*0+O.readUInt8(++k)*0+O.readUInt8(++k)*2**24+O.readUInt8(++k)*2**16+O.readUInt8(++k)*2**8+O.readUInt8(++k));let z=0;W&&(z=O.readUInt8(++k)*2**24+O.readUInt8(++k)*2**16+O.readUInt8(++k)*2**8+O.readUInt8(++k)),this._state.state=3,this._state.readLen=$,this._state.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),s(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class f extends w.Disposable{constructor(P,O,U,W,$,k){super();this._tracer=P,this._onData=$,this._writeFn=k,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new c(this._tracer,W,U,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(z=>this._onError.fire(z))),this._register(this._zlibDeflateStream.onError(z=>this._onError.fire(z)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(O,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,O){return new Promise((U,W)=>{P.write(O),P.flush($=>U($))})}acceptFrame(P,O,U){this._readQueue.push({data:P,isCompressed:O,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,O,U){return new Promise((W,$)=>{P.write(O),U&&P.write(L.VSBuffer.fromByteArray([0,0,255,255])),P.flush(k=>W(k))})}}class c extends w.Disposable{constructor(P,O,U,W){super();this._tracer=P,this._recordInflateBytes=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(W),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(L.VSBuffer.wrap($))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(O)})}}class l extends w.Disposable{constructor(P,O){super();this._tracer=P,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(L.VSBuffer.wrap(U))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),P(O)})}}function s(S,P){if(P===0)return;let O=S.byteLength>>>2;for(let A=0;A<O;A++){const F=S.readUInt32BE(A*4);S.writeUInt32BE(F^P,A*4)}let U=O*4,W=S.byteLength-U;const $=P>>>24&255,k=P>>>16&255,z=P>>>8&255;W>=1&&S.writeUInt8(S.readUInt8(U)^$,U),W>=2&&S.writeUInt8(S.readUInt8(U+1)^k,U+1),W>=3&&S.writeUInt8(S.readUInt8(U+2)^z,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const S=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${S}.sock`):P=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${S}.sock`),r(P),P}e.createRandomIPCHandle=n;function t(S,P,O){const U=(0,T.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${O}-${P}-sock`;let W;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${O}-${P}.sock`):W=(0,b.join)(S,`${O}-${P}.sock`),r(W),W}e.createStaticIPCHandle=t;function r(S){const P=a[I.platform];typeof P=="number"&&S.length>=P&&console.warn(`WARNING: IPC handle "${S}" is longer than ${P} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(P){super(o.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const O=R.Event.fromNodeEventEmitter(P,"connection");return R.Event.map(O,U=>({protocol:new v.Protocol(new y(U,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(S){return new Promise((P,O)=>{const U=(0,_.createServer)();U.on("error",O),U.listen(S,()=>{U.removeListener("error",O),P(new o(U))})})}e.serve=u;function g(S,P){return new Promise((O,U)=>{const W=(0,_.createConnection)(S,()=>{W.removeListener("error",U),O(v.Client.fromSocket(new y(W,`ipc-client${P}`),P))});W.once("error",U)})}e.connect=g}),define(te[241],ne([0,1,57,240]),function(J,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,L,i,R,w){const b=C=>w(C,void 0),I=T.createConnection({host:D,port:L},()=>{I.removeListener("error",b);const C=Buffer.alloc(16);for(let y=0;y<16;y++)C[y]=Math.round(Math.random()*256);const d=C.toString("base64");let v=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${L}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];I.write(v.join(`\r
`)+`\r
\r
`);const h=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",h),w(void 0,new _.NodeSocket(I,R)))};I.on("data",h)});I.once("error",b)}}}),define(te[242],ne([0,1,57,115,241,5,2,21,8,26,184,62,91]),function(J,e,T,_,D,L,i,R,w,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(E,f,c,l,s){let a;for(let n=3;n&&(a&&a.dispose(),a=await new h(E,f,c,l,s).waitForReady(),!(s&&_.BROWSER_RESTRICTED_PORTS[s]||!_.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));n--);return a}class h extends i.Disposable{constructor(f,c,l,s,a){super();this.defaultTunnelHost=c,this.suggestedLocalPort=a,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=T.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let f=await(0,_.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(f){f.pause();const c=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),s=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&f.write(a.buffer),f.on("end",()=>{this._socketsDispose.delete(f.localAddress),s.end()}),f.on("close",()=>s.end()),f.on("error",()=>{this._socketsDispose.delete(f.localAddress),s.destroy()}),s.on("end",()=>f.end()),s.on("close",()=>f.end()),s.on("error",()=>{f.destroy()}),f.pipe(s),s.pipe(f),this._socketsDispose.set(f.localAddress,()=>{f.end(),s.end()})}}let y=class extends C.AbstractTunnelService{constructor(f,c,l,s,a){super(c);this.socketFactory=f,this.signService=l,this.productService=s,this.configurationService=a}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,c,l,s,a,n,t){const r=this.getTunnelFromMap(c,l);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,s,a,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${s}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},u=v(o,this.defaultTunnelHost,c,l,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};y=de([G(1,w.ILogService),G(2,d.ISignService),G(3,b.IProductService),G(4,R.IConfigurationService)],y),e.BaseTunnelService=y;let p=class extends y{constructor(f,c,l,s){super(D.nodeSocketFactory,f,c,l,s)}};p=de([G(0,w.ILogService),G(1,d.ISignService),G(2,b.IProductService),G(3,R.IConfigurationService)],p),e.TunnelService=p;let m=class extends i.Disposable{constructor(f,c,l,s){super();this.logService=f,this.productService=c,this.signService=l,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(f,c,l,s,a,n,t,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${a}.`),!this._tunnelServices.has(f)){const o=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(f,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(c,l,s,a,n,t,r)}};m=de([G(0,w.ILogService),G(1,b.IProductService),G(2,d.ISignService),G(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[251],ne([0,1,72,33,38,9,2,16,18,7,34,119,180,161,181,172,173,174,159,163,21,182,78,201,79,192,11,154,197,205,30,162,203,239,80,157,14,177,179,53,6,169,83,170,171,59,188,8,85,60,86,26,191,43,23,199,200,22,92,93,94,44,206,207,95,209,215,97,98,99,24,63,228,229,230,64,231,232,233,234,235,236,91,196,62,242,189,190,90,195,84,204,36,217]),function(J,e,T,_,D,L,i,R,w,b,I,C,d,v,h,y,p,m,E,f,c,l,s,a,n,t,r,o,u,g,S,P,O,U,W,$,k,z,A,F,B,Z,V,j,Q,M,N,q,x,K,ee,H,X,re,oe,le,he,be,Ce,we,ve,De,ye,Ie,Me,je,Ne,qe,ie,ae,ce,Se,Pe,Ae,Te,Fe,_e,Ue,Y,se,ue,fe,pe,ge,Ee,Re,ke,Le,$e,Ye,He,Ct,It,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Rt extends i.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),T.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Oe="vscode:electron-main->shared-process=disposeWorker",We=(Ge,ze)=>this.onDisposeWorker(ze);T.ipcRenderer.on(Oe,We),this._register((0,i.toDisposable)(()=>T.ipcRenderer.removeListener(Oe,We)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ce.registerConfiguration)(),me.invokeFunction(Oe=>{const We=Oe.get(q.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(We)}),this._register((0,i.combinedDisposable)(me.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(h.LanguagePackCachedDataCleaner),me.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(p.LogsDataCleaner),me.createInstance(y.LocalizationsUpdater),me.createInstance(v.ExtensionsCleaner)))}async initServices(){const me=new V.ServiceCollection,Oe={_serviceBrand:void 0,...ee.default};me.set(H.IProductService,Oe);const We=new I.StaticRouter(xe=>xe==="main"),Ge=new j.MessagePortMainProcessService(this.server,We);me.set(Q.IMainProcessService,Ge);const ze=new o.NativeEnvironmentService(this.configuration.args,Oe);me.set(r.INativeEnvironmentService,ze);const rt=new x.LogLevelChannelClient(this.server.getChannel("logLevel",We)),Qe=new x.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ge.getChannel("logger"));me.set(q.ILoggerService,Qe);const at=this._register(new q.MultiplexLogService([this._register(new q.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,w.joinPath)(b.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new x.FollowerLogService(rt,at));me.set(q.ILogService,Je),this.sharedProcessWorkerService=new Ye.SharedProcessWorkerService(Je,Oe,ze),me.set($e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Xe=this._register(new z.FileService(Je));me.set(k.IFileService,Xe);const ct=this._register(new A.DiskFileSystemProvider(Je));Xe.registerProvider(R.Schemas.file,ct);const Be=this._register(new l.ConfigurationService(ze.settingsResource,Xe));me.set(c.IConfigurationService,Be);const tt=new le.NativeStorageService(void 0,Ge,ze);me.set(oe.IStorageService,tt),this._register((0,i.toDisposable)(()=>tt.flush())),await Promise.all([Be.initialize(),tt.initialize()]),me.set(He.IUserConfigurationFileService,I.ProxyChannel.toService(Ge.getChannel(He.UserConfigurationFileServiceId))),me.set(It.IUriIdentityService,new Pt.UriIdentityService(Xe)),me.set(re.IRequestService,new F.SyncDescriptor(X.RequestService)),me.set(E.IChecksumService,new F.SyncDescriptor(f.ChecksumService));const st=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(K.INativeHostService,st),me.set(n.IDownloadService,new F.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(st)),ut=new I.StaticRouter(xe=>lt.getActiveClientId().then(dt=>xe===dt));me.set(W.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ct.AssignmentService(this.configuration.machineId,Be,Oe);let nt;const Ze=[];if((0,De.supportsTelemetry)(Oe,ze)){const xe=new we.TelemetryLogAppender(Qe,ze);Ze.push(xe);const{appRoot:dt,extensionsPath:Tt,installSourcePath:Lt}=ze;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const wt=new ye.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>wt.flush())),Ze.push(wt)}const yt=new ye.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>yt.flush())),Ze.push(yt)}nt=new ve.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Xe,(0,_.release)(),(0,_.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,Lt),sendErrorTelemetry:!0,piiPaths:[dt,Tt]},Be)}else{nt=De.NullTelemetryService;const xe=De.NullAppender;Ze.push(xe)}this.server.registerChannel("telemetryAppender",new Ce.TelemetryAppenderChannel(Ze)),me.set(be.ITelemetryService,nt);const kt=new Ie.CustomEndpointTelemetryService(Be,nt,Qe,ze);me.set(be.ICustomEndpointTelemetryService,kt),me.set(S.IExtensionManagementService,new F.SyncDescriptor(U.ExtensionManagementService)),me.set(S.IExtensionGalleryService,new F.SyncDescriptor(g.ExtensionGalleryService)),me.set(S.IExtensionTipsService,new F.SyncDescriptor(O.ExtensionTipsService)),me.set(M.ILocalizationsService,new F.SyncDescriptor(N.LocalizationsService)),me.set(s.IDiagnosticsService,new F.SyncDescriptor(a.DiagnosticsService)),me.set(Se.IUserDataSyncAccountService,new F.SyncDescriptor(Se.UserDataSyncAccountService)),me.set(ce.IUserDataSyncLogService,new F.SyncDescriptor(Te.UserDataSyncLogService)),me.set(ce.IUserDataSyncUtilService,new Ae.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),me.set(S.IGlobalExtensionEnablementService,new F.SyncDescriptor(u.GlobalExtensionEnablementService)),me.set(ie.IIgnoredExtensionsManagementService,new F.SyncDescriptor(ie.IgnoredExtensionsManagementService)),me.set(qe.IExtensionsStorageSyncService,new F.SyncDescriptor(qe.ExtensionsStorageSyncService)),me.set(ce.IUserDataSyncStoreManagementService,new F.SyncDescriptor(se.UserDataSyncStoreManagementService)),me.set(ce.IUserDataSyncStoreService,new F.SyncDescriptor(se.UserDataSyncStoreService)),me.set(Fe.IUserDataSyncMachinesService,new F.SyncDescriptor(Fe.UserDataSyncMachinesService)),me.set(ce.IUserDataSyncBackupStoreService,new F.SyncDescriptor(Pe.UserDataSyncBackupStoreService)),me.set(ce.IUserDataAutoSyncEnablementService,new F.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),me.set(ce.IUserDataSyncResourceEnablementService,new F.SyncDescriptor(_e.UserDataSyncResourceEnablementService)),me.set(ce.IUserDataSyncService,new F.SyncDescriptor(Ue.UserDataSyncService));const St=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,ze,Je,nt);return await St.initialize(),me.set(je.ILocalPtyService,this._register(St)),me.set(pe.ISignService,new F.SyncDescriptor(ge.SignService)),me.set(Ee.ISharedTunnelsService,new F.SyncDescriptor(Re.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new F.SyncDescriptor(Le.SharedProcessTunnelService)),new Z.InstantiationService(me)}initChannels(me){const Oe=new P.ExtensionManagementChannel(me.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const We=I.ProxyChannel.fromService(me.get(M.ILocalizationsService));this.server.registerChannel("localizations",We);const Ge=I.ProxyChannel.fromService(me.get(s.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const ze=new P.ExtensionTipsChannel(me.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=I.ProxyChannel.fromService(me.get(E.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new Ae.UserDataSyncMachinesServiceChannel(me.get(Fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=I.ProxyChannel.fromService(me.get(be.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Je=new Ae.UserDataSyncAccountServiceChannel(me.get(Se.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new Ae.UserDataSyncStoreManagementServiceChannel(me.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ct=new Y.UserDataSyncChannel(me.get(ce.IUserDataSyncService),me.get(q.ILogService));this.server.registerChannel("userDataSync",ct);const Be=this._register(me.get(B.IInstantiationService).createInstance(ue.UserDataAutoSyncService)),tt=new Ae.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",tt);const st=me.get(je.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Me.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get($e.ISharedProcessWorkerService));this.server.registerChannel($e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const We=(0,D.toErrorMessage)(Oe,!0);!We||me.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Dt(pt){const me=new Rt(pt);T.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),T.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Dt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b9cf83f70bb6b4697b544a97c7056dfd28fccc5f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
