/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Y){for(var e=[],m=0,L=Y.length;m<L;m++)e[m]=ge[Y[m]];return e};define(ge[56],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=m}),define(ge[73],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(R){const P=[];for(let a in R)m.call(R,a)&&P.push(R[a]);return P}e.values=L;function D(R,P){for(let a in R)if(m.call(R,a)&&P({key:a,value:R[a]},function(){delete R[a]})===!1)return}e.forEach=D;function C(R,P){const a=Object.create(null);for(const w of R){const f=P(w);let v=a[f];v||(v=a[f]=[]),v.push(w)}return a}e.groupBy=C;function i(R){const P=Object.create(null);return R&&R.forEach((a,w)=>{P[w]=a}),P}e.fromMap=i;function k(R,P){const a=[],w=[];for(let f of R)P.has(f)||a.push(f);for(let f of P)R.has(f)||w.push(f);return{removed:a,added:w}}e.diffSets=k;function S(R,P){const a=[],w=[];for(let[f,v]of R)P.has(f)||a.push(v);for(let[f,v]of P)R.has(f)||w.push(v);return{removed:a,added:w}}e.diffMaps=S;class y{constructor(){this.map=new Map}add(P,a){let w=this.map.get(P);w||(w=new Set,this.map.set(P,w)),w.add(a)}delete(P,a){const w=this.map.get(P);!w||(w.delete(a),w.size===0&&this.map.delete(P))}forEach(P,a){const w=this.map.get(P);!w||w.forEach(a)}}e.SetMap=y}),define(ge[57],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(i){return(k,S,y)=>{let R=null,P=null;if(typeof y.value=="function"?(R="value",P=y.value):typeof y.get=="function"&&(R="get",P=y.get),!P)throw new Error("not supported");y[R]=i(P,S)}}e.createDecorator=m;function L(i,k,S){let y=null,R=null;if(typeof S.value=="function"?(y="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${k}`;S[y]=function(...a){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,a)}),this[P]}}e.memoize=L;function D(i,k,S){return m((y,R)=>{const P=`$debounce$${R}`,a=`$debounce$result$${R}`;return function(...w){this[a]||(this[a]=S?S():void 0),clearTimeout(this[P]),k&&(this[a]=k(this[a],...w),w=[this[a]]),this[P]=setTimeout(()=>{y.apply(this,w),this[a]=S?S():void 0},i)}})}e.debounce=D;function C(i,k,S){return m((y,R)=>{const P=`$throttle$timer$${R}`,a=`$throttle$result$${R}`,w=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...v){if(this[a]||(this[a]=S?S():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...v)),this[f])return;const _=this[w]+i;_<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[a]]),this[a]=S?S():void 0):(this[f]=!0,this[P]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),y.apply(this,[this[a]]),this[a]=S?S():void 0},_-Date.now()))}})}e.throttle=C}),define(ge[15],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(E=>{E(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=m,e.errorHandler=new m;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function D(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=D;function C(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function i(g){if(g instanceof Error){let{name:c,message:E}=g;const n=g.stacktrace||g.stack;return{$isError:!0,name:c,message:E,stack:n}}return g}e.transformErrorForSerialization=i;const k="Canceled";function S(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=S;class y extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=y;function R(){const g=new Error(k);return g.name=g.message,g}e.canceled=R;function P(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=P;function a(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=a;function w(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function f(g){const c=new Error(`${g} has been disposed`);return c.name="DISPOSED",c}e.disposed=f;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=_;class A extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=A;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function o(g){const c=g;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=o;function r(g,c=Object.create(null)){const E=new Error(g);return c.actions&&(E.actions=c.actions),E}e.createErrorWithActions=r}),define(ge[17],pe([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,V=0){return H[H.length-(1+V)]}e.tail=L;function D(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=D;function C(H,V,q=(te,fe)=>te===fe){if(H===V)return!0;if(!H||!V||H.length!==V.length)return!1;for(let te=0,fe=H.length;te<fe;te++)if(!q(H[te],V[te]))return!1;return!0}e.equals=C;function i(H,V,q){let te=0,fe=H.length-1;for(;te<=fe;){const Ce=(te+fe)/2|0,ke=q(H[Ce],V);if(ke<0)te=Ce+1;else if(ke>0)fe=Ce-1;else return Ce}return-(te+1)}e.binarySearch=i;function k(H,V){let q=0,te=H.length;if(te===0)return 0;for(;q<te;){const fe=Math.floor((q+te)/2);V(H[fe])?te=fe:q=fe+1}return q}e.findFirstInSorted=k;function S(H,V,q){if(H=H|0,H>=V.length)throw new TypeError("invalid index");let te=V[Math.floor(V.length*Math.random())],fe=[],Ce=[],ke=[];for(let Ue of V){const xe=q(Ue,te);xe<0?fe.push(Ue):xe>0?Ce.push(Ue):ke.push(Ue)}return H<fe.length?S(H,fe,q):H<fe.length+ke.length?ke[0]:S(H-(fe.length+ke.length),Ce,q)}e.quickSelect=S;function y(H,V){const q=[];let te;for(const fe of H.slice(0).sort(V))!te||V(te[0],fe)!==0?(te=[fe],q.push(te)):te.push(fe);return q}e.groupBy=y;function R(H,V,q){const te=[];function fe(Ue,xe,ze){if(xe===0&&ze.length===0)return;const Q=te[te.length-1];Q&&Q.start+Q.deleteCount===Ue?(Q.deleteCount+=xe,Q.toInsert.push(...ze)):te.push({start:Ue,deleteCount:xe,toInsert:ze})}let Ce=0,ke=0;for(;;){if(Ce===H.length){fe(Ce,0,V.slice(ke));break}if(ke===V.length){fe(Ce,H.length-Ce,[]);break}const Ue=H[Ce],xe=V[ke],ze=q(Ue,xe);ze===0?(Ce+=1,ke+=1):ze<0?(fe(Ce,1,[]),Ce+=1):ze>0&&(fe(Ce,0,[xe]),ke+=1)}return te}e.sortedDiff=R;function P(H,V,q){const te=R(H,V,q),fe=[],Ce=[];for(const ke of te)fe.push(...H.slice(ke.start,ke.start+ke.deleteCount)),Ce.push(...ke.toInsert);return{removed:fe,added:Ce}}e.delta=P;function a(H,V,q){if(q===0)return[];const te=H.slice(0,q).sort(V);return f(H,V,te,q,H.length),te}e.top=a;function w(H,V,q,te,fe){return q===0?Promise.resolve([]):new Promise((Ce,ke)=>{(async()=>{const Ue=H.length,xe=H.slice(0,q).sort(V);for(let ze=q,Q=Math.min(q+te,Ue);ze<Ue;ze=Q,Q=Math.min(Q+te,Ue)){if(ze>q&&await new Promise(Z=>setTimeout(Z)),fe&&fe.isCancellationRequested)throw(0,m.canceled)();f(H,V,xe,ze,Q)}return xe})().then(Ce,ke)})}e.topAsync=w;function f(H,V,q,te,fe){for(const Ce=q.length;te<fe;te++){const ke=H[te];if(V(ke,q[Ce-1])<0){q.pop();const Ue=k(q,xe=>V(ke,xe)<0);q.splice(Ue,0,ke)}}}function v(H){return H.filter(V=>!!V)}e.coalesce=v;function _(H){let V=0;for(let q=0;q<H.length;q++)H[q]&&(H[V]=H[q],V+=1);H.length=V}e.coalesceInPlace=_;function A(H,V,q){H.splice(q,0,H.splice(V,1)[0])}e.move=A;function p(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=p;function o(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=o;function r(H,V=q=>q){const q=new Set;return H.filter(te=>{const fe=V(te);return q.has(fe)?!1:(q.add(fe),!0)})}e.distinct=r;function g(H){const V=Object.create(null);return q=>{const te=H(q);return V[te]?!1:(V[te]=!0,!0)}}e.uniqueFilter=g;function c(H,V){const q=E(H,V);if(q!==-1)return H[q]}e.findLast=c;function E(H,V){for(let q=H.length-1;q>=0;q--){const te=H[q];if(V(te))return q}return-1}e.lastIndex=E;function n(H,V){return H.length>0?H[0]:V}e.firstOrDefault=n;function t(H,V,q=(te,fe)=>te===fe){let te=0;for(let fe=0,Ce=Math.min(H.length,V.length);fe<Ce&&q(H[fe],V[fe]);fe++)te++;return te}e.commonPrefixLength=t;function s(H){return[].concat(...H)}e.flatten=s;function d(H,V){let q=typeof V=="number"?H:0;typeof V=="number"?q=H:(q=0,V=H);const te=[];if(q<=V)for(let fe=q;fe<V;fe++)te.push(fe);else for(let fe=q;fe>V;fe--)te.push(fe);return te}e.range=d;function l(H,V,q){return H.reduce((te,fe)=>(te[V(fe)]=q?q(fe):fe,te),Object.create(null))}e.index=l;function h(H,V){return H.push(V),()=>u(H,V)}e.insert=h;function u(H,V){const q=H.indexOf(V);if(q>-1)return H.splice(q,1),V}e.remove=u;function b(H,V,q){const te=H.slice(0,V),fe=H.slice(V);return te.concat(q,fe)}e.arrayInsert=b;function I(H,V){let q;if(typeof V=="number"){let te=V;q=()=>{const fe=Math.sin(te++)*179426549;return fe-Math.floor(fe)}}else q=Math.random;for(let te=H.length-1;te>0;te-=1){const fe=Math.floor(q()*(te+1)),Ce=H[te];H[te]=H[fe],H[fe]=Ce}}e.shuffle=I;function T(H,V){const q=H.indexOf(V);q>-1&&(H.splice(q,1),H.unshift(V))}e.pushToStart=T;function x(H,V){const q=H.indexOf(V);q>-1&&(H.splice(q,1),H.push(V))}e.pushToEnd=x;function O(H,V){return Array.isArray(H)?H.map(V):V(H)}e.mapArrayOrNot=O;function F(H){return Array.isArray(H)?H:[H]}e.asArray=F;function W(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=W;function M(H,V){for(const q of H){const te=V(q);if(te!==void 0)return te}}e.mapFind=M;function B(H,V,q){const te=z(H,V),fe=H.length,Ce=q.length;H.length=fe+Ce;for(let ke=fe-1;ke>=te;ke--)H[ke+Ce]=H[ke];for(let ke=0;ke<Ce;ke++)H[ke+te]=q[ke]}e.insertInto=B;function U(H,V,q,te){const fe=z(H,V),Ce=H.splice(fe,q);return B(H,fe,te),Ce}e.splice=U;function z(H,V){return V<0?Math.max(V+H.length,0):Math.min(V,H.length)}function K(H,V){let q=Number.MAX_SAFE_INTEGER,te=0;return H.forEach((fe,Ce)=>{const ke=V(fe);ke<q&&(q=ke,te=Ce)}),te}e.minIndex=K;function N(H,V){let q=Number.MIN_SAFE_INTEGER,te=0;return H.forEach((fe,Ce)=>{const ke=V(fe);ke>q&&(q=ke,te=Ce)}),te}e.maxIndex=N;class j{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let q=this.firstIdx;for(;q<this.items.length&&V(this.items[q]);)q++;const te=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,te}takeFromEndWhile(V){let q=this.lastIdx;for(;q>=0&&V(this.items[q]);)q--;const te=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,te}peek(){return this.items[this.firstIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}takeCount(V){const q=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,q}}e.ArrayQueue=j}),define(ge[74],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const D=this;let C=!1,i;return function(){return C||(C=!0,i=L.apply(D,arguments)),i}}e.once=m}),define(ge[75],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(ge[76],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function D(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=D;const C=Object.freeze([]);function i(){return C}L.empty=i;function*k(g){yield g}L.single=k;function S(g){return g||C}L.from=S;function y(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=y;function R(g){return g[Symbol.iterator]().next().value}L.first=R;function P(g,c){for(const E of g)if(c(E))return!0;return!1}L.some=P;function a(g,c){for(const E of g)if(c(E))return E}L.find=a;function*w(g,c){for(const E of g)c(E)&&(yield E)}L.filter=w;function*f(g,c){let E=0;for(const n of g)yield c(n,E++)}L.map=f;function*v(...g){for(const c of g)for(const E of c)yield E}L.concat=v;function*_(g){for(const c of g)for(const E of c)yield E}L.concatNested=_;function A(g,c,E){let n=E;for(const t of g)n=c(n,t);return n}L.reduce=A;function*p(g,c,E=g.length){for(c<0&&(c+=g.length),E<0?E+=g.length:E>g.length&&(E=g.length);c<E;c++)yield g[c]}L.slice=p;function o(g,c=Number.POSITIVE_INFINITY){const E=[];if(c===0)return[E,g];const n=g[Symbol.iterator]();for(let t=0;t<c;t++){const s=n.next();if(s.done)return[E,L.empty()];E.push(s.value)}return[E,{[Symbol.iterator](){return n}}]}L.consume=o;function r(g,c,E=(n,t)=>n===t){const n=g[Symbol.iterator](),t=c[Symbol.iterator]();for(;;){const s=n.next(),d=t.next();if(s.done!==d.done)return!1;if(s.done)return!0;if(!E(s.value,d.value))return!1}}L.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(ge[58],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(c){c[c.None=0]="None",c[c.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=2]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",c[c.InvalidUnicode=4]="InvalidUnicode",c[c.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",c[c.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(c){c[c.OpenBraceToken=1]="OpenBraceToken",c[c.CloseBraceToken=2]="CloseBraceToken",c[c.OpenBracketToken=3]="OpenBracketToken",c[c.CloseBracketToken=4]="CloseBracketToken",c[c.CommaToken=5]="CommaToken",c[c.ColonToken=6]="ColonToken",c[c.NullKeyword=7]="NullKeyword",c[c.TrueKeyword=8]="TrueKeyword",c[c.FalseKeyword=9]="FalseKeyword",c[c.StringLiteral=10]="StringLiteral",c[c.NumericLiteral=11]="NumericLiteral",c[c.LineCommentTrivia=12]="LineCommentTrivia",c[c.BlockCommentTrivia=13]="BlockCommentTrivia",c[c.LineBreakTrivia=14]="LineBreakTrivia",c[c.Trivia=15]="Trivia",c[c.Unknown=16]="Unknown",c[c.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(c){c[c.InvalidSymbol=1]="InvalidSymbol",c[c.InvalidNumberFormat=2]="InvalidNumberFormat",c[c.PropertyNameExpected=3]="PropertyNameExpected",c[c.ValueExpected=4]="ValueExpected",c[c.ColonExpected=5]="ColonExpected",c[c.CommaExpected=6]="CommaExpected",c[c.CloseBraceExpected=7]="CloseBraceExpected",c[c.CloseBracketExpected=8]="CloseBracketExpected",c[c.EndOfFileExpected=9]="EndOfFileExpected",c[c.InvalidCommentToken=10]="InvalidCommentToken",c[c.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",c[c.UnexpectedEndOfString=12]="UnexpectedEndOfString",c[c.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",c[c.InvalidUnicode=14]="InvalidUnicode",c[c.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",c[c.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(c){c.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function i(c,E=!1){let n=0,t=c.length,s="",d=0,l=16,h=0;function u(W){let M=0,B=0;for(;M<W;){const U=c.charCodeAt(n);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;n++,M++}return M<W&&(B=-1),B}function b(W){n=W,s="",d=0,l=16,h=0}function I(){const W=n;if(c.charCodeAt(n)===48)n++;else for(n++;n<c.length&&y(c.charCodeAt(n));)n++;if(n<c.length&&c.charCodeAt(n)===46)if(n++,n<c.length&&y(c.charCodeAt(n)))for(n++;n<c.length&&y(c.charCodeAt(n));)n++;else return h=3,c.substring(W,n);let M=n;if(n<c.length&&(c.charCodeAt(n)===69||c.charCodeAt(n)===101))if(n++,(n<c.length&&c.charCodeAt(n)===43||c.charCodeAt(n)===45)&&n++,n<c.length&&y(c.charCodeAt(n))){for(n++;n<c.length&&y(c.charCodeAt(n));)n++;M=n}else h=3;return c.substring(W,M)}function T(){let W="",M=n;for(;;){if(n>=t){W+=c.substring(M,n),h=2;break}const B=c.charCodeAt(n);if(B===34){W+=c.substring(M,n),n++;break}if(B===92){if(W+=c.substring(M,n),n++,n>=t){h=2;break}switch(c.charCodeAt(n++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const z=u(4);z>=0?W+=String.fromCharCode(z):h=4;break;default:h=5}M=n;continue}if(B>=0&&B<=31)if(S(B)){W+=c.substring(M,n),h=2;break}else h=6;n++}return W}function x(){if(s="",h=0,d=n,n>=t)return d=t,l=17;let W=c.charCodeAt(n);if(k(W)){do n++,s+=String.fromCharCode(W),W=c.charCodeAt(n);while(k(W));return l=15}if(S(W))return n++,s+=String.fromCharCode(W),W===13&&c.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(W){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=T(),l=10;case 47:const M=n-1;if(c.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(c.charCodeAt(n));)n++;return s=c.substring(M,n),l=12}if(c.charCodeAt(n+1)===42){n+=2;const B=t-1;let U=!1;for(;n<B;){if(c.charCodeAt(n)===42&&c.charCodeAt(n+1)===47){n+=2,U=!0;break}n++}return U||(n++,h=1),s=c.substring(M,n),l=13}return s+=String.fromCharCode(W),n++,l=16;case 45:if(s+=String.fromCharCode(W),n++,n===t||!y(c.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=I(),l=11;default:for(;n<t&&O(W);)n++,W=c.charCodeAt(n);if(d!==n){switch(s=c.substring(d,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(W),n++,l=16}}function O(W){if(k(W)||S(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let W;do W=x();while(W>=12&&W<=15);return W}return{setPosition:b,getPosition:()=>n,scan:E?F:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>h}}e.createScanner=i;function k(c){return c===32||c===9||c===11||c===12||c===160||c===5760||c>=8192&&c<=8203||c===8239||c===8287||c===12288||c===65279}function S(c){return c===10||c===13||c===8232||c===8233}function y(c){return c>=48&&c<=57}var R;(function(c){c[c.nullCharacter=0]="nullCharacter",c[c.maxAsciiCharacter=127]="maxAsciiCharacter",c[c.lineFeed=10]="lineFeed",c[c.carriageReturn=13]="carriageReturn",c[c.lineSeparator=8232]="lineSeparator",c[c.paragraphSeparator=8233]="paragraphSeparator",c[c.nextLine=133]="nextLine",c[c.space=32]="space",c[c.nonBreakingSpace=160]="nonBreakingSpace",c[c.enQuad=8192]="enQuad",c[c.emQuad=8193]="emQuad",c[c.enSpace=8194]="enSpace",c[c.emSpace=8195]="emSpace",c[c.threePerEmSpace=8196]="threePerEmSpace",c[c.fourPerEmSpace=8197]="fourPerEmSpace",c[c.sixPerEmSpace=8198]="sixPerEmSpace",c[c.figureSpace=8199]="figureSpace",c[c.punctuationSpace=8200]="punctuationSpace",c[c.thinSpace=8201]="thinSpace",c[c.hairSpace=8202]="hairSpace",c[c.zeroWidthSpace=8203]="zeroWidthSpace",c[c.narrowNoBreakSpace=8239]="narrowNoBreakSpace",c[c.ideographicSpace=12288]="ideographicSpace",c[c.mathematicalSpace=8287]="mathematicalSpace",c[c.ogham=5760]="ogham",c[c._=95]="_",c[c.$=36]="$",c[c._0=48]="_0",c[c._1=49]="_1",c[c._2=50]="_2",c[c._3=51]="_3",c[c._4=52]="_4",c[c._5=53]="_5",c[c._6=54]="_6",c[c._7=55]="_7",c[c._8=56]="_8",c[c._9=57]="_9",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.ampersand=38]="ampersand",c[c.asterisk=42]="asterisk",c[c.at=64]="at",c[c.backslash=92]="backslash",c[c.bar=124]="bar",c[c.caret=94]="caret",c[c.closeBrace=125]="closeBrace",c[c.closeBracket=93]="closeBracket",c[c.closeParen=41]="closeParen",c[c.colon=58]="colon",c[c.comma=44]="comma",c[c.dot=46]="dot",c[c.doubleQuote=34]="doubleQuote",c[c.equals=61]="equals",c[c.exclamation=33]="exclamation",c[c.greaterThan=62]="greaterThan",c[c.lessThan=60]="lessThan",c[c.minus=45]="minus",c[c.openBrace=123]="openBrace",c[c.openBracket=91]="openBracket",c[c.openParen=40]="openParen",c[c.percent=37]="percent",c[c.plus=43]="plus",c[c.question=63]="question",c[c.semicolon=59]="semicolon",c[c.singleQuote=39]="singleQuote",c[c.slash=47]="slash",c[c.tilde=126]="tilde",c[c.backspace=8]="backspace",c[c.formFeed=12]="formFeed",c[c.byteOrderMark=65279]="byteOrderMark",c[c.tab=9]="tab",c[c.verticalTab=11]="verticalTab"})(R||(R={}));function P(c,E){const n=[],t=new Object;let s;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function h(u,b,I,T){d.value=u,d.offset=b,d.length=I,d.type=T,d.colonOffset=void 0,s=d}try{o(c,{onObjectBegin:(u,b)=>{if(E<=u)throw t;s=void 0,l=E>u,n.push("")},onObjectProperty:(u,b,I)=>{if(E<b||(h(u,b,I,"property"),n[n.length-1]=u,E<=b+I))throw t},onObjectEnd:(u,b)=>{if(E<=u)throw t;s=void 0,n.pop()},onArrayBegin:(u,b)=>{if(E<=u)throw t;s=void 0,n.push(0)},onArrayEnd:(u,b)=>{if(E<=u)throw t;s=void 0,n.pop()},onLiteralValue:(u,b,I)=>{if(E<b||(h(u,b,I,g(u)),E<=b+I))throw t},onSeparator:(u,b,I)=>{if(E<=b)throw t;if(u===":"&&s&&s.type==="property")s.colonOffset=b,l=!1,s=void 0;else if(u===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(u){if(u!==t)throw u}return{path:n,previousNode:s,isAtPropertyKey:l,matches:u=>{let b=0;for(let I=0;b<u.length&&I<n.length;I++)if(u[b]===n[I]||u[b]==="*")b++;else if(u[b]!=="**")return!1;return b===u.length}}}e.getLocation=P;function a(c,E=[],n=C.DEFAULT){let t=null,s=[];const d=[];function l(u){Array.isArray(s)?s.push(u):t!==null&&(s[t]=u)}return o(c,{onObjectBegin:()=>{const u={};l(u),d.push(s),s=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{s=d.pop()},onArrayBegin:()=>{const u=[];l(u),d.push(s),s=u,t=null},onArrayEnd:()=>{s=d.pop()},onLiteralValue:l,onError:(u,b,I)=>{E.push({error:u,offset:b,length:I})}},n),s[0]}e.parse=a;function w(c,E=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function d(u){return t.children.push(u),u}o(c,{onObjectBegin:u=>{t=d({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,b,I)=>{t=d({type:"property",offset:b,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:b,length:I,parent:t})},onObjectEnd:(u,b)=>{t.length=u+b-t.offset,t=t.parent,s(u+b)},onArrayBegin:(u,b)=>{t=d({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,b)=>{t.length=u+b-t.offset,t=t.parent,s(u+b)},onLiteralValue:(u,b,I)=>{d({type:g(u),offset:b,length:I,parent:t,value:u}),s(b+I)},onSeparator:(u,b,I)=>{t.type==="property"&&(u===":"?t.colonOffset=b:u===","&&s(b))},onError:(u,b,I)=>{E.push({error:u,offset:b,length:I})}},n);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=w;function f(c,E){if(!c)return;let n=c;for(let t of E)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===t){n=d.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=f;function v(c){if(!c.parent||!c.parent.children)return[];const E=v(c.parent);if(c.parent.type==="property"){const n=c.parent.children[0].value;E.push(n)}else if(c.parent.type==="array"){const n=c.parent.children.indexOf(c);n!==-1&&E.push(n)}return E}e.getNodePath=v;function _(c){switch(c.type){case"array":return c.children.map(_);case"object":const E=Object.create(null);for(let n of c.children){const t=n.children[1];t&&(E[n.children[0].value]=_(t))}return E;case"null":case"string":case"number":case"boolean":return c.value;default:return}}e.getNodeValue=_;function A(c,E,n=!1){return E>=c.offset&&E<c.offset+c.length||n&&E===c.offset+c.length}e.contains=A;function p(c,E,n=!1){if(A(c,E,n)){const t=c.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=E;s++){const d=p(t[s],E,n);if(d)return d}return c}}e.findNodeAtOffset=p;function o(c,E,n=C.DEFAULT){const t=i(c,!1);function s(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(q){return q?te=>q(te,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=s(E.onObjectBegin),h=d(E.onObjectProperty),u=s(E.onObjectEnd),b=s(E.onArrayBegin),I=s(E.onArrayEnd),T=d(E.onLiteralValue),x=d(E.onSeparator),O=s(E.onComment),F=d(E.onError),W=n&&n.disallowComments,M=n&&n.allowTrailingComma;function B(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:W||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(q){case 12:case 13:W?U(10):O();break;case 16:U(1);break;case 15:case 14:break;default:return q}}}function U(q,te=[],fe=[]){if(F(q),te.length+fe.length>0){let Ce=t.getToken();for(;Ce!==17;){if(te.indexOf(Ce)!==-1){B();break}else if(fe.indexOf(Ce)!==-1)break;Ce=B()}}}function z(q){const te=t.getTokenValue();return q?T(te):h(te),B(),!0}function K(){switch(t.getToken()){case 11:let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(U(2),q=0)}catch(te){U(2)}T(q);break;case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return B(),!0}function N(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(z(!1),t.getToken()===6?(x(":"),B(),V()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function j(){l(),B();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||U(4,[],[]),x(","),B(),t.getToken()===2&&M)break}else q&&U(6,[],[]);N()||U(4,[],[2,5]),q=!0}return u(),t.getToken()!==2?U(7,[2],[]):B(),!0}function H(){b(),B();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||U(4,[],[]),x(","),B(),t.getToken()===4&&M)break}else q&&U(6,[],[]);V()||U(4,[],[4,5]),q=!0}return I(),t.getToken()!==4?U(8,[4],[]):B(),!0}function V(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return z(!0);default:return K()}}return B(),t.getToken()===17?n.allowEmptyContent?!0:(U(4,[],[]),!1):V()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=o;function r(c,E){let n=i(c),t=[],s,d=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:d!==l&&t.push(c.substring(d,l)),E!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,E)),d=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=r;function g(c){switch(typeof c){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(c){if(Array.isArray(c))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ge[138],pe([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,y,R){let P,a,w,f,v;if(y){for(f=y.offset,v=f+y.length,w=f;w>0&&!k(S,w-1);)w--;let d=v;for(;d<S.length&&!k(S,d);)d++;a=S.substring(w,d),P=C(a,R)}else a=S,P=0,w=0,f=0,v=S.length;const _=i(R,S);let A=!1,p=0,o;R.insertSpaces?o=D(" ",R.tabSize||4):o="	";const r=(0,m.createScanner)(a,!1);let g=!1;function c(){return _+D(o,P+p)}function E(){let d=r.scan();for(A=!1;d===15||d===14;)A=A||d===14,d=r.scan();return g=d===16||r.getTokenError()!==0,d}const n=[];function t(d,l,h){!g&&l<v&&h>f&&S.substring(l,h)!==d&&n.push({offset:l,length:h-l,content:d})}let s=E();if(s!==17){const d=r.getTokenOffset()+w,l=D(o,P);t(l,w,d)}for(;s!==17;){let d=r.getTokenOffset()+r.getTokenLength()+w,l=E(),h="";for(;!A&&(l===12||l===13);){const b=r.getTokenOffset()+w;t(" ",d,b),d=r.getTokenOffset()+r.getTokenLength()+w,h=l===12?c():"",l=E()}if(l===2)s!==1&&(p--,h=c());else if(l===4)s!==3&&(p--,h=c());else{switch(s){case 3:case 1:p++,h=c();break;case 5:case 12:h=c();break;case 13:A?h=c():h=" ";break;case 6:h=" ";break;case 10:if(l===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?h=" ":l!==5&&l!==17&&(g=!0);break;case 16:g=!0;break}A&&(l===12||l===13)&&(h=c())}const u=r.getTokenOffset()+w;t(h,d,u),s=l}return n}e.format=L;function D(S,y){let R="";for(let P=0;P<y;P++)R+=S;return R}function C(S,y){let R=0,P=0;const a=y.tabSize||4;for(;R<S.length;){const w=S.charAt(R);if(w===" ")P++;else if(w==="	")P+=a;else break;R++}return Math.floor(P/a)}function i(S,y){for(let R=0;R<y.length;R++){const P=y.charAt(R);if(P==="\r")return R+1<y.length&&y.charAt(R+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function k(S,y){return`\r
`.indexOf(S.charAt(y))!==-1}e.isEOL=k}),define(ge[139],pe([0,1,58,138]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(y,R,P){return C(y,R,void 0,P)}e.removeProperty=D;function C(y,R,P,a,w){const f=R.slice(),v=[],_=(0,m.parseTree)(y,v);let A,p;for(;f.length>0&&(p=f.pop(),A=(0,m.findNodeAtLocation)(_,f),A===void 0&&P!==void 0);)typeof p=="string"?P={[p]:P}:P=[P];if(A)if(A.type==="object"&&typeof p=="string"&&Array.isArray(A.children)){const o=(0,m.findNodeAtLocation)(A,[p]);if(o!==void 0)if(P===void 0){if(!o.parent)throw new Error("Malformed AST");const r=A.children.indexOf(o.parent);let g,c=o.parent.offset+o.parent.length;if(r>0){const E=A.children[r-1];g=E.offset+E.length}else g=A.offset+1,A.children.length>1&&(c=A.children[1].offset);return i(y,{offset:g,length:c-g,content:""},a)}else return i(y,{offset:o.offset,length:o.length,content:JSON.stringify(P)},a);else{if(P===void 0)return[];const r=`${JSON.stringify(p)}: ${JSON.stringify(P)}`,g=w?w(A.children.map(E=>E.children[0].value)):A.children.length;let c;if(g>0){const E=A.children[g-1];c={offset:E.offset+E.length,length:0,content:","+r}}else A.children.length===0?c={offset:A.offset+1,length:0,content:r}:c={offset:A.offset+1,length:0,content:r+","};return i(y,c,a)}}else if(A.type==="array"&&typeof p=="number"&&Array.isArray(A.children))if(P!==void 0){const o=`${JSON.stringify(P)}`;let r;if(A.children.length===0||p===0)r={offset:A.offset+1,length:0,content:A.children.length===0?o:o+","};else{const g=p===-1||p>A.children.length?A.children.length:p,c=A.children[g-1];r={offset:c.offset+c.length,length:0,content:","+o}}return i(y,r,a)}else{const o=p,r=A.children[o];let g;if(A.children.length===1)g={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===o){const c=A.children[o-1],E=c.offset+c.length,n=A.offset+A.length;g={offset:E,length:n-2-E,content:""}}else g={offset:r.offset,length:A.children[o+1].offset-r.offset,content:""};return i(y,g,a)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${A.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return i(y,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(P)},a)}}e.setProperty=C;function i(y,R,P){let a=k(y,R),w=R.offset,f=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;w>0&&!(0,L.isEOL)(a,w-1);)w--;for(;f<a.length&&!(0,L.isEOL)(a,f);)f++}const v=(0,L.format)(a,{offset:w,length:f-w},P);for(let A=v.length-1;A>=0;A--){const p=v[A];a=k(a,p),w=Math.min(w,p.offset),f=Math.max(f,p.offset+p.length),f+=p.content.length-p.length}const _=y.length-(a.length-f)-w;return[{offset:w,length:_,content:a.substring(w,f)}]}e.withFormatting=i;function k(y,R){return y.substring(0,R.offset)+R.content+y.substring(R.offset+R.length)}e.applyEdit=k;function S(y,R){let P=R.slice(0).sort((w,f)=>{const v=w.offset-f.offset;return v===0?w.length-f.length:v}),a=y.length;for(let w=P.length-1;w>=0;w--){let f=P[w];if(f.offset+f.length<=a)y=k(y,f);else throw new Error("Overlapping edit");a=f.offset}return y}e.applyEdits=S}),define(ge[140],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new m(()=>D(this.getValue()))}}e.Lazy=m}),define(ge[6],pe([0,1,74,76]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function i(t){C=t}if(e.setDisposableTracker=i,D){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(d)},3e3)}setParent(s,d){if(s&&s!==p.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function k(t){return C?.trackDisposable(t),t}function S(t){C?.markAsDisposed(t)}function y(t,s){C?.setParent(t,s)}function R(t,s){if(!!C)for(const d of t)C.setParent(d,s)}function P(t){return C?.markAsSingleton(t),t}e.markAsSingleton=P;class a extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=a;function w(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=w;function f(t){if(L.Iterable.is(t)){let s=[];for(const d of t)if(d)try{d.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new a(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function v(...t){const s=_(()=>f(t));return R(t,s),s}e.combinedDisposable=v;function _(t){const s=k({dispose:(0,m.once)(()=>{S(s),t()})});return s}e.toDisposable=_;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return y(s,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new A,k(this),y(this._store,this)}dispose(){S(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&y(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&y(s,null),s}}e.MutableDisposable=o;class r{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class g{constructor(){this.references=new Map}acquire(s,...d){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...d)},this.references.set(s,l));const{object:h}=l,u=(0,m.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:h,dispose:u}}}e.ReferenceCollection=g;class c{constructor(s){this.referenceCollection=s}async acquire(s,...d){const l=this.referenceCollection.acquire(s,...d);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=c;class E{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=E;function n(t){const s=new A;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(ge[93],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const i=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=i}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,i){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(i){const y=this._last;this._last=k,k.prev=y,y.next=k}else{const y=this._first;this._first=k,k.next=y,y.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const i=C.prev;i.next=C.next,C.next.prev=i}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,ye){for(var be=0;be<ye.length;be++){var ae=ye[be];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Te,ae.key,ae)}}function e(Te,ye,be){return ye&&Y(Te.prototype,ye),be&&Y(Te,be),Te}function m(Te,ye){if(!!Te){if(typeof Te=="string")return L(Te,ye);var be=Object.prototype.toString.call(Te).slice(8,-1);if(be==="Object"&&Te.constructor&&(be=Te.constructor.name),be==="Map"||be==="Set")return Array.from(Te);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return L(Te,ye)}}function L(Te,ye){(ye==null||ye>Te.length)&&(ye=Te.length);for(var be=0,ae=new Array(ye);be<ye;be++)ae[be]=Te[be];return ae}function D(Te,ye){var be=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(be)return(be=be.call(Te)).next.bind(be);if(Array.isArray(Te)||(be=m(Te))||ye&&Te&&typeof Te.length=="number"){be&&(Te=be);var ae=0;return function(){return ae>=Te.length?{done:!0}:{done:!1,value:Te[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function i(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Te){C.exports.defaults=Te}C.exports={defaults:i(),getDefaults:i,changeDefaults:k};var S=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(ye){return a[ye]};function f(Te,ye){if(ye){if(S.test(Te))return Te.replace(y,w)}else if(R.test(Te))return Te.replace(P,w);return Te}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Te){return Te.replace(v,function(ye,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var A=/(^|[^\[])\^/g;function p(Te,ye){Te=Te.source||Te,ye=ye||"";var be={replace:function(de,ve){return ve=ve.source||ve,ve=ve.replace(A,"$1"),Te=Te.replace(de,ve),be},getRegex:function(){return new RegExp(Te,ye)}};return be}var o=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Te,ye,be){if(Te){var ae;try{ae=decodeURIComponent(_(be)).replace(o,"").toLowerCase()}catch(de){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!r.test(be)&&(be=s(ye,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch(de){return null}return be}var c={},E=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,ye){c[" "+Te]||(E.test(Te)?c[" "+Te]=Te+"/":c[" "+Te]=u(Te,"/",!0)),Te=c[" "+Te];var be=Te.indexOf(":")===-1;return ye.substring(0,2)==="//"?be?ye:Te.replace(n,"$1")+ye:ye.charAt(0)==="/"?be?ye:Te.replace(t,"$1")+ye:Te+ye}var d={exec:function(){}};function l(Te){for(var ye=1,be,ae;ye<arguments.length;ye++){be=arguments[ye];for(ae in be)Object.prototype.hasOwnProperty.call(be,ae)&&(Te[ae]=be[ae])}return Te}function h(Te,ye){var be=Te.replace(/\|/g,function(ve,Ee,Fe){for(var Qe=!1,We=Ee;--We>=0&&Fe[We]==="\\";)Qe=!Qe;return Qe?"|":" |"}),ae=be.split(/ \|/),de=0;if(ae[0].trim()||ae.shift(),ae[ae.length-1].trim()||ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;de<ae.length;de++)ae[de]=ae[de].trim().replace(/\\\|/g,"|");return ae}function u(Te,ye,be){var ae=Te.length;if(ae===0)return"";for(var de=0;de<ae;){var ve=Te.charAt(ae-de-1);if(ve===ye&&!be)de++;else if(ve!==ye&&be)de++;else break}return Te.substr(0,ae-de)}function b(Te,ye){if(Te.indexOf(ye[1])===-1)return-1;for(var be=Te.length,ae=0,de=0;de<be;de++)if(Te[de]==="\\")de++;else if(Te[de]===ye[0])ae++;else if(Te[de]===ye[1]&&(ae--,ae<0))return de;return-1}function I(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Te,ye){if(ye<1)return"";for(var be="";ye>1;)ye&1&&(be+=Te),ye>>=1,Te+=Te;return be+Te}var x={escape:f,unescape:_,edit:p,cleanUrl:g,resolveUrl:s,noopTest:d,merge:l,splitCells:h,rtrim:u,findClosingBracket:b,checkSanitizeDeprecation:I,repeatString:T},O=C.exports.defaults,F=x.rtrim,W=x.splitCells,M=x.escape,B=x.findClosingBracket;function U(Te,ye,be,ae){var de=ye.href,ve=ye.title?M(ye.title):null,Ee=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ae.state.inLink=!0;var Fe={type:"link",raw:be,href:de,title:ve,text:Ee,tokens:ae.inlineTokens(Ee,[])};return ae.state.inLink=!1,Fe}else return{type:"image",raw:be,href:de,title:ve,text:M(Ee)}}function z(Te,ye){var be=Te.match(/^(\s+)(?:```)/);if(be===null)return ye;var ae=be[1];return ye.split(`
`).map(function(de){var ve=de.match(/^\s+/);if(ve===null)return de;var Ee=ve[0];return Ee.length>=ae.length?de.slice(ae.length):de}).join(`
`)}var K=function(){function Te(be){this.options=be||O}var ye=Te.prototype;return ye.space=function(ae){var de=this.rules.block.newline.exec(ae);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},ye.code=function(ae){var de=this.rules.block.code.exec(ae);if(de){var ve=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ve:F(ve,`
`)}}},ye.fences=function(ae){var de=this.rules.block.fences.exec(ae);if(de){var ve=de[0],Ee=z(ve,de[3]||"");return{type:"code",raw:ve,lang:de[2]?de[2].trim():de[2],text:Ee}}},ye.heading=function(ae){var de=this.rules.block.heading.exec(ae);if(de){var ve=de[2].trim();if(/#$/.test(ve)){var Ee=F(ve,"#");(this.options.pedantic||!Ee||/ $/.test(Ee))&&(ve=Ee.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:ve,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ye.hr=function(ae){var de=this.rules.block.hr.exec(ae);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(ae){var de=this.rules.block.blockquote.exec(ae);if(de){var ve=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ve,[]),text:ve}}},ye.list=function(ae){var de=this.rules.block.list.exec(ae);if(de){var ve,Ee,Fe,Qe,We,Xe,at,lt,le,_e,ce=de[1].trim(),X=ce.length>1,De={type:"list",raw:"",ordered:X,start:X?+ce.slice(0,-1):"",loose:!1,items:[]};ce=X?"\\d{1,9}\\"+ce.slice(-1):"\\"+ce,this.options.pedantic&&(ce=X?ce:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ce+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ae&&!(this.rules.block.hr.test(ae)||!(de=Le.exec(ae)));){le=de[2].split(`
`),this.options.pedantic?(Qe=2,_e=le[0].trimLeft()):(Qe=de[2].search(/[^ ]/),Qe=de[1].length+(Qe>4?1:Qe),_e=le[0].slice(Qe-de[1].length)),Xe=!1,ve=de[0],!le[0]&&/^ *$/.test(le[1])&&(ve=de[1]+le.slice(0,2).join(`
`)+`
`,De.loose=!0,le=[]);var et=new RegExp("^ {0,"+Math.min(3,Qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(We=1;We<le.length;We++){if(lt=le[We],this.options.pedantic&&(lt=lt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),et.test(lt)){ve=de[1]+le.slice(0,We).join(`
`)+`
`;break}if(!Xe){lt.trim()||(Xe=!0),lt.search(/[^ ]/)>=Qe?_e+=`
`+lt.slice(Qe):_e+=`
`+lt;continue}if(lt.search(/[^ ]/)>=Qe||!lt.trim()){_e+=`
`+lt.slice(Qe);continue}else{ve=de[1]+le.slice(0,We).join(`
`)+`
`;break}}De.loose||(at?De.loose=!0:/\n *\n *$/.test(ve)&&(at=!0)),this.options.gfm&&(Ee=/^\[[ xX]\] /.exec(_e),Ee&&(Fe=Ee[0]!=="[ ] ",_e=_e.replace(/^\[[ xX]\] +/,""))),De.items.push({type:"list_item",raw:ve,task:!!Ee,checked:Fe,loose:!1,text:_e}),De.raw+=ve,ae=ae.slice(ve.length)}De.items[De.items.length-1].raw=ve.trimRight(),De.items[De.items.length-1].text=_e.trimRight(),De.raw=De.raw.trimRight();var qe=De.items.length;for(We=0;We<qe;We++)this.lexer.state.top=!1,De.items[We].tokens=this.lexer.blockTokens(De.items[We].text,[]),De.items[We].tokens.some(function(mt){return mt.type==="space"})&&(De.loose=!0,De.items[We].loose=!0);return De}},ye.html=function(ae){var de=this.rules.block.html.exec(ae);if(de){var ve={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(ve.type="paragraph",ve.text=this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]),ve.tokens=[],this.lexer.inline(ve.text,ve.tokens)),ve}},ye.def=function(ae){var de=this.rules.block.def.exec(ae);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ve=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ve,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(ae){var de=this.rules.block.table.exec(ae);if(de){var ve={type:"table",header:W(de[1]).map(function(at){return{text:at}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(ve.header.length===ve.align.length){ve.raw=de[0];var Ee=ve.align.length,Fe,Qe,We,Xe;for(Fe=0;Fe<Ee;Fe++)/^ *-+: *$/.test(ve.align[Fe])?ve.align[Fe]="right":/^ *:-+: *$/.test(ve.align[Fe])?ve.align[Fe]="center":/^ *:-+ *$/.test(ve.align[Fe])?ve.align[Fe]="left":ve.align[Fe]=null;for(Ee=ve.rows.length,Fe=0;Fe<Ee;Fe++)ve.rows[Fe]=W(ve.rows[Fe],ve.header.length).map(function(at){return{text:at}});for(Ee=ve.header.length,Qe=0;Qe<Ee;Qe++)ve.header[Qe].tokens=[],this.lexer.inlineTokens(ve.header[Qe].text,ve.header[Qe].tokens);for(Ee=ve.rows.length,Qe=0;Qe<Ee;Qe++)for(Xe=ve.rows[Qe],We=0;We<Xe.length;We++)Xe[We].tokens=[],this.lexer.inlineTokens(Xe[We].text,Xe[We].tokens);return ve}}},ye.lheading=function(ae){var de=this.rules.block.lheading.exec(ae);if(de){var ve={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(ve.text,ve.tokens),ve}},ye.paragraph=function(ae){var de=this.rules.block.paragraph.exec(ae);if(de){var ve={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(ve.text,ve.tokens),ve}},ye.text=function(ae){var de=this.rules.block.text.exec(ae);if(de){var ve={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(ve.text,ve.tokens),ve}},ye.escape=function(ae){var de=this.rules.inline.escape.exec(ae);if(de)return{type:"escape",raw:de[0],text:M(de[1])}},ye.tag=function(ae){var de=this.rules.inline.tag.exec(ae);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):M(de[0]):de[0]}},ye.link=function(ae){var de=this.rules.inline.link.exec(ae);if(de){var ve=de[2].trim();if(!this.options.pedantic&&/^</.test(ve)){if(!/>$/.test(ve))return;var Ee=F(ve.slice(0,-1),"\\");if((ve.length-Ee.length)%2==0)return}else{var Fe=B(de[2],"()");if(Fe>-1){var Qe=de[0].indexOf("!")===0?5:4,We=Qe+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,We).trim(),de[3]=""}}var Xe=de[2],at="";if(this.options.pedantic){var lt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Xe);lt&&(Xe=lt[1],at=lt[3])}else at=de[3]?de[3].slice(1,-1):"";return Xe=Xe.trim(),/^</.test(Xe)&&(this.options.pedantic&&!/>$/.test(ve)?Xe=Xe.slice(1):Xe=Xe.slice(1,-1)),U(de,{href:Xe&&Xe.replace(this.rules.inline._escapes,"$1"),title:at&&at.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ye.reflink=function(ae,de){var ve;if((ve=this.rules.inline.reflink.exec(ae))||(ve=this.rules.inline.nolink.exec(ae))){var Ee=(ve[2]||ve[1]).replace(/\s+/g," ");if(Ee=de[Ee.toLowerCase()],!Ee||!Ee.href){var Fe=ve[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(ve,Ee,ve[0],this.lexer)}},ye.emStrong=function(ae,de,ve){ve===void 0&&(ve="");var Ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Ee&&!(Ee[3]&&ve.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=Ee[1]||Ee[2]||"";if(!Fe||Fe&&(ve===""||this.rules.inline.punctuation.exec(ve))){var Qe=Ee[0].length-1,We,Xe,at=Qe,lt=0,le=Ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,de=de.slice(-1*ae.length+Qe);(Ee=le.exec(de))!=null;)if(We=Ee[1]||Ee[2]||Ee[3]||Ee[4]||Ee[5]||Ee[6],!!We){if(Xe=We.length,Ee[3]||Ee[4]){at+=Xe;continue}else if((Ee[5]||Ee[6])&&Qe%3&&!((Qe+Xe)%3)){lt+=Xe;continue}if(at-=Xe,!(at>0)){if(Xe=Math.min(Xe,Xe+at+lt),Math.min(Qe,Xe)%2){var _e=ae.slice(1,Qe+Ee.index+Xe);return{type:"em",raw:ae.slice(0,Qe+Ee.index+Xe+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}var ce=ae.slice(2,Qe+Ee.index+Xe-1);return{type:"strong",raw:ae.slice(0,Qe+Ee.index+Xe+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}}}}},ye.codespan=function(ae){var de=this.rules.inline.code.exec(ae);if(de){var ve=de[2].replace(/\n/g," "),Ee=/[^ ]/.test(ve),Fe=/^ /.test(ve)&&/ $/.test(ve);return Ee&&Fe&&(ve=ve.substring(1,ve.length-1)),ve=M(ve,!0),{type:"codespan",raw:de[0],text:ve}}},ye.br=function(ae){var de=this.rules.inline.br.exec(ae);if(de)return{type:"br",raw:de[0]}},ye.del=function(ae){var de=this.rules.inline.del.exec(ae);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},ye.autolink=function(ae,de){var ve=this.rules.inline.autolink.exec(ae);if(ve){var Ee,Fe;return ve[2]==="@"?(Ee=M(this.options.mangle?de(ve[1]):ve[1]),Fe="mailto:"+Ee):(Ee=M(ve[1]),Fe=Ee),{type:"link",raw:ve[0],text:Ee,href:Fe,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ye.url=function(ae,de){var ve;if(ve=this.rules.inline.url.exec(ae)){var Ee,Fe;if(ve[2]==="@")Ee=M(this.options.mangle?de(ve[0]):ve[0]),Fe="mailto:"+Ee;else{var Qe;do Qe=ve[0],ve[0]=this.rules.inline._backpedal.exec(ve[0])[0];while(Qe!==ve[0]);Ee=M(ve[0]),ve[1]==="www."?Fe="http://"+Ee:Fe=Ee}return{type:"link",raw:ve[0],text:Ee,href:Fe,tokens:[{type:"text",raw:Ee,text:Ee}]}}},ye.inlineText=function(ae,de){var ve=this.rules.inline.text.exec(ae);if(ve){var Ee;return this.lexer.state.inRawBlock?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):M(ve[0]):ve[0]:Ee=M(this.options.smartypants?de(ve[0]):ve[0]),{type:"text",raw:ve[0],text:Ee}}},Te}(),N=x.noopTest,j=x.edit,H=x.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=j(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=j(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=j(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=j(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=j(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=j(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=H({},V),V.gfm=H({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=j(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=H({},V.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:j(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=j(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=j(V._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=j(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=j(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=j(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=j(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=j(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=j(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=j(q.reflink).replace("label",q._label).getRegex(),q.reflinkSearch=j(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=H({},q),q.pedantic=H({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=H({},q.normal,{escape:j(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=j(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=H({},q.gfm,{br:j(q.br).replace("{2,}","*").getRegex(),text:j(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var te={block:V,inline:q},fe=K,Ce=C.exports.defaults,ke=te.block,Ue=te.inline,xe=x.repeatString;function ze(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(Te){var ye="",be,ae,de=Te.length;for(be=0;be<de;be++)ae=Te.charCodeAt(be),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var Z=function(){function Te(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||Ce,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:ke.normal,inline:Ue.normal};this.options.pedantic?(ae.block=ke.pedantic,ae.inline=Ue.pedantic):this.options.gfm&&(ae.block=ke.gfm,this.options.breaks?ae.inline=Ue.breaks:ae.inline=Ue.gfm),this.tokenizer.rules=ae}Te.lex=function(ae,de){var ve=new Te(de);return ve.lex(ae)},Te.lexInline=function(ae,de){var ve=new Te(de);return ve.inlineTokens(ae)};var ye=Te.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ye.blockTokens=function(ae,de){var ve=this;de===void 0&&(de=[]),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var Ee,Fe,Qe,We;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(at){return(Ee=at.call({lexer:ve},ae,de))?(ae=ae.substring(Ee.raw.length),de.push(Ee),!0):!1}))){if(Ee=this.tokenizer.space(ae)){ae=ae.substring(Ee.raw.length),Ee.type&&de.push(Ee);continue}if(Ee=this.tokenizer.code(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(Ee);continue}if(Ee=this.tokenizer.fences(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.heading(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.hr(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.blockquote(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.list(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.html(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.def(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[Ee.tag]||(this.tokens.links[Ee.tag]={href:Ee.href,title:Ee.title});continue}if(Ee=this.tokenizer.table(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.lheading(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Qe=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var at=Infinity,lt=ae.slice(1),le=void 0;ve.options.extensions.startBlock.forEach(function(_e){le=_e.call({lexer:this},lt),typeof le=="number"&&le>=0&&(at=Math.min(at,le))}),at<Infinity&&at>=0&&(Qe=ae.substring(0,at+1))}(),this.state.top&&(Ee=this.tokenizer.paragraph(Qe))){Fe=de[de.length-1],We&&Fe.type==="paragraph"?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(Ee),We=Qe.length!==ae.length,ae=ae.substring(Ee.raw.length);continue}if(Ee=this.tokenizer.text(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+Ee.raw,Fe.text+=`
`+Ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(Ee);continue}if(ae){var Xe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Xe);break}else throw new Error(Xe)}}return this.state.top=!0,de},ye.inline=function(ae,de){this.inlineQueue.push({src:ae,tokens:de})},ye.inlineTokens=function(ae,de){var ve=this;de===void 0&&(de=[]);var Ee,Fe,Qe,We=ae,Xe,at,lt;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(Xe=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)le.includes(Xe[0].slice(Xe[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,Xe.index)+"["+xe("a",Xe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Xe=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,Xe.index)+"["+xe("a",Xe[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Xe=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,Xe.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(at||(lt=""),at=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(Ee=ce.call({lexer:ve},ae,de))?(ae=ae.substring(Ee.raw.length),de.push(Ee),!0):!1}))){if(Ee=this.tokenizer.escape(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.tag(ae)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&Ee.type==="text"&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):de.push(Ee);continue}if(Ee=this.tokenizer.link(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Ee.raw.length),Fe=de[de.length-1],Fe&&Ee.type==="text"&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):de.push(Ee);continue}if(Ee=this.tokenizer.emStrong(ae,We,lt)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.codespan(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.br(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.del(ae)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Ee=this.tokenizer.autolink(ae,Q)){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(!this.state.inLink&&(Ee=this.tokenizer.url(ae,Q))){ae=ae.substring(Ee.raw.length),de.push(Ee);continue}if(Qe=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=Infinity,X=ae.slice(1),De=void 0;ve.options.extensions.startInline.forEach(function(Le){De=Le.call({lexer:this},X),typeof De=="number"&&De>=0&&(ce=Math.min(ce,De))}),ce<Infinity&&ce>=0&&(Qe=ae.substring(0,ce+1))}(),Ee=this.tokenizer.inlineText(Qe,ze)){ae=ae.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(lt=Ee.raw.slice(-1)),at=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=Ee.raw,Fe.text+=Ee.text):de.push(Ee);continue}if(ae){var _e="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(_e);break}else throw new Error(_e)}}return de},e(Te,null,[{key:"rules",get:function(){return{block:ke,inline:Ue}}}]),Te}(),re=C.exports.defaults,ue=x.cleanUrl,J=x.escape,ie=function(){function Te(be){this.options=be||re}var ye=Te.prototype;return ye.code=function(ae,de,ve){var Ee=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ae,Ee);Fe!=null&&Fe!==ae&&(ve=!0,ae=Fe)}return ae=ae.replace(/\n$/,"")+`
`,Ee?'<pre><code class="'+this.options.langPrefix+J(Ee,!0)+'">'+(ve?ae:J(ae,!0))+`</code></pre>
`:"<pre><code>"+(ve?ae:J(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,de,ve,Ee){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ee.slug(ve)+'">'+ae+"</h"+de+`>
`:"<h"+de+">"+ae+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,de,ve){var Ee=de?"ol":"ul",Fe=de&&ve!==1?' start="'+ve+'"':"";return"<"+Ee+Fe+`>
`+ae+"</"+Ee+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+de+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,de){var ve=de.header?"th":"td",Ee=de.align?"<"+ve+' align="'+de.align+'">':"<"+ve+">";return Ee+ae+"</"+ve+`>
`},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,de,ve){if(ae=ue(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ve;var Ee='<a href="'+J(ae)+'"';return de&&(Ee+=' title="'+de+'"'),Ee+=">"+ve+"</a>",Ee},ye.image=function(ae,de,ve){if(ae=ue(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ve;var Ee='<img src="'+ae+'" alt="'+ve+'"';return de&&(Ee+=' title="'+de+'"'),Ee+=this.options.xhtml?"/>":">",Ee},ye.text=function(ae){return ae},Te}(),we=function(){function Te(){}var ye=Te.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,de,ve){return""+ve},ye.image=function(ae,de,ve){return""+ve},ye.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var ye=Te.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,de){var ve=ae,Ee=0;if(this.seen.hasOwnProperty(ve)){Ee=this.seen[ae];do Ee++,ve=ae+"-"+Ee;while(this.seen.hasOwnProperty(ve))}return de||(this.seen[ae]=Ee,this.seen[ve]=0),ve},ye.slug=function(ae,de){de===void 0&&(de={});var ve=this.serialize(ae);return this.getNextSafeSlug(ve,de.dryrun)},Te}(),je=ie,Ke=we,Ze=Me,rt=C.exports.defaults,ut=x.unescape,it=function(){function Te(be){this.options=be||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Te.parse=function(ae,de){var ve=new Te(de);return ve.parse(ae)},Te.parseInline=function(ae,de){var ve=new Te(de);return ve.parseInline(ae)};var ye=Te.prototype;return ye.parse=function(ae,de){de===void 0&&(de=!0);var ve="",Ee,Fe,Qe,We,Xe,at,lt,le,_e,ce,X,De,Le,et,qe,mt,_t,kt,bt,gt=ae.length;for(Ee=0;Ee<gt;Ee++){if(ce=ae[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(bt=this.options.extensions.renderers[ce.type].call({parser:this},ce),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ve+=bt||"";continue}switch(ce.type){case"space":continue;case"hr":{ve+=this.renderer.hr();continue}case"heading":{ve+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,ut(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ve+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(le="",lt="",We=ce.header.length,Fe=0;Fe<We;Fe++)lt+=this.renderer.tablecell(this.parseInline(ce.header[Fe].tokens),{header:!0,align:ce.align[Fe]});for(le+=this.renderer.tablerow(lt),_e="",We=ce.rows.length,Fe=0;Fe<We;Fe++){for(at=ce.rows[Fe],lt="",Xe=at.length,Qe=0;Qe<Xe;Qe++)lt+=this.renderer.tablecell(this.parseInline(at[Qe].tokens),{header:!1,align:ce.align[Qe]});_e+=this.renderer.tablerow(lt)}ve+=this.renderer.table(le,_e);continue}case"blockquote":{_e=this.parse(ce.tokens),ve+=this.renderer.blockquote(_e);continue}case"list":{for(X=ce.ordered,De=ce.start,Le=ce.loose,We=ce.items.length,_e="",Fe=0;Fe<We;Fe++)qe=ce.items[Fe],mt=qe.checked,_t=qe.task,et="",qe.task&&(kt=this.renderer.checkbox(mt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=kt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=kt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:kt}):et+=kt),et+=this.parse(qe.tokens,Le),_e+=this.renderer.listitem(et,_t,mt);ve+=this.renderer.list(_e,X,De);continue}case"html":{ve+=this.renderer.html(ce.text);continue}case"paragraph":{ve+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(_e=ce.tokens?this.parseInline(ce.tokens):ce.text;Ee+1<gt&&ae[Ee+1].type==="text";)ce=ae[++Ee],_e+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ve+=de?this.renderer.paragraph(_e):_e;continue}default:{var Et='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Et);return}else throw new Error(Et)}}}return ve},ye.parseInline=function(ae,de){de=de||this.renderer;var ve="",Ee,Fe,Qe,We=ae.length;for(Ee=0;Ee<We;Ee++){if(Fe=ae[Ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){ve+=Qe||"";continue}switch(Fe.type){case"escape":{ve+=de.text(Fe.text);break}case"html":{ve+=de.html(Fe.text);break}case"link":{ve+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{ve+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{ve+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{ve+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{ve+=de.codespan(Fe.text);break}case"br":{ve+=de.br();break}case"del":{ve+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{ve+=de.text(Fe.text);break}default:{var Xe='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ve},Te}(),st=Z,Ae=it,wt=K,ee=ie,se=we,Se=Me,Ge=x.merge,Ye=x.checkSanitizeDeprecation,nt=x.escape,he=C.exports.getDefaults,Ie=C.exports.changeDefaults,Be=C.exports.defaults;function $e(Te,ye,be){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof ye=="function"&&(be=ye,ye=null),ye=Ge({},$e.defaults,ye||{}),Ye(ye),be){var ae=ye.highlight,de;try{de=st.lex(Te,ye)}catch(Qe){return be(Qe)}var ve=function(We){var Xe;if(!We)try{ye.walkTokens&&$e.walkTokens(de,ye.walkTokens),Xe=Ae.parse(de,ye)}catch(at){We=at}return ye.highlight=ae,We?be(We):be(null,Xe)};if(!ae||ae.length<3||(delete ye.highlight,!de.length))return ve();var Ee=0;$e.walkTokens(de,function(Qe){Qe.type==="code"&&(Ee++,setTimeout(function(){ae(Qe.text,Qe.lang,function(We,Xe){if(We)return ve(We);Xe!=null&&Xe!==Qe.text&&(Qe.text=Xe,Qe.escaped=!0),Ee--,Ee===0&&ve()})},0))}),Ee===0&&ve();return}try{var Fe=st.lex(Te,ye);return ye.walkTokens&&$e.walkTokens(Fe,ye.walkTokens),Ae.parse(Fe,ye)}catch(Qe){if(Qe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+nt(Qe.message+"",!0)+"</pre>";throw Qe}}$e.options=$e.setOptions=function(Te){return Ge($e.defaults,Te),Ie($e.defaults),$e},$e.getDefaults=he,$e.defaults=Be,$e.use=function(){for(var Te=this,ye=arguments.length,be=new Array(ye),ae=0;ae<ye;ae++)be[ae]=arguments[ae];var de=Ge.apply(void 0,[{}].concat(be)),ve=$e.defaults.extensions||{renderers:{},childTokens:{}},Ee;be.forEach(function(Fe){if(Fe.extensions&&(Ee=!0,Fe.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Xe=ve.renderers?ve.renderers[We.name]:null;Xe?ve.renderers[We.name]=function(){for(var at=arguments.length,lt=new Array(at),le=0;le<at;le++)lt[le]=arguments[le];var _e=We.renderer.apply(this,lt);return _e===!1&&(_e=Xe.apply(this,lt)),_e}:ve.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ve[We.level]?ve[We.level].unshift(We.tokenizer):ve[We.level]=[We.tokenizer],We.start&&(We.level==="block"?ve.startBlock?ve.startBlock.push(We.start):ve.startBlock=[We.start]:We.level==="inline"&&(ve.startInline?ve.startInline.push(We.start):ve.startInline=[We.start]))}We.childTokens&&(ve.childTokens[We.name]=We.childTokens)})),Fe.renderer&&function(){var We=$e.defaults.renderer||new ee,Xe=function(le){var _e=We[le];We[le]=function(){for(var ce=arguments.length,X=new Array(ce),De=0;De<ce;De++)X[De]=arguments[De];var Le=Fe.renderer[le].apply(We,X);return Le===!1&&(Le=_e.apply(We,X)),Le}};for(var at in Fe.renderer)Xe(at);de.renderer=We}(),Fe.tokenizer&&function(){var We=$e.defaults.tokenizer||new wt,Xe=function(le){var _e=We[le];We[le]=function(){for(var ce=arguments.length,X=new Array(ce),De=0;De<ce;De++)X[De]=arguments[De];var Le=Fe.tokenizer[le].apply(We,X);return Le===!1&&(Le=_e.apply(We,X)),Le}};for(var at in Fe.tokenizer)Xe(at);de.tokenizer=We}(),Fe.walkTokens){var Qe=$e.defaults.walkTokens;de.walkTokens=function(We){Fe.walkTokens.call(Te,We),Qe&&Qe(We)}}Ee&&(de.extensions=ve),$e.setOptions(de)})},$e.walkTokens=function(Te,ye){for(var be=function(){var Ee=de.value;switch(ye(Ee),Ee.type){case"table":{for(var Fe=D(Ee.header),Qe;!(Qe=Fe()).done;){var We=Qe.value;$e.walkTokens(We.tokens,ye)}for(var Xe=D(Ee.rows),at;!(at=Xe()).done;)for(var lt=at.value,le=D(lt),_e;!(_e=le()).done;){var ce=_e.value;$e.walkTokens(ce.tokens,ye)}break}case"list":{$e.walkTokens(Ee.items,ye);break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Ee.type]?$e.defaults.extensions.childTokens[Ee.type].forEach(function(X){$e.walkTokens(Ee[X],ye)}):Ee.tokens&&$e.walkTokens(Ee.tokens,ye)}},ae=D(Te),de;!(de=ae()).done;)be()},$e.parseInline=function(Te,ye){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");ye=Ge({},$e.defaults,ye||{}),Ye(ye);try{var be=st.lexInline(Te,ye);return ye.walkTokens&&$e.walkTokens(be,ye.walkTokens),Ae.parseInline(be,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+nt(ae.message+"",!0)+"</pre>";throw ae}},$e.Parser=Ae,$e.parser=Ae.parse,$e.Renderer=ee,$e.TextRenderer=se,$e.Lexer=st,$e.lexer=st.lex,$e.Tokenizer=wt,$e.Slugger=Se,$e.parse=$e;var tt=$e;return tt}),define(ge[77],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(i,k,S){return Math.min(Math.max(i,k),S)}e.clamp=m;function L(i,k){return(k+i%k)%k}e.rot=L;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function i(S){C.push(S,Date.now())}function k(){const S=[];for(let y=0;y<C.length;y+=2)S.push({name:C[y],startTime:C[y+1]});return S}return{mark:i,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const i of performance.getEntriesByType("mark"))C.push({name:i.name,startTime:Math.round(D+i.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(ge[12],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,D=!1,C=!1,i=!1,k=!1,S=!1,y=!1,R=!1,P,a=m,w,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const _=typeof v?.versions?.electron=="string",A=_&&v?.type==="renderer";if(e.isElectronSandboxed=A&&v?.sandboxed,typeof navigator=="object"&&!A)f=navigator.userAgent,L=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,R=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=f.indexOf("Linux")>=0,S=!0,P=navigator.language,a=P;else if(typeof v=="object"){L=v.platform==="win32",D=v.platform==="darwin",C=v.platform==="linux",i=C&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,y=_,P=m,a=m;const s=v.env.VSCODE_NLS_CONFIG;if(s)try{const d=JSON.parse(s),l=d.availableLanguages["*"];P=d.locale,a=l||m,w=d._translationsConfigFile}catch(d){}k=!0}else console.error("Unable to resolve platform.");var p;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function o(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let r=0;D?r=1:L?r=3:C&&(r=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=i,e.isNative=k,e.isElectron=y,e.isWeb=S,e.isIOS=R,e.platform=r,e.userAgent=f,e.language=a;var g;(function(s){function d(){return e.language}s.value=d;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function h(){return e.language==="en"}s.isDefault=h})(g=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=w,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let h=0,u=s.length;h<u;h++){const b=s[h];if(b.id===l.data.vscodeScheduleAsyncWork){s.splice(h,1),b.callback();return}}});let d=0;return l=>{const h=++d;s.push({id:h,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return s=>setTimeout(s)})();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||R?2:L?1:3;let E=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,E=new Uint16Array(s.buffer)[0]===(2<<8)+1}return E}e.isLittleEndian=t}),define(ge[40],pe([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const D=m.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ge[9],pe([0,1,40]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,C=90,i=122,k=46,S=47,y=92,R=58,P=63;class a extends Error{constructor(r,g,c){let E;typeof g=="string"&&g.indexOf("not ")===0?(E="must not be",g=g.replace(/^not /,"")):E="must be";const n=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${n} ${E} of type ${g}`;t+=`. Received type ${typeof c}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function w(o,r){if(typeof o!="string")throw new a(r,"string",o)}function f(o){return o===S||o===y}function v(o){return o===S}function _(o){return o>=L&&o<=C||o>=D&&o<=i}function A(o,r,g,c){let E="",n=0,t=-1,s=0,d=0;for(let l=0;l<=o.length;++l){if(l<o.length)d=o.charCodeAt(l);else{if(c(d))break;d=S}if(c(d)){if(!(t===l-1||s===1))if(s===2){if(E.length<2||n!==2||E.charCodeAt(E.length-1)!==k||E.charCodeAt(E.length-2)!==k){if(E.length>2){const h=E.lastIndexOf(g);h===-1?(E="",n=0):(E=E.slice(0,h),n=E.length-1-E.lastIndexOf(g)),t=l,s=0;continue}else if(E.length!==0){E="",n=0,t=l,s=0;continue}}r&&(E+=E.length>0?`${g}..`:"..",n=2)}else E.length>0?E+=`${g}${o.slice(t+1,l)}`:E=o.slice(t+1,l),n=l-t-1;t=l,s=0}else d===k&&s!==-1?++s:s=-1}return E}function p(o,r){if(r===null||typeof r!="object")throw new a("pathObject","Object",r);const g=r.dir||r.root,c=r.base||`${r.name||""}${r.ext||""}`;return g?g===r.root?`${g}${c}`:`${g}${o}${c}`:c}e.win32={resolve(...o){let r="",g="",c=!1;for(let E=o.length-1;E>=-1;E--){let n;if(E>=0){if(n=o[E],w(n,"path"),n.length===0)continue}else r.length===0?n=m.cwd():(n=m.env[`=${r}`]||m.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==r.toLowerCase()&&n.charCodeAt(2)===y)&&(n=`${r}\\`));const t=n.length;let s=0,d="",l=!1;const h=n.charCodeAt(0);if(t===1)f(h)&&(s=1,l=!0);else if(f(h))if(l=!0,f(n.charCodeAt(1))){let u=2,b=u;for(;u<t&&!f(n.charCodeAt(u));)u++;if(u<t&&u!==b){const I=n.slice(b,u);for(b=u;u<t&&f(n.charCodeAt(u));)u++;if(u<t&&u!==b){for(b=u;u<t&&!f(n.charCodeAt(u));)u++;(u===t||u!==b)&&(d=`\\\\${I}\\${n.slice(b,u)}`,s=u)}}}else s=1;else _(h)&&n.charCodeAt(1)===R&&(d=n.slice(0,2),s=2,t>2&&f(n.charCodeAt(2))&&(l=!0,s=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(c){if(r.length>0)break}else if(g=`${n.slice(s)}\\${g}`,c=l,l&&r.length>0)break}return g=A(g,!c,"\\",f),c?`${r}\\${g}`:`${r}${g}`||"."},normalize(o){w(o,"path");const r=o.length;if(r===0)return".";let g=0,c,E=!1;const n=o.charCodeAt(0);if(r===1)return v(n)?"\\":o;if(f(n))if(E=!0,f(o.charCodeAt(1))){let s=2,d=s;for(;s<r&&!f(o.charCodeAt(s));)s++;if(s<r&&s!==d){const l=o.slice(d,s);for(d=s;s<r&&f(o.charCodeAt(s));)s++;if(s<r&&s!==d){for(d=s;s<r&&!f(o.charCodeAt(s));)s++;if(s===r)return`\\\\${l}\\${o.slice(d)}\\`;s!==d&&(c=`\\\\${l}\\${o.slice(d,s)}`,g=s)}}}else g=1;else _(n)&&o.charCodeAt(1)===R&&(c=o.slice(0,2),g=2,r>2&&f(o.charCodeAt(2))&&(E=!0,g=3));let t=g<r?A(o.slice(g),!E,"\\",f):"";return t.length===0&&!E&&(t="."),t.length>0&&f(o.charCodeAt(r-1))&&(t+="\\"),c===void 0?E?`\\${t}`:t:E?`${c}\\${t}`:`${c}${t}`},isAbsolute(o){w(o,"path");const r=o.length;if(r===0)return!1;const g=o.charCodeAt(0);return f(g)||r>2&&_(g)&&o.charCodeAt(1)===R&&f(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let r,g;for(let n=0;n<o.length;++n){const t=o[n];w(t,"path"),t.length>0&&(r===void 0?r=g=t:r+=`\\${t}`)}if(r===void 0)return".";let c=!0,E=0;if(typeof g=="string"&&f(g.charCodeAt(0))){++E;const n=g.length;n>1&&f(g.charCodeAt(1))&&(++E,n>2&&(f(g.charCodeAt(2))?++E:c=!1))}if(c){for(;E<r.length&&f(r.charCodeAt(E));)E++;E>=2&&(r=`\\${r.slice(E)}`)}return e.win32.normalize(r)},relative(o,r){if(w(o,"from"),w(r,"to"),o===r)return"";const g=e.win32.resolve(o),c=e.win32.resolve(r);if(g===c||(o=g.toLowerCase(),r=c.toLowerCase(),o===r))return"";let E=0;for(;E<o.length&&o.charCodeAt(E)===y;)E++;let n=o.length;for(;n-1>E&&o.charCodeAt(n-1)===y;)n--;const t=n-E;let s=0;for(;s<r.length&&r.charCodeAt(s)===y;)s++;let d=r.length;for(;d-1>s&&r.charCodeAt(d-1)===y;)d--;const l=d-s,h=t<l?t:l;let u=-1,b=0;for(;b<h;b++){const T=o.charCodeAt(E+b);if(T!==r.charCodeAt(s+b))break;T===y&&(u=b)}if(b!==h){if(u===-1)return c}else{if(l>h){if(r.charCodeAt(s+b)===y)return c.slice(s+b+1);if(b===2)return c.slice(s+b)}t>h&&(o.charCodeAt(E+b)===y?u=b:b===2&&(u=3)),u===-1&&(u=0)}let I="";for(b=E+u+1;b<=n;++b)(b===n||o.charCodeAt(b)===y)&&(I+=I.length===0?"..":"\\..");return s+=u,I.length>0?`${I}${c.slice(s,d)}`:(c.charCodeAt(s)===y&&++s,c.slice(s,d))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const r=e.win32.resolve(o);if(r.length<=2)return o;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const g=r.charCodeAt(2);if(g!==P&&g!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(_(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return o},dirname(o){w(o,"path");const r=o.length;if(r===0)return".";let g=-1,c=0;const E=o.charCodeAt(0);if(r===1)return f(E)?o:".";if(f(E)){if(g=c=1,f(o.charCodeAt(1))){let s=2,d=s;for(;s<r&&!f(o.charCodeAt(s));)s++;if(s<r&&s!==d){for(d=s;s<r&&f(o.charCodeAt(s));)s++;if(s<r&&s!==d){for(d=s;s<r&&!f(o.charCodeAt(s));)s++;if(s===r)return o;s!==d&&(g=c=s+1)}}}}else _(E)&&o.charCodeAt(1)===R&&(g=r>2&&f(o.charCodeAt(2))?3:2,c=g);let n=-1,t=!0;for(let s=r-1;s>=c;--s)if(f(o.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(g===-1)return".";n=g}return o.slice(0,n)},basename(o,r){r!==void 0&&w(r,"ext"),w(o,"path");let g=0,c=-1,E=!0,n;if(o.length>=2&&_(o.charCodeAt(0))&&o.charCodeAt(1)===R&&(g=2),r!==void 0&&r.length>0&&r.length<=o.length){if(r===o)return"";let t=r.length-1,s=-1;for(n=o.length-1;n>=g;--n){const d=o.charCodeAt(n);if(f(d)){if(!E){g=n+1;break}}else s===-1&&(E=!1,s=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(c=n):(t=-1,c=s))}return g===c?c=s:c===-1&&(c=o.length),o.slice(g,c)}for(n=o.length-1;n>=g;--n)if(f(o.charCodeAt(n))){if(!E){g=n+1;break}}else c===-1&&(E=!1,c=n+1);return c===-1?"":o.slice(g,c)},extname(o){w(o,"path");let r=0,g=-1,c=0,E=-1,n=!0,t=0;o.length>=2&&o.charCodeAt(1)===R&&_(o.charCodeAt(0))&&(r=c=2);for(let s=o.length-1;s>=r;--s){const d=o.charCodeAt(s);if(f(d)){if(!n){c=s+1;break}continue}E===-1&&(n=!1,E=s+1),d===k?g===-1?g=s:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||E===-1||t===0||t===1&&g===E-1&&g===c+1?"":o.slice(g,E)},format:p.bind(null,"\\"),parse(o){w(o,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return r;const g=o.length;let c=0,E=o.charCodeAt(0);if(g===1)return f(E)?(r.root=r.dir=o,r):(r.base=r.name=o,r);if(f(E)){if(c=1,f(o.charCodeAt(1))){let u=2,b=u;for(;u<g&&!f(o.charCodeAt(u));)u++;if(u<g&&u!==b){for(b=u;u<g&&f(o.charCodeAt(u));)u++;if(u<g&&u!==b){for(b=u;u<g&&!f(o.charCodeAt(u));)u++;u===g?c=u:u!==b&&(c=u+1)}}}}else if(_(E)&&o.charCodeAt(1)===R){if(g<=2)return r.root=r.dir=o,r;if(c=2,f(o.charCodeAt(2))){if(g===3)return r.root=r.dir=o,r;c=3}}c>0&&(r.root=o.slice(0,c));let n=-1,t=c,s=-1,d=!0,l=o.length-1,h=0;for(;l>=c;--l){if(E=o.charCodeAt(l),f(E)){if(!d){t=l+1;break}continue}s===-1&&(d=!1,s=l+1),E===k?n===-1?n=l:h!==1&&(h=1):n!==-1&&(h=-1)}return s!==-1&&(n===-1||h===0||h===1&&n===s-1&&n===t+1?r.base=r.name=o.slice(t,s):(r.name=o.slice(t,n),r.base=o.slice(t,s),r.ext=o.slice(n,s))),t>0&&t!==c?r.dir=o.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let r="",g=!1;for(let c=o.length-1;c>=-1&&!g;c--){const E=c>=0?o[c]:m.cwd();w(E,"path"),E.length!==0&&(r=`${E}/${r}`,g=E.charCodeAt(0)===S)}return r=A(r,!g,"/",v),g?`/${r}`:r.length>0?r:"."},normalize(o){if(w(o,"path"),o.length===0)return".";const r=o.charCodeAt(0)===S,g=o.charCodeAt(o.length-1)===S;return o=A(o,!r,"/",v),o.length===0?r?"/":g?"./":".":(g&&(o+="/"),r?`/${o}`:o)},isAbsolute(o){return w(o,"path"),o.length>0&&o.charCodeAt(0)===S},join(...o){if(o.length===0)return".";let r;for(let g=0;g<o.length;++g){const c=o[g];w(c,"path"),c.length>0&&(r===void 0?r=c:r+=`/${c}`)}return r===void 0?".":e.posix.normalize(r)},relative(o,r){if(w(o,"from"),w(r,"to"),o===r||(o=e.posix.resolve(o),r=e.posix.resolve(r),o===r))return"";const g=1,c=o.length,E=c-g,n=1,t=r.length-n,s=E<t?E:t;let d=-1,l=0;for(;l<s;l++){const u=o.charCodeAt(g+l);if(u!==r.charCodeAt(n+l))break;u===S&&(d=l)}if(l===s)if(t>s){if(r.charCodeAt(n+l)===S)return r.slice(n+l+1);if(l===0)return r.slice(n+l)}else E>s&&(o.charCodeAt(g+l)===S?d=l:l===0&&(d=0));let h="";for(l=g+d+1;l<=c;++l)(l===c||o.charCodeAt(l)===S)&&(h+=h.length===0?"..":"/..");return`${h}${r.slice(n+d)}`},toNamespacedPath(o){return o},dirname(o){if(w(o,"path"),o.length===0)return".";const r=o.charCodeAt(0)===S;let g=-1,c=!0;for(let E=o.length-1;E>=1;--E)if(o.charCodeAt(E)===S){if(!c){g=E;break}}else c=!1;return g===-1?r?"/":".":r&&g===1?"//":o.slice(0,g)},basename(o,r){r!==void 0&&w(r,"ext"),w(o,"path");let g=0,c=-1,E=!0,n;if(r!==void 0&&r.length>0&&r.length<=o.length){if(r===o)return"";let t=r.length-1,s=-1;for(n=o.length-1;n>=0;--n){const d=o.charCodeAt(n);if(d===S){if(!E){g=n+1;break}}else s===-1&&(E=!1,s=n+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(c=n):(t=-1,c=s))}return g===c?c=s:c===-1&&(c=o.length),o.slice(g,c)}for(n=o.length-1;n>=0;--n)if(o.charCodeAt(n)===S){if(!E){g=n+1;break}}else c===-1&&(E=!1,c=n+1);return c===-1?"":o.slice(g,c)},extname(o){w(o,"path");let r=-1,g=0,c=-1,E=!0,n=0;for(let t=o.length-1;t>=0;--t){const s=o.charCodeAt(t);if(s===S){if(!E){g=t+1;break}continue}c===-1&&(E=!1,c=t+1),s===k?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||c===-1||n===0||n===1&&r===c-1&&r===g+1?"":o.slice(r,c)},format:p.bind(null,"/"),parse(o){w(o,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return r;const g=o.charCodeAt(0)===S;let c;g?(r.root="/",c=1):c=0;let E=-1,n=0,t=-1,s=!0,d=o.length-1,l=0;for(;d>=c;--d){const h=o.charCodeAt(d);if(h===S){if(!s){n=d+1;break}continue}t===-1&&(s=!1,t=d+1),h===k?E===-1?E=d:l!==1&&(l=1):E!==-1&&(l=-1)}if(t!==-1){const h=n===0&&g?1:n;E===-1||l===0||l===1&&E===t-1&&E===n+1?r.base=r.name=o.slice(h,t):(r.name=o.slice(h,E),r.base=o.slice(h,t),r.ext=o.slice(E,t))}return n>0?r.dir=o.slice(0,n-1):g&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[94],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...i){const k=i.reduce((R,P)=>(R[P]=!0,R),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(R=>!k[R]).forEach(R=>{for(let P=0;P<S.length;P++)if(R.search(S[P])!==-1){delete C[R];break}})}e.sanitizeProcessEnvironment=D}),define(ge[46],pe([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class D{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new D(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ge[3],pe([0,1,15,74,6,93,46]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>D.Disposable.None;function g(M){return(B,U=null,z)=>{let K=!1,N;return N=M(j=>{if(!K)return N?N.dispose():K=!0,B.call(U,j)},null,z),K&&N.dispose(),N}}r.once=g;function c(M,B){return l((U,z=null,K)=>M(N=>U.call(z,B(N)),null,K))}r.map=c;function E(M,B){return l((U,z=null,K)=>M(N=>{B(N),U.call(z,N)},null,K))}r.forEach=E;function n(M,B){return l((U,z=null,K)=>M(N=>B(N)&&U.call(z,N),null,K))}r.filter=n;function t(M){return M}r.signal=t;function s(...M){return(B,U=null,z)=>(0,D.combinedDisposable)(...M.map(K=>K(N=>B.call(U,N),null,z)))}r.any=s;function d(M,B,U){let z=U;return c(M,K=>(z=B(z,K),z))}r.reduce=d;function l(M){let B;const U=new a({onFirstListenerAdd(){B=M(U.fire,U)},onLastListenerRemove(){B.dispose()}});return U.event}function h(M,B,U=100,z=!1,K){let N,j,H,V=0;const q=new a({leakWarningThreshold:K,onFirstListenerAdd(){N=M(te=>{V++,j=B(j,te),z&&!H&&(q.fire(j),j=void 0),clearTimeout(H),H=setTimeout(()=>{const fe=j;j=void 0,H=void 0,(!z||V>1)&&q.fire(fe),V=0},U)})},onLastListenerRemove(){N.dispose()}});return q.event}r.debounce=h;function u(M,B=(U,z)=>U===z){let U=!0,z;return n(M,K=>{const N=U||!B(K,z);return U=!1,z=K,N})}r.latch=u;function b(M,B){return[r.filter(M,B),r.filter(M,U=>!B(U))]}r.split=b;function I(M,B=!1,U=[]){let z=U.slice(),K=M(H=>{z?z.push(H):j.fire(H)});const N=()=>{z&&z.forEach(H=>j.fire(H)),z=null},j=new a({onFirstListenerAdd(){K||(K=M(H=>j.fire(H)))},onFirstListenerDidAdd(){z&&(B?setTimeout(N):N())},onLastListenerRemove(){K&&K.dispose(),K=null}});return j.event}r.buffer=I;class T{constructor(B){this.event=B}map(B){return new T(c(this.event,B))}forEach(B){return new T(E(this.event,B))}filter(B){return new T(n(this.event,B))}reduce(B,U){return new T(d(this.event,B,U))}latch(){return new T(u(this.event))}debounce(B,U=100,z=!1,K){return new T(h(this.event,B,U,z,K))}on(B,U,z){return this.event(B,U,z)}once(B,U,z){return g(this.event)(B,U,z)}}function x(M){return new T(M)}r.chain=x;function O(M,B,U=z=>z){const z=(...H)=>j.fire(U(...H)),K=()=>M.on(B,z),N=()=>M.removeListener(B,z),j=new a({onFirstListenerAdd:K,onLastListenerRemove:N});return j.event}r.fromNodeEventEmitter=O;function F(M,B,U=z=>z){const z=(...H)=>j.fire(U(...H)),K=()=>M.addEventListener(B,z),N=()=>M.removeEventListener(B,z),j=new a({onFirstListenerAdd:K,onLastListenerRemove:N});return j.event}r.fromDOMEventEmitter=F;function W(M){return new Promise(B=>g(M)(B))}r.toPromise=W})(k=e.Event||(e.Event={}));class S{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${S._idPool++}`}start(g){this._stopWatch=new i.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let y=-1;function R(r){const g=y;return y=r,{dispose(){y=g}}}e.setGlobalLeakWarningThreshold=R;class P{constructor(g,c=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let c=y;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||g<c)return;this._stacks||(this._stacks=new Map);const E=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(E)||0;if(this._stacks.set(E,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,s=0;for(const[d,l]of this._stacks)(!t||s<l)&&(t=d,s=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(E)||0;this._stacks.set(E,t-1)}}}class a{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=y>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(g,c,E)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(c?[g,c]:g);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,c);const s=this._leakageMon?.check(this._listeners.size),d=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return E instanceof D.DisposableStore?E.add(d):Array.isArray(E)&&E.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,E]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,E):c[0].call(c[1],E)}catch(n){(0,m.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class w extends a{async fireAsync(g,c,E){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,g]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],d={...t,waitUntil:l=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");E&&(l=E(l,typeof n=="function"?n:n[0])),s.push(l)}};try{typeof n=="function"?n.call(void 0,d):n[0].call(n[1],d)}catch(l){(0,m.onUnexpectedError)(l);continue}Object.freeze(s),await Promise.allSettled(s).then(l=>{for(const h of l)h.status==="rejected"&&(0,m.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=w;class f extends a{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=f;class v extends f{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=v;class _ extends a{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]})}}e.MicrotaskEmitter=_;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const c={event:g,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const E=()=>{this.hasListeners&&this.unhook(c);const n=this.events.indexOf(c);this.events.splice(n,1)};return(0,D.toDisposable)((0,L.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(c=>this.emitter.fire(c))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=A;class p{constructor(){this.buffers=[]}wrapEvent(g){return(c,E,n)=>g(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>c.call(E,t)):c.call(E,t)},void 0,n)}bufferEvents(g){const c=[];this.buffers.push(c);const E=g();return this.buffers.pop(),c.forEach(n=>n()),E}}e.EventBufferer=p;class o{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ge[21],pe([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,S){const y=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(y)}}});var D;(function(k){function S(y){return y===k.None||y===k.Cancelled||y instanceof C?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=i}),define(ge[78],pe([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(R){const P=this._icons.get(R.id);P?R.description?P.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function C(y){return y?y.replace(/\$\((.*?)\)/g,(R,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=C;class i{constructor(R,P,a){this.id=R,this.definition=P,this.description=a,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function k(y,R){const P=["codicon","codicon-"+y];return R&&P.push("codicon-modifier-"+R),P}e.getClassNamesArray=k;var S;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function P(f){if(f instanceof i)return["codicon","codicon-"+f.id];const v=R.exec(f.id);if(!v)return P(i.error);let[,_,A]=v;const p=["codicon","codicon-"+_];return A&&p.push("codicon-modifier-"+A.substr(1)),p}y.asClassNameArray=P;function a(f){return P(f).join(" ")}y.asClassName=a;function w(f){return"."+P(f).join(".")}y.asCSSSelector=w})(S=e.CSSIcon||(e.CSSIcon={}))}),define(ge[95],pe([0,1,15,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(o){const r=o;return r?[r.on,r.pause,r.resume,r.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=D;function C(o){const r=o;return r?D(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function i(o,r){return new k(o,r)}e.newWriteableStream=i;class k{constructor(r,g){this.reducer=r,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(g=>g(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(g=>g(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,g){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(r,g){if(this.state.destroyed)return;let c;switch(r){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const E=c.indexOf(g);E>=0&&c.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(o,r){const g=[];let c;for(;(c=o.read())!==null;)g.push(c);return r(g)}e.consumeReadable=S;function y(o,r,g){const c=[];let E;for(;(E=o.read())!==null&&c.length<g;)c.push(E);return E===null&&c.length>0?r(c):{read:()=>{if(c.length>0)return c.shift();if(typeof E!="undefined"){const n=E;return E=void 0,n}return o.read()}}}e.peekReadable=y;function R(o,r){return new Promise((g,c)=>{const E=[];P(o,{onData:n=>{r&&E.push(n)},onError:n=>{r?c(n):g(void 0)},onEnd:()=>{g(r?r(E):void 0)}})})}e.consumeStream=R;function P(o,r){o.on("error",g=>r.onError(g)),o.on("end",()=>r.onEnd()),o.on("data",g=>r.onData(g))}e.listenStream=P;function a(o,r){return new Promise((g,c)=>{const E=new L.DisposableStore,n=[],t=l=>{if(n.push(l),n.length>r)return E.dispose(),o.pause(),g({stream:o,buffer:n,ended:!1})},s=l=>c(l),d=()=>g({stream:o,buffer:n,ended:!0});E.add((0,L.toDisposable)(()=>o.removeListener("error",s))),o.on("error",s),E.add((0,L.toDisposable)(()=>o.removeListener("end",d))),o.on("end",d),E.add((0,L.toDisposable)(()=>o.removeListener("data",t))),o.on("data",t)})}e.peekStream=a;function w(o,r){const g=i(r);return g.end(o),g}e.toStream=w;function f(){const o=i(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=f;function v(o){let r=!1;return{read:()=>r?null:(r=!0,o)}}e.toReadable=v;function _(o,r,g){const c=i(g);return P(o,{onData:E=>c.write(r.data(E)),onError:E=>c.error(r.error?r.error(E):E),onEnd:()=>c.end()}),c}e.transform=_;function A(o,r,g){let c=!1;return{read:()=>{const E=r.read();return c?E:(c=!0,E!==null?g([o,E]):o)}}}e.prefixedReadable=A;function p(o,r,g){let c=!1;const E=i(g);return P(r,{onData:n=>c?E.write(n):(c=!0,E.write(g([o,n]))),onError:n=>E.error(n),onEnd:()=>{c||(c=!0,E.write(o)),E.end()}}),E}e.prefixedStream=p}),define(ge[22],pe([0,1,95]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,C;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(D||(D=new TextEncoder),new i(D.encode(t)))}static fromByteArray(t){const s=i.alloc(t.length);for(let d=0,l=t.length;d<l;d++)s.buffer[d]=t[d];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let h=0,u=t.length;h<u;h++)s+=t[h].byteLength}const d=i.alloc(s);let l=0;for(let h=0,u=t.length;h<u;h++){const b=t[h];d.set(b,l),l+=b.byteLength}return d}clone(){const t=i.alloc(this.byteLength);return t.set(this),t}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){if(t instanceof i)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return y(this.buffer,t)}writeUInt32BE(t,s){R(this.buffer,t,s)}readUInt32LE(t){return P(this.buffer,t)}writeUInt32LE(t,s){a(this.buffer,t,s)}readUInt8(t){return w(this.buffer,t)}writeUInt8(t,s){f(this.buffer,t,s)}}e.VSBuffer=i;function k(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=k;function S(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=S;function y(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=y;function R(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=R;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=P;function a(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=a;function w(n,t){return n[t]}e.readUInt8=w;function f(n,t,s){n[s]=t}e.writeUInt8=f;function v(n){return m.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=v;function _(n){return m.toReadable(n)}e.bufferToReadable=_;function A(n){return m.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=A;async function p(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await A(n.stream)])}e.bufferedStreamToBuffer=p;function o(n){return m.toStream(n,t=>i.concat(t))}e.bufferToStream=o;function r(n){return m.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=r;function g(n){return m.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=g;function c(n,t){return m.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=c;function E(n,t){return m.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=E}),define(ge[8],pe([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=L;const D=/{(\d+)}/g;function C(he,...Ie){return Ie.length===0?he:he.replace(D,function(Be,$e){const tt=parseInt($e,10);return isNaN(tt)||tt<0||tt>=Ie.length?Be:Ie[tt]})}e.format=C;const i=/{([^}]+)}/g;function k(he,Ie){return he.replace(i,(Be,$e)=>Ie[$e]??Be)}e.format2=k;function S(he){return he.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=S;function y(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function R(he,Ie){let Be=0;const $e=Ie.charCodeAt(0);for(let tt=he.length-1;tt>=0;tt--)he.charCodeAt(tt)===$e&&Be++;return Be}e.count=R;function P(he,Ie,Be="\u2026"){return he.length<=Ie?he:`${he.substr(0,Ie)}${Be}`}e.truncate=P;function a(he,Ie=" "){const Be=w(he,Ie);return f(Be,Ie)}e.trim=a;function w(he,Ie){if(!he||!Ie)return he;const Be=Ie.length;if(Be===0||he.length===0)return he;let $e=0;for(;he.indexOf(Ie,$e)===$e;)$e=$e+Be;return he.substring($e)}e.ltrim=w;function f(he,Ie){if(!he||!Ie)return he;const Be=Ie.length,$e=he.length;if(Be===0||$e===0)return he;let tt=$e,Te=-1;for(;Te=he.lastIndexOf(Ie,tt-1),!(Te===-1||Te+Be!==tt);){if(Te===0)return"";tt=Te}return he.substring(0,tt)}e.rtrim=f;function v(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function _(he){return he.replace(/\*/g,"")}e.stripWildcards=_;function A(he,Ie,Be={}){if(!he)throw new Error("Cannot create regex from empty string");Ie||(he=y(he)),Be.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let $e="";return Be.global&&($e+="g"),Be.matchCase||($e+="i"),Be.multiline&&($e+="m"),Be.unicode&&($e+="u"),new RegExp(he,$e)}e.createRegExp=A;function p(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function o(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=o;function r(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=r;function g(he){return he.split(/\r\n|\r|\n/)}e.splitLines=g;function c(he){for(let Ie=0,Be=he.length;Ie<Be;Ie++){const $e=he.charCodeAt(Ie);if($e!==32&&$e!==9)return Ie}return-1}e.firstNonWhitespaceIndex=c;function E(he,Ie=0,Be=he.length){for(let $e=Ie;$e<Be;$e++){const tt=he.charCodeAt($e);if(tt!==32&&tt!==9)return he.substring(Ie,$e)}return he.substring(Ie,Be)}e.getLeadingWhitespace=E;function n(he,Ie=he.length-1){for(let Be=Ie;Be>=0;Be--){const $e=he.charCodeAt(Be);if($e!==32&&$e!==9)return Be}return-1}e.lastNonWhitespaceIndex=n;function t(he,Ie){return he<Ie?-1:he>Ie?1:0}e.compare=t;function s(he,Ie,Be=0,$e=he.length,tt=0,Te=Ie.length){for(;Be<$e&&tt<Te;Be++,tt++){let ae=he.charCodeAt(Be),de=Ie.charCodeAt(tt);if(ae<de)return-1;if(ae>de)return 1}const ye=$e-Be,be=Te-tt;return ye<be?-1:ye>be?1:0}e.compareSubstring=s;function d(he,Ie){return l(he,Ie,0,he.length,0,Ie.length)}e.compareIgnoreCase=d;function l(he,Ie,Be=0,$e=he.length,tt=0,Te=Ie.length){for(;Be<$e&&tt<Te;Be++,tt++){let ae=he.charCodeAt(Be),de=Ie.charCodeAt(tt);if(ae===de)continue;if(ae>=128||de>=128)return s(he.toLowerCase(),Ie.toLowerCase(),Be,$e,tt,Te);h(ae)&&(ae-=32),h(de)&&(de-=32);const ve=ae-de;if(ve!==0)return ve}const ye=$e-Be,be=Te-tt;return ye<be?-1:ye>be?1:0}e.compareSubstringIgnoreCase=l;function h(he){return he>=97&&he<=122}e.isLowerAsciiLetter=h;function u(he){return he>=65&&he<=90}e.isUpperAsciiLetter=u;function b(he,Ie){return he.length===Ie.length&&l(he,Ie)===0}e.equalsIgnoreCase=b;function I(he,Ie){const Be=Ie.length;return Ie.length>he.length?!1:l(he,Ie,0,Be)===0}e.startsWithIgnoreCase=I;function T(he,Ie){let Be,$e=Math.min(he.length,Ie.length);for(Be=0;Be<$e;Be++)if(he.charCodeAt(Be)!==Ie.charCodeAt(Be))return Be;return $e}e.commonPrefixLength=T;function x(he,Ie){let Be,$e=Math.min(he.length,Ie.length);const tt=he.length-1,Te=Ie.length-1;for(Be=0;Be<$e;Be++)if(he.charCodeAt(tt-Be)!==Ie.charCodeAt(Te-Be))return Be;return $e}e.commonSuffixLength=x;function O(he){return 55296<=he&&he<=56319}e.isHighSurrogate=O;function F(he){return 56320<=he&&he<=57343}e.isLowSurrogate=F;function W(he,Ie){return(he-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=W;function M(he,Ie,Be){const $e=he.charCodeAt(Be);if(O($e)&&Be+1<Ie){const tt=he.charCodeAt(Be+1);if(F(tt))return W($e,tt)}return $e}e.getNextCodePoint=M;function B(he,Ie){const Be=he.charCodeAt(Ie-1);if(F(Be)&&Ie>1){const $e=he.charCodeAt(Ie-2);if(O($e))return W($e,Be)}return Be}function U(he,Ie){const Be=st.getInstance(),$e=Ie,tt=he.length,Te=M(he,tt,Ie);Ie+=Te>=65536?2:1;let ye=Be.getGraphemeBreakType(Te);for(;Ie<tt;){const be=M(he,tt,Ie),ae=Be.getGraphemeBreakType(be);if(ut(ye,ae))break;Ie+=be>=65536?2:1,ye=ae}return Ie-$e}e.nextCharLength=U;function z(he,Ie){const Be=st.getInstance(),$e=Ie,tt=B(he,Ie);Ie-=tt>=65536?2:1;let Te=Be.getGraphemeBreakType(tt);for(;Ie>0;){const ye=B(he,Ie),be=Be.getGraphemeBreakType(ye);if(ut(be,Te))break;Ie-=ye>=65536?2:1,Te=be}return $e-Ie}e.prevCharLength=z;function K(he,Ie){const Be=st.getInstance(),$e=he.length,tt=Ie,Te=M(he,$e,Ie),ye=Be.getGraphemeBreakType(Te);Ie+=Te>=65536?2:1;let be=ye;for(;Ie<$e;){const de=M(he,$e,Ie),ve=Be.getGraphemeBreakType(de);if(ut(be,ve))break;Ie+=de>=65536?2:1,be=ve}const ae=Ie;for(Ie=tt,be=ye;Ie>0;){const de=B(he,Ie),ve=Be.getGraphemeBreakType(de);if(ut(ve,be))break;Ie-=de>=65536?2:1,be=ve}return[Ie,ae]}function N(he,Ie){return Ie>0&&F(he.charCodeAt(Ie))?K(he,Ie-1):K(he,Ie)}e.getCharContainingOffset=N;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(he){return j.test(he)}e.containsRTL=H;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function q(he){return V.test(he)}e.containsEmoji=q;const te=/^[\t\n\r\x20-\x7E]*$/;function fe(he){return te.test(he)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ce(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=Ce;function ke(he){for(let Ie=0,Be=he.length;Ie<Be;Ie++)if(Ue(he.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=ke;function Ue(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=Ue;function xe(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=xe;function ze(he,Ie){if(he.length<Ie)return he;const Be=/\b/g;let $e=0;for(;Be.test(he)&&!(he.length-Be.lastIndex<Ie);)$e=Be.lastIndex,Be.lastIndex+=1;return he.substring($e).replace(/^\s/,"")}e.lcut=ze;const Q=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(he){return he&&(he=he.replace(Q,""),he=he.replace(Z,""),he=he.replace(re,"")),he}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=J;function ie(he){return J(he)?he.substr(1):he}e.stripUTF8BOM=ie;function we(he,Ie){if(!he||!Ie||he.length<Ie.length)return!1;const Be=Ie.length,$e=he.toLowerCase();let tt=0,Te=-1;for(;tt<Be;){const ye=$e.indexOf(Ie[tt],Te+1);if(ye<0)return!1;Te=ye,tt++}return!0}e.fuzzyContains=we;function Me(he,Ie=!1){return he?(Ie&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=Me;function je(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=je;function Ke(he,Ie=1){if(Ie===0)return"";let Be=-1;do Be=he.indexOf(`
`,Be+1),Ie--;while(Ie>0&&Be>=0);return Be===-1?he:(he[Be-1]==="\r"&&Be--,he.substr(0,Be))}e.getNLines=Ke;function Ze(he){const Ie=90-65+1;return he=he%(2*Ie),he<Ie?String.fromCharCode(97+he):String.fromCharCode(65+he-Ie)}e.singleLetterHash=Ze;function rt(he){return st.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=rt;function ut(he,Ie){return he===0?Ie!==5&&Ie!==7:he===2&&Ie===3?!1:he===4||he===2||he===3||Ie===4||Ie===2||Ie===3?!0:!(he===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(he===11||he===9)&&(Ie===9||Ie===10)||(he===12||he===10)&&Ie===10||Ie===5||Ie===13||Ie===7||he===1||he===13&&Ie===14||he===6&&Ie===6)}e.breakBetweenGraphemeBreakType=ut;var it;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(it=e.GraphemeBreakType||(e.GraphemeBreakType={}));class st{constructor(){this._data=Ae()}static getInstance(){return st._INSTANCE||(st._INSTANCE=new st),st._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Be=this._data,$e=Be.length/3;let tt=1;for(;tt<=$e;)if(Ie<Be[3*tt])tt=2*tt;else if(Ie>Be[3*tt+1])tt=2*tt+1;else return Be[3*tt+2];return 0}}st._INSTANCE=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function wt(he,Ie){if(he===0)return 0;const Be=ee(he,Ie);if(Be!==void 0)return Be;const $e=B(Ie,he);return he-=se($e),he}e.getLeftDeleteOffset=wt;function ee(he,Ie){let Be=B(Ie,he);for(he-=se(Be);Se(Be)||Be===65039||Be===8419;){if(he===0)return;Be=B(Ie,he),he-=se(Be)}if(!!xe(Be)){if(he>=0){const $e=B(Ie,he);$e===8205&&(he-=se($e))}return he}}function se(he){return he>=65536?2:1}function Se(he){return 127995<=he&&he<=127999}var Ge;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.noBreakWhitespace="\xA0";class Ye{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ye.map){let $e=function(ye){const be=new Map;for(let ae=0;ae<ye.length;ae+=2)be.set(ye[ae],ye[ae+1]);return be};const Ie=Ye.getData();let Be=m.locale;(!Be||!(Be in Ie))&&(Be=m.language),(!Be||!(Be in Ie))&&(Be="_default");const tt=$e(Ie._common),Te=$e(Ie[Be]);for(const[ye,be]of Te)tt.set(ye,be);Ye.map=tt}return Ye.map}static isAmbiguous(Ie){return Ye.getConfusablesForCurrentLocale().has(Ie)}static getPrimaryConfusable(Ie){return Ye.getConfusablesForCurrentLocale().get(Ie)}static getPrimaryConfusableCodePoints(){return new Set(Ye.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ye;class nt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(nt.getRawData())),this._data}static isInvisibleCharacter(Ie){return nt.getData().has(Ie)}static get codePoints(){return nt.getData()}}e.InvisibleCharacters=nt,nt._data=void 0}),define(ge[47],pe([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(A){return D(A,0)}e.hash=L;function D(A,p){switch(typeof A){case"object":return A===null?C(349,p):Array.isArray(A)?S(A,p):y(A,p);case"string":return k(A,p);case"boolean":return i(A,p);case"number":return C(A,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=D;function C(A,p){return(p<<5)-p+A|0}e.numberHash=C;function i(A,p){return C(A?433:863,p)}function k(A,p){p=C(149417,p);for(let o=0,r=A.length;o<r;o++)p=C(A.charCodeAt(o),p);return p}e.stringHash=k;function S(A,p){return p=C(104579,p),A.reduce((o,r)=>D(r,o),p)}function y(A,p){return p=C(181387,p),Object.keys(A).sort().reduce((o,r)=>(o=k(r,o),D(A[r],o)),p)}class R{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=D(p,this._value),this._value}}e.Hasher=R;var P;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function a(A,p,o=32){const r=o-p,g=~((1<<r)-1);return(A<<p|(g&A)>>>r)>>>0}function w(A,p=0,o=A.byteLength,r=0){for(let g=0;g<o;g++)A[p+g]=r}function f(A,p,o="0"){for(;A.length<p;)A=o+A;return A}function v(A,p=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(o=>o.toString(16).padStart(2,"0")).join(""):f((A>>>0).toString(16),p/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const o=p.length;if(o===0)return;const r=this._buff;let g=this._buffLen,c=this._leftoverHighSurrogate,E,n;for(c!==0?(E=c,n=-1,c=0):(E=p.charCodeAt(0),n=0);;){let t=E;if(m.isHighSurrogate(E))if(n+1<o){const s=p.charCodeAt(n+1);m.isLowSurrogate(s)?(n++,t=m.computeCodePoint(E,s)):t=65533}else{c=E;break}else m.isLowSurrogate(E)&&(t=65533);if(g=this._push(r,g,t),n++,n<o)E=p.charCodeAt(n);else break}this._buffLen=g,this._leftoverHighSurrogate=c}_push(p,o,r){return r<128?p[o++]=r:r<2048?(p[o++]=192|(r&1984)>>>6,p[o++]=128|(r&63)>>>0):r<65536?(p[o++]=224|(r&61440)>>>12,p[o++]=128|(r&4032)>>>6,p[o++]=128|(r&63)>>>0):(p[o++]=240|(r&1835008)>>>18,p[o++]=128|(r&258048)>>>12,p[o++]=128|(r&4032)>>>6,p[o++]=128|(r&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=_._bigBlock32,o=this._buffDV;for(let l=0;l<64;l+=4)p.setUint32(l,o.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,a(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let r=this._h0,g=this._h1,c=this._h2,E=this._h3,n=this._h4,t,s,d;for(let l=0;l<80;l++)l<20?(t=g&c|~g&E,s=1518500249):l<40?(t=g^c^E,s=1859775393):l<60?(t=g&c|g&E|c&E,s=2400959708):(t=g^c^E,s=3395469782),d=a(r,5)+t+n+s+p.getUint32(l*4,!1)&4294967295,n=E,E=c,c=a(g,30),g=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[24],pe([0,1,17,8]),function(Y,e,m,L){"use strict";var D,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,s){let d=n.get(t);return d===void 0&&(d=s,n.set(t,d)),d}e.getOrSet=k;function S(n){const t=[];return n.forEach((s,d)=>{t.push(`${d} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function y(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=y;class R{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return s-d}value(){return this._value[this._pos]}}e.StringIterator=R;class P{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class a{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=a;var w;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(w||(w={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(_||(_={}));class A{constructor(t){this._iter=t}static forUris(t=()=>!1){return new A(new f(t))}static forPaths(){return new A(new a)}static forStrings(){return new A(new R)}static forConfigKeys(){return new A(new P)}clear(){this._root=void 0}fill(t,s){if(s){const d=s.slice(0);(0,m.shuffle)(d);for(let l of d)this.set(l,t)}else{const d=t.slice(0);(0,m.shuffle)(d);for(let l of d)this.set(l[0],l[1])}}set(t,s){const d=this._iter.reset(t);let l;this._root||(this._root=new v,this._root.segment=d.value());const h=[];for(l=this._root;;){const b=d.cmp(l.segment);if(b>0)l.left||(l.left=new v,l.left.segment=d.value()),h.push([-1,l]),l=l.left;else if(b<0)l.right||(l.right=new v,l.right.segment=d.value()),h.push([1,l]),l=l.right;else if(d.hasNext())d.next(),l.mid||(l.mid=new v,l.mid.segment=d.value()),h.push([0,l]),l=l.mid;else break}const u=l.value;l.value=s,l.key=t;for(let b=h.length-1;b>=0;b--){const I=h[b][1];I.updateHeight();const T=I.balanceFactor();if(T<-1||T>1){const x=h[b][0],O=h[b+1][0];if(x===1&&O===1)h[b][1]=I.rotateLeft();else if(x===-1&&O===-1)h[b][1]=I.rotateRight();else if(x===1&&O===-1)I.right=h[b+1][1]=h[b+1][1].rotateRight(),h[b][1]=I.rotateLeft();else if(x===-1&&O===1)I.left=h[b+1][1]=h[b+1][1].rotateLeft(),h[b][1]=I.rotateRight();else throw new Error;if(b>0)switch(h[b-1][0]){case-1:h[b-1][1].left=h[b][1];break;case 1:h[b-1][1].right=h[b][1];break;case 0:h[b-1][1].mid=h[b][1];break}else this._root=h[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let d=this._root;for(;d;){const l=s.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else break}return d}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const d=this._iter.reset(t),l=[];let h=this._root;for(;h;){const u=d.cmp(h.segment);if(u>0)l.push([-1,h]),h=h.left;else if(u<0)l.push([1,h]),h=h.right;else if(d.hasNext())d.next(),l.push([0,h]),h=h.mid;else break}if(!!h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this._min(h.right),{key:b,value:I,segment:T}=u;this._delete(u.key,!1),h.key=b,h.value=I,h.segment=T}else{const u=h.left??h.right;if(l.length>0){const[b,I]=l[l.length-1];switch(b){case-1:I.left=u;break;case 0:I.mid=u;break;case 1:I.right=u;break}}else this._root=u}for(let u=l.length-1;u>=0;u--){const b=l[u][1];b.updateHeight();const I=b.balanceFactor();if(I>1?(b.right.balanceFactor()>=0||(b.right=l[u+1][1]=l[u+1][1].rotateRight()),l[u][1]=b.rotateLeft()):I<-1&&(b.left.balanceFactor()<=0||(b.left=l[u+1][1]=l[u+1][1].rotateLeft()),l[u][1]=b.rotateRight()),u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let d=this._root,l;for(;d;){const h=s.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(s.hasNext())s.next(),l=d.value||l,d=d.mid;else break}return d&&d.value||l}findSuperstr(t){const s=this._iter.reset(t);let d=this._root;for(;d;){const l=s.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[s,d]of this)t(d,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const d=s.balanceFactor();return d<-1||d>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=A;class p{constructor(t,s){this.uri=t,this.value=s}}class o{constructor(t,s){this[D]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=s??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new p(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[d,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=n=>n.toString();var r;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const d=this._map.get(t);if(!!d)return s!==0&&this.touch(d,s),d.value}set(t,s,d=0){let l=this._map.get(t);if(l)l.value=s,d!==0&&this.touch(l,d);else{switch(l={key:t,value:s,next:void 0,previous:void 0},d){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const d=this._state;let l=this._head;for(;l;){if(s?t.bind(s)(l.value,l.key,this):t(l.value,l.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,s=this._state;let d=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.key,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return l}values(){const t=this,s=this._state;let d=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.value,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return l}entries(){const t=this,s=this._state;let d=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:[d.key,d.value],done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,d=this.size;for(;s&&d>t;)this._map.delete(s.key),s=s.next,d--;this._head=s,this._size=d,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,d=t.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const d=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(d.previous=l,l.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const d=t.next,l=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=l,l.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,d)=>{t.push([d,s])}),t}fromJSON(t){this.clear();for(const[s,d]of t)this.set(s,d)}}e.LinkedMap=g;class c extends g{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class E{constructor(t){i.set(this,void 0),ot(this,i,t,"f")}get size(){return Oe(this,i,"f").size}forEach(t,s){Oe(this,i,"f").forEach(t,s)}get(t){return Oe(this,i,"f").get(t)}has(t){return Oe(this,i,"f").has(t)}entries(){return Oe(this,i,"f").entries()}keys(){return Oe(this,i,"f").keys()}values(){return Oe(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Oe(this,i,"f").entries()}}e.ReadonlyMapView=E}),define(ge[96],pe([0,1,24,8]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(ie,we){for(let Me=0,je=J.length;Me<je;Me++){const Ke=J[Me](ie,we);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(J,ie,we){if(!we||we.length<ie.length)return null;let Me;return J?Me=L.startsWithIgnoreCase(we,ie):Me=we.indexOf(ie)===0,Me?ie.length>0?[{start:0,end:ie.length}]:[]:null}function i(J,ie){const we=ie.toLowerCase().indexOf(J.toLowerCase());return we===-1?null:[{start:we,end:we+J.length}]}e.matchesContiguousSubString=i;function k(J,ie){return S(J.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=k;function S(J,ie,we,Me){if(we===J.length)return[];if(Me===ie.length)return null;if(J[we]===ie[Me]){let je=null;return(je=S(J,ie,we+1,Me+1))?A({start:Me,end:Me+1},je):null}return S(J,ie,we,Me+1)}function y(J){return 97<=J&&J<=122}function R(J){return 65<=J&&J<=90}e.isUpper=R;function P(J){return 48<=J&&J<=57}function a(J){return J===32||J===9||J===10||J===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>w.add(J.charCodeAt(0)));function f(J){return a(J)||w.has(J)}function v(J,ie){return J===ie||f(J)&&f(ie)}function _(J){return y(J)||R(J)||P(J)}function A(J,ie){return ie.length===0?ie=[J]:J.end===ie[0].start?ie[0].start=J.start:ie.unshift(J),ie}function p(J,ie){for(let we=ie;we<J.length;we++){const Me=J.charCodeAt(we);if(R(Me)||P(Me)||we>0&&!_(J.charCodeAt(we-1)))return we}return J.length}function o(J,ie,we,Me){if(we===J.length)return[];if(Me===ie.length)return null;if(J[we]!==ie[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=o(J,ie,we+1,Me+1);!je&&(Ke=p(ie,Ke))<ie.length;)je=o(J,ie,we+1,Ke),Ke++;return je===null?null:A({start:Me,end:Me+1},je)}}function r(J){let ie=0,we=0,Me=0,je=0,Ke=0;for(let st=0;st<J.length;st++)Ke=J.charCodeAt(st),R(Ke)&&ie++,y(Ke)&&we++,_(Ke)&&Me++,P(Ke)&&je++;const Ze=ie/J.length,rt=we/J.length,ut=Me/J.length,it=je/J.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ut,numericPercent:it}}function g(J){const{upperPercent:ie,lowerPercent:we}=J;return we===0&&ie>.6}function c(J){const{upperPercent:ie,lowerPercent:we,alphaPercent:Me,numericPercent:je}=J;return we>.2&&ie<.8&&Me>.6&&je<.2}function E(J){let ie=0,we=0,Me=0,je=0;for(let Ke=0;Ke<J.length;Ke++)Me=J.charCodeAt(Ke),R(Me)&&ie++,y(Me)&&we++,a(Me)&&je++;return(ie===0||we===0)&&je===0?J.length<=30:ie<=5}function n(J,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!E(J)||ie.length>60)return null;const we=r(ie);if(!c(we)){if(!g(we))return null;ie=ie.toLowerCase()}let Me=null,je=0;for(J=J.toLowerCase();je<ie.length&&(Me=o(J,ie,0,je))===null;)je=p(ie,je+1);return Me}e.matchesCamelCase=n;function t(J,ie,we=!1){if(!ie||ie.length===0)return null;let Me=null,je=0;for(J=J.toLowerCase(),ie=ie.toLowerCase();je<ie.length&&(Me=s(J,ie,0,je,we))===null;)je=d(ie,je+1);return Me}e.matchesWords=t;function s(J,ie,we,Me,je){if(we===J.length)return[];if(Me===ie.length)return null;if(v(J.charCodeAt(we),ie.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=s(J,ie,we+1,Me+1,je),!je)for(;!Ke&&(Ze=d(ie,Ze))<ie.length;)Ke=s(J,ie,we+1,Ze,je),Ze++;return Ke===null?null:A({start:Me,end:Me+1},Ke)}else return null}function d(J,ie){for(let we=ie;we<J.length;we++)if(f(J.charCodeAt(we))||we>0&&f(J.charCodeAt(we-1)))return we;return J.length}const l=D(e.matchesPrefix,n,i),h=D(e.matchesPrefix,n,k),u=new m.LRUCache(1e4);function b(J,ie,we=!1){if(typeof J!="string"||typeof ie!="string")return null;let Me=u.get(J);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(J),"i"),u.set(J,Me));const je=Me.exec(ie);return je?[{start:je.index,end:je.index+je[0].length}]:we?h(J,ie):l(J,ie)}e.matchesFuzzy=b;function I(J,ie){const we=Ue(J,J.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return we?x(we):null}e.matchesFuzzy2=I;function T(J,ie,we,Me,je,Ke){const Ze=Math.min(13,J.length);for(;we<Ze;we++){const rt=Ue(J,ie,we,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=T;function x(J){if(typeof J=="undefined")return[];const ie=[],we=J[1];for(let Me=J.length-1;Me>1;Me--){const je=J[Me]+we,Ke=ie[ie.length-1];Ke&&Ke.end===je?Ke.end=je+1:ie.push({start:je,end:je+1})}return ie}e.createMatches=x;const O=128;function F(){const J=[],ie=[];for(let we=0;we<=O;we++)ie[we]=0;for(let we=0;we<=O;we++)J.push(ie.slice(0));return J}function W(J){const ie=[];for(let we=0;we<=J;we++)ie[we]=0;return ie}const M=W(2*O),B=W(2*O),U=F(),z=F(),K=F(),N=!1;function j(J,ie,we,Me,je){function Ke(rt,ut,it=" "){for(;rt.length<ut;)rt=it+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=we;rt++)rt===0?Ze+=" |":Ze+=`${ie[rt-1]}|`,Ze+=J[rt].slice(0,je+1).map(ut=>Ke(ut.toString(),3)).join("|")+`
`;return Ze}function H(J,ie,we,Me){J=J.substr(ie),we=we.substr(Me),console.log(j(z,J,J.length,we,we.length)),console.log(j(K,J,J.length,we,we.length)),console.log(j(U,J,J.length,we,we.length))}function V(J,ie){if(ie<0||ie>=J.length)return!1;const we=J.codePointAt(ie);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(we)}}function q(J,ie){if(ie<0||ie>=J.length)return!1;switch(J.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function te(J,ie,we){return ie[J]!==we[J]}function fe(J,ie,we,Me,je,Ke,Ze=!1){for(;ie<we&&je<Ke;)J[ie]===Me[je]&&(Ze&&(M[ie]=je),ie+=1),je+=1;return ie===we}e.isPatternInWord=fe;var Ce;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var ke;(function(J){J.Default=[-100,0];function ie(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}J.isDefault=ie})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Ue(J,ie,we,Me,je,Ke,Ze){const rt=J.length>O?O:J.length,ut=Me.length>O?O:Me.length;if(we>=rt||Ke>=ut||rt-we>ut-Ke||!fe(ie,we,rt,je,Ke,ut,!0))return;xe(rt,ut,we,Ke,ie,je);let it=1,st=1,Ae=we,wt=Ke;const ee=[!1];for(it=1,Ae=we;Ae<rt;it++,Ae++){const nt=M[Ae],he=B[Ae],Ie=Ae+1<rt?B[Ae+1]:ut;for(st=nt-Ke+1,wt=nt;wt<Ie;st++,wt++){let Be=Number.MIN_SAFE_INTEGER,$e=!1;wt<=he&&(Be=ze(J,ie,Ae,we,Me,je,wt,ut,Ke,U[it-1][st-1]===0,ee));let tt=0;Be!==Number.MAX_SAFE_INTEGER&&($e=!0,tt=Be+z[it-1][st-1]);const Te=wt>nt,ye=Te?z[it][st-1]+(U[it][st-1]>0?-5:0):0,be=wt>nt+1&&U[it][st-1]>0,ae=be?z[it][st-2]+(U[it][st-2]>0?-5:0):0;if(be&&(!Te||ae>=ye)&&(!$e||ae>=tt))z[it][st]=ae,K[it][st]=3,U[it][st]=0;else if(Te&&(!$e||ye>=tt))z[it][st]=ye,K[it][st]=2,U[it][st]=0;else if($e)z[it][st]=tt,K[it][st]=1,U[it][st]=U[it-1][st-1]+1;else throw new Error("not possible")}}if(N&&H(J,we,Me,Ke),!ee[0]&&!Ze)return;it--,st--;const se=[z[it][st],Ke];let Se=0,Ge=0;for(;it>=1;){let nt=st;do{const he=K[it][nt];if(he===3)nt=nt-2;else if(he===2)nt=nt-1;else break}while(nt>=1);Se>1&&ie[we+it-1]===je[Ke+st-1]&&!te(nt+Ke-1,Me,je)&&Se+1>U[it][nt]&&(nt=st),nt===st?Se++:Se=1,Ge||(Ge=nt),it--,st=nt-1,se.push(st)}ut===rt&&(se[0]+=2);const Ye=Ge-rt;return se[0]-=Ye,se}e.fuzzyScore=Ue;function xe(J,ie,we,Me,je,Ke){let Ze=J-1,rt=ie-1;for(;Ze>=we&&rt>=Me;)je[Ze]===Ke[rt]&&(B[Ze]=rt,Ze--),rt--}function ze(J,ie,we,Me,je,Ke,Ze,rt,ut,it,st){if(ie[we]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let Ae=1,wt=!1;return Ze===we-Me?Ae=J[we]===je[Ze]?7:5:te(Ze,je,Ke)&&(Ze===0||!te(Ze-1,je,Ke))?(Ae=J[we]===je[Ze]?7:5,wt=!0):V(Ke,Ze)&&(Ze===0||!V(Ke,Ze-1))?Ae=5:(V(Ke,Ze-1)||q(Ke,Ze-1))&&(Ae=5,wt=!0),Ae>1&&we===Me&&(st[0]=!0),wt||(wt=te(Ze,je,Ke)||V(Ke,Ze-1)||q(Ke,Ze-1)),we===Me?Ze>ut&&(Ae-=wt?3:5):it?Ae+=wt?2:0:Ae+=wt?0:1,Ze+1===rt&&(Ae-=wt?3:5),Ae}function Q(J,ie,we,Me,je,Ke,Ze){return re(J,ie,we,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=Q;function Z(J,ie,we,Me,je,Ke,Ze){return re(J,ie,we,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=Z;function re(J,ie,we,Me,je,Ke,Ze,rt){let ut=Ue(J,ie,we,Me,je,Ke,rt);if(ut&&!Ze)return ut;if(J.length>=3){const it=Math.min(7,J.length-1);for(let st=we+1;st<it;st++){const Ae=ue(J,st);if(Ae){const wt=Ue(Ae,Ae.toLowerCase(),we,Me,je,Ke,rt);wt&&(wt[0]-=3,(!ut||wt[0]>ut[0])&&(ut=wt))}}}return ut}function ue(J,ie){if(ie+1>=J.length)return;const we=J[ie],Me=J[ie+1];if(we!==Me)return J.slice(0,ie)+Me+we+J.slice(ie+2)}}),define(ge[141],pe([0,1,78,96,8]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),i=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function S(_){return _.replace(k,(A,p)=>p?A:`\\${A}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function R(_){return _.replace(y,A=>`\\${A}`)}e.markdownEscapeEscapedIcons=R;const P=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function a(_){return _.indexOf(e.iconStartMarker)===-1?_:_.replace(P,(A,p,o,r)=>o?A:p||r||"")}e.stripIcons=a;function w(_){const A=_.indexOf(e.iconStartMarker);return A===-1?{text:_}:f(_,A)}e.parseLabelWithIcons=w;function f(_,A){const p=[];let o="";function r(l){if(l){o+=l;for(const h of l)p.push(E)}}let g=-1,c="",E=0,n,t,s=A;const d=_.length;for(r(_.substr(0,A));s<d;)n=_[s],t=_[s+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=s,r(c),c=e.iconStartMarker,s++):n===")"&&g!==-1?(E+=s-g+1,g=-1,c=""):g!==-1?i.test(n)?c+=n:(r(c),g=-1,c=""):r(n),s++;return r(c),{text:o,iconOffsets:p}}function v(_,A,p=!1){const{text:o,iconOffsets:r}=A;if(!r||r.length===0)return(0,L.matchesFuzzy)(_,o,p);const g=(0,D.ltrim)(o," "),c=o.length-g.length,E=(0,L.matchesFuzzy)(_,g,p);if(E)for(const n of E){const t=r[n.start+c]+c;n.start+=t,n.end+=t}return E}e.matchesFuzzyIconAware=v}),define(ge[97],pe([0,1,15,141]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(w="",f=!1){if(this.value=w,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(w,f=0){return this.value+=y(this.supportThemeIcons?(0,L.escapeIcons)(w):w).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,f){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=C;function i(a){return k(a)?!a.value:Array.isArray(a)?a.every(i):!0}e.isEmptyMarkdownString=i;function k(a){return a instanceof C?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function S(a,w){return a===w?!0:!a||!w?!1:a.value===w.value&&a.isTrusted===w.isTrusted&&a.supportThemeIcons===w.supportThemeIcons}e.markdownStringEqual=S;function y(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function R(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function P(a){const w=[],f=a.split("|").map(_=>_.trim());a=f[0];const v=f[1];if(v){const _=/height=(\d+)/.exec(v),A=/width=(\d+)/.exec(v),p=_?_[1]:"",o=A?A[1]:"",r=isFinite(parseInt(o)),g=isFinite(parseInt(p));r&&w.push(`width="${o}"`),g&&w.push(`height="${p}"`)}return{href:a,dimensions:w}}e.parseHrefAndDimensions=P}),define(ge[79],pe([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function D(y){return S(y,"NFC",L)}e.normalizeNFC=D;const C=new m.LRUCache(1e4);function i(y){return S(y,"NFD",C)}e.normalizeNFD=i;const k=/[^\u0000-\u0080]/;function S(y,R,P){if(!y)return y;const a=P.get(y);if(a)return a;let w;return k.test(y)?w=y.normalize(R):w=y,P.set(y,w),w}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(R){return i(R).replace(y,"")}}()}),define(ge[48],pe([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const C="error",i="warning",k="warn",S="info",y="ignore";function R(a){return a?m.equalsIgnoreCase(C,a)?D.Error:m.equalsIgnoreCase(i,a)||m.equalsIgnoreCase(k,a)?D.Warning:m.equalsIgnoreCase(S,a)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function P(a){switch(a){case D.Error:return C;case D.Warning:return i;case D.Info:return S;default:return y}}D.toString=P}(L||(L={})),e.default=L}),define(ge[13],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(h){return Array.isArray(h)}e.isArray=m;function L(h){return typeof h=="string"}e.isString=L;function D(h){return Array.isArray(h)&&h.every(u=>L(u))}e.isStringArray=D;function C(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=C;function i(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=i;function k(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=k;function S(h){return h===!0||h===!1}e.isBoolean=S;function y(h){return typeof h=="undefined"}e.isUndefined=y;function R(h){return!P(h)}e.isDefined=R;function P(h){return y(h)||h===null}e.isUndefinedOrNull=P;function a(h,u){if(!h)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=a;function w(h){if(P(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=w;function f(...h){const u=[];for(let b=0;b<h.length;b++){const I=h[b];if(P(I))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);u.push(I)}return u}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function _(h){if(!C(h))return!1;for(let u in h)if(v.call(h,u))return!1;return!0}e.isEmptyObject=_;function A(h){return typeof h=="function"}e.isFunction=A;function p(...h){return h.length>0&&h.every(A)}e.areFunctions=p;function o(h,u){const b=Math.min(h.length,u.length);for(let I=0;I<b;I++)r(h[I],u[I])}e.validateConstraints=o;function r(h,u){if(L(u)){if(typeof h!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(A(u)){try{if(h instanceof u)return}catch{}if(!P(h)&&h.constructor===u||u.length===1&&u.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function g(h){let u=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)u=u.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return u}e.getAllPropertyNames=g;function c(h){const u=[];for(const b of g(h))typeof h[b]=="function"&&u.push(b);return u}e.getAllMethodNames=c;function E(h,u){const b=T=>function(){const x=Array.prototype.slice.call(arguments,0);return u(T,x)};let I={};for(const T of h)I[T]=b(T);return I}e.createProxyObject=E;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function s(h){return class{constructor(){return new Proxy({},{get(u,b){if(u[b])return u[b];throw new Error(`Not Implemented: ${h}->${String(b)}`)}})}}}e.NotImplementedProxy=s;function d(h,u="Unreachable"){throw new Error(u)}e.assertNever=d;function l(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=l}),define(ge[30],pe([0,1,9,12,8,13]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function k(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function S(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function y(n,t=m.posix.sep){if(!n)return"";const s=n.length,d=n.charCodeAt(0);if(i(d)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let h=3;const u=h;for(;h<s&&!i(n.charCodeAt(h));h++);if(u!==h&&!i(n.charCodeAt(h+1))){for(h+=1;h<s;h++)if(i(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,t)}}return t}else if(A(d)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<s;l++)if(i(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=y;function R(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const d=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(d===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,t=L.isWindows){const s=t?P:a;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&w.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function v(n,t,s){const d=n===t;return!s||d?d:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=v;function _(n,t,s,d=m.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let h=t.length;return t.charAt(t.length-1)===d&&h--,n.charAt(h)===d}return t.charAt(t.length-1)!==d&&(t+=d),n.indexOf(t)===0}e.isEqualOrParent=_;function A(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=A;function p(n,t){return L.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(t,n)),n=(0,m.normalize)(n),L.isWindows?(n=(0,D.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,D.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=p;function o(n){const t=(0,m.normalize)(n);return L.isWindows?n.length>3?!1:r(t)&&(n.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=o;function r(n,t){return(t!==void 0?t:L.isWindows)?A(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function g(n){return r(n)?n[0]:void 0}e.getDriveLetter=g;function c(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=c;function E(n){const t=n.split(":");let s,d,l;if(t.forEach(h=>{const u=Number(h);(0,C.isNumber)(u)?d===void 0?d=u:l===void 0&&(l=u):s=s?[s,h].join(":"):h}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:l!==void 0?l:d!==void 0?1:void 0}}e.parseLineAndColumnAware=E}),define(ge[25],pe([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(A=>{v[A]&&typeof v[A]=="object"?_[A]=L(v[A]):_[A]=v[A]}),_}e.deepClone=L;function D(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const A=_.shift();Object.freeze(A);for(const p in A)if(C.call(A,p)){const o=A[p];typeof o=="object"&&!Object.isFrozen(o)&&_.push(o)}}return v}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function i(v,_){return k(v,_,new Set)}e.cloneAndChange=i;function k(v,_,A){if((0,m.isUndefinedOrNull)(v))return v;const p=_(v);if(typeof p!="undefined")return p;if((0,m.isArray)(v)){const o=[];for(const r of v)o.push(k(r,_,A));return o}if((0,m.isObject)(v)){if(A.has(v))throw new Error("Cannot clone recursive data-structure");A.add(v);const o={};for(let r in v)C.call(v,r)&&(o[r]=k(v[r],_,A));return A.delete(v),o}return v}function S(v,_,A=!0){return(0,m.isObject)(v)?((0,m.isObject)(_)&&Object.keys(_).forEach(p=>{p in v?A&&((0,m.isObject)(v[p])&&(0,m.isObject)(_[p])?S(v[p],_[p],A):v[p]=_[p]):v[p]=_[p]}),v):_}e.mixin=S;function y(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let A,p;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(A=0;A<v.length;A++)if(!y(v[A],_[A]))return!1}else{const o=[];for(p in v)o.push(p);o.sort();const r=[];for(p in _)r.push(p);if(r.sort(),!y(o,r))return!1;for(A=0;A<o.length;A++)if(!y(v[o[A]],_[o[A]]))return!1}return!0}e.equals=y;function R(v){const _=new Set;return JSON.stringify(v,(A,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(_.has(p))return"[Circular]";_.add(p)}return p})}e.safeStringify=R;function P(v,_,A){const p=_(v);return typeof p=="undefined"?A:p}e.getOrDefault=P;function a(v,_){const A=Object.create(null);return!v||!_||Object.keys(_).forEach(o=>{const r=v[o],g=_[o];y(r,g)||(A[o]=g)}),A}e.distinct=a;function w(v,_){const A=_.toLowerCase(),p=Object.keys(v).find(o=>o.toLowerCase()===A);return p?v[p]:v[_]}e.getCaseInsensitive=w;function f(v,_){const A=Object.create(null);for(const[p,o]of Object.entries(v))_(p,o)&&(A[p]=o);return A}e.filter=f}),define(ge[98],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function D(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=D}),define(ge[2],pe([0,1,9,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,i=/^\/\//;function k(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function y(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==P&&(t=P+t):t=P;break}return t}const R="",P="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(t,s,d,l,h,u=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=S(t,u),this.authority=s||R,this.path=y(this.scheme,d||R),this.query=l||R,this.fragment=h||R,k(this,u))}static isUri(t){return t instanceof w?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:d,path:l,query:h,fragment:u}=t;return s===void 0?s=this.scheme:s===null&&(s=R),d===void 0?d=this.authority:d===null&&(d=R),l===void 0?l=this.path:l===null&&(l=R),h===void 0?h=this.query:h===null&&(h=R),u===void 0?u=this.fragment:u===null&&(u=R),s===this.scheme&&d===this.authority&&l===this.path&&h===this.query&&u===this.fragment?this:new v(s,d,l,h,u)}static parse(t,s=!1){const d=a.exec(t);return d?new v(d[2]||R,E(d[4]||R),E(d[5]||R),E(d[7]||R),E(d[9]||R),s):new v(R,R,R,R,R)}static file(t){let s=R;if(L.isWindows&&(t=t.replace(/\\/g,P)),t[0]===P&&t[1]===P){const d=t.indexOf(P,2);d===-1?(s=t.substring(2),t=P):(s=t.substring(2,d),t=t.substring(d)||P)}return new v("file",s,t,R,R)}static from(t){const s=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return k(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&t.scheme==="file"?d=w.file(m.win32.join(o(t,!0),...s)).path:d=m.posix.join(t.path,...s),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof w)return t;{const s=new v(t);return s._formatted=t.external,s._fsPath=t._sep===f?t.fsPath:null,s}}else return t}}e.URI=w;const f=L.isWindows?1:void 0;class v extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(n,t){let s,d=-1;for(let l=0;l<n.length;l++){const h=n.charCodeAt(l);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)d!==-1&&(s+=encodeURIComponent(n.substring(d,l)),d=-1),s!==void 0&&(s+=n.charAt(l));else{s===void 0&&(s=n.substr(0,l));const u=_[h];u!==void 0?(d!==-1&&(s+=encodeURIComponent(n.substring(d,l)),d=-1),s+=u):d===-1&&(d=l)}}return d!==-1&&(s+=encodeURIComponent(n.substring(d))),s!==void 0?s:n}function p(n){let t;for(let s=0;s<n.length;s++){const d=n.charCodeAt(s);d===35||d===63?(t===void 0&&(t=n.substr(0,s)),t+=_[d]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function o(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,L.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=o;function r(n,t){const s=t?p:A;let d="",{scheme:l,authority:h,path:u,query:b,fragment:I}=n;if(l&&(d+=l,d+=":"),(h||l==="file")&&(d+=P,d+=P),h){let T=h.indexOf("@");if(T!==-1){const x=h.substr(0,T);h=h.substr(T+1),T=x.indexOf(":"),T===-1?d+=s(x,!1):(d+=s(x.substr(0,T),!1),d+=":",d+=s(x.substr(T+1),!1)),d+="@"}h=h.toLowerCase(),T=h.indexOf(":"),T===-1?d+=s(h,!1):(d+=s(h.substr(0,T),!1),d+=h.substr(T))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const T=u.charCodeAt(1);T>=65&&T<=90&&(u=`/${String.fromCharCode(T+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const T=u.charCodeAt(0);T>=65&&T<=90&&(u=`${String.fromCharCode(T+32)}:${u.substr(2)}`)}d+=s(u,!0)}return b&&(d+="?",d+=s(b,!1)),I&&(d+="#",d+=t?I:A(I,!1)),d}function g(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+g(n.substr(3)):n}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(n){return n.match(c)?n.replace(c,t=>g(t)):n}}),define(ge[59],pe([0,1,22,8,2]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(R){return JSON.stringify(R,S)}e.stringify=C;function i(R){let P=JSON.parse(R);return P=y(P),P}e.parse=i;var k;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function S(R,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function y(R,P=0){if(!R||P>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return D.URI.revive(R);case 2:return new RegExp(R.source,R.flags)}if(R instanceof m.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let a=0;a<R.length;++a)R[a]=y(R[a],P+1);else for(const a in R)Object.hasOwnProperty.call(R,a)&&(R[a]=y(R[a],P+1))}return R}e.revive=y}),define(ge[10],pe([0,1,12,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,y,R){this._hosts[S]=y,this._ports[S]=R}setConnectionToken(S,y){this._connectionTokens[S]=y}rewrite(S){if(this._delegate)return this._delegate(S);const y=S.authority;let R=this._hosts[y];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const P=this._ports[y],a=this._connectionTokens[y];let w=`path=${encodeURIComponent(S.path)}`;return typeof a=="string"&&(w+=`&tkn=${encodeURIComponent(a)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${R}:${P}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new C;class i{asBrowserUri(S,y){const R=this.toUri(S,y);return R.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===D.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${D.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?R.with({scheme:D.vscodeFileResource,authority:R.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(S,y){const R=this.toUri(S,y);return R.scheme===D.vscodeFileResource?R.with({scheme:D.file,authority:R.authority!==i.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(S,y){return L.URI.isUri(S)?S:L.URI.parse(y.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(ge[23],pe([0,1,30,10,9,12,8,2]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(w){return(0,k.uriToFsPath)(w,!0)}e.originalFSPath=S;class y{constructor(f){this._ignorePathCasing=f}compare(f,v,_=!1){return f===v?0:(0,i.compare)(this.getComparisonKey(f,_),this.getComparisonKey(v,_))}isEqual(f,v,_=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,_)===this.getComparisonKey(v,_)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,_=!1){if(f.scheme===v.scheme){if(f.scheme===L.Schemas.file)return m.isEqualOrParent(S(f),S(v),this._ignorePathCasing(f))&&f.query===v.query&&(_||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return m.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(_||f.fragment===v.fragment)}return!1}joinPath(f,...v){return k.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(D.dirname(S(f))).path:(v=D.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===L.Schemas.file?v=k.URI.file(D.normalize(S(f))).path:v=D.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===L.Schemas.file){const p=D.relative(S(f),S(v));return C.isWindows?m.toSlashes(p):p}let _=f.path||"/",A=v.path||"/";if(this._ignorePathCasing(f)){let p=0;for(const o=Math.min(_.length,A.length);p<o&&!(_.charCodeAt(p)!==A.charCodeAt(p)&&_.charAt(p).toLowerCase()!==A.charAt(p).toLowerCase());p++);_=A.substr(0,p)+_.substr(p)}return D.posix.relative(_,A)}resolvePath(f,v){if(f.scheme===L.Schemas.file){const _=k.URI.file(D.resolve(S(f),v));return f.with({authority:_.authority,path:_.path})}return v=m.toPosixPath(v),f.with({path:D.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,i.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=D.sep){if(f.scheme===L.Schemas.file){const _=S(f);return _.length>m.getRoot(_).length&&_[_.length-1]===v}else{const _=f.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=D.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=D.sep){let _=!1;if(f.scheme===L.Schemas.file){const A=S(f);_=A!==void 0&&A.length===m.getRoot(A).length&&A[A.length-1]===v}else{v="/";const A=f.path;_=A.length===1&&A.charCodeAt(A.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(w=>w.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new y(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(w,f){const v=[];for(let _=0;_<w.length;_++){const A=f(w[_]);w.some((p,o)=>o===_?!1:(0,e.isEqualOrParent)(A,f(p)))||v.push(w[_])}return v}e.distinctParents=R;var P;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(o=>{const[r,g]=o.split(":");r&&g&&_.set(r,g)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&_.set(w.META_DATA_MIME,p),_}w.parseMetaData=f})(P=e.DataUri||(e.DataUri={}));function a(w,f,v){if(f){let _=w.path;return _&&_[0]!==D.posix.sep&&(_=D.posix.sep+_),w.with({scheme:v,authority:f,path:_})}return w.with({scheme:v})}e.toLocalResource=a}),define(ge[18],pe([0,1,21,15,3,6,23,12]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(H){return!!H&&typeof H.then=="function"}e.isThenable=S;function y(H){const V=new m.CancellationTokenSource,q=H(V.token),te=new Promise((fe,Ce)=>{const ke=V.token.onCancellationRequested(()=>{ke.dispose(),V.dispose(),Ce((0,L.canceled)())});Promise.resolve(q).then(Ue=>{ke.dispose(),V.dispose(),fe(Ue)},Ue=>{ke.dispose(),V.dispose(),Ce(Ue)})});return new class{cancel(){V.cancel()}then(fe,Ce){return te.then(fe,Ce)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.createCancelablePromise=y;function R(H,V,q){return Promise.race([H,new Promise(te=>V.onCancellationRequested(()=>te(q)))])}e.raceCancellation=R;async function P(H){let V=-1;const q=H.map((fe,Ce)=>fe.then(ke=>(V=Ce,ke))),te=await Promise.race(q);return H.forEach((fe,Ce)=>{Ce!==V&&fe.cancel()}),te}e.raceCancellablePromises=P;function a(H,V,q){let te;const fe=setTimeout(()=>{te?.(void 0),q?.()},V);return Promise.race([H.finally(()=>clearTimeout(fe)),new Promise(Ce=>te=Ce)])}e.raceTimeout=a;function w(H){return new Promise((V,q)=>{const te=H();S(te)?te.then(V,q):V(te)})}e.asPromise=w;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(V){if(this.activePromise){if(this.queuedPromiseFactory=V,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const te=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,te};this.queuedPromise=new Promise(te=>{this.activePromise.then(q,q).then(te)})}return new Promise((q,te)=>{this.queuedPromise.then(q,te)})}return this.activePromise=V(),new Promise((q,te)=>{this.activePromise.then(fe=>{this.activePromise=null,q(fe)},fe=>{this.activePromise=null,te(fe)})})}}e.Throttler=f;class v{constructor(){this.current=Promise.resolve(null)}queue(V){return this.current=this.current.then(()=>V(),()=>V())}}e.Sequencer=v;class _{constructor(){this.promiseMap=new Map}queue(V,q){const fe=(this.promiseMap.get(V)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(V)===fe&&this.promiseMap.delete(V)});return this.promiseMap.set(V,fe),fe}}e.SequencerByKey=_;class A{constructor(V){this.defaultDelay=V,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(V,q=this.defaultDelay){return this.task=V,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((te,fe)=>{this.doResolve=te,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const te=this.task;return this.task=null,te()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=A;class p{constructor(V){this.delayer=new A(V),this.throttler=new f}trigger(V,q){return this.delayer.trigger(()=>this.throttler.queue(V),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class o{constructor(){this._isOpen=!1,this._promise=new Promise((V,q)=>{this._completePromise=V})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class r extends o{constructor(V){super();this._timeout=setTimeout(()=>this.open(),V)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function g(H,V){return V?new Promise((q,te)=>{const fe=setTimeout(()=>{Ce.dispose(),q()},H),Ce=V.onCancellationRequested(()=>{clearTimeout(fe),Ce.dispose(),te((0,L.canceled)())})}):y(q=>g(H,q))}e.timeout=g;function c(H,V=0){const q=setTimeout(H,V);return(0,C.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=c;function E(H){const V=[];let q=0;const te=H.length;function fe(){return q<te?H[q++]():null}function Ce(ke){ke!=null&&V.push(ke);const Ue=fe();return Ue?Ue.then(Ce):Promise.resolve(V)}return Promise.resolve(null).then(Ce)}e.sequence=E;function n(H,V=te=>!!te,q=null){let te=0;const fe=H.length,Ce=()=>{if(te>=fe)return Promise.resolve(q);const ke=H[te++];return Promise.resolve(ke()).then(xe=>V(xe)?Promise.resolve(xe):Ce())};return Ce()}e.first=n;function t(H,V=te=>!!te,q=null){if(H.length===0)return Promise.resolve(q);let te=H.length;const fe=()=>{te=-1;for(const Ce of H)Ce.cancel?.()};return new Promise((Ce,ke)=>{for(const Ue of H)Ue.then(xe=>{--te>=0&&V(xe)?(fe(),Ce(xe)):te===0&&Ce(q)}).catch(xe=>{--te>=0&&(fe(),ke(xe))})})}e.firstParallel=t;class s{constructor(V){this._size=0,this.maxDegreeOfParalellism=V,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(V){return this._size++,new Promise((q,te)=>{this.outstandingPromises.push({factory:V,c:q,e:te}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const V=this.outstandingPromises.shift();this.runningPromises++;const q=V.factory();q.then(V.c,V.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class d extends s{constructor(){super(1)}}e.Queue=d;class l{constructor(){this.queues=new Map}queueFor(V,q=i.extUri){const te=q.getComparisonKey(V);let fe=this.queues.get(te);return fe||(fe=new d,D.Event.once(fe.onFinished)(()=>{fe?.dispose(),this.queues.delete(te)}),this.queues.set(te,fe)),fe}dispose(){this.queues.forEach(V=>V.dispose()),this.queues.clear()}}e.ResourceQueue=l;class h{constructor(V,q){this._token=-1,typeof V=="function"&&typeof q=="number"&&this.setIfNotSet(V,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(V,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,V()},q)}setIfNotSet(V,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,V()},q))}}e.TimeoutTimer=h;class u{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(V,q){this.cancel(),this._token=setInterval(()=>{V()},q)}}e.IntervalTimer=u;class b{constructor(V,q){this.timeoutToken=-1,this.runner=V,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(V=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,V)}get delay(){return this.timeout}set delay(V){this.timeout=V}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class I{constructor(V,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=V,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(V=this.timeout){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(V/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=I;class T extends b{constructor(V,q){super(V,q);this.units=[]}work(V){this.units.push(V),this.isScheduled()||this.schedule()}doRun(){const V=this.units;this.units=[],this.runner&&this.runner(V)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class x extends C.Disposable{constructor(V,q,te,fe){super();this.maxWorkChunkSize=V,this.maxPendingWork=q,this.throttleDelay=te,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(V){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+V.length>this.maxPendingWork)return!1}else if(this.pending+V.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...V),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,k.setTimeout0)(()=>{if(V)return;const q=Date.now()+3;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.runWhenIdle=(H,V)=>{const q=requestIdleCallback(H,typeof V=="number"?{timeout:V}:void 0);let te=!1;return{dispose(){te||(te=!0,cancelIdleCallback(q))}}}}();class O{constructor(V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function F(H,V,q){let te;for(let fe=0;fe<q;fe++)try{return await H()}catch(Ce){te=Ce,await g(V)}throw te}e.retry=F;class W{hasPending(V){return this._pending?typeof V=="number"?this._pending.taskId===V:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(V,q,te){return this._pending={taskId:V,cancel:()=>te?.(),promise:q},q.then(()=>this.donePending(V),()=>this.donePending(V)),q}donePending(V){this._pending&&V===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const V=this._next;this._next=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}setNext(V){if(this._next)this._next.run=V;else{let q,te;const fe=new Promise((Ce,ke)=>{q=Ce,te=ke});this._next={run:V,promise:fe,promiseResolve:q,promiseReject:te}}return this._next.promise}}e.TaskSequentializer=W;class M{constructor(V,q=()=>Date.now()){this.interval=V,this.nowFn=q,this.lastIncrementTime=0,this.value=0}increment(){const V=this.nowFn();return V-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=V,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((V,q)=>{this.completeCallback=V,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(V){return new Promise(q=>{this.completeCallback(V),this.resolved=!0,q()})}error(V){return new Promise(q=>{this.errorCallback(V),this.rejected=!0,q()})}cancel(){new Promise(V=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,V()})}}e.DeferredPromise=B;var U;(function(H){async function V(te){let fe;const Ce=await Promise.all(te.map(ke=>ke.then(Ue=>Ue,Ue=>{fe||(fe=Ue)})));if(typeof fe!="undefined")throw fe;return Ce}H.settled=V;function q(te){return new Promise(async(fe,Ce)=>{try{await te(fe,Ce)}catch(ke){Ce(ke)}})}H.withAsyncBody=q})(U=e.Promises||(e.Promises={}));var z;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(z||(z={}));class K{constructor(V){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const q={emitOne:te=>this.emitOne(te),emitMany:te=>this.emitMany(te),reject:te=>this.reject(te)};try{await Promise.resolve(V(q)),this.resolve()}catch(te){this.reject(te)}finally{q.emitOne=void 0,q.emitMany=void 0,q.reject=void 0}})}static fromArray(V){return new K(q=>{q.emitMany(V)})}static fromPromise(V){return new K(async q=>{q.emitMany(await V)})}static fromPromises(V){return new K(async q=>{await Promise.all(V.map(async te=>q.emitOne(await te)))})}static merge(V){return new K(async q=>{await Promise.all(V.map(async te=>{for await(const fe of te)q.emitOne(fe)}))})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(V<this._results.length)return{done:!1,value:this._results[V++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(V,q){return new K(async te=>{for await(const fe of V)te.emitOne(q(fe))})}map(V){return K.map(this,V)}static filter(V,q){return new K(async te=>{for await(const fe of V)q(fe)&&te.emitOne(fe)})}filter(V){return K.filter(this,V)}static coalesce(V){return K.filter(V,q=>!!q)}coalesce(){return K.coalesce(this)}static async toPromise(V){const q=[];for await(const te of V)q.push(te);return q}toPromise(){return K.toPromise(this)}emitOne(V){this._state===0&&(this._results.push(V),this._onStateChanged.fire())}emitMany(V){this._state===0&&(this._results=this._results.concat(V),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(V){this._state===0&&(this._state=2,this._error=V,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class N extends K{constructor(V,q){super(q);this._source=V}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=N;function j(H){const V=new m.CancellationTokenSource,q=H(V.token);return new N(V,async te=>{const fe=V.token.onCancellationRequested(()=>{fe.dispose(),V.dispose(),te.reject((0,L.canceled)())});try{for await(const Ce of q){if(V.token.isCancellationRequested)return;te.emitOne(Ce)}fe.dispose(),V.dispose()}catch(Ce){fe.dispose(),V.dispose(),te.reject(Ce)}})}e.createCancelableAsyncIterable=j}),define(ge[99],pe([0,1,18,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new m.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),i=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,b,I=!1){const T=u||"",x=b||"",O=D.value.collator.compare(T,x);return D.value.collatorIsNumeric&&O===0&&T!==x?T<x?-1:1:O}e.compareFileNames=k;function S(u,b){const I=C.value.collator;return u=u||"",b=b||"",g(I,u,b)}e.compareFileNamesDefault=S;function y(u,b){const I=C.value.collator;return u=u||"",b=b||"",t(u,b)||g(I,u,b)}e.compareFileNamesUpper=y;function R(u,b){const I=C.value.collator;return u=u||"",b=b||"",n(u,b)||g(I,u,b)}e.compareFileNamesLower=R;function P(u,b){return u=u||"",b=b||"",u===b?0:u<b?-1:1}e.compareFileNamesUnicode=P;function a(u,b,I=!1){I||(u=u&&u.toLowerCase(),b=b&&b.toLowerCase());const[T,x]=o(u),[O,F]=o(b);return T!==O?T<O?-1:1:x===F?0:x<F?-1:1}e.noIntlCompareFileNames=a;function w(u,b){const[I,T]=o(u),[x,O]=o(b);let F=D.value.collator.compare(T,O);if(F===0){if(D.value.collatorIsNumeric&&T!==O)return T<O?-1:1;if(F=D.value.collator.compare(I,x),D.value.collatorIsNumeric&&F===0&&I!==x)return I<x?-1:1}return F}e.compareFileExtensions=w;function f(u,b){u=u||"",b=b||"";const I=r(u),T=r(b),x=C.value.collator,O=i.value.collator;return g(O,I,T)||g(x,u,b)}e.compareFileExtensionsDefault=f;function v(u,b){u=u||"",b=b||"";const I=r(u),T=r(b),x=C.value.collator,O=i.value.collator;return g(O,I,T)||t(u,b)||g(x,u,b)}e.compareFileExtensionsUpper=v;function _(u,b){u=u||"",b=b||"";const I=r(u),T=r(b),x=C.value.collator,O=i.value.collator;return g(O,I,T)||n(u,b)||g(x,u,b)}e.compareFileExtensionsLower=_;function A(u,b){u=u||"",b=b||"";const I=r(u).toLowerCase(),T=r(b).toLowerCase();return I!==T?I<T?-1:1:u!==b?u<b?-1:1:0}e.compareFileExtensionsUnicode=A;const p=/^(.*?)(\.([^.]*))?$/;function o(u,b=!1){const I=u?p.exec(u):[];let T=[I&&I[1]||"",I&&I[3]||""];return b&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function r(u){const b=u?p.exec(u):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function g(u,b,I){let T=u.compare(b,I);return T!==0?T:b.length!==I.length?b.length<I.length?-1:1:0}function c(u){const b=u.charAt(0);return b.toLocaleUpperCase()!==b}function E(u){const b=u.charAt(0);return b.toLocaleLowerCase()!==b}function n(u,b){return c(u)&&E(b)?-1:E(u)&&c(b)?1:0}function t(u,b){return E(u)&&c(b)?-1:c(u)&&E(b)?1:0}function s(u,b,I=!1){return I||(u=u&&u.toLowerCase(),b=b&&b.toLowerCase()),u===b?0:u<b?-1:1}function d(u,b,I=!1){const T=u.split(L.sep),x=b.split(L.sep),O=T.length-1,F=x.length-1;let W,M;for(let B=0;;B++){if(W=O===B,M=F===B,W&&M)return k(T[B],x[B],I);if(W)return-1;if(M)return 1;const U=s(T[B],x[B],I);if(U!==0)return U}}e.comparePaths=d;function l(u,b,I){const T=u.toLowerCase(),x=b.toLowerCase(),O=h(u,b,I);if(O)return O;const F=T.endsWith(I),W=x.endsWith(I);if(F!==W)return F?-1:1;const M=k(T,x);return M!==0?M:T.localeCompare(x)}e.compareAnything=l;function h(u,b,I){const T=u.toLowerCase(),x=b.toLowerCase(),O=T.startsWith(I),F=x.startsWith(I);if(O!==F)return O?-1:1;if(O&&F){if(T.length<x.length)return-1;if(T.length>x.length)return 1}return 0}e.compareByPrefix=h}),define(ge[100],pe([0,1,99,96,47,9,12,8]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,y=[S,[]];function R(U,z,K,N){if(!U||!z)return y;const j=U.length,H=z.length;if(j<H)return y;const V=U.toLowerCase();return P(z,K,H,U,V,j,N)}e.scoreFuzzy=R;function P(U,z,K,N,j,H,V){const q=[],te=[];for(let Ue=0;Ue<K;Ue++){const xe=Ue*H,ze=xe-H,Q=Ue>0,Z=U[Ue],re=z[Ue];for(let ue=0;ue<H;ue++){const J=ue>0,ie=xe+ue,we=ie-1,Me=ze+ue-1,je=J?q[we]:0,Ke=Q&&J?q[Me]:0,Ze=Q&&J?te[Me]:0;let rt;!Ke&&Q?rt=0:rt=a(Z,re,N,j,ue,Ze),rt&&Ke+rt>=je&&(V||Q||j.startsWith(z,ue))?(te[ie]=Ze+1,q[ie]=Ke+rt):(te[ie]=S,q[ie]=je)}}const fe=[];let Ce=K-1,ke=H-1;for(;Ce>=0&&ke>=0;){const Ue=Ce*H+ke;te[Ue]===S||(fe.push(ke),Ce--),ke--}return[q[K*H-1],fe.reverse()]}function a(U,z,K,N,j,H){let V=0;if(!w(z,N[j]))return V;if(V+=1,H>0&&(V+=H*5),U===K[j]&&(V+=1),j===0)V+=8;else{const q=f(K.charCodeAt(j-1));q?V+=q:(0,L.isUpper)(K.charCodeAt(j))&&H===0&&(V+=2)}return V}function w(U,z){return U===z?!0:U==="/"||U==="\\"?z==="/"||z==="\\":!1}function f(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function _(U,z,K=0,N=0){const j=z;return j.values&&j.values.length>1?A(U,j.values,K,N):p(U,z,K,N)}e.scoreFuzzy2=_;function A(U,z,K,N){let j=0;const H=[];for(const V of z){const[q,te]=p(U,V,K,N);if(typeof q!="number")return v;j+=q,H.push(...te)}return[j,h(H)]}function p(U,z,K,N){const j=(0,L.fuzzyScore)(z.original,z.originalLowercase,K,U,U.toLowerCase(),N,!0);return j?[j[0],(0,L.createMatches)(j)]:v}const o=Object.freeze({score:0}),r=1<<18,g=1<<17,c=1<<16;function E(U,z,K,N){const j=N.values?N.values:[N];return(0,D.hash)({[N.normalized]:{values:j.map(V=>({value:V.normalized,expectContiguousMatch:V.expectContiguousMatch})),label:U,description:z,allowNonContiguousMatches:K}})}function n(U,z,K,N,j){if(!U||!z.normalized)return o;const H=N.getItemLabel(U);if(!H)return o;const V=N.getItemDescription(U),q=E(H,V,K,z),te=j[q];if(te)return te;const fe=t(H,V,N.getItemPath(U),z,K);return j[q]=fe,fe}e.scoreItemFuzzy=n;function t(U,z,K,N,j){const H=!K||!N.containsPathSeparator;return K&&(i.isLinux?N.pathNormalized===K:(0,k.equalsIgnoreCase)(N.pathNormalized,K))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:N.values&&N.values.length>1?s(U,z,K,N.values,H,j):d(U,z,K,N,H,j)}function s(U,z,K,N,j,H){let V=0;const q=[],te=[];for(const fe of N){const{score:Ce,labelMatch:ke,descriptionMatch:Ue}=d(U,z,K,fe,j,H);if(Ce===S)return o;V+=Ce,ke&&q.push(...ke),Ue&&te.push(...Ue)}return{score:V,labelMatch:h(q),descriptionMatch:h(te)}}function d(U,z,K,N,j,H){if(j||!z){const[V,q]=R(U,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(V){const te=(0,L.matchesPrefix)(N.normalized,U);let fe;return te?(fe=g,fe+=Math.round(N.normalized.length/U.length*100)):fe=c,{score:fe+V,labelMatch:te||l(q)}}}if(z){let V=z;K&&(V=`${z}${C.sep}`);const q=V.length,te=`${V}${U}`,[fe,Ce]=R(te,N.normalized,N.normalizedLowercase,H&&!N.expectContiguousMatch);if(fe){const ke=l(Ce),Ue=[],xe=[];return ke.forEach(ze=>{ze.start<q&&ze.end>q?(Ue.push({start:0,end:ze.end-q}),xe.push({start:ze.start,end:q})):ze.start>=q?Ue.push({start:ze.start-q,end:ze.end-q}):xe.push(ze)}),{score:fe,labelMatch:Ue,descriptionMatch:xe}}}return o}function l(U){const z=[];if(!U)return z;let K;for(const N of U)K&&K.end===N?K.end+=1:(K={start:N,end:N+1},z.push(K));return z}function h(U){const z=U.sort((j,H)=>j.start-H.start),K=[];let N;for(const j of z)!N||!u(N,j)?(N=j,K.push(j)):(N.start=Math.min(N.start,j.start),N.end=Math.max(N.end,j.end));return K}function u(U,z){return!(U.end<z.start||z.end<U.start)}function b(U,z,K,N,j,H){const V=n(U,K,N,j,H),q=n(z,K,N,j,H),te=V.score,fe=q.score;if((te===r||fe===r)&&te!==fe)return te===r?-1:1;if(te>c||fe>c){if(te!==fe)return te>fe?-1:1;if(te<g&&fe<g){const Z=T(V.labelMatch,q.labelMatch);if(Z!==0)return Z}const ze=j.getItemLabel(U)||"",Q=j.getItemLabel(z)||"";if(ze.length!==Q.length)return ze.length-Q.length}if(te!==fe)return te>fe?-1:1;const Ce=Array.isArray(V.labelMatch)&&V.labelMatch.length>0,ke=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(Ce&&!ke)return-1;if(ke&&!Ce)return 1;const Ue=I(U,V,j),xe=I(z,q,j);return Ue&&xe&&Ue!==xe?xe>Ue?-1:1:x(U,z,K,j)}e.compareItemsByFuzzyScore=b;function I(U,z,K){let N=-1,j=-1;if(z.descriptionMatch&&z.descriptionMatch.length?N=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(N=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(j=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const H=K.getItemDescription(U);H&&(j+=H.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(j=z.descriptionMatch[z.descriptionMatch.length-1].end);return j-N}function T(U,z){if(!U&&!z||(!U||!U.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!U||!U.length)return 1;const K=U[0].start,j=U[U.length-1].end-K,H=z[0].start,q=z[z.length-1].end-H;return j===q?0:q<j?1:-1}function x(U,z,K,N){const j=N.getItemLabel(U)||"",H=N.getItemLabel(z)||"",V=N.getItemDescription(U),q=N.getItemDescription(z),te=j.length+(V?V.length:0),fe=H.length+(q?q.length:0);if(te!==fe)return te-fe;const Ce=N.getItemPath(U),ke=N.getItemPath(z);return Ce&&ke&&Ce.length!==ke.length?Ce.length-ke.length:j!==H?(0,m.compareAnything)(j,H,K.normalized):V&&q&&V!==q?(0,m.compareAnything)(V,q,K.normalized):Ce&&ke&&Ce!==ke?(0,m.compareAnything)(Ce,ke,K.normalized):0}function O(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function W(U){typeof U!="string"&&(U="");const z=U.toLowerCase(),{pathNormalized:K,normalized:N,normalizedLowercase:j}=M(U),H=K.indexOf(C.sep)>=0,V=O(U);let q;const te=U.split(F);if(te.length>1)for(const fe of te){const Ce=O(fe),{pathNormalized:ke,normalized:Ue,normalizedLowercase:xe}=M(fe);Ue&&(q||(q=[]),q.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:ke,normalized:Ue,normalizedLowercase:xe,expectContiguousMatch:Ce}))}return{original:U,originalLowercase:z,pathNormalized:K,normalized:N,normalizedLowercase:j,values:q,containsPathSeparator:H,expectContiguousMatch:V}}e.prepareQuery=W;function M(U){let z;i.isWindows?z=U.replace(/\//g,C.sep):z=U.replace(/\\/g,C.sep);const K=(0,k.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:K,normalizedLowercase:K.toLowerCase()}}function B(U){return Array.isArray(U)?W(U.map(z=>z.original).join(F)):W(U.original)}e.pieceToQuery=B}),define(ge[31],pe([0,1,18,30,24,9,8]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const S="**",y="/",R="[/\\\\]",P="[^/\\\\]",a=/\//g;function w(N){switch(N){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}|${R}${P}+)*?`}}function f(N,j){if(!N)return[];const H=[];let V=!1,q=!1,te="";for(const fe of N){switch(fe){case j:if(!V&&!q){H.push(te),te="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":q=!0;break;case"]":q=!1;break}te+=fe}return te&&H.push(te),H}e.splitGlobAware=f;function v(N){if(!N)return"";let j="";const H=f(N,y);if(H.every(V=>V===S))j=".*";else{let V=!1;H.forEach((q,te)=>{if(q===S){V||(j+=w(2),V=!0);return}let fe=!1,Ce="",ke=!1,Ue="";for(const xe of q){if(xe!=="}"&&fe){Ce+=xe;continue}if(ke&&(xe!=="]"||!Ue)){let ze;xe==="-"?ze=xe:(xe==="^"||xe==="!")&&!Ue?ze="^":xe===y?ze="":ze=i.escapeRegExpCharacters(xe),Ue+=ze;continue}switch(xe){case"{":fe=!0;continue;case"[":ke=!0;continue;case"}":j+=`(?:${f(Ce,",").map(Z=>v(Z)).join("|")})`,fe=!1,Ce="";break;case"]":j+="["+Ue+"]",ke=!1,Ue="";break;case"?":j+=P;continue;case"*":j+=w(1);continue;default:j+=i.escapeRegExpCharacters(xe)}}te<H.length-1&&(H[te+1]!==S||te+2<H.length)&&(j+=R),V=!1})}return j}const _=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new D.LRUCache(1e4),E=function(){return!1},n=function(){return null};function t(N,j){if(!N)return n;let H;typeof N!="string"?H=N.pattern:H=N,H=H.trim();const V=`${H}_${!!j.trimForExclusions}`;let q=c.get(V);if(q)return s(q,N);let te;if(_.test(H)){const fe=H.substr(4);q=function(Ce,ke){return typeof Ce=="string"&&Ce.endsWith(fe)?H:null}}else(te=A.exec(d(H,j)))?q=l(te[1],H):(j.trimForExclusions?o:p).test(H)?q=h(H,j):(te=r.exec(d(H,j)))?q=u(te[1].substr(1),H,!0):(te=g.exec(d(H,j)))?q=u(te[1],H,!1):q=b(H);return c.set(V,q),s(q,N)}function s(N,j){return typeof j=="string"?N:function(H,V){return L.isEqualOrParent(H,j.base)?N(C.relative(j.base,H),V):null}}function d(N,j){return j.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function l(N,j){const H=`/${N}`,V=`\\${N}`,q=function(fe,Ce){return typeof fe!="string"?null:Ce?Ce===N?j:null:fe===N||fe.endsWith(H)||fe.endsWith(V)?j:null},te=[N];return q.basenames=te,q.patterns=[j],q.allBasenames=te,q}function h(N,j){const H=K(N.slice(1,-1).split(",").map(Ce=>t(Ce,j)).filter(Ce=>Ce!==n),N),V=H.length;if(!V)return n;if(V===1)return H[0];const q=function(Ce,ke){for(let Ue=0,xe=H.length;Ue<xe;Ue++)if(H[Ue](Ce,ke))return N;return null},te=H.find(Ce=>!!Ce.allBasenames);te&&(q.allBasenames=te.allBasenames);const fe=H.reduce((Ce,ke)=>ke.allPaths?Ce.concat(ke.allPaths):Ce,[]);return fe.length&&(q.allPaths=fe),q}function u(N,j,H){const V=C.sep===C.posix.sep,q=V?N:N.replace(a,C.sep),te=C.sep+q,fe=C.posix.sep+N,Ce=H?function(ke,Ue){return typeof ke=="string"&&(ke===q||ke.endsWith(te)||!V&&(ke===N||ke.endsWith(fe)))?j:null}:function(ke,Ue){return typeof ke=="string"&&(ke===q||!V&&ke===N)?j:null};return Ce.allPaths=[(H?"*/":"./")+N],Ce}function b(N){try{const j=new RegExp(`^${v(N)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?N:null}}catch(j){return n}}function I(N,j,H){return!N||typeof j!="string"?!1:T(N)(j,void 0,H)}e.match=I;function T(N,j={}){if(!N)return E;if(typeof N=="string"||W(N)){const H=t(N,j);if(H===n)return E;const V=function(q,te){return!!H(q,te)};return H.allBasenames&&(V.allBasenames=H.allBasenames),H.allPaths&&(V.allPaths=H.allPaths),V}return U(N,j)}e.parse=T;function x(N){if(!N)return;let j;return H=>(j||(j=(N()||Promise.resolve([])).then(V=>V?F(V):{})),j.then(V=>!!V[H]))}e.hasSiblingPromiseFn=x;function O(N){if(!N)return;let j;return H=>{if(!j){const V=N();j=V?F(V):{}}return!!j[H]}}e.hasSiblingFn=O;function F(N){const j={};for(const H of N)j[H]=!0;return j}function W(N){const j=N;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=W;function M(N){return N.allBasenames||[]}e.getBasenameTerms=M;function B(N){return N.allPaths||[]}e.getPathTerms=B;function U(N,j){const H=K(Object.getOwnPropertyNames(N).map(Ce=>z(Ce,N[Ce],j)).filter(Ce=>Ce!==n)),V=H.length;if(!V)return n;if(!H.some(Ce=>!!Ce.requiresSiblings)){if(V===1)return H[0];const Ce=function(xe,ze){for(let Q=0,Z=H.length;Q<Z;Q++){const re=H[Q](xe,ze);if(re)return re}return null},ke=H.find(xe=>!!xe.allBasenames);ke&&(Ce.allBasenames=ke.allBasenames);const Ue=H.reduce((xe,ze)=>ze.allPaths?xe.concat(ze.allPaths):xe,[]);return Ue.length&&(Ce.allPaths=Ue),Ce}const q=function(Ce,ke,Ue){let xe;for(let ze=0,Q=H.length;ze<Q;ze++){const Z=H[ze];Z.requiresSiblings&&Ue&&(ke||(ke=C.basename(Ce)),xe||(xe=ke.substr(0,ke.length-C.extname(Ce).length)));const re=Z(Ce,ke,xe,Ue);if(re)return re}return null},te=H.find(Ce=>!!Ce.allBasenames);te&&(q.allBasenames=te.allBasenames);const fe=H.reduce((Ce,ke)=>ke.allPaths?Ce.concat(ke.allPaths):Ce,[]);return fe.length&&(q.allPaths=fe),q}function z(N,j,H){if(j===!1)return n;const V=t(N,H);if(V===n)return n;if(typeof j=="boolean")return V;if(j){const q=j.when;if(typeof q=="string"){const te=(fe,Ce,ke,Ue)=>{if(!Ue||!V(fe,Ce))return null;const xe=q.replace("$(basename)",ke),ze=Ue(xe);return(0,m.isThenable)(ze)?ze.then(Q=>Q?N:null):ze?N:null};return te.requiresSiblings=!0,te}}return V}function K(N,j){const H=N.filter(Ce=>!!Ce.basenames);if(H.length<2)return N;const V=H.reduce((Ce,ke)=>{const Ue=ke.basenames;return Ue?Ce.concat(Ue):Ce},[]);let q;if(j){q=[];for(let Ce=0,ke=V.length;Ce<ke;Ce++)q.push(j)}else q=H.reduce((Ce,ke)=>{const Ue=ke.patterns;return Ue?Ce.concat(Ue):Ce},[]);const te=function(Ce,ke){if(typeof Ce!="string")return null;if(!ke){let xe;for(xe=Ce.length;xe>0;xe--){const ze=Ce.charCodeAt(xe-1);if(ze===47||ze===92)break}ke=Ce.substr(xe)}const Ue=V.indexOf(ke);return Ue!==-1?q[Ue]:null};te.basenames=V,te.patterns=q,te.allBasenames=V;const fe=N.filter(Ce=>!Ce.basenames);return fe.push(te),fe}}),define(ge[80],pe([0,1,30,10,9,12,23,8,2]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(t,s,d){if(typeof t=="string"&&(t=S.URI.file(t)),d){const h=d.getWorkspaceFolder(t);if(h){const u=d.getWorkspace().folders.length>1;let b;if((0,i.isEqual)(h.uri,t)?b="":b=(0,i.relativePath)(h.uri,t),u){const I=h.name?h.name:(0,i.basename)(h.uri);b=b?I+" \u2022 "+b:I}return b}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,D.normalize)(P(t.fsPath));let l=(0,D.normalize)(t.fsPath);return!C.isWindows&&s?.userHome&&(l=w(l,s.userHome.fsPath)),l}e.getPathLabel=y;function R(t){if(!t)return;typeof t=="string"&&(t=S.URI.file(t));const s=(0,i.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(s)?P(s):s}e.getBaseLabel=R;function P(t,s){return(0,m.hasDriveLetter)(t,s)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=P;let a=Object.create(null);function w(t,s){if(C.isWindows||!t||!s)return t;let d=a.original===s?a.normalized:void 0;return d||(d=`${(0,k.rtrim)(s,D.posix.sep)}${D.posix.sep}`,a={original:s,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=w;function f(t,s){return t.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=f;const v="\u2026",_="\\\\",A="~";function p(t,s=D.sep){const d=new Array(t.length);let l=!1;for(let h=0;h<t.length;h++){let u=t[h];if(u===""){d[h]=`.${s}`;continue}if(!u){d[h]=u;continue}l=!0;let b="";u.indexOf(_)===0?(b=u.substr(0,u.indexOf(_)+_.length),u=u.substr(u.indexOf(_)+_.length)):u.indexOf(s)===0?(b=u.substr(0,u.indexOf(s)+s.length),u=u.substr(u.indexOf(s)+s.length)):u.indexOf(A)===0&&(b=u.substr(0,u.indexOf(A)+A.length),u=u.substr(u.indexOf(A)+A.length));const I=u.split(s);for(let T=1;l&&T<=I.length;T++)for(let x=I.length-T;l&&x>=0;x--){l=!1;let O=I.slice(x,x+T).join(s);for(let F=0;!l&&F<t.length;F++)if(F!==h&&t[F]&&t[F].indexOf(O)>-1){const W=x+T===I.length,M=x>0&&t[F].indexOf(s)>-1?s+O:O,B=t[F].endsWith(M);l=!W||B}if(!l){let F="";(I[0].endsWith(":")||b!=="")&&(x===1&&(x=0,T++,O=I[0]+s+O),x>0&&(F=I[0]+s),F=b+F),x>0&&(F=F+v+s),F=F+O,x+T<I.length&&(F=F+s+v),d[h]=F}}l&&(d[h]=u)}return d}e.shorten=p;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function r(t,s=Object.create(null)){const d=[];let l=!1,h="";for(const u of t)if(u==="$"||l&&u==="{")h&&d.push({value:h,type:o.TEXT}),h="",l=!0;else if(u==="}"&&l){const b=s[h];if(typeof b=="string")b.length&&d.push({value:b,type:o.VARIABLE});else if(b){const I=d[d.length-1];(!I||I.type!==o.SEPARATOR)&&d.push({value:b.label,type:o.SEPARATOR})}h="",l=!1}else h+=u;return h&&!l&&d.push({value:h,type:o.TEXT}),d.filter((u,b)=>{if(u.type===o.SEPARATOR){const I=d[b-1],T=d[b+1];return[I,T].every(x=>x&&(x.type===o.VARIABLE||x.type===o.TEXT)&&x.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=r;function g(t,s){return C.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function c(t,s){return C.isMacintosh||s?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function E(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=E;function n(t){const s=t.indexOf("/")!==-1?D.posix:D.win32,d=s.basename(t),l=s.dirname(t);return d.length?{name:d,parentPath:l}:{name:l,parentPath:""}}e.splitName=n}),define(ge[101],pe([0,1,31,10,9,23,8]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let S=[],y=[],R=[];function P(t,s=!1){const d=a(t);S.push(d),d.userConfigured?R.push(d):y.push(d),s&&!d.userConfigured&&S.forEach(l=>{l.mime===d.mime||l.userConfigured||(d.extension&&l.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&l.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&l.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&l.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=P;function a(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function w(t){t?(S=S.filter(s=>!s.userConfigured),R=[]):(S=[],y=[],R=[])}e.clearTextMimes=w;function f(t,s){let d;if(t)switch(t.scheme){case L.Schemas.file:d=t.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const l=(0,D.basename)(d),h=v(d,l,R);if(h)return[h,k.text];const u=v(d,l,y);if(u)return[u,k.text];if(s){const b=_(s);if(b)return[b,k.text]}return[k.unknown]}e.guessMimeTypes=f;function v(t,s,d){let l=null,h=null,u=null;for(let b=d.length-1;b>=0;b--){const I=d[b];if(s===I.filenameLowercase){l=I;break}if(I.filepattern&&(!h||I.filepattern.length>h.filepattern.length)){const T=I.filepatternOnPath?t:s;I.filepatternLowercase?.(T)&&(h=I)}I.extension&&(!u||I.extension.length>u.extension.length)&&s.endsWith(I.extensionLowercase)&&(u=I)}return l?l.mime:h?h.mime:u?u.mime:null}function _(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=S.length-1;s>=0;s--){const d=S[s];if(!d.firstline)continue;const l=t.match(d.firstline);if(l&&l.length>0)return d.mime}return null}function A(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&A(t[0]):!0}e.isUnspecific=A;const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const s=(0,D.extname)(t),d=p[s.toLowerCase()];return d!==void 0?d:g(t)}e.getMediaOrTextMime=r;function g(t){const s=(0,D.extname)(t);return o[s.toLowerCase()]}e.getMediaMime=g;function c(t){for(const s in o)if(o[s]===t)return s}e.getExtensionForMimeType=c;const E=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const d=E.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(ge[102],pe([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(R){return R.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const a=this._uriTransformer.transformIncoming(P);return a===P?P:L(m.URI.from(a))}transformOutgoing(P){const a=this._uriTransformer.transformOutgoing(P);return a===P?P:L(m.URI.from(a))}transformOutgoingURI(P){const a=this._uriTransformer.transformOutgoing(P);return a===P?P:m.URI.from(a)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function C(R,P,a){if(!R||a>200)return null;if(typeof R=="object"){if(R instanceof m.URI)return P.transformOutgoing(R);for(let w in R)if(Object.hasOwnProperty.call(R,w)){const f=C(R[w],P,a+1);f!==null&&(R[w]=f)}}return null}function i(R,P){const a=C(R,P,0);return a===null?R:a}e.transformOutgoingURIs=i;function k(R,P,a,w){if(!R||w>200)return null;if(typeof R=="object"){if(R.$mid===1)return a?m.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(let f in R)if(Object.hasOwnProperty.call(R,f)){const v=k(R[f],P,a,w+1);v!==null&&(R[f]=v)}}return null}function S(R,P){const a=k(R,P,!1,0);return a===null?R:a}e.transformIncomingURIs=S;function y(R,P){const a=k(R,P,!0,0);return a===null?R:a}e.transformAndReviveIncomingURIs=y}),define(ge[32],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return m.test(S)}e.isUUID=L;const D=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let y=0;y<S.length;y++)S[y]=Math.floor(Math.random()*256);return S};function k(){i(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,y="";return y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+="-",y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y+=C[D[S++]],y}e.generateUuid=k}),define(ge[142],pe([0,1,103]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const i=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return i;let S=0,y,R=S;for(;R<k.length;)if(y=k.charCodeAt(R),y===13||y===10){if(i.push(k.substring(S,R)),R++,R<k.length){const P=y;y=k.charCodeAt(R),(P===13&&y===10||P===10&&y===13)&&R++}S=R}else R++;return this.remaining=S<k.length?k.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(ge[28],pe([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function f(M,B=w.UNLINK){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===w.UNLINK?_(M):v(M)}async function v(M){try{const B=(0,S.join)((0,L.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(M,B)}catch(U){return _(M)}_(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function _(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function A(M){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=A;async function p(M,B){return g(await(B?o(M):(0,D.promisify)(m.readdir)(M)))}async function o(M){try{return await(0,D.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],U=await p(M);for(const z of U){let K=!1,N=!1,j=!1;try{const H=await e.Promises.lstat((0,S.join)(M,z));K=H.isFile(),N=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}B.push({name:z,isFile:()=>K,isDirectory:()=>N,isSymbolicLink:()=>j})}return B}function r(M){return g(m.readdirSync(M))}e.readdirSync=r;function g(M){return M.map(B=>typeof B=="string"?y.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=y.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function c(M){const B=await p(M),U=[];for(const z of B)await n.existsDirectory((0,S.join)(M,z))&&U.push(z);return U}function E(M,B=1e3){return new Promise(U=>{let z=!1;const K=setInterval(()=>{z||(z=!0,m.access(M,N=>{z=!1,N&&(clearInterval(K),U(void 0))}))},B)})}e.whenDeleted=E;var n;(function(M){async function B(K){let N;try{if(N=await e.Promises.lstat(K),!N.isSymbolicLink())return{stat:N}}catch(j){}try{return{stat:await e.Promises.stat(K),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(y.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw H}throw j}}M.stat=B;async function U(K){try{const{stat:N,symbolicLink:j}=await M.stat(K);return N.isFile()&&j?.dangling!==!0}catch(N){}return!1}M.existsFile=U;async function z(K){try{const{stat:N,symbolicLink:j}=await M.stat(K);return N.isDirectory()&&j?.dangling!==!0}catch(N){}return!1}M.existsDirectory=z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function s(M,B,U){return t.queueFor(P.URI.file(M),R.extUriBiasedIgnorePathCase).queue(()=>{const z=u(U);return new Promise((K,N)=>l(M,B,z,j=>j?N(j):K()))})}let d=!0;function l(M,B,U,z){if(!d)return m.writeFile(M,B,{mode:U.mode,flag:U.flag},z);m.open(M,U.flag,U.mode,(K,N)=>{if(K)return z(K);m.writeFile(N,B,j=>{if(j)return m.close(N,()=>z(j));m.fdatasync(N,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),d=!1),m.close(N,V=>z(V))))})})}function h(M,B,U){const z=u(U);if(!d)return m.writeFileSync(M,B,{mode:z.mode,flag:z.flag});const K=m.openSync(M,z.flag,z.mode);try{m.writeFileSync(K,B);try{m.fdatasyncSync(K)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),d=!1}}finally{m.closeSync(K)}}e.writeFileSync=h;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function b(M,B){if(M===B)return;async function U(z){try{const K=await e.Promises.lstat(z);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(z,K.atime,new Date)}catch(K){}}try{await e.Promises.rename(M,B),await U(B)}catch(z){if(M.toLowerCase()!==B.toLowerCase()&&z.code==="EXDEV"||M.endsWith("."))await I(M,B,{preserveSymlinks:!1}),await f(M,w.MOVE),await U(B);else throw z}}async function I(M,B,U){return x(M,B,{root:{source:M,target:B},options:U,handledSourcePaths:new Set})}const T=511;async function x(M,B,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:z,symbolicLink:K}=await n.stat(M);if(K){if(U.options.preserveSymlinks)try{return await W(M,B,U)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(K.dangling)return}return z.isDirectory()?O(M,B,z.mode&T,U):F(M,B,z.mode&T)}async function O(M,B,U,z){await e.Promises.mkdir(B,{recursive:!0,mode:U});const K=await p(M);for(const N of K)await x((0,S.join)(M,N),(0,S.join)(B,N),z)}async function F(M,B,U){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,U)}async function W(M,B,U){let z=await e.Promises.readlink(M);(0,i.isEqualOrParent)(z,U.root.source,!y.isLinux)&&(z=(0,S.join)(U.root.target,z.substr(U.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,D.promisify)(m.access)}get stat(){return(0,D.promisify)(m.stat)}get lstat(){return(0,D.promisify)(m.lstat)}get utimes(){return(0,D.promisify)(m.utimes)}get read(){return(0,D.promisify)(m.read)}get readFile(){return(0,D.promisify)(m.readFile)}get write(){return(0,D.promisify)(m.write)}get appendFile(){return(0,D.promisify)(m.appendFile)}get fdatasync(){return(0,D.promisify)(m.fdatasync)}get truncate(){return(0,D.promisify)(m.truncate)}get rename(){return(0,D.promisify)(m.rename)}get copyFile(){return(0,D.promisify)(m.copyFile)}get open(){return(0,D.promisify)(m.open)}get close(){return(0,D.promisify)(m.close)}get symlink(){return(0,D.promisify)(m.symlink)}get readlink(){return(0,D.promisify)(m.readlink)}get chmod(){return(0,D.promisify)(m.chmod)}get mkdir(){return(0,D.promisify)(m.mkdir)}get unlink(){return(0,D.promisify)(m.unlink)}get rmdir(){return(0,D.promisify)(m.rmdir)}get realpath(){return(0,D.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return s}get rm(){return f}get move(){return b}get copy(){return I}}}),define(ge[104],pe([0,1,60,9,8,28]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(R){const P=(0,L.dirname)(R);if(R===P)return R;const a=((0,L.basename)(R)||R).toLowerCase();try{const f=(0,C.readdirSync)(P).filter(v=>v.toLowerCase()===a);if(f.length===1){const v=i(P);if(v)return(0,L.join)(v,f[0])}else if(f.length>1){const v=f.indexOf(a);if(v>=0){const _=i(P);if(_)return(0,L.join)(_,f[v])}}}catch(w){}return null}e.realcaseSync=i;async function k(R){try{return await C.Promises.realpath(R)}catch(P){const a=y(R);return await C.Promises.access(a,m.constants.R_OK),a}}e.realpath=k;function S(R){try{return m.realpathSync(R)}catch(P){const a=y(R);return m.accessSync(a,m.constants.R_OK),a}}e.realpathSync=S;function y(R){return(0,D.rtrim)((0,L.normalize)(R),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,m,L){var D=arguments.length,C=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,L);else for(var k=Y.length-1;k>=0;k--)(i=Y[k])&&(C=(D<3?i(C):D>3?i(e,m,C):i(e,m))||C);return D>3&&C&&Object.defineProperty(e,m,C),C};define(ge[105],pe([0,1,17,18,22,21,57,15,3,6,59,8,13]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function f(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(A||(A={}));class p{constructor(N){this.buffer=N,this.pos=0}read(N){const j=this.buffer.slice(this.pos,this.pos+N);return this.pos+=j.byteLength,j}}class o{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var r;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object"})(r||(r={}));function g(K){const N=D.VSBuffer.alloc(4);return N.writeUInt32BE(K,0),N}function c(K){return K.read(4).readUInt32BE(0)}function E(K){const N=D.VSBuffer.alloc(1);return N.writeUInt8(K,0),N}const n={Undefined:E(r.Undefined),String:E(r.String),Buffer:E(r.Buffer),VSBuffer:E(r.VSBuffer),Array:E(r.Array),Object:E(r.Object)},t=typeof Buffer!="undefined";function s(K,N){if(typeof N=="undefined")K.write(n.Undefined);else if(typeof N=="string"){const j=D.VSBuffer.fromString(N);K.write(n.String),K.write(g(j.byteLength)),K.write(j)}else if(t&&Buffer.isBuffer(N)){const j=D.VSBuffer.wrap(N);K.write(n.Buffer),K.write(g(j.byteLength)),K.write(j)}else if(N instanceof D.VSBuffer)K.write(n.VSBuffer),K.write(g(N.byteLength)),K.write(N);else if(Array.isArray(N)){K.write(n.Array),K.write(g(N.length));for(const j of N)s(K,j)}else{const j=D.VSBuffer.fromString(JSON.stringify(N));K.write(n.Object),K.write(g(j.byteLength)),K.write(j)}}function d(K){switch(K.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return K.read(c(K)).toString();case r.Buffer:return K.read(c(K)).buffer;case r.VSBuffer:return K.read(c(K));case r.Array:{const j=c(K),H=[];for(let V=0;V<j;V++)H.push(d(K));return H}case r.Object:return JSON.parse(K.read(c(K)).toString())}}class l{constructor(N,j,H=null,V=1e3){this.protocol=N,this.ctx=j,this.logger=H,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(q=>this.onRawMessage(q)),this.sendResponse({type:200})}registerChannel(N,j){this.channels.set(N,j),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const j=this.send([N.type]);this.logger&&this.logger.logOutgoing(j,0,1,_(N.type));return}case 201:case 202:case 204:case 203:{const j=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(j,N.id,1,_(N.type),N.data);return}}}send(N,j=void 0){const H=new o;return s(H,N),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onRawMessage(N){const j=new p(N),H=d(j),V=d(j),q=H[0];switch(q){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}: ${H[2]}.${H[3]}`,V),this.onPromise({type:q,id:H[1],channelName:H[2],name:H[3],arg:V});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}: ${H[2]}.${H[3]}`,V),this.onEventListen({type:q,id:H[1],channelName:H[2],name:H[3],arg:V});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:H[1]})}}onPromise(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const H=new C.CancellationTokenSource;let V;try{V=j.call(this.ctx,N.name,N.arg,H.token)}catch(fe){V=Promise.reject(fe)}const q=N.id;V.then(fe=>{this.sendResponse({id:q,data:fe,type:201}),this.activeRequests.delete(N.id)},fe=>{fe instanceof Error?this.sendResponse({id:q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:q,data:fe,type:203}),this.activeRequests.delete(N.id)});const te=(0,y.toDisposable)(()=>H.cancel());this.activeRequests.set(N.id,te)}onEventListen(N){const j=this.channels.get(N.channelName);if(!j){this.collectPendingRequest(N);return}const H=N.id,q=j.listen(this.ctx,N.name,N.arg)(te=>this.sendResponse({id:H,data:te,type:204}));this.activeRequests.set(N.id,q)}disposeActiveRequest(N){const j=this.activeRequests.get(N.id);j&&(j.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let j=this.pendingRequests.get(N.channelName);j||(j=[],this.pendingRequests.set(N.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:N,timeoutTimer:H})}flushPendingRequests(N){const j=this.pendingRequests.get(N);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var h;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(N,j=null){this.protocol=N,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(N){const j=this;return{call(H,V,q){return j.isDisposed?Promise.reject(k.canceled()):j.requestPromise(N,H,V,q)},listen(H,V){return j.isDisposed?Promise.reject(k.canceled()):j.requestEvent(N,H,V)}}}requestPromise(N,j,H,V=C.CancellationToken.None){const q=this.lastRequestId++,fe={id:q,type:100,channelName:N,name:j,arg:H};if(V.isCancellationRequested)return Promise.reject(k.canceled());let Ce;return new Promise((Ue,xe)=>{if(V.isCancellationRequested)return xe(k.canceled());const ze=()=>{const ue=J=>{switch(J.type){case 201:this.handlers.delete(q),Ue(J.data);break;case 202:this.handlers.delete(q);const ie=new Error(J.data.message);ie.stack=J.data.stack,ie.name=J.data.name,xe(ie);break;case 203:this.handlers.delete(q),xe(J.data);break}};this.handlers.set(q,ue),this.sendRequest(fe)};let Q=null;this.state===A.Idle?ze():(Q=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),Q.then(()=>{Q=null,ze()}));const Z=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:q,type:101}),xe(k.canceled())},re=V.onCancellationRequested(Z);Ce=(0,y.combinedDisposable)((0,y.toDisposable)(Z),re),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(N,j,H){const V=this.lastRequestId++,te={id:V,type:102,channelName:N,name:j,arg:H};let fe=null;const Ce=new S.Emitter({onFirstListenerAdd:()=>{fe=(0,L.createCancelablePromise)(Ue=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(Ce),this.sendRequest(te)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(Ce),this.sendRequest({id:V,type:103}))}}),ke=Ue=>Ce.fire(Ue.data);return this.handlers.set(V,ke),Ce.event}sendRequest(N){switch(N.type){case 100:case 102:{const j=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(j,N.id,0,`${f(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const j=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(j,N.id,0,f(N.type));return}}}send(N,j=void 0){const H=new o;return s(H,N),s(H,j),this.sendBuffer(H.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(j){return 0}}onBuffer(N){const j=new p(N),H=d(j),V=d(j),q=H[0];switch(q){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,_(q)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,H[1],0,_(q),V),this.onResponse({type:H[0],id:H[1],data:V})}}onResponse(N){if(N.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(N.id);j&&j(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}Ve([i.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class b{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:j,onDidClientDisconnect:H})=>{S.Event.once(j.onMessage)(q=>{const te=new p(q),fe=d(te),Ce=new l(j,fe),ke=new u(j);this.channels.forEach((xe,ze)=>Ce.registerChannel(ze,xe));const Ue={channelServer:Ce,channelClient:ke,ctx:fe};this._connections.add(Ue),this._onDidAddConnection.fire(Ue),H(()=>{Ce.dispose(),ke.dispose(),this._connections.delete(Ue),this._onDidRemoveConnection.fire(Ue)})})})}get connections(){const N=[];return this._connections.forEach(j=>N.push(j)),N}getChannel(N,j){const H=this;return{call(V,q,te){let fe;if((0,a.isFunction)(j)){let ke=(0,m.getRandomElement)(H.connections.filter(j));fe=ke?Promise.resolve(ke):S.Event.toPromise(S.Event.filter(H.onDidAddConnection,j))}else fe=j.routeCall(H,V,q);const Ce=fe.then(ke=>ke.channelClient.getChannel(N));return T(Ce).call(V,q,te)},listen(V,q){if((0,a.isFunction)(j))return H.getMulticastEvent(N,j,V,q);const te=j.routeEvent(H,V,q).then(fe=>fe.channelClient.getChannel(N));return T(te).listen(V,q)}}}getMulticastEvent(N,j,H,V){const q=this;let te=new y.DisposableStore;const fe=new S.Emitter({onFirstListenerAdd:()=>{te=new y.DisposableStore;const Ce=new S.EventMultiplexer,ke=new Map,Ue=ze=>{const Z=ze.channelClient.getChannel(N).listen(H,V),re=Ce.add(Z);ke.set(ze,re)},xe=ze=>{const Q=ke.get(ze);!Q||(Q.dispose(),ke.delete(ze))};q.connections.filter(j).forEach(Ue),S.Event.filter(q.onDidAddConnection,j)(Ue,void 0,te),q.onDidRemoveConnection(xe,void 0,te),Ce.event(fe.fire,fe,te),te.add(Ce)},onLastListenerRemove:()=>{te.dispose()}});return fe.event}registerChannel(N,j){this.channels.set(N,j),this._connections.forEach(H=>{H.channelServer.registerChannel(N,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class I{constructor(N,j,H=null){const V=new o;s(V,j),N.send(V.buffer),this.channelClient=new u(N,H),this.channelServer=new l(N,j,H)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,j){this.channelServer.registerChannel(N,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=I;function T(K){return{call(N,j,H){return K.then(V=>V.call(N,j,H))},listen(N,j){const H=new S.Relay;return K.then(V=>H.input=V.listen(N,j)),H.event}}}e.getDelayedChannel=T;function x(K){let N=!1;return{call(j,H,V){return N?K.call(j,H,V):(0,L.timeout)(0).then(()=>N=!0).then(()=>K.call(j,H,V))},listen(j,H){if(N)return K.listen(j,H);const V=new S.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>V.input=K.listen(j,H)),V.event}}}e.getNextTickChannel=x;class O{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const j of N.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=O;var F;(function(K){function N(q,te){const fe=q,Ce=te&&te.disableMarshalling,ke=new Map;for(const Ue in fe)H(Ue)&&ke.set(Ue,S.Event.buffer(fe[Ue],!0));return new class{listen(Ue,xe,ze){const Q=ke.get(xe);if(Q)return Q;if(V(xe)){const Z=fe[xe];if(typeof Z=="function")return Z.call(fe,ze)}throw new Error(`Event not found: ${xe}`)}call(Ue,xe,ze){const Q=fe[xe];if(typeof Q=="function"){if(!Ce&&Array.isArray(ze))for(let Z=0;Z<ze.length;Z++)ze[Z]=(0,R.revive)(ze[Z]);return Q.apply(fe,ze)}throw new Error(`Method not found: ${xe}`)}}}K.fromService=N;function j(q,te){const fe=te&&te.disableMarshalling;return new Proxy({},{get(Ce,ke){if(typeof ke=="string")return te?.properties?.has(ke)?te.properties.get(ke):V(ke)?function(Ue){return q.listen(ke,Ue)}:H(ke)?q.listen(ke):async function(...Ue){let xe;te&&!(0,a.isUndefinedOrNull)(te.context)?xe=[te.context,...Ue]:xe=Ue;const ze=await q.call(ke,xe);return fe?ze:(0,R.revive)(ze)};throw new Error(`Property not found: ${String(ke)}`)}})}K.toService=j;function H(q){return q[0]==="o"&&q[1]==="n"&&P.isUpperAsciiLetter(q.charCodeAt(2))}function V(q){return/^onDynamic/.test(q)&&P.isUpperAsciiLetter(q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){let N=K.toString();if(N!=="[object Object]")return N}return K}function B(K){return Array.isArray(K)?K.map(M):M(K)}function U(K,N,j,H,V,q,te){te=B(te);const fe=W[V],Ce=fe[H%fe.length];let ke=[`%c[${K}]%c[${String(N).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(q)?(ke=ke.concat(te),ke.push(")")):ke.push(te),console.log.apply(console,ke)}e.logWithColors=U;class z{constructor(N,j){this._outgoingPrefix=N,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,j,H,V,q){this._totalOutgoing+=N,U(this._outgoingPrefix,this._totalOutgoing,N,j,H,V,q)}logIncoming(N,j,H,V,q){this._totalIncoming+=N,U(this._incomingPrefix,this._totalIncoming,N,j,H,V,q)}}e.IPCLogger=z}),define(ge[106],pe([0,1,22,3,6,105]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var i;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(i=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let d=0;function l(u,b){if(!s.has(u)){const I=String(++d);s.set(u,I)}return s.get(u)}function h(u,b,I,T){if(!t.enableDiagnostics)return;const x=l(u,b);if(T instanceof m.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const O=m.VSBuffer.alloc(T.byteLength);O.set(T),t.records.push({timestamp:Date.now(),id:x,label:b,type:I,buff:O})}else t.records.push({timestamp:Date.now(),id:x,label:b,type:I,data:T})}t.traceSocketEvent=h})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function R(){return y||(y=m.VSBuffer.alloc(0)),y}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,d){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const b=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=s),b}if(this._chunks[0].byteLength>s){const b=this._chunks[0].slice(0,s);return d&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),b}let l=m.VSBuffer.alloc(s),h=0,u=0;for(;s>0;){const b=this._chunks[u];if(b.byteLength>s){const I=b.slice(0,s);l.set(I,h),h+=s,d&&(this._chunks[u]=b.slice(s),this._totalLength-=s),s-=s}else l.set(b,h),h+=b.byteLength,d?(this._chunks.shift(),this._totalLength-=b.byteLength):u++,s-=b.byteLength}return l}}e.ChunkStream=P;var a;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(a||(a={}));function w(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var f;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(s,d,l,h){this.type=s,this.id=d,this.ack=l,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class _ extends D.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:w(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,h=this._state.id,u=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new v(l,h,u,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class A{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=m.VSBuffer.alloc(13);d.writeUInt8(s.type,0),d.writeUInt32BE(s.id,1),d.writeUInt32BE(s.ack,5),d.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:w(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(d,s.data)}_bufferAdd(s,d){const l=this._totalLength===0;return this._data.push(s,d),this._totalLength+=s.byteLength+d.byteLength,l}_bufferTake(){const s=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,d){this._bufferAdd(s,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class p extends D.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new A(this._socket)),this._socketReader=this._register(new _(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new v(1,0,0,s))}}e.Protocol=p;class o extends C.IPCClient{constructor(s,d,l=null){super(s,d,l);this.protocol=s}static fromSocket(s,d){return new o(new p(s),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=o;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class g{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],d=0,l=this._first;for(;l;)s[d++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const d=new g(s);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class E{constructor(){this.lastRuns=[];const s=Date.now();for(let d=0;d<E._HISTORY_LENGTH;d++)this.lastRuns[d]=s-1e3*d;setInterval(()=>{for(let d=E._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const s=Date.now(),d=(1+E._HISTORY_LENGTH)*1e3;let l=0;for(let h=0;h<E._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=d&&l++;return 1-l/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class n{constructor(s,d=null,l=E.getInstance()){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new _(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),d&&this._socketReader.acceptChunk(d)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new v(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new v(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new v(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,d){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new _(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let d=0,l=s.length;d<l;d++)this._socketWriter.write(s[d]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new v(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let l=0,h=d.length;l<h;l++)this._socketWriter.write(d[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new v(1,d,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const d=new v(2,0,0,s);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),d=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime;if(d>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-d,500))}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,R());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ge[107],pe([0,1,98]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let S=(0,m.toUint8)(k);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){let S=new Uint8Array(256);for(let y=0;y<256;y++)S[y]=k;return S}set(k,S){let y=(0,m.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=y:this._map.set(k,y)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var D;(function(i){i[i.False=0]="False",i[i.True=1]="True"})(D||(D={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(ge[143],pe([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(i){i[i.Regular=0]="Regular",i[i.Whitespace=1]="Whitespace",i[i.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends m.CharacterClassifier{constructor(k){super(0);for(let S=0,y=k.length;S<y;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function C(i){let k={};return S=>(k.hasOwnProperty(S)||(k[S]=i(S)),k[S])}e.getMapForWordSeparators=C(i=>new D(i))}),define(ge[49],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(D,C){this.lineNumber=D,this.column=C}with(D=this.lineNumber,C=this.column){return D===this.lineNumber&&C===this.column?this:new m(D,C)}delta(D=0,C=0){return this.with(this.lineNumber+D,this.column+C)}equals(D){return m.equals(this,D)}static equals(D,C){return!D&&!C?!0:!!D&&!!C&&D.lineNumber===C.lineNumber&&D.column===C.column}isBefore(D){return m.isBefore(this,D)}static isBefore(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<C.column}isBeforeOrEqual(D){return m.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,C){return D.lineNumber<C.lineNumber?!0:C.lineNumber<D.lineNumber?!1:D.column<=C.column}static compare(D,C){let i=D.lineNumber|0,k=C.lineNumber|0;if(i===k){let S=D.column|0,y=C.column|0;return S-y}return i-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new m(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=m}),define(ge[41],pe([0,1,49]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,i,k,S){C>k||C===k&&i>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=C,this.endColumn=i):(this.startLineNumber=C,this.startColumn=i,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<C.startColumn||i.lineNumber===C.endLineNumber&&i.column>C.endColumn)}static strictContainsPosition(C,i){return!(i.lineNumber<C.startLineNumber||i.lineNumber>C.endLineNumber||i.lineNumber===C.startLineNumber&&i.column<=C.startColumn||i.lineNumber===C.endLineNumber&&i.column>=C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,i){return!(i.startLineNumber<C.startLineNumber||i.endLineNumber<C.startLineNumber||i.startLineNumber>C.endLineNumber||i.endLineNumber>C.endLineNumber||i.startLineNumber===C.startLineNumber&&i.startColumn<=C.startColumn||i.endLineNumber===C.endLineNumber&&i.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,i){let k,S,y,R;return i.startLineNumber<C.startLineNumber?(k=i.startLineNumber,S=i.startColumn):i.startLineNumber===C.startLineNumber?(k=i.startLineNumber,S=Math.min(i.startColumn,C.startColumn)):(k=C.startLineNumber,S=C.startColumn),i.endLineNumber>C.endLineNumber?(y=i.endLineNumber,R=i.endColumn):i.endLineNumber===C.endLineNumber?(y=i.endLineNumber,R=Math.max(i.endColumn,C.endColumn)):(y=C.endLineNumber,R=C.endColumn),new L(k,S,y,R)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,i){let k=C.startLineNumber,S=C.startColumn,y=C.endLineNumber,R=C.endColumn,P=i.startLineNumber,a=i.startColumn,w=i.endLineNumber,f=i.endColumn;return k<P?(k=P,S=a):k===P&&(S=Math.max(S,a)),y>w?(y=w,R=f):y===w&&(R=Math.min(R,f)),k>y||k===y&&S>R?null:new L(k,S,y,R)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,i){return!!C&&!!i&&C.startLineNumber===i.startLineNumber&&C.startColumn===i.startColumn&&C.endLineNumber===i.endLineNumber&&C.endColumn===i.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,i){return new L(this.startLineNumber,this.startColumn,C,i)}setStartPosition(C,i){return new L(C,i,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,i=C){return new L(C.lineNumber,C.column,i.lineNumber,i.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<C.startColumn)}static areIntersecting(C,i){return!(C.endLineNumber<i.startLineNumber||C.endLineNumber===i.startLineNumber&&C.endColumn<=i.startColumn||i.endLineNumber<C.startLineNumber||i.endLineNumber===C.startLineNumber&&i.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,i){if(C&&i){const y=C.startLineNumber|0,R=i.startLineNumber|0;if(y===R){const P=C.startColumn|0,a=i.startColumn|0;if(P===a){const w=C.endLineNumber|0,f=i.endLineNumber|0;if(w===f){const v=C.endColumn|0,_=i.endColumn|0;return v-_}return w-f}return P-a}return y-R}return(C?1:0)-(i?1:0)}static compareRangesUsingEnds(C,i){return C.endLineNumber===i.endLineNumber?C.endColumn===i.endColumn?C.startLineNumber===i.startLineNumber?C.startColumn-i.startColumn:C.startLineNumber-i.startLineNumber:C.endColumn-i.endColumn:C.endLineNumber-i.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(ge[144],pe([0,1,49,41]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,S,y,R){super(k,S,y,R);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,S):new C(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new C(k,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new C(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let y=0,R=k.length;y<R;y++)if(!this.selectionsEqual(k[y],S[y]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,y,R,P){return P===0?new C(k,S,y,R):new C(y,R,k,S)}}e.Selection=C}),define(ge[108],pe([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var i;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(i=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class y{constructor(o,r){this._findMatchBrand=void 0,this.range=o,this.matches=r}}e.FindMatch=y;var R;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var P;(function(p){p[p.Disabled=0]="Disabled",p[p.EnabledForActive=1]="EnabledForActive",p[p.Enabled=2]="Enabled"})(P=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(o,r,g){this.visibleColumn=o,this.className=r,this.horizontalLine=g}}e.IndentGuide=a;class w{constructor(o,r){this.top=o,this.endColumn=r}}e.IndentGuideHorizontalLine=w;var f;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class _{constructor(o,r,g,c,E,n){this.identifier=o,this.range=r,this.text=g,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=E,this._isTracked=n}}e.ValidAnnotatedEditOperation=_;class A{constructor(o,r,g){this.reverseEdits=o,this.changes=r,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=A}),define(ge[145],pe([0,1,8,143,49,41,108]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(o,r,g,c){this.searchString=o,this.isRegex=r,this.matchCase=g,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=y(this.searchString):o=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(c){return null}if(!r)return null;let g=!this.isRegex&&!o;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new R(r,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function y(p){if(!p||p.length===0)return!1;for(let o=0,r=p.length;o<r;o++)if(p.charCodeAt(o)===92){if(o++,o>=r)break;const c=p.charCodeAt(o);if(c===110||c===114||c===87)return!0}return!1}e.isMultilineRegexSource=y;class R{constructor(o,r,g){this.regex=o,this.wordSeparators=r,this.simpleSearch=g}}e.SearchData=R;function P(p,o,r){if(!r)return new i.FindMatch(p,null);let g=[];for(let c=0,E=o.length;c<E;c++)g[c]=o[c];return new i.FindMatch(p,g)}e.createFindMatch=P;class a{constructor(o){let r=[],g=0;for(let c=0,E=o.length;c<E;c++)o.charCodeAt(c)===10&&(r[g++]=c);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(o){const r=this._lineFeedsOffsets;let g=0,c=r.length-1;if(c===-1||o<=r[0])return 0;for(;g<c;){const E=g+((c-g)/2>>0);r[E]>=o?c=E-1:r[E+1]>=o?(g=E,c=E):g=E+1}return g+1}}class w{static findMatches(o,r,g,c,E){const n=r.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(o,g,new A(n.wordSeparators,n.regex),c,E):this._doFindMatchesLineByLine(o,g,n,c,E):[]}static _getMultilineMatchRange(o,r,g,c,E,n){let t,s=0;c?(s=c.findLineFeedCountBeforeOffset(E),t=r+E+s):t=r+E;let d;if(c){let b=c.findLineFeedCountBeforeOffset(E+n.length)-s;d=t+n.length+b}else d=t+n.length;const l=o.getPositionAt(t),h=o.getPositionAt(d);return new C.Range(l.lineNumber,l.column,h.lineNumber,h.column)}static _doFindMatchesMultiline(o,r,g,c,E){const n=o.getOffsetAt(r.getStartPosition()),t=o.getValueInRange(r,1),s=o.getEOL()===`\r
`?new a(t):null,d=[];let l=0,h;for(g.reset(0);h=g.next(t);)if(d[l++]=P(this._getMultilineMatchRange(o,n,t,s,h.index,h[0]),h,c),l>=E)return d;return d}static _doFindMatchesLineByLine(o,r,g,c,E){const n=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=o.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(g,d,r.startLineNumber,r.startColumn-1,t,n,c,E),n}const s=o.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(g,s,r.startLineNumber,r.startColumn-1,t,n,c,E);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<E;d++)t=this._findMatchesInLine(g,o.getLineContent(d),d,0,t,n,c,E);if(t<E){const d=o.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(g,d,r.endLineNumber,0,t,n,c,E)}return n}static _findMatchesInLine(o,r,g,c,E,n,t,s){const d=o.wordSeparators;if(!t&&o.simpleSearch){const u=o.simpleSearch,b=u.length,I=r.length;let T=-b;for(;(T=r.indexOf(u,T+b))!==-1;)if((!d||_(d,r,I,T,b))&&(n[E++]=new i.FindMatch(new C.Range(g,T+1+c,g,T+1+b+c),null),E>=s))return E;return E}const l=new A(o.wordSeparators,o.regex);let h;l.reset(0);do if(h=l.next(r),h&&(n[E++]=P(new C.Range(g,h.index+1+c,g,h.index+1+h[0].length+c),h,t),E>=s))return E;while(h);return E}static findNextMatch(o,r,g,c){const E=r.parseSearchRequest();if(!E)return null;const n=new A(E.wordSeparators,E.regex);return E.regex.multiline?this._doFindNextMatchMultiline(o,g,n,c):this._doFindNextMatchLineByLine(o,g,n,c)}static _doFindNextMatchMultiline(o,r,g,c){const E=new D.Position(r.lineNumber,1),n=o.getOffsetAt(E),t=o.getLineCount(),s=o.getValueInRange(new C.Range(E.lineNumber,E.column,t,o.getLineMaxColumn(t)),1),d=o.getEOL()===`\r
`?new a(s):null;g.reset(r.column-1);let l=g.next(s);return l?P(this._getMultilineMatchRange(o,n,s,d,l.index,l[0]),l,c):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(o,new D.Position(1,1),g,c):null}static _doFindNextMatchLineByLine(o,r,g,c){const E=o.getLineCount(),n=r.lineNumber,t=o.getLineContent(n),s=this._findFirstMatchInLine(g,t,n,r.column,c);if(s)return s;for(let d=1;d<=E;d++){const l=(n+d-1)%E,h=o.getLineContent(l+1),u=this._findFirstMatchInLine(g,h,l+1,1,c);if(u)return u}return null}static _findFirstMatchInLine(o,r,g,c,E){o.reset(c-1);const n=o.next(r);return n?P(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,E):null}static findPreviousMatch(o,r,g,c){const E=r.parseSearchRequest();if(!E)return null;const n=new A(E.wordSeparators,E.regex);return E.regex.multiline?this._doFindPreviousMatchMultiline(o,g,n,c):this._doFindPreviousMatchLineByLine(o,g,n,c)}static _doFindPreviousMatchMultiline(o,r,g,c){const E=this._doFindMatchesMultiline(o,new C.Range(1,1,r.lineNumber,r.column),g,c,10*k);if(E.length>0)return E[E.length-1];const n=o.getLineCount();return r.lineNumber!==n||r.column!==o.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(o,new D.Position(n,o.getLineMaxColumn(n)),g,c):null}static _doFindPreviousMatchLineByLine(o,r,g,c){const E=o.getLineCount(),n=r.lineNumber,t=o.getLineContent(n).substring(0,r.column-1),s=this._findLastMatchInLine(g,t,n,c);if(s)return s;for(let d=1;d<=E;d++){const l=(E+n-d-1)%E,h=o.getLineContent(l+1),u=this._findLastMatchInLine(g,h,l+1,c);if(u)return u}return null}static _findLastMatchInLine(o,r,g,c){let E=null,n;for(o.reset(0);n=o.next(r);)E=P(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,c);return E}}e.TextModelSearch=w;function f(p,o,r,g,c){if(g===0)return!0;const E=o.charCodeAt(g-1);if(p.get(E)!==0||E===13||E===10)return!0;if(c>0){const n=o.charCodeAt(g);if(p.get(n)!==0)return!0}return!1}function v(p,o,r,g,c){if(g+c===r)return!0;const E=o.charCodeAt(g+c);if(p.get(E)!==0||E===13||E===10)return!0;if(c>0){const n=o.charCodeAt(g+c-1);if(p.get(n)!==0)return!0}return!1}function _(p,o,r,g,c){return f(p,o,r,g,c)&&v(p,o,r,g,c)}e.isValidMatch=_;class A{constructor(o,r){this._wordSeparators=o,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const r=o.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(g=this._searchRegex.exec(o),!g))return null;const c=g.index,E=g[0].length;if(c===this._prevMatchStartIndex&&E===this._prevMatchLength){if(E===0){m.getNextCodePoint(o,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=c,this._prevMatchLength=E,!this._wordSeparators||_(this._wordSeparators,o,r,c,E))return g}while(g);return null}}e.Searcher=A}),define(ge[109],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)k.indexOf(y)>=0||(S+="\\"+y);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function L(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let y="g";k.ignoreCase&&(y+="i"),k.multiline&&(y+="m"),k.unicode&&(y+="u"),S=new RegExp(k.source,y)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const D={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,S,y,R,P=D){if(y.length>P.maxLen){let _=k-P.maxLen/2;return _<0?_=0:R+=_,y=y.substring(_,k+P.maxLen/2),C(k,S,y,R,P)}const a=Date.now(),w=k-1-R;let f=-1,v=null;for(let _=1;!(Date.now()-a>=P.timeBudget);_++){const A=w-P.windowSize*_;S.lastIndex=Math.max(0,A);const p=i(S,y,w,f);if(!p&&v||(v=p,A<=0))break;f=A}if(v){let _={word:v[0],startColumn:R+1+v.index,endColumn:R+1+v.index+v[0].length};return S.lastIndex=0,_}return null}e.getWordAtText=C;function i(k,S,y,R){let P;for(;P=k.exec(S);){const a=P.index||0;if(a<=y&&k.lastIndex>=y)return P;if(R>0&&a>R)return null}return null}}),define(ge[146],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let S=0,y=k.notIn.length;S<y;S++)switch(k.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const y=k.findTokenIndexAtOffset(S-2),R=k.getStandardTokenType(y);return this.isOK(R)}_findNeutralCharacterInRange(k,S){for(let y=k;y<=S;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function C(i,k,S){i.has(k)?i.get(k).push(S):i.set(k,[S])}}),define(ge[82],pe([0,1,31,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(C,i,k,S){if(Array.isArray(C)){let y=0;for(const R of C){const P=D(R,i,k,S);if(P===10)return P;P>y&&(y=P)}return y}else{if(typeof C=="string")return S?C==="*"?5:C===k?10:0:0;if(C){const{language:y,pattern:R,scheme:P,hasAccessToAllModels:a}=C;if(!S&&!a)return 0;let w=0;if(P)if(P===i.scheme)w=10;else if(P==="*")w=5;else return 0;if(y)if(y===k)w=10;else if(y==="*")w=Math.max(w,5);else return 0;if(R){let f;if(typeof R=="string"?f=R:f={...R,base:(0,L.normalize)(R.base)},f===i.fsPath||(0,m.match)(f,i.fsPath))w=10;else return 0}return w}else return 0}}e.score=D}),define(ge[147],pe([0,1,107]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class D{constructor(f,v,_){const A=new Uint8Array(f*v);for(let p=0,o=f*v;p<o;p++)A[p]=_;this._data=A,this.rows=f,this.cols=v}get(f,v){return this._data[f*this.cols+v]}set(f,v,_){this._data[f*this.cols+v]=_}}e.Uint8Matrix=D;class C{constructor(f){let v=0,_=0;for(let p=0,o=f.length;p<o;p++){let[r,g,c]=f[p];g>v&&(v=g),r>_&&(_=r),c>_&&(_=c)}v++,_++;let A=new D(_,v,0);for(let p=0,o=f.length;p<o;p++){let[r,g,c]=f[p];A.set(r,g,c)}this._states=A,this._maxCharCode=v}nextState(f,v){return v<0||v>=this._maxCharCode?0:this._states.get(f,v)}}e.StateMachine=C;let i=null;function k(){return i===null&&(i=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),i}var S;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let y=null;function R(){if(y===null){y=new m.CharacterClassifier(0);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<w.length;v++)y.set(w.charCodeAt(v),1);const f=".,;";for(let v=0;v<f.length;v++)y.set(f.charCodeAt(v),2)}return y}class P{static _createLink(f,v,_,A,p){let o=p-1;do{const r=v.charCodeAt(o);if(f.get(r)!==2)break;o--}while(o>A);if(A>0){const r=v.charCodeAt(A-1),g=v.charCodeAt(o);(r===40&&g===41||r===91&&g===93||r===123&&g===125)&&o--}return{range:{startLineNumber:_,startColumn:A+1,endLineNumber:_,endColumn:o+2},url:v.substring(A,o+1)}}static computeLinks(f,v=k()){const _=R();let A=[];for(let p=1,o=f.getLineCount();p<=o;p++){const r=f.getLineContent(p),g=r.length;let c=0,E=0,n=0,t=1,s=!1,d=!1,l=!1,h=!1;for(;c<g;){let u=!1;const b=r.charCodeAt(c);if(t===13){let I;switch(b){case 40:s=!0,I=0;break;case 41:I=s?0:1;break;case 91:l=!0,d=!0,I=0;break;case 93:l=!1,I=d?0:1;break;case 123:h=!0,I=0;break;case 125:I=h?0:1;break;case 39:I=n===34||n===96?0:1;break;case 34:I=n===39||n===96?0:1;break;case 96:I=n===39||n===34?0:1;break;case 42:I=n===42?1:0;break;case 124:I=n===124?1:0;break;case 32:I=l?0:1;break;default:I=_.get(b)}I===1&&(A.push(P._createLink(_,r,p,E,c)),u=!0)}else if(t===12){let I;b===91?(d=!0,I=0):I=_.get(b),I===1?u=!0:t=13}else t=v.nextState(t,b),t===0&&(u=!0);u&&(t=1,s=!1,d=!1,h=!1,E=c+1,n=b),c++}t===13&&A.push(P._createLink(_,r,p,E,g))}return A}}e.LinkComputer=P;function a(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:P.computeLinks(w)}e.computeLinks=a}),define(ge[148],pe([0,1,3,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(i){this._onDidChange.fire({changedLanguages:i,changedColorMap:!1})}register(i,k){return this._map.set(i,k),this.fire([i]),(0,L.toDisposable)(()=>{this._map.get(i)===k&&(this._map.delete(i),this.fire([i]))})}registerPromise(i,k){let S=null,y=!1;return this._promises.set(i,k.then(R=>{this._promises.delete(i),!(y||!R)&&(S=this.register(i,R))})),(0,L.toDisposable)(()=>{y=!0,S&&S.dispose()})}getPromise(i){const k=this.get(i);if(k)return Promise.resolve(k);const S=this._promises.get(i);return S?S.then(y=>this.get(i)):null}get(i){return this._map.get(i)||null}setColorMap(i){this._colorMap=i,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(ge[110],pe([0,1,22,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(D||(D={}));function C(P){for(let a=0,w=P.length;a<w;a+=4){const f=P[a+0],v=P[a+1],_=P[a+2],A=P[a+3];P[a+0]=A,P[a+1]=_,P[a+2]=v,P[a+3]=f}}function i(P){const a=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||C(a),m.VSBuffer.wrap(a)}function k(P){const a=P.buffer;if(L.isLittleEndian()||C(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const w=new Uint8Array(a.byteLength);return w.set(a),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function S(P){const a=new Uint32Array(y(P));let w=0;if(a[w++]=P.id,P.type==="full")a[w++]=1,a[w++]=P.data.length,a.set(P.data,w),w+=P.data.length;else{a[w++]=2,a[w++]=P.deltas.length;for(const f of P.deltas)a[w++]=f.start,a[w++]=f.deleteCount,f.data?(a[w++]=f.data.length,a.set(f.data,w),w+=f.data.length):a[w++]=0}return i(a)}e.encodeSemanticTokensDto=S;function y(P){let a=0;if(a+=1+1,P.type==="full")a+=1+P.data.length;else{a+=1,a+=(1+1+1)*P.deltas.length;for(const w of P.deltas)w.data&&(a+=w.data.length)}return a}function R(P){const a=k(P);let w=0;const f=a[w++];if(a[w++]===1){const p=a[w++],o=a.subarray(w,w+p);return w+=p,{id:f,type:"full",data:o}}const _=a[w++];let A=[];for(let p=0;p<_;p++){const o=a[w++],r=a[w++],g=a[w++];let c;g>0&&(c=a.subarray(w,w+g),w+=g),A[p]={start:o,deleteCount:r,data:c}}return{id:f,type:"delta",deltas:A}}e.decodeSemanticTokensDto=R}),define(ge[111],pe([0,1,17,98]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,y){S=(0,L.toUint32)(S);const R=this.values,P=this.prefixSum,a=y.length;return a===0?!1:(this.values=new Uint32Array(R.length+a),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S),S+a),this.values.set(y,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,y){return S=(0,L.toUint32)(S),y=(0,L.toUint32)(y),this.values[S]===y?!1:(this.values[S]=y,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,y){S=(0,L.toUint32)(S),y=(0,L.toUint32)(y);const R=this.values,P=this.prefixSum;if(S>=R.length)return!1;let a=R.length-S;return y>=a&&(y=a),y===0?!1:(this.values=new Uint32Array(R.length-y),this.values.set(R.subarray(0,S),0),this.values.set(R.subarray(S+y),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,L.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),S>=this.values.length&&(S=this.values.length-1);for(let R=y;R<=S;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let y=0,R=this.values.length-1,P=0,a=0,w=0;for(;y<=R;)if(P=y+(R-y)/2|0,a=this.prefixSum[P],w=a-this.values[P],S<w)R=P-1;else if(S>=a)y=P+1;else break;return new i(P,S-w)}}e.PrefixSumComputer=D;class C{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const y=this._indexBySum[S],R=y>0?this._prefixSum[y-1]:0;return new i(y,S-R)}removeValues(S,y){this._values.splice(S,y),this._invalidate(S)}insertValues(S,y){this._values=(0,m.arrayInsert)(this._values,S,y),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,y=this._values.length;S<y;S++){const R=this._values[S],P=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=P+R;for(let a=0;a<R;a++)this._indexBySum[P+a]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,y){this._values[S]!==y&&(this._values[S]=y,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=C;class i{constructor(S,y){this.index=S,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=y}}e.PrefixSumIndexOfResult=i}),define(ge[149],pe([0,1,8,49,111]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,S,y,R){this._uri=k,this._lines=S,this._eol=y,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const y of S)this._acceptDeleteRange(y.range),this._acceptInsertText(new L.Position(y.range.startLineNumber,y.range.startColumn),y.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,y=new Uint32Array(S);for(let R=0;R<S;R++)y[R]=this._lines[R].length+k;this._lineStarts=new D.PrefixSumComputer(y)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;let y=(0,m.splitLines)(S);if(y.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+y[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}y[y.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+y[0]);let R=new Uint32Array(y.length-1);for(let P=1;P<y.length;P++)this._lines.splice(k.lineNumber+P-1,0,y[P]),R[P-1]=y[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}e.MirrorTextModel=C}),define(ge[150],pe([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ge[151],pe([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,C=D*24,i=C*7,k=C*30,S=C*365;function y(P,a){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,m.localize)(0,null,y(new Date().getTime()+w*1e3,!1));if(w<30)return(0,m.localize)(1,null);let f;return w<L?(f=w,a?f===1?(0,m.localize)(2,null,f):(0,m.localize)(3,null,f):f===1?(0,m.localize)(4,null,f):(0,m.localize)(5,null,f)):w<D?(f=Math.floor(w/L),a?f===1?(0,m.localize)(6,null,f):(0,m.localize)(7,null,f):f===1?(0,m.localize)(8,null,f):(0,m.localize)(9,null,f)):w<C?(f=Math.floor(w/D),a?f===1?(0,m.localize)(10,null,f):(0,m.localize)(11,null,f):f===1?(0,m.localize)(12,null,f):(0,m.localize)(13,null,f)):w<i?(f=Math.floor(w/C),a?f===1?(0,m.localize)(14,null,f):(0,m.localize)(15,null,f):f===1?(0,m.localize)(16,null,f):(0,m.localize)(17,null,f)):w<k?(f=Math.floor(w/i),a?f===1?(0,m.localize)(18,null,f):(0,m.localize)(19,null,f):f===1?(0,m.localize)(20,null,f):(0,m.localize)(21,null,f)):w<S?(f=Math.floor(w/k),a?f===1?(0,m.localize)(22,null,f):(0,m.localize)(23,null,f):f===1?(0,m.localize)(24,null,f):(0,m.localize)(25,null,f)):(f=Math.floor(w/S),a?f===1?(0,m.localize)(26,null,f):(0,m.localize)(27,null,f):f===1?(0,m.localize)(28,null,f):(0,m.localize)(29,null,f))}e.fromNow=y;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ge[152],pe([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ge[50],pe([0,1,17,13,152]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(y,R){return R&&(y.stack||y.stacktrace)?D.localize(0,null,k(y),i(y.stack)||i(y.stacktrace)):k(y)}function i(y){return Array.isArray(y)?y.join(`
`):y}function k(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function S(y=null,R=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const P=m.coalesce(y),a=S(P[0],R);return P.length>1?D.localize(4,null,a,P.length):a}if(L.isString(y))return y;if(y.detail){const P=y.detail;if(P.error)return C(P.error,R);if(P.exception)return C(P.exception,R)}return y.stack?C(y,R):y.message?y.message:D.localize(5,null)}e.toErrorMessage=S}),define(ge[153],pe([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ge[112],pe([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function f(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(c,E){if(k.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};E&&(n.cwd=E);const t=m.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],n);return new Promise(s=>{t.once("error",d=>{s({success:!1,error:d})}),t.once("exit",(d,l)=>{s(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?f(n.status):1})}else if(k.isLinux||k.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(n,[c.pid.toString()],{encoding:"utf8",shell:!0},(s,d,l)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function _(c){!c||(delete c.DEBUG,k.isMacintosh&&delete c.DYLD_LIBRARY_PATH,k.isLinux&&delete c.LD_PRELOAD)}e.removeDangerousEnvVariables=_;function A(c=S.env){return c.comspec||"cmd.exe"}e.getWindowsShell=A;class p{constructor(E,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=E,this.args=n,this.shell=t,this.options=s;else{const d=E;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(S.env).forEach(l=>{d[l]=S.env[l]}),Object.keys(this.options.env).forEach(l=>{d[l]=this.options.env[l]}),this.options.env=d}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const n=E.lastIndexOf(i.sep);return n!==-1&&(E=E.substring(n+1)),p.WellKnowCommands[E]?E:"other"}start(E){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(n=>{let t,s;const d=new Promise((l,h)=>{t=l,s=h});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=m.exec(l,this.options,(h,u,b)=>{this.childProcess=null;const I=h;I&&I.killed?s({killed:this.terminateRequested,stdout:u.toString(),stderr:b.toString()}):this.handleExec(t,E,h,u,b)})}else{let l=null;const h=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,E,s);const b={terminated:this.terminateRequested};R.isNumber(u)&&(b.cmdCode=u),t(b)};if(this.shell&&k.isWindows){const u=C.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let b=!1,I=!1;const T=[];let x=this.ensureQuotes(this.cmd);T.push(x.value),b=x.quoted,this.args&&this.args.forEach(F=>{x=this.ensureQuotes(F),T.push(x.value),I=I&&x.quoted});const O=["/s","/c"];b?I?O.push('"'+T.join(" ")+'"'):T.length>1?O.push('"'+T[0]+'" '+T.slice(1).join(" ")):O.push('"'+T[0]+'"'):O.push(T.join(" ")),l=m.spawn(A(),O,u)}else this.cmd&&(l=m.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(R.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",u=>{this.childProcess=null,s({terminated:this.terminateRequested,error:u})}),l.pid&&(this.childProcess.on("close",h),this.handleSpawn(l,t,E,s,!0)))}return d})}handleClose(E,n,t,s){}ensureQuotes(E){return p.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,v(E,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!k.isWindows)return E(!1);const n=m.spawn(A(),["/s","/c"]);n.on("error",t=>E(!0)),n.on("exit",t=>E(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class o extends p{constructor(E,n,t,s){super(E,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,n,t,s,d){[s,d].forEach((l,h)=>{const u=new P.LineDecoder;u.write(l).forEach(T=>{n({line:T,source:h===0?0:1})});const I=u.end();I&&n({line:I,source:h===0?0:1})}),E({terminated:this.terminateRequested,error:t})}handleSpawn(E,n,t,s,d){const l=new P.LineDecoder,h=new P.LineDecoder;E.stdout.on("data",u=>{l.write(u).forEach(I=>t({line:I,source:0}))}),E.stderr.on("data",u=>{h.write(u).forEach(I=>t({line:I,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=h}handleClose(E,n,t,s){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&t({line:l,source:1})}}e.LineProcess=o;function r(c){let E=[],n=!1;const t=function(s){if(n){E.push(s);return}(!c.send(s,l=>{if(l&&console.error(l),n=!1,E.length>0){const h=E.slice(0);E=[],h.forEach(u=>t(u))}})||k.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=r;var g;(function(c){async function E(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(s===void 0&&R.isString(S.env.PATH)&&(s=S.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function l(h){if(await a.Promises.exists(h)){let u;try{u=await a.Promises.stat(h)}catch(b){b.message.startsWith("EACCES")&&(u=await a.Promises.lstat(h))}return u?!u.isDirectory():!1}return!1}for(let h of s){let u;if(i.isAbsolute(h)?u=i.join(h,n):u=i.join(t,h,n),await l(u))return u;let b=u+".com";if(await l(b)||(b=u+".exe",await l(b)))return b}return i.join(t,n)}c.findExecutable=E})(g=e.win32||(e.win32={}))}),define(ge[154],pe([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ge[113],pe([0,1,154,12,109]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.deriveFromWorkspaceTrust=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class i{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=i;class k{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,Se){this._values[se]=Se}}e.ValidatedEditorOptions=k;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class y{constructor(se,Se,Ge,Ye){this.id=se,this.name=Se,this.defaultValue=Ge,this.schema=Ye}compute(se,Se,Ge){return Ge}}class R{constructor(se,Se=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=Se}validate(se){return this.defaultValue}}class P{constructor(se,Se,Ge,Ye){this.id=se,this.name=Se,this.defaultValue=Ge,this.schema=Ye}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,Se,Ge){return Ge}}function a(ee,se){return typeof ee=="undefined"?se:ee==="false"?!1:Boolean(ee)}e.boolean=a;class w extends P{constructor(se,Se,Ge,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ge),super(se,Se,Ge,Ye)}validate(se){return a(se,this.defaultValue)}}function f(ee,se,Se,Ge){if(typeof ee=="undefined")return se;let Ye=parseInt(ee,10);return isNaN(Ye)?se:(Ye=Math.max(Se,Ye),Ye=Math.min(Ge,Ye),Ye|0)}e.clampedInt=f;class v extends P{constructor(se,Se,Ge,Ye,nt,he=void 0){typeof he!="undefined"&&(he.type="integer",he.default=Ge,he.minimum=Ye,he.maximum=nt),super(se,Se,Ge,he),this.minimum=Ye,this.maximum=nt}static clampedInt(se,Se,Ge,Ye){return f(se,Se,Ge,Ye)}validate(se){return v.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class _ extends P{constructor(se,Se,Ge,Ye,nt){typeof nt!="undefined"&&(nt.type="number",nt.default=Ge),super(se,Se,Ge,nt),this.validationFn=Ye}static clamp(se,Se,Ge){return se<Se?Se:se>Ge?Ge:se}static float(se,Se){if(typeof se=="number")return se;if(typeof se=="undefined")return Se;const Ge=parseFloat(se);return isNaN(Ge)?Se:Ge}validate(se){return this.validationFn(_.float(se,this.defaultValue))}}class A extends P{static string(se,Se){return typeof se!="string"?Se:se}constructor(se,Se,Ge,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ge),super(se,Se,Ge,Ye)}validate(se){return A.string(se,this.defaultValue)}}function p(ee,se,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?se:ee}e.stringSet=p;class o extends P{constructor(se,Se,Ge,Ye,nt=void 0){typeof nt!="undefined"&&(nt.type="string",nt.enum=Ye,nt.default=Ge),super(se,Se,Ge,nt),this._allowedValues=Ye}validate(se){return p(se,this.defaultValue,this._allowedValues)}}class r extends y{constructor(se,Se,Ge,Ye,nt,he,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="string",Ie.enum=nt,Ie.default=Ye),super(se,Se,Ge,Ie),this._allowedValues=nt,this._convert=he}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function g(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Se,Ge){return Ge===0?se.accessibilitySupport:Ge}}class E extends y{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:m.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertSpace:a(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(ee){switch(ee){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function l(ee){switch(ee){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class h extends R{constructor(){super(127,[65,33])}compute(se,Se,Ge){const Ye=["monaco-editor"];return Se.get(33)&&Ye.push(Se.get(33)),se.extraEditorClassName&&Ye.push(se.extraEditorClassName),Se.get(65)==="default"?Ye.push("mouse-default"):Se.get(65)==="copy"&&Ye.push("mouse-copy"),Se.get(99)&&Ye.push("showUnused"),Se.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class u extends w{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(se,Se,Ge){return Ge&&se.emptySelectionClipboard}}class b extends y{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:m.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{cursorMoveOnType:a(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":p(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":p(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Se.loop,this.defaultValue.loop)}}}class I extends y{constructor(){super(44,"fontLigatures",I.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?I.OFF:se==="true"?I.ON:se:Boolean(se)?I.ON:I.OFF}}e.EditorFontLigatures=I,I.OFF='"liga" off, "calt" off',I.ON='"liga" on, "calt" on';class T extends R{constructor(){super(43)}compute(se,Se,Ge){return se.fontInfo}}class x extends P{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(se){let Se=_.float(se,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(Se,6,100)}compute(se,Se,Ge){return se.fontInfo.fontSize}}class O extends y{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(v.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class F extends y{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ge,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ge,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ge,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ge,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ge,description:m.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{multiple:p(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??p(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??p(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??p(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??p(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??p(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:A.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:A.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:A.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:A.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:A.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends y{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:m.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),delay:v.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:a(Se.sticky,this.defaultValue.sticky),above:a(Se.above,this.defaultValue.above)}}}var M;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class B extends R{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(se,Se,Ge){return B.computeLayout(Se,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Se=se.height/se.lineHeight,Ge=se.scrollBeyondLastLine?Se-1:0,Ye=(se.viewLineCount+Ge)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/Ye);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:Ge,desiredRatio:Ye,minimapLineCount:nt}}static _computeMinimapLayout(se,Se){const Ge=se.outerWidth,Ye=se.outerHeight,nt=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const he=Se.stableMinimapLayoutInput,Ie=he&&se.outerHeight===he.outerHeight&&se.lineHeight===he.lineHeight&&se.typicalHalfwidthCharacterWidth===he.typicalHalfwidthCharacterWidth&&se.pixelRatio===he.pixelRatio&&se.scrollBeyondLastLine===he.scrollBeyondLastLine&&se.minimap.enabled===he.minimap.enabled&&se.minimap.side===he.minimap.side&&se.minimap.size===he.minimap.size&&se.minimap.showSlider===he.minimap.showSlider&&se.minimap.renderCharacters===he.minimap.renderCharacters&&se.minimap.maxColumn===he.minimap.maxColumn&&se.minimap.scale===he.minimap.scale&&se.verticalScrollbarWidth===he.verticalScrollbarWidth&&se.isViewportWrapping===he.isViewportWrapping,Be=se.lineHeight,$e=se.typicalHalfwidthCharacterWidth,tt=se.scrollBeyondLastLine,Te=se.minimap.renderCharacters;let ye=nt>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const be=se.minimap.maxColumn,ae=se.minimap.size,de=se.minimap.side,ve=se.verticalScrollbarWidth,Ee=se.viewLineCount,Fe=se.remainingWidth,Qe=se.isViewportWrapping,We=Te?2:3;let Xe=Math.floor(nt*Ye);const at=Xe/nt;let lt=!1,le=!1,_e=We*ye,ce=ye/nt,X=1;if(ae==="fill"||ae==="fit"){const{typicalViewportLineCount:kt,extraLinesBeyondLastLine:bt,desiredRatio:gt,minimapLineCount:Et}=B.computeContainedMinimapLineCount({viewLineCount:Ee,scrollBeyondLastLine:tt,height:Ye,lineHeight:Be,pixelRatio:nt});if(Ee/Et>1)lt=!0,le=!0,ye=1,_e=1,ce=ye/nt;else{let Lt=!1,yt=ye+1;if(ae==="fit"){const At=Math.ceil((Ee+bt)*_e);Qe&&Ie&&Fe<=Se.stableFitRemainingWidth?(Lt=!0,yt=Se.stableFitMaxMinimapScale):Lt=At>Xe}if(ae==="fill"||Lt){lt=!0;const At=ye;_e=Math.min(Be*nt,Math.max(1,Math.floor(1/gt))),Qe&&Ie&&Fe<=Se.stableFitRemainingWidth&&(yt=Se.stableFitMaxMinimapScale),ye=Math.min(yt,Math.max(1,Math.floor(_e/We))),ye>At&&(X=Math.min(2,ye/At)),ce=ye/nt/X,Xe=Math.ceil(Math.max(kt,Ee+bt)*_e),Qe?(Se.stableMinimapLayoutInput=se,Se.stableFitRemainingWidth=Fe,Se.stableFitMaxMinimapScale=ye):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const De=Math.floor(be*ce),Le=Math.min(De,Math.max(0,Math.floor((Fe-ve-2)*ce/($e+ce)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(nt*Le);const qe=et/nt;et=Math.floor(et*X);const mt=Te?1:2,_t=de==="left"?0:Ge-Le-ve;return{renderMinimap:mt,minimapLeft:_t,minimapWidth:Le,minimapHeightIsEditorHeight:lt,minimapIsSampling:le,minimapScale:ye,minimapLineHeight:_e,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(se,Se){const Ge=Se.outerWidth|0,Ye=Se.outerHeight|0,nt=Se.lineHeight|0,he=Se.lineNumbersDigitCount|0,Ie=Se.typicalHalfwidthCharacterWidth,Be=Se.maxDigitWidth,$e=Se.pixelRatio,tt=Se.viewLineCount,Te=se.get(122),ye=Te==="inherit"?se.get(121):Te,be=ye==="inherit"?se.get(117):ye,ae=se.get(120),de=se.get(2),ve=Se.isDominatedByLongLines,Ee=se.get(49),Fe=se.get(59).renderType!==0,Qe=se.get(60),We=se.get(93),Xe=se.get(64),at=se.get(91),lt=at.verticalScrollbarSize,le=at.verticalHasArrows,_e=at.arrowSize,ce=at.horizontalScrollbarSize,X=se.get(57),De=se.get(37);let Le;if(typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)){const Bt=parseFloat(X.substr(0,X.length-2));Le=v.clampedInt(Bt*Ie,0,0,1e3)}else Le=v.clampedInt(X,0,0,1e3);De&&(Le+=16);let et=0;if(Fe){const Bt=Math.max(he,Qe);et=Math.round(Bt*Be)}let qe=0;Ee&&(qe=nt);let mt=0,_t=mt+qe,kt=_t+et,bt=kt+Le;const gt=Ge-qe-et-Le;let Et=!1,Ct=!1,Lt=-1;de!==2&&(ye==="inherit"&&ve?(Et=!0,Ct=!0):be==="on"||be==="bounded"?Ct=!0:be==="wordWrapColumn"&&(Lt=ae));const yt=B._computeMinimapLayout({outerWidth:Ge,outerHeight:Ye,lineHeight:nt,typicalHalfwidthCharacterWidth:Ie,pixelRatio:$e,scrollBeyondLastLine:We,minimap:Xe,verticalScrollbarWidth:lt,viewLineCount:tt,remainingWidth:gt,isViewportWrapping:Ct},Se.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(mt+=yt.minimapWidth,_t+=yt.minimapWidth,kt+=yt.minimapWidth,bt+=yt.minimapWidth);const At=gt-yt.minimapWidth,xt=Math.max(1,Math.floor((At-lt-2)/Ie)),Tt=le?_e:0;return Ct&&(Lt=Math.max(1,xt),be==="bounded"&&(Lt=Math.min(Lt,ae))),{width:Ge,height:Ye,glyphMarginLeft:mt,glyphMarginWidth:qe,lineNumbersLeft:_t,lineNumbersWidth:et,decorationsLeft:kt,decorationsWidth:Le,contentLeft:bt,contentWidth:At,minimap:yt,viewportColumn:xt,isWordWrapMinified:Et,isViewportWrapping:Ct,wrappingColumn:Lt,verticalScrollbarWidth:lt,horizontalScrollbarHeight:ce,overviewRuler:{top:Tt,width:lt,height:Ye-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=B;class U extends y{constructor(){const se={enabled:!0};super(56,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:m.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled)}}}class z extends y{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:m.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),fontSize:v.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:A.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class K extends _{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>_.clamp(se,0,150),{markdownDescription:m.localize(47,null)})}compute(se,Se,Ge){return se.fontInfo.lineHeight}}class N extends y{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:se.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:m.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),size:p(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(Se.side,this.defaultValue.side,["right","left"]),showSlider:p(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Se.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(Se.scale,1,1,3),maxColumn:v.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(ee){return ee==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends y{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{top:v.clampedInt(Se.top,0,0,1e3),bottom:v.clampedInt(Se.bottom,0,0,1e3)}}}class V extends y{constructor(){const se={enabled:!0,cycle:!1};super(75,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:m.localize(61,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),cycle:a(Se.cycle,this.defaultValue.cycle)}}}class q extends R{constructor(){super(128)}compute(se,Se,Ge){return se.pixelRatio}}class te extends y{constructor(){const se={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:m.localize(62,null)},comments:{type:"boolean",default:se.comments,description:m.localize(63,null)},other:{type:"boolean",default:se.other,description:m.localize(64,null)}}}],default:se,description:m.localize(65,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const Se=se,Ge={other:a(Se.other,this.defaultValue.other),comments:a(Se.comments,this.defaultValue.comments),strings:a(Se.strings,this.defaultValue.strings)};return Ge.other&&Ge.comments&&Ge.strings?!0:!Ge.other&&!Ge.comments&&!Ge.strings?!1:Ge}return this.defaultValue}}var fe;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends y{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(se){let Se=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(Se=4,Ge=se):se==="interval"?Se=3:se==="relative"?Se=2:se==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ge}}}function ke(ee){const se=ee.get(86);return se==="editable"?ee.get(80):se!=="on"}e.filterValidationDecorations=ke;class Ue extends y{constructor(){const se=[],Se={type:"number",description:m.localize(71,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:se,description:m.localize(73,null)})}validate(se){if(Array.isArray(se)){let Se=[];for(let Ge of se)if(typeof Ge=="number")Se.push({column:v.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Ye=Ge;Se.push({column:v.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return Se.sort((Ge,Ye)=>Ge.column-Ye.column),Se}return this.defaultValue}}function xe(ee,se){if(typeof ee!="string")return se;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends y{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:m.localize(84,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se,Ge=v.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=v.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:xe(Se.vertical,this.defaultValue.vertical),horizontal:xe(Se.horizontal,this.defaultValue.horizontal),useShadows:a(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:v.clampedInt(Se.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:v.clampedInt(Se.verticalSliderSize,Ye,0,1e3),scrollByPage:a(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.deriveFromWorkspaceTrust="deriveFromWorkspaceTrust",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class Q extends y{constructor(){const se={nonBasicASCII:e.deriveFromWorkspaceTrust,invisibleCharacters:e.deriveFromWorkspaceTrust,ambiguousCharacters:e.deriveFromWorkspaceTrust,includeComments:e.deriveFromWorkspaceTrust,allowedCharacters:""};super(112,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:se.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"string",default:se.allowedCharacters,description:m.localize(89,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{nonBasicASCII:ie(Se.nonBasicASCII,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),invisibleCharacters:ie(Se.invisibleCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),ambiguousCharacters:ie(Se.ambiguousCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),includeComments:ie(Se.includeComments,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),allowedCharacters:Z(Se.allowedCharacters,"")}}}function Z(ee,se){return typeof ee!="string"?se:ee}class re extends y{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:m.localize(90,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:a(Se.enabled,this.defaultValue.enabled),mode:p(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ue extends y{constructor(){const se={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,description:m.localize(91,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:a(se.enabled,this.defaultValue.enabled)}}}class J extends y{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:se.bracketPairs,description:m.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:se.bracketPairsHorizontal,description:m.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:m.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:m.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:se.highlightActiveIndentation,description:m.localize(102,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{bracketPairs:ie(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ie(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ie(ee,se,Se){const Ge=Se.indexOf(ee);return Ge===-1?se:Se[Ge]}class we extends y{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(103,null),m.localize(104,null)],default:se.insertMode,description:m.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:m.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:m.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:m.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:m.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:m.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:m.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:m.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:m.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertMode:p(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Se.showIcons,this.defaultValue.showIcons),showStatusBar:a(Se.showStatusBar,this.defaultValue.showStatusBar),preview:a(Se.preview,this.defaultValue.preview),previewMode:p(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Se.showMethods,this.defaultValue.showMethods),showFunctions:a(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Se.showFields,this.defaultValue.showFields),showVariables:a(Se.showVariables,this.defaultValue.showVariables),showClasses:a(Se.showClasses,this.defaultValue.showClasses),showStructs:a(Se.showStructs,this.defaultValue.showStructs),showInterfaces:a(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Se.showModules,this.defaultValue.showModules),showProperties:a(Se.showProperties,this.defaultValue.showProperties),showEvents:a(Se.showEvents,this.defaultValue.showEvents),showOperators:a(Se.showOperators,this.defaultValue.showOperators),showUnits:a(Se.showUnits,this.defaultValue.showUnits),showValues:a(Se.showValues,this.defaultValue.showValues),showConstants:a(Se.showConstants,this.defaultValue.showConstants),showEnums:a(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Se.showKeywords,this.defaultValue.showKeywords),showWords:a(Se.showWords,this.defaultValue.showWords),showColors:a(Se.showColors,this.defaultValue.showColors),showFiles:a(Se.showFiles,this.defaultValue.showFiles),showReferences:a(Se.showReferences,this.defaultValue.showReferences),showFolders:a(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Se.showSnippets,this.defaultValue.showSnippets),showUsers:a(Se.showUsers,this.defaultValue.showUsers),showIssues:a(Se.showIssues,this.defaultValue.showIssues)}}}class Me extends y{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(145,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class je extends R{constructor(){super(129,[80])}compute(se,Se,Ge){return Se.get(80)?!0:se.tabFocusMode}}var Ke;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(Ke=e.WrappingIndent||(e.WrappingIndent={}));function Ze(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class rt extends R{constructor(){super(131,[130])}compute(se,Se,Ge){const Ye=Se.get(130);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const ut="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?it:L.isLinux?st:ut,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ae(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var wt;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(wt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new w(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(146,null)})),acceptSuggestionOnEnter:Ae(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(147,null),""],markdownDescription:m.localize(148,null)})),accessibilitySupport:Ae(new c),accessibilityPageSize:Ae(new v(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(149,null)})),ariaLabel:Ae(new A(4,"ariaLabel",m.localize(150,null))),autoClosingBrackets:Ae(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),autoClosingDelete:Ae(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(154,null),""],description:m.localize(155,null)})),autoClosingOvertype:Ae(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingQuotes:Ae(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),autoIndent:Ae(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[m.localize(161,null),m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null)],description:m.localize(166,null)})),automaticLayout:Ae(new w(10,"automaticLayout",!1)),autoSurround:Ae(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(167,null),m.localize(168,null),m.localize(169,null),""],description:m.localize(170,null)})),bracketPairColorization:Ae(new ue),bracketPairGuides:Ae(new J),stickyTabStops:Ae(new w(103,"stickyTabStops",!1,{description:m.localize(171,null)})),codeLens:Ae(new w(14,"codeLens",!0,{description:m.localize(172,null)})),codeLensFontFamily:Ae(new A(15,"codeLensFontFamily","",{description:m.localize(173,null)})),codeLensFontSize:Ae(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(174,null)})),colorDecorators:Ae(new w(17,"colorDecorators",!0,{description:m.localize(175,null)})),columnSelection:Ae(new w(18,"columnSelection",!1,{description:m.localize(176,null)})),comments:Ae(new E),contextmenu:Ae(new w(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new w(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(177,null)})),cursorBlinking:Ae(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:m.localize(178,null)})),cursorSmoothCaretAnimation:Ae(new w(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(179,null)})),cursorStyle:Ae(new r(24,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:m.localize(180,null)})),cursorSurroundingLines:Ae(new v(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(181,null)})),cursorSurroundingLinesStyle:Ae(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(182,null),m.localize(183,null)],description:m.localize(184,null)})),cursorWidth:Ae(new v(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(185,null)})),disableLayerHinting:Ae(new w(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new w(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new w(30,"domReadOnly",!1)),dragAndDrop:Ae(new w(31,"dragAndDrop",!0,{description:m.localize(186,null)})),emptySelectionClipboard:Ae(new u),extraEditorClassName:Ae(new A(33,"extraEditorClassName","")),fastScrollSensitivity:Ae(new _(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(187,null)})),find:Ae(new b),fixedOverflowWidgets:Ae(new w(36,"fixedOverflowWidgets",!1)),folding:Ae(new w(37,"folding",!0,{description:m.localize(188,null)})),foldingStrategy:Ae(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),foldingHighlight:Ae(new w(39,"foldingHighlight",!0,{description:m.localize(192,null)})),foldingImportsByDefault:Ae(new w(40,"foldingImportsByDefault",!1,{description:m.localize(193,null)})),unfoldOnClickAfterEndOfLine:Ae(new w(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(194,null)})),fontFamily:Ae(new A(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(195,null)})),fontInfo:Ae(new T),fontLigatures2:Ae(new I),fontSize:Ae(new x),fontWeight:Ae(new O),formatOnPaste:Ae(new w(47,"formatOnPaste",!1,{description:m.localize(196,null)})),formatOnType:Ae(new w(48,"formatOnType",!1,{description:m.localize(197,null)})),glyphMargin:Ae(new w(49,"glyphMargin",!0,{description:m.localize(198,null)})),gotoLocation:Ae(new F),hideCursorInOverviewRuler:Ae(new w(51,"hideCursorInOverviewRuler",!1,{description:m.localize(199,null)})),hover:Ae(new W),inDiffEditor:Ae(new w(53,"inDiffEditor",!1)),letterSpacing:Ae(new _(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>_.clamp(ee,-5,20),{description:m.localize(200,null)})),lightbulb:Ae(new U),lineDecorationsWidth:Ae(new P(57,"lineDecorationsWidth",10)),lineHeight:Ae(new K),lineNumbers:Ae(new Ce),lineNumbersMinChars:Ae(new v(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new w(61,"linkedEditing",!1,{description:m.localize(201,null)})),links:Ae(new w(62,"links",!0,{description:m.localize(202,null)})),matchBrackets:Ae(new o(63,"matchBrackets","always",["always","near","never"],{description:m.localize(203,null)})),minimap:Ae(new N),mouseStyle:Ae(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new _(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(204,null)})),mouseWheelZoom:Ae(new w(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(205,null)})),multiCursorMergeOverlapping:Ae(new w(68,"multiCursorMergeOverlapping",!0,{description:m.localize(206,null)})),multiCursorModifier:Ae(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[m.localize(207,null),m.localize(208,null)],markdownDescription:m.localize(209,null)})),multiCursorPaste:Ae(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),occurrencesHighlight:Ae(new w(71,"occurrencesHighlight",!0,{description:m.localize(213,null)})),overviewRulerBorder:Ae(new w(72,"overviewRulerBorder",!0,{description:m.localize(214,null)})),overviewRulerLanes:Ae(new v(73,"overviewRulerLanes",3,0,3)),padding:Ae(new H),parameterHints:Ae(new V),peekWidgetDefaultFocus:Ae(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(215,null),m.localize(216,null)],description:m.localize(217,null)})),definitionLinkOpensInPeek:Ae(new w(77,"definitionLinkOpensInPeek",!1,{description:m.localize(218,null)})),quickSuggestions:Ae(new te),quickSuggestionsDelay:Ae(new v(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(219,null)})),readOnly:Ae(new w(80,"readOnly",!1)),renameOnType:Ae(new w(81,"renameOnType",!1,{description:m.localize(220,null),markdownDeprecationMessage:m.localize(221,null)})),renderControlCharacters:Ae(new w(82,"renderControlCharacters",!0,{description:m.localize(222,null),restricted:!0})),renderFinalNewline:Ae(new w(83,"renderFinalNewline",!0,{description:m.localize(223,null)})),renderLineHighlight:Ae(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(224,null)],description:m.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Ae(new w(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(226,null)})),renderValidationDecorations:Ae(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),revealHorizontalRightPadding:Ae(new v(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ae(new w(89,"roundedSelection",!0,{description:m.localize(231,null)})),rulers:Ae(new Ue),scrollbar:Ae(new ze),scrollBeyondLastColumn:Ae(new v(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(232,null)})),scrollBeyondLastLine:Ae(new w(93,"scrollBeyondLastLine",!0,{description:m.localize(233,null)})),scrollPredominantAxis:Ae(new w(94,"scrollPredominantAxis",!0,{description:m.localize(234,null)})),selectionClipboard:Ae(new w(95,"selectionClipboard",!0,{description:m.localize(235,null),included:L.isLinux})),selectionHighlight:Ae(new w(96,"selectionHighlight",!0,{description:m.localize(236,null)})),selectOnLineNumbers:Ae(new w(97,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),showUnused:Ae(new w(99,"showUnused",!0,{description:m.localize(240,null)})),showDeprecated:Ae(new w(125,"showDeprecated",!0,{description:m.localize(241,null)})),inlayHints:Ae(new z),snippetSuggestions:Ae(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(242,null),m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),smartSelect:Ae(new Me),smoothScrolling:Ae(new w(102,"smoothScrolling",!1,{description:m.localize(247,null)})),stopRenderingLineAfter:Ae(new v(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new we),inlineSuggest:Ae(new re),suggestFontSize:Ae(new v(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(248,null)})),suggestLineHeight:Ae(new v(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestOnTriggerCharacters:Ae(new w(108,"suggestOnTriggerCharacters",!0,{description:m.localize(250,null)})),suggestSelection:Ae(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),tabCompletion:Ae(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),tabIndex:Ae(new v(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ae(new Q),unusualLineTerminators:Ae(new o(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),useShadowDOM:Ae(new w(114,"useShadowDOM",!0)),useTabStops:Ae(new w(115,"useTabStops",!0,{description:m.localize(263,null)})),wordSeparators:Ae(new A(116,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:m.localize(264,null)})),wordWrap:Ae(new o(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(265,null),m.localize(266,null),m.localize(267,null),m.localize(268,null)],description:m.localize(269,null)})),wordWrapBreakAfterCharacters:Ae(new A(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new A(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new v(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(270,null)})),wordWrapOverride1:Ae(new o(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new o(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ae(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ze,{enumDescriptions:[m.localize(271,null),m.localize(272,null),m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),wrappingStrategy:Ae(new o(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),editorClassName:Ae(new h),pixelRatio:Ae(new q),tabFocusMode:Ae(new je),layoutInfo:Ae(new B),wrappingInfo:Ae(new rt)}}),define(ge[155],pe([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[156],pe([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[157],pe([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[158],pe([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[159],pe([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ge[160],pe([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ge[161],pe([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[162],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[163],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[164],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[165],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[166],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[167],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[168],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[169],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[170],pe([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ge[171],pe([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(ge[172],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[173],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[174],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[175],pe([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[176],pe([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[177],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(i){i[i.ACTIVATE=1]="ACTIVATE",i[i.RESTORE=2]="RESTORE",i[i.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(i){i[i.PICK=0]="PICK",i[i.DISABLED=1]="DISABLED",i[i.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var D;(function(i){i[i.API=0]="API",i[i.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(i){i[i.Center=0]="Center",i[i.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",i[i.NearTop=2]="NearTop",i[i.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[178],pe([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(a){return a=a.trim(),a==="*"||L.test(a)}e.isValidVersionStr=C;function i(a){if(!C(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=a.match(L);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=i;function k(a){if(!a)return null;let w=a.majorBase,f=a.majorMustEqual,v=a.minorBase,_=a.minorMustEqual,A=a.patchBase,p=a.patchMustEqual;a.hasCaret&&(w===0||(_=!1),p=!1);let o=0;if(a.preRelease){const r=D.exec(a.preRelease);if(r){const[,g,c,E]=r;o=Date.UTC(Number(g),Number(c)-1,Number(E))}}return{majorBase:w,majorMustEqual:f,minorBase:v,minorMustEqual:_,patchBase:A,patchMustEqual:p,isMinimum:a.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function S(a,w,f){let v;typeof a=="string"?v=k(i(a)):v=a;let _;w instanceof Date?_=w.getTime():typeof w=="string"&&(_=new Date(w).getTime());let A;if(typeof f=="string"?A=k(i(f)):A=f,!v||!A)return!1;let p=v.majorBase,o=v.minorBase,r=v.patchBase,g=A.majorBase,c=A.minorBase,E=A.patchBase,n=A.notBefore,t=A.majorMustEqual,s=A.minorMustEqual,d=A.patchMustEqual;return A.isMinimum?p>g?!0:p<g?!1:o>c?!0:o<c||_&&_<n?!1:r>=E:(p===1&&g===0&&(!t||!s||!d)&&(g=1,c=0,E=0,t=!0,s=!1,d=!1),p<g?!1:p>g?!t:o<c?!1:o>c?!s:r<E?!1:r>E?!d:!(_&&_<n))}e.isValidVersion=S;function y(a,w,f,v){return f.isBuiltin||typeof f.main=="undefined"?!0:P(a,w,f.engines.vscode,v)}e.isValidExtensionVersion=y;function R(a,w,f){return a==="*"||P(w,f,a)}e.isEngineValid=R;function P(a,w,f,v=[]){let _=k(i(f));if(!_)return v.push(m.localize(0,null,f)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(m.localize(1,null,f)),!1}else if(!_.majorMustEqual)return v.push(m.localize(2,null,f)),!1;return S(a,w,_)?!0:(v.push(m.localize(3,null,a,f)),!1)}}),define(ge[114],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(D,C=[],i=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=m}),define(ge[83],pe([0,1,114]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(i,k,S){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],S)),L.push([i,k])}e.registerSingleton=D;function C(){return L}e.getSingletonServiceDescriptors=C}),define(ge[179],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let i of this._nodes.values())i.outgoing.size===0&&C.push(i);return C}insertEdge(C,i){const k=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(i);k.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(C),k)}removeNode(C){const i=this._hashFn(C);this._nodes.delete(i);for(let k of this._nodes.values())k.outgoing.delete(i),k.incoming.delete(i)}lookupOrInsertNode(C){const i=this._hashFn(C);let k=this._nodes.get(i);return k||(k=new m(C),this._nodes.set(i,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[i,k]of this._nodes)C.push(`${i}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,i]of this._nodes){const k=new Set([C]),S=this._findCycle(i,k);if(S)return S}}_findCycle(C,i){for(let[k,S]of C.outgoing){if(i.has(k))return[...i,k].join(" -> ");i.add(k);const y=this._findCycle(S,i);if(y)return y;i.delete(k)}}}e.Graph=L}),define(ge[4],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(i,k,S,y){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:i,index:S,optional:y}):(k[m.DI_DEPENDENCIES]=[{id:i,index:S,optional:y}],k[m.DI_TARGET]=k)}function D(i){if(m.serviceIds.has(i))return m.serviceIds.get(i);const k=function(S,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,S,R,!1)};return k.toString=()=>i,m.serviceIds.set(i,k),k}e.createDecorator=D;function C(i){return i}e.refineServiceDecorator=C}),define(ge[180],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(ge[181],pe([0,1,3,47,6,24,77,82,180]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function y(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(y):!!v.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(_,A){let p={selector:_,provider:A,_score:-1,_time:this._clock++};return this._entries.push(p),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(p){let o=this._entries.indexOf(p);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const A=[];for(let p of this._entries)p._score>0&&A.push(p.provider);return A}ordered(_){const A=[];return this._orderedForEach(_,p=>A.push(p.provider)),A}orderedGroups(_){const A=[];let p,o;return this._orderedForEach(_,r=>{p&&o===r._score?p.push(r.provider):(o=r._score,p=[r.provider],A.push(p))}),A}_orderedForEach(_,A){if(!!_){this._updateScores(_);for(const p of this._entries)p._score>0&&A(p)}}_updateScores(_){let A={uri:_.uri.toString(),language:_.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let p of this._entries)if(p._score=(0,k.score)(p.selector,_.uri,_.getLanguageId(),(0,S.shouldSynchronizeModel)(_)),y(p.selector)&&p._score>0){for(let o of this._entries)o._score=0;p._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(_,A){return _._score<A._score?1:_._score>A._score?-1:_._time<A._time?1:_._time>A._time?-1:0}}e.LanguageFeatureRegistry=R;const P=new WeakMap;let a=0;function w(v){let _=P.get(v);return _===void 0&&(_=++a,P.set(v,_)),_}class f{constructor(_,A,p=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=A,this.max=p,this._cache=new C.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((A,p)=>(0,L.doHash)(w(p),A),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const A=this._key(_),p=this._cache.get(A);return this._clamp(p?.value)}update(_,A){const p=this._key(_);let o=this._cache.get(p);return o||(o=new i.MovingAverage,this._cache.set(p,o)),o.update(A),this.get(_)}}e.LanguageFeatureRequestDelays=f}),define(ge[84],pe([0,1,2,41,181,148,78]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var S;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var y;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(y=e.ColorId||(e.ColorId={}));var R;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var P;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(P=e.MetadataConsts||(e.MetadataConsts={}));class a{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let I=this.getForeground(b),T="mtk"+I,x=this.getFontStyle(b);return x&1&&(T+=" mtki"),x&2&&(T+=" mtkb"),x&4&&(T+=" mtku"),T}static getInlineStyleFromMetadata(b,I){const T=this.getForeground(b),x=this.getFontStyle(b);let O=`color: ${I[T]};`;return x&1&&(O+="font-style: italic;"),x&2&&(O+="font-weight: bold;"),x&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=a;var w;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(w=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(b){const I=u[b];let T=I&&i.iconRegistry.get(I);return T||(console.info("No codicon found for CompletionItemKind "+b),T=i.Codicon.symbolProperty),T.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(b,I){let T=u[b];return typeof T=="undefined"&&!I&&(T=9),T}}();var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var A;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(A=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(u){return u&&m.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=g;var c;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(c=e.SymbolKind||(e.SymbolKind={}));var E;(function(u){u[u.Deprecated=1]="Deprecated"})(E=e.SymbolTag||(e.SymbolTag={}));var n;(function(u){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const I=new Map;I.set(0,"file"),I.set(1,"module"),I.set(2,"namespace"),I.set(3,"package"),I.set(4,"class"),I.set(5,"method"),I.set(6,"property"),I.set(7,"field"),I.set(8,"constructor"),I.set(9,"enum"),I.set(10,"interface"),I.set(11,"function"),I.set(12,"variable"),I.set(13,"constant"),I.set(14,"string"),I.set(15,"number"),I.set(16,"boolean"),I.set(17,"array"),I.set(18,"object"),I.set(19,"key"),I.set(20,"null"),I.set(21,"enum-member"),I.set(22,"struct"),I.set(23,"event"),I.set(24,"operator"),I.set(25,"type-parameter");function T(F){return b.get(F)}u.fromString=T;function x(F){return I.get(F)}u.toString=x;function O(F,W){const M=I.get(F);let B=M&&i.iconRegistry.get("symbol-"+M);return B||(console.info("No codicon found for SymbolKind "+F),B=i.Codicon.symbolProperty),`${W?"inline":"block"} ${B.classNames}`}u.toCssClassName=O})(n=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(b){this.value=b}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var s;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var l;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var h;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(h=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[115],pe([0,1,13,2,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(_){return _&&typeof _=="object"&&(!_.overrideIdentifier||typeof _.overrideIdentifier=="string")&&(!_.resource||_.resource instanceof L.URI)}e.isConfigurationOverrides=C;function i(_){return _&&typeof _=="object"&&(!_.overrideIdentifiers||m.isArray(_.overrideIdentifiers))&&!_.overrideIdentifier&&(!_.resource||_.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=i;var k;(function(_){_[_.USER=1]="USER",_[_.USER_LOCAL=2]="USER_LOCAL",_[_.USER_REMOTE=3]="USER_REMOTE",_[_.WORKSPACE=4]="WORKSPACE",_[_.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",_[_.DEFAULT=6]="DEFAULT",_[_.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(_){switch(_){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function y(_,A){const p=Object.create(null);for(let o in _)R(p,o,_[o],A);return p}e.toValuesTree=y;function R(_,A,p,o){const r=A.split("."),g=r.pop();let c=_;for(let E=0;E<r.length;E++){let n=r[E],t=c[n];switch(typeof t){case"undefined":t=c[n]=Object.create(null);break;case"object":break;default:o(`Ignoring ${A} as ${r.slice(0,E+1).join(".")} is ${JSON.stringify(t)}`);return}c=t}if(typeof c=="object"&&c!==null)try{c[g]=p}catch(E){o(`Ignoring ${A} as ${r.join(".")} is ${JSON.stringify(c)}`)}else o(`Ignoring ${A} as ${r.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=R;function P(_,A){const p=A.split(".");a(_,p)}e.removeFromValueTree=P;function a(_,A){const p=A.shift();if(A.length===0){delete _[p];return}if(Object.keys(_).indexOf(p)!==-1){const o=_[p];typeof o=="object"&&!Array.isArray(o)&&(a(o,A),Object.keys(o).length===0&&delete _[p])}}function w(_,A,p){function o(c,E){let n=c;for(const t of E){if(typeof n!="object"||n===null)return;n=n[t]}return n}const r=A.split("."),g=o(_,r);return typeof g=="undefined"?p:g}e.getConfigurationValue=w;function f(_,A,p){Object.keys(A).forEach(o=>{o!=="__proto__"&&(o in _?m.isObject(_[o])&&m.isObject(A[o])?f(_[o],A[o],p):p&&(_[o]=A[o]):_[o]=A[o])})}e.merge=f;function v(_,A,p){const o=_.inspect(A),r=_.inspect(p);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:o.defaultValue}e.getMigratedSettingValue=v}),define(ge[61],pe([0,1,12,8,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",m.isMacintosh),i.set("isLinux",m.isLinux),i.set("isWindows",m.isWindows),i.set("isWeb",m.isWeb),i.set("isMacNative",m.isMacintosh&&!m.isWeb),i.set("isEdge",C.indexOf("Edg/")>=0),i.set("isFirefox",C.indexOf("Firefox")>=0),i.set("isChrome",C.indexOf("Chrome")>=0),i.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var S;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return a.INSTANCE}static true(){return w.INSTANCE}static has(F){return f.create(F)}static equals(F,W){return v.create(F,W)}static notEquals(F,W){return p.create(F,W)}static regex(F,W){return t.create(F,W)}static in(F,W){return _.create(F,W)}static not(F){return o.create(F)}static and(...F){return l.create(F,null)}static or(...F){return h.create(F,null,!0)}static greater(F,W){return g.create(F,W)}static greaterEquals(F,W){return c.create(F,W)}static smaller(F,W){return E.create(F,W)}static smallerEquals(F,W){return n.create(F,W)}static deserialize(F,W=!1){if(!!F)return this._deserializeOrExpression(F,W)}static _deserializeOrExpression(F,W){let M=F.split("||");return h.create(M.map(B=>this._deserializeAndExpression(B,W)),null,!0)}static _deserializeAndExpression(F,W){let M=F.split("&&");return l.create(M.map(B=>this._deserializeOne(B,W)),null)}static _deserializeOne(F,W){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return p.create(M[0].trim(),this._deserializeValue(M[1],W))}if(F.indexOf("==")>=0){let M=F.split("==");return v.create(M[0].trim(),this._deserializeValue(M[1],W))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],W))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return _.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return E.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?o.create(F.substr(1).trim()):f.create(F)}static _deserializeValue(F,W){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,W){if((0,L.isFalsyOrWhitespace)(F)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),B=F.lastIndexOf("/");if(M===B||M<0){if(W)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(M+1,B),z=F[B+1]==="i"?"i":"";try{return new RegExp(U,z)}catch(K){if(W)throw new Error(`bad regexp-value '${F}', parse error: ${K}`);return console.warn(`bad regexp-value '${F}', parse error: ${K}`),null}}}e.ContextKeyExpr=y;function R(O,F){const W=O?O.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!W&&!M?!0:!W||!M?!1:W.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function P(O,F){return O.cmp(F)}class a{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class w{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class f{constructor(F,W){this.key=F,this.negated=W,this.type=2}static create(F,W=null){const M=i.get(F);return typeof M=="boolean"?M?w.INSTANCE:a.INSTANCE:new f(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:b(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?w.INSTANCE:a.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class v{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=4}static create(F,W,M=null){if(typeof W=="boolean")return W?f.create(F,M):o.create(F,M);const B=i.get(F);return typeof B=="boolean"?W===(B?"true":"false")?w.INSTANCE:a.INSTANCE:new v(F,W,M)}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const W=F?"true":"false";return this.value===W?w.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class _{constructor(F,W){this.key=F,this.valueKey=W,this.type=10,this.negated=null}static create(F,W){return new _(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const W=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray(W)?W.indexOf(M)>=0:typeof M=="string"&&typeof W=="object"&&W!==null?k.call(W,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this)),this.negated}}e.ContextKeyInExpr=_;class A{constructor(F){this._actual=F,this.type=11}static create(F){return new A(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new A(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=A;class p{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=5}static create(F,W,M=null){if(typeof W=="boolean")return W?o.create(F,M):f.create(F,M);const B=i.get(F);return typeof B=="boolean"?W===(B?"true":"false")?a.INSTANCE:w.INSTANCE:new p(F,W,M)}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=i.get(this.key);if(typeof F=="boolean"){const W=F?"true":"false";return this.value===W?a.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class o{constructor(F,W){this.key=F,this.negated=W,this.type=3}static create(F,W=null){const M=i.get(F);return typeof M=="boolean"?M?a.INSTANCE:w.INSTANCE:new o(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:b(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=i.get(this.key);return typeof F=="boolean"?F?a.INSTANCE:w.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function r(O,F){if(typeof O=="string"){const W=parseFloat(O);isNaN(W)||(O=W)}return typeof O=="string"||typeof O=="number"?F(O):a.INSTANCE}class g{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=12}static create(F,W,M=null){return r(W,B=>new g(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class c{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=13}static create(F,W,M=null){return r(W,B=>new c(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class E{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=14}static create(F,W,M=null){return r(W,B=>new E(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=E;class n{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=15}static create(F,W,M=null){return r(W,B=>new n(F,B,M))}cmp(F){return F.type!==this.type?this.type-F.type:I(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,W){this.key=F,this.regexp=W,this.type=7,this.negated=null}static create(F,W){return new t(F,W)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const W=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return W<M?-1:W>M?1:0}equals(F){if(F.type===this.type){const W=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&W===M}return!1}substituteConstants(){return this}evaluate(F){let W=F.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(F){this._actual=F,this.type=8}static create(F){return new s(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new s(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function d(O){let F=null;for(let W=0,M=O.length;W<M;W++){const B=O[W].substituteConstants();if(O[W]!==B&&F===null){F=[];for(let U=0;U<W;U++)F[U]=O[U]}F!==null&&(F[W]=B)}return F===null?O:F}class l{constructor(F,W){this.expr=F,this.negated=W,this.type=6}static create(F,W){return l._normalizeArr(F,W)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const B=P(this.expr[W],F.expr[W]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(F.expr[W]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:l.create(F,this.negated)}evaluate(F){for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].evaluate(F))return!1;return!0}static _normalizeArr(F,W){const M=[];let B=!1;for(const U of F)if(!!U){if(U.type===1){B=!0;continue}if(U.type===0)return a.INSTANCE;if(U.type===6){M.push(...U.expr);continue}M.push(U)}if(M.length===0&&B)return w.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(P);for(let U=1;U<M.length;U++)M[U-1].equals(M[U])&&(M.splice(U,1),U--);if(M.length===1)return M[0];for(;M.length>1;){const U=M[M.length-1];if(U.type!==9)break;M.pop();const z=M.pop(),K=M.length===0,N=h.create(U.expr.map(j=>l.create([j,z],null)),null,K);N&&(M.push(N),M.sort(P))}return M.length===1?M[0]:new l(M,W)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let W of this.expr)F.push(...W.keys());return F}map(F){return new l(this.expr.map(W=>W.map(F)),null)}negate(){if(!this.negated){const F=[];for(let W of this.expr)F.push(W.negate());this.negated=h.create(F,this,!0)}return this.negated}}class h{constructor(F,W){this.expr=F,this.negated=W,this.type=9}static create(F,W,M){return h._normalizeArr(F,W,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const B=P(this.expr[W],F.expr[W]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(F.expr[W]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:h.create(F,this.negated,!1)}evaluate(F){for(let W=0,M=this.expr.length;W<M;W++)if(this.expr[W].evaluate(F))return!0;return!1}static _normalizeArr(F,W,M){let B=[],U=!1;if(F){for(let z=0,K=F.length;z<K;z++){const N=F[z];if(!!N){if(N.type===0){U=!0;continue}if(N.type===1)return w.INSTANCE;if(N.type===9){B=B.concat(N.expr);continue}B.push(N)}}if(B.length===0&&U)return a.INSTANCE;B.sort(P)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(M){for(let z=0;z<B.length;z++)for(let K=z+1;K<B.length;K++)T(B[z],B[K])&&(B.splice(K,1),K--);if(B.length===1)return B[0]}return new h(B,W)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let W of this.expr)F.push(...W.keys());return F}map(F){return new h(this.expr.map(W=>W.map(F)),null)}negate(){if(!this.negated){let F=[];for(let W of this.expr)F.push(W.negate());for(;F.length>1;){const W=F.shift(),M=F.shift(),B=[];for(const z of x(W))for(const K of x(M))B.push(l.create([z,K],null));const U=F.length===0;F.unshift(h.create(B,null,U))}this.negated=F[0]}return this.negated}}class u extends f{constructor(F,W,M){super(F,null);this._defaultValue=W,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:W!=null?typeof W:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return p.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(O,F){return O<F?-1:O>F?1:0}function I(O,F,W,M){return O<W?-1:O>W?1:F<M?-1:F>M?1:0}function T(O,F){if(F.type===6&&O.type!==9&&O.type!==6){for(const B of F.expr)if(O.equals(B))return!0}const W=O.negate(),M=x(W).concat(x(F));M.sort(P);for(let B=0;B<M.length;B++){const z=M[B].negate();for(let K=B+1;K<M.length;K++){const N=M[K];if(z.equals(N))return!0}}return!1}e.implies=T;function x(O){return O.type===9?O.expr:[O]}}),define(ge[182],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[183],pe([0,1,10,156,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function i(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function k(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function S(o,r){switch(o){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function y(o,r){return r==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function R(o,r,g){return y(r,g)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===g?!0:P(g).includes(o)}e.isTargetPlatformCompatible=R;function P(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function a(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=a;var w;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var f;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var v;(function(o){o.Install="install",o.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var _;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var A;(function(o){o.Unsupported="Unsupported",o.UnsupportedPreRelease="UnsupportedPreRelease",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(r,g){super(r);this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ge[184],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(ge[185],pe([0,1,37,10,9,12,94,28,112,158,184]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends a{openTerminal(r,g){return this.spawnTerminal(m,r,S.getWindowsShell(),g)}spawnTerminal(r,g,c,E){const n=g.windowsExec||w.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const t=D.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(n,E?[E]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(t==="wt"||t==="wt.exe")&&s.push("-d ."),new Promise((d,l)=>{const h=_(process),u=r.spawn(c,s,{cwd:E,env:h});u.on("error",l),u.on("exit",()=>d())})}runInTerminal(r,g,c,E,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:w.getDefaultTerminalWindows();return new Promise((s,d)=>{const l=`"${g} - ${P}"`,h=`""${c.join('" "')}" & pause"`,u=["/c","start",l,"/wait",t,"/c",h],b=Object.assign({},_(process),E);Object.keys(b).filter(x=>b[x]===null).forEach(x=>delete b[x]);const I={cwd:g,env:b,windowsVerbatimArguments:!0};m.spawn(w.CMD,u,I).on("error",x=>{d(A(x))}),s(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class f extends a{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,c,E,n){const t=n.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,d)=>{if(t===R.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const l=t===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,Y).fsPath,"-t",r||P,"-w",g];for(let T of c)u.push("-a"),u.push(T);if(E){const T=Object.assign({},_(process),E);for(let x in T){const O=T[x];O===null?(u.push("-u"),u.push(x)):(u.push("-e"),u.push(`${x}=${O}`))}}let b="";const I=m.spawn(f.OSASCRIPT,u);I.on("error",T=>{d(A(T))}),I.stderr.on("data",T=>{b+=T.toString()}),I.on("exit",T=>{if(T===0)s(void 0);else if(b){const x=b.split(`
`,1);d(new Error(x[0]))}else d(new Error(y.localize(1,null,l,T)))})}else d(new Error(y.localize(2,null,t)))})}spawnTerminal(r,g,c){const E=g.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const s=["-a",E];c&&s.push(c);const d=_(process),l=r.spawn("/usr/bin/open",s,{cwd:c,env:d});l.on("error",t),l.on("exit",()=>n())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class v extends a{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,c,E,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,d)=>{let l=[];t.then(h=>{h.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const u=`${p(c)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;l.push(`''${u}''`);const b=Object.assign({},_(process),E);Object.keys(b).filter(O=>b[O]===null).forEach(O=>delete b[O]);const I={cwd:g,env:b};let T="";const x=m.spawn(h,l,I);x.on("error",O=>{d(A(O))}),x.stderr.on("data",O=>{T+=O.toString()}),x.on("exit",O=>{if(O===0)s(void 0);else if(T){const F=T.split(`
`,1);d(new Error(F[0]))}else d(new Error(y.localize(4,null,h,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!v._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)v._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");v._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{r?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,g,c){const E=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{E.then(s=>{const d=_(process),l=r.spawn(s,[],{cwd:c,env:d});l.on("error",t),l.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=y.localize(3,null);function _(o){const r={...o.env};return(0,i.sanitizeProcessEnvironment)(r),r}function A(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(y.localize(5,null,o.path)):o}function p(o){let r="";for(let g of o)g.indexOf(" ")>=0?r+='"'+g+'"':r+=g,r+=" ";return r}}),define(ge[42],pe([0,1,24,9,8,13,2,159,4]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function y(M){return M.create===!0}e.isFileOpenForWriteOptions=y;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(M){M[M.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var a;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=w;function f(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=_;var A;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(B,U){super(B);this.code=U}}e.FileSystemProviderError=p;function o(M,B){const U=new p(M.toString(),B);return g(U,B),U}e.createFileSystemProviderError=o;function r(M){return M||o((0,k.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=r;function g(M,B){return M.name=B?`${B} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function c(M){if(!M)return A.Unknown;if(M instanceof p)return M.code;const B=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!B)return A.Unknown;switch(B[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=c;function E(M){if(M instanceof h)return M.fileOperationResult;switch(c(M)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=E;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(B,U,z){this.resource=B,this.operation=U,this.target=z}isOperation(B){return this.operation===B}}e.FileOperationEvent=t;var s;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class d{constructor(B,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const z=new Map;for(const K of B){const N=z.get(K.type);N?N.push([K.resource,K]):z.set(K.type,[[K.resource,K]])}for(const[K,N]of z)switch(K){case 1:this.added=m.TernarySearchTree.forUris(()=>U),this.added.fill(N);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>U),this.updated.fill(N);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>U),this.deleted.fill(N);break}}contains(B,...U){return this.doContains(B,{includeChildren:!1},...U)}affects(B,...U){return this.doContains(B,{includeChildren:!0},...U)}doContains(B,U,...z){if(!B)return!1;const K=z.length>0;return!!((!K||z.includes(1))&&(this.added?.get(B)||U.includeChildren&&this.added?.findSuperstr(B))||(!K||z.includes(0))&&(this.updated?.get(B)||U.includeChildren&&this.updated?.findSuperstr(B))||(!K||z.includes(2))&&(this.deleted?.findSubstr(B)||U.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function l(M,B,U){return!M||!B||M===B||B.length>M.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),U?(0,D.startsWithIgnoreCase)(M,B):M.indexOf(B)===0)}e.isParent=l;class h extends Error{constructor(B,U,z){super(B);this.fileOperationResult=U,this.options=z}}e.FileOperationError=h;class u extends h{constructor(B,U,z){super(B,2,z);this.stat=U}}e.NotModifiedSinceFileOperationError=u;var b;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=T;async function x(M,B){if(!B.hasProvider(i.URI.from({scheme:M.scheme})))return new Promise(U=>{const z=B.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===M.scheme&&K.added&&(z.dispose(),U())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<O.KB?(0,k.localize)(1,null,B.toFixed(0)):B<O.MB?(0,k.localize)(2,null,(B/O.KB).toFixed(2)):B<O.GB?(0,k.localize)(3,null,(B/O.MB).toFixed(2)):B<O.TB?(0,k.localize)(4,null,(B/O.GB).toFixed(2)):(0,k.localize)(5,null,(B/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function W(M){return{maxFileSize:M===0?300*O.MB:16*O.GB,maxHeapSize:M===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=W}),define(ge[85],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...D){this._entries=new Map;for(let[C,i]of D)this.set(C,i)}set(D,C){const i=this._entries.get(D);return this._entries.set(D,C),i}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=m}),define(ge[186],pe([0,1,18,15,114,179,4,85]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class y extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new k.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=f,this._strict=v,this._parent=_,this._services.set(i.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...v){let _=a.traceInvocation(f),A=!1;try{return f({get:o=>{if(A)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(o,_);if(!r)throw new Error(`[invokeFunction] unknown service '${o}'`);return r}},...v)}finally{A=!0,_.stop()}}createInstance(f,...v){let _,A;return f instanceof D.SyncDescriptor?(_=a.traceCreation(f.ctor),A=this._createInstance(f.ctor,f.staticArguments.concat(v),_)):(_=a.traceCreation(f),A=this._createInstance(f,v,_)),_.stop(),A}_createInstance(f,v=[],_){let A=i._util.getServiceDependencies(f).sort((r,g)=>r.index-g.index),p=[];for(const r of A){let g=this._getOrCreateServiceInstance(r.id,_);if(!g&&this._strict&&!r.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${r.id}.`);p.push(g)}let o=A.length>0?A[0].index:v.length;if(v.length!==o){console.warn(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${v.length} static arguments`);let r=o-v.length;r>0?v=v.concat(new Array(r)):v=v.slice(0,o)}return new f(...[...v,...p])}_setServiceInstance(f,v){if(this._services.get(f)instanceof D.SyncDescriptor)this._services.set(f,v);else if(this._parent)this._parent._setServiceInstance(f,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let v=this._services.get(f);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):v}_getOrCreateServiceInstance(f,v){let _=this._getServiceInstanceOrDescriptor(f);return _ instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,_,v.branch(f,!0)):(v.branch(f,!1),_)}_safeCreateAndCacheServiceInstance(f,v,_){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,v,_)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,v,_){const A=new C.Graph(r=>r.id.toString());let p=0;const o=[{id:f,desc:v,_trace:_}];for(;o.length;){const r=o.pop();if(A.lookupOrInsertNode(r),p++>1e3)throw new y(A);for(let g of i._util.getServiceDependencies(r.desc.ctor)){let c=this._getServiceInstanceOrDescriptor(g.id);if(!c&&!g.optional&&console.warn(`[createInstance] ${f} depends on ${g.id} which is NOT registered.`),c instanceof D.SyncDescriptor){const E={id:g.id,desc:c,_trace:r._trace.branch(g.id,!0)};A.insertEdge(r,E),o.push(E)}}}for(;;){const r=A.roots();if(r.length===0){if(!A.isEmpty())throw new y(A);break}for(const{data:g}of r){if(this._getServiceInstanceOrDescriptor(g.id)instanceof D.SyncDescriptor){const E=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,E)}A.removeNode(g)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,v,_=[],A,p){if(this._services.get(f)instanceof D.SyncDescriptor)return this._createServiceInstance(v,_,A,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,v,_,A,p);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(f,v=[],_,A){if(_){const p=new m.IdleValue(()=>this._createInstance(f,v,A));return new Proxy(Object.create(null),{get(o,r){if(r in o)return o[r];let g=p.value,c=g[r];return typeof c!="function"||(c=c.bind(g),o[r]=c),c},set(o,r,g){return p.value[r]=g,!0}})}else return this._createInstance(f,v,A)}}e.InstantiationService=R;var P;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(P||(P={}));class a{constructor(f,v){this.type=f,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return S?new a(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(f){return S?new a(0,f.name):a._None}branch(f,v){let _=new a(2,f.toString());return this._dep.push([f,v,_]),_}stop(){let f=Date.now()-this._start;a._totals+=f;let v=!1;function _(p,o){let r=[],g=new Array(p+1).join("	");for(const[c,E,n]of o._dep)if(E&&n){v=!0,r.push(`${g}CREATES -> ${c}`);let t=_(p+1,n);t&&r.push(t)}else r.push(`${g}uses -> ${c}`);return r.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(f>2||v)&&console.log(A.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(ge[11],pe([0,1,50,3,6,12,4]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function y(E,n,t){switch(n){case S.Trace:E.trace(t);break;case S.Debug:E.debug(t);break;case S.Info:E.info(t);break;case S.Warning:E.warn(t);break;case S.Error:E.error(t);break;case S.Critical:E.critical(t);break;default:throw new Error("Invalid log level")}}e.log=y;function R(E){let n="";for(let t=0;t<E.length;t++){let s=E[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(d){}n+=(t>0?" ":"")+s}return n}e.format=R;class P extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class a extends P{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,R([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,R([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,R([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,R([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(S.Error,R(s))}else this.log(S.Error,R([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,R([n,...t]))}flush(){}}e.AbstractMessageLogger=a;class w extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class f extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class v extends P{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,m.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class _ extends P{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=_;class A extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=A;class p extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class o{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=o;function r(E){if(E.verbose)return S.Trace;if(typeof E.logLevel=="string"){const n=g(E.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function g(E){switch(E){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=g;function c(E){switch(E){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(ge[187],pe([0,1,42,11]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(k,S,y,R,P){try{const a=await new Promise((f,v)=>{Y(["spdlog"],f,v)});a.setFlushOn(L.LogLevel.Trace);const w=await a.createAsyncRotatingLogger(k,S,y,R);return P&&w.clearFormatters(),w}catch(a){console.error(a)}return null}function C(k,S,y){switch(S){case L.LogLevel.Trace:k.trace(y);break;case L.LogLevel.Debug:k.debug(y);break;case L.LogLevel.Info:k.info(y);break;case L.LogLevel.Warning:k.warn(y);break;case L.LogLevel.Error:k.error(y);break;case L.LogLevel.Critical:k.critical(y);break;default:throw new Error("Invalid log level")}}class i extends L.AbstractMessageLogger{constructor(S,y,R,P,a){super();this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(S,y,R,P),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}async _createSpdLogLogger(S,y,R,P){const a=R?6:1,w=30/a*m.ByteSize.MB,f=await D(S,y,w,a,P);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:v,message:_}of this.buffer)C(this._logger,v,_);this.buffer=[]}}log(S,y){this._logger?C(this._logger,S,y):this.getLevel()<=S&&this.buffer.push({level:S,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=i}),define(ge[116],pe([0,1,48,160,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var i;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(i=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(f,v){return v-f}S.compare=y;const R=Object.create(null);R[S.Error]=(0,L.localize)(0,null),R[S.Warning]=(0,L.localize)(1,null),R[S.Info]=(0,L.localize)(2,null);function P(f){return R[f]||""}S.toString=P;function a(f){switch(f){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=a;function w(f){switch(f){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=w}(i=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const y="";function R(a){return P(a,!0)}S.makeKey=R;function P(a,w){let f=[y];return a.source?f.push(a.source.replace("\xA6","\\\xA6")):f.push(y),a.code?typeof a.code=="string"?f.push(a.code.replace("\xA6","\\\xA6")):f.push(a.code.value.replace("\xA6","\\\xA6")):f.push(y),a.severity!==void 0&&a.severity!==null?f.push(i.toString(a.severity)):f.push(y),a.message&&w?f.push(a.message.replace("\xA6","\\\xA6")):f.push(y),a.startLineNumber!==void 0&&a.startLineNumber!==null?f.push(a.startLineNumber.toString()):f.push(y),a.startColumn!==void 0&&a.startColumn!==null?f.push(a.startColumn.toString()):f.push(y),a.endLineNumber!==void 0&&a.endLineNumber!==null?f.push(a.endLineNumber.toString()):f.push(y),a.endColumn!==void 0&&a.endColumn!==null?f.push(a.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}S.makeKeyOptionalMessage=P})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(ge[188],pe([0,1,3,48,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,D.createDecorator)("notificationService");var C;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var i;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(i=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(ge[189],pe([0,1,6,8,2,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function i(S,y){return D.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,y):(0,L.startsWithIgnoreCase)(S,y+":")}e.matchesScheme=i;function k(S,...y){return y.some(R=>i(S,R))}e.matchesSomeScheme=k}),define(ge[190],pe([0,1,10,12,40,23]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)i=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));i=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const S=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i});var He=this&&this.__param||function(Y,e){return function(m,L){e(m,L,Y)}};define(ge[117],pe([0,1,18,21,6,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var i;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(i=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(P,a){super();this.deferred=new m.DeferredPromise,a.withProgress(P,w=>(this.reporter=w,this.lastStep&&w.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=Ve([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends D.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(P){this.stop();const a=++this.currentOperationId,w=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>w.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:w.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ge[51],pe([0,1,56,13]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(i,k){m.ok(L.isString(i)),m.ok(L.isObject(k)),m.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,k)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new D}),define(ge[191],pe([0,1,3,51]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,y){this.schemasById[D(S)]=y,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new C;L.Registry.add(e.Extensions.JSONContribution,i)}),define(ge[118],pe([0,1,17,3,13,155,191,51]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const R=k.Registry.as(i.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,c=!0){this.registerConfigurations([g],c)}registerConfigurations(g,c=!0){const E=this.doRegisterConfigurations(g,c);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(g){const c=this.doDeregisterConfigurations(g);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:g,remove:c}){const E=[];E.push(...this.doDeregisterConfigurations(c)),E.push(...this.doRegisterConfigurations(g,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(E)})}registerDefaultConfigurations(g){const c=[],E=[];for(const{overrides:n,source:t}of g)for(const s in n)if(c.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const d={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:d});const l={type:"object",default:d,description:C.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:D.isString(t)?void 0:t};E.push(...f(s)),this.configurationProperties[s]=l,this.defaultLanguageConfigurationOverridesNode.properties[s]=l}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const d=this.configurationProperties[s];d&&(this.updatePropertyDefaultValue(s,d),this.updateSchema(s,d))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const c=[];for(const{overrides:E,source:n}of g)for(const t in E){const s=this.configurationDefaultsOverrides.get(t),d=D.isString(n)?n:n?.id,l=D.isString(s?.source)?s?.source:s?.source?.id;if(d===l)if(c.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const c of g)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,c){const E=[];return g.forEach(n=>{E.push(...this.validateAndRegisterProperties(n,c,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),E}doDeregisterConfigurations(g){const c=[],E=n=>{if(n.properties)for(const t in n.properties)c.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>E(t))};for(const n of g){E(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return c}validateAndRegisterProperties(g,c=!0,E,n,t=3){t=D.isUndefinedOrNull(g.scope)?t:g.scope;let s=[],d=g.properties;if(d)for(let h in d){if(c&&p(h)){delete d[h];continue}const u=d[h];if(u.source=E,u.defaultDefaultValue=d[h].default,this.updatePropertyDefaultValue(h,u),e.OVERRIDE_PROPERTY_REGEX.test(h)?u.scope=void 0:(u.scope=D.isUndefinedOrNull(u.scope)?t:u.scope,u.restricted=D.isUndefinedOrNull(u.restricted)?!!n?.includes(h):u.restricted),d[h].hasOwnProperty("included")&&!d[h].included){this.excludedConfigurationProperties[h]=d[h],delete d[h];continue}else this.configurationProperties[h]=d[h];!d[h].deprecationMessage&&d[h].markdownDeprecationMessage&&(d[h].deprecationMessage=d[h].markdownDeprecationMessage),s.push(h)}let l=g.allOf;if(l)for(let h of l)s.push(...this.validateAndRegisterProperties(h,c,E,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const c=E=>{let n=E.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=E.allOf;t&&t.forEach(c)};c(g)}updateSchema(g,c){switch(e.allSettings.properties[g]=c,c.scope){case 1:e.applicationSettings.properties[g]=c;break;case 2:e.machineSettings.properties[g]=c;break;case 6:e.machineOverridableSettings.properties[g]=c;break;case 3:e.windowSettings.properties[g]=c;break;case 4:e.resourceSettings.properties[g]=c;break;case 5:e.resourceSettings.properties[g]=c,this.resourceLanguageSettingsSchema.properties[g]=c;break}}removeFromSchema(g,c){switch(delete e.allSettings.properties[g],c.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const c=`[${g}]`,E={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,E),e.allSettings.properties[c]=E,e.applicationSettings.properties[c]=E,e.machineSettings.properties[c]=E,e.machineOverridableSettings.properties[c]=E,e.windowSettings.properties[c]=E,e.resourceSettings.properties[c]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,c){const E=this.configurationDefaultsOverrides.get(g);let n=E?.value,t=E?.source;D.isUndefined(n)&&(n=c.defaultDefaultValue,t=void 0),D.isUndefined(n)&&(n=_(c.type)),c.default=n,c.defaultValueSource=t}}const a="\\[([^\\]]+)\\]",w=new RegExp(a,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${a})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(r){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let c=w.exec(r);for(;c?.length;){const E=c[1].trim();E&&g.push(E),c=w.exec(r)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=f;function v(r){return r.reduce((g,c)=>`${g}[${c}]`,"")}e.keyFromOverrideIdentifiers=v;function _(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const A=new P;k.Registry.add(e.Extensions.Configuration,A);function p(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):A.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=p;function o(){const r=[],g=A.getConfigurationProperties();for(const c of Object.keys(g))r.push([c,g[c].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=o}),define(ge[192],pe([0,1,17,3,58,6,24,25,13,2,115,118,51]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,R.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,R.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return m.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=k.deepClone(this.contents),s=k.deepClone(this.overrides),d=[...this.keys];for(const l of n){this.mergeContents(t,l.contents);for(const h of l.overrides){const[u]=s.filter(b=>m.equals(b.identifiers,h.identifiers));u?(this.mergeContents(u.contents,h.contents),u.keys.push(...h.keys),u.keys=m.distinct(u.keys)):s.push(k.deepClone(h))}for(const h of l.keys)d.indexOf(h)===-1&&d.push(h)}return new w(t,d,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const d of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[d],h=t[d];h&&(typeof l=="object"&&typeof h=="object"?(l=k.deepClone(l),this.mergeContents(l,h)):l=h),s[d]=l}return new w(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&S.isObject(n[s])&&S.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=k.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const d=l=>{l&&(s?this.mergeContents(s,l):s=k.deepClone(l))};for(const l of this.overrides)m.equals(l.identifiers,[n])?t=l.contents:l.identifiers.includes(n)&&d(l.contents);return d(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,R.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,R.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=w;class f extends w{constructor(n={}){const t=a.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),d=Object.create(null),l=[];for(const h in t){const u=n[h],b=u!==void 0?u:t[h].default;(0,R.addToValueTree)(d,h,b,I=>console.error(`Conflict in default settings: ${I}`))}for(const h of Object.keys(d))P.OVERRIDE_PROPERTY_REGEX.test(h)&&l.push({identifiers:(0,P.overrideIdentifiersFromKey)(h),keys:Object.keys(d[h]),contents:(0,R.toValuesTree)(d[h],u=>console.error(`Conflict in default settings file: ${u}`))});super(d,s,l)}}e.DefaultConfigurationModel=f;class v{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:d,overrides:l,restricted:h}=this.doParseRaw(n,t);this._configurationModel=new w(s,d,l),this._restrictedConfigurations=h||[]}doParseContent(n){let t={},s=null,d=[],l=[],h=[];function u(I){Array.isArray(d)?d.push(I):s!==null&&(d[s]=I)}let b={onObjectBegin:()=>{let I={};u(I),l.push(d),d=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{d=l.pop()},onArrayBegin:()=>{let I=[];u(I),l.push(d),d=I,s=null},onArrayEnd:()=>{d=l.pop()},onLiteralValue:u,onError:(I,T,x)=>{h.push({error:I,offset:T,length:x})}};if(n)try{D.visit(n,b),t=d[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return t}doParseRaw(n,t){const s=a.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),d=this.filter(n,s,!0,t);n=d.raw;const l=(0,R.toValuesTree)(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),h=Object.keys(n),u=this.toOverrides(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:l,keys:h,overrides:u,restricted:d.restricted}}filter(n,t,s,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:n,restricted:[]};const l={},h=[];for(let u in n)if(P.OVERRIDE_PROPERTY_REGEX.test(u)&&s){const b=this.filter(n[u],t,!1,d);l[u]=b.raw,h.push(...b.restricted)}else{const b=t[u],I=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&h.push(u),(I===void 0||d.scopes===void 0||d.scopes.includes(I))&&(d.skipRestricted&&b?.restricted||(l[u]=n[u]))}return{raw:l,restricted:h}}toOverrides(n,t){const s=[];for(const d of Object.keys(n))if(P.OVERRIDE_PROPERTY_REGEX.test(d)){const l={};for(const h in n[d])l[h]=n[d][h];s.push({identifiers:(0,P.overrideIdentifiersFromKey)(d),keys:Object.keys(l),contents:(0,R.toValuesTree)(l,t)})}return s}}e.ConfigurationModelParser=v;class _ extends C.Disposable{constructor(n,t,s,d){super();this.userSettingsResource=n,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class A{constructor(n,t,s=new w,d=new w,l=new i.ResourceMap,h=new w,u=new i.ResourceMap,b=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=d,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=u,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let d;s.resource?(d=this._memoryConfigurationByResource.get(s.resource),d||(d=new w,this._memoryConfigurationByResource.set(s.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(n):d.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const d=this.getConsolidateConfigurationModel(t,s),l=this.getFolderConfigurationModelForResource(t.resource,s),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,u=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),b=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),I=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),T=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),x=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,O=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,F=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(n):h.getValue(n),W=d.getValue(n),M=m.distinct(m.flatten(d.overrides.map(B=>B.identifiers))).filter(B=>d.getOverrideValue(n,B)!==void 0);return{defaultValue:u,userValue:b,userLocalValue:I,userRemoteValue:T,workspaceValue:x,workspaceFolderValue:O,memoryValue:F,value:W,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:l?.freeze().getValue(n),override:t.overrideIdentifier?l?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:h.getValue(n),override:t.overrideIdentifier?h.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n){const{added:t,updated:s,removed:d,overrides:l}=g(this._defaultConfiguration,n),h=[...t,...s,...d];return h.length&&this.updateDefaultConfiguration(n),{keys:h,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:d,overrides:l}=g(this.localUserConfiguration,n),h=[...t,...s,...d];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:d,overrides:l}=g(this.remoteUserConfiguration,n);let h=[...t,...s,...d];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:d,overrides:l}=g(this.workspaceConfiguration,n);let h=[...t,...s,...d];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:l}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:d,updated:l,removed:h,overrides:u}=g(s,t);let b=[...d,...l,...h];return(b.length||!s)&&this.updateFolderConfiguration(n,t),{keys:b,overrides:u}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:d,removed:l,overrides:h}=g(t,void 0);return{keys:[...s,...d,...l],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const d=t.getFolder(n);d&&(s=this.getFolderConsolidatedConfiguration(d.uri)||s);const l=this._memoryConfigurationByResource.get(n);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(n);d?(t=s.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:d,keys:l}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:d,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(d=>t.add(d))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((h,u)=>(h.set(y.URI.revive(u[0]),this.parseConfigurationModel(u[1])),h),new i.ResourceMap);return new A(t,s,new w,d,l,new w,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new w(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=A;function p(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const n=new Set,t=new Map;for(const d of E)d.keys.forEach(l=>n.add(l)),d.overrides.forEach(([l,h])=>{const u=(0,i.getOrSet)(t,l,new Set);h.forEach(b=>u.add(b))});const s=[];return t.forEach((d,l)=>s.push([l,[...d.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=p;class o{constructor(n,t,s,d){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=d,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(u=>l.add(u)),n.overrides.forEach(([,u])=>u.forEach(b=>l.add(b))),this.affectedKeys=[...l.values()];const h=new w;this.affectedKeys.forEach(u=>h.setValue(u,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!k.equals(s,d)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,R.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof s=="object"&&(d=Object.keys(s)[0]);){if(n=n[d],!n)return!1;s=s[d]}return!0}}e.ConfigurationChangeEvent=o;class r extends o{constructor(n,t,s,d){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function g(E,n){const{added:t,removed:s,updated:d}=c(n,E),l=[],h=E?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const b=u.filter(I=>!h.includes(I));for(const I of b)l.push([I,n.getKeysForOverrideIdentifier(I)])}if(E){const b=h.filter(I=>!u.includes(I));for(const I of b)l.push([I,E.getKeysForOverrideIdentifier(I)])}if(n&&E){for(const b of h)if(u.includes(b)){const I=c({contents:E.getOverrideValue(void 0,b)||{},keys:E.getKeysForOverrideIdentifier(b)},{contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)});l.push([b,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:s,updated:d,overrides:l}}function c(E,n){const t=E?n?E.keys.filter(l=>n.keys.indexOf(l)===-1):[...E.keys]:[],s=n?E?n.keys.filter(l=>E.keys.indexOf(l)===-1):[...n.keys]:[],d=[];if(E&&n){for(const l of n.keys)if(E.keys.indexOf(l)!==-1){const h=(0,R.getConfigurationValue)(n.contents,l),u=(0,R.getConfigurationValue)(E.contents,l);k.equals(h,u)||d.push(l)}}return{added:t,removed:s,updated:d}}}),define(ge[119],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(i,k=L.Unknown,S){super(i);this._message=i,this._code=k,this._detail=S,this.isHandled=k===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(i){return i instanceof D&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof D&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof D&&i.isHandled}}e.RemoteAuthorityResolverError=D}),define(ge[62],pe([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===m.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function D(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.getRemoteName=D;function C(y){return y.scheme!==m.Schemas.file&&y.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function i(y){if(y.folders.length)return y.folders.every(R=>C(R.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=i;function k(y){return i(y)?.scheme}e.getVirtualWorkspaceScheme=k;function S(y){return i(y)!==void 0}e.isVirtualWorkspace=S}),define(ge[27],pe([0,1,8,4,62]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=C;function i(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,f){if(typeof w=="undefined"||w===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof w=="string"||typeof f=="string"){let v=typeof w=="string"?w:w.value,_=typeof f=="string"?f:f.value;return m.equalsIgnoreCase(v,_)}return w._lower===f._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=S;function y(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function R(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function P(a,w){if(w){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return a.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[193],pe([0,1,8,27]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(f,v){return f.uuid&&v.uuid?f.uuid===v.uuid:f.id===v.id?!0:(0,m.compareIgnoreCase)(f.id,v.id)===0}e.areSameExtensions=D;class C{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof C?D(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=C;function i(f,v){return`${f}.${v}`}e.getExtensionId=i;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(f,v){return k(i(f,v))}e.getGalleryExtensionId=S;function y(f,v){const _=[],A=p=>{for(const o of _)if(o.some(r=>D(v(r),v(p))))return o;return null};for(const p of f){const o=A(p);o?o.push(p):_.push([p])}return _}e.groupByExtension=y;function R(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function P(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function a(f){const v=new Set;if(f.malicious)for(const _ of f.malicious)v.add(_.id);return v}e.getMaliciousExtensionsSet=a;function w(f,v){const _=[],A=v.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const p=A.shift();if(p&&_.every(o=>!D(o.identifier,{id:p}))){const o=f.filter(r=>D(r.identifier,{id:p}));o.length===1&&(_.push(o[0]),A.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=w}),define(ge[120],pe([0,1,3,12,4,11]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var i;(function(f){f.Http="http",f.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=P;function a(f,v){return v?v!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=a;let w=class{constructor(v){this.logService=v,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v,_){return this._tunnelProvider=v,v?(this._canElevate=_.elevation,this._privacyOptions=_.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],_=Array.from(this._tunnels.values());for(let A of _){const p=Array.from(A.values());for(let o of p){const r=await o.value;r&&v.push(r)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:_}of v.values())await _.then(A=>A?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,_,A,p,o=!1,r=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${_}:${A} on local port ${p}.`),!v)return;_||(_="localhost");const c=this.retainOrCreateTunnel(v,_,A,p,o,r,g);return c?c.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(_,A);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(E);return(E.tunnelRemoteHost!==_||E.tunnelRemotePort!==A)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const _=this._tunnels.get(v.tunnelRemoteHost);if(_){const A=_.get(v.tunnelRemotePort);A&&(A.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,A))}}}}async tryDisposeTunnel(v,_,A){if(A.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${_}.`);const p=A.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(_),p}}async closeTunnel(v,_){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${_} `);const A=this._tunnels.get(v);if(A&&A.has(_)){const p=A.get(_);p.refcount=0,await this.tryDisposeTunnel(v,_,p)}}addTunnelToMap(v,_,A){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(_,{refcount:1,value:A})}async removeEmptyTunnelFromMap(v,_){const A=this._tunnels.get(v);A&&(await A.get(_)||A.delete(_),A.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,_){let A=[v];R(v)?(A.push(...e.LOCALHOST_ADDRESSES),A.push(...e.ALL_INTERFACES_ADDRESSES)):P(v)&&A.push(...e.ALL_INTERFACES_ADDRESSES);const p=A.map(o=>this._tunnels.get(o));for(const o of p){const r=o?.get(_);if(r)return r}}canTunnel(v){return!!y(v)}createWithProvider(v,_,A,p,o,r,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${_}:${A} on local port ${p}.`);const E={elevationRequired:o?a(p===void 0?A:p):!1},n={remoteAddress:{host:_,port:A},localAddressPort:p,privacy:r,public:r!==k.Private,protocol:g},t=v.forwardPort(n,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(_,A,t),t}};w=Ve([He(0,C.ILogService)],w),e.AbstractTunnelService=w}),define(ge[194],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>Y(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),i=new C.validator;if(i){const k=String(m._nextId++);return this.validators.set(k,i),{id:k,data:i.createNewMessage(D)}}}catch(C){}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const i=this.validators.get(D.id);if(!i)return!1;this.validators.delete(D.id);try{return i.validate(C)==="ok"}catch(k){return!1}}async sign(D){try{const C=await this.vsda(),i=new C.signer;if(i)return i.sign(D)}catch(C){}return D}}e.SignService=m,m._nextId=1}),define(ge[195],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,C,i=5){let k;return k=C(S=>{const y=typeof S=="string"?S:S.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(y);return}const P=setTimeout(()=>this.flushBuffer(D),i);R={data:[y],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,R)}),k}stopBuffering(D){const C=this._terminalBufferMap.get(D);C&&C.dispose()}flushBuffer(D){const C=this._terminalBufferMap.get(D);C&&(this._terminalBufferMap.delete(D),this._callback(D,C.data.join("")))}}e.TerminalDataBufferer=m}),define(ge[196],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(ge[86],pe([0,1,78,3,6,4,51,196]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(_){function A(p){return p&&typeof p=="object"&&typeof p.id=="string"}_.isThemeColor=A})(S=e.ThemeColor||(e.ThemeColor={}));function y(_){return{id:_}}e.themeColorFromId=y;var R;(function(_){function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}_.isThemeIcon=A;const p=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function o(n){const t=p.exec(n);if(!t)return;let[,s]=t;return{id:s}}_.fromString=o;function r(n,t){let s=n.id;const d=s.lastIndexOf("~");return d!==-1&&(s=s.substring(0,d)),t&&(s=`${s}~${t}`),{id:s}}_.modify=r;function g(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}_.getModifier=g;function c(n,t){return n.id===t.id&&n.color?.id===t.color?.id}_.isEqual=c;function E(n,t){return{id:n.id,color:t?y(t):void 0}}_.asThemeIcon=E,_.asClassNameArray=m.CSSIcon.asClassNameArray,_.asClassName=m.CSSIcon.asClassName,_.asCSSSelector=m.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function P(_){switch(_){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,D.toDisposable)(()=>{const p=this.themingParticipants.indexOf(A);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new a;i.Registry.add(e.Extensions.ThemingContribution,w);function f(_){return w.onColorThemeChange(_)}e.registerThemingParticipant=f;class v extends D.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,p){let o=this.theme.getColor(A);return o&&p&&(o=p(o,this.theme)),o?o.toString():null}}e.Themable=v}),define(ge[43],pe([0,1,24,23,2,4]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var i;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(i=e.WorkbenchState||(e.WorkbenchState={}));function k(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=k;function S(a){const w=a;return!!(w&&typeof w=="object"&&D.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=S;class y{constructor(w,f,v,_,A){this._id=w,this._transient=v,this._configuration=_,this._ignorePathCasing=A,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class R{constructor(w,f){this.raw=f,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function P(a){return new R({uri:a,index:0,name:(0,L.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=P}),define(ge[197],pe([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(M){return(typeof M=="string"?(0,k.extname)(M):(0,y.extname)(M))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function A(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function r(M){const B=M;return typeof B?.id=="string"&&R.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=r;function g(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=g;function c(M){const B=M;return typeof B?.id=="string"&&R.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=c;function E(M){const B=M;if(B?.uri)return{id:B.id,uri:R.URI.revive(B.uri)};const U=M;if(U?.configPath)return{id:U.id,configPath:R.URI.revive(U.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=E;function n(M,B){return y.extUriBiasedIgnorePathCase.isEqualOrParent(M,B.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function t(M){return s(M)||d(M)}e.isStoredWorkspaceFolder=t;function s(M){const B=M;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=s;function d(M){const B=M;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function l(M,B,U,z,K=!S.isWindows,N){if(M.scheme!==z.scheme)return{name:U,uri:M.toString(!0)};let j=B?void 0:N.relativePath(z,M);if(j!==void 0)j.length===0?j=".":S.isWindows&&M.scheme===i.Schemas.file&&!K&&(j=j.replace(/\//g,"\\"));else if(M.scheme===i.Schemas.file)j=M.fsPath,S.isWindows&&(j=(0,C.normalizeDriveLetter)(j),K&&(j=(0,m.toSlashes)(j)));else{if(!N.isEqualAuthority(M.authority,z.authority))return{name:U,uri:M.toString(!0)};j=M.path}return{name:U,path:j}}e.getStoredWorkspaceFolder=l;function h(M,B,U){let z=[],K=new Set;const N=U.dirname(B);for(let j of M){let H;if(s(j))j.path&&(H=U.resolvePath(N,j.path));else if(d(j))try{H=R.URI.parse(j.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(V){console.warn(V)}if(H){let V=U.getComparisonKey(H);if(!K.has(V)){K.add(V);const q=j.name||U.basenameOrAuthority(H);z.push(new f.WorkspaceFolder({uri:H,name:q,index:z.length},j))}}}return z}e.toWorkspaceFolders=h;function u(M,B,U,z,K){let N=b(B,M);const j=K.dirname(B),H=K.dirname(z),V=[],q=I(N.folders);for(const ke of N.folders){const Ue=s(ke)?K.resolvePath(j,ke.path):R.URI.parse(ke.uri);let xe;U?xe=!1:xe=!s(ke)||(0,k.isAbsolute)(ke.path),V.push(l(Ue,xe,ke.name,H,q,K))}const te={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},fe=D.setProperty(M,["folders"],V,te);let Ce=D.applyEdits(M,fe);return(0,y.isEqualAuthority)(N.remoteAuthority,(0,w.getRemoteAuthority)(z))&&(Ce=D.applyEdits(Ce,D.removeProperty(Ce,["remoteAuthority"],te))),Ce}e.rewriteWorkspaceFileForNewLocation=u;function b(M,B){let U=L.parse(B);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(z=>t(z));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function I(M){return S.isWindows?M.some(B=>s(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=I;function T(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function x(M){return typeof M.folderUri=="string"}function O(M){return typeof M.fileUri=="string"}function F(M,B){const U={workspaces:[],files:[]};if(M){const z=function(N,j){for(let H=0;H<N.length;H++)try{j(N[H],H)}catch(V){B.warn(`Error restoring recent entry ${JSON.stringify(N[H])}: ${V.toString()}. Skip entry.`)}},K=M;if(Array.isArray(K.entries))z(K.entries,N=>{const j=N.label,H=N.remoteAuthority;T(N)?U.workspaces.push({label:j,remoteAuthority:H,workspace:{id:N.workspace.id,configPath:R.URI.parse(N.workspace.configPath)}}):x(N)?U.workspaces.push({label:j,remoteAuthority:H,folderUri:R.URI.parse(N.folderUri)}):O(N)&&U.files.push({label:j,remoteAuthority:H,fileUri:R.URI.parse(N.fileUri)})});else{const N=M;Array.isArray(N.workspaces3)&&z(N.workspaces3,(j,H)=>{const V=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[H]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:V,workspace:{id:j.id,configPath:R.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:V,folderUri:R.URI.parse(j)})}),Array.isArray(N.files2)&&z(N.files2,(j,H)=>{const V=Array.isArray(N.fileLabels)&&N.fileLabels[H]||void 0;typeof j=="string"&&U.files.push({label:V,fileUri:R.URI.parse(j)})})}}return U}e.restoreRecentlyOpened=F;function W(M){const B={entries:[]};for(const U of M.workspaces)p(U)?B.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):B.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)B.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return B}e.toStoreData=W}),define(ge[87],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const C=this._idPool++;return this._data.set(C,D),this.logDebugInfo(),C}get(D,C){return this._data.has(D)?this._data.get(D)[C]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(ge[44],pe([0,1,10,23,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(ge[26],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(ge[198],pe([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(i,k,S){this._deferredPromises=new Map,this._id=i,this._shared=k,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of y.values())R.complete()}catch(R){for(const P of y.values())P.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,i])=>i!==void 0).map(([i])=>i)}get whenReady(){return this._init}get(i,k){let S=this._value[i];return typeof S=="undefined"&&(S=k),S}update(i,k){this._value[i]=k;let S=this._deferredPromises.get(i);if(S!==void 0)return S.p;const y=new m.DeferredPromise;return this._deferredPromises.set(i,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class D extends L{constructor(i,k){super(i.identifier.value,!0,k);this._extension=i}setKeysForSync(i){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},i)}}e.ExtensionGlobalMemento=D}),define(ge[199],pe([0,1,3,2,11]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,y){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(S.value,y)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));y.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:y.apiNotebook})}};C=Ve([He(0,D.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ge[14],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[200],pe([0,1,27,3]),function(Y,e,m,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,S){D.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),ot(this,D,S,"f"),Oe(this,D,"f").onDidChangePassword(y=>{y.extensionId===this._id&&this._onDidChange.fire({key:y.key})})}get(k){return Oe(this,D,"f").get(this._id,k)}store(k,S){return Oe(this,D,"f").store(this._id,k,S)}delete(k){return Oe(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=C,D=new WeakMap}),define(ge[121],pe([0,1,4,3]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(i){this._enabled=i}$onDidChangeTelemetryEnabled(i){this._enabled=i,this._onDidChangeTelemetryEnabled.fire(i)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(ge[63],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,D=(p,o)=>{const r={controllerId:o};return L.set(p,r),r};e.createPrivateApiFor=D;const C=p=>L.get(p);e.getPrivateApiFor=C;const i=(p,o,r,g)=>{let c=r;return{enumerable:!0,configurable:!1,get(){return c},set(E){if(!g(c,E)){const n=c;c=E,p.listener?.({op:3,key:o,value:E,previous:n})}}}},k=(p,o)=>p===o,S={range:(p,o)=>p===o?!0:!p||!o?!1:p.isEqual(o),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(p,o)=>!(p.length!==o.length||p.some(r=>!o.find(g=>r.id===g.id)))},y=Object.keys(S),R=(p,o)=>({range:i(p,"range",void 0,S.range),label:i(p,"label",o,S.label),description:i(p,"description",void 0,S.description),canResolveChildren:i(p,"canResolveChildren",!1,S.canResolveChildren),busy:i(p,"busy",!1,S.busy),error:i(p,"error",void 0,S.error),tags:i(p,"tags",[],S.tags)}),P=(p,o)=>{const r=new Map;for(const g of y)S[g](p[g],o[g])||r.set(g,o[g]);return r};e.diffTestItems=P;class a extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=a;class w extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class f extends Error{constructor(o,r,g){super(`TestItem with ID "${o}" is from controller "${r}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=f;const v=p=>{const o=(0,e.getPrivateApiFor)(p);let r=new Map;return{get size(){return r.size},forEach(g,c){for(const E of r.values())g.call(c,E,this)},replace(g){const c=new Map,E=new Set(r.keys()),n={op:4,ops:[]};for(const t of g){if(!(t instanceof _))throw new w(t.id);const s=(0,e.getPrivateApiFor)(t).controllerId;if(s!==o.controllerId)throw new f(t.id,s,o.controllerId);if(c.has(t.id))throw new a(t.id);c.set(t.id,t),E.delete(t.id),n.ops.push({op:0,item:t})}for(const t of E.keys())n.ops.push({op:1,id:t});o.listener?.(n),r=c},add(g){if(!(g instanceof _))throw new w(g.id);r.set(g.id,g),o.listener?.({op:0,item:g})},delete(g){r.delete(g)&&o.listener?.({op:1,id:g})},get(g){return r.get(g)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class _{constructor(o,r,g,c){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const E=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof A?void 0:E.parent}},children:{value:v(this),enumerable:!0,writable:!1},...R(E,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class A extends _{constructor(o,r){super(o,o,r,void 0)}}e.TestItemRootImpl=A}),define(ge[52],pe([0,1,4,120,3,14]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var i;(function(S){function y(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=y;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==L.TunnelPrivacyId.ConstantPrivate&&P.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(i=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(y){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,R){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,R){return{dispose:()=>{}}}async $providePortAttributes(y,R,P,a,w){return[]}async $forwardPort(y,R){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([He(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[7],pe([0,1,17,15,97,24,101,8,13,2,32,42,119]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a){"use strict";var w,f,v,_,A,p,o,r,g,c,E,n,t,s,d,l,h,u,b,I;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(G){function $(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf($,G),Object.setPrototypeOf($.prototype,G.prototype),$}let x=A=class{constructor($){w.set(this,void 0),ot(this,w,$,"f")}static from(...$){let oe=$;return new A(function(){if(oe){for(const Pe of oe)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();oe=void 0}})}dispose(){typeof Oe(this,w,"f")=="function"&&(Oe(this,w,"f").call(this),ot(this,w,void 0,"f"))}};w=new WeakMap,x=A=Ve([T],x),e.Disposable=x;let O=p=class{constructor($,oe){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=oe}static Min(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let Pe=1;Pe<$.length;Pe++){const Je=$[Pe];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let Pe=1;Pe<$.length;Pe++){const Je=$[Pe];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition($){if(!$)return!1;if($ instanceof p)return!0;let{line:oe,character:Pe}=$;return typeof oe=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,oe=0){if($===null||oe===null)throw(0,L.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=0:typeof $=="number"?Pe=$:(Pe=typeof $.lineDelta=="number"?$.lineDelta:0,oe=typeof $.characterDelta=="number"?$.characterDelta:0),Pe===0&&oe===0?this:new p(this.line+Pe,this.character+oe)}with($,oe=this.character){if($===null||oe===null)throw(0,L.illegalArgument)();let Pe;return typeof $=="undefined"?Pe=this.line:typeof $=="number"?Pe=$:(Pe=typeof $.line=="number"?$.line:this.line,oe=typeof $.character=="number"?$.character:this.character),Pe===this.line&&oe===this.character?this:new p(Pe,oe)}toJSON(){return{line:this.line,character:this.character}}};O=p=Ve([T],O),e.Position=O;let F=o=class{constructor($,oe,Pe,Je){let ct,dt;if(typeof $=="number"&&typeof oe=="number"&&typeof Pe=="number"&&typeof Je=="number"?(ct=new O($,oe),dt=new O(Pe,Je)):$ instanceof O&&oe instanceof O&&(ct=$,dt=oe),!ct||!dt)throw new Error("Invalid arguments");ct.isBefore(dt)?(this._start=ct,this._end=dt):(this._start=dt,this._end=ct)}static isRange($){return $ instanceof o?!0:$?O.isPosition($.start)&&O.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof o?this.contains($._start)&&this.contains($._end):$ instanceof O?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const oe=O.Max($.start,this._start),Pe=O.Min($.end,this._end);if(!oe.isAfter(Pe))return new o(oe,Pe)}union($){if(this.contains($))return this;if($.contains(this))return $;const oe=O.Min($.start,this._start),Pe=O.Max($.end,this.end);return new o(oe,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,oe=this.end){if($===null||oe===null)throw(0,L.illegalArgument)();let Pe;return $?O.isPosition($)?Pe=$:(Pe=$.start||this.start,oe=$.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&oe.isEqual(this.end)?this:new o(Pe,oe)}toJSON(){return[this.start,this.end]}};F=o=Ve([T],F),e.Range=F;let W=r=class extends F{constructor($,oe,Pe,Je){let ct,dt;if(typeof $=="number"&&typeof oe=="number"&&typeof Pe=="number"&&typeof Je=="number"?(ct=new O($,oe),dt=new O(Pe,Je)):$ instanceof O&&oe instanceof O&&(ct=$,dt=oe),!ct||!dt)throw new Error("Invalid arguments");super(ct,dt);this._anchor=ct,this._active=dt}static isSelection($){return $ instanceof r?!0:$?F.isRange($)&&O.isPosition($.anchor)&&O.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=r=Ve([T],W),e.Selection=W;class M{constructor($,oe,Pe){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(oe),this.connectionToken=Pe}}e.ResolvedAuthority=M;class B extends Error{constructor($,oe=a.RemoteAuthorityResolverErrorCode.Unknown,Pe){super($);this._message=$,this._code=oe,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable($,oe){return new B($,a.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable($){return new B($,a.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var U;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var z;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=g=class{constructor($,oe){this._range=$,this._newText=oe}static isTextEdit($){return $ instanceof g?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,oe){return new g($,oe)}static insert($,oe){return g.replace(new F($,$),oe)}static delete($){return g.replace($,"")}static setEndOfLine($){const oe=new g(new F(new O(0,0),new O(0,0)),"");return oe.newEol=$,oe}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};K=g=Ve([T],K),e.TextEdit=K;var N;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(N=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,oe,Pe,Je){this._edits.push({_type:1,from:$,to:oe,options:Pe,metadata:Je})}createFile($,oe,Pe){this._edits.push({_type:1,from:void 0,to:$,options:oe,metadata:Pe})}deleteFile($,oe,Pe){this._edits.push({_type:1,from:$,to:void 0,options:oe,metadata:Pe})}replaceNotebookMetadata($,oe,Pe){this._edits.push({_type:3,metadata:Pe,uri:$,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells($,oe,Pe,Je,ct){let dt,ft,Pt=[],Ft;if(Ne.isNotebookRange(oe)&&Ot.isNotebookCellDataArray(Pe)&&!Ot.isNotebookCellDataArray(Je)?(dt=oe.start,ft=oe.end,Pt=Pe,Ft=Je):typeof oe=="number"&&typeof Pe=="number"&&Ot.isNotebookCellDataArray(Je)&&(dt=oe,ft=Pe,Pt=Je,Ft=ct),dt===void 0||ft===void 0)throw new Error("Invalid arguments");(dt!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:$,index:dt,count:ft-dt,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata($,oe,Pe,Je){this._edits.push({_type:3,metadata:Je,uri:$,edit:{editType:8,index:oe,metadata:Pe}})}replace($,oe,Pe,Je){this._edits.push({_type:2,uri:$,edit:new K(oe,Pe),metadata:Je})}insert($,oe,Pe,Je){this.replace($,new F(oe,oe),Pe,Je)}delete($,oe,Pe){this.replace($,oe,"",Pe)}has($){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===$.toString())}set($,oe){if(oe)for(const Pe of oe)Pe&&this._edits.push({_type:2,uri:$,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const Je=this._edits[Pe];Je._type===2&&Je.uri.toString()===$.toString()&&(this._edits[Pe]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const oe=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===$.toString()&&oe.push(Pe.edit);return oe}entries(){const $=new C.ResourceMap;for(let oe of this._edits)if(oe._type===2){let Pe=$.get(oe.uri);Pe||(Pe=[oe.uri,[]],$.set(oe.uri,Pe)),Pe[1].push(oe.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=Ve([T],j),e.WorkspaceEdit=j;let H=c=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof c?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=c._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,oe=this._tabstop++){if(typeof $=="function"){const Pe=new c;Pe._tabstop=this._tabstop,$(Pe),this._tabstop=Pe._tabstop,$=Pe.value}else $=c._escape($);return this.value+="${",this.value+=oe,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,oe=this._tabstop++){const Pe=$.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable($,oe){if(typeof oe=="function"){const Pe=new c;Pe._tabstop=this._tabstop,oe(Pe),this._tabstop=Pe._tabstop,oe=Pe.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};H=c=Ve([T],H),e.SnippetString=H;var V;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(V=e.DiagnosticTag||(e.DiagnosticTag={}));var q;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let te=E=class{constructor($,oe){if(this.uri=$,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof O)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof E?!0:$?F.isRange($.range)&&y.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};te=E=Ve([T],te),e.Location=te;let fe=class{constructor($,oe){this.location=$,this.message=oe}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&y.URI.isUri($.location.uri):!1}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.location.range.isEqual(oe.location.range)&&$.location.uri.toString()===oe.location.uri.toString()}};fe=Ve([T],fe),e.DiagnosticRelatedInformation=fe;let Ce=class{constructor($,oe,Pe=q.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=$,this.message=oe,this.severity=Pe}toJSON(){return{severity:q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.severity===oe.severity&&$.code===oe.code&&$.severity===oe.severity&&$.source===oe.source&&$.range.isEqual(oe.range)&&(0,m.equals)($.tags,oe.tags)&&(0,m.equals)($.relatedInformation,oe.relatedInformation,fe.isEqual)}};Ce=Ve([T],Ce),e.Diagnostic=Ce;let ke=class{constructor($,oe){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=oe}};ke=Ve([T],ke),e.Hover=ke;var Ue;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(Ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor($,oe=Ue.Text){this.range=$,this.kind=oe}toJSON(){return{range:this.range,kind:Ue[this.kind]}}};xe=Ve([T],xe),e.DocumentHighlight=xe;var ze;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var Q;(function(G){G[G.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let Z=n=class{constructor($,oe,Pe,Je,ct){this.name=$,this.kind=oe,this.containerName=ct,typeof Pe=="string"&&(this.containerName=Pe),Je instanceof te?this.location=Je:Pe instanceof F&&(this.location=new te(Je,Pe)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};Z=n=Ve([T],Z),e.SymbolInformation=Z;let re=t=class{constructor($,oe,Pe,Je,ct){this.name=$,this.detail=oe,this.kind=Pe,this.range=Je,this.selectionRange=ct,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};re=t=Ve([T],re),e.DocumentSymbol=re;var ue;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let J=class{constructor($,oe){this.title=$,this.kind=oe}};J=Ve([T],J),e.CodeAction=J;let ie=s=class{constructor($){this.value=$}append($){return new s(this.value?this.value+s.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+s.sep)}};ie.sep=".",ie=s=Ve([T],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let we=class{constructor($,oe){if(this.range=$,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=Ve([T],we),e.SelectionRange=we;class Me{constructor($,oe,Pe,Je,ct,dt){this.kind=$,this.name=oe,this.detail=Pe,this.uri=Je,this.range=ct,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor($,oe){this.fromRanges=oe,this.from=$}}e.CallHierarchyIncomingCall=je;class Ke{constructor($,oe){this.fromRanges=oe,this.to=$}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor($,oe){this.range=$,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([T],rt),e.CodeLens=rt;let ut=d=class{constructor($,oe=!1){f.set(this,void 0),ot(this,f,new D.MarkdownString($,{supportThemeIcons:oe}),"f")}static isMarkdownString($){return $ instanceof d?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Oe(this,f,"f").value}set value($){Oe(this,f,"f").value=$}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted($){Oe(this,f,"f").isTrusted=$}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons($){Oe(this,f,"f").supportThemeIcons=$}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml($){Oe(this,f,"f").supportHtml=$}appendText($){return Oe(this,f,"f").appendText($),this}appendMarkdown($){return Oe(this,f,"f").appendMarkdown($),this}appendCodeblock($,oe){return Oe(this,f,"f").appendCodeblock(oe??"",$),this}};f=new WeakMap,ut=d=Ve([T],ut),e.MarkdownString=ut;let it=class{constructor($,oe){this.label=$,this.documentation=oe}};it=Ve([T],it),e.ParameterInformation=it;let st=class{constructor($,oe){this.label=$,this.documentation=oe,this.parameters=[]}};st=Ve([T],st),e.SignatureInformation=st;let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ae=Ve([T],Ae),e.SignatureHelp=Ae;var wt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(wt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ee;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ee=e.InlayHintKind||(e.InlayHintKind={}));let se=class{constructor($,oe,Pe){this.text=$,this.position=oe,this.kind=Pe}};se=Ve([T],se),e.InlayHint=se;var Se;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(G){G[G.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor($,oe){this.label=$,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=Ve([T],nt),e.CompletionItem=nt;let he=class{constructor($=[],oe=!1){this.items=$,this.isIncomplete=oe}};he=Ve([T],he),e.CompletionList=he;let Ie=class{constructor($,oe,Pe){this.text=$,this.range=oe,this.command=Pe}};Ie=Ve([T],Ie),e.InlineSuggestion=Ie;let Be=class{constructor($){this.items=$}};Be=Ve([T],Be),e.InlineSuggestions=Be;var $e;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})($e=e.ViewColumn||(e.ViewColumn={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ye;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var be;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(be=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ae;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ve;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ve=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function $(oe){switch(oe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=$}(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor($,oe){if(oe&&!y.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=oe}};Ee=Ve([T],Ee),e.DocumentLink=Ee;let Fe=class{constructor($,oe,Pe,Je){this.red=$,this.green=oe,this.blue=Pe,this.alpha=Je}};Fe=Ve([T],Fe),e.Color=Fe;let Qe=class{constructor($,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=oe}};Qe=Ve([T],Qe),e.ColorInformation=Qe;let We=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};We=Ve([T],We),e.ColorPresentation=We;var Xe;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Xe=e.ColorFormat||(e.ColorFormat={}));var at;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class lt{constructor($,oe,Pe){if(this.startIndex=$,this.length=oe,this.tooltip=Pe,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=lt;var le;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=_e;var ce;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let De=l=class{constructor($,oe){if(this.label=oe,typeof $!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};De.Clean=new l("clean","Clean"),De.Build=new l("build","Build"),De.Rebuild=new l("rebuild","Rebuild"),De.Test=new l("test","Test"),De=l=Ve([T],De),e.TaskGroup=De;function Le(G){let $="";for(let oe=0;oe<G.length;oe++)$+=G[oe].replace(/,/g,",,")+",";return $}let et=class{constructor($,oe,Pe){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=Pe):this._options=oe)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)$.push(oe);return Le($)}};et=Ve([T],et),e.ProcessExecution=et;let qe=class{constructor($,oe,Pe){if(this._args=[],Array.isArray(oe)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=oe,this._options=Pe}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=oe}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)$.push(typeof oe=="string"?oe:oe.value);return Le($)}};qe=Ve([T],qe),e.ShellExecution=qe;var mt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class kt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=kt;let bt=h=class{constructor($,oe,Pe,Je,ct,dt){this.__deprecated=!1,this._definition=this.definition=$;let ft;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=Pe,this.execution=Je,ft=ct,this.__deprecated=!0):oe===_t.Global||oe===_t.Workspace?(this.target=oe,this._name=this.name=Pe,this._source=this.source=Je,this.execution=ct,ft=dt):(this.target=oe,this._name=this.name=Pe,this._source=this.source=Je,this.execution=ct,ft=dt),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof et?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const oe=this._definition.type;(h.EmptyType===oe||h.ProcessType===oe||h.ShellType===oe||h.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=h=Ve([T],bt),e.Task=bt;var gt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let Et=class{constructor($,oe=Ct.None){this.collapsibleState=oe,y.URI.isUri($)?this.resourceUri=$:this.label=$}};Et=Ve([T],Et),e.TreeItem=Et;var Ct;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Lt=Ve([T],Lt),e.TreeDataTransferItem=Lt;let yt=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,oe){this._items.set($,oe)}forEach($){this._items.forEach($)}};yt=Ve([T],yt),e.TreeDataTransfer=yt;let At=class{constructor($,oe){this.id=$,this.color=oe}};At=Ve([T],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let xt=class{constructor($){this.id=$}};xt=Ve([T],xt),e.ThemeColor=xt;var Tt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Tt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor($,oe){if(typeof $!="string"&&(!$||!y.URI.isUri($)&&!y.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=y.URI.file($),this.base=$):y.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=oe}};Bt=Ve([T],Bt),e.RelativePattern=Bt;let Ht=class{constructor($,oe,Pe,Je){this.enabled=typeof $=="boolean"?$:!0,typeof oe=="string"&&(this.condition=oe),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Ht=Ve([T],Ht),e.Breakpoint=Ht;let St=class extends Ht{constructor($,oe,Pe,Je,ct){super(oe,Pe,Je,ct);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};St=Ve([T],St),e.SourceBreakpoint=St;let Qt=class extends Ht{constructor($,oe,Pe,Je,ct){super(oe,Pe,Je,ct);this.functionName=$}};Qt=Ve([T],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends Ht{constructor($,oe,Pe,Je,ct,dt,ft){super(Je,ct,dt,ft);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=oe,this.canPersist=Pe}};Vt=Ve([T],Vt),e.DataBreakpoint=Vt;let si=class{constructor($,oe,Pe){this.command=$,this.args=oe||[],this.options=Pe}};si=Ve([T],si),e.DebugAdapterExecutable=si;let oi=class{constructor($,oe){this.port=$,this.host=oe}};oi=Ve([T],oi),e.DebugAdapterServer=oi;let Rt=class{constructor($){this.path=$}};Rt=Ve([T],Rt),e.DebugAdapterNamedPipeServer=Rt;let Xt=class{constructor($){this.implementation=$}};Xt=Ve([T],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor($,oe){this.range=$,this.expression=oe}};ai=Ve([T],ai),e.EvaluatableExpression=ai;var Yt;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor($,oe){this.range=$,this.text=oe}};zt=Ve([T],zt),e.InlineValueText=zt;let vt=class{constructor($,oe,Pe=!0){this.range=$,this.variableName=oe,this.caseSensitiveLookup=Pe}};vt=Ve([T],vt),e.InlineValueVariableLookup=vt;let ci=class{constructor($,oe){this.range=$,this.expression=oe}};ci=Ve([T],ci),e.InlineValueEvaluatableExpression=ci;let Mt=class{constructor($,oe){this.frameId=$,this.stoppedLocation=oe}};Mt=Ve([T],Mt),e.InlineValueContext=Mt;var jt;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Jt=u=class extends Error{constructor($,oe=P.FileSystemProviderErrorCode.Unknown,Pe){super(y.URI.isUri($)?$.toString(!0):$);this.code=Pe?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists($){return new u($,P.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound($){return new u($,P.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory($){return new u($,P.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory($){return new u($,P.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions($){return new u($,P.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable($){return new u($,P.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Jt=u=Ve([T],Jt),e.FileSystemError=Jt;let li=class{constructor($,oe,Pe){this.start=$,this.end=oe,this.kind=Pe}};li=Ve([T],li),e.FoldingRange=li;var fi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor($,oe=[]){this.tokenTypes=$,this.tokenModifiers=oe}}e.SemanticTokensLegend=Zt;function _i(G){return typeof G=="undefined"||(0,S.isStringArray)(G)}class qt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let oe=0,Pe=$.tokenTypes.length;oe<Pe;oe++)this._tokenTypeStrToInt.set($.tokenTypes[oe],oe);for(let oe=0,Pe=$.tokenModifiers.length;oe<Pe;oe++)this._tokenModifierStrToInt.set($.tokenModifiers[oe],oe)}}push($,oe,Pe,Je,ct){if(typeof $=="number"&&typeof oe=="number"&&typeof Pe=="number"&&typeof Je=="number"&&(typeof ct=="number"||typeof ct=="undefined"))return typeof ct=="undefined"&&(ct=0),this._pushEncoded($,oe,Pe,Je,ct);if(F.isRange($)&&typeof oe=="string"&&_i(Pe))return this._push($,oe,Pe);throw(0,L.illegalArgument)()}_push($,oe,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=$.start.line,ct=$.start.character,dt=$.end.character-$.start.character,ft=this._tokenTypeStrToInt.get(oe);let Pt=0;if(Pe)for(const Ft of Pe){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Je,ct,dt,ft,Pt)}_pushEncoded($,oe,Pe,Je,ct){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let Ut=0;Ut<Pt;Ut++){let Wt=this._data[5*Ut],di=this._data[5*Ut+1];Wt===0?(Wt=Ft,di+=Nt):Wt+=Ft,this._data[5*Ut]=Wt,this._data[5*Ut+1]=di,Ft=Wt,Nt=di}}let dt=$,ft=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ct,this._prevLine=$,this._prevChar=oe}static _sortAndDeltaEncode($){let oe=[];const Pe=$.length/5|0;for(let ft=0;ft<Pe;ft++)oe[ft]=ft;oe.sort((ft,Pt)=>{const Ft=$[5*ft],Nt=$[5*Pt];if(Ft===Nt){const Ut=$[5*ft+1],Wt=$[5*Pt+1];return Ut-Wt}return Ft-Nt});const Je=new Uint32Array($.length);let ct=0,dt=0;for(let ft=0;ft<Pe;ft++){const Pt=5*oe[ft],Ft=$[Pt+0],Nt=$[Pt+1],Ut=$[Pt+2],Wt=$[Pt+3],di=$[Pt+4],$i=Ft-ct,Xi=$i===0?Nt-dt:Nt,hi=5*ft;Je[hi+0]=$i,Je[hi+1]=Xi,Je[hi+2]=Ut,Je[hi+3]=Wt,Je[hi+4]=di,ct=Ft,dt=Nt}return Je}build($){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),$):new Gt(qt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=qt;class Gt{constructor($,oe){this.resultId=oe,this.data=$}}e.SemanticTokens=Gt;class Si{constructor($,oe,Pe){this.start=$,this.deleteCount=oe,this.data=Pe}}e.SemanticTokensEdit=Si;class Ci{constructor($,oe){this.resultId=oe,this.edits=$}}e.SemanticTokensEdits=Ci;var Kt;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new At("arrow-left")},ei=Ve([T],ei),e.QuickInputButtons=ei;var Di;(function(G){G[G.Default=1]="Default",G[G.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,oe,Pe){this.badge=$,this.tooltip=oe,this.color=Pe}static validate($){if($.badge){let oe=(0,k.nextCharLength)($.badge,0);if(oe<$.badge.length&&(oe+=(0,k.nextCharLength)($.badge,oe)),$.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor($){this.kind=$}};ti=Ve([T],ti),e.ColorTheme=ti;var gi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ne{constructor($,oe){if($<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");$<=oe?(this._start=$,this._end=oe):(this._start=oe,this._end=$)}static isNotebookRange($){return $ instanceof Ne?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let oe=this._start,Pe=this._end;return $.start!==void 0&&(oe=$.start),$.end!==void 0&&(Pe=$.end),oe===this._start&&Pe===this._end?this:new Ne(oe,Pe)}}e.NotebookRange=Ne;class Ot{constructor($,oe,Pe,Je,ct,dt,ft){this.kind=$,this.value=oe,this.languageId=Pe,this.mime=Je,this.outputs=ct??[],this.metadata=dt,this.executionSummary=ft,Ot.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(oe=>Ot.isNotebookCellData(oe))}static isNotebookCellData($){return!0}}e.NotebookCellData=Ot;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class pt{constructor($,oe){this.data=$,this.mime=oe;const Pe=(0,i.normalizeMimeType)(oe,!0);if(!Pe)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem($){return $ instanceof pt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const oe={name:$.name,message:$.message,stack:$.stack};return pt.json(oe,"application/vnd.code.notebook.error")}static stdout($){return pt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return pt.text($,"application/vnd.code.notebook.stderr")}static bytes($,oe="application/octet-stream"){return new pt($,oe)}static text($,oe=i.Mimes.text){const Pe=Oe(pt,v,"f",_).encode(String($));return new pt(Pe,oe)}static json($,oe="application/json"){const Pe=JSON.stringify($,void 0,"	");return pt.text(Pe,oe)}}e.NotebookCellOutputItem=pt,v=pt,_={value:new TextEncoder};class ii{constructor($,oe,Pe){this.items=ii.ensureUniqueMimeTypes($,!0),typeof oe=="string"?(this.id=oe,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=oe??Pe)}static isNotebookCellOutput($){return $ instanceof ii?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,S.isArray)($.items)}static ensureUniqueMimeTypes($,oe=!1){const Pe=new Set,Je=new Set;for(let ct=0;ct<$.length;ct++){const dt=$[ct],ft=(0,i.normalizeMimeType)(dt.mime);if(!Pe.has(ft)){Pe.add(ft);continue}Je.add(ct),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?$:$.filter((ct,dt)=>!Je.has(dt))}}e.NotebookCellOutput=ii;var Ii;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,oe){this.text=$,this.alignment=oe}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,oe=[]){this.uri=$,this.provides=(0,m.asArray)(oe)}}e.NotebookRendererScript=Ri;let ni=class{constructor($,oe){this.label=$,this.timestamp=oe}};ni=Ve([T],ni),e.TimelineItem=ni;var Li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,oe){this.ranges=$,this.wordPattern=oe}}e.LinkedEditingRanges=Oi;class Ni{constructor($,oe){this._port=$,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var ne;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ne=e.TestResultState||(e.TestResultState={}));var me;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(me=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor($=void 0,oe=void 0,Pe=void 0){this.include=$,this.exclude=oe,this.profile=Pe}};Re=Ve([T],Re),e.TestRunRequest=Re;let ht=b=class{constructor($){this.message=$}static diff($,oe,Pe){const Je=new b($);return Je.expectedOutput=oe,Je.actualOutput=Pe,Je}};ht=b=Ve([T],ht),e.TestMessage=ht;let Dt=class{constructor($){this.id=$}};Dt=Ve([T],Dt),e.TestTag=Dt;let It=class{constructor($,oe){this.covered=$,this.total=oe}};It=Ve([T],It),e.CoveredCount=It;let Ui=I=class{constructor($,oe,Pe,Je){this.uri=$,this.statementCoverage=oe,this.branchCoverage=Pe,this.functionCoverage=Je}static fromDetails($,oe){const Pe=new It(0,0),Je=new It(0,0),ct=new It(0,0);for(const ft of oe)if("branches"in ft){Pe.total+=1,Pe.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Je.total+=1,Je.covered+=Pt.executionCount>0?1:0}else ct.total+=1,ct.covered+=ft.executionCount>0?1:0;const dt=new I($,Pe,Je.total>0?Je:void 0,ct.total>0?ct:void 0);return dt.detailedCoverage=oe,dt}};Ui=I=Ve([T],Ui),e.FileCoverage=Ui;let xi=class{constructor($,oe,Pe=[]){this.executionCount=$,this.location=oe,this.branches=Pe}};xi=Ve([T],xi),e.StatementCoverage=xi;let Bi=class{constructor($,oe){this.executionCount=$,this.location=oe}};Bi=Ve([T],Bi),e.BranchCoverage=Bi;let Wi=class{constructor($,oe){this.executionCount=$,this.location=oe}};Wi=Ve([T],Wi),e.FunctionCoverage=Wi;var qi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,oe,Pe,Je,ct,dt){this.kind=$,this.name=oe,this.detail=Pe,this.uri=Je,this.range=ct,this.selectionRange=dt}}e.TypeHierarchyItem=Qi}),define(ge[122],pe([0,1,56,10,8,149,109,7,17]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const y=new Map;function R(f,v){v?y.set(f,v):y.delete(f)}e.setWordDefinitionFor=R;function P(f){return y.get(f)}e.getWordDefinitionFor=P;class a extends C.MirrorTextModel{constructor(v,_,A,p,o,r,g,c){super(_,A,p,o);this._proxy=v,this._languageId=r,this._isDirty=g,this._notebook=c,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,A){return v._getWordRangeAtPosition(_,A)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,m.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,m.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const A=this._eol,p=_.start.line,o=_.end.line,r=[];r.push(this._lines[p].substring(_.start.character));for(let g=p+1;g<o;g++)r.push(this._lines[g]);return r.push(this._lines[o].substring(0,_.end.character)),r.join(A)}_lineAt(v){let _;if(v instanceof k.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new w(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),A=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,A))}_validateRange(v){if(!(v instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),A=this._validatePosition(v.end);return _===v.start&&A===v.end?v:new k.Range(_.line,_.character,A.line,A.character)}_validatePosition(v){if(!(v instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:A}=v,p=!1;if(_<0)_=0,A=0,p=!0;else if(_>=this._lines.length)_=this._lines.length-1,A=this._lines[_].length,p=!0;else{const o=this._lines[_].length;A<0?(A=0,p=!0):A>o&&(A=o,p=!0)}return p?new k.Position(_,A):v}_getWordRangeAtPosition(v,_){const A=this._validatePosition(v);if(!_)_=P(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const p=(0,i.getWordAtText)(A.character+1,(0,i.ensureValidWordDefinition)(_),this._lines[A.line],0);if(p)return new k.Range(A.line,p.startColumn-1,A.line,p.endColumn-1)}}e.ExtHostDocumentData=a;class w{constructor(v,_,A){this._line=v,this._text=_,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(ge[201],pe([0,1,7,3,111,6,82,24,2,32]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(a,w,f,v){this._notebook=f,this._selector=v,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,y.generateUuid)()}),this._init(),this._disposables.add(w.onDidChangeDocument(A=>{const p=this._cellUris.get(A.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(A=>_(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const a=[],w=[];for(const f of this._notebook.getCells())f.kind===m.NotebookCellKind.Code&&(!this._selector||(0,i.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),a.push(f.document.getText().length+1),w.push(f.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(w))}get version(){return this._versionId}getText(a){if(!a){let p="";for(const o of this._cells)p+=o.document.getText()+`
`;return p=p.slice(0,-1),p}if(a.isEmpty)return"";const w=this.locationAt(a.start),f=this.locationAt(a.end),v=this._cellUris.get(w.uri),_=this._cellUris.get(f.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new m.Range(w.range.start,f.range.end));const A=[this._cells[v].document.getText(new m.Range(w.range.start,new m.Position(this._cells[v].document.lineCount,0)))];for(let p=v+1;p<_;p++)A.push(this._cells[p].document.getText());return A.push(this._cells[_].document.getText(new m.Range(new m.Position(0,0),f.range.end))),A.join(`
`)}offsetAt(a){const w=this._cellLines.getIndexOf(a.line),f=this._cellLengths.getPrefixSum(w.index-1),v=this._cells[w.index].document.offsetAt(a.with(w.remainder));return f+v}positionAt(a){if(typeof a=="number"){const f=this._cellLengths.getIndexOf(a),v=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(v)}const w=this._cellUris.get(a.uri);if(w!==void 0){const f=this._cellLines.getPrefixSum(w-1);return new m.Position(f+a.range.start.line,a.range.start.character)}return new m.Position(0,0)}locationAt(a){m.Range.isRange(a)||(a=new m.Range(a,a));const w=this._cellLines.getIndexOf(a.start.line);let f=w;a.isEmpty||(f=this._cellLines.getIndexOf(a.end.line));const v=new m.Position(w.remainder,a.start.character),_=new m.Position(f.remainder,a.end.character),A=new m.Range(v,_),p=this._cells[w.index];return new m.Location(p.document.uri,p.document.validateRange(A))}contains(a){return this._cellUris.has(a)}validateRange(a){const w=this.validatePosition(a.start),f=this.validatePosition(a.end);return a.with(w,f)}validatePosition(a){const w=this._cellLines.getIndexOf(a.line),f=new m.Position(w.remainder,a.character),v=this._cells[w.index].document.validatePosition(f),_=this._cellLines.getPrefixSum(w.index-1);return new m.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=R}),define(ge[202],pe([0,1,7,14,3]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([He(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ge[64],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=i=>i,this.transformOutgoing=i=>i,this.transformOutgoingURI=i=>i,this.transformOutgoingScheme=i=>i)}}e.URITransformerService=L}),define(ge[203],pe([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function D(k,S){if(S.serializeBuffersForPostMessage){const y=new L,R=(w,f)=>{if(f instanceof ArrayBuffer){const v=y.add(f);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(f)){const v=C(f);if(v){const _=y.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},P=JSON.stringify(k,R),a=y.buffers.map(w=>{const f=new Uint8Array(w);return m.VSBuffer.wrap(f)});return{message:P,buffers:a}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function i(k,S){const y=S.map(a=>{const w=new ArrayBuffer(a.byteLength);return new Uint8Array(w).set(a.buffer),w}),R=S.length?(a,w)=>{if(typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const f=w,{index:v}=f,_=y[v];if(f.view)switch(f.view.type){case 1:return new Int8Array(_,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return w}:void 0;return{message:JSON.parse(k,R),arrayBuffers:y}}e.deserializeWebviewMessage=i}),define(ge[204],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function D(i){const k=new Map;return i.types.forEach((S,y)=>{k.set(S,{asString:async()=>i.items[y].asString})}),k}L.toITreeDataTransfer=D;async function C(i){const k={types:[],items:[]},S=Array.from(i.entries());for(const y of S)k.types.push(y[0]),k.items.push({asString:await y[1].asString()});return k}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ge[88],pe([0,1,10,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(k,S){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===m.Schemas.file&&(k=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:k.path})),L.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function C(k){return k.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function i(k){return k.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=i}),define(ge[205],pe([0,1,3,6,88]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,S,y){this._proxy=k,this._editors=S,this._initData=y,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this._insets.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,y,R,P){let a;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){a=o;break}if(!a)throw new Error("not a visible editor");const w=this,f=this._handlePool++,v=new m.Emitter,_=new m.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,D.asWebviewUri)(o,w._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(o){this._options=o,w._proxy.$setOptions(f,o)}get options(){return this._options}set html(o){this._html=o,w._proxy.$setHtml(f,o)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(o){return w._proxy.$postMessage(f,o)}},p=new class{constructor(){this.editor=k,this.line=S,this.height=y,this.webview=A,this.onDidDispose=_.event}dispose(){w._insets.has(f)&&(w._insets.delete(f),w._proxy.$disposeEditorInset(f),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(f,a.id,a.value.document.uri,S+1,y,R||{},P.identifier,P.extensionLocation),this._insets.set(f,{editor:k,inset:p,onDidReceiveMessage:v}),p}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const y=this._insets.get(k);y&&y.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(ge[206],pe([0,1,171,13,2,6,4,61,51,42,17,10]),function(Y,e,m,L,D,C,i,k,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function a(O,F,W){for(const M of W.visibleEditorPanes)if(M.group.id===F&&O.matches(M.input))return M.getViewState()}e.findViewStateForEditor=a;function w(O){if(g(O))return!1;const F=O;return D.URI.isUri(F?.resource)}e.isResourceEditorInput=w;function f(O){if(g(O))return!1;const F=O;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function v(O){if(g(O)||f(O))return!1;const F=O;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function _(O){if(g(O))return!1;const F=O;return F?F.resource===void 0||F.resource.scheme===P.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var A;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(A=e.Verbosity||(e.Verbosity={}));var p;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var o;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function g(O){return O instanceof r}e.isEditorInput=g;function c(O){const F=O;return D.URI.isUri(F?.preferredResource)}function E(O){const F=O;return g(F?.primary)&&g(F?.secondary)}e.isSideBySideEditorInput=E;function n(O){const F=O;return g(F?.modified)&&g(F?.original)}e.isDiffEditorInput=n;function t(O){return g(O?.editor)}e.isEditorInputWithOptions=t;function s(O){const F=O;return t(O)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function d(O){const F=O;return typeof F?.groupId=="number"&&g(F.editor)}e.isEditorIdentifier=d;var l;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,W){if(!F)return;if(W?.supportSideBySide){const{primary:B,secondary:U}=this.getSideEditors(F);if(B&&U){if(W?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===h.ANY)return this.getOriginalUri(B,{filterByScheme:W.filterByScheme})??this.getOriginalUri(U,{filterByScheme:W.filterByScheme});F=W.supportSideBySide===h.PRIMARY?B:U}}if(f(F)||v(F))return;const M=c(F)?F.preferredResource:F.resource;return!M||!W||!W.filterByScheme?M:this.filterUri(M,W.filterByScheme)}getSideEditors(F){return E(F)||v(F)?{primary:F.primary,secondary:F.secondary}:n(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,W){if(!F)return;if(W?.supportSideBySide){const{primary:B,secondary:U}=this.getSideEditors(F);if(B&&U){if(W?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===h.ANY)return this.getCanonicalUri(B,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:W.filterByScheme});F=W.supportSideBySide===h.PRIMARY?B:U}}if(f(F)||v(F))return;const M=F.resource;return!M||!W||!W.filterByScheme?M:this.filterUri(M,W.filterByScheme)}filterUri(F,W){if(Array.isArray(W)){if(W.some(M=>F.scheme===M))return F}else if(W===F.scheme)return F}}e.EditorResourceAccessor=new u;var b;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const W=this.instantiationService=F.get(i.IInstantiationService);for(const[M,B]of this.editorSerializerConstructors)this.createEditorSerializer(M,B,W);this.editorSerializerConstructors.clear()}createEditorSerializer(F,W,M){const B=M.createInstance(W);this.editorSerializerInstances.set(F,B)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,W){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,W,this.instantiationService):this.editorSerializerConstructors.set(F,W),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new I);async function T(O,F){if(!O||!O.length)return[];const W=await Promise.all(O.map(async M=>{const B=D.URI.revive(M.fileUri);if(!B||!await F.canHandleResource(B))return;let z=M.exists,K=M.type;if(typeof z!="boolean"||typeof K!="number")try{K=(await F.resolve(B)).isDirectory?y.FileType.Directory:y.FileType.Unknown,z=!0}catch{z=!1}if(!z&&M.openOnlyIfExists||K===y.FileType.Directory)return;const N={selection:z?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let j;return z?j={resource:B,options:N}:j={resource:B,options:N,forceUntitled:!0},j}));return(0,R.coalesce)(W)}e.pathsToEditors=T;var x;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}))}),define(ge[123],pe([0,1,3,18,172]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,y,R){const P={command:k};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof R=="number"){const a=setTimeout(()=>{clearTimeout(a);const w=this.pendingRequests.get(P.seq);if(w){this.pendingRequests.delete(P.seq);const f={type:"response",seq:0,request_seq:P.seq,success:!1,command:k,message:(0,D.localize)(0,null,R,k)};w(f)}},R)}return y&&this.pendingRequests.set(P.seq,y),P.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const S=k,y=this.pendingRequests.get(S.request_seq);y&&(this.pendingRequests.delete(S.request_seq),y(S));break}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,y)=>k.set(y,S)),await(0,L.timeout)(500),k.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ge[207],pe([0,1,8,2,9,25,10]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(n,t,s){return n.replace(k,function(d,l){return t&&l.length>0&&l[0]!=="_"?d:s&&s.hasOwnProperty(l)?s[l]:d})}e.formatPII=S;function y(n){const t={};for(const s of Object.keys(n))s.startsWith("!")||(t[s]=n[s]);return t}e.filterExceptionsFromTelemetry=y;function R(n){return n.configuration.request==="attach"&&!P(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function P(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function a(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=a;function w(n,t,s){let d,l=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=h.exec(n);){let b=u.index+1,I=b+u[0].length;if(b<=t&&I>=s){d=u[0],l=b;break}}if(d){let b=/\w+/g,I=null;for(;(I=b.exec(d))&&!(I.index+1+l+I[0].length>=s););I&&(d=d.substring(0,b.lastIndex))}return d?{start:l,end:l+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=w;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(n){return!!(n&&n.match(f))}e.isUri=v;function _(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(v(n.path))return L.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return L.URI.file(n.path)}return n.path}function A(n){if(typeof n.path=="object"){const t=L.URI.revive(n.path);if(t)return t.scheme===i.Schemas.file?t.fsPath:t.toString()}return n.path}function p(n,t){const s=t?_:A,d=(0,C.deepClone)(n);return r(d,(l,h)=>{l&&h&&(h.path=s(h))}),d}e.convertToDAPaths=p;function o(n,t){const s=t?_:A,d=(0,C.deepClone)(n);return r(d,(l,h)=>{!l&&h&&(h.path=s(h))}),d}e.convertToVSCPaths=o;function r(n,t){switch(n.type){case"event":const s=n;switch(s.event){case"output":t(!1,s.body.source);break;case"loadedSource":t(!1,s.body.source);break;case"breakpoint":t(!1,s.body.breakpoint.source);break;default:break}break;case"request":const d=n;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(h=>t(!1,h));break;default:break}break;case"response":const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(h=>t(!1,h.source));break;case"loadedSources":l.body.sources.forEach(h=>t(!1,h));break;case"scopes":l.body.scopes.forEach(h=>t(!1,h.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(h=>t(!1,h.source));break;case"setBreakpoints":l.body.breakpoints.forEach(h=>t(!1,h.source));break;default:break}break}}function g(n){return n.filter(t=>!t.presentation?.hidden).sort((t,s)=>t.presentation?s.presentation?t.presentation.group?s.presentation.group?t.presentation.group!==s.presentation.group?t.presentation.group.localeCompare(s.presentation.group):c(t.presentation.order,s.presentation.order):-1:s.presentation.group?1:c(t.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=g;function c(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function E(n,t){const s=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(s!=="none"&&(await t.saveAll(),s==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ge[208],pe([0,1,28,37,173,124,9,8,25,12,183,123]),function(Y,e,m,L,D,C,i,k,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",r=>this.handleData(r))}sendMessage(p){if(this.outputStream){const o=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${a.TWO_CRLF}${o}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+o))}continue}}else{const o=this.rawData.indexOf(a.TWO_CRLF);if(o!==-1){const g=this.rawData.toString("utf8",0,o).split(a.HEADER_LINESEPARATOR);for(const c of g){const E=c.split(a.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(o+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class w extends a{startSession(){return new Promise((p,o)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",g=>{r?this._onError.fire(g):o(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=w;class f extends w{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=f;class v extends w{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=v;class _ extends a{constructor(p,o,r){super();this.adapterExecutable=p,this.debugType=o,this.outputService=r}async startSession(){const p=this.adapterExecutable.command,o=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(p)if(i.isAbsolute(p)){if(!await m.Promises.exists(p))throw new Error(D.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let g=process.env;if(r.env&&Object.keys(r.env).length>0&&(g=S.mixin(S.deepClone(process.env),r.env)),p==="node")if(Array.isArray(o)&&o.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:g,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(n.cwd=r.cwd);const t=L.fork(o[0],o.slice(1),n);if(!t.pid)throw new Error(D.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const E={env:g};r.cwd&&(E.cwd=r.cwd),this.serverProcess=L.spawn(p,o,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,n)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const c=this.outputService;if(c){const E=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=c.getChannel(R.ExtensionsChannelId);t&&t.append(E(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),y.isWindows?new Promise((p,o)=>{const r=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,c,E){if(g)return o(g)});r.on("exit",p),r.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,o){if(!p)return;const r=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?r.runtime=i.join(o,p.runtime):r.runtime=p.runtime),p.runtimeArgs&&(r.runtimeArgs=p.runtimeArgs),p.program&&(i.isAbsolute(p.program)?r.program=p.program:r.program=i.join(o,p.program)),p.args&&(r.args=p.args);const g=p;return g.win&&(r.win=_.extract(g.win,o)),g.winx86&&(r.winx86=_.extract(g.winx86,o)),g.windows&&(r.windows=_.extract(g.windows,o)),g.osx&&(r.osx=_.extract(g.osx,o)),g.linux&&(r.linux=_.extract(g.linux,o)),r}static platformAdapterExecutable(p,o){let r=Object.create(null);o=o.toLowerCase();for(const s of p)if(s.contributes){const d=s.contributes.debuggers;d&&d.length>0&&d.filter(l=>typeof l.type=="string"&&k.equalsIgnoreCase(l.type,o)).forEach(l=>{const h=_.extract(l,s.extensionLocation.fsPath);r=S.mixin(r,h,s.isBuiltin)})}let g;y.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=r.winx86||r.win||r.windows:y.isWindows?g=r.win||r.windows:y.isMacintosh?g=r.osx:y.isLinux&&(g=r.linux),g=g||r;let c=g.program||r.program;const E=g.args||r.args;let n=g.runtime||r.runtime;const t=g.runtimeArgs||r.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof c=="string"?[c]:[]).concat(E||[])};if(c)return{type:"executable",command:c,args:E||[]}}}e.ExecutableDebugAdapter=_}),define(ge[209],pe([0,1,37,12,30,185]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function i(a,w){return new Promise((f,v)=>{let _="";const A=m.spawn(a,w);A.pid&&A.stdout.on("data",p=>{_+=p.toString()}),A.on("error",p=>{v(p)}),A.on("close",p=>{f(_)})})}let k;function S(a,w){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const f=w.getConfiguration("terminal");return k.runInTerminal(a.title,a.cwd,a.args,a.env||{},f.external||{})}e.runInExternalTerminal=S;async function y(a){if(a)if(L.isWindows){const w=await new Promise((f,v)=>{Y(["windows-process-tree"],f,v)});return new Promise(f=>{w.getProcessTree(a,v=>{f(v.children.length>0)})})}else return i("/usr/bin/pgrep",["-lP",String(a)]).then(w=>{const f=w.trim();return!(f.length===0||f.indexOf(" tmux")>=0)},w=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var R;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(R||(R={}));function P(a,w,f,v){a=a.trim().toLowerCase();let _;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?_=1:a.indexOf("cmd.exe")>=0?_=0:a.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let A,p=" ";switch(_){case 1:if(A=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),f){const r=(0,D.getDriveLetter)(f);r&&(p+=`${r}:; `),p+=`cd ${A(f)}; `}if(v)for(let r in v){const g=v[r];g===null?p+=`Remove-Item env:${r}; `:p+=`\${env:${r}}='${g}'; `}if(w.length>0){const r=A(w.shift());p+=r[0]==="'"?`& ${r} `:`${r} `;for(let g of w)p+=`${A(g)} `}break;case 0:if(A=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),f){const r=(0,D.getDriveLetter)(f);r&&(p+=`${r}: && `),p+=`cd ${A(f)} && `}if(v){p+='cmd /C "';for(let r in v){let g=v[r];g===null?p+=`set "${r}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,c=>`^${c}`),p+=`set "${r}=${g}" && `)}}for(let r of w)p+=`${A(r)} `;v&&(p+='"');break;case 2:A=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const o=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(f&&(p+=`cd ${A(f)} ; `),v){p+="/usr/bin/env";for(let r in v){const g=v[r];g===null?p+=` -u ${o(r)}`:p+=` ${o(`${r}=${g}`)}`}p+=" "}for(let r of w)p+=`${A(r)} `;break}return p}e.prepareCommand=P}),define(ge[125],pe([0,1,31,76,101,10,9,12,61]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var P;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var a;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(a=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var w;(function(b){b.Always="always",b.Never="never",b.Optional="optional"})(w=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.ChangeCellMime=13]="ChangeCellMime",b[b.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var v;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(v=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(_=e.CellEditType||(e.CellEditType={}));var A;(function(b){b.scheme=C.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function T(B,U){return B.with({scheme:b.scheme,fragment:`ch${U.toString().padStart(7,"0")}${B.scheme!==C.Schemas.file?B.scheme:""}`})}b.generate=T;function x(B){if(B.scheme!==b.scheme)return;const U=I.exec(B.fragment);return U?{handle:Number(U[1]),notebook:B.with({scheme:B.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parse=x;function O(B,U,z){return B.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${U.toString().padStart(7,"0")},${z??""},${B.scheme!==C.Schemas.file?B.scheme:""}`})}b.generateCellOutputUri=O;function F(B){if(B.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const U=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!U)return;const z=Number(U[1]),K=U[2]&&U[2]!==""?U[2]:void 0,N=U[3];return{handle:z,outputId:K,notebook:B.with({scheme:N||C.Schemas.file,fragment:null})}}b.parseCellOutputUri=F;function W(B,U,z){return B.with({scheme:z,fragment:`ch${U.toString().padStart(7,"0")}${B.scheme!==C.Schemas.file?B.scheme:""}`})}b.generateCellUri=W;function M(B,U){if(B.scheme!==U)return;const z=I.exec(B.fragment);return z?{handle:Number(z[1]),notebook:B.with({scheme:B.fragment.substr(z[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parseCellUri=M})(A=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(b){return p.get(b)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function r(b){return p.get(b)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function g(b){return p.get(b)?.mergeable??!1}e.mimeTypeIsMergeable=g;const c=b=>k.isWindows?b.replace(/\//g,"\\"):b;class E{constructor(I=[],T=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=T,this.order=[...new Set(I)].map(x=>({pattern:x,matches:m.parse(c(x))}))}sort(I){const T=new Map(L.Iterable.map(I,O=>[O,c(O)]));let x=[];for(const{matches:O}of this.order)for(const[F,W]of T)if(O(W)){x.push(F),T.delete(F);break}return T.size&&(x=x.concat([...T.keys()].sort((O,F)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(F)))),x}prioritize(I,T){const x=this.findIndex(I);if(x===-1){this.order.unshift({pattern:I,matches:m.parse(c(I))});return}const O=new Set(T.map(W=>this.findIndex(W,x)));O.delete(-1);const F=Array.from(O).sort();this.order.splice(x+1,0,...F.map(W=>this.order[W]));for(let W=F.length-1;W>=0;W--)this.order.splice(F[W],1)}toArray(){return this.order.map(I=>I.pattern)}findIndex(I,T=this.order.length){const x=c(I);for(let O=0;O<T;O++)if(this.order[O].matches(x))return O;return-1}}e.MimeTypeDisplayOrder=E;function n(b,I,T,x=(O,F)=>O===F){const O=[];function F(B,U,z){if(U===0&&z.length===0)return;const K=O[O.length-1];K&&K.start+K.deleteCount===B?(K.deleteCount+=U,K.toInsert.push(...z)):O.push({start:B,deleteCount:U,toInsert:z})}let W=0,M=0;for(;;){if(W===b.length){F(W,0,I.slice(M));break}if(M===I.length){F(W,b.length-W,[]);break}const B=b[W],U=I[M];if(x(B,U)){W+=1,M+=1;continue}T(U)?(F(W,1,[]),W+=1):(F(W,0,[U]),M+=1)}return O}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(b){b.default="default",b.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(b){const I=b;return!!((typeof I.include=="string"||m.isRelativePattern(I.include))&&(typeof I.exclude=="string"||m.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=s;function d(b,I,T){if(Array.isArray(b.viewType)&&b.viewType.indexOf(I)>=0||b.viewType===I)return!0;if(b.filenamePattern){let x=s(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,O=s(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(m.match(x,(0,i.basename)(T.fsPath).toLowerCase()))return!(O&&m.match(O,(0,i.basename)(T.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class l{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let T=0;T<this.textModel.cells.length;T++)I[T]=this.textModel.cells[T].getHashValue();return I}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var h;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(I){return`${u._prefix}${I}`}static parse(I){if(I.startsWith(u._prefix))return I.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(ge[210],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(ge[211],pe([0,1,4,61]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ge[212],pe([0,1,175,4,61]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[213],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=m;function L(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=L}),define(ge[126],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(P){P[P.Error=0]="Error",P[P.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var C;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const i=(P,a)=>{a.expand!==void 0&&(P.expand=a.expand),a.item!==void 0&&(P.item=P.item?Object.assign(P.item,a.item):a.item)};e.applyTestItemUpdate=i;var k;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var S;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire",P[P.AddTag=5]="AddTag",P[P.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class y{add(a){}update(a){}remove(a,w){}complete(){}}e.IncrementalChangeCollector=y;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const w=this.createChangeCollector();for(const f of a)switch(f[0]){case 0:{const v=f[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const A=this.createItem(v,_);this.items.set(v.item.extId,A),w.add(A)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),w.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=f[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),w.update(_);break}case 2:{const v=this.items.get(f[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[f[1]]];for(;_.length;)for(const A of _.pop()){const p=this.items.get(A);p&&(_.push(p.children),this.items.delete(A),w.remove(p,p!==v),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f[1]);break;case 3:this.updatePendingRoots(f[1]);break;case 5:this._tags.set(f[1].id,f[1]);break;case 6:this._tags.delete(f[1]);break}w.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=R}),define(ge[89],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class D{constructor(i,k=i.length){if(this.path=i,this.viewEnd=k,i.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(i,k,S=i.parent){if(i.id===k)return new D([k]);let y=[i.id];for(let R=S;R&&R.id!==k;R=R.parent)y.push(R.id);return y.push(k),new D(y.reverse())}static isRoot(i){return!i.includes("\0")}static fromString(i){return new D(i.split("\0"))}static join(i,k){return new D([...i.path,k])}static joinToString(i,k){return i.toString()+"\0"+k}static compare(i,k){return i===k?0:k.startsWith(i+"\0")?2:i.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let i=1;i<=this.viewEnd;i++)yield new D(this.path,i)}compare(i){if(typeof i=="string")return D.compare(this.toString(),i);for(let k=0;k<i.viewEnd&&k<this.viewEnd;k++)if(i.path[k]!==this.path[k])return 1;return i.viewEnd>this.viewEnd?2:i.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let i=1;i<this.viewEnd;i++)this.stringifed+="\0",this.stringifed+=this.path[i]}return this.stringifed}}e.TestId=D}),define(ge[214],pe([0,1,9,40,13,25,12,80,176]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(P,a,w){this._contributedVariables=new Map,this._context=P,this._labelService=a,w&&(this._envVariablesPromise=w.then(f=>this.prepareEnv(f)))}prepareEnv(P){if(i.isWindows){const a=Object.create(null);return Object.keys(P).forEach(w=>{a[w.toLowerCase()]=P[w]}),a}return P}resolveWithEnvironment(P,a,w){return this.recursiveResolve(this.prepareEnv(P),a?a.uri:void 0,w)}async resolveAsync(P,a){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,a)}async resolveAnyBase(P,a,w,f){const v=C.deepClone(a);return i.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):i.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):i.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,v,w,f)}async resolveAnyAsync(P,a,w){return this.resolveAnyBase(P,a,w)}async resolveAnyMap(P,a,w){const f=new Map;return{newConfig:await this.resolveAnyBase(P,a,w,f),resolvedVariables:f}}resolveWithInteractionReplace(P,a,w,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,a,w,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,a){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,a)}recursiveResolve(P,a,w,f,v){if(D.isString(w))return this.resolveString(P,a,w,f,v);if(D.isArray(w))return w.map(_=>this.recursiveResolve(P,a,_,f,v));if(D.isObject(w)){let _=Object.create(null);return Object.keys(w).forEach(A=>{const p=this.resolveString(P,a,A,f,v);_[p]=this.recursiveResolve(P,a,w[A],f,v)}),_}return w}resolveString(P,a,w,f,v){return w.replace(y.VARIABLE_REGEXP,(A,p)=>{if(p.includes(y.VARIABLE_LHS))return A;let o=this.evaluateSingleVariable(P,A,p,a,f);return v&&v.set(p,o),o!==A&&D.isString(o)&&o.match(y.VARIABLE_REGEXP)&&(o=this.resolveString(P,a,o,f,v)),o})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,a,w,f,v){let _;const A=w.split(":");A.length>1&&(w=A[0],_=A[1]);const p=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,S.localize)(0,null,a))},o=()=>{const g=p();if(this._context.getWorkspaceFolderPathForFile){const c=this._context.getWorkspaceFolderPathForFile();if(c)return c}throw new Error((0,S.localize)(1,null,a,m.basename(g)))},r=()=>{if(_){const g=this._context.getFolderUri(_);if(g)return g;throw new Error((0,S.localize)(2,null,a,_))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,a)):new Error((0,S.localize)(4,null,a))};switch(w){case"env":if(_){if(P){const g=P[i.isWindows?_.toLowerCase():_];if(D.isString(g))return g}return""}throw new Error((0,S.localize)(5,null,a));case"config":if(_){const g=this._context.getConfigurationValue(f,_);if(D.isUndefinedOrNull(g))throw new Error((0,S.localize)(6,null,a,_));if(D.isObject(g))throw new Error((0,S.localize)(7,null,a,_));return g}throw new Error((0,S.localize)(8,null,a));case"command":return this.resolveFromMap(a,_,v,"command");case"input":return this.resolveFromMap(a,_,v,"input");default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return f||_?(0,k.normalizeDriveLetter)(this.fsPath(r())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,S.localize)(9,null,a));case"selectedText":const c=this._context.getSelectedText();if(c)return c;throw new Error((0,S.localize)(10,null,a));case"file":return p();case"fileWorkspaceFolder":return o();case"relativeFile":return f||_?m.relative(this.fsPath(r()),p()):p();case"relativeFileDirname":const E=m.dirname(p());if(f||_){const d=m.relative(this.fsPath(r()),E);return d.length===0?".":d}return E;case"fileDirname":return m.dirname(p());case"fileExtname":return m.extname(p());case"fileBasename":return m.basename(p());case"fileBasenameNoExtension":const n=m.basename(p());return n.slice(0,n.length-m.extname(n).length);case"fileDirnameBasename":return m.basename(m.dirname(p()));case"execPath":const t=this._context.getExecPath();return t||a;case"execInstallFolder":const s=this._context.getAppRoot();return s||a;case"pathSeparator":return m.sep;default:try{const d=_?`${w}:${_}`:w;return this.resolveFromMap(a,d,v,void 0)}catch(d){return a}}}}resolveFromMap(P,a,w,f){if(a&&w){const v=f===void 0?w[a]:w[f+":"+a];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[127],pe([0,1,4,206]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var D;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var i;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(i=e.GroupLocation||(e.GroupLocation={}));var k;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(v){const _=v;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=y;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function w(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=w;function f(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(ge[215],pe([0,1,4,127]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(C){const i=C;return typeof C=="number"||(0,L.isEditorGroup)(i)}e.isPreferredGroup=D}),define(ge[16],pe([0,1,17,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(le){function _e(X){const{selectionStartLineNumber:De,selectionStartColumn:Le,positionLineNumber:et,positionColumn:qe}=X,mt=new p.Position(De-1,Le-1),_t=new p.Position(et-1,qe-1);return new p.Selection(mt,_t)}le.to=_e;function ce(X){const{anchor:De,active:Le}=X;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}le.from=ce})(o=e.Selection||(e.Selection={}));var r;(function(le){function _e(X){if(!X)return;const{start:De,end:Le}=X;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}le.from=_e;function ce(X){if(!X)return;const{startLineNumber:De,startColumn:Le,endLineNumber:et,endColumn:qe}=X;return new p.Range(De-1,Le-1,et-1,qe-1)}le.to=ce})(r=e.Range||(e.Range={}));var g;(function(le){function _e(ce){switch(ce){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 4:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}le.to=_e})(g=e.TokenType||(e.TokenType={}));var c;(function(le){function _e(X){return new p.Position(X.lineNumber-1,X.column-1)}le.to=_e;function ce(X){return{lineNumber:X.line+1,column:X.character+1}}le.from=ce})(c=e.Position||(e.Position={}));var E;(function(le){function _e(De,Le){return(0,m.coalesce)((0,m.asArray)(De).map(et=>ce(et,Le)))}le.from=_e;function ce(De,Le){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:X(De.scheme,Le),pattern:typeof De.pattern=="undefined"?void 0:Ge.from(De.pattern),exclusive:De.exclusive}}function X(De,Le){return Le&&typeof De=="string"?Le.transformOutgoingScheme(De):De}})(E=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(le){function _e(X){switch(X){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}le.from=_e;function ce(X){switch(X){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}le.to=ce})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(le){function _e(X){let De;return X.code&&((0,S.isString)(X.code)||(0,S.isNumber)(X.code)?De=String(X.code):De={value:String(X.code.value),target:X.code.target}),{...r.from(X.range),message:X.message,source:X.source,code:De,severity:d.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(s.from),tags:Array.isArray(X.tags)?(0,m.coalesce)(X.tags.map(n.from)):void 0}}le.from=_e;function ce(X){const De=new p.Diagnostic(r.to(X),X.message,d.to(X.severity));return De.source=X.source,De.code=(0,S.isString)(X.code)?X.code:X.code?.value,De.relatedInformation=X.relatedInformation&&X.relatedInformation.map(s.to),De.tags=X.tags&&(0,m.coalesce)(X.tags.map(n.to)),De}le.to=ce})(t=e.Diagnostic||(e.Diagnostic={}));var s;(function(le){function _e(X){return{...r.from(X.location.range),message:X.message,resource:X.location.uri}}le.from=_e;function ce(X){return new p.DiagnosticRelatedInformation(new p.Location(X.resource,r.to(X)),X.message)}le.to=ce})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(le){function _e(X){switch(X){case p.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}le.from=_e;function ce(X){switch(X){case w.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}le.to=ce})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(le){function _e(X){return typeof X=="number"&&X>=p.ViewColumn.One?X-1:X===p.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}le.from=_e;function ce(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ce})(l=e.ViewColumn||(e.ViewColumn={}));function h(le){return typeof le.range!="undefined"}function u(le){return le.length===0?!0:!!h(le[0])}e.isDecorationOptionsArr=u;var b;(function(le){function _e(qe){return qe.map(le.from)}le.fromMany=_e;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function X(qe){let mt;if(ce(qe)){const{language:gt,value:Et}=qe;mt={value:"```"+gt+`
`+Et+"\n```\n"}}else p.MarkdownString.isMarkdownString(qe)?mt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?mt={value:qe}:mt={value:""};const _t=Object.create(null);mt.uris=_t;const kt=gt=>{try{let Et=y.URI.parse(gt,!0);Et=Et.with({query:De(Et.query,_t)}),_t[gt]=Et}catch(Et){}return""},bt=new C.Renderer;return bt.link=kt,bt.image=gt=>kt(D.parseHrefAndDimensions(gt).href),C(mt.value,{renderer:bt}),mt}le.from=X;function De(qe,mt){if(!qe)return qe;let _t;try{_t=(0,i.parse)(qe)}catch(bt){}if(!_t)return qe;let kt=!1;return _t=(0,k.cloneAndChange)(_t,bt=>{if(y.URI.isUri(bt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[gt]=bt,kt=!0,gt}else return}),kt?JSON.stringify(_t):qe}function Le(qe){const mt=new p.MarkdownString(qe.value,qe.supportThemeIcons);return mt.isTrusted=qe.isTrusted,mt.supportHtml=qe.supportHtml,mt}le.to=Le;function et(qe){if(!!qe)return typeof qe=="string"?qe:le.from(qe)}le.fromStrict=et})(b=e.MarkdownString||(e.MarkdownString={}));function I(le){return u(le)?le.map(_e=>({range:r.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?b.fromMany(_e.hoverMessage):_e.hoverMessage?b.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):le.map(_e=>({range:r.from(_e)}))}e.fromRangeOrRangeWithMessage=I;function T(le){return typeof le=="undefined"?le:typeof le=="string"?y.URI.file(le):le}e.pathOrURIToURI=T;var x;(function(le){function _e(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?T(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}le.from=_e})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(le){function _e(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?T(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?x.from(ce.before):void 0,after:ce.after?x.from(ce.after):void 0}}le.from=_e})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(le){function _e(ce){if(typeof ce=="undefined")return ce;switch(ce){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=_e})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(le){function _e(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?F.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?O.from(ce.light):void 0,dark:ce.dark?O.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?T(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?x.from(ce.before):void 0,after:ce.after?x.from(ce.after):void 0}}le.from=_e})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(le){function _e(X){return{text:X.newText,eol:X.newEol&&Ae.from(X.newEol),range:r.from(X.range)}}le.from=_e;function ce(X){const De=new p.TextEdit(r.to(X.range),X.text);return De.newEol=typeof X.eol=="undefined"?void 0:Ae.to(X.eol),De}le.to=ce})(M=e.TextEdit||(e.TextEdit={}));var B;(function(le){function _e(X,De,Le){const et={edits:[]};if(X instanceof p.WorkspaceEdit)for(let qe of X._allEntries())if(qe._type===1)et.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const mt=De?.getDocument(qe.uri);et.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:mt?.version,metadata:qe.metadata})}else qe._type===3?et.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&et.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map($e.from)}});return et}le.from=_e;function ce(X){const De=new p.WorkspaceEdit;for(const Le of X.edits)Le.edit?De.replace(y.URI.revive(Le.resource),r.to(Le.edit.range),Le.edit.text):De.renameFile(y.URI.revive(Le.oldUri),y.URI.revive(Le.newUri),Le.options);return De}le.to=ce})(B=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(le){const _e=Object.create(null);_e[p.SymbolKind.File]=0,_e[p.SymbolKind.Module]=1,_e[p.SymbolKind.Namespace]=2,_e[p.SymbolKind.Package]=3,_e[p.SymbolKind.Class]=4,_e[p.SymbolKind.Method]=5,_e[p.SymbolKind.Property]=6,_e[p.SymbolKind.Field]=7,_e[p.SymbolKind.Constructor]=8,_e[p.SymbolKind.Enum]=9,_e[p.SymbolKind.Interface]=10,_e[p.SymbolKind.Function]=11,_e[p.SymbolKind.Variable]=12,_e[p.SymbolKind.Constant]=13,_e[p.SymbolKind.String]=14,_e[p.SymbolKind.Number]=15,_e[p.SymbolKind.Boolean]=16,_e[p.SymbolKind.Array]=17,_e[p.SymbolKind.Object]=18,_e[p.SymbolKind.Key]=19,_e[p.SymbolKind.Null]=20,_e[p.SymbolKind.EnumMember]=21,_e[p.SymbolKind.Struct]=22,_e[p.SymbolKind.Event]=23,_e[p.SymbolKind.Operator]=24,_e[p.SymbolKind.TypeParameter]=25;function ce(De){return typeof _e[De]=="number"?_e[De]:6}le.from=ce;function X(De){for(const Le in _e)if(_e[Le]===De)return Number(Le);return p.SymbolKind.Property}le.to=X})(U=e.SymbolKind||(e.SymbolKind={}));var z;(function(le){function _e(X){switch(X){case p.SymbolTag.Deprecated:return 1}}le.from=_e;function ce(X){switch(X){case 1:return p.SymbolTag.Deprecated}}le.to=ce})(z=e.SymbolTag||(e.SymbolTag={}));var K;(function(le){function _e(X){return{name:X.name,kind:U.from(X.kind),tags:X.tags&&X.tags.map(z.from),containerName:X.containerName,location:q.from(X.location)}}le.from=_e;function ce(X){const De=new p.SymbolInformation(X.name,U.to(X.kind),X.containerName,q.to(X.location));return De.tags=X.tags&&X.tags.map(z.to),De}le.to=ce})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var N;(function(le){function _e(X){const De={name:X.name||"!!MISSING: name!!",detail:X.detail,range:r.from(X.range),selectionRange:r.from(X.selectionRange),kind:U.from(X.kind),tags:X.tags?.map(z.from)??[]};return X.children&&(De.children=X.children.map(_e)),De}le.from=_e;function ce(X){const De=new p.DocumentSymbol(X.name,X.detail,U.to(X.kind),r.to(X.range),r.to(X.selectionRange));return(0,m.isNonEmptyArray)(X.tags)&&(De.tags=X.tags.map(z.to)),X.children&&(De.children=X.children.map(ce)),De}le.to=ce})(N=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(le){function _e(X){const De=new p.CallHierarchyItem(U.to(X.kind),X.name,X.detail||"",y.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}le.to=_e;function ce(X,De,Le){if(De=De??X._sessionId,Le=Le??X._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,name:X.name,detail:X.detail,kind:U.from(X.kind),uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(z.from)}}le.from=ce})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(le){function _e(ce){return new p.CallHierarchyIncomingCall(j.to(ce.from),ce.fromRanges.map(X=>r.to(X)))}le.to=_e})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var V;(function(le){function _e(ce){return new p.CallHierarchyOutgoingCall(j.to(ce.to),ce.fromRanges.map(X=>r.to(X)))}le.to=_e})(V=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var q;(function(le){function _e(X){return{range:X.range&&r.from(X.range),uri:X.uri}}le.from=_e;function ce(X){return new p.Location(y.URI.revive(X.uri),r.to(X.range))}le.to=ce})(q=e.location||(e.location={}));var te;(function(le){function _e(X){const De=X,Le=X;return{originSelectionRange:De.originSelectionRange?r.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Le.uri,range:r.from(De.targetRange?De.targetRange:Le.range),targetSelectionRange:De.targetSelectionRange?r.from(De.targetSelectionRange):void 0}}le.from=_e;function ce(X){return{targetUri:y.URI.revive(X.uri),targetRange:r.to(X.range),targetSelectionRange:X.targetSelectionRange?r.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?r.to(X.originSelectionRange):void 0}}le.to=ce})(te=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(le){function _e(X){return{range:r.from(X.range),contents:b.fromMany(X.contents)}}le.from=_e;function ce(X){return new p.Hover(X.contents.map(b.to),r.to(X.range))}le.to=ce})(fe=e.Hover||(e.Hover={}));var Ce;(function(le){function _e(X){return{range:r.from(X.range),expression:X.expression}}le.from=_e;function ce(X){return new p.EvaluatableExpression(r.to(X.range),X.expression)}le.to=ce})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ke;(function(le){function _e(X){if(X instanceof p.InlineValueText)return{type:"text",range:r.from(X.range),text:X.text};if(X instanceof p.InlineValueVariableLookup)return{type:"variable",range:r.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}le.from=_e;function ce(X){switch(X.type){case"text":return{range:r.to(X.range),text:X.text};case"variable":return{range:r.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:r.to(X.range),expression:X.expression}}}le.to=ce})(ke=e.InlineValue||(e.InlineValue={}));var Ue;(function(le){function _e(X){return{frameId:X.frameId,stoppedLocation:r.from(X.stoppedLocation)}}le.from=_e;function ce(X){return new p.InlineValueContext(X.frameId,r.to(X.stoppedLocation))}le.to=ce})(Ue=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(le){function _e(X){return{range:r.from(X.range),kind:X.kind}}le.from=_e;function ce(X){return new p.DocumentHighlight(r.to(X.range),X.kind)}le.to=ce})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(le){function _e(ce){switch(ce){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}le.to=_e})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(le){function _e(ce){return{triggerKind:ze.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}le.to=_e})(Q=e.CompletionContext||(e.CompletionContext={}));var Z;(function(le){function _e(X){switch(X){case p.CompletionItemTag.Deprecated:return 1}}le.from=_e;function ce(X){switch(X){case 1:return p.CompletionItemTag.Deprecated}}le.to=ce})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(le){const _e=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ce(Le){return _e.get(Le)??9}le.from=ce;const X=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function De(Le){return X.get(Le)??p.CompletionItemKind.Property}le.to=De})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(le){function _e(ce,X){const De=new p.CompletionItem(ce.label);return De.insertText=ce.insertText,De.kind=re.to(ce.kind),De.tags=ce.tags?.map(Z.to),De.detail=ce.detail,De.documentation=D.isMarkdownString(ce.documentation)?b.to(ce.documentation):ce.documentation,De.sortText=ce.sortText,De.filterText=ce.filterText,De.preselect=ce.preselect,De.commitCharacters=ce.commitCharacters,R.Range.isIRange(ce.range)?De.range=r.to(ce.range):typeof ce.range=="object"&&(De.range={inserting:r.to(ce.range.insert),replacing:r.to(ce.range.replace)}),De.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?De.insertText=new p.SnippetString(ce.insertText):(De.insertText=ce.insertText,De.textEdit=De.range instanceof p.Range?new p.TextEdit(De.range,De.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(De.additionalTextEdits=ce.additionalTextEdits.map(Le=>M.to(Le))),De.command=X&&ce.command?X.fromInternal(ce.command):void 0,De}le.to=_e})(ue=e.CompletionItem||(e.CompletionItem={}));var J;(function(le){function _e(X){return{label:X.label,documentation:X.documentation?b.fromStrict(X.documentation):void 0}}le.from=_e;function ce(X){return{label:X.label,documentation:D.isMarkdownString(X.documentation)?b.to(X.documentation):X.documentation}}le.to=ce})(J=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(le){function _e(X){return{label:X.label,documentation:X.documentation?b.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(J.from):[],activeParameter:X.activeParameter}}le.from=_e;function ce(X){return{label:X.label,documentation:D.isMarkdownString(X.documentation)?b.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(J.to):[],activeParameter:X.activeParameter}}le.to=ce})(ie=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(le){function _e(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ie.from):[]}}le.from=_e;function ce(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ie.to):[]}}le.to=ce})(we=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(le){function _e(X){return{text:X.text,position:c.from(X.position),kind:je.from(X.kind??p.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}le.from=_e;function ce(X){const De=new p.InlayHint(X.text,c.to(X.position),je.to(X.kind));return De.whitespaceAfter=X.whitespaceAfter,De.whitespaceBefore=X.whitespaceBefore,De}le.to=ce})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(le){function _e(X){return X}le.from=_e;function ce(X){return X}le.to=ce})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(le){function _e(X){return{range:r.from(X.range),url:X.target,tooltip:X.tooltip}}le.from=_e;function ce(X){let De;if(X.url)try{De=typeof X.url=="string"?y.URI.parse(X.url,!0):y.URI.revive(X.url)}catch(Le){}return new p.DocumentLink(r.to(X.range),De)}le.to=ce})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(le){function _e(X){const De=new p.ColorPresentation(X.label);return X.textEdit&&(De.textEdit=M.to(X.textEdit)),X.additionalTextEdits&&(De.additionalTextEdits=X.additionalTextEdits.map(Le=>M.to(Le))),De}le.to=_e;function ce(X){return{label:X.label,textEdit:X.textEdit?M.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(De=>M.from(De)):void 0}}le.from=ce})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(le){function _e(X){return new p.Color(X[0],X[1],X[2],X[3])}le.to=_e;function ce(X){return[X.red,X.green,X.blue,X.alpha]}le.from=ce})(rt=e.Color||(e.Color={}));var ut;(function(le){function _e(X){return{range:r.from(X.range)}}le.from=_e;function ce(X){return new p.SelectionRange(r.to(X.range))}le.to=ce})(ut=e.SelectionRange||(e.SelectionRange={}));var it;(function(le){function _e(ce){switch(ce){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}le.to=_e})(it=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var st;(function(le){function _e(X){switch(X){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}le.from=_e;function ce(X){switch(X){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}le.to=ce})(st=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(le){function _e(X){if(X===p.EndOfLine.CRLF)return 1;if(X===p.EndOfLine.LF)return 0}le.from=_e;function ce(X){if(X===1)return p.EndOfLine.CRLF;if(X===0)return p.EndOfLine.LF}le.to=ce})(Ae=e.EndOfLine||(e.EndOfLine={}));var wt;(function(le){function _e(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=_e})(wt=e.ProgressLocation||(e.ProgressLocation={}));var ee;(function(le){function _e(ce){const X={start:ce.start+1,end:ce.end+1};return ce.kind&&(X.kind=se.from(ce.kind)),X}le.from=_e})(ee=e.FoldingRange||(e.FoldingRange={}));var se;(function(le){function _e(ce){if(ce)switch(ce){case p.FoldingRangeKind.Comment:return P.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return P.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return P.FoldingRangeKind.Region}}le.from=_e})(se=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Se;(function(le){function _e(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?r.from(ce.selection):void 0,override:typeof ce.override=="boolean"?a.EditorResolution.DISABLED:void 0}}le.from=_e})(Se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ge;(function(le){function _e(X){return X instanceof p.RelativePattern||typeof X=="string"?X:ce(X)?new p.RelativePattern(X.base,X.pattern):X}le.from=_e;function ce(X){const De=X;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(Ge=e.GlobPattern||(e.GlobPattern={}));var Ye;(function(le){function _e(ce){if(ce){if(Array.isArray(ce))return ce.map(_e);if(typeof ce=="string")return ce;{const X=ce;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Ge.from(X.pattern),exclusive:X.exclusive}}}else return}le.from=_e})(Ye=e.LanguageSelector||(e.LanguageSelector={}));var nt;(function(le){function _e(X){return{start:X.start,end:X.end}}le.from=_e;function ce(X){return new p.NotebookRange(X.start,X.end)}le.to=ce})(nt=e.NotebookRange||(e.NotebookRange={}));var he;(function(le){function _e(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}le.to=_e;function ce(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}le.from=ce})(he=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(le){function _e(X){switch(X){case p.NotebookCellKind.Markup:return v.CellKind.Markup;case p.NotebookCellKind.Code:default:return v.CellKind.Code}}le.from=_e;function ce(X){switch(X){case v.CellKind.Markup:return p.NotebookCellKind.Markup;case v.CellKind.Code:default:return p.NotebookCellKind.Code}}le.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Be;(function(le){function _e(X){const De={metadata:X.metadata??Object.create(null),cells:[]};for(let Le of X.cells)p.NotebookCellData.validate(Le),De.cells.push($e.from(Le));return De}le.from=_e;function ce(X){const De=new p.NotebookData(X.cells.map($e.to));return(0,S.isEmptyObject)(X.metadata)||(De.metadata=X.metadata),De}le.to=ce})(Be=e.NotebookData||(e.NotebookData={}));var $e;(function(le){function _e(X){return{cellKind:Ie.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:he.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Te.from):[]}}le.from=_e;function ce(X){return new p.NotebookCellData(Ie.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Te.to):void 0,X.metadata,X.internalMetadata?he.to(X.internalMetadata):void 0)}le.to=ce})($e=e.NotebookCellData||(e.NotebookCellData={}));var tt;(function(le){function _e(X){return{mime:X.mime,valueBytes:L.VSBuffer.wrap(X.data)}}le.from=_e;function ce(X){return new p.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}le.to=ce})(tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(le){function _e(X){return{outputId:X.id,items:X.items.map(tt.from),metadata:X.metadata}}le.from=_e;function ce(X){const De=X.items.map(tt.to);return new p.NotebookCellOutput(De,X.outputId,X.metadata)}le.to=ce})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(le){function _e(Le){if(Le!=null){if(Le instanceof p.RelativePattern||typeof Le=="string")return Le;if(De(Le))return new p.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:Ge.from(Le.include)||void 0,exclude:Ge.from(Le.exclude)||void 0}}}le.from=_e;function ce(Le){return typeof Le=="string"?Le:De(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}le.to=ce;function X(Le){const et=Le,qe=Ge.from(et.include);if(!(qe&&qe instanceof p.RelativePattern||typeof qe=="string"))return!1;const mt=Ge.from(et.exclude);return!!(mt&&mt instanceof p.RelativePattern||typeof mt=="string")}function De(Le){const et=Le;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var be;(function(le){function _e(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?x.from(ce.top):void 0}}le.from=_e})(be=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ae;(function(le){function _e(ce,X,De){const Le=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,De),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}le.from=_e})(ae=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(le){function _e(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}le.from=_e})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ve;(function(le){function _e(X){return{uri:X.uri,provides:X.provides}}le.from=_e;function ce(X){return new p.NotebookRendererScript(y.URI.revive(X.uri),X.provides)}le.to=ce})(ve=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ee;(function(le){function _e(X){return{message:b.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?q.from(X.location):void 0}}le.from=_e;function ce(X){const De=new p.TestMessage(typeof X.message=="string"?X.message:b.to(X.message));return De.actualOutput=X.actual,De.expectedOutput=X.expected,De.location=X.location?q.to(X.location):void 0,De}le.to=ce})(Ee=e.TestMessage||(e.TestMessage={}));var Fe;(function(le){let _e;(function(ce){ce.Delimiter="\0"})(_e||(_e={})),le.namespace=(ce,X)=>ce+"\0"+X,le.denamespace=ce=>{const X=ce.indexOf("\0");return{ctrlId:ce.slice(0,X),tagId:ce.slice(X+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Qe;(function(le){function _e(Le){const et=(0,f.getPrivateApiFor)(Le).controllerId;return{extId:_.TestId.fromExtHostTestItem(Le,et).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Fe.namespace(et,qe.id)),range:r.from(Le.range)||null,description:Le.description||null,error:Le.error&&b.fromStrict(Le.error)||null}}le.from=_e;function ce(Le){return{parent:void 0,error:void 0,id:_.TestId.fromString(Le.extId).localId,label:Le.label,uri:y.URI.revive(Le.uri),tags:(Le.tags||[]).map(et=>{const{tagId:qe}=Fe.denamespace(et);return new p.TestTag(qe)}),range:r.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}le.toPlain=ce;function X(Le){const et=_.TestId.fromString(Le.extId),qe=new f.TestItemImpl(et.controllerId,et.localId,Le.label,y.URI.revive(Le.uri));return qe.range=r.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function De(Le){let et;for(const qe of Le.tests){const mt=X(qe.item);(0,f.getPrivateApiFor)(mt).parent=et,et=mt}return et}le.toItemFromContext=De})(Qe=e.TestItem||(e.TestItem={})),function(le){function _e(X){return{id:X.id}}le.from=_e;function ce(X){return new p.TestTag(X.id)}le.to=ce}(Fe=e.TestTag||(e.TestTag={}));var We;(function(le){const _e=(X,De)=>{const Le={...Qe.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(et=>({state:et.state,duration:et.duration,messages:et.messages.filter(qe=>qe.type===0).map(Ee.to)})),children:X.children.map(et=>De.get(et)).filter(S.isDefined).map(et=>_e(et,De))};for(const et of Le.children)et.parent=Le;return Le};function ce(X){const De=[],Le=new Map;for(const et of X.items)Le.set(et.item.extId,et),X.request.targets.some(qe=>qe.controllerId===et.controllerId&&qe.testIds.includes(et.item.extId))&&De.push(et);return{completedAt:X.completedAt,results:De.map(et=>_e(et,Le))}}le.to=ce})(We=e.TestResults||(e.TestResults={}));var Xe;(function(le){function _e(Le){return{covered:Le.covered,total:Le.covered}}function ce(Le){return"line"in Le?c.from(Le):r.from(Le)}function X(Le){return"branches"in Le?{count:Le.executionCount,location:ce(Le.location),type:1,branches:Le.branches.length?Le.branches.map(et=>({count:et.executionCount,location:et.location&&ce(et.location)})):void 0}:{type:0,count:Le.executionCount,location:ce(Le.location)}}le.fromDetailed=X;function De(Le){return{uri:Le.uri,statement:_e(Le.statementCoverage),branch:Le.branchCoverage&&_e(Le.branchCoverage),function:Le.functionCoverage&&_e(Le.functionCoverage),details:Le.detailedCoverage?.map(X)}}le.fromFile=De})(Xe=e.TestCoverage||(e.TestCoverage={}));var at;(function(le){function _e(ce){switch(ce){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}le.to=_e})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var lt;(function(le){function _e(X){const De=new p.TypeHierarchyItem(U.to(X.kind),X.name,X.detail||"",y.URI.revive(X.uri),r.to(X.range),r.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}le.to=_e;function ce(X,De,Le){if(De=De??X._sessionId,Le=Le??X._itemId,De===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Le,kind:U.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:r.from(X.range),selectionRange:r.from(X.selectionRange),tags:X.tags?.map(z.from)}}le.from=ce})(lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ge[216],pe([0,1,2,15,7,16,93]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(y,R,P,a={timeout:1500,errors:3}){this._logService=y,this._documents=R,this._mainThreadBulkEdits=P,this._thresholds=a,this._callbacks=new i.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(y){return(R,P,a)=>{const f={dispose:this._callbacks.push([R,P,y])};return Array.isArray(a)&&a.push(f),f}}async $participateInSave(y,R){const P=m.URI.revive(y);let a=!1;const w=setTimeout(()=>a=!0,this._thresholds.timeout),f=[];try{for(let v of[...this._callbacks]){if(a)break;const _=this._documents.getDocument(P),A=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:C.TextDocumentSaveReason.to(R)});f.push(A)}}finally{clearTimeout(w)}return f}_deliverEventAsyncAndBlameBadListeners([y,R,P],a){const w=this._badListeners.get(y);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,y,R,a).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const v=this._badListeners.get(y);this._badListeners.set(y,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(y,R,P,a){const w=[],f=Date.now(),{document:v,reason:_}=a,{version:A}=v,p=Object.freeze({document:v,reason:_,waitUntil(o){if(Object.isFrozen(w))throw(0,L.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(o))}});try{R.apply(P,[p])}catch(o){return Promise.reject(o)}return Object.freeze(w),new Promise((o,r)=>{const g=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(c=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(g),o(c)}).catch(c=>{clearTimeout(g),r(c)})}).then(o=>{const r={edits:[]};for(const g of o)if(Array.isArray(g)&&g.every(c=>c instanceof D.TextEdit))for(const{newText:c,newEol:E,range:n}of g)r.edits.push({_type:2,resource:v.uri,edit:{range:n&&C.Range.from(n),text:c,eol:E&&C.EndOfLine.from(E)}});if(r.edits.length!==0)return A===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[217],pe([0,1,3,31,2,16,7]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(R,P,a,w,f){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,a&&(this._config+=1),w&&(this._config+=2),f&&(this._config+=4);const v=(0,L.parse)(P),_=R(A=>{if(!a)for(let p of A.created){const o=D.URI.revive(p);v(o.fsPath)&&this._onDidCreate.fire(o)}if(!w)for(let p of A.changed){const o=D.URI.revive(p);v(o.fsPath)&&this._onDidChange.fire(o)}if(!f)for(let p of A.deleted){const o=D.URI.revive(p);v(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=i.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(R,P,a){this._logService=P,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(R,P,a,w){return new k(this._onFileSystemEvent.event,R,P,a,w)}$onFileEvent(R){this._onFileSystemEvent.fire(R)}$onDidRunFileOperation(R,P){switch(R){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(a=>D.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(a=>D.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(R){return this._createWillExecuteEvent(R,this._onWillRenameFile)}getOnWillCreateFileEvent(R){return this._createWillExecuteEvent(R,this._onWillCreateFile)}getOnWillDeleteFileEvent(R){return this._createWillExecuteEvent(R,this._onWillDeleteFile)}_createWillExecuteEvent(R,P){return(a,w,f)=>{const v=function(A){a.call(w,A)};return v.extension=R,P.event(v,void 0,f)}}async $onWillRunFileOperation(R,P,a,w){switch(R){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(f=>({oldUri:D.URI.revive(f.source),newUri:D.URI.revive(f.target)}))},a,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(f=>D.URI.revive(f.target))},a,w);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(f=>D.URI.revive(f.target))},a,w)}}async _fireWillEvent(R,P,a,w){const f=new Set,v=[];if(await R.fireAsync(P,w,async(A,p)=>{const o=Date.now(),r=await Promise.resolve(A);r instanceof i.WorkspaceEdit&&(v.push(r),f.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-o>a&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),w.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let A of v){let{edits:p}=C.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(p)}return{edit:_,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=S}),define(ge[218],pe([0,1,10,25,2,16,7,125]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(a,w,f,v){this.start=a,this.deletedCount=w,this.deletedItems=f,this.items=v}static asApiEvents(a){return a.map(w=>({start:w.start,deletedCount:w.deletedCount,deletedItems:w.deletedItems,items:w.items.map(f=>f.apiCell)}))}}class y{constructor(a,w,f){this.notebook=a,this._extHostDocument=w,this._cellData=f,this.handle=f.handle,this.uri=D.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(a,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,w=this._extHostDocument.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:w.document,get mime(){return a._mime},set mime(f){a._mime=f},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(C.NotebookCellOutput.to)}setOutputItems(a,w,f){const v=f.map(C.NotebookCellOutputItem.to),_=this._outputs.find(A=>A.id===a);_&&(w||(_.items.length=0),_.items.push(...v))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=y;class R{constructor(a,w,f,v,_,A){this._proxy=a,this._textDocumentsAndEditors=w,this._textDocuments=f,this._emitter=v,this.uri=_,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===m.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(w){return w=a._validateIndex(w),a._cells[w].apiCell},getCells(w){return(w?a._getCells(w):a._cells).map(v=>v.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,w){this._versionId=a.versionId,this._isDirty=w;for(const f of a.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===k.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let w=a.start|0,f=a.end|0;return w<0&&(w=0),f>this._cells.length&&(f=this._cells.length),a.with({start:w,end:f})}_getCells(a){a=this._validateRange(a);const w=[];for(let f=a.start;f<a.end;f++)w.push(this._cells[f]);return w}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,w){if(this._disposed)return;const f=[],v=[],_=[];a.reverse().forEach(A=>{const o=A[2].map(c=>{const E=new y(this,this._textDocumentsAndEditors,c);return w||v.push(y.asModelAddData(this.apiNotebook,c)),E}),r=new S(A[0],A[1],[],o),g=this._cells.splice(A[0],A[1],...o);for(const c of g)_.push(c.uri),r.deletedItems.push(c.apiCell);f.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),w||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(f)}))}_moveCell(a,w){const f=this._cells.splice(a,1);this._cells.splice(w,0,...f);const v=[new S(a,1,f.map(_=>_.apiCell),[]),new S(w,0,[],f)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(a,w){const f=this._cells[a];f.setOutputs(w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(a,w,f,v){const _=this._cells[a];_.setOutputItems(w,f,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(a,w){const f=this._cells[a];f.apiCell.document.languageId!==w&&this._textDocuments.$acceptModelModeChanged(f.uri,w)}_changeCellMime(a,w){const f=this._cells[a];f.apiCell.mime=w}_changeCellMetadata(a,w){const f=this._cells[a],v=f.apiCell.metadata;f.setMetadata(w);const _=f.apiCell.metadata;(0,L.equals)(v,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(a,w){const f=this._cells[a],v=f.internalMetadata;if(f.setInternalMetadata(w),v.runState!==w.runState){const _=w.runState??i.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,state:_}))}}getCellFromApiCell(a){return this._cells.find(w=>w.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(w=>w.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(ge[128],pe([0,1,7,16,15]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,y){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:y})}replaceCells(S,y,R){this._throwIfFinalized(),!(S===y&&R.length===0)&&this._collectedEdits.push({editType:1,index:S,count:y-S,cells:R.map(L.NotebookCellData.from)})}}class i{constructor(S,y,R,P,a,w){this.id=S,this._proxy=y,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=P,this._viewColumn=w}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(y){if(!Array.isArray(y)||!y.every(m.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");S._selections=y,S._trySetSelections(y)},get visibleRanges(){return S._visibleRanges},revealRange(y,R){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(y),R??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(y){const R=new C(this.document.version);return y(R),S._applyEdit(R.finalize())},setDecorations(y,R){return S.setDecorations(y,R)}},i.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const y=[];let R=-1;for(let P=0;P<S.cellEdits.length;P++){if(R<0){y.push(S.cellEdits[P]),R++;continue}const w=y[R],f=S.cellEdits[P];if(w.editType===1&&f.editType===1&&w.index===f.index){w.cells.push(...S.cellEdits[P].cells),w.count+=S.cellEdits[P].count;continue}y.push(S.cellEdits[P]),R++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,y)}setDecorations(S,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return y.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(y),S.key)}}e.ExtHostNotebookEditor=i,i.apiEditorsToExtHost=new WeakMap}),define(ge[219],pe([0,1,16,117,164,21,57,15]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,w,f){const v=this._handles++,{title:_,location:A,cancellable:p}=w,o={label:(0,D.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(v,{location:m.ProgressLocation.from(A),title:_,source:o,cancellable:p},a).catch(k.onUnexpectedExternalError),this._withProgress(v,f,!!p)}_withProgress(a,w,f){let v;f&&(v=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,v));const _=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),v&&v.dispose()};let A;try{A=w(new R(this._proxy,a),f&&v?v.token:C.CancellationToken.None)}catch(p){throw _(a),p}return A.then(p=>_(a),p=>_(a)),A}$acceptProgressCanceled(a){const w=this._mapHandleToCancellationSource.get(a);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=S;function y(P,a){return P.message=a.message,typeof a.increment=="number"&&(typeof P.increment=="number"?P.increment+=a.increment:P.increment=a.increment),P}class R extends L.Progress{constructor(a,w){super(f=>this.throttledReport(f));this._proxy=a,this._handle=w}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,i.throttle)(100,(P,a)=>y(P,a),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ge[129],pe([0,1,56,15,75,16,7]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(a,w,f){const v=k._Keys.nextId();a.$registerTextEditorDecorationType(w.identifier,v,C.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:v,dispose(){a.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(a,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,w){this._throwIfFinalized();let f=null;if(a instanceof i.Position)f=new i.Range(a,a);else if(a instanceof i.Range)f=a;else throw new Error("Unrecognized location");this._pushEdit(f,w,!1)}insert(a,w){this._throwIfFinalized(),this._pushEdit(new i.Range(a,a),w,!0)}delete(a){this._throwIfFinalized();let w=null;if(a instanceof i.Range)w=a;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(a,w,f){const v=this._document.validateRange(a);this._collectedEdits.push({range:v,text:w,forceMoveMarkers:f})}setEndOfLine(a){if(this._throwIfFinalized(),a!==i.EndOfLine.LF&&a!==i.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=S;class y{constructor(a,w,f,v){this._proxy=a,this._id=w,this._accept(f),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(A){_._setTabSize(A)},get insertSpaces(){return _._insertSpaces},set insertSpaces(A){_._setInsertSpaces(A)},get cursorStyle(){return _._cursorStyle},set cursorStyle(A){_._setCursorStyle(A)},get lineNumbers(){return _._lineNumbers},set lineNumbers(A){_._setLineNumbers(A)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const w=Math.floor(a);return w>0?w:null}if(typeof a=="string"){const w=parseInt(a,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(a){const w=this._validateTabSize(a);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const w=this._validateInsertSpaces(a);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(a)})))}assign(a){const w={};let f=!1;if(typeof a.tabSize!="undefined"){const v=this._validateTabSize(a.tabSize);v==="auto"?(f=!0,w.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,f=!0,w.tabSize=v)}if(typeof a.insertSpaces!="undefined"){const v=this._validateInsertSpaces(a.insertSpaces);v==="auto"?(f=!0,w.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,f=!0,w.insertSpaces=v)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,f=!0,w.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,f=!0,w.lineNumbers=C.TextEditorLineNumbersStyle.from(a.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(a,w){w.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=y;class R{constructor(a,w,f,v,_,A,p,o){this.id=a,this._proxy=w,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new y(this._proxy,this.id,A,f),this._visibleRanges=p,this._viewColumn=o;const r=this;this.value=Object.freeze({get document(){return v.getValue()},set document(g){throw(0,L.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(g){if(!(g instanceof i.Selection))throw(0,L.illegalArgument)("selection");r._selections=[g],r._trySetSelection()},get selections(){return r._selections},set selections(g){if(!Array.isArray(g)||g.some(c=>!(c instanceof i.Selection)))throw(0,L.illegalArgument)("selections");r._selections=g,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return r._options.value},set options(g){r._disposed||r._options.assign(g)},get viewColumn(){return r._viewColumn},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,c={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new S(v.getValue(),c);return g(E),r._applyEdit(E)},insertSnippet(g,c,E={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!c||Array.isArray(c)&&c.length===0)n=r._selections.map(t=>C.Range.from(t));else if(c instanceof i.Position){const{lineNumber:t,column:s}=C.Position.from(c);n=[{startLineNumber:t,startColumn:s,endLineNumber:t,endColumn:s}]}else if(c instanceof i.Range)n=[C.Range.from(c)];else{n=[];for(const t of c)if(t instanceof i.Range)n.push(C.Range.from(t));else{const{lineNumber:s,column:d}=C.Position.from(t);n.push({startLineNumber:s,startColumn:d,endLineNumber:s,endColumn:d})}}return w.$tryInsertSnippet(a,g.value,n,E)},setDecorations(g,c){const E=c.length===0;E&&!r._hasDecorationsForKey.has(g.key)||(E?r._hasDecorationsForKey.delete(g.key):r._hasDecorationsForKey.add(g.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(c))return w.$trySetDecorations(a,g.key,C.fromRangeOrRangeWithMessage(c));{const n=new Array(4*c.length);for(let t=0,s=c.length;t<s;t++){const d=c[t];n[4*t]=d.start.line+1,n[4*t+1]=d.start.character+1,n[4*t+2]=d.end.line+1,n[4*t+3]=d.end.character+1}return w.$trySetDecorationsFast(a,g.key,n)}}))},revealRange(g,c){r._runOnProxy(()=>w.$tryRevealRange(a,C.Range.from(g),c||i.TextEditorRevealType.Default))},show(g){w.$tryShowEditor(a,C.ViewColumn.from(g))},hide(){w.$tryHideEditor(a)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,m.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,m.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,m.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,m.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const w=a.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const f=w.edits.map(_=>_.range);f.sort((_,A)=>_.end.line===A.end.line?_.end.character===A.end.character?_.start.line===A.start.line?_.start.character-A.start.character:_.start.line-A.start.line:_.end.character-A.end.character:_.end.line-A.end.line);for(let _=0,A=f.length-1;_<A;_++){const p=f[_].end;if(f[_+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=w.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,v,{setEndOfLine:typeof w.setEndOfLine=="number"?C.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=R}),define(ge[220],pe([0,1,167,23,2,3,6,18,7,13,17,16,21,204]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(A,p){if((0,y.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let o;return Array.isArray(A.highlights)&&(o=A.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),o=o.length?o:void 0),{label:A.label,highlights:o}}}class v{constructor(p,o,r){this._proxy=p,this.commands=o,this.logService=r,this.treeViews=new Map;function g(c){return c&&c.$treeViewId&&c.$treeItemHandle}o.registerArgumentProcessor({processArgument:c=>g(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(E=>g(E)?this.convertArgument(E):E):c})}registerTreeDataProvider(p,o,r){const g=this.createTreeView(p,{treeDataProvider:o},r);return{dispose:()=>g.dispose()}}createTreeView(p,o,r){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.supportedMimeTypes,c=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dragAndDropMimeTypes:g}),E=this.createExtHostTreeView(p,o,r);return{get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get message(){return E.message},set message(n){E.message=n},get title(){return E.title},set title(n){E.title=n},get description(){return E.description},set description(n){E.description=n},reveal:(n,t)=>E.reveal(n,t),dispose:async()=>{await c,this.treeViews.delete(p),E.dispose()}}}$getChildren(p,o){const r=this.treeViews.get(p);return r?r.getChildren(o):Promise.reject(new Error((0,m.localize)(0,null,p)))}async $onDrop(p,o,r,g,c){const E=this.treeViews.get(p);if(!E)return Promise.reject(new Error((0,m.localize)(1,null,p)));const n=w.TreeDataTransferConverter.toITreeDataTransfer(o);if(g===p&&c){const t=await E.onWillDrop(c);t&&t.forEach((s,d)=>{s&&n.set(d,s)})}return E.onDrop(n,r)}async $hasResolve(p){const o=this.treeViews.get(p);if(!o)throw new Error((0,m.localize)(2,null,p));return o.hasResolve}$resolve(p,o,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(3,null,p));return g.resolveTreeItem(o,r)}$setExpanded(p,o,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(4,null,p));g.setExpanded(o,r)}$setSelection(p,o){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(5,null,p));r.setSelection(o)}$setVisible(p,o){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(6,null,p));r.setVisible(o)}createExtHostTreeView(p,o,r){const g=new _(p,o,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(p,g),g}convertArgument(p){const o=this.treeViews.get(p.$treeViewId);return o?o.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=v;class _ extends i.Disposable{constructor(p,o,r,g,c,E){super();if(this.viewId=p,this.proxy=r,this.commands=g,this.logService=c,this.extension=E,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new a.CancellationTokenSource,E.contributes&&E.contributes.views)for(const s in E.contributes.views)for(const d of E.contributes.views[s])d.id===p&&(this._title=d.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(s=>this._onDidChangeData.fire({message:!1,element:s}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(s,d)=>(s||(s={message:!1,elements:[]}),d.element!==!1&&(n||(n=new Promise(l=>t=l),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(d.element)?s.elements.push(...d.element):s.elements.push(d.element)),d.message&&(s.message=!0),s),200,!0)(({message:s,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const l=t;return n=null,this.refresh(d).then(()=>l())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,y.isUndefinedOrNull)(p))}async getChildren(p){const o=p?this.getExtensionElement(p):void 0;if(p&&!o)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(p);return r||(r=await this.fetchChildrenNodes(o)),r?r.map(g=>g.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,o){o=o||{select:!0,focus:!1};const r=(0,y.isUndefinedOrNull)(o.select)?!0:o.select,g=(0,y.isUndefinedOrNull)(o.focus)?!1:o.focus,c=(0,y.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(E=>this.resolveTreeNode(p,E[E.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:E.map(t=>t.item)},{select:r,focus:g,expand:c})),E=>this.logService.error(E)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:g,expand:c})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,o){const r=this.getExtensionElement(p);r&&(o?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(p){(0,R.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(p){const o=[];for(const r of p){const g=this.getExtensionElement(r);g&&o.push(g)}if(!(!this.dndController?.onWillDrop||o.length===0))return this.dndController.onWillDrop(o)}async onDrop(p,o){const r=this.getExtensionElement(o);if(!!r)return(0,k.asPromise)(()=>this.dndController?.onDrop(p,r))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,o){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(p);if(r){const g=this.nodes.get(r);if(g){const c=await this.dataProvider.resolveTreeItem(g.extensionItem,r,o)??g.extensionItem;return g.item.tooltip=this.getTooltip(c.tooltip),g.item.command=this.getCommand(g.disposableStore,c.command),g.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(o=>o?this.resolveUnknownParentChain(o).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(g=>(r.push(g),r))):Promise.resolve([]))}resolveParent(p){const o=this.nodes.get(p);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,o){const r=this.nodes.get(p);return r?Promise.resolve(r):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(g=>this.createHandle(p,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const c=this.getExtensionElement(g);if(c){const E=this.nodes.get(c);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(p){if(p){let o;if(typeof p=="string"){const r=this.getExtensionElement(p);o=r?this.nodes.get(r):void 0}else o=p;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const o=new a.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=p?this.nodes.get(p):void 0,g=await this.dataProvider.getChildren(p);if(o.token.isCancellationRequested)return;const c=await Promise.all((0,R.coalesce)(g||[]).map(async E=>{const n=await this.dataProvider.getTreeItem(E);return n&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(E,n,r):null}));return o.token.isCancellationRequested?void 0:(0,R.coalesce)(c)}finally{o.dispose()}}refresh(p){if(p.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new a.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(p);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const o=new Set,r=p.map(c=>this.nodes.get(c));for(const c of r)if(c&&!o.has(c.item.handle)){let E=c;for(;E&&E.parent&&r.findIndex(n=>E&&E.parent&&n&&n.item.handle===E.parent.item.handle)===-1;){const n=this.elements.get(E.parent.item.handle);E=n?this.nodes.get(n):void 0}E&&!E.parent&&o.add(c.item.handle)}const g=[];return o.forEach(c=>{const E=this.elements.get(c);if(E){const n=this.nodes.get(E);n&&(!n.parent||!o.has(n.parent.item.handle))&&g.push(c)}}),g}refreshHandles(p){const o={};return Promise.all(p.map(r=>this.refreshNode(r).then(g=>{g&&(o[r]=g.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(p){const o=this.getExtensionElement(p);if(o){const r=this.nodes.get(o);if(r)return this.clearChildren(o),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(g=>{if(g){const c=this.createTreeNode(o,g,r.parent);return this.updateNodeCache(o,c,r,r.parent),r.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,o,r){const g=this.createTreeNode(p,o,r);if(o.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,o.id));return this.addNodeToCache(p,g),this.addNodeToParentCache(g,r),g}getTooltip(p){return S.MarkdownString.isMarkdownString(p)?P.MarkdownString.from(p):p}getCommand(p,o){return o?this.commands.toInternal(o,p):void 0}createTreeNode(p,o,r){const g=new i.DisposableStore,c=this.createHandle(p,o,r),E=this.getLightIconPath(o);return{item:{handle:c,parentHandle:r?r.item.handle:void 0,label:f(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(g,o.command),contextValue:o.contextValue,icon:E,iconDark:this.getDarkIconPath(o)||E,themeIcon:this.getThemeIcon(o),collapsibleState:(0,y.isUndefinedOrNull)(o.collapsibleState)?S.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:r,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(p){return p.iconPath instanceof S.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:o,label:r,resourceUri:g},c,E){if(o)return`${_.ID_HANDLE_PREFIX}/${o}`;const n=f(r,this.extension),t=c?c.item.handle:_.LABEL_HANDLE_PREFIX;let s=n?n.label:g?(0,L.basename)(g):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const d=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,l=this.getChildrenNodes(c)||[];let h,u=0;do{if(h=`${t}/${u}:${s}`,E||!this.elements.has(h)||d===h)break;u++}while(u<=l.length);return h}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon))return typeof p.iconPath=="string"||D.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return D.URI.isUri(p)?p:D.URI.file(p)}addNodeToCache(p,o){this.elements.set(o.item.handle,p),this.nodes.set(p,o)}updateNodeCache(p,o,r,g){this.elements.delete(o.item.handle),this.nodes.delete(p),o.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(p,o);const c=this.getChildrenNodes(g)||[],E=c.filter(n=>n.item.handle===r.item.handle)[0];E&&c.splice(c.indexOf(E),1,o)}addNodeToParentCache(p,o){o?(o.children||(o.children=[]),o.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const o=this.nodes.get(p);if(o){if(o.children)for(const r of o.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}o.children=void 0}}else this.clearAll()}clear(p){const o=this.nodes.get(p);if(o){if(o.children)for(const r of o.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}this.nodes.delete(p),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}_.LABEL_HANDLE_PREFIX="0",_.ID_HANDLE_PREFIX="1"}),define(ge[221],pe([0,1,18,3,6,13,63,16,126,89]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends D.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new i.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const w of this.tree.values())this.updateExpandability(w)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const w=this.diff[this.diff.length-1];if(w&&a[0]===1){if(w[0]===1&&w[1].extId===a[1].extId){(0,S.applyTestItemUpdate)(w[1],a[1]);return}if(w[0]===0&&w[1].item.extId===a[1].extId){(0,S.applyTestItemUpdate)(w[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,w){const f=this.tree.get(a);if(!!f){if((f.expandLevels===void 0||w>f.expandLevels)&&(f.expandLevels=w),f.expand===1){const v=this.resolveChildren(f);return v.isOpen()?this.expandChildren(f,w-1):v.wait().then(()=>this.expandChildren(f,w-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,w-1)):this.expandChildren(f,w-1)}}dispose(){for(const a of this.tree.values())(0,i.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,w){switch(w.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(y.TestId.joinToString(a.fullId,w.id));break;case 0:this.upsertItem(w.item,a);break;case 4:for(const p of w.ops)this.onTestItemEvent(a,p);break;case 3:const{key:f,value:v,previous:_}=w,A=a.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(v,_,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:k.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:k.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[f]:v??null}}]);break}break;default:(0,C.assertNever)(w)}}upsertItem(a,w){if(!(a instanceof i.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const f=y.TestId.fromExtHostTestItem(a,this.root.id,w?.actual),v=(0,i.getPrivateApiFor)(a);v.parent&&v.parent!==w?.actual&&v.parent.children.delete(a.id);let _=this.tree.get(f.toString());if(!_){_={fullId:f,actual:a,parent:w?f.parentId:null,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(a,w),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(a)}]),this.connectItemAndChildren(a,_,w);return}if(_.actual===a){this.connectItem(a,_,w);return}const A=_.actual.children,p=_.actual,o=(0,i.diffTestItems)(p,a);(0,i.getPrivateApiFor)(p).listener=void 0,_.actual=a,_.expand=0;for(const[r,g]of o)this.onTestItemEvent(_,{op:3,key:r,value:g,previous:p[r]});this.connectItemAndChildren(a,_,w);for(const r of A)a.children.get(r.id)||this.removeItem(y.TestId.joinToString(f,r.id))}diffTagRefs(a,w,f){const v=new Set(w.map(_=>_.id));for(const _ of a)v.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:f,item:{tags:a.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const w=this.tags.get(a.id);w?w.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const w=this.tags.get(a);w&&!--w.refCount&&(this.tags.delete(a),this.pushDiff([6,k.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,w){(0,i.getPrivateApiFor)(a).parent=w&&w.actual!==this.root?w.actual:void 0}connectItem(a,w,f){this.setItemParent(a,f);const v=(0,i.getPrivateApiFor)(a);v.parent=f?.actual,v.listener=_=>this.onTestItemEvent(w,_),this.updateExpandability(w)}connectItemAndChildren(a,w,f){this.connectItem(a,w,f);for(const v of a.children)this.upsertItem(v,w)}updateExpandability(a){let w;this._resolveHandler?a.resolveBarrier?w=a.resolveBarrier.isOpen()?3:2:w=a.actual.canResolveChildren?1:0:w=0,w!==a.expand&&(a.expand=w,this.pushDiff([1,{extId:a.fullId.toString(),expand:w}]),w===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,w){if(w<0)return;const f=[];for(const v of a.actual.children){const _=this.expand(y.TestId.joinToString(a.fullId,v.id),w);(0,m.isThenable)(_)&&f.push(_)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const _=new m.Barrier;return _.open(),_}a.expand=2,this.pushExpandStateUpdate(a);const w=a.resolveBarrier=new m.Barrier,f=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(_){f(_)}return(0,m.isThenable)(v)?v.catch(f).then(()=>{w.open(),this.updateExpandability(a)}):(w.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const w=this.tree.get(a);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const f=[w];for(;f.length;){const v=f.pop();if(!!v){(0,i.getPrivateApiFor)(v.actual).listener=void 0;for(const _ of v.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)f.push(this.tree.get(y.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=R}),define(ge[222],pe([0,1,4,182]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(ge[223],pe([0,1,27,3,9]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=C;class i{constructor(R){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let P of R.activationEvents)P==="onUri"&&(P=`onUri:${m.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(R)}}keepOnly(R){const P=new Set;R.forEach(a=>P.add(m.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>P.has(m.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,P){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const a=i._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(a.map(w=>w.identifier)),P.length>0){const w=new Set;P.forEach(f=>w.add(m.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!w.has(m.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(a)}static _findLoopingExtensions(R){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,A){this.addNode(_),this.addNode(A),this._arcs.has(_)?this._arcs.get(_).push(A):this._arcs.set(_,[A])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,A){const p=P.getArcs(_);for(let o=0;o<p.length;o++)if(!A.has(p[o]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let _ of R){const A=m.ExtensionIdentifier.toKey(_.identifier);if(a.set(A,_),_.extensionDependencies)for(let p of _.extensionDependencies){const o=m.ExtensionIdentifier.toKey(p);P.addArc(A,o)}}let w=new Set;P.getNodes().filter(_=>P.getArcs(_).length===0).forEach(_=>w.add(_));let f=P.getNodes().filter(_=>!w.has(_)),v;do{v=!1;for(let _=0;_<f.length;_++){const A=f[_];P.hasOnlyGoodArcs(A,w)&&(f.splice(_,1),_--,w.add(A),v=!0)}}while(v);return f.map(_=>a.get(_))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const P=this._activationMap.get(R);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const P=this._extensionsMap.get(m.ExtensionIdentifier.toKey(R));return P||void 0}}e.ExtensionDescriptionRegistry=i;var k;(function(y){y[y.Builtin=0]="Builtin",y[y.User=1]="User",y[y.Dev=2]="Dev"})(k||(k={}));function S(y,R){const P=y.isBuiltin?0:y.isUnderDevelopment?2:1,a=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(P!==a)return P-a;const w=D.posix.basename(y.extensionLocation.path),f=D.posix.basename(R.extensionLocation.path);return w<f?-1:w>f?1:0}}),define(ge[224],pe([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function C(k){const S=m.VSBuffer.alloc(1);switch(k){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function i(k,S){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=i}),define(ge[29],pe([0,1,3,2,4,27,193]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class y{constructor(g){this.dependency=g}}e.MissingExtensionDependency=y;var R;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function P(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=P;function a(r,g){return r.enabledApiProposals?r.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=a;function w(r,g){if(!a(r,g))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=w;class f{constructor(g,c,E,n){this.codeLoadingTime=g,this.activateCallTime=c,this.activateResolvedTime=E,this.activationReason=n}}e.ActivationTimes=f;class v{constructor(g,c){this.description=g,this.value=c}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var _;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(_=e.ActivationKind||(e.ActivationKind={}));function A(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,i.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=A;function p(r,g){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!g,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=p;class o{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,c){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,c,E,n,t){}_onDidActivateExtensionError(g,c){}_onExtensionRuntimeError(g,c){}_onExtensionHostExit(g){}}e.NullExtensionService=o}),define(ge[225],pe([0,1,15,27,29,11]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const i=Promise.resolve(void 0);class k{constructor(v,_,A,p){this.startup=v,this.codeLoadingTime=_,this.activateCallTime=A,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(v){this._startup=v,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(v,_){return v===-1||_===-1?-1:_-v}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class y{constructor(v,_,A,p,o,r){this.activationFailed=v,this.activationFailedError=_,this.activationTimes=A,this.module=p,this.exports=o,this.subscriptions=r}}e.ActivatedExtension=y;class R extends y{constructor(v){super(!1,null,v,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends y{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class a extends y{constructor(v){super(!0,v,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=a;let w=class{constructor(v,_,A,p,o){this._logService=o,this._isDisposed=!1,this._registry=v,this._resolvedExtensionsSet=new Set,_.forEach(r=>this._resolvedExtensionsSet.add(L.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,A.forEach(r=>this._hostExtensionsMap.set(L.ExtensionIdentifier.toKey(r),r)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(v){const _=L.ExtensionIdentifier.toKey(v);return this._activatedExtensions.has(_)}getActivatedExtension(v){const _=L.ExtensionIdentifier.toKey(v),A=this._activatedExtensions.get(_);if(!A)throw new Error("Extension `"+v.value+"` is not known or not activated");return A}activateByEvent(v,_){if(this._alreadyActivatedEvents[v])return i;const A=this._registry.getExtensionDescriptionsForActivationEvent(v);return this._activateExtensions(A.map(p=>({id:p.identifier,reason:{startup:_,extensionId:p.identifier,activationEvent:v}}))).then(()=>{this._alreadyActivatedEvents[v]=!0})}activateById(v,_){const A=this._registry.getExtensionDescription(v);if(!A)throw new Error("Extension `"+v+"` is not known");return this._activateExtensions([{id:A.identifier,reason:_}])}_handleActivateRequest(v,_,A){if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(v.id))){_[L.ExtensionIdentifier.toKey(v.id)]=v;return}const p=this._registry.getExtensionDescription(v.id);if(!p){const g=new Error(`Cannot activate unknown extension '${v.id.value}'`);this._host.onExtensionActivationError(v.id,g,new D.MissingExtensionDependency(v.id.value)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(v.id),new a(g));return}const o=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let r=!0;for(let g=0,c=o.length;g<c;g++){const E=o[g];if(this._resolvedExtensionsSet.has(L.ExtensionIdentifier.toKey(E)))continue;const n=this._activatedExtensions.get(L.ExtensionIdentifier.toKey(E));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const l=p.displayName||p.identifier.value,h=this._registry.getExtensionDescription(E),u=h&&h.displayName||E,b=new Error(`Cannot activate the '${l}' extension because its dependency '${u}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(p.identifier,b,null),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new a(b));return}if(this._hostExtensionsMap.has(L.ExtensionIdentifier.toKey(E))){r=!1,_[L.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(L.ExtensionIdentifier.toKey(E)),reason:v.reason};continue}const t=this._registry.getExtensionDescription(E);if(t){if(!t.main&&!t.browser)continue;r=!1,_[L.ExtensionIdentifier.toKey(E)]={id:t.identifier,reason:v.reason};continue}const s=p.displayName||p.identifier.value,d=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(p.identifier,d,new D.MissingExtensionDependency(E)),this._activatedExtensions.set(L.ExtensionIdentifier.toKey(p.identifier),new a(d));return}r?_[L.ExtensionIdentifier.toKey(p.identifier)]=v:A.push(v)}_activateExtensions(v){if(v.length===0||(v=v.filter(o=>!this._activatedExtensions.has(L.ExtensionIdentifier.toKey(o.id))),v.length===0))return Promise.resolve(void 0);const _=Object.create(null),A=[];for(let o=0,r=v.length;o<r;o++)this._handleActivateRequest(v[o],_,A);for(let o=0,r=A.length;o<r;o++){const g=L.ExtensionIdentifier.toKey(A[o].id);_[g]&&delete _[g]}const p=Object.keys(_).map(o=>_[o]);return A.length===0?Promise.all(p.map(o=>this._activateExtension(o.id,o.reason))).then(o=>{}):this._activateExtensions(p).then(o=>this._activateExtensions(A))}_activateExtension(v,_){const A=L.ExtensionIdentifier.toKey(v);if(this._activatedExtensions.has(A))return Promise.resolve(void 0);const p=this._activatingExtensions.get(A);if(p)return p;const o=this._host.actualActivateExtension(v,_).then(void 0,r=>{const g=new Error;return r&&r.name&&(g.name=r.name),r&&r.message?g.message=`Activating extension '${v.value}' failed: ${r.message}.`:g.message=`Activating extension '${v.value}' failed: ${r}.`,r&&r.stack&&(g.stack=r.stack),this._isDisposed&&m.isPromiseCanceledError(r)?new a(r):(this._host.onExtensionActivationError(v,g,null),this._logService.error(`Activating extension ${v.value} failed due to an error:`),this._logService.error(r),new a(r))}).then(r=>{this._activatedExtensions.set(A,r),this._activatingExtensions.delete(A)});return this._activatingExtensions.set(A,o),o}};w=Ve([He(4,C.ILogService)],w),e.ExtensionsActivator=w}),define(ge[226],pe([0,1,11,26,29]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:D.ExtensionHostLogFileName}))}};C=Ve([He(0,m.ILoggerService),He(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ge[227],pe([0,1,15]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,i)=>{this._actualOk=C,this._actualErr=i,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,i){return this._ensureActual().then(C,i)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(ge[53],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(y,R){this._proxyIdentifierBrand=void 0,this.isMain=y,this.sid=R,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function D(S){const y=new m(!0,S);return L[y.nid]=y,y}e.createMainContextProxyIdentifier=D;function C(S){const y=new m(!1,S);return L[y.nid]=y,y}e.createExtHostContextProxyIdentifier=C;function i(S){return L[S].sid}e.getStringIdentifierForProxy=i;class k{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=k}),define(ge[5],pe([0,1,59,2,53]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var i;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(i=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(o){o.name="$ident";function r(c,E){return Object.defineProperty(c,o.name,{value:E,enumerable:!0}),c}o.mixin=r;function g(c){return c[o.name]}o.of=g})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class w{static mixin(r){return r._id=w._n++,r}}e.IdObject=w,w._n=0;var f;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(o){if(o&&o.edits)for(const r of o.edits)typeof r.resource=="object"?r.resource=L.URI.revive(r.resource):(r.newUri=L.URI.revive(r.newUri),r.oldUri=L.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return o}e.reviveWorkspaceEditDto=A;var p;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[90],pe([0,1,5,3,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,y){return this._proxy.$setPassword(k,S,y)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(ge[65],pe([0,1,4,11,5,14]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let i=class{constructor(S,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,y,R){const P=this.getUsageKey(S,y);this._reportedUsages.has(P)||(this._reportedUsages.add(P),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}getUsageKey(S,y){return`${S}-${y.identifier.value}`}};i=Ve([He(0,C.IExtHostRpcService),He(1,L.ILogService)],i),e.ExtHostApiDeprecationService=i,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,y){}})}),define(ge[228],pe([0,1,3,5,7,27]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class i{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,y,R,P={}){const a=C.ExtensionIdentifier.toKey(S.identifier),w=this._inFlightRequests.get(a)||[],f=[...R].sort().join(" ");let v=w.find(_=>_.scopes===f);if(v)return v.result;{const _=this._getSession(S,a,y,R,P);v={scopes:f,result:_},w.push(v),this._inFlightRequests.set(a,w);try{await _}finally{const A=w.findIndex(p=>p.scopes===f);A>-1&&(w.splice(A),this._inFlightRequests.set(a,w))}return _}}async _getSession(S,y,R,P,a={}){await this._proxy.$ensureProvider(R);const w=S.displayName||S.name;return this._proxy.$getSession(R,P,y,w,a)}async removeSession(S,y){const R=this._authenticationProviders.get(S);return R?R.provider.removeSession(y):this._proxy.$removeSession(S,y)}registerAuthenticationProvider(S,y,R,P){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:y,provider:R,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(w=>w.id===S)||this._providers.push({id:S,label:y});const a=R.onDidChangeSessions(w=>{this._proxy.$sendDidChangeSessions(S,{added:w.added??[],changed:w.changed??[],removed:w.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,y,P?.supportsMultipleAccounts??!1),new D.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(S);const w=this._providers.findIndex(f=>f.id===S);w>-1&&this._providers.splice(w),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const R=this._authenticationProviders.get(S);if(R)return Promise.resolve(R.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this._onDidChangeSessions.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=i}),define(ge[229],pe([0,1,5,14,16]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,S){this._extHostDocumentsAndEditors=S,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const S=D.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=Ve([He(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ge[230],pe([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const i=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return i.$readText()},writeText(k){return i.$writeText(k)}})}}e.ExtHostClipboard=L}),define(ge[38],pe([0,1,13,7,16,25,5,17,11,59,41,49,2,6,4,14,63,22,53,50]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(s,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(i.MainContext.MainThreadCommands),this._logService=d,this.converter=new g(this,l=>{const h=this._apiCommands.get(l);return h?.result===E.Void?h:void 0},d),this._argumentProcessors=[{processArgument(l){return(0,y.revive)(l)}},{processArgument(l){return(0,C.cloneAndChange)(l,function(h){if(R.Range.isIRange(h))return D.Range.to(h);if(P.Position.isIPosition(h))return D.Position.to(h);if(R.Range.isIRange(h.range)&&a.URI.isUri(h.uri))return D.location.to(h);if(h instanceof A.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const d=this.registerCommand(!1,s.id,async(...l)=>{const h=s.args.map((b,I)=>{if(!b.validate(l[I]))throw new Error(`Invalid argument '${b.name}' when running '${s.id}', received: ${l[I]}`);return b.convert(l[I])}),u=await this.executeCommand(s.internalId,...h);return s.result.convert(u,l,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new L.Disposable(()=>{d.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,d,l,h,u,b){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:l,thisArg:h,description:u,extension:b}),s&&this._proxy.$registerCommand(d),new L.Disposable(()=>{this._commands.delete(d)&&s&&this._proxy.$unregisterCommand(d)})}executeCommand(s,...d){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,d,!0)}async _doExecuteCommand(s,d,l){if(this._commands.has(s))return this._executeContributedCommand(s,d,!1);{let h=!1;const u=(0,C.cloneAndChange)(d,function(b){if(b instanceof L.Position)return D.Position.from(b);if(b instanceof L.Range)return D.Range.from(b);if(b instanceof L.Location)return D.location.from(b);if(L.NotebookRange.isNotebookRange(b))return D.NotebookRange.from(b);if(b instanceof ArrayBuffer)return h=!0,A.VSBuffer.wrap(new Uint8Array(b));if(b instanceof Uint8Array)return h=!0,A.VSBuffer.wrap(b);if(!Array.isArray(b))return b});try{const b=await this._proxy.$executeCommand(s,h?new p.SerializableObjectWithBuffers(u):u,l);return(0,y.revive)(b)}catch(b){if(b instanceof Error&&b.message==="$executeCommand:retry")return this._doExecuteCommand(s,d,!1);throw b}}}async _executeContributedCommand(s,d,l){const h=this._commands.get(s);if(!h)throw new Error("Unknown command");let{callback:u,thisArg:b,description:I}=h;if(I)for(let T=0;T<I.args.length;T++)try{(0,m.validateConstraint)(d[T],I.args[T].constraint)}catch(x){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${I.args[T].name}' - ${I.args[T].description}`)}try{return await u.apply(b,d)}catch(T){if(s===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...d);x&&(s=x.command)}throw this._logService.error(T,s,h.extension?.identifier),l?new class extends Error{constructor(){super((0,o.toErrorMessage)(T));this.id=s,this.source=h.extension?.displayName??h.extension?.name}}:T}}$executeContributedCommand(s,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(d=d.map(l=>this._argumentProcessors.reduce((h,u)=>u.processArgument(h),l)),this._executeContributedCommand(s,d,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(d=>(s&&(d=d.filter(l=>l[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[d,l]of this._commands){let{description:h}=l;h&&(s[d]=h)}return Promise.resolve(s)}};r=Ve([He(0,v.IExtHostRpcService),He(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class g{constructor(s,d,l){this._commands=s,this._lookupApiCommand=d,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,d){if(!s)return;const l={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return l;const h=this._lookupApiCommand(s.command);if(h)l.id=h.internalId,l.arguments=h.args.map((u,b)=>u.convert(s.arguments&&s.arguments[b]));else if((0,k.isNonEmptyArray)(s.arguments)){const u=++this._cachIdPool;this._cache.set(u,s),d.add((0,w.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),l.$ident=u,l.id=this.delegatingCommandId,l.arguments=[u],this._logService.trace("CommandsConverter#CREATE",s.command,u)}return l}fromInternal(s){const d=i.ObjectIdentifier.of(s);return typeof d=="number"?this._cache.get(d):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const d=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class c{constructor(s,d,l,h){this.name=s,this.description=d,this.validate=l,this.convert=h}optional(){return new c(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,d){return new c(s??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",t=>a.URI.isUri(t),t=>t),c.Position=new c("position","A position in a text document",t=>L.Position.isPosition(t),D.Position.from),c.Range=new c("range","A range in a text document",t=>L.Range.isRange(t),D.Range.from),c.Selection=new c("selection","A selection in a text document",t=>L.Selection.isSelection(t),D.Selection.from),c.Number=new c("number","",t=>typeof t=="number",t=>t),c.String=new c("string","",t=>typeof t=="string",t=>t),c.CallHierarchyItem=new c("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,D.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,D.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",t=>t instanceof _.TestItemImpl,D.TestItem.from);class E{constructor(s,d){this.description=s,this.convert=d}}e.ApiCommandResult=E,E.Void=new E("no result",t=>t);class n{constructor(s,d,l,h,u){this.id=s,this.internalId=d,this.description=l,this.args=h,this.result=u}}e.ApiCommand=n}),define(ge[231],pe([0,1,16,7,84,38,17,110]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,w)=>{if((0,i.isFalsyOrEmpty)(a))return;class f extends L.SymbolInformation{static to(_){const A=new f(_.name,m.SymbolKind.to(_.kind),_.containerName||"",new L.Location(w[0],m.Range.to(_.range)));return A.detail=_.detail,A.range=A.location.range,A.selectionRange=m.Range.to(_.selectionRange),A.children=_.children?_.children.map(f.to):[],A}}return a.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new C.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(w=>L.Position.isPosition(w)),a=>a.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(w=>{let f;for(const v of w.reverse())f=new L.SelectionRange(m.Range.to(v),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:m.Range.to(a.range),placeholder:a.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return m.WorkspaceEdit.to(a)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const w=(0,k.decodeSemanticTokensDto)(a);if(w.type==="full")return new L.SemanticTokens(w.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const w=(0,k.decodeSemanticTokensDto)(a);if(w.type==="full")return new L.SemanticTokens(w.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,w,f)=>{if(!a)return new L.CompletionList([]);const v=a.suggestions.map(_=>m.CompletionItem.to(_,f));return new L.CompletionList(v,a.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return m.SignatureHelp.to(a)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,w,f)=>R(v=>new L.CodeLens(m.Range.to(v.range),v.command&&f.fromInternal(v.command)))(a))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>L.Range.isRange(a),a=>L.Selection.isSelection(a)?m.Selection.from(a):m.Range.from(a)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,w,f)=>R(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(v.command)}else{const _=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=m.WorkspaceEdit.to(v.edit)),v.command&&(_.command=f.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(a))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(w=>new L.ColorInformation(m.Range.to(w.range),m.Color.to(w.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",a=>a instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:m.Range.from(a.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(w=>m.NotebookExclusiveDocumentPattern.to(w))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[m.ViewColumn.from(a.viewColumn),m.TextEditorOpenOptions.from(a)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class y{static register(w){S.forEach(w.registerApiCommand,w)}}e.ExtHostApiCommands=y;function R(a){return w=>{if(Array.isArray(w))return w.map(a)}}function P(a){if(!Array.isArray(a))return;const w=[];for(const f of a)D.isLocationLink(f)?w.push(m.DefinitionLink.to(f)):w.push(m.location.to(f));return w}}),define(ge[232],pe([0,1,18,57,3,6,2,84,27,16,7,5]),function(Y,e,m,L,D,C,i,k,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(w,f,v){const _=w.getProxy(P.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const s=this._commentControllers.get(t.handle);return s||t}else if(t&&t.$mid===7){const s=this._commentControllers.get(t.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let l=t.commentUniqueId,h=d.getCommentByUniqueId(l);return h||t}else if(t&&t.$mid===10){const s=this._commentControllers.get(t.thread.commentControlHandle);if(!s)return t;const d=s.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let l=t.text,h=t.commentUniqueId,u=d.getCommentByUniqueId(h);return u?(u.body=l,u):t}return t}})}createCommentController(t,s,d){const l=A.handlePool++,h=new o(t,l,s,d);this._commentControllers.set(h.handle,h);const u=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(h),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),u),h.value}$createCommentThreadTemplate(t,s,d){const l=this._commentControllers.get(t);!l||l.$createCommentThreadTemplate(s,d)}async $updateCommentThreadTemplate(t,s,d){const l=this._commentControllers.get(t);!l||l.$updateCommentThreadTemplate(s,d)}$deleteCommentThread(t,s){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(s)}$provideCommentingRanges(t,s,d){const l=this._commentControllers.get(t);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const h=v.getDocument(i.URI.revive(s));return(0,m.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(h,d)).then(u=>u?u.map(b=>y.Range.from(b)):void 0)}$toggleReaction(t,s,d,l,h){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const b=u.getCommentThread(s);if(b){const I=b.getCommentByUniqueId(l.uniqueIdInThread);if(u!==void 0&&I&&u.reactionHandler)return u.reactionHandler(I,c(h))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class p{constructor(t,s,d,l,h,u,b){this._commentControllerHandle=s,this._id=d,this._uri=l,this._range=h,this._comments=u,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),_.$createCommentThread(s,this.handle,this._id,this._uri,y.Range.from(this._range),b),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(s,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(T){I.range=T},get comments(){return I.comments},set comments(T){I.comments=T},get collapsibleState(){return I.collapsibleState},set collapsibleState(T){I.collapsibleState=T},get canReply(){return I.canReply},set canReply(T){I.canReply=T},get contextValue(){return I.contextValue},set contextValue(T){I.contextValue=T},get label(){return I.label},set label(T){I.label=T},dispose:()=>{I.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),s={};t("range")&&(s.range=y.Range.from(this._range)),t("label")&&(s.label=this.label),t("contextValue")&&(s.contextValue=this.contextValue??null),t("comments")&&(s.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(s.collapseState=E(this._collapseState)),t("canReply")&&(s.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(t){for(let s of this._commentsMap){let d=s[0],l=s[1];if(t===l)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}p._handlePool=0,Ve([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,s,d,l){this._extension=t,this._handle=s,this._id=d,this._label=l,this._threads=new Map,_.$registerCommentController(this.handle,d,l);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(u){h.options=u},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(u){h.commentingRangeProvider=u},get reactionHandler(){return h.reactionHandler},set reactionHandler(u){h.reactionHandler=u},createCommentThread(u,b,I){return h.createCommentThread(u,b,I).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,_.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,s,d,l){if(typeof t=="string"){const h=new p(this.id,this.handle,t,s,d,l,this._extension.identifier);return this._threads.set(h.handle,h),h}else{const h=new p(this.id,this.handle,void 0,t,s,d,this._extension.identifier);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(t,s){const d=new p(this.id,this.handle,void 0,i.URI.revive(t),y.Range.to(s),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,s){let d=this._threads.get(t);d&&(d.range=y.Range.to(s))}$deleteCommentThread(t){let s=this._threads.get(t);s&&s.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(n,t,s){let d=s.get(t);d||(d=++n.commentHandle,s.set(t,d));const l=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:y.MarkdownString.from(t.body),userName:t.author.name,userIconPath:l,label:t.label,commentReactions:t.reactions?t.reactions.map(h=>g(h)):void 0}}function g(n){return{label:n.label,iconPath:n.iconPath?y.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function c(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?i.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function E(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=a}),define(ge[130],pe([0,1,2,5,7,4,14,11,17,8,9]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bi{constructor(w,f){this._logService=f,this._provider=new Map,this._proxy=w.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(w,f){const v=bi._handlePool++;this._provider.set(v,{provider:w,extensionId:f}),this._proxy.$registerDecorationProvider(v,f.value);const _=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(v,null);return}let p=(0,S.asArray)(A);if(p.length<=bi._maxEventSize){this._proxy.$onDidChange(v,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,p.length);const o=p.map(c=>({uri:c,rank:(0,y.count)(c.path,"/")})),r=(0,S.groupBy)(o,(c,E)=>c.rank-E.rank||(0,y.compare)(c.uri.path,E.uri.path));let g=[];e:for(let c of r){let E;for(let n of c){let t=(0,R.dirname)(n.uri.path);if(E!==t&&(E=t,g.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(v,g)});return new D.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(w,f,v){if(!this._provider.has(w))return Object.create(null);const _=Object.create(null),{provider:A,extensionId:p}=this._provider.get(w);return await Promise.all(f.map(async o=>{try{const{uri:r,id:g}=o,c=await Promise.resolve(A.provideFileDecoration(m.URI.revive(r),v));if(!c)return;try{D.FileDecoration.validate(c),_[g]=[c.propagate,c.tooltip,c.badge,c.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${p.value}': ${E}`)}}catch(r){this._logService.error(r)}})),_}};P._handlePool=0,P._maxEventSize=250,P=Ve([He(0,i.IExtHostRpcService),He(1,k.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[233],pe([0,1,162,116,2,5,7,16,3,11,24,44]),function(Y,e,m,L,D,C,i,k,S,y,R,P){"use strict";var a,w,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(p,o,r,g,c,E){this._name=p,this._owner=o,this._maxDiagnosticsPerFile=r,a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,ot(this,f,new R.ResourceMap(n=>g.getComparisonKey(n)),"f"),ot(this,a,c,"f"),ot(this,w,E,"f")}dispose(){this._isDisposed||(Oe(this,w,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,o){if(!p){this.clear();return}this._checkDisposed();let r=[];if(D.URI.isUri(p)){if(!o){this.delete(p);return}Oe(this,f,"f").set(p,o.slice()),r=[p]}else if(Array.isArray(p)){r=[];let c;p=[...p].sort(v._compareIndexedTuplesByUri);for(const E of p){const[n,t]=E;if((!c||n.toString()!==c.toString())&&(c&&Oe(this,f,"f").get(c).length===0&&Oe(this,f,"f").delete(c),c=n,r.push(n),Oe(this,f,"f").set(n,[])),t){const s=Oe(this,f,"f").get(n);s&&s.push(...t)}else{const s=Oe(this,f,"f").get(n);s&&(s.length=0)}}}if(Oe(this,w,"f").fire(r),!Oe(this,a,"f"))return;const g=[];for(let c of r){let E=[];const n=Oe(this,f,"f").get(c);if(n)if(n.length>this._maxDiagnosticsPerFile){E=[];const t=[i.DiagnosticSeverity.Error,i.DiagnosticSeverity.Warning,i.DiagnosticSeverity.Information,i.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let d of n)if(d.severity===t[s]&&E.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;E.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=n.map(t=>k.Diagnostic.from(t));g.push([c,E])}Oe(this,a,"f").$changeMany(this._owner,g)}delete(p){this._checkDisposed(),Oe(this,w,"f").fire([p]),Oe(this,f,"f").delete(p),Oe(this,a,"f")&&Oe(this,a,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Oe(this,w,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,a,"f")&&Oe(this,a,"f").$clear(this._owner)}forEach(p,o){this._checkDisposed();for(let r of Oe(this,f,"f").keys())p.apply(o,[r,this.get(r),this])}get(p){this._checkDisposed();const o=Oe(this,f,"f").get(p);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,o){return p[0].toString()<o[0].toString()?-1:p[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=v,a=new WeakMap,w=new WeakMap,f=new WeakMap;let _=class ri{constructor(p,o,r){this._logService=o,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const o=new R.ResourceMap;for(const r of p)o.set(r,r);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(p,o){const{_collections:r,_proxy:g,_onDidChangeDiagnostics:c,_logService:E,_fileSystemInfoService:n}=this,t=new class{$changeMany(l,h){g.$changeMany(l,h),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,l,h.length===0?"CLEARING":h)}$clear(l){g.$clear(l),E.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,l)}dispose(){g.dispose()}};let s;if(!o)o="_generated_diagnostic_collection_name_#"+ri._idPool++,s=o;else if(!r.has(o))s=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do s=o+ri._idPool++;while(r.has(s))}return new class extends v{constructor(){super(o,s,ri._maxDiagnosticsPerFile,n.extUri,t,c);r.set(s,this)}dispose(){super.dispose(),r.delete(s)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const o=new Map,r=[];for(const g of this._collections.values())g.forEach((c,E)=>{let n=o.get(c.toString());typeof n=="undefined"&&(n=r.length,o.set(c.toString(),n),r.push([c,[]])),r[n][1]=r[n][1].concat(...E)});return r}}_getDiagnostics(p){let o=[];for(let r of this._collections.values())r.has(p)&&(o=o.concat(r.get(p)));return o}$acceptMarkersChange(p){if(!this._mirrorCollection){const o="_generated_mirror",r=new v(o,o,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,r),this._mirrorCollection=r}for(const[o,r]of p)this._mirrorCollection.set(D.URI.revive(o),r.map(k.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=Ve([He(1,y.ILogService),He(2,P.IExtHostFileSystemInfo)],_),e.ExtHostDiagnostics=_}),define(ge[234],pe([0,1,2,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(i){this._proxy=i.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(i){return this._proxy.$showOpenDialog(i).then(k=>k?k.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(i){return this._proxy.$showSaveDialog(i).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(ge[235],pe([0,1,15,2,7,5,10,21,8]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(P,a,w){this._documentsAndEditors=a,this._logService=w,this._documentContentProviders=new Map,this._proxy=P.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,a){if(Object.keys(i.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const w=y._handlePool++;this._documentContentProviders.set(w,a),this._proxy.$registerTextContentProvider(w,P);let f;return typeof a.onDidChange=="function"&&(f=a.onDidChange(v=>{if(v.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(w,v).then(_=>{if(!_&&typeof _!="string")return;const A=this._documentsAndEditors.getDocument(v);if(!A)return;const p=(0,S.splitLines)(_);if(!A.equalLines(p))return this._proxy.$onVirtualDocumentChange(v,_)},m.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(P,a){const w=this._documentContentProviders.get(P);return w?Promise.resolve(w.provideTextDocumentContent(L.URI.revive(a),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=y,y._handlePool=0}),define(ge[236],pe([0,1,3,6,2,5,122,16,13,25,7]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(w,f){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!w)return;const f=this._documentsAndEditors.getDocument(w);if(f)return f}getDocument(w){const f=this.getDocumentData(w);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this._documentsAndEditors.getDocument(w);if(f)return Promise.resolve(f);let v=this._documentLoader.get(w.toString());return v||(v=this._proxy.$tryOpenDocument(w).then(_=>{this._documentLoader.delete(w.toString());const A=D.URI.revive(_);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(A))},_=>(this._documentLoader.delete(w.toString()),Promise.reject(_))),this._documentLoader.set(w.toString(),v)),v}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(f=>D.URI.revive(f))}$acceptModelModeChanged(w,f){const v=D.URI.revive(w),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(f),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(w){const f=D.URI.revive(w),v=this._documentsAndEditors.getDocument(f);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(w,f){const v=D.URI.revive(w),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(f),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,f,v){const _=D.URI.revive(w),A=this._documentsAndEditors.getDocument(_);if(!A)throw new Error("unknown document");A._acceptIsDirty(v),A.onEvents(f);let p;f.isUndoing?p=R.TextDocumentChangeReason.Undo:f.isRedoing&&(p=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:A.document,contentChanges:f.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:p}))}setWordDefinitionFor(w,f){(0,i.setWordDefinitionFor)(w,f)}}e.ExtHostDocuments=P}),define(ge[45],pe([0,1,56,3,6,2,4,5,122,14,129,16,11,24,10,76,140]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(r,g){this._extHostRpc=r,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const g=[],c=[],E=[];if(r.removedDocuments)for(const n of r.removedDocuments){const t=C.URI.revive(n),s=this._documents.get(t);s?.unref()&&(this._documents.delete(t),g.push(s.value))}if(r.addedDocuments)for(const n of r.addedDocuments){const t=C.URI.revive(n.uri);let s=this._documents.get(t);if(s&&t.scheme!==f.Schemas.vscodeNotebookCell&&t.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);s||(s=new A(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,s),c.push(s.value)),s.ref()}if(r.removedEditors)for(const n of r.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&E.push(t)}if(r.addedEditors)for(const n of r.addedEditors){const t=C.URI.revive(n.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const s=this._documents.get(t).value,d=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>s.document),n.selections.map(P.Selection.to),n.options,n.visibleRanges.map(l=>P.Range.to(l)),typeof n.editorPosition=="number"?P.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,d)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,D.dispose)(g),(0,D.dispose)(E),r.removedDocuments&&this._onDidRemoveDocuments.fire(g),r.addedDocuments&&this._onDidAddDocuments.fire(c),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return r?g:g?.value}allEditors(){return[...this._editors.values()]}};p=Ve([He(0,y.IExtHostRpcService),He(1,a.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,i.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[54],pe([0,1,16,5,2,3,4,14,18]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,i.createDecorator)("IExtHostEditorTabs");let y=class{constructor(P){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=P.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(P){let a=-1;this._tabs=P.map((f,v)=>(f.isActive&&(a=v),Object.freeze({label:f.label,viewColumn:m.ViewColumn.to(f.viewColumn),index:v,resource:D.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:_,viewId:A})=>({resource:D.URI.revive(_),viewId:A})),viewId:f.editorId,isActive:f.isActive,move:async(_,A)=>{this._proxy.$moveTab(f,_,m.ViewColumn.from(A)),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,S.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,v)=>f.viewColumn===v.viewColumn?f.index-v.index:f.viewColumn-v.viewColumn);const w=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==w&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};y=Ve([He(0,k.IExtHostRpcService)],y),e.ExtHostEditorTabs=y}),define(ge[237],pe([0,1,2,5,6,7,16,147,8,22,29]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const v=this._schemes.indexOf(f);v>=0&&(this._schemes.splice(v,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),v=[];let _,A,p=14,o=14;for(const r of f){let g=_?(0,S.commonPrefixLength)(_,r):0;for(g===0?A=1:A=o;g<r.length;g++)g+1===r.length?(p=o,o=9):o+=1,v.push([A,r.toUpperCase().charCodeAt(g),o]),v.push([A,r.toLowerCase().charCodeAt(g),o]),A=o;_=r,o=p}v.push([9,58,10]),v.push([10,47,12]),this._stateMachine=new k.StateMachine(v)}}provideDocumentLinks(f){this._initStateMachine();const v=[],_=k.LinkComputer.computeLinks({getLineContent(A){return f.lineAt(A-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const A of _){const p=i.DocumentLink.to(A);p.target&&v.push(p)}return v}}class a{constructor(f,v){this._extHostLanguageFeatures=v,this._linkProvider=new P,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,v,_,A={}){if(this._registeredSchemes.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(v),this._registeredSchemes.add(v),this._fsProvider.set(p,_);let o=2;A.isCaseSensitive&&(o+=1024),A.isReadonly&&(o+=2048),typeof _.copy=="function"&&(o+=8),typeof _.open=="function"&&typeof _.close=="function"&&typeof _.read=="function"&&typeof _.write=="function"&&((0,R.checkProposedApiEnabled)(f,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(p,v,o).catch(g=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${v}`),console.error(g)});const r=_.onDidChangeFile(g=>{const c=[];for(const E of g){let{uri:n,type:t}=E;if(n.scheme!==v)continue;let s;switch(t){case C.FileChangeType.Changed:s=0;break;case C.FileChangeType.Created:s=1;break;case C.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:n,type:s})}this._proxy.$onFileSystemChange(p,c)});return(0,D.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(v),this._registeredSchemes.delete(v),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(f){const{type:v,ctime:_,mtime:A,size:p,permissions:o}=f;return{type:v,ctime:_,mtime:A,size:p,permissions:o}}$stat(f,v){return Promise.resolve(this._getFsProvider(f).stat(m.URI.revive(v))).then(_=>a._asIStat(_))}$readdir(f,v){return Promise.resolve(this._getFsProvider(f).readDirectory(m.URI.revive(v)))}$readFile(f,v){return Promise.resolve(this._getFsProvider(f).readFile(m.URI.revive(v))).then(_=>y.VSBuffer.wrap(_))}$writeFile(f,v,_,A){return Promise.resolve(this._getFsProvider(f).writeFile(m.URI.revive(v),_.buffer,A))}$delete(f,v,_){return Promise.resolve(this._getFsProvider(f).delete(m.URI.revive(v),_))}$rename(f,v,_,A){return Promise.resolve(this._getFsProvider(f).rename(m.URI.revive(v),m.URI.revive(_),A))}$copy(f,v,_,A){const p=this._getFsProvider(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(m.URI.revive(v),m.URI.revive(_),A))}$mkdir(f,v){return Promise.resolve(this._getFsProvider(f).createDirectory(m.URI.revive(v)))}$watch(f,v,_,A){const p=this._getFsProvider(f).watch(m.URI.revive(_),A);this._watches.set(v,p)}$unwatch(f,v){const _=this._watches.get(v);_&&(_.dispose(),this._watches.delete(v))}$open(f,v,_){const A=this._getFsProvider(f);if(!A.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(A.open(m.URI.revive(v),_))}$close(f,v){const _=this._getFsProvider(f);if(!_.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(_.close(v))}$read(f,v,_,A){const p=this._getFsProvider(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.VSBuffer.alloc(A);return Promise.resolve(p.read(v,_,o.buffer,0,A)).then(r=>o.slice(0,r))}$write(f,v,_,A){const p=this._getFsProvider(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(v,_,A.buffer,0,A.byteLength))}_getFsProvider(f){const v=this._fsProvider.get(f);if(!v){const _=new Error;throw _.name="ENOPRO",_.message="no provider",_}return v}}e.ExtHostFileSystem=a}),define(ge[66],pe([0,1,5,42,7,22,4,14,44,6]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class $t{constructor(a,w){this._fileSystemProvider=new Map,this._proxy=a.getProxy(m.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(v){try{const _=f._fileSystemProvider.get(v.scheme);if(!_)return await f._proxy.$stat(v);await f._proxy.$ensureActivation(v.scheme);const A=await _.stat(v);return{type:A.type,ctime:A.ctime,mtime:A.mtime,size:A.size,permissions:A.permissions}}catch(_){$t._handleError(_)}},async readDirectory(v){try{const _=f._fileSystemProvider.get(v.scheme);return _?(await f._proxy.$ensureActivation(v.scheme),(await _.readDirectory(v)).slice()):await f._proxy.$readdir(v)}catch(_){return $t._handleError(_)}},async createDirectory(v){try{return await f._proxy.$mkdir(v)}catch(_){return $t._handleError(_)}},async readFile(v){try{const _=f._fileSystemProvider.get(v.scheme);return _?(await f._proxy.$ensureActivation(v.scheme),(await _.readFile(v)).slice()):(await f._proxy.$readFile(v)).buffer}catch(_){return $t._handleError(_)}},async writeFile(v,_){try{return await f._proxy.$writeFile(v,C.VSBuffer.wrap(_))}catch(A){return $t._handleError(A)}},async delete(v,_){try{const A=f._fileSystemProvider.get(v.scheme);return A?(await f._proxy.$ensureActivation(v.scheme),await A.delete(v,{recursive:!1,..._})):await f._proxy.$delete(v,{recursive:!1,useTrash:!1,..._})}catch(A){return $t._handleError(A)}},async rename(v,_,A){try{return await f._proxy.$rename(v,_,{overwrite:!1,...A})}catch(p){return $t._handleError(p)}},async copy(v,_,A){try{return await f._proxy.$copy(v,_,{overwrite:!1,...A})}catch(p){return $t._handleError(p)}},isWritableFileSystem(v){const _=w.getCapabilities(v);if(typeof _=="number")return!(_&2048)}})}static _handleError(a){if(a instanceof D.FileSystemError)throw a;if(!(a instanceof Error))throw new D.FileSystemError(String(a));if(a.name==="ENOPRO")throw D.FileSystemError.Unavailable(a.message);switch(a.name){case L.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(a.message);case L.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(a.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(a.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(a.message);case L.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(a.message);case L.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(a.message);default:throw new D.FileSystemError(a.message,a.name)}}addFileSystemProvider(a,w){return this._fileSystemProvider.set(a,w),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(a))}};R=Ve([He(0,k.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,i.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,2,38]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(i,k,S,y){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=y;const R=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",P=>!0,P=>P),new L.ApiCommandArgument("resource","Interactive resource Uri",P=>!0,P=>P),new L.ApiCommandArgument("controllerId","Notebook controller Id",P=>!0,P=>P),new L.ApiCommandArgument("title","Interactive editor title",P=>!0,P=>P)],new L.ApiCommandResult("Notebook and input URI",P=>{if(P.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(P.notebookEditorId);return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(i,k,S,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:i,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(i,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[i]})}}e.ExtHostInteractive=D}),define(ge[239],pe([0,1,6,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(i){this._handlePool=0,this._proxy=i.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(i){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,i),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(ge[240],pe([0,1,2,25,16,7,5,8,41,17,13,144,6,110,75,87,46,15,3]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentSymbols(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideDocumentSymbols(re,Z);if(!(0,y.isFalsyOrEmpty)(ue))return ue[0]instanceof C.DocumentSymbol?ue.map(D.DocumentSymbol.from):o._asDocumentSymbolTree(ue)}static _asDocumentSymbolTree(Q){Q=Q.slice(0).sort((ue,J)=>{let ie=ue.location.range.start.compareTo(J.location.range.start);return ie===0&&(ie=J.location.range.end.compareTo(ue.location.range.end)),ie});const Z=[],re=[];for(const ue of Q){const J={name:ue.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ue.kind),tags:ue.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:ue.containerName,range:D.Range.from(ue.location.range),selectionRange:D.Range.from(ue.location.range),children:[]};for(;;){if(re.length===0){re.push(J),Z.push(J);break}const ie=re[re.length-1];if(S.Range.containsRange(ie.range,J.range)&&!S.Range.equalsRange(ie.range,J.range)){ie.children&&ie.children.push(J),re.push(J);break}re.pop()}}return Z}}class r{constructor(Q,Z,re){this._documents=Q,this._commands=Z,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideCodeLenses(re,Z);if(!ue||Z.isCancellationRequested)return;const J=this._cache.add(ue),ie=new a.DisposableStore;this._disposables.set(J,ie);const we={cacheId:J,lenses:[]};for(let Me=0;Me<ue.length;Me++)we.lenses.push({cacheId:[J,Me],range:D.Range.from(ue[Me].range),command:this._commands.toInternal(ue[Me].command,ie)});return we}async resolveCodeLens(Q,Z){const re=Q.cacheId&&this._cache.get(...Q.cacheId);if(!re)return;let ue;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ue=re:ue=await this._provider.resolveCodeLens(re,Z),ue||(ue=re),Z.isCancellationRequested)return;const J=Q.cacheId&&this._disposables.get(Q.cacheId[0]);if(!!J)return Q.command=this._commands.toInternal(ue.command??r._badCmd,J),Q}releaseCodeLenses(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(ze){return Array.isArray(ze)?ze.map(D.DefinitionLink.from):ze?[D.DefinitionLink.from(ze)]:[]}class c{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDefinition(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideDefinition(ue,J,re);return g(ie)}}class E{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDeclaration(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideDeclaration(ue,J,re);return g(ie)}}class n{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideImplementation(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideImplementation(ue,J,re);return g(ie)}}class t{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideTypeDefinition(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideTypeDefinition(ue,J,re);return g(ie)}}class s{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideHover(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideHover(ue,J,re);if(!(!ie||(0,y.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=ue.getWordRangeAtPosition(J)),ie.range||(ie.range=new C.Range(J,J)),D.Hover.from(ie)}}class d{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideEvaluatableExpression(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideEvaluatableExpression(ue,J,re);if(ie)return D.EvaluatableExpression.from(ie)}}class l{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideInlineValues(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=await this._provider.provideInlineValues(J,D.Range.to(Z),D.InlineValueContext.to(re),ue);if(Array.isArray(ie))return ie.map(we=>D.InlineValue.from(we))}}class h{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentHighlights(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideDocumentHighlights(ue,J,re);if(Array.isArray(ie))return ie.map(D.DocumentHighlight.from)}}class u{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideLinkedEditingRanges(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.provideLinkedEditingRanges(ue,J,re);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,y.coalesce)(ie.ranges.map(D.Range.from)),wordPattern:ie.wordPattern}}}class b{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideReferences(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=await this._provider.provideReferences(J,ie,re,ue);if(Array.isArray(we))return we.map(D.location.from)}}class I{constructor(Q,Z,re,ue,J,ie,we){this._documents=Q,this._commands=Z,this._diagnostics=re,this._provider=ue,this._logService=J,this._extension=ie,this._apiDeprecation=we,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=P.Selection.isISelection(Z)?D.Selection.to(Z):D.Range.to(Z),we=[];for(const ut of this._diagnostics.getDiagnostics(Q))if(ie.intersection(ut.range)&&we.push(ut)>I._maxCodeActionsPerFile)break;const Me={diagnostics:we,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:D.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(J,ie,Me,ue);if(!(0,y.isNonEmptyArray)(je)||ue.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new a.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ut=0;ut<je.length;ut++){const it=je[ut];!it||(I._isCommand(it)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:it.title,command:this._commands.toInternal(it,Ze)})):(Me.only&&(it.kind?Me.only.contains(it.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ut],title:it.title,command:it.command&&this._commands.toInternal(it.command,Ze),diagnostics:it.diagnostics&&it.diagnostics.map(D.Diagnostic.from),edit:it.edit&&D.WorkspaceEdit.from(it.edit),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,disabled:it.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(Q,Z){const[re,ue]=Q,J=this._cache.get(re,ue);if(!J||I._isCommand(J)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(J,Z)??J;return ie?.edit?D.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}static _isCommand(Q){return typeof Q.command=="string"&&typeof Q.title=="string"}}I._maxCodeActionsPerFile=1e3;class T{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentFormattingEdits(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideDocumentFormattingEdits(ue,Z,re);if(Array.isArray(J))return J.map(D.TextEdit.from)}}class x{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentRangeFormattingEdits(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Range.to(Z),we=await this._provider.provideDocumentRangeFormattingEdits(J,ie,re,ue);if(Array.isArray(we))return we.map(D.TextEdit.from)}}class O{constructor(Q,Z){this._documents=Q,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(Q,Z,re,ue,J){const ie=this._documents.getDocument(Q),we=D.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(ie,we,re,ue,J);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class F{constructor(Q,Z){this._provider=Q,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(Q,Z){const re=i.IdObject.mixin({symbols:[]}),ue=await this._provider.provideWorkspaceSymbols(Q,Z);if((0,y.isNonEmptyArray)(ue))for(const J of ue){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ie=i.IdObject.mixin(D.WorkspaceSymbol.from(J));this._symbolCache.set(ie._id,J),re.symbols.push(ie)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(Q,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return Q;const re=this._symbolCache.get(Q._id);if(re){const ue=await this._provider.resolveWorkspaceSymbol(re,Z);return ue&&(0,L.mixin)(Q,D.WorkspaceSymbol.from(ue),!0)}}releaseWorkspaceSymbols(Q){const Z=this._resultCache.get(Q);if(Z){for(let[re,ue]=Z;re<=ue;re++)this._symbolCache.delete(re);this._resultCache.delete(Q)}}}class W{constructor(Q,Z,re){this._documents=Q,this._provider=Z,this._logService=re}static supportsResolving(Q){return typeof Q.prepareRename=="function"}async provideRenameEdits(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z);try{const we=await this._provider.provideRenameEdits(J,ie,re,ue);return we?D.WorkspaceEdit.from(we):void 0}catch(we){const Me=W._asMessage(we);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(Q,Z,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ue=this._documents.getDocument(Q),J=D.Position.to(Z);try{const ie=await this._provider.prepareRename(ue,J,re);let we,Me;if(C.Range.isRange(ie)?(we=ie,Me=ue.getText(ie)):(0,R.isObject)(ie)&&(we=ie.range,Me=ie.placeholder),!we||!Me)return;if(we.start.line>J.line||we.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(we),text:Me}}catch(ie){const we=W._asMessage(ie);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(Q){return typeof Q=="string"?Q:Q instanceof Error&&typeof Q.message=="string"?Q.message:void 0}}class M{constructor(Q,Z){this.resultId=Q,this.tokens=Z}}class B{constructor(Q,Z){this._documents=Q,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(Q,Z,re){const ue=this._documents.getDocument(Q),J=Z!==0?this._previousResults.get(Z):null;let ie=typeof J?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ue,J.resultId,re):await this._provider.provideDocumentSemanticTokens(ue,re);return J&&this._previousResults.delete(Z),ie?(ie=B._fixProvidedSemanticTokens(ie),this._send(B._convertToEdits(J,ie),ie)):null}async releaseDocumentSemanticColoring(Q){this._previousResults.delete(Q)}static _fixProvidedSemanticTokens(Q){return B._isSemanticTokens(Q)?B._isCorrectSemanticTokens(Q)?Q:new C.SemanticTokens(new Uint32Array(Q.data),Q.resultId):B._isSemanticTokensEdits(Q)?B._isCorrectSemanticTokensEdits(Q)?Q:new C.SemanticTokensEdits(Q.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),Q.resultId):Q}static _isSemanticTokens(Q){return Q&&!!Q.data}static _isCorrectSemanticTokens(Q){return Q.data instanceof Uint32Array}static _isSemanticTokensEdits(Q){return Q&&Array.isArray(Q.edits)}static _isCorrectSemanticTokensEdits(Q){for(const Z of Q.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(Q,Z){if(!B._isSemanticTokens(Z)||!Q||!Q.tokens)return Z;const re=Q.tokens,ue=re.length,J=Z.data,ie=J.length;let we=0;const Me=Math.min(ue,ie);for(;we<Me&&re[we]===J[we];)we++;if(we===ue&&we===ie)return new C.SemanticTokensEdits([],Z.resultId);let je=0;const Ke=Me-we;for(;je<Ke&&re[ue-je-1]===J[ie-je-1];)je++;return new C.SemanticTokensEdits([{start:we,deleteCount:ue-we-je,data:J.subarray(we,ie-je)}],Z.resultId)}_send(Q,Z){if(B._isSemanticTokens(Q)){const re=this._nextResultId++;return this._previousResults.set(re,new M(Q.resultId,Q.data)),(0,w.encodeSemanticTokensDto)({id:re,type:"full",data:Q.data})}if(B._isSemanticTokensEdits(Q)){const re=this._nextResultId++;return B._isSemanticTokens(Z)?this._previousResults.set(re,new M(Z.resultId,Z.data)):this._previousResults.set(re,new M(Q.resultId)),(0,w.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(Q.edits||[]).map(ue=>({start:ue.start,deleteCount:ue.deleteCount,data:ue.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class U{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideDocumentRangeSemanticTokens(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideDocumentRangeSemanticTokens(ue,D.Range.to(Z),re);return J?this._send(J):null}_send(Q){return(0,w.encodeSemanticTokensDto)({id:0,type:"full",data:Q.data})}}e.DocumentRangeSemanticTokensAdapter=U;class z{constructor(Q,Z,re,ue,J){this._documents=Q,this._commands=Z,this._provider=re,this._apiDeprecation=ue,this._extension=J,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(Q){return typeof Q.resolveCompletionItem=="function"}async provideCompletionItems(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=J.getWordRangeAtPosition(ie)||new C.Range(ie,ie),Me=we.with({end:ie}),je=new _.StopWatch(!0),Ke=await this._provider.provideCompletionItems(J,ie,ue,D.CompletionContext.to(re));if(!Ke||ue.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,rt=z.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ut=new a.DisposableStore;this._disposables.set(rt,ut);const it=[],st={x:rt,b:it,a:{replace:D.Range.from(we),insert:D.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let Ae=0;Ae<Ze.items.length;Ae++){const wt=Ze.items[Ae],ee=this._convertCompletionItem(wt,[rt,Ae],Me,we);it.push(ee)}return st}async resolveCompletionItem(Q,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...Q);if(!re)return;const ue=await this._provider.resolveCompletionItem(re,Z);if(!!ue)return this._convertCompletionItem(ue,Q)}releaseCompletionItems(Q){this._disposables.get(Q)?.dispose(),this._disposables.delete(Q),this._cache.delete(Q)}_convertCompletionItem(Q,Z,re,ue){const J=this._disposables.get(Z[0]);if(!J)throw Error("DisposableStore is missing...");const ie={x:Z,a:Q.label,b:Q.kind!==void 0?D.CompletionItemKind.from(Q.kind):void 0,n:Q.tags&&Q.tags.map(D.CompletionItemTag.from),c:Q.detail,d:typeof Q.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(Q.documentation),e:Q.sortText!==Q.label?Q.sortText:void 0,f:Q.filterText!==Q.label?Q.filterText:void 0,g:Q.preselect||void 0,i:Q.keepWhitespace?1:0,k:Q.commitCharacters,l:Q.additionalTextEdits&&Q.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(Q.command,J)};Q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=Q.textEdit.newText):typeof Q.insertText=="string"?ie.h=Q.insertText:Q.insertText instanceof C.SnippetString&&(ie.h=Q.insertText.value,ie.i|=4);let we;return Q.textEdit?we=Q.textEdit.range:Q.range&&(we=Q.range),C.Range.isRange(we)?ie.j=D.Range.from(we):we&&(!re?.isEqual(we.inserting)||!ue?.isEqual(we.replacing))&&(ie.j={insert:D.Range.from(we.inserting),replace:D.Range.from(we.replacing)}),ie}}class K{constructor(Q,Z,re){this._documents=Q,this._provider=Z,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=await this._provider.provideInlineCompletionItems(J,ie,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:D.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:D.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},ue);if(!we||ue.isCancellationRequested)return;const Me=(0,R.isArray)(we)?{items:we}:we,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ut;return Ze.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),ut=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?D.Range.from(Ze.range):void 0,command:ut,idx:rt}})}}disposeCompletions(Q){this._cache.delete(Q);const Z=this._disposables.get(Q);Z&&Z.clear(),this._disposables.delete(Q)}handleDidShowCompletionItem(Q,Z){const re=this._cache.get(Q,Z);re&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new p.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(Q){let Z=N.map.get(Q);return Z||(Z=new N,N.map.set(Q,Z)),Z}fireOnDidShowCompletionItem(Q){this._onDidShowCompletionItemEmitter.fire(Q)}}e.InlineCompletionController=N,N.map=new WeakMap;class j{constructor(Q,Z){this._documents=Q,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(Q,Z,re,ue){const J=this._documents.getDocument(Q),ie=D.Position.to(Z),we=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(J,ie,ue,we);if(Me){const je=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}reviveContext(Q){let Z;if(Q.activeSignatureHelp){const re=D.SignatureHelp.to(Q.activeSignatureHelp),ue=this._cache.get(Q.activeSignatureHelp.id,0);ue?(Z=ue,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...Q,activeSignatureHelp:Z}}releaseSignatureHelp(Q){this._cache.delete(Q)}}class H{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideInlayHints(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideInlayHints(ue,D.Range.to(Z),re);return J?{hints:J.map(D.InlayHint.from)}:void 0}}class V{constructor(Q,Z){this._documents=Q,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideDocumentLinks(re,Z);if(!(!Array.isArray(ue)||ue.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ue.filter(V._validateLink).map(D.DocumentLink.from)};{const J=this._cache.add(ue),ie={links:[],id:J};for(let we=0;we<ue.length;we++){if(!V._validateLink(ue[we]))continue;const Me=D.DocumentLink.from(ue[we]);Me.cacheId=[J,we],ie.links.push(Me)}return ie}}}static _validateLink(Q){return Q.target&&Q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(Q,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...Q);if(!re)return;const ue=await this._provider.resolveDocumentLink(re,Z);if(!(!ue||!V._validateLink(ue)))return D.DocumentLink.from(ue)}releaseLinks(Q){this._cache.delete(Q)}}class q{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideColors(Q,Z){const re=this._documents.getDocument(Q),ue=await this._provider.provideDocumentColors(re,Z);return Array.isArray(ue)?ue.map(ie=>({color:D.Color.from(ie.color),range:D.Range.from(ie.range)})):[]}async provideColorPresentations(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Range.to(Z.range),ie=D.Color.to(Z.color),we=await this._provider.provideColorPresentations(ie,{document:ue,range:J},re);if(!!Array.isArray(we))return we.map(D.ColorPresentation.from)}}class te{constructor(Q,Z){this._documents=Q,this._provider=Z}async provideFoldingRanges(Q,Z,re){const ue=this._documents.getDocument(Q),J=await this._provider.provideFoldingRanges(ue,Z,re);if(!!Array.isArray(J))return J.map(D.FoldingRange.from)}}class fe{constructor(Q,Z,re){this._documents=Q,this._provider=Z,this._logService=re}async provideSelectionRanges(Q,Z,re){const ue=this._documents.getDocument(Q),J=Z.map(D.Position.to),ie=await this._provider.provideSelectionRanges(ue,J,re);if(!(0,y.isNonEmptyArray)(ie))return[];if(ie.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let Me=0;Me<J.length;Me++){const je=[];we.push(je);let Ke=J[Me],Ze=ie[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return we}}class Ce{constructor(Q,Z){this._documents=Q,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.prepareCallHierarchy(ue,J,re);if(!ie)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(ie)?ie.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,ie)]}async provideCallsTo(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(ue,re);if(!!J)return J.map(ie=>({from:this._cacheAndConvertItem(Q,ie.from),fromRanges:ie.fromRanges.map(we=>D.Range.from(we))}))}async provideCallsFrom(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(ue,re);if(!!J)return J.map(ie=>({to:this._cacheAndConvertItem(Q,ie.to),fromRanges:ie.fromRanges.map(we=>D.Range.from(we))}))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,Z){const re=this._cache.get(Q),ue=D.CallHierarchyItem.from(Z,Q,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(Q,Z){return this._cache.get(Q)?.get(Z)}}class ke{constructor(Q,Z){this._documents=Q,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(Q,Z,re){const ue=this._documents.getDocument(Q),J=D.Position.to(Z),ie=await this._provider.prepareTypeHierarchy(ue,J,re);if(!ie)return;const we=this._idPool.nextId();return this._cache.set(we,new Map),Array.isArray(ie)?ie.map(Me=>this._cacheAndConvertItem(we,Me)):[this._cacheAndConvertItem(we,ie)]}async provideSupertypes(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySupertypes(ue,re);if(!!J)return J.map(ie=>this._cacheAndConvertItem(Q,ie))}async provideSubtypes(Q,Z,re){const ue=this._itemFromCache(Q,Z);if(!ue)throw new Error("missing type hierarchy item");const J=await this._provider.provideTypeHierarchySubtypes(ue,re);if(!!J)return J.map(ie=>this._cacheAndConvertItem(Q,ie))}releaseSession(Q){this._cache.delete(Q)}_cacheAndConvertItem(Q,Z){const re=this._cache.get(Q),ue=D.TypeHierarchyItem.from(Z,Q,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(Q,Z){return this._cache.get(Q)?.get(Z)}}class Ue{constructor(Q,Z){this.adapter=Q,this.extension=Z}}class xe{constructor(Q,Z,re,ue,J,ie,we){this._adapter=new Map,this._uriTransformer=Z,this._proxy=Q.getProxy(i.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ue,this._diagnostics=J,this._logService=ie,this._apiDeprecation=we}_transformDocumentSelector(Q){return D.DocumentSelector.from(Q,this._uriTransformer)}_createDisposable(Q){return new C.Disposable(()=>{this._adapter.delete(Q),this._proxy.$unregister(Q)})}_nextHandle(){return xe._handlePool++}_withAdapter(Q,Z,re,ue,J=!1){const ie=this._adapter.get(Q);if(!ie)return Promise.resolve(ue);if(ie.adapter instanceof Z){let we;ie.extension&&(we=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=re(ie.adapter,ie.extension),je=ie.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-we}ms`),Ke=>{J&&Ke instanceof A.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(Q,Z){const re=this._nextHandle();return this._adapter.set(re,new Ue(Q,Z)),re}static _extLabel(Q){return Q.displayName||Q.name}registerDocumentSymbolProvider(Q,Z,re,ue){const J=this._addNewAdapter(new o(this._documents,re),Q),ie=ue&&ue.label||xe._extLabel(Q);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),ie),this._createDisposable(J)}$provideDocumentSymbols(Q,Z,re){return this._withAdapter(Q,o,ue=>ue.provideDocumentSymbols(m.URI.revive(Z),re),void 0)}registerCodeLensProvider(Q,Z,re){const ue=this._nextHandle(),J=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ue(new r(this._documents,this._commands.converter,re),Q)),this._proxy.$registerCodeLensSupport(ue,this._transformDocumentSelector(Z),J);let ie=this._createDisposable(ue);if(J!==void 0){const we=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(J));ie=C.Disposable.from(ie,we)}return ie}$provideCodeLenses(Q,Z,re){return this._withAdapter(Q,r,ue=>ue.provideCodeLenses(m.URI.revive(Z),re),void 0)}$resolveCodeLens(Q,Z,re){return this._withAdapter(Q,r,ue=>ue.resolveCodeLens(Z,re),void 0)}$releaseCodeLenses(Q,Z){this._withAdapter(Q,r,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(Q,Z,re){const ue=this._addNewAdapter(new c(this._documents,re),Q);return this._proxy.$registerDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDefinition(Q,Z,re,ue){return this._withAdapter(Q,c,J=>J.provideDefinition(m.URI.revive(Z),re,ue),[])}registerDeclarationProvider(Q,Z,re){const ue=this._addNewAdapter(new E(this._documents,re),Q);return this._proxy.$registerDeclarationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDeclaration(Q,Z,re,ue){return this._withAdapter(Q,E,J=>J.provideDeclaration(m.URI.revive(Z),re,ue),[])}registerImplementationProvider(Q,Z,re){const ue=this._addNewAdapter(new n(this._documents,re),Q);return this._proxy.$registerImplementationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideImplementation(Q,Z,re,ue){return this._withAdapter(Q,n,J=>J.provideImplementation(m.URI.revive(Z),re,ue),[])}registerTypeDefinitionProvider(Q,Z,re){const ue=this._addNewAdapter(new t(this._documents,re),Q);return this._proxy.$registerTypeDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideTypeDefinition(Q,Z,re,ue){return this._withAdapter(Q,t,J=>J.provideTypeDefinition(m.URI.revive(Z),re,ue),[])}registerHoverProvider(Q,Z,re,ue){const J=this._addNewAdapter(new s(this._documents,re),Q);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(Q,Z,re,ue){return this._withAdapter(Q,s,J=>J.provideHover(m.URI.revive(Z),re,ue),void 0)}registerEvaluatableExpressionProvider(Q,Z,re,ue){const J=this._addNewAdapter(new d(this._documents,re),Q);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(Q,Z,re,ue){return this._withAdapter(Q,d,J=>J.provideEvaluatableExpression(m.URI.revive(Z),re,ue),void 0)}registerInlineValuesProvider(Q,Z,re,ue){const J=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new l(this._documents,re),Q);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(Z),J);let we=this._createDisposable(ie);if(J!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(J));we=C.Disposable.from(we,Me)}return we}$provideInlineValues(Q,Z,re,ue,J){return this._withAdapter(Q,l,ie=>ie.provideInlineValues(m.URI.revive(Z),re,ue,J),void 0)}registerDocumentHighlightProvider(Q,Z,re){const ue=this._addNewAdapter(new h(this._documents,re),Q);return this._proxy.$registerDocumentHighlightProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentHighlights(Q,Z,re,ue){return this._withAdapter(Q,h,J=>J.provideDocumentHighlights(m.URI.revive(Z),re,ue),void 0)}registerLinkedEditingRangeProvider(Q,Z,re){const ue=this._addNewAdapter(new u(this._documents,re),Q);return this._proxy.$registerLinkedEditingRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideLinkedEditingRanges(Q,Z,re,ue){return this._withAdapter(Q,u,async J=>{const ie=await J.provideLinkedEditingRanges(m.URI.revive(Z),re,ue);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?xe._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(Q,Z,re){const ue=this._addNewAdapter(new b(this._documents,re),Q);return this._proxy.$registerReferenceSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideReferences(Q,Z,re,ue,J){return this._withAdapter(Q,b,ie=>ie.provideReferences(m.URI.revive(Z),re,ue,J),void 0)}registerCodeActionProvider(Q,Z,re,ue){const J=new a.DisposableStore,ie=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,re,this._logService,Q,this._apiDeprecation),Q);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(Z),{providedKinds:ue?.providedCodeActionKinds?.map(we=>we.value),documentation:ue?.documentation?.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,J)}))},xe._extLabel(Q),Boolean(re.resolveCodeAction)),J.add(this._createDisposable(ie)),J}$provideCodeActions(Q,Z,re,ue,J){return this._withAdapter(Q,I,ie=>ie.provideCodeActions(m.URI.revive(Z),re,ue,J),void 0)}$resolveCodeAction(Q,Z,re){return this._withAdapter(Q,I,ue=>ue.resolveCodeAction(Z,re),void 0)}$releaseCodeActions(Q,Z){this._withAdapter(Q,I,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(Q,Z,re){const ue=this._addNewAdapter(new T(this._documents,re),Q);return this._proxy.$registerDocumentFormattingSupport(ue,this._transformDocumentSelector(Z),Q.identifier,Q.displayName||Q.name),this._createDisposable(ue)}$provideDocumentFormattingEdits(Q,Z,re,ue){return this._withAdapter(Q,T,J=>J.provideDocumentFormattingEdits(m.URI.revive(Z),re,ue),void 0)}registerDocumentRangeFormattingEditProvider(Q,Z,re){const ue=this._addNewAdapter(new x(this._documents,re),Q);return this._proxy.$registerRangeFormattingSupport(ue,this._transformDocumentSelector(Z),Q.identifier,Q.displayName||Q.name),this._createDisposable(ue)}$provideDocumentRangeFormattingEdits(Q,Z,re,ue,J){return this._withAdapter(Q,x,ie=>ie.provideDocumentRangeFormattingEdits(m.URI.revive(Z),re,ue,J),void 0)}registerOnTypeFormattingEditProvider(Q,Z,re,ue){const J=this._addNewAdapter(new O(this._documents,re),Q);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),ue,Q.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(Q,Z,re,ue,J,ie){return this._withAdapter(Q,O,we=>we.provideOnTypeFormattingEdits(m.URI.revive(Z),re,ue,J,ie),void 0)}registerWorkspaceSymbolProvider(Q,Z){const re=this._addNewAdapter(new F(Z,this._logService),Q);return this._proxy.$registerNavigateTypeSupport(re,typeof Z.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(Q,Z,re){return this._withAdapter(Q,F,ue=>ue.provideWorkspaceSymbols(Z,re),{symbols:[]})}$resolveWorkspaceSymbol(Q,Z,re){return this._withAdapter(Q,F,ue=>ue.resolveWorkspaceSymbol(Z,re),void 0)}$releaseWorkspaceSymbols(Q,Z){this._withAdapter(Q,F,re=>re.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(Q,Z,re){const ue=this._addNewAdapter(new W(this._documents,re,this._logService),Q);return this._proxy.$registerRenameSupport(ue,this._transformDocumentSelector(Z),W.supportsResolving(re)),this._createDisposable(ue)}$provideRenameEdits(Q,Z,re,ue,J){return this._withAdapter(Q,W,ie=>ie.provideRenameEdits(m.URI.revive(Z),re,ue,J),void 0)}$resolveRenameLocation(Q,Z,re,ue){return this._withAdapter(Q,W,J=>J.resolveRenameLocation(m.URI.revive(Z),re,ue),void 0)}registerDocumentSemanticTokensProvider(Q,Z,re,ue){const J=this._nextHandle(),ie=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new Ue(new B(this._documents,re),Q)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),ue,ie);let we=this._createDisposable(J);if(ie){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(ie));we=C.Disposable.from(we,Me)}return we}$provideDocumentSemanticTokens(Q,Z,re,ue){return this._withAdapter(Q,B,J=>J.provideDocumentSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}$releaseDocumentSemanticTokens(Q,Z){this._withAdapter(Q,B,re=>re.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(Q,Z,re,ue){const J=this._addNewAdapter(new U(this._documents,re),Q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),ue),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(Q,Z,re,ue){return this._withAdapter(Q,U,J=>J.provideDocumentRangeSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}registerCompletionItemProvider(Q,Z,re,ue){const J=this._addNewAdapter(new z(this._documents,this._commands.converter,re,this._apiDeprecation,Q),Q);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),ue,z.supportsResolving(re),`${Q.identifier.value}(${ue.join("")})`),this._createDisposable(J)}$provideCompletionItems(Q,Z,re,ue,J){return this._withAdapter(Q,z,ie=>ie.provideCompletionItems(m.URI.revive(Z),re,ue,J),void 0)}$resolveCompletionItem(Q,Z,re){return this._withAdapter(Q,z,ue=>ue.resolveCompletionItem(Z,re),void 0)}$releaseCompletionItems(Q,Z){this._withAdapter(Q,z,re=>re.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(Q,Z,re){const ue=this._addNewAdapter(new K(this._documents,re,this._commands.converter),Q);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideInlineCompletions(Q,Z,re,ue,J){return this._withAdapter(Q,K,ie=>ie.provideInlineCompletions(m.URI.revive(Z),re,ue,J),void 0)}$handleInlineCompletionDidShow(Q,Z,re){this._withAdapter(Q,K,async ue=>{ue.handleDidShowCompletionItem(Z,re)},void 0)}$freeInlineCompletionsList(Q,Z){this._withAdapter(Q,K,async re=>{re.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(Q,Z,re,ue){const J=Array.isArray(ue)?{triggerCharacters:ue,retriggerCharacters:[]}:ue,ie=this._addNewAdapter(new j(this._documents,re),Q);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(Z),J),this._createDisposable(ie)}$provideSignatureHelp(Q,Z,re,ue,J){return this._withAdapter(Q,j,ie=>ie.provideSignatureHelp(m.URI.revive(Z),re,ue,J),void 0)}$releaseSignatureHelp(Q,Z){this._withAdapter(Q,j,re=>re.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(Q,Z,re){const ue=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new H(this._documents,re),Q);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),ue);let ie=this._createDisposable(J);if(ue!==void 0){const we=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ue));ie=C.Disposable.from(ie,we)}return ie}$provideInlayHints(Q,Z,re,ue){return this._withAdapter(Q,H,J=>J.provideInlayHints(m.URI.revive(Z),re,ue),void 0)}registerDocumentLinkProvider(Q,Z,re){const ue=this._addNewAdapter(new V(this._documents,re),Q);return this._proxy.$registerDocumentLinkProvider(ue,this._transformDocumentSelector(Z),typeof re.resolveDocumentLink=="function"),this._createDisposable(ue)}$provideDocumentLinks(Q,Z,re){return this._withAdapter(Q,V,ue=>ue.provideLinks(m.URI.revive(Z),re),void 0)}$resolveDocumentLink(Q,Z,re){return this._withAdapter(Q,V,ue=>ue.resolveLink(Z,re),void 0)}$releaseDocumentLinks(Q,Z){this._withAdapter(Q,V,re=>re.releaseLinks(Z),void 0)}registerColorProvider(Q,Z,re){const ue=this._addNewAdapter(new q(this._documents,re),Q);return this._proxy.$registerDocumentColorProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentColors(Q,Z,re){return this._withAdapter(Q,q,ue=>ue.provideColors(m.URI.revive(Z),re),[])}$provideColorPresentations(Q,Z,re,ue){return this._withAdapter(Q,q,J=>J.provideColorPresentations(m.URI.revive(Z),re,ue),void 0)}registerFoldingRangeProvider(Q,Z,re){const ue=this._nextHandle(),J=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ue(new te(this._documents,re),Q)),this._proxy.$registerFoldingRangeProvider(ue,this._transformDocumentSelector(Z),J);let ie=this._createDisposable(ue);if(J!==void 0){const we=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ie=C.Disposable.from(ie,we)}return ie}$provideFoldingRanges(Q,Z,re,ue){return this._withAdapter(Q,te,J=>J.provideFoldingRanges(m.URI.revive(Z),re,ue),void 0)}registerSelectionRangeProvider(Q,Z,re){const ue=this._addNewAdapter(new fe(this._documents,re,this._logService),Q);return this._proxy.$registerSelectionRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideSelectionRanges(Q,Z,re,ue){return this._withAdapter(Q,fe,J=>J.provideSelectionRanges(m.URI.revive(Z),re,ue),[])}registerCallHierarchyProvider(Q,Z,re){const ue=this._addNewAdapter(new Ce(this._documents,re),Q);return this._proxy.$registerCallHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareCallHierarchy(Q,Z,re,ue){return this._withAdapter(Q,Ce,J=>Promise.resolve(J.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideCallHierarchyIncomingCalls(Q,Z,re,ue){return this._withAdapter(Q,Ce,J=>J.provideCallsTo(Z,re,ue),void 0)}$provideCallHierarchyOutgoingCalls(Q,Z,re,ue){return this._withAdapter(Q,Ce,J=>J.provideCallsFrom(Z,re,ue),void 0)}$releaseCallHierarchy(Q,Z){this._withAdapter(Q,Ce,re=>Promise.resolve(re.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(Q,Z,re){const ue=this._addNewAdapter(new ke(this._documents,re),Q);return this._proxy.$registerTypeHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareTypeHierarchy(Q,Z,re,ue){return this._withAdapter(Q,ke,J=>Promise.resolve(J.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideTypeHierarchySupertypes(Q,Z,re,ue){return this._withAdapter(Q,ke,J=>J.provideSupertypes(Z,re,ue),void 0)}$provideTypeHierarchySubtypes(Q,Z,re,ue){return this._withAdapter(Q,ke,J=>J.provideSubtypes(Z,re,ue),void 0)}$releaseTypeHierarchy(Q,Z){this._withAdapter(Q,ke,re=>Promise.resolve(re.releaseSession(Z)),void 0)}static _serializeRegExp(Q){return{pattern:Q.source,flags:(0,k.regExpFlags)(Q)}}static _serializeIndentationRule(Q){return{decreaseIndentPattern:xe._serializeRegExp(Q.decreaseIndentPattern),increaseIndentPattern:xe._serializeRegExp(Q.increaseIndentPattern),indentNextLinePattern:Q.indentNextLinePattern?xe._serializeRegExp(Q.indentNextLinePattern):void 0,unIndentedLinePattern:Q.unIndentedLinePattern?xe._serializeRegExp(Q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(Q){return{beforeText:xe._serializeRegExp(Q.beforeText),afterText:Q.afterText?xe._serializeRegExp(Q.afterText):void 0,previousLineText:Q.previousLineText?xe._serializeRegExp(Q.previousLineText):void 0,action:Q.action}}static _serializeOnEnterRules(Q){return Q.map(xe._serializeOnEnterRule)}setLanguageConfiguration(Q,Z,re){let{wordPattern:ue}=re;if(ue&&(0,k.regExpLeadsToEndlessLoop)(ue))throw new Error(`Invalid language configuration: wordPattern '${ue}' is not allowed to match the empty string.`);ue?this._documents.setWordDefinitionFor(Z,ue):this._documents.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",Q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",Q,"Do not use.");const J=this._nextHandle(),ie={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?xe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?xe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?xe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,ie),this._createDisposable(J)}$setWordDefinitions(Q){for(const Z of Q)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=xe,xe._handlePool=0}),define(ge[241],pe([0,1,5,16,7,48,18,6]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,a,w){this._documents=P,this._commands=a,this._uriTransformer=w,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,P){await this._proxy.$changeLanguage(R,P);const a=this._documents.getDocumentData(R);if(!a)throw new Error(`document '${R.toString}' NOT found`);return a.document}async tokenAtPosition(R,P){const a=R.version,w=L.Position.from(P),f=await this._proxy.$tokensAtPosition(R.uri,w),v={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new D.Range(P.line,P.character,P.line,P.character)};if(!f)return v;const _={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!_.range.contains(P)||a!==R.version?v:_}createLanguageStatusItem(R,P,a){const w=this._handlePool++,f=this._proxy,v=this._ids,_=`${R.identifier.value}/${P}`;if(v.has(_))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);v.add(_);const A={selector:a,id:P,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p,o=new k.DisposableStore;const r=()=>{p?.dispose(),p=(0,i.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(w,{id:_,name:A.name??R.displayName??R.name,source:R.displayName??R.name,selector:L.DocumentSelector.from(A.selector,this._uriTransformer),label:A.text,detail:A.detail??"",severity:A.severity===D.LanguageStatusSeverity.Error?C.default.Error:A.severity===D.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:A.command&&this._commands.toInternal(A.command,o),accessibilityInfo:A.accessibilityInformation,busy:A.busy})},0)},g={dispose(){o.dispose(),p?.dispose(),f.$removeLanguageStatus(w),v.delete(_)},get id(){return A.id},get name(){return A.name},set name(c){A.name=c,r()},get selector(){return A.selector},set selector(c){A.selector=c,r()},get text(){return A.text},set text(c){A.text=c,r()},get detail(){return A.detail},set detail(c){A.detail=c,r()},get severity(){return A.severity},set severity(c){A.severity=c,r()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(c){A.accessibilityInformation=c,r()},get command(){return A.command},set command(c){A.command=c,r()},get busy(){return A.busy},set busy(c){A.busy=c,r()}};return r(),g}}e.ExtHostLanguages=S}),define(ge[131],pe([0,1,11,5,26,14,3]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(R,P){const a=new i.Emitter;super(P.logLevel,a.event);this._proxy=R.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(a)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,P,a){return new S(this._proxy,R,P,a)}};k=Ve([He(0,C.IExtHostRpcService),He(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends m.AbstractMessageLogger{constructor(R,P,a,w){super(w?.always);this.proxy=R,this.file=P,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(a),this.proxy.$createLogger(P,w).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,P){const a=[[R,P]];this.isLoggerCreated?this.doLog(a):this.buffer.push(...a)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ge[242],pe([0,1,5,11,29]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let i=class{constructor(S,y){this._logService=y,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,y,R,P,a){const w={extension:S};let f;typeof P=="string"||C(P)?f=[P,...a]:(w.modal=P?.modal,w.useCustom=P?.useCustom,w.detail=P?.detail,f=a),w.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const v=[];for(let _=0;_<f.length;_++){const A=f[_];if(typeof A=="string")v.push({title:A,handle:_,isCloseAffordance:!1});else if(typeof A=="object"){let{title:p,isCloseAffordance:o}=A;v.push({title:p,isCloseAffordance:!!o,handle:_})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(y,R,w,v).then(_=>{if(typeof _=="number")return f[_]})}};i=Ve([He(1,L.ILogService)],i),e.ExtHostMessageService=i}),define(ge[243],pe([0,1,22,3,47,6,24,8,13,2,87,5,16,7,53,218,128]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(o,r,g,c,E){this._textDocumentsAndEditors=g,this._textDocuments=c,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,s=n.cell.handle,l=this._documents.get(t)?.getCell(s);if(l)return l.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const r=this._editors.get(o);if(!r)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(o){for(const[r,g]of this._editors)if(g.apiEditor===o)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,r){const g=this._documents.get(o);if(!g&&!r)throw new Error(`NO notebook document for '${o}'`);return g}_getProviderData(o){const r=this._notebookContentProviders.get(o);if(!r)throw new Error(`NO provider for '${o}'`);return r}registerNotebookContentProvider(o,r,g,c,E){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:o,provider:g});let n;return g.onDidChangeNotebookContentOptions&&(n=g.onDidChangeNotebookContentOptions(()=>{const t=a.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},r,a.NotebookDocumentContentOptions.from(c),A._convertNotebookRegistrationData(o,E)),new w.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(o,r){if(!r)return;const g=r.filenamePattern.map(c=>a.NotebookExclusiveDocumentPattern.from(c)).filter(c=>c!==void 0);if(r.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:r.displayName,filenamePattern:g,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,r,g){const c=A._notebookStatusBarItemProviderHandlePool++,E=typeof g.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(c,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(c,E,r);let n;return E!==void 0&&(n=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(E))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(c),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(c,E),n&&n.dispose()})}async createNotebookDocument(o){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&a.NotebookData.from(o.content)});return y.URI.revive(r)}async openNotebookDocument(o){const r=this._documents.get(o);if(r)return r.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(o),c=this._documents.get(y.URI.revive(g));return(0,S.assertIsDefined)(c?.apiNotebook)}async showNotebookDocument(o,r){y.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let g;typeof r=="object"?g={position:a.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(a.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:g={preserveFocus:!1};const c=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,g),E=c&&this._editors.get(c)?.apiEditor;if(E)return E;throw c?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,r,g,c){const E=this._notebookStatusBarItemProviders.get(o),n=y.URI.revive(r),t=this._documents.get(n);if(!t||!E)return;const s=t.getCellFromIndex(g);if(!s)return;const d=await E.provideCellStatusBarItems(s.apiCell,c);if(!d)return;const l=new C.DisposableStore,h=this._statusBarCache.add([l]),b=(Array.isArray(d)?d:[d]).map(I=>a.NotebookStatusBarItem.from(I,this._commandsConverter,l));return{cacheId:h,items:b}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,r,g,c,E){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,g),this._notebookProxy.$registerNotebookSerializer(n,{id:o.identifier,location:o.extensionLocation},r,a.NotebookDocumentContentOptions.from(c),A._convertNotebookRegistrationData(o,E)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(o,r,g){const c=this._notebookSerializer.get(o);if(!c)throw new Error("NO serializer found");const E=await c.deserializeNotebook(r.buffer,g);return new f.SerializableObjectWithBuffers(a.NotebookData.from(E))}async $notebookToData(o,r,g){const c=this._notebookSerializer.get(o);if(!c)throw new Error("NO serializer found");const E=await c.serializeNotebook(a.NotebookData.to(r.value),g);return m.VSBuffer.wrap(E)}async $openNotebook(o,r,g,c,E){const{provider:n}=this._getProviderData(o),t=await n.openNotebook(y.URI.revive(r),{backupId:g,untitledDocumentData:c?.buffer},E);return new f.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(a.NotebookCellData.from)})}async $saveNotebook(o,r,g){const c=this.getNotebookDocument(y.URI.revive(r)),{provider:E}=this._getProviderData(o);return await E.saveNotebook(c.apiNotebook,g),!0}async $saveNotebookAs(o,r,g,c){const E=this.getNotebookDocument(y.URI.revive(r)),{provider:n}=this._getProviderData(o);return await n.saveNotebookAs(y.URI.revive(g),E.apiNotebook,c),!0}async $backupNotebook(o,r,g){const c=this.getNotebookDocument(y.URI.revive(r)),E=this._getProviderData(o),n=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),t=String((0,D.hash)([c.uri.toString(),this._backupIdPool++])),s=y.URI.joinPath(n,t),d=await E.provider.backupNotebook(c.apiNotebook,{destination:s},g);return c.updateBackup(d),d.id}_createExtHostEditor(o,r,g){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const c=new _.ExtHostNotebookEditor(r,this._notebookEditorsProxy,o,g.visibleRanges.map(a.NotebookRange.to),g.selections.map(a.NotebookRange.to),typeof g.viewColumn=="number"?a.ViewColumn.to(g.viewColumn):void 0);this._editors.set(r,c)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const g of o.value.removedDocuments){const c=y.URI.revive(g),E=this._documents.get(c);E&&(E.dispose(),this._documents.delete(c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===c.toString()&&this._editors.delete(n.id)}if(o.value.addedDocuments){const g=[];for(const c of o.value.addedDocuments){const E=y.URI.revive(c.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const n=this,t=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){n._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){n._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){n._onDidChangeCellMetadata.fire(s)},emitCellExecutionStateChange(s){n._onDidChangeCellExecutionState.fire(s)}},E,c);g.push(...c.cells.map(s=>v.ExtHostCell.asModelAddData(t.apiNotebook,s))),this._documents.get(E)?.dispose(),this._documents.set(E,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const g of o.value.addedEditors){if(this._editors.has(g.id))return;const c=y.URI.revive(g.documentUri),E=this._documents.get(c);E&&this._createExtHostEditor(E,g.id,g)}const r=[];if(o.value.removedEditors)for(const g of o.value.removedEditors){const c=this._editors.get(g);c&&(this._editors.delete(g),this._activeNotebookEditor?.id===c.id&&(this._activeNotebookEditor=void 0),r.push(c))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(c=>this._editors.get(c)).filter(c=>!!c);const g=new Set;this._visibleNotebookEditors.forEach(c=>g.add(c.id));for(const c of this._editors.values()){const E=g.has(c.id);c._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(c=>c).filter(c=>c.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(ge[244],pe([0,1,3,75,11,5,14,16]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(P,a){const w=S._Keys.nextId();P.$registerNotebookEditorDecorationType(w,k.NotebookDecorationRenderOptions.from(a)),this.value={key:w,dispose(){P.$removeNotebookEditorDecorationType(w)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let y=class{constructor(P,a,w){this._logService=P,this._extHostRpc=a,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,a);const w=this._notebooksAndEditors.getEditorById(P);a.visibleRanges&&w._acceptVisibleRanges(a.visibleRanges.ranges.map(k.NotebookRange.to)),a.selections&&w._acceptSelections(a.selections.selections.map(k.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const a in P)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(k.ViewColumn.to(P[a]))}};y=Ve([He(0,D.ILogService),He(1,i.IExtHostRpcService)],y),e.ExtHostNotebookEditors=y}),define(ge[245],pe([0,1,17,18,21,3,6,24,2,27,11,5,38,16,7,88,210,29,53]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(n,t,s,d,l){this._initData=t,this._extHostNotebook=s,this._commands=d,this._logService=l,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(P.MainContext.MainThreadNotebookKernels);const h=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const b=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:b}}else if(u&&"notebookEditor"in u){const b=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(b===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:b}}return u})],a.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(n,t,s,d,l,h){for(let j of this._kernelData.values())if(j.controller.id===t&&y.ExtensionIdentifier.equals(n.identifier,j.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const u=this._handlePool++,b=this;this._logService.trace(`NotebookController[${u}], CREATED by ${n.identifier.value}, ${t}`);const I=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${n.identifier}'`);let T=!1;const x=new i.DisposableStore,O=new C.Emitter,F=new C.Emitter,W={id:`${n.identifier.value}/${t}`,notebookType:s,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:d||n.identifier.value,preloads:h?h.map(w.NotebookRendererScript.from):[]};let M=l??I,B;this._proxy.$addKernel(u,W).catch(j=>{console.log(j),T=!0});let U=0;const z=()=>{if(T)return;const j=++U;Promise.resolve().then(()=>{j===U&&this._proxy.$updateKernel(u,W)})},K=new k.ResourceMap,N={get id(){return t},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return W.label},set label(j){W.label=j??n.displayName??n.name,z()},get detail(){return W.detail??""},set detail(j){W.detail=j,z()},get description(){return W.description??""},set description(j){W.description=j,z()},get kind(){return(0,A.checkProposedApiEnabled)(n,"notebookControllerKind"),W.kind??""},set kind(j){(0,A.checkProposedApiEnabled)(n,"notebookControllerKind"),W.kind=j,z()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(j){W.supportedLanguages=j,z()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(j){W.supportsExecutionOrder=j,z()},get rendererScripts(){return W.preloads?W.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(j){M=j??I},get interruptHandler(){return B},set interruptHandler(j){B=j,W.supportsInterrupt=Boolean(j),z()},createNotebookCellExecution(j){if(T)throw new Error("notebook controller is DISPOSED");if(!K.has(j.notebook.uri))throw b._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(K.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${j.notebook.uri.toString()}`);return b._createNotebookCellExecution(j)},dispose:()=>{T||(this._logService.trace(`NotebookController[${u}], DISPOSED`),T=!0,this._kernelData.delete(u),x.dispose(),O.dispose(),F.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(j,H){b._proxy.$updateNotebookPriority(u,j.uri,H)},onDidReceiveMessage:F.event,postMessage(j,H){return(0,A.checkProposedApiEnabled)(n,"notebookMessaging"),b._proxy.$postMessage(u,H&&b._extHostNotebook.getIdByEditor(H),j)},asWebviewUri(j){return(0,A.checkProposedApiEnabled)(n,"notebookMessaging"),(0,v.asWebviewUri)(j,b._initData.remote)}};return this._kernelData.set(u,{extensionId:n.identifier,controller:N,onDidReceiveMessage:F,onDidChangeSelection:O,associatedNotebooks:K}),N}$acceptNotebookAssociation(n,t,s){const d=this._kernelData.get(n);if(d){const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));s?d.associatedNotebooks.set(l.uri,!0):d.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,l.uri.toString(),s),d.onDidChangeSelection.fire({selected:s,notebook:l.apiNotebook})}}async $executeCells(n,t,s){const d=this._kernelData.get(n);if(!d)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(t)),h=[];for(let u of s){const b=l.getCell(u);b&&h.push(b.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,l.uri.toString(),h.length),await d.controller.executeHandler.call(d.controller,h,l.apiNotebook,d.controller)}catch(u){this._logService.error(`NotebookController[${n}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(n,t,s){const d=this._kernelData.get(n);if(!d)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,l.apiNotebook);else for(let h of s){const u=l.getCell(h);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,s){const d=this._kernelData.get(n);if(!d)return;const l=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:s}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const d=new g(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,d);const l=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),l.dispose(),this._activeExecutions.delete(s.uri))});return d.asApiObject()}};o=Ve([He(4,R.ILogService)],o),e.ExtHostNotebookKernels=o;var r;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(r||(r={}));class g extends i.Disposable{constructor(n,t,s){super();this._document=n,this._cell=t,this._proxy=s,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new c(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new p.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const s=f.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return s===t.items?w.NotebookCellOutput.from(t):w.NotebookCellOutput.from({items:s,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,s){const d=this.cellIndexToHandle(t),l=this.validateAndConvertOutputs((0,m.asArray)(n));return this.updateSoon({editType:_.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:s,outputs:l})}async updateOutputItems(n,t,s){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(n),!0),this.updateSoon({editType:_.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(w.NotebookCellOutputItem.from),outputId:t.id,append:s})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(s){n._executionOrder=s,n.update([{editType:_.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(s){if(n._state===r.Resolved||n._state===r.Started)throw new Error("Cannot call start again");n._state=r.Started,n._onDidChangeState.fire(),n.update({editType:_.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:s})},end(s,d){if(n._state===r.Resolved)throw new Error("Cannot call resolve twice");n._state=r.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:_.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:d,lastRunSuccess:s}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(s){return n.verifyStateForOutput(),n.updateOutputs([],s,!1)},appendOutput(s,d){return n.verifyStateForOutput(),n.updateOutputs(s,d,!0)},replaceOutput(s,d){return n.verifyStateForOutput(),n.updateOutputs(s,d,!1)},appendOutputItems(s,d){return n.verifyStateForOutput(),n.updateOutputItems(s,d,!0)},replaceOutputItems(s,d){return n.verifyStateForOutput(),n.updateOutputItems(s,d,!1)}})}}g.HANDLE=0;class c{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(ge[246],pe([0,1,3,5,128,29]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class i{constructor(S,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,y,R){const P=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(y)?.fire({editor:P.apiEditor,message:R})}createRendererMessaging(S,y){if(!S.contributes?.notebookRenderer?.some(w=>w.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const R=(0,C.isProposedApiEnabled)(S,"notebookEditor"),P=new WeakMap;return{onDidReceiveMessage:(w,f,v)=>{const _=R?w:A=>{const p={};P.set(p,A.editor),w({editor:p,message:A.message})};return this.getOrCreateEmitterFor(y).event(_,f,v)},postMessage:(w,f)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(w)&&([w,f]=[f,w]);const v=R?f:P.get(f),_=v&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(v);return this.proxy.$postMessage(_?.id,y,w)}}}getOrCreateEmitterFor(S){let y=this._rendererMessageEmitters.get(S);return y||(y=new m.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,y),y)}}e.ExtHostNotebookRenderers=i}),define(ge[132],pe([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends L.Disposable{constructor(_,A,p,o){super();this.id=_,this.name=A,this.logger=p,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,_)}replace(_){const A=this.offset;this.write(_),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,A),this.visible&&this.logger.flush()}show(_,A){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:A))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=a.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let f=class{constructor(_,A,p,o,r){this.extHostFileSystem=p,this.extHostFileSystemInfo=o,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(A.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[A,p]of this.channels)p.visible=A===this.visibleChannelId}createOutputChannel(_,A){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(_,A);return p.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,p)}async doCreateOutputChannel(_,A){const p=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(_,!1,o,A.identifier.value);return new w(g,_,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,A){let p=!1;const o=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return _},append(r){o(),A.then(g=>g.append(r))},appendLine(r){o(),A.then(g=>g.appendLine(r))},clear(){o(),A.then(r=>r.clear())},replace(r){o(),A.then(g=>g.replace(r))},show(r,g){o(),A.then(c=>c.show(r,g))},hide(){o(),A.then(r=>r.hide())},dispose(){p=!0,A.then(r=>r.dispose())}}}};f=Ve([He(0,C.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,i.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(ge[247],pe([0,1,18,21,3,6,5,2,7,15,17,48,86,29]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(v,_,A){const p=v.getProxy(i.MainContext.MainThreadQuickOpen);class o{constructor(l,h){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=h}showQuickPick(l,h,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(l),I=++this._instances,T=p.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},u),x={},O=T.then(()=>x);return Promise.race([O,b]).then(F=>{if(F!==x)return b.then(W=>{const M=[];for(let B=0;B<W.length;B++){const U=W[B];typeof U=="string"?M.push({label:U,handle:B}):U.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:U.label}):M.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:B})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{h.onDidSelectItem(W[B])}),p.$setItems(I,M),T.then(B=>{if(typeof B=="number")return W[B];if(Array.isArray(B))return B.map(U=>W[U])})})}).then(void 0,F=>{if(!(0,y.isPromiseCanceledError)(F))return p.$setError(I,F),Promise.reject(F)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,h=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,p.$input(l,typeof this._validateInput=="function",h).then(void 0,u=>{if(!(0,y.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(l){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,h=L.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!u)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(I=>I.uri.toString()===u.uri.toString())}createQuickPick(l){const h=new t(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(l){const h=new s(l,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(l,h){const u=this._sessions.get(l);u&&u._fireDidChangeValue(h)}$onDidAccept(l){const h=this._sessions.get(l);h&&h._fireDidAccept()}$onDidChangeActive(l,h){const u=this._sessions.get(l);u instanceof t&&u._fireDidChangeActive(h)}$onDidChangeSelection(l,h){const u=this._sessions.get(l);u instanceof t&&u._fireDidChangeSelection(h)}$onDidTriggerButton(l,h){const u=this._sessions.get(l);u&&u._fireDidTriggerButton(h)}$onDidTriggerItemButton(l,h,u){const b=this._sessions.get(l);b instanceof t&&b._fireDidTriggerItemButton(h,u)}$onDidHide(l){const h=this._sessions.get(l);h&&h._fireDidHide()}}class r{constructor(l,h){this._extensionId=l,this._onDidDispose=h,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((h,u)=>{const b=h===S.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(b,h)}),this.update({buttons:l.map((h,u)=>({...n(h),tooltip:h.tooltip,handle:h===S.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const h=this._handlesToButtons.get(l);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(l){if(!this._disposed){for(const h of Object.keys(l)){const u=l[h];this._pendingUpdate[h]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function g(d){if(d instanceof S.ThemeIcon)return{id:d.id};const l=E(d),h=c(d);return{dark:typeof l=="string"?k.URI.file(l):l,light:typeof h=="string"?k.URI.file(h):h}}function c(d){return typeof d=="object"&&"light"in d?d.light:d}function E(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const l=g(d.iconPath);let h,u;return"id"in l?u=a.ThemeIcon.asClassName(l):h=l,{iconPath:h,iconClass:u}}class t extends r{constructor(l,h){super(l.identifier,h);this.extension=l,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){l.some(u=>u.kind!==void 0)&&(0,w.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((u,b)=>{this._handlesToItems.set(b,u),this._itemsToHandles.set(u,b)});const h=[];for(let u=0;u<l.length;u++){const b=l[u];b.kind===S.QuickPickItemKind.Separator?h.push({type:"separator",label:b.label}):h.push({handle:u,label:b.label,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,buttons:b.buttons?.map((I,T)=>({...n(I),tooltip:I.tooltip,handle:T}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(l){const h=(0,R.coalesce)(l.map(u=>this._handlesToItems.get(u)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(l){const h=(0,R.coalesce)(l.map(u=>this._handlesToItems.get(u)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(l,h){const u=this._handlesToItems.get(l);if(!u||!u.buttons||!u.buttons.length)return;const b=u.buttons[h];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:u})}}class s extends r{constructor(l,h){super(l,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?P.default.Error:P.default.Ignore})}}return new o(_,A)}e.createExtHostQuickOpen=f}),define(ge[248],pe([0,1,2,3,57,6,18,5,17,99,11,27,86,16,29]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||a.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function _(d,l){if(!d.iconPath&&!l.iconPath)return 0;if(d.iconPath){if(!l.iconPath)return 1}else return-1;const h=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,u=typeof l.iconPath=="string"?l.iconPath:m.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,y.comparePaths)(h,u)}function A(d,l){let h=0;if(d.strikeThrough!==l.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==l.faded)return d.faded?1:-1;if(d.tooltip!==l.tooltip)return(d.tooltip||"").localeCompare(l.tooltip||"");if(h=_(d,l),h!==0)return h;if(d.light&&l.light)h=_(d.light,l.light);else{if(d.light)return 1;if(l.light)return-1}if(h!==0)return h;if(d.dark&&l.dark)h=_(d.dark,l.dark);else{if(d.dark)return 1;if(l.dark)return-1}return h}function p(d,l){if(d.command!==l.command)return d.command<l.command?-1:1;if(d.title!==l.title)return d.title<l.title?-1:1;if(d.tooltip!==l.tooltip){if(d.tooltip!==void 0&&l.tooltip!==void 0)return d.tooltip<l.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(d.arguments===l.arguments)return 0;if(d.arguments)if(l.arguments){if(d.arguments.length!==l.arguments.length)return d.arguments.length-l.arguments.length}else return 1;else return-1;for(let h=0;h<d.arguments.length;h++){const u=d.arguments[h],b=l.arguments[h];if(u!==b)return u<b?-1:1}return 0}function o(d,l){let h=(0,y.comparePaths)(d.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(h!==0)return h;if(d.command&&l.command)h=p(d.command,l.command);else{if(d.command)return 1;if(l.command)return-1}if(h!==0)return h;if(d.decorations&&l.decorations)h=A(d.decorations,l.decorations);else{if(d.decorations)return 1;if(l.decorations)return-1}return h}function r(d,l){for(let h=0;h<d.length;h++)if(d[h]!==l[h])return!1;return!0}function g(d,l){return d.command===l.command&&d.title===l.title&&d.tooltip===l.tooltip&&(d.arguments&&l.arguments?r(d.arguments,l.arguments):d.arguments===l.arguments)}function c(d,l){return(0,S.equals)(d,l,g)}class E{constructor(l,h,u){this._extension=l,this._proxy=h,this._sourceControlHandle=u,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(l){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}showValidationMessage(l,h){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,l,h)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=E;class n{constructor(l,h,u,b,I){this._proxy=l,this._commands=h,this._sourceControlHandle=u,this._id=b,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,h){const u=this._resourceStatesCommandsMap.get(l);return u?(0,i.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this._resourceStates].sort(o),u=(0,S.sortedDiff)(this._resourceSnapshot,l,o).map(T=>{const x=T.toInsert.map(O=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,O);const W=O.resourceUri;let M;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const te=new C.DisposableStore;M=this._commands.converter.toInternal(O.command,te),this._resourceStatesDisposablesMap.set(F,te)}else this._resourceStatesCommandsMap.set(F,O.command);const B=v(O.decorations),U=O.decorations&&v(O.decorations.light)||B,z=O.decorations&&v(O.decorations.dark)||B,K=[U,z],N=O.decorations&&O.decorations.tooltip||"",j=O.decorations&&!!O.decorations.strikeThrough,H=O.decorations&&!!O.decorations.faded,V=O.contextValue||"";return{rawResource:[F,W,K,N,j,H,V,M],handle:F}});return{start:T.start,deleteCount:T.deleteCount,toInsert:x}}),b=u.map(({start:T,deleteCount:x,toInsert:O})=>[T,x,O.map(F=>F.rawResource)]),I=u.reverse();for(const{start:T,deleteCount:x,toInsert:O}of I){const F=O.map(M=>M.handle),W=this._handlesSnapshot.splice(T,x,...F);for(const M of W)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=l,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(l,h,u,b,I,T){this._extension=l,this._proxy=h,this._commands=u,this._id=b,this._label=I,this._rootUri=T,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new E(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,I,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=l;const h=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(l){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=l;const h=l!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:h??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&c(this._statusBarCommands,l))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=l;const h=(l||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}get selected(){return this._selected}createResourceGroup(l,h){const u=new n(this._proxy,this._commands,this.handle,l,h),b=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,b),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const l=[],h=[];for(const[u,b]of this.createdResourceGroups){b.dispose();const I=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),I.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),l.push([u.handle,u.id,u.label,u.features]);const T=u._takeResourceStateSnapshot();T.length>0&&h.push([u.handle,T]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,l,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(h=>{const u=h._takeResourceStateSnapshot();u.length!==0&&l.push([h.handle,u])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,D.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let s=class Hi{constructor(l,h,u){this._commands=h,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=l.getProxy(k.MainContext.MainThreadSCM),this._telemetry=l.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const I=this._sourceControls.get(b.sourceControlHandle);if(!I)return b;const T=I.getResourceGroup(b.groupHandle);return T?T.getResourceState(b.handle):b}else if(b&&b.$mid===4){const I=this._sourceControls.get(b.sourceControlHandle);return I?I.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const I=this._sourceControls.get(b.handle);return I||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,h,u,b){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,h,u,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const I=Hi._handlePool++,T=new t(l,this._proxy,this._commands,h,u,b);this._sourceControls.set(I,T);const x=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(l.identifier))||[];return x.push(T),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(l.identifier),x),T}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const h=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(l.identifier)),u=h&&h[h.length-1];return u&&u.inputBox}$provideOriginalResource(l,h,u){const b=m.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,b.toString());const I=this._sourceControls.get(l);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,i.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(b,u)).then(T=>T||null)}$onInputBoxValueChange(l,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const u=this._sourceControls.get(l);return u&&u.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(l,h,u,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,h,u);const I=this._sourceControls.get(l);if(!I)return Promise.resolve(void 0);const T=I.getResourceGroup(h);return T?T.$executeResourceCommand(u,b):Promise.resolve(void 0)}$validateInput(l,h,u){this.logService.trace("ExtHostSCM#$validateInput",l);const b=this._sourceControls.get(l);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):(0,i.asPromise)(()=>b.inputBox.validateInput(h,u)).then(I=>{if(!I)return Promise.resolve(void 0);const T=w.MarkdownString.fromStrict(I.message);return T?Promise.resolve([T,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this._sourceControls.get(l)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([He(2,R.ILogService)],s),e.ExtHostSCM=s});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[249],pe([0,1,7,5,165,6,16,13]),function(Y,e,m,L,D,C,i,k){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(f,v,_,A,p=m.StatusBarAlignment.Left,o){S.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,ot(this,S,f,"f"),ot(this,y,v,"f"),this._entryId=R.ID_GEN++,this._extension=_,this._id=A,this._alignment=p,this._priority=this.validatePriority(o)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!R.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,y,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let v;this._name?v=this._name:v=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const A=this._tooltip?i.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,f,v,this._text,A,this._command?.internal,_,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,y=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const v={message:f};return this._messages.unshift(v),this._update(),new m.Disposable(()=>{const _=this._messages.indexOf(v);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(f,v){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new P(this)}createStatusBarEntry(f,v,_,A){return new R(this._proxy,this._commands,f,v,_,A)}setStatusBarMessage(f,v){const _=this._statusMessage.setMessage(f);let A;return typeof v=="number"?A=setTimeout(()=>_.dispose(),v):typeof v!="undefined"&&v.then(()=>_.dispose(),()=>_.dispose()),new m.Disposable(()=>{_.dispose(),clearTimeout(A)})}}e.ExtHostStatusBar=a}),define(ge[91],pe([0,1,5,3,4]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}getValue(k,S,y){return this._proxy.$getValue(k,S).then(R=>R||y)}setValue(k,S,y){return this._proxy.$setValue(k,S,y)}$acceptValue(k,S,y){this._onDidChangeStorage.fire({shared:k,key:S,value:y})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ge[67],pe([0,1,4,26,11,66,2]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(y,R,P){this._logService=R,this._extHostFileSystem=P,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(y){return i.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,R=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(i.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:i.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(y){if(this._value)return i.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return i.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([He(0,L.IExtHostInitDataService),He(1,D.ILogService),He(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[34],pe([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,86,13,18]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class p{constructor(d,l,h,u){this._proxy=d,this._id=l,this._creationOptions=h,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(I=>this._pidPromiseComplete=I);const b=this;this.value={get name(){return b._name||""},get processId(){return b._pidPromise},get creationOptions(){return b._creationOptions},get exitStatus(){return b._exitStatus},get state(){return b._state},sendText(I,T=!0){b._checkDisposed(),b._proxy.$sendText(b._id,I,T)},show(I){b._checkDisposed(),b._proxy.$show(b._id,I)},hide(){b._checkDisposed(),b._proxy.$hide(b._id)},dispose(){b._disposed||(b._disposed=!0,b._proxy.$dispose(b._id))},get dimensions(){if(!(b._cols===void 0||b._rows===void 0))return{columns:b._cols,rows:b._rows}}}}async create(d,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,_.withNullAsUndefined)(d.shellPath),shellArgs:(0,_.withNullAsUndefined)(d.shellArgs),cwd:(0,_.withNullAsUndefined)(d.cwd),env:(0,_.withNullAsUndefined)(d.env),icon:(0,_.withNullAsUndefined)(n(d.iconPath)),color:v.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,_.withNullAsUndefined)(d.message),strictEnv:(0,_.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(d.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,l,h,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:v.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(d,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,l){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,l){return d===this._cols&&l===this._rows||d===0||l===0?!1:(this._cols=d,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=p;class o{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,l){this._pty.setDimensions?.({columns:d,rows:l})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let r=1,g=class extends k.Disposable{constructor(d,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[h,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,l){const h=new p(this._proxy,(0,w.generateUuid)(),d,d.name),u=new o(d.pty);return h.createExtensionTerminal(d.location,this._serializeParentTerminal(d,l).resolvedExtHostIdentifier,n(d.iconPath),t(d.color)).then(b=>{const I=this._setupExtHostProcessListeners(b,u);this._terminalProcessDisposables[b]=I}),this._terminals.push(h),h.value}_serializeParentTerminal(d,l){if(l=l||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const h=d.location.parentTerminal;if(h){const u=this._terminals.find(b=>b.value===h);u&&(l.resolvedExtHostIdentifier=u._id)}}else d.location&&typeof d.location!="object"?l.location=d.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(d,l){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const u=new o(l),b=this._setupExtHostProcessListeners(d,u);this._terminalProcessDisposables[d]=b}async $acceptActiveTerminalChanged(d){const l=this._activeTerminal;if(d===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(d);h&&(this._activeTerminal=h,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,l){const h=this._getTerminalById(d);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:l})}async $acceptTerminalDimensions(d,l,h){const u=this._getTerminalById(d);u&&u.setDimensions(l,h)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(d,l,h){this._terminalProcesses.get(d)?.resize(l,h)}async $acceptTerminalTitleChange(d,l){const h=this._getTerminalById(d);h&&(h.name=l)}async $acceptTerminalClosed(d,l){const h=this._getTerminalObjectIndexById(this._terminals,d);if(h!==null){const u=this._terminals.splice(h,1)[0];u.setExitCode(l),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(d,l,h,u){if(l){const T=this._getTerminalObjectIndexById(this._terminals,l);if(T!==null){this._terminals[T]._id=d,this._onDidOpenTerminal.fire(this.terminals[T]),this._terminals[T].isOpen=!0;return}}const b={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:C.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},I=new p(this._proxy,d,b,h);this._terminals.push(I),this._onDidOpenTerminal.fire(I.value),I.isOpen=!0}async $acceptTerminalProcessId(d,l){const h=this._getTerminalById(d);h&&h._setProcessId(l)}async $startExtensionTerminal(d,l){const h=this._getTerminalById(d);if(!h)return{message:(0,y.localize)(0,null,d)};h.isOpen||await new Promise(b=>{const I=this.onDidOpenTerminal(async T=>{T===h.value&&(I.dispose(),b())})});const u=this._terminalProcesses.get(d);u?u.startSendingEvents(l):this._extensionTerminalAwaitingStart[d]={initialDimensions:l}}_setupExtHostProcessListeners(d,l){const h=new k.DisposableStore;h.add(l.onProcessReady(b=>this._proxy.$sendProcessReady(d,b.pid,b.cwd))),h.add(l.onDidChangeProperty(b=>this._proxy.$sendProcessProperty(d,b))),this._bufferer.startBuffering(d,l.onProcessData),h.add(l.onProcessExit(b=>this._onProcessExit(d,b))),this._terminalProcesses.set(d,l);const u=this._extensionTerminalAwaitingStart[d];return u&&l instanceof o&&(l.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),h}$acceptProcessAckDataEvent(d,l){this._terminalProcesses.get(d)?.acknowledgeDataEvent(l)}$acceptProcessInput(d,l){this._terminalProcesses.get(d)?.input(l)}$acceptTerminalInteraction(d){const l=this._getTerminalById(d);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(d,l,h){try{this._terminalProcesses.get(d)?.resize(l,h)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(d,l){this._terminalProcesses.get(d)?.shutdown(l)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(l=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:l}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,l,h){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,h),this._proxy.$registerProfileProvider(l,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(d,l){const h=new a.CancellationTokenSource().token;let u=await this._profileProviders.get(d)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,l);return}this.createTerminalFromOptions(u.options,l)}}async $provideLinks(d,l){const h=this._getTerminalById(d);if(!h)return[];this._terminalLinkCache.delete(d);const u=this._terminalLinkCancellationSource.get(d);u&&u.dispose(!0);const b=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,b);const I=[],T={terminal:h.value,line:l},x=[];for(const W of this._linkProviders)x.push(A.Promises.withAsyncBody(async M=>{b.token.onCancellationRequested(()=>M({provider:W,links:[]}));const B=await W.provideTerminalLinks(T,b.token)||[];b.token.isCancellationRequested||M({provider:W,links:B})}));const O=await Promise.all(x);if(b.token.isCancellationRequested)return[];const F=new Map;for(const W of O)W&&W.links.length>0&&I.push(...W.links.map(M=>{const B={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(B.id,{provider:W.provider,link:M}),B}));return this._terminalLinkCache.set(d,F),I}$activateLink(d,l){const h=this._terminalLinkCache.get(d)?.get(l);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(d,l){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const h=this._terminalProcessDisposables[d];h&&(h.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,l)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,l){const h=this._getTerminalObjectIndexById(d,l);return h!==null?d[h]:null}_getTerminalObjectIndexById(d,l){let h=null;return d.some((u,b)=>u._id===l?(h=b,!0):!1),h}getEnvironmentVariableCollection(d){let l=this._environmentVariableCollections.get(d.identifier.value);return l||(l=new c,this._setEnvironmentVariableCollection(d.identifier.value,l)),l}_syncEnvironmentVariableCollection(d,l){const h=(0,P.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(d,l.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(d){d.forEach(l=>{const h=l[0],u=new c(l[1]);this._setEnvironmentVariableCollection(h,u)})}$acceptDefaultProfile(d,l){this._defaultProfile=d,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(d,l){this._environmentVariableCollections.set(d,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,l)})}};g=Ve([He(1,i.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class c{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,l){this._setIfDiffers(d,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(d,l){this._setIfDiffers(d,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,l){this._setIfDiffers(d,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,l){const h=this.map.get(d);(!h||h.value!==l.value||h.type!==l.type)&&(this.map.set(d,l),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,l){this.map.forEach((h,u)=>d.call(l,u,h,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let E=class extends g{constructor(d){super(!1,d)}createTerminal(d,l,h){throw new R.NotSupportedError}createTerminalFromOptions(d,l){throw new R.NotSupportedError}};E=Ve([He(0,i.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function n(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function t(s){return v.ThemeColor.isThemeColor(s)?s:void 0}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[250],pe([0,1,17,22,21,3,74,47,6,25,13,32,5,14,63,16,7,221,126,89]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(T,x){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(a.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new E(this.proxy),x.registerArgumentProcessor({processArgument:O=>O?.$mid===13?v.TestItem.toItemFromContext(O):O})}createTestController(T,x){if(this.controllers.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const O=new S.DisposableStore,F=O.add(new A.SingleUseTestCollection(T));F.root.label=x;const W=new Map,M=this.proxy,B={items:F.root.children,get label(){return x},set label(z){x=z,F.root.label=z,M.$updateControllerLabel(T,x)},get id(){return T},createRunProfile:(z,K,N,j,H)=>{let V=(0,k.hash)(z);for(;W.has(V);)V++;const q=new u(this.proxy,T,V,z,K,N,j,H);return W.set(V,q),q},createTestItem(z,K,N){return new f.TestItemImpl(T,z,K,N)},createTestRun:(z,K,N=!0)=>this.runTracker.createTestRun(T,F,z,K,N),set resolveHandler(z){F.resolveHandler=z},get resolveHandler(){return F.resolveHandler},dispose:()=>{O.dispose()}};B.createRunConfiguration=B.createRunProfile,M.$registerTestController(T,x),O.add((0,S.toDisposable)(()=>M.$unregisterTestController(T)));const U={controller:B,collection:F,profiles:W};return this.controllers.set(T,U),O.add((0,S.toDisposable)(()=>this.controllers.delete(T))),O.add(F.onDidGenerateDiff(z=>M.$publishDiff(T,z))),B}createTestObserver(){return this.observer.checkout()}async runTests(T,x=D.CancellationToken.None){const O=n(T);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(O.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:T.include?.map(W=>W.id)??[F.collection.root.id],profileGroup:b[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:T.exclude?.map(W=>W.id)},x)}$provideFileCoverage(T,x,O){return(0,m.mapFind)(this.runTracker.trackers,W=>W.id===T?W.getCoverage(x):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(T,x,O,F){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===T?M.getCoverage(x):void 0)?.resolveFileCoverage(O,F)??Promise.resolve([])}$configureRunProfile(T,x){this.controllers.get(T)?.profiles.get(x)?.configureHandler?.()}$publishTestResults(T){this.results=Object.freeze(T.map(x=>(0,y.deepFreeze)(v.TestResults.to(x))).concat(this.results).sort((x,O)=>O.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(T,x){const O=this.controllers.get(o.TestId.fromString(T).controllerId)?.collection;O&&(await O.expand(T,x<0?Infinity:x),O.flushDiff())}$acceptDiff(T){this.observer.applyDiff(T)}async $runControllerTests(T,x){const O=this.controllers.get(T.controllerId);if(!O)return;const{collection:F,profiles:W}=O,M=W.get(T.profileId);if(!M)return;const B=T.testIds.map(N=>F.tree.get(N)).filter(R.isDefined),U=T.excludeExtIds.map(N=>O.collection.tree.get(N)).filter(R.isDefined).filter(N=>B.some(j=>j.fullId.compare(N.fullId)===2));if(!B.length)return;const z=new _.TestRunRequest(B.some(N=>N.actual instanceof f.TestItemRootImpl)?void 0:B.map(N=>N.actual),U.map(N=>N.actual),M),K=this.runTracker.prepareForMainThreadTestRun(z,t.fromInternal(T,O.collection),x);try{await M.runHandler(z,x)}finally{K.isRunning&&!x.isCancellationRequested&&await C.Event.toPromise(K.onEnd),K.dispose()}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}};g=Ve([He(0,w.IExtHostRpcService)],g),e.ExtHostTesting=g;class c extends S.Disposable{constructor(T,x,O){super();this.dto=T,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(T){return this.tasks.get(T)?.coverage}createRun(T){const x=this.dto.id,O=this.dto.controllerId,F=(0,P.generateUuid)(),W=new s(this.proxy,x,F),M=K=>(N,...j)=>{if(U){console.warn(`Setting the state of test "${N.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(N)||(this.ensureTestIsKnown(N),K(N,...j))},B=(K,N)=>{const j=N instanceof Array?N.map(v.TestMessage.from):[v.TestMessage.from(N)];if(K.uri&&K.range){const H={range:v.Range.from(K.range),uri:K.uri};for(const V of j)V.location=V.location||H}this.proxy.$appendTestMessagesInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),j)};let U=!1;const z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:T,get coverageProvider(){return W.coverageProvider},set coverageProvider(K){W.coverageProvider=K},enqueued:M(K=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),1)}),skipped:M(K=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),5)}),started:M(K=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),2)}),errored:M((K,N,j)=>{B(K,N),this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),6,j)}),failed:M((K,N,j)=>{B(K,N),this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,O).toString(),4,j)}),passed:M((K,N)=>{this.proxy.$updateTestStateInRun(x,F,o.TestId.fromExtHostTestItem(K,this.dto.controllerId).toString(),3,N)}),appendOutput:(K,N,j)=>{U||(j&&(this.dto.isIncluded(j)?this.ensureTestIsKnown(j):j=void 0),this.proxy.$appendOutputToRun(x,F,L.VSBuffer.fromString(K),N&&v.location.from(N),j&&o.TestId.fromExtHostTestItem(j,O).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(x,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:z,coverage:W}),this.proxy.$startedTestRunTask(x,{id:F,name:T,running:!0}),z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(T){if(!(T instanceof f.TestItemImpl))throw new f.InvalidTestItemError(T.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(T,this.dto.controllerId).toString()))return;const x=[],O=this.dto.colllection.root;for(;;){const F=v.TestItem.from(T);if(x.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),T===O))break;T=T.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class E{constructor(T){this.proxy=T,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(T,x,O){return this.getTracker(T,x,O)}cancelRunById(T){for(const x of this.tracked.values())if(x.id===T){x.dispose();return}}cancelAllRuns(){for(const T of this.tracked.values())T.dispose()}createTestRun(T,x,O,F,W){const M=this.tracked.get(O);if(M)return M.createRun(F);const B=t.fromPublic(T,x,O,W),U=n(O);this.proxy.$startedExtensionTestRun({controllerId:T,profile:U&&{group:b[U.kind],id:U.profileId},exclude:O.exclude?.map(K=>K.id)??[],id:B.id,include:O.include?.map(K=>K.id)??[x.root.id],persist:W});const z=this.getTracker(O,B);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),z.createRun(F)}getTracker(T,x,O){const F=new c(x,this.proxy,O);return this.tracked.set(T,F),F.onEnd(()=>this.tracked.delete(T)),F}}e.TestRunCoordinator=E;const n=I=>{if(!!I.profile){if(!(I.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class t{constructor(T,x,O,F,W,M){this.controllerId=T,this.id=x,this.isPersisted=W,this.colllection=M,this.includePrefix=O.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}static fromPublic(T,x,O,F){return new t(T,(0,P.generateUuid)(),O.include?.map(W=>o.TestId.fromExtHostTestItem(W,T).toString())??[T],O.exclude?.map(W=>o.TestId.fromExtHostTestItem(W,T).toString())??[],F,x)}static fromInternal(T,x){return new t(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,x)}isIncluded(T){const x=o.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(x===O||x.startsWith(O))return!1;for(const O of this.includePrefix)if(x===O||x.startsWith(O))return!0;return!1}}e.TestRunDto=t;class s{constructor(T,x,O){this.proxy=T,this.runId=x,this.taskId=O}set coverageProvider(T){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this._coverageProvider=T,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(T){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(T))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(T,x){const O=await this.fileCoverage;let F=O?.[T];return!this._coverageProvider||!O||!F?[]:(F.detailedCoverage||(F=O[T]=await this._coverageProvider.resolveFileCoverage?.(F,x)??F),F.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class d extends p.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,v.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:x,removed:O}=this;return{get added(){return[...T].map(F=>F.revived)},get updated(){return[...x].map(F=>F.revived)},get removed(){return[...O].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,x){return{...T,revived:v.TestItem.toPlain(T.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(T){this.proxy=T}checkout(){this.current||(this.current=this.createObserverData());const T=this.current;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(x=>x.revived)},dispose:(0,i.once)(()=>{--T.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(T){return this.current?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.current?.tests.apply(T)}createObserverData(){const T=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:T}}}class u{constructor(T,x,O,F,W,M,B=!1,U=void 0){this.controllerId=x,this.profileId=O,this._label=F,this.kind=W,this.runHandler=M,this._isDefault=B,this._tag=U,r.set(this,void 0),ot(this,r,T,"f");const z=b[W];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Oe(this,r,"f").$publishTestRunProfile({profileId:O,controllerId:x,tag:U?v.TestTag.namespace(this.controllerId,U.id):null,label:F,group:z,isDefault:B,hasConfigurationHandler:!1})}get label(){return this._label}set label(T){T!==this._label&&(this._label=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get isDefault(){return this._isDefault}set isDefault(T){T!==this._isDefault&&(this._isDefault=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?v.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(T){T!==this._configureHandler&&(this._configureHandler=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}dispose(){Oe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,r=new WeakMap;const b={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(ge[251],pe([0,1,3,17,5,129,16,7]),function(Y,e,m,L,D,C,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const P=this._extHostDocumentsAndEditors.allEditors();return R?P:P.map(a=>a.value)}async showTextDocument(R,P,a){let w;typeof P=="number"?w={position:i.ViewColumn.from(P),preserveFocus:a}:typeof P=="object"?w={position:i.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?i.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:w={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(R.uri,w),v=f&&this._extHostDocumentsAndEditors.getEditor(f);if(v)return v.value;throw f?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new C.TextEditorDecorationType(this._proxy,R,P).value}$acceptEditorPropertiesChanged(R,P){const a=this._extHostDocumentsAndEditors.getEditor(R);if(!a)throw new Error("unknown text editor");if(P.options&&a._acceptOptions(P.options),P.selections){const w=P.selections.selections.map(i.Selection.to);a._acceptSelections(w)}if(P.visibleRanges){const w=L.coalesce(P.visibleRanges.map(i.Range.to));a._acceptVisibleRanges(w)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...P.options,lineNumbers:i.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const w=k.TextEditorSelectionChangeKind.fromValue(P.selections.source),f=P.selections.selections.map(i.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:f,kind:w})}if(P.visibleRanges){const w=L.coalesce(P.visibleRanges.map(i.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:w})}}$acceptEditorPositionData(R){for(const P in R){const a=this._extHostDocumentsAndEditors.getEditor(P);if(!a)throw new Error("Unknown text editor");const w=i.ViewColumn.to(R[P]);a.value.viewColumn!==w&&(a._acceptViewColumn(w),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:w}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(ge[252],pe([0,1,2,4,5,6,7]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(R,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const w=a.uri===void 0?void 0:m.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(S(w))?.get(a.handle)}return a}})}async $getTimeline(R,P,a,w,f){return this._providers.get(R)?.provideTimeline(m.URI.revive(P),a,w,f)}registerTimelineProvider(R,P,a,w){const f=new C.DisposableStore,v=this.convertTimelineItem(P.id,w,f).bind(this);let _;P.onDidChange&&(_=P.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:P.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:R,onDidChange:void 0,async provideTimeline(p,o,r,g){g?.resetCache&&(f.clear(),A.get(P.id)?.clear());const c=await P.provideTimeline(p,o,r);if(c==null)return;const E=v(p,g);return{...c,source:P.id,items:c.items.map(E)}},dispose(){for(const p of A.values())p.get(P.id)?.clear();_?.dispose(),f.dispose()}})}convertTimelineItem(R,P,a){return(w,f)=>{let v;if(f?.cacheResults){let _=this._itemsBySourceAndUriMap.get(R);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(R,_));const A=S(w);v=_.get(A),v===void 0&&(v=new Map,_.set(A,v))}return _=>{const{iconPath:A,...p}=_,o=`${R}|${_.id??_.timestamp}`;v?.set(o,_);let r,g,c;return _.iconPath&&(A instanceof i.ThemeIcon?c={id:A.id,color:A.color}:m.URI.isUri(A)?(r=A,g=A):{light:r,dark:g}=A),{...p,id:p.id??void 0,handle:o,source:R,command:_.command?P.toInternal(_.command,a):void 0,icon:r,iconDark:g,themeIcon:c,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,C.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function S(y){return y?.toString()}}),define(ge[253],pe([0,1,6,10,2,5]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class i{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,R,P){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const a=P.schemes.find(w=>!i.supportedSchemes.has(w));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,R),this._proxy.$registerUriOpener(y,P.schemes,S,P.label),(0,m.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(S,y,R){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const a=D.URI.revive(y);return P.canOpenExternalUri(a,R)}async $openUri(S,y,R){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(D.URI.revive(y.resolvedUri),{sourceUri:D.URI.revive(y.sourceUri)},R)}}e.ExtHostUriOpeners=i,i.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(ge[254],pe([0,1,5,2,6,15,27]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(y){this.handles=new Set,this.handlers=new Map,this._proxy=y.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(y,R){if(this.handles.has(i.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const P=k.HandlePool++;return this.handles.add(i.ExtensionIdentifier.toKey(y)),this.handlers.set(P,R),this._proxy.$registerUriHandler(P,y),(0,D.toDisposable)(()=>{this.handles.delete(i.ExtensionIdentifier.toKey(y)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(y,R){const P=this.handlers.get(y);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(R))}catch(a){(0,C.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(y){return L.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=k,k.HandlePool=0});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[68],pe([0,1,3,10,2,178,203,88,5]),function(Y,e,m,L,D,C,i,k,S){"use strict";var y,R,P,a,w,f,v,_,A,p,o,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(h,u,b,I,T,x,O){y.set(this,void 0),R.set(this,void 0),P.set(this,void 0),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,""),_.set(this,void 0),A.set(this,!1),p.set(this,!1),o.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Oe(this,r,"f").event,ot(this,y,h,"f"),ot(this,R,u,"f"),ot(this,_,b,"f"),ot(this,a,I,"f"),ot(this,w,T,"f"),ot(this,f,x,"f"),ot(this,o,c(x),"f"),ot(this,P,O,"f")}dispose(){ot(this,A,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return ot(this,p,!0,"f"),(0,k.asWebviewUri)(h,Oe(this,a,"f").remote)}get cspSource(){const h=Oe(this,f,"f").extensionLocation;if(h.scheme===L.Schemas.https||h.scheme===L.Schemas.http){let u=h.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,v,"f")}set html(h){this.assertNotDisposed(),Oe(this,v,"f")!==h&&(ot(this,v,h,"f"),!Oe(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(ot(this,p,!0,"f"),Oe(this,P,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,y,"f"),h))}get options(){return this.assertNotDisposed(),Oe(this,_,"f")}set options(h){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,y,"f"),t(Oe(this,f,"f"),Oe(this,w,"f"),h)),ot(this,_,h,"f")}async postMessage(h){if(Oe(this,A,"f"))return!1;const u=(0,i.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Oe(this,o,"f")});return Oe(this,R,"f").$postMessage(Oe(this,y,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Oe(this,A,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,y=new WeakMap,R=new WeakMap,P=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,_=new WeakMap,A=new WeakMap,p=new WeakMap,o=new WeakMap,r=new WeakMap;function c(l){try{const h=(0,C.normalizeVersion)((0,C.parseVersion)(l.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;class E{constructor(h,u,b,I,T){this.initData=u,this.workspace=b,this._logService=I,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=h.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(h,u,...b){const I=this.getWebview(h);if(I){const{message:T}=(0,i.deserializeWebviewMessage)(u,b);I._onMessageEmitter.fire(T)}}$onMissingCsp(h,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,u,b){const I=new g(h,this._webviewProxy,s(u),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(h,I),I._onDidDispose(()=>{this._webviews.delete(h)}),I}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=E;function n(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=n;function t(l,h,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||d(l,h)}}e.serializeWebviewOptions=t;function s(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(h=>D.URI.from(h))}}e.reviveOptions=s;function d(l,h){return[...(h?.getWorkspaceFolders()||[]).map(u=>u.uri),l.extensionLocation]}}),define(ge[255],pe([0,1,21,47,6,10,23,2,16,68,87,5,7]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(c,E){this.document=c,this._storagePath=E,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,E){await this.getEdit(c).undo(),E||this.disposeBackup()}async redo(c,E){await this.getEdit(c).redo(),E||this.disposeBackup()}disposeEdits(c){for(const E of c)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=r(this.document.uri)+this._backupCounter++;return(0,i.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const E=this._edits.get(c,0);if(!E)throw new Error("No edit found");return E}}class f{constructor(){this._documents=new Map}get(c,E){return this._documents.get(this.key(c,E))}add(c,E,n){const t=this.key(c,E.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${c} resource:${E.uri}`);const s=new w(E,n);return this._documents.set(t,s),s}delete(c,E){const n=this.key(c,E.uri);this._documents.delete(n)}key(c,E){return`${c}@@@${E}`}}var v;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(c,E,n){return this.add(0,c,E,n)}addCustomProvider(c,E,n){return this.add(1,c,E,n)}get(c){return this._providers.get(c)}add(c,E,n,t){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:c,extension:n,provider:t}),new a.Disposable(()=>this._providers.delete(E))}}class A{constructor(c,E,n,t,s){this._extHostDocuments=E,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=s,this._editorProviders=new _,this._documents=new f,this._proxy=c.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,E,n,t){const s=new D.DisposableStore;return p(n)?(s.add(this._editorProviders.addTextProvider(E,c,n)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(c),E,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(c))):(s.add(this._editorProviders.addCustomProvider(E,c,n)),this.supportEditing(n)&&s.add(n.onDidChangeCustomDocument(d=>{const l=this.getCustomDocumentEntry(E,d.document.uri);if(o(d)){const h=l.addEdit(d);this._proxy.$onDidEdit(d.document.uri,E,h,d.label)}else this._proxy.$onContentChange(d.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(c),E,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(c))),a.Disposable.from(s,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(c,E,n,t,s){const d=this._editorProviders.get(E);if(!d)throw new Error(`No provider found for '${E}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${E}'`);const l=k.URI.revive(c),h=await d.provider.openCustomDocument(l,{backupId:n,untitledDocumentData:t?.buffer},s);let u;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(E,h,u),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(c,E){const n=this._editorProviders.get(E);if(!n)throw new Error(`No provider found for '${E}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${E}'`);const t=k.URI.revive(c),{document:s}=this.getCustomDocumentEntry(E,t);this._documents.delete(E,s),s.dispose()}async $resolveWebviewEditor(c,E,n,t,s,d){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);const h=S.ViewColumn.to(s),u=this._extHostWebview.createNewWebview(E,t.webviewOptions,l.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(E,n,t.title,h,t.panelOptions,u),I=k.URI.revive(c);switch(l.type){case 1:{const{document:T}=this.getCustomDocumentEntry(n,I);return l.provider.resolveCustomEditor(T,b,d)}case 0:{const T=this._extHostDocuments.getDocument(I);return l.provider.resolveCustomTextEditor(T,b,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,E,n){this.getCustomDocumentEntry(E,c).disposeEdits(n)}async $onMoveCustomEditor(c,E,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const s=this._extHostWebviewPanels.getWebviewPanel(c);if(!s)throw new Error("No webview found");const d=k.URI.revive(E),l=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(l,s,m.CancellationToken.None)}async $undo(c,E,n,t){return this.getCustomDocumentEntry(E,c).undo(n,t)}async $redo(c,E,n,t){return this.getCustomDocumentEntry(E,c).redo(n,t)}async $revert(c,E,n){const t=this.getCustomDocumentEntry(E,c);await this.getCustomEditorProvider(E).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(c,E,n){const t=this.getCustomDocumentEntry(E,c);await this.getCustomEditorProvider(E).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(c,E,n,t){const s=this.getCustomDocumentEntry(E,c);return this.getCustomEditorProvider(E).saveCustomDocumentAs(s.document,k.URI.revive(n),t)}async $backup(c,E,n){const t=this.getCustomDocumentEntry(E,c),d=await this.getCustomEditorProvider(E).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(d),d.id}getCustomDocumentEntry(c,E){const n=this._documents.get(c,k.URI.revive(E));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(c){const n=this._editorProviders.get(c)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(c){return!!c.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function p(g){return typeof g.resolveCustomTextEditor=="function"}function o(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function r(g){const c=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,L.hash)(c)+""}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[256],pe([0,1,3,6,2,32,16,68,5,7]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";var R,P,a,w,f,v,_,A,p,o,r,g,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends L.Disposable{constructor(d,l,h,u,b,I,T){super();R.set(this,void 0),P.set(this,void 0),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,void 0),_.set(this,void 0),A.set(this,void 0),p.set(this,!0),o.set(this,!0),r.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,g,"f").event,c.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,c,"f").event,ot(this,R,d,"f"),ot(this,P,l,"f"),ot(this,a,h,"f"),ot(this,f,I,"f"),ot(this,A,b,"f"),ot(this,v,u,"f"),ot(this,w,T,"f")}dispose(){Oe(this,r,"f")||(ot(this,r,!0,"f"),Oe(this,g,"f").fire(),Oe(this,P,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,w,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,w,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,a,"f")}get title(){return this.assertNotDisposed(),Oe(this,v,"f")}set title(d){this.assertNotDisposed(),Oe(this,v,"f")!==d&&(ot(this,v,d,"f"),Oe(this,P,"f").$setTitle(Oe(this,R,"f"),d))}get iconPath(){return this.assertNotDisposed(),Oe(this,_,"f")}set iconPath(d){this.assertNotDisposed(),Oe(this,_,"f")!==d&&(ot(this,_,d,"f"),Oe(this,P,"f").$setIconPath(Oe(this,R,"f"),D.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,A,"f")=="number"&&Oe(this,A,"f")<0))return Oe(this,A,"f")}get active(){return this.assertNotDisposed(),Oe(this,o,"f")}get visible(){return this.assertNotDisposed(),Oe(this,p,"f")}_updateViewState(d){Oe(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(ot(this,o,d.active,"f"),ot(this,p,d.visible,"f"),ot(this,A,d.viewColumn,"f"),Oe(this,c,"f").fire({webviewPanel:this}))}reveal(d,l){this.assertNotDisposed(),Oe(this,P,"f").$reveal(Oe(this,R,"f"),{viewColumn:d?i.ViewColumn.from(d):void 0,preserveFocus:!!l})}assertNotDisposed(){if(Oe(this,r,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,_=new WeakMap,A=new WeakMap,p=new WeakMap,o=new WeakMap,r=new WeakMap,g=new WeakMap,c=new WeakMap;class n{constructor(d,l,h){this.webviews=l,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,l,h,u,b={}){const I=typeof u=="object"?u.viewColumn:u,T={viewColumn:i.ViewColumn.from(I),preserveFocus:typeof u=="object"&&!!u.preserveFocus},x=(0,k.shouldSerializeBuffersForPostMessage)(d),O=n.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),O,l,{title:h,panelOptions:t(b),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,b),serializeBuffersForPostMessage:x},T);const F=this.webviews.createNewWebview(O,b,d);return this.createNewWebviewPanel(O,l,h,I,b,F)}$onDidChangeWebviewPanelViewStates(d){const l=Object.keys(d);l.sort((h,u)=>{const b=d[h],I=d[u];return b.active?1:I.active?-1:+b.visible-+I.visible});for(const h of l){const u=this.getWebviewPanel(h);if(!u)continue;const b=d[h];u._updateViewState({active:b.active,visible:b.visible,viewColumn:i.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,l,h){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:h,extension:d}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new y.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(d,l,h,u){const b=this._serializers.get(l);if(!b)throw new Error(`No serializer found for '${l}'`);const{serializer:I,extension:T}=b,x=this.webviews.createNewWebview(d,h.webviewOptions,T),O=this.createNewWebviewPanel(d,l,h.title,u,h.panelOptions,x);await I.deserializeWebviewPanel(O,h.state)}createNewWebviewPanel(d,l,h,u,b,I){const T=new E(d,this._proxy,l,h,u,b,I);return this._webviewPanels.set(d,T),T}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=n;function t(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[257],pe([0,1,3,6,68,5,7]),function(Y,e,m,L,D,C,i){"use strict";var k,S,y,R,P,a,w,f,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends L.Disposable{constructor(r,g,c,E,n,t){super();k.set(this,void 0),S.set(this,void 0),y.set(this,void 0),R.set(this,void 0),P.set(this,!1),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),v.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,v,"f").event,_.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,_,"f").event,ot(this,y,c,"f"),ot(this,w,E,"f"),ot(this,k,r,"f"),ot(this,S,g,"f"),ot(this,R,n,"f"),ot(this,a,t,"f")}dispose(){Oe(this,P,"f")||(ot(this,P,!0,"f"),Oe(this,_,"f").fire(),Oe(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(r){this.assertNotDisposed(),Oe(this,w,"f")!==r&&(ot(this,w,r,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Oe(this,f,"f")}set description(r){this.assertNotDisposed(),Oe(this,f,"f")!==r&&(ot(this,f,r,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,k,"f"),r))}get visible(){return Oe(this,a,"f")}get webview(){return Oe(this,R,"f")}get viewType(){return Oe(this,y,"f")}_setVisible(r){r===Oe(this,a,"f")||Oe(this,P,"f")||(ot(this,a,r,"f"),Oe(this,v,"f").fire())}show(r){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,k,"f"),!!r)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,y=new WeakMap,R=new WeakMap,P=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,v=new WeakMap,_=new WeakMap;class p{constructor(r,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,g,c,E){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:c,extension:r}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(r),g,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new i.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(r,g,c,E,n){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:s,extension:d}=t,l=this._extHostWebview.createNewWebview(r,{},d),h=new A(r,this._proxy,g,c,l,!0);this._webviewViews.set(r,h),await s.resolveWebviewView(h,{state:E},n)}async $onDidChangeWebviewViewVisibility(r,g){this.getWebviewView(r)._setVisible(g)}async $disposeWebviewView(r){const g=this.getWebviewView(r);this._webviewViews.delete(r),g.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const g=this._webviewViews.get(r);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=p}),define(ge[133],pe([0,1,3,5,2,10,8,4,14]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class zi{constructor(P){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,a){let w;if(typeof P=="string"){w=P;try{P=D.URI.parse(P)}catch(f){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,i.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,w,a)}async asExternalUri(P,a){if((0,i.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this._proxy.$asExternalUri(P,a);return D.URI.from(w)}};y.InitialState={focused:!0},y=Ve([He(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ge[258],pe([0,1,9,81,32,38,6,5,2,14]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends i.Disposable{constructor(a,w){super();const f=a.getProxy(k.MainContext.MainThreadDownloadService);w.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=S.URI.file((0,m.join)((0,L.tmpdir)(),(0,D.generateUuid)()));return await f.$download(v,_),_})}};R=Ve([He(0,y.IExtHostRpcService),He(1,C.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(ge[259],pe([0,1,131,10,187,32]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class i extends m.ExtHostLoggerService{doCreateLogger(S,y,R){return S.scheme===L.Schemas.file?new D.SpdLogLogger(R?.name||(0,C.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.doCreateLogger(S,y,R)}}e.ExtHostLoggerService=i}),define(ge[260],pe([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(c){const E=await super._getWorkspaceStorageURI(c);if(E.scheme!==k.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const n=E.fsPath;let t=0;do{let s;t===0?s=n:s=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await P(s);const d=L.join(s,"vscode.lock"),l=await v(this._logService,d,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),D.URI.file(s);t++}while(t<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(g){try{await y.Promises.stat(g);return}catch{}try{await y.Promises.mkdir(g,{recursive:!0})}catch{}}const a=1e3,w=10*60*1e3;class f extends i.Disposable{constructor(c,E){super();this.logService=c,this.filename=E,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await _(c,E);(!n||n.pid!==process.pid)&&(c.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await y.Promises.utimes(E,new Date,new Date)}catch(t){c.error(t),c.info(`Lock '${E}': Could not update mtime.`)}},a)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(c){}}async setWillRelease(c){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${c} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+c};await y.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function v(g,c,E){try{const t={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(c,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const n=await _(g,c);return!n||n.pid!==process.pid?E?(g.info(`Lock '${c}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${c}': Could not acquire lock, checking if the file is stale.`),o(g,c)):(g.info(`Lock '${c}': Lock acquired.`),new f(g,c))}async function _(g,c){let E;try{E=await y.Promises.readFile(c)}catch(n){return g.error(n),null}try{return JSON.parse(String(E))}catch(n){return g.error(n),null}}async function A(g,c){let E;try{E=await y.Promises.stat(c)}catch(n){return g.error(n),0}return E.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch(c){return!1}}async function o(g,c){const E=await _(g,c);if(!E)return g.info(`Lock '${c}': Could not read pid of lock holder.`),r(g,c);if(E.willReleaseAt){let l=E.willReleaseAt-Date.now();if(l<5e3){for(l>0?g.info(`Lock '${c}': The lockfile is scheduled to be released in ${l} ms.`):g.info(`Lock '${c}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,S.timeout)(Math.min(100,l)),await A(g,c)===0)return r(g,c);l=E.willReleaseAt-Date.now()}return r(g,c)}}if(!p(E.pid))return g.info(`Lock '${c}': The pid ${E.pid} appears to be gone.`),r(g,c);const n=await A(g,c),t=Date.now()-n;if(t<=w)return g.info(`Lock '${c}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${c}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const s=await A(g,c),d=Date.now()-s;return d<=w?(g.info(`Lock '${c}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${c}': The lock looks stale even after waiting for 2s.`),r(g,c))}async function r(g,c){g.info(`Lock '${c}': Deleting a stale lock.`);try{await y.Promises.unlink(c)}catch(E){}return v(g,c,!0)}}),define(ge[261],pe([0,1,32,14,34]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,y){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:y})}createTerminalFromOptions(k,S){const y=new D.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(y),y.create(k,this._serializeParentTerminal(k,S)),y.value}};C=Ve([He(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ge[262],pe([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,77,11]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(h,u,b){this.remoteAddress=h,this.localAddress=u,this._dispose=b,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(l){const h=l.trim().split(`
`),u=[];return h.forEach(I=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(I);T&&T.length>=3&&u.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),u.reduce((I,T)=>(I[T.socket]=T,I),{})}e.getSockets=o;function r(...l){const h=[].concat(...l.map(c));return[...new Map(h.filter(u=>u.st==="0A").map(u=>{const b=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:g(b[0]),port:parseInt(b[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=r;function g(l){let h="";if(l.length===8)for(let u=l.length-2;u>=0;u-=2)h+=parseInt(l.substr(u,2),16),u!==0&&(h+=".");else for(let u=l.length-4;u>=0;u-=4)h+=parseInt(l.substr(u,4),16).toString(16),u!==0&&(h+=":");return h}e.parseIpAddress=g;function c(l){const h=l.trim().split(`
`),u=h.shift().trim().split(/\s+/).filter(I=>I!=="rx_queue"&&I!=="tm->when");return h.map(I=>I.trim().split(/\s+/).reduce((T,x,O)=>(T[u[O]||O]=x,T),{}))}e.loadConnectionTable=c;function E(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function n(l){const h=l.trim().split(`
`),u=[];return h.forEach(b=>{const I=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);I&&I.length>=4&&u.push({pid:parseInt(I[1],10),ppid:parseInt(I[2]),cmd:I[3]})}),u}e.getRootProcesses=n;async function t(l,h,u){const b=u.reduce((T,x)=>(T[x.pid]=x,T),{}),I=[];return l.forEach(({socket:T,ip:x,port:O})=>{const F=h[T]?h[T].pid:void 0,W=F?b[F]?.cmd:void 0;F&&W&&!E(W)&&I.push({host:x,port:O,detail:W,pid:F})}),I}e.findPorts=t;function s(l,h,u){const b=new Map,I=n(h);for(const T of l){const x=u.get(T.port);if(x){b.set(T.port,x);continue}const O=I.find(F=>F.cmd.includes(`${T.port}`));if(O){let F=O,W;do W=I.find(M=>M.ppid===F.pid),W&&(F=W);while(W);b.set(T.port,{host:T.ip,port:T.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else b.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=s;let d=class extends C.Disposable{constructor(h,u,b){super();this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=h.getProxy(m.MainContext.MainThreadTunnelService),a.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(h,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(u,h.displayName);if(b){const I=new p(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(I),I}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(h){return Math.max(h*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(h,u){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:h,provider:u}),this._proxy.$registerPortsAttributesProvider(h,b),new P.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(h,u,b,I,T){const x=[];for(const F of h){const W=this._portAttributesProviders.get(F);if(!W)return[];x.push(...await Promise.all(u.map(async M=>W.provider.providePortAttributes(M,b,I,T))))}const O=x.filter(F=>!!F);return O.length>0?O.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(h){if(h&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=h;let u=new _.MovingAverage,b;for(;this._candidateFindingEnabled;){const I=new Date().getTime(),T=(await this.findCandidatePorts()).filter(O=>(0,v.isLocalhost)(O.host)||(0,v.isAllInterfaces)(O.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(O=>O.port).join(", ")}`);const x=new Date().getTime()-I;u.update(x),(!b||JSON.stringify(b)!==JSON.stringify(T))&&(b=T,await this._proxy.$onFoundNewCandidates(b)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(h){if(h){if(h.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this._showCandidatePort=h.showCandidatePort,this._proxy.$setCandidateFilter()),h.tunnelFactory){this._forwardPortProvider=h.tunnelFactory;let u=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(h,u){if(this._extensionTunnels.has(h.host)){const b=this._extensionTunnels.get(h.host);b.has(h.port)&&(u&&b.get(h.port).disposeListener.dispose(),await b.get(h.port).tunnel.dispose(),b.delete(h.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(h,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(h,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const I=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(h.remoteAddress.host)||this._extensionTunnels.set(h.remoteAddress.host,new Map);const T=this._register(I.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(I.remoteAddress))));return this._extensionTunnels.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:I,disposeListener:T}),w.TunnelDto.fromApiTunnel(I)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(h){const u=await Promise.all(h.map(I=>this._showCandidatePort(I.host,I.port,I.detail??""))),b=h.filter((I,T)=>u[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(I=>I.port).join(", ")} to ${b.map(I=>I.port).join(", ")}`),b}async findCandidatePorts(){let h="",u="";try{h=await R.Promises.readFile("/proc/net/tcp","utf8"),u=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const b=r(h,u),I=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,K,N)=>{U(K)})}),T=o(I),x=await R.Promises.readdir("/proc"),O=[];for(let U of x)try{const z=Number(U),K=y.joinPath(k.URI.file("/proc"),U);if((await R.Promises.stat(K.fsPath)).isDirectory()&&!isNaN(z)){const j=await R.Promises.readlink(y.joinPath(K,"cwd").fsPath),H=await R.Promises.readFile(y.joinPath(K,"cmdline").fsPath,"utf8");O.push({pid:z,cwd:j,cmd:H})}}catch(z){}const F=[],W=b.filter(U=>{const z=T[U.socket];return z||F.push(U),z}),M=t(W,T,O);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(K,N,j)=>{z(N)})});this._foundRootPorts=s(F,U,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return M.then(U=>B?U.concat(B):U)}};d=Ve([He(0,L.IExtHostRpcService),He(1,i.IExtHostInitDataService),He(2,A.ILogService)],d),e.ExtHostTunnelService=d}),define(ge[263],pe([0,1,18,22,21,15,3,6,102,227,53]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(b,I){try{return JSON.stringify(b,I)}catch(T){return"null"}}const w="$$ref$$",f={[w]:-1};class v{constructor(I,T){this.jsonString=I,this.referencedBuffers=T}}function _(b,I=null,T=!1){const x=[];return{jsonString:(T?a:JSON.stringify)(b,(F,W)=>{if(typeof W=="undefined")return f;if(typeof W=="object"){if(W instanceof L.VSBuffer){const M=x.push(W)-1;return{[w]:M}}if(I)return I(F,W)}return W}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=_;function A(b,I,T){return JSON.parse(b,(x,O)=>{if(O){const F=O[w];if(typeof F=="number")return I[F];if(T&&O.$mid===1)return T.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=A;function p(b,I){return JSON.stringify(b,I)}function o(b){return b?(I,T)=>T&&T.$mid===1?b.transformOutgoing(T):T:null}var r;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const c=()=>{},E=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(I,T=null,x=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new i.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=T,this._uriTransformer=x,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,F=R.ProxyIdentifier.count;O<F;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,S.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:T,sid:x}=I;return this._proxies[T]||(this._proxies[T]=this._createProxy(T,x)),this._proxies[T]}_createProxy(I,T){let x={get:(O,F)=>(typeof F=="string"&&!O[F]&&F.charCodeAt(0)===36&&(O[F]=(...W)=>this._remoteCall(I,F,W)),F===n?T:O[F])};return new Proxy(Object.create(null),x)}set(I,T){return this._locals[I.nid]=T,T}assertRegistered(I){for(let T=0,x=I.length;T<x;T++){const O=I[T];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const T=I.byteLength,x=s.read(I,0),O=x.readUInt8(),F=x.readUInt32();switch(O){case 1:case 2:{let{rpcId:W,method:M,args:B}=l.deserializeRequestJSONArgs(x);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(T,F,W,M,B,O===2);break}case 3:case 4:{let{rpcId:W,method:M,args:B}=l.deserializeRequestMixedArgs(x);this._uriTransformer&&(B=(0,S.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(T,F,W,M,B,O===4);break}case 5:{this._logger&&this._logger.logIncoming(T,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(T,F);break}case 7:{this._receiveReply(T,F,void 0);break}case 9:{let W=l.deserializeReplyOKJSON(x);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply(T,F,W);break}case 10:{const W=l.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(T,F,W);break}case 8:{let W=l.deserializeReplyOKVSBuffer(x);this._receiveReply(T,F,W);break}case 11:{let W=l.deserializeReplyErrError(x);this._uriTransformer&&(W=(0,S.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr(T,F,W);break}case 12:{this._receiveReplyErr(T,F,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,T,x,O,F,W){this._logger&&this._logger.logIncoming(I,T,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(x)}.${O}(`,F);const M=String(T);let B,U;if(W){const K=new D.CancellationTokenSource;F.push(K.token),B=this._invokeHandler(x,O,F),U=()=>K.cancel()}else B=this._invokeHandler(x,O,F),U=c;this._cancelInvokedHandlers[M]=U;const z=l.serializeAcknowledged(T);this._logger&&this._logger.logOutgoing(z.byteLength,T,1,"ack"),this._protocol.send(z),B.then(K=>{delete this._cancelInvokedHandlers[M];const N=l.serializeReplyOK(T,K,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,T,1,"reply:",K),this._protocol.send(N)},K=>{delete this._cancelInvokedHandlers[M];const N=l.serializeReplyErr(T,K);this._logger&&this._logger.logOutgoing(N.byteLength,T,1,"replyErr:",K),this._protocol.send(N)})}_receiveCancel(I,T){this._logger&&this._logger.logIncoming(I,T,1,"receiveCancel");const x=String(T);this._cancelInvokedHandlers[x]&&this._cancelInvokedHandlers[x]()}_receiveReply(I,T,x){this._logger&&this._logger.logIncoming(I,T,0,"receiveReply:",x);const O=String(T);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const F=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],F.resolveOk(x)}_receiveReplyErr(I,T,x){this._logger&&this._logger.logIncoming(I,T,0,"receiveReplyErr:",x);const O=String(T);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const F=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let W;x&&(x.$isError?(W=new Error,W.name=x.name,W.message=x.message,W.stack=x.stack):W=x),F.resolveErr(W)}_invokeHandler(I,T,x){try{return Promise.resolve(this._doInvokeHandler(I,T,x))}catch(O){return Promise.reject(O)}}_doInvokeHandler(I,T,x){const O=this._locals[I];if(!O)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(I));let F=O[T];if(typeof F!="function")throw new Error("Unknown method "+T+" on actor "+(0,R.getStringIdentifierForProxy)(I));return F.apply(O,x)}_remoteCall(I,T,x){if(this._isDisposed)return Promise.reject(C.canceled());let O=null;if(x.length>0&&D.CancellationToken.isCancellationToken(x[x.length-1])&&(O=x.pop()),O&&O.isCancellationRequested)return Promise.reject(C.canceled());const F=l.serializeRequestArguments(x,this._uriReplacer),W=++this._lastMessageId,M=String(W),B=new y.LazyPromise;O&&O.onCancellationRequested(()=>{const z=l.serializeCancel(W);this._logger&&this._logger.logOutgoing(z.byteLength,W,0,"cancel"),this._protocol.send(l.serializeCancel(W))}),this._pendingRPCReplies[M]=B,this._onWillSendRequest(W);const U=l.serializeRequest(W,I,T,F,!!O);return this._logger&&this._logger.logOutgoing(U.byteLength,W,0,`request: ${(0,R.getStringIdentifierForProxy)(I)}.${T}(`,x),this._protocol.send(U),B}}e.RPCProtocol=t,P=E,t.UNRESPONSIVE_TIME=3*1e3;class s{constructor(I,T){this._buff=I,this._offset=T}static alloc(I,T,x){let O=new s(L.VSBuffer.alloc(x+1+4),0);return O.writeUInt8(I),O.writeUInt32(T),O}static read(I,T){return new s(I,T)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,x}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,x}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const T=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,T}static sizeMixedArray(I){let T=0;T+=1;for(let x=0,O=I.length;x<O;x++){const F=I[x];switch(T+=1,F.type){case 1:T+=this.sizeLongString(F.value);break;case 2:T+=this.sizeVSBuffer(F.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(F.value);for(let W=0;W<F.buffers.length;++W)T+=this.sizeVSBuffer(F.buffers[W]);break;case 4:break}}return T}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let T=0,x=I.length;T<x;T++){const O=I[T];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let F=0;F<O.buffers.length;++F)this.writeBuffer(O.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let T=new Array(I);for(let x=0;x<I;x++)switch(this.readUInt8()){case 1:T[x]=this.readLongString();break;case 2:T[x]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),W=this.readLongString(),M=[];for(let B=0;B<F;++B)M.push(this.readVSBuffer());T[x]=new R.SerializableObjectWithBuffers(A(W,M,null));break;case 4:T[x]=void 0;break}return T}}s.sizeUInt32=4;var d;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(d||(d={}));class l{static _useMixedArgSerialization(I){for(let T=0,x=I.length;T<x;T++)if(I[T]instanceof L.VSBuffer||I[T]instanceof R.SerializableObjectWithBuffers||typeof I[T]=="undefined")return!0;return!1}static serializeRequestArguments(I,T){if(this._useMixedArgSerialization(I)){const x=[];for(let O=0,F=I.length;O<F;O++){const W=I[O];if(W instanceof L.VSBuffer)x[O]={type:2,value:W};else if(typeof W=="undefined")x[O]={type:4};else if(W instanceof R.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=_(W.value,T);x[O]={type:3,value:L.VSBuffer.fromString(M),buffers:B}}else x[O]={type:1,value:L.VSBuffer.fromString(p(W,T))}}return{type:1,args:x}}return{type:0,args:p(I,T)}}static serializeRequest(I,T,x,O,F){switch(O.type){case 0:return this._requestJSONArgs(I,T,x,O.args,F);case 1:return this._requestMixedArgs(I,T,x,O.args,F)}}static _requestJSONArgs(I,T,x,O,F){const W=L.VSBuffer.fromString(x),M=L.VSBuffer.fromString(O);let B=0;B+=s.sizeUInt8(),B+=s.sizeShortString(W),B+=s.sizeLongString(M);let U=s.alloc(F?2:1,I,B);return U.writeUInt8(T),U.writeShortString(W),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(I){const T=I.readUInt8(),x=I.readShortString(),O=I.readLongString();return{rpcId:T,method:x,args:JSON.parse(O)}}static _requestMixedArgs(I,T,x,O,F){const W=L.VSBuffer.fromString(x);let M=0;M+=s.sizeUInt8(),M+=s.sizeShortString(W),M+=s.sizeMixedArray(O);let B=s.alloc(F?4:3,I,M);return B.writeUInt8(T),B.writeShortString(W),B.writeMixedArray(O),B.buffer}static deserializeRequestMixedArgs(I){const T=I.readUInt8(),x=I.readShortString(),O=I.readMixedArray(),F=new Array(O.length);for(let W=0,M=O.length;W<M;W++){const B=O[W];typeof B=="string"?F[W]=JSON.parse(B):F[W]=B}return{rpcId:T,method:x,args:F}}static serializeAcknowledged(I){return s.alloc(5,I,0).buffer}static serializeCancel(I){return s.alloc(6,I,0).buffer}static serializeReplyOK(I,T,x){if(typeof T=="undefined")return this._serializeReplyOKEmpty(I);if(T instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(I,T);if(T instanceof R.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:F}=_(T.value,x,!0);return this._serializeReplyOKJSONWithBuffers(I,O,F)}else return this._serializeReplyOKJSON(I,a(T,x))}static _serializeReplyOKEmpty(I){return s.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,T){let x=0;x+=s.sizeVSBuffer(T);let O=s.alloc(8,I,x);return O.writeVSBuffer(T),O.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,T){const x=L.VSBuffer.fromString(T);let O=0;O+=s.sizeLongString(x);let F=s.alloc(9,I,O);return F.writeLongString(x),F.buffer}static _serializeReplyOKJSONWithBuffers(I,T,x){const O=L.VSBuffer.fromString(T);let F=0;F+=s.sizeUInt32,F+=s.sizeLongString(O);for(const M of x)F+=s.sizeVSBuffer(M);let W=s.alloc(10,I,F);W.writeUInt32(x.length),W.writeLongString(O);for(const M of x)W.writeBuffer(M);return W.buffer}static deserializeReplyOKJSON(I){const T=I.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(I,T){const x=I.readUInt32(),O=I.readLongString(),F=[];for(let W=0;W<x;++W)F.push(I.readVSBuffer());return new R.SerializableObjectWithBuffers(A(O,F,T))}static serializeReplyErr(I,T){return T?this._serializeReplyErrEror(I,T):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,T){const x=L.VSBuffer.fromString(a(C.transformErrorForSerialization(T),null));let O=0;O+=s.sizeLongString(x);let F=s.alloc(11,I,O);return F.writeLongString(x),F.buffer}static deserializeReplyErrError(I){const T=I.readLongString();return JSON.parse(T)}static _serializeReplyErrEmpty(I){return s.alloc(12,I,0).buffer}}var h;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var u;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(u||(u={}))}),define(ge[264],pe([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(ge[265],pe([0,1,10,9,12,2,4,62,43,222,264]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,i.createDecorator)("pathService");let P=class Vi{constructor(w,f,v,_){this.localUserHome=w,this.remoteAgentService=f,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||w})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(w,f){if(w.remoteAuthority)return m.Schemas.vscodeRemote;const v=(0,k.getVirtualWorkspaceScheme)(f.getWorkspace());if(v)return v;const _=f.getWorkspace().folders[0];if(_)return _.uri.scheme;const A=f.getWorkspace().configuration;return A?A.scheme:m.Schemas.file}async userHome(w){return w?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(w=>w===1?L.win32:L.posix)}async fileURI(w){let f="";if(await this.resolveOS===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const _=w.indexOf("/",2);_===-1?(f=w.substring(2),w="/"):(f=w.substring(2,_),w=w.substring(_)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:f,path:w,query:"",fragment:""})}};P=Ve([He(1,R.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(ge[69],pe([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(i,k){this.line=i,this.character=k}isBefore(i){return!1}isBeforeOrEqual(i){return!1}isAfter(i){return!1}isAfterOrEqual(i){return!1}isEqual(i){return!1}compareTo(i){return 0}translate(i,k){return new m(0,0)}with(i){return new m(0,0)}}e.Position=m;class L{constructor(i,k,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(i,k),this.end=new m(S,y)}contains(i){return!1}isEqual(i){return!1}intersection(i){}union(i){return new L(0,0,0,0)}with(i){return new L(0,0,0,0)}}e.Range=L;var D;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[33],pe([0,1,17,31,25,30,8,4,9,15,69,13]),function(Y,e,m,L,D,C,i,k,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",w=" characters skipped \u27EB",f=(a.length+w.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var v;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var _;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function A(z){return!!z.preview}e.resultIsMatch=A;function p(z){return!!z.resource}e.isFileMatch=p;function o(z){return!!z.message}e.isProgressMessage=o;var r;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(K){this.resource=K,this.results=[]}}e.FileMatch=g;class c{constructor(K,N,j){this.ranges=N;const H=Array.isArray(N)?N:[N];if(j&&j.matchLines===1&&E(H)){K=(0,i.getNLines)(K,j.matchLines);let V="",q=0,te=0;const fe=Math.floor(j.charsPerLine/5),Ce=[];for(const ke of H){const Ue=Math.max(ke.startColumn-fe,0),xe=ke.startColumn+j.charsPerLine;if(Ue>te+fe+f){const ze=a+(Ue-te)+w;V+=ze+K.slice(Ue,xe),q+=Ue-(te+ze.length)}else V+=K.slice(te,xe);Ce.push(new t(0,ke.startColumn-q,ke.endColumn-q)),te=xe}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:K,matches:(0,m.mapArrayOrNot)(N,q=>new n(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=c;function E(z){const K=z[0].startLineNumber;for(const N of z)if(N.startLineNumber!==K||N.endLineNumber!==K)return!1;return!0}class n{constructor(K,N,j,H){this.startLineNumber=K,this.startColumn=N,this.endLineNumber=j,this.endColumn=H}}e.SearchRange=n;class t extends n{constructor(K,N,j){super(K,N,K,j)}}e.OneLineRange=t;var s;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function d(z,K=!0){const N=z&&z.files&&z.files.exclude,j=K&&z&&z.search&&z.search.exclude;if(!N&&!j)return;if(!N||!j)return N||j;let H=Object.create(null);return H=D.mixin(H,D.deepClone(N)),H=D.mixin(H,D.deepClone(j),!0),H}e.getExcludes=d;function l(z,K){return z.excludePattern&&L.match(z.excludePattern,K)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&L.match(z.includePattern,K)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(N=>{const j=N.folder.fsPath;if(C.isEqualOrParent(K,j)){const H=S.relative(j,K);return!N.includePattern||!!L.match(N.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var h;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(K,N){super(K);this.code=N}}e.SearchError=u;function b(z){const K=z.message;if((0,y.isPromiseCanceledError)(z))return new u(K,h.canceled);try{const N=JSON.parse(K);return new u(N.message,N.code)}catch(N){return new u(K,h.other)}}e.deserializeSearchError=b;function I(z){const K={message:z.message,code:z.code};return new Error(JSON.stringify(K))}e.serializeSearchError=I;function T(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=T;function x(z){return z.type==="success"}e.isSerializedSearchSuccess=x;function O(z){return!!z.path}e.isSerializedFileMatch=O;function F(z,K){const N=z.searchPath?z.searchPath:z.relativePath;return(0,i.fuzzyContains)(N,K)}e.isFilePatternMatch=F;class W{constructor(K){this.path=K,this.results=[]}addMatch(K){this.results.push(K)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function M(z,K){const N={...z||{},...K||{}};return Object.keys(N).filter(j=>{const H=N[j];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class B{constructor(K,N){this._parsedIncludeExpression=null,this._excludeExpression={...K.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=K.includePattern;N.includePattern&&(j?j={...j,...N.includePattern}:j=N.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}matchesExcludesSync(K,N,j){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,j))}includedInQuerySync(K,N,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(K,N,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(K,N,j))}includedInQuery(K,N,j){const H=this._parsedExcludeExpression(K,N,j),V=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(K,N,j):!0;return(0,P.isPromise)(H)?H.then(q=>q?!1:V()):V()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=B;function U(z){for(const K in z)if(typeof z[K]!="boolean")return!0;return!1}}),define(ge[35],pe([0,1,17,18,21,3,24,10,77,23,8,13,2,168,4,11,188,43,44,26,14,7,33,5]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o,r,g,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(I,T,x){return new y.ExtUri(O=>l(O,x)).isEqual(I,T)}function t(I,T,x){return n(I.uri,T.uri,x)?0:(0,R.compare)(I.uri.toString(),T.uri.toString())}function s(I,T,x){return I.index!==T.index?I.index<T.index?-1:1:n(I.uri,T.uri,x)?(0,R.compare)(I.name,T.name):(0,R.compare)(I.uri.toString(),T.uri.toString())}function d(I,T,x,O){const F=I.slice(0).sort((M,B)=>x(M,B,O)),W=T.slice(0).sort((M,B)=>x(M,B,O));return(0,m.delta)(F,W,(M,B)=>x(M,B,O))}function l(I,T){const x=T.getCapabilities(I.scheme);return!(x&&x&1024)}class h extends A.Workspace{constructor(T,x,O,F,W,M,B){super(T,O.map(U=>new A.WorkspaceFolder(U)),F,W,B);this._name=x,this._isUntitled=M,this._workspaceFolders=[],this._structure=i.TernarySearchTree.forUris(B),O.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(T,x,O,F){if(!T)return{workspace:null,added:[],removed:[]};const{id:W,name:M,folders:B,configuration:U,transient:z,isUntitled:K}=T,N=[],j=x;x?B.forEach((te,fe)=>{const Ce=a.URI.revive(te.uri),ke=h._findFolder(O||x,Ce,F);ke?(ke.name=te.name,ke.index=te.index,N.push(ke)):N.push({uri:Ce,name:te.name,index:fe})}):N.push(...B.map(({uri:te,name:fe,index:Ce})=>({uri:a.URI.revive(te),name:fe,index:Ce}))),N.sort((te,fe)=>te.index<fe.index?-1:1);const H=new h(W,M,N,!!z,U?a.URI.revive(U):null,!!K,te=>l(te,F)),{added:V,removed:q}=d(j?j.workspaceFolders:[],H.workspaceFolders,t,F);return{workspace:H,added:V,removed:q}}static _findFolder(T,x,O){for(let F=0;F<T.folders.length;F++){const W=T.workspaceFolders[F];if(n(W.uri,x,O))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(T,x){return x&&this._structure.get(T)&&(T=(0,y.dirname)(T)),this._structure.findSubstr(T)}resolveWorkspaceFolder(T){return this._structure.get(T)}}let u=class{constructor(T,x,O,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=T.getProxy(E.MainContext.MainThreadWorkspace),this._messageService=T.getProxy(E.MainContext.MainThreadMessageService);const W=x.workspace;this._confirmedWorkspace=W?new h(W.id,W.name,[],!!W.transient,W.configuration?a.URI.revive(W.configuration):null,!!W.isUntitled,M=>l(M,O)):void 0}$initializeWorkspace(T,x){this._trusted=x,this.$acceptWorkspaceData(T),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:k.Schemas.untitled,path:(0,y.basename)((0,y.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(T,x,O,...F){const W=[];if(Array.isArray(F)&&F.forEach(K=>{a.URI.isUri(K.uri)&&!W.some(N=>n(N.uri,K.uri,this._extHostFileSystemInfo))&&W.push({uri:K.uri,name:K.name||(0,y.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[x,O].some(K=>typeof K!="number"||K<0)||O===0&&W.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+O>M.length)return!1;const B=M.slice(0);B.splice(x,O,...W.map(K=>({uri:K.uri,name:K.name||(0,y.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<B.length;K++){const N=B[K];if(B.some((j,H)=>H!==K&&n(N.uri,j.uri,this._extHostFileSystemInfo)))return!1}B.forEach((K,N)=>K.index=N);const{added:U,removed:z}=d(M,B,s,this._extHostFileSystemInfo);if(U.length===0&&z.length===0)return!1;if(this._proxy){const K=T.displayName||T.name;this._proxy.$updateWorkspaceFolders(K,x,O,W).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,w.localize)(0,null,K,N.toString()),{extension:T},[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(T,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(T,x)}async getWorkspaceFolder2(T,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(T,x)}async resolveWorkspaceFolder(T){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(T)}getPath(){if(!this._actualWorkspace)return;const{folders:T}=this._actualWorkspace;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,x){let O,F="";if(typeof T=="string"?(O=a.URI.file(T),F=T):typeof T!="undefined"&&(O=T,F=T.fsPath),!O)return F;const W=this.getWorkspaceFolder(O,!0);if(!W)return F;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let M=(0,y.relativePath)(W.uri,O);return x&&W.name&&(M=`${W.name}/${M}`),M}trySetWorkspaceFolders(T){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:T,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:x,added:O,removed:F}=h.toExtHostWorkspace(T,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:F}))}findFiles(T,x,O,F,W=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(x===null?M=!1:x&&(typeof x=="string"?M=x:M=x.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:U}=b(T);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(B),(0,P.withUndefinedAsNull)(U),(0,P.withUndefinedAsNull)(M),(0,P.withUndefinedAsNull)(O),W).then(z=>Array.isArray(z)?z.map(K=>a.URI.revive(K)):[])}async findTextInFiles(T,x,O,F,W=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),B=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:U,folder:z}=b(x.include),K=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,N={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:B,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:U,excludePattern:K},j=!1;if(this._activeSearchCallbacks[M]=H=>{if(j)return;const V=a.URI.revive(H.resource);H.results.forEach(q=>{(0,c.resultIsMatch)(q)?O({uri:V,preview:{text:q.preview.text,matches:(0,m.mapArrayOrNot)(q.preview.matches,te=>new g.Range(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,m.mapArrayOrNot)(q.ranges,te=>new g.Range(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):O({uri:V,text:q.text,lineNumber:q.lineNumber})})},W.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(T,(0,P.withUndefinedAsNull)(z),N,M,W);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(T,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](T)}saveAll(T){return this._proxy.$saveAll(T)}resolveProxy(T){return this._proxy.$resolveProxy(T)}get trusted(){return this._trusted}requestWorkspaceTrust(T){return this._proxy.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([He(0,r.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,p.IExtHostFileSystemInfo),He(3,v.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function b(I){let T,x;return I&&(typeof I=="string"?T=I:(T=I.pattern,x=I.baseFolder||a.URI.file(I.base))),{includePattern:T,folder:x}}}),define(ge[36],pe([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(E,n){if(n){const t=n.split(".");let s=E;for(let d=0;s&&d<t.length;d++)s=s[t[d]];return s}}function _(E){return E instanceof f.URI}function A(E){return E&&E.uri instanceof f.URI&&E.languageId&&typeof E.languageId=="string"}function p(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function o(E){return E&&E.uri instanceof f.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function r(E){if(_(E))return{resource:E};if(A(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(p(E))return{overrideIdentifier:E.languageId};if(o(E))return{resource:E.uri};if(E===null)return{resource:null}}let g=class{constructor(n,t,s){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new c(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(n,t))}};g=Ve([He(0,a.IExtHostRpcService),He(1,D.IExtHostWorkspace),He(2,w.ILogService)],g),e.ExtHostConfiguration=g;class c{constructor(n,t,s,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=n,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,s))}getConfiguration(n,t,s){const d=r(t)||{},l=this._toReadonlyValue(n?v(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,d,s?.identifier);function h(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case i.ConfigurationTarget.Global:return 1;case i.ConfigurationTarget.Workspace:return 4;case i.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(b){return typeof v(l,b)!="undefined"},get:(b,I)=>{this._validateConfigurationAccess(n?`${n}.${b}`:b,d,s?.identifier);let T=v(l,b);if(typeof T=="undefined")T=I;else{let x;const O=(F,W)=>{let M;const B=()=>{x=x||(0,m.deepClone)(l),M=M||v(x,W)};return(0,y.isObject)(F)?new Proxy(F,{get:(U,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>M;if(x)return M=M||v(x,W),M[z];const K=U[z];return typeof z=="string"?O(K,`${W}.${z}`):K},set:(U,z,K)=>(B(),M&&(M[z]=K),!0),deleteProperty:(U,z)=>(B(),M&&delete M[z],!0),defineProperty:(U,z,K)=>(B(),M&&Object.defineProperty(M,z,K),!0)}):F};T=O(T,b)}return T},update:(b,I,T,x)=>{b=n?`${n}.${b}`:b;const O=h(T);return I!==void 0?this._proxy.$updateConfigurationOption(O,b,I,d,x):this._proxy.$removeConfigurationOption(O,b,d,x)},inspect:b=>{b=n?`${n}.${b}`:b;const I=(0,m.deepClone)(this._configuration.inspect(b,d,this._extHostWorkspace.workspace));if(I)return{key:b,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof l=="object"&&(0,m.mixin)(u,l,!1),Object.freeze(u)}_toReadonlyValue(n){const t=s=>(0,y.isObject)(s)?new Proxy(s,{get:(d,l)=>t(d[l]),set:(d,l,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(d,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(d,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return t(n)}_validateConfigurationAccess(n,t,s){const d=S.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),l=s?`[${s.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const s=new k.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,l)=>s.affectsConfiguration(d,r(l))})}_toMap(n){return n.reduce((t,s)=>(t.set(s[0],s[1]),t),new Map)}}e.ExtHostConfigProvider=c,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[70],pe([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o,r){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var c;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(c=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(W){function M(z){if(z){const K=z;return K&&!!K.process}else return!1}W.is=M;function B(z){if(z==null)return;const K={process:z.process,args:z.args};return z.options&&(K.options=n.from(z.options)),K}W.from=B;function U(z){if(z!=null)return new i.ProcessExecution(z.process,z.args,z.options)}W.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(W){function M(U){if(U!=null)return U}W.from=M;function B(U){if(U!=null)return U}W.to=B})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(W){function M(z){if(z){const K=z;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=M;function B(z){if(z==null)return;const K={};return z.commandLine!==void 0?K.commandLine=z.commandLine:(K.command=z.command,K.args=z.args),z.options&&(K.options=s.from(z.options)),K}W.from=B;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new i.ShellExecution(z.commandLine,z.options):new i.ShellExecution(z.command,z.args?z.args:[],z.options)}W.to=U})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(W){function M(z){if(z){let K=z;return K&&K.customExecution==="customExecution"}else return!1}W.is=M;function B(z){return{customExecution:"customExecution"}}W.from=B;function U(z,K){return K.get(z)}W.to=U})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(W){function M(B,U){let z;return B.scope!==void 0&&typeof B.scope!="number"?z=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===i.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=o.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:z}}W.from=M})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(W){function M(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}W.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var b;(function(W){function M(z,K){if(z==null)return[];const N=[];for(let j of z){const H=B(j,K);H&&N.push(H)}return N}W.fromMany=M;function B(z,K){if(z==null)return;let N;z.execution instanceof i.ProcessExecution?N=t.from(z.execution):z.execution instanceof i.ShellExecution?N=d.from(z.execution):z.execution&&z.execution instanceof i.CustomExecution&&(N=l.from(z.execution));const j=c.from(z.definition);let H;return z.scope?typeof z.scope=="number"?H=z.scope:H=z.scope.uri:H=i.TaskScope.Workspace,!j||!H?void 0:{_id:z._id,definition:j,name:z.name,source:{extensionId:K.identifier.value,label:z.source,scope:H},execution:N,isBackground:z.isBackground,group:u.from(z.group),presentationOptions:E.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}W.from=B;async function U(z,K,N){if(z==null)return;let j;t.is(z.execution)?j=t.to(z.execution):d.is(z.execution)?j=d.to(z.execution):l.is(z.execution)&&(j=l.to(z._id,N));const H=c.to(z.definition);let V;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?V=z.source.scope:V=await K.resolveWorkspaceFolder(m.URI.revive(z.source.scope)):V=i.TaskScope.Workspace),!H||!V)return;const q=new i.Task(H,V,z.name,z.source.label,j,z.problemMatchers);return z.isBackground!==void 0&&(q.isBackground=z.isBackground),z.group!==void 0&&(q.group=i.TaskGroup.from(z.group._id),q.group&&z.group.isDefault&&(q.group=new i.TaskGroup(q.group.id,q.group.label),z.group.isDefault&&(q.group.isDefault=z.group.isDefault))),z.presentationOptions&&(q.presentationOptions=E.to(z.presentationOptions)),z._id&&(q._id=z._id),z.detail&&(q.detail=z.detail),q}W.to=U})(b=e.TaskDTO||(e.TaskDTO={}));var I;(function(W){function M(U){return U}W.from=M;function B(U){if(!!U)return Object.assign(Object.create(null),U)}W.to=B})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(M,B,U){this._id=B,this._task=U,g.set(this,void 0),ot(this,g,M,"f")}get task(){return this._task}terminate(){Oe(this,g,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}g=new WeakMap;var x;(function(W){function M(B){return{id:B._id,task:void 0}}W.from=M})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(M,B,U,z,K,N,j,H){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=z,this._configurationService=K,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,B,U){if(!U)return new i.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:B,provider:U,extension:M}),this._proxy.$registerTaskProvider(z,B),new i.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(M,B){this._proxy.$registerTaskSystem(M,B)}fetchTasks(M){return this._proxy.$fetchTasks(I.from(M)).then(async B=>{const U=[];for(let z of B){const K=await b.to(z,this._workspaceProvider,this._providedCustomExecutions2);K&&U.push(K)}return U})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(B=>M.push(B)),M}terminateTask(M){if(!(M instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,B,U){const z=this._providedCustomExecutions2.get(M.id);z&&(this._activeCustomExecutions2.set(M.id,z),this._terminalService.attachPtyToTerminal(B,await z.callback(U))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const B=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const B=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:B,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const B=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:M.exitCode})}$provideTasks(M,B){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));const z=[],K=(0,L.asPromise)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal(B,z,U,N));return new Promise(N=>{K.then(j=>{Promise.all(z).then(()=>{N(j)})})})}async $resolveTask(M,B){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(B.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await b.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const K=await U.provider.resolveTask(z,R.CancellationToken.None);if(!K)return;this.checkDeprecation(K,U);const N=b.from(K,U.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(N.execution)&&await this.addCustomExecution(N,K,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,B,U){const z=await this._proxy.$createTaskId(M);!U&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,B.execution)),this._providedCustomExecutions2.set(z,B.execution)}async getTaskExecution(M,B){if(typeof M=="string"){const K=this._taskExecutionPromises.get(M);if(!K)throw new Error("Unexpected: The specified task is missing an execution");return K}let U=this._taskExecutionPromises.get(M.id);if(U)return U;const z=new Promise((K,N)=>{function j(H,V,q){q?K(new T(H,V.id,q)):N("Unexpected: Task does not exist.")}B?j(this,M,B):b.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(H=>j(this,M,H))});return this._taskExecutionPromises.set(M.id,z),z.then(K=>(this._taskExecutions.set(M.id,K),K),K=>Promise.reject(K))}checkDeprecation(M,B){M._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let U=this._notProvidedCustomExecutions.values(),z=U.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=U.next()}};O=Ve([He(0,a.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,A.ILogService),He(7,p.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let F=class extends O{constructor(M,B,U,z,K,N,j,H){super(M,B,U,z,K,N,j,H);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(M,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const U=b.from(B,M);if(U===void 0)throw new Error("Task is not valid");if(l.is(U.execution))await this.addCustomExecution(U,B,!1);else throw new r.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),B);return this._proxy.$executeTask(U).catch(K=>{throw new Error(K)}),z}provideTasksInternal(M,B,U,z){const K=[];if(z)for(let N of z){this.checkDeprecation(N,U),(!N.definition||!M[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const j=b.from(N,U.extension);j&&l.is(j.execution)?(K.push(j),B.push(this.addCustomExecution(j,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:U.extension}}async resolveTaskInternal(M){if(l.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,B,U){}};F=Ve([He(0,a.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,A.ILogService),He(7,p.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ge[266],pe([0,1,17,73,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,33]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(h,u,b,I){this.configurationService=h,this.workspaceContextService=u,this.editorGroupsService=b,this.pathService=I}text(h,u,b={}){h=this.getContentPattern(h,b);const I=this.configurationService.getValue(),T=u&&u.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(u?.map(_.toWorkspaceFolder),b),type:2,contentPattern:h,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:I.search.usePCRE2||T||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}getContentPattern(h,u){const b=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const I={...h,wordSeparators:b.editor.wordSeparators};return this.isCaseSensitive(h,u)&&(I.isCaseSensitive=!0),this.isMultiline(h)&&(I.isMultiline=!0),I}file(h,u={}){return{...this.commonQuery(h,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(h,u){return h?(h=Array.isArray(h)?h.map(t):t(h),u?this.parseSearchPaths(h):{pattern:c(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],u={}){const b=this.handleIncludeExclude(u.includePattern,u.expandPatterns),I=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),T=h.length>1,x=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,u,I)):h.map(W=>this.getFolderQueryForRoot(W,u,I,T))).filter(W=>!!W),O={_reason:u._reason,folderQueries:x,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:I.pattern,includePattern:b.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(z=>z.resource)))).filter(U=>(0,o.pathIncludedInQuery)(O,U.fsPath)),B=this.commonQueryFromFileList(M);return{...O,...B}}const F=u.extraFileResources&&u.extraFileResources.filter(W=>(0,o.pathIncludedInQuery)(O,W.fsPath));return O.extraFileResources=F&&F.length?F:void 0,O}commonQueryFromFileList(h){const u=[],b=new i.ResourceMap,I={};let T=!1;return h.forEach(x=>{if(x.scheme===k.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(x)){const F=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let W=b.get(F);W||(T=!0,W={folder:F,includePattern:{}},u.push(W),b.set(F,W));const M=S.relative(F.fsPath,x.fsPath);(0,P.assertIsDefined)(W.includePattern)[M.replace(/\\/g,"/")]=!0}else x.fsPath&&(T=!0,I[x.fsPath]=!0)}),{folderQueries:u,includePattern:I,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}isCaseSensitive(h,u){if(u.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,w.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const u=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),I=(Array.isArray(h)?h:E(h)).map(B=>{const U=this.pathService.resolvedUserHome;return U?(0,C.untildify)(B,U.scheme===k.Schemas.file?U.fsPath:U.path):B}),T=L.groupBy(I,B=>u(B)?"searchPaths":"exprSegments"),x=(T.exprSegments||[]).map(B=>R.rtrim(B,"/")).map(B=>R.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),n(B))),O={},F=this.expandSearchPathPatterns(T.searchPaths||[]);F&&F.length&&(O.searchPaths=F);const W=m.flatten(x),M=c(...W);return M&&(O.pattern=M),O}getExcludesForFolder(h,u){return u.disregardExcludeSettings?void 0:(0,o.getExcludes)(h,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const u=m.flatten(h.map(I=>{let{pathPortion:T,globPortion:x}=g(I);x&&(x=s(x));const O=this.expandOneSearchPath(T);return m.flatten(O.map(F=>this.resolveOneSearchPathPattern(F,x)))})),b=new Map;return u.forEach(I=>{const T=I.searchPath.toString(),x=b.get(T);x?I.pattern&&(x.pattern=x.pattern||{},x.pattern[I.pattern]=!0):b.set(T,{searchPath:I.searchPath,pattern:I.pattern?c(I.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:h})}]:[{searchPath:a.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=t(h),h.startsWith("../")||h===".."){const I=S.posix.resolve(u.path,h);return[{searchPath:u.with({path:I})}]}const b=s(h);return[{searchPath:u,pattern:b}]}else{if(h==="./"||h===".\\")return[];{const u=h.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(T=>{const x=u.match(new RegExp(`^${R.escapeRegExpCharacters(T.name)}(?:/(.*)|$)`));return x?{match:x,folder:T}:null}).filter(P.isDefined);if(I.length)return I.map(T=>{const x=T.match[1];return{searchPath:T.folder.uri,pattern:x&&s(x)}});{const T=h.match(/\.[\/\\](.+)[\/\\]?/),x=T?T[1]:h,O=f.localize(0,null,x);throw new Error(O)}}}}resolveOneSearchPathPattern(h,u){const b=h.pattern&&u?`${h.pattern}/${u}`:h.pattern||u,I=[{searchPath:h.searchPath,pattern:b}];return b&&!b.endsWith("**")&&I.push({searchPath:h.searchPath,pattern:b+"/**"}),I}getFolderQueryForSearchPath(h,u,b){const I=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(h.searchPath),u,b,!1);return I?{...I,includePattern:h.pattern}:null}getFolderQueryForRoot(h,u,b,I){let T;const x=a.URI.isUri(h)?h:h.uri;if(b.searchPaths){const B=b.searchPaths.filter(U=>(0,y.isEqual)(U.searchPath,x))[0];if(B&&!B.pattern)return null;B&&(T=B.pattern)}const O=this.configurationService.getValue({resource:x}),W={...this.getExcludesForFolder(O,u)||{},...T||{}},M=a.URI.isUri(h)?(0,y.basename)(h):h.name;return{folder:x,folderName:I?M:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!O.search.followSymlinks}}};r=Ve([He(0,v.IConfigurationService),He(1,_.IWorkspaceContextService),He(2,A.IEditorGroupsService),He(3,p.IPathService)],r),e.QueryBuilder=r;function g(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const u=h.index,b=l.substr(0,u).match(/[/|\\][^/\\]*$/);if(b){let I=l.substr(0,b.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:l.substr((b.index||0)+1)}}}return{pathPortion:l}}function c(...l){return l.length?l.reduce((h,u)=>(h[u]=!0,h),Object.create(null)):void 0}function E(l){return D.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function n(l){return[`**/${l}/**`,`**/${l}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(l){return l.replace(/\\/g,"/")}function s(l){return t(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(l,h){l=m.distinct(l,I=>I.toString());const u=[],b=h.getWorkspace();return l&&l.forEach(I=>{let T;if(h.getWorkbenchState()===2)T=(0,y.relativePath)(b.folders[0].uri,I),T&&T!=="."&&(T="./"+T);else{const x=h.getWorkspaceFolder(I);if(x){const O=x.name;if(b.folders.filter(W=>W.name===O).length===1){const W=(0,y.relativePath)(x.uri,I);W===""?T=`./${x.name}`:T=`./${x.name}/${W}`}else T=I.fsPath}}T&&u.push(T)}),u}e.resolveResourcesForSearchIncludes=d}),define(ge[267],pe([0,1,23,2,21,15,4,266,33,43]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(v,_){const A=_.activationEvents;if(!A)return Promise.resolve(void 0);const p=[],o=[];for(const t of A)if(/^workspaceContains:/.test(t)){const s=t.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||v.forceUsingSearch?o.push(s):p.push(s)}if(p.length===0&&o.length===0)return Promise.resolve(void 0);let r;const g=new Promise((t,s)=>{r=t}),c=t=>r({activationEvent:t}),E=Promise.all(p.map(t=>a(v,t,c))).then(()=>{}),n=w(v,_.identifier,o,c);return Promise.all([E,n]).then(()=>{r(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function a(v,_,A){for(const p of v.folders)if(await v.exists(m.joinPath(L.URI.revive(p),_))){A(`workspaceContains:${_}`);return}}async function w(v,_,A,p){if(A.length===0)return Promise.resolve(void 0);const o=new D.CancellationTokenSource,r=v.checkExists(v.folders,A,o.token),g=setTimeout(async()=>{o.cancel(),v.logService.info(`Not activating extension '${_.value}': Timed out while searching for 'workspaceContains' pattern ${A.join(",")}`)},R);let c=!1;try{c=await r}catch(E){C.isPromiseCanceledError(E)||C.onUnexpectedError(E)}o.dispose(),clearTimeout(g),c&&p(`workspaceContains:${A.join(",")}`)}function f(v,_,A,p){const o=v.get(i.IInstantiationService),r=v.get(S.ISearchService),c=o.createInstance(k.QueryBuilder).file(_.map(E=>(0,y.toWorkspaceFolder)(L.URI.revive(E))),{_reason:"checkExists",includePattern:A,exists:!0});return r.fileSearch(c,p).then(E=>!!E.limitHit,E=>C.isPromiseCanceledError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=f});var ot=this&&this.__classPrivateFieldSet||function(Y,e,m,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,m):D?D.value=m:e.set(Y,m),m},Oe=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(ge[39],pe([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o,r,g,c,E,n,t,s,d,l,h,u,b,I,T,x,O){"use strict";var F,W,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let B=class ji extends k.Disposable{constructor(N,j,H,V,q,te,fe,Ce,ke,Ue){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=H,this._initData=fe,this._extHostWorkspace=V,this._extHostConfiguration=q,this._logService=te,this._extHostTunnelService=ke,this._extHostTerminalService=Ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new i.Barrier,this._readyToStartExtensionHost=new i.Barrier,this._readyToRunExtensions=new i.Barrier,this._eagerExtensionsActivated=new i.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=N.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(ze=>xe.add(o.ExtensionIdentifier.toKey(ze))),this._activator=this._register(new w.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Q,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,p.transformErrorForSerialization(Q),Z)},actualActivateExtension:async(ze,Q)=>{if(xe.has(o.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Q),new w.HostExtension;const Z=this._registry.getExtensionDescription(ze);return this._activateExtension(Z,Q)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){p.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(q=>q.identifier).filter(q=>this.isActivated(q)).map(q=>this._deactivate(q))}catch(j){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,j){return this._activator.activateByEvent(N,j)}_activateById(N,j){return this._activator.activateById(N,j)}activateByIdWithErrors(N,j){return this._activateById(N,j).then(()=>{const H=this._activator.getActivatedExtension(N);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}async _realPathExtensionUri(N){if(N.scheme!==O.Schemas.file)return N;const j=await this._hostUtils.realpath(N.fsPath);return y.URI.file(j)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const N=S.TernarySearchTree.forUris(j=>C.extUriBiasedIgnorePathCase.ignorePathCasing(j));for(const j of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(j)){const H=await this._realPathExtensionUri(j.extensionLocation);N.set(H,j)}return N})()),this._extensionPathIndex}_deactivate(N){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return j;const H=this._activator.getActivatedExtension(N);if(!H)return j;try{typeof H.module.deactivate=="function"&&(j=Promise.resolve(H.module.deactivate()).then(void 0,V=>(this._logService.error(V),Promise.resolve(void 0))))}catch(V){this._logService.error(V)}try{(0,k.dispose)(H.subscriptions)}catch(V){this._logService.error(V)}return j}async _activateExtension(N,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,j).then(H=>{const V=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,V.codeLoadingTime,V.activateCallTime,V.activateResolvedTime,j),this._logExtensionActivationTimes(N,j,"success",V),H},H=>{throw this._logExtensionActivationTimes(N,j,"failure"),H})}_logExtensionActivationTimes(N,j,H,V){const q=U(N,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...q,...V||{},outcome:H})}_doActivateExtension(N,j){const H=U(N,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const V=this._getEntryPoint(N);if(!V)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${N.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this._logService.flush();const q=new w.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,C.joinPath)(N.extensionLocation,V),q),this._loadExtensionContext(N)]).then(te=>(D.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),ji._callActivate(this._logService,N.identifier,te[0],te[1],q))).then(te=>(D.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),te))}_loadExtensionContext(N){const j=new g.ExtensionGlobalMemento(N,this._storage),H=new g.ExtensionMemento(N.identifier.value,!1,this._storage),V=new x.ExtensionSecrets(N,this._secretState),q=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?c.ExtensionMode.Test:c.ExtensionMode.Development:c.ExtensionMode.Production,te=this._initData.remote.isRemote?c.ExtensionKind.Workspace:c.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([j.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let Ce;return Object.freeze({globalState:j,workspaceState:H,secrets:V,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(ke){return L.join(N.extensionLocation.fsPath,ke)},get storagePath(){return fe._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(N).fsPath},get logPath(){return L.join(fe._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return y.URI.joinPath(fe._initData.logsLocation,N.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(N)},get globalStorageUri(){return fe._storagePath.globalValue(N)},get extensionMode(){return q},get extension(){return Ce===void 0&&(Ce=new z(fe,N.identifier,N,te)),Ce},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(N,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,j,H,V,q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,j,H,V,q).then(te=>new w.ActivatedExtension(!1,null,q.build(),H,te,V.subscriptions))}static _callActivateOptional(N,j,H,V,q){if(typeof H.activate=="function")try{q.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${j.value}`);const te=typeof global=="object"?global:self,fe=H.activate.apply(te,[V]);return q.activateCallStop(),q.activateResolveStart(),Promise.resolve(fe).then(Ce=>(q.activateResolveStop(),Ce))}catch(te){return Promise.reject(te)}else return Promise.resolve(H)}_activateOneStartupFinished(N,j){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:j}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const j of N.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(N,j)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,q=>{this._logService.error(q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(q=>this._handleWorkspaceContainsEagerExtensions(q.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(j),V=Promise.all([N,H]).then(()=>{});return Promise.race([V,(0,i.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),V}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(N,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,j){if(this.isActivated(j.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,V={logService:this._logService,folders:N.map(te=>te.uri),forceUsingSearch:H,exists:te=>this._hostUtils.exists(te.fsPath),checkExists:(te,fe,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(te,fe,Ce)},q=await(0,I.checkActivateWorkspaceContainsExtension)(V,j);if(!!q)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:q.activationEvent}).then(void 0,te=>this._logService.error(te))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:j}=this._initData.environment;if(!N||!j)throw new Error(m.localize(0,null));const H=await this._loadCommonJSModule(null,j,new w.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(m.localize(1,null,j.toString()));return new Promise((V,q)=>{const te=(ke,Ue)=>{ke?q(ke):V(typeof Ue=="number"&&Ue>0?1:0)},fe=(0,C.originalFSPath)(j),Ce=H.run(fe,te);Ce&&Ce.then&&Ce.then(()=>{V(0)}).catch(ke=>{q(ke.toString())})})}async $extensionTestsExit(N){this._logService.info(`Extension host terminating: test runner requested exit with code ${N}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(N,j){return this._resolvers[N]=j,(0,k.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const j=N.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const H=N.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(N,j){const{authorityPrefix:H,resolver:V}=await this._activateAndGetResolver(N);if(!V)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(V)),D.mark(`code/extHost/willResolveAuthority/${H}`);const q=await V.resolve(N,{resolveAttempt:j});D.mark(`code/extHost/didResolveAuthorityOK/${H}`);const te={authority:N,host:q.host,port:q.port,connectionToken:q.connectionToken},fe={extensionHostEnv:q.extensionHostEnv,isTrusted:q.isTrusted,authenticationSession:q.authenticationSessionForInitializingExtensions?{id:q.authenticationSessionForInitializingExtensions.id,providerId:q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:te,options:fe,tunnelInformation:{environmentTunnels:q.environmentTunnels}}}}catch(q){if(D.mark(`code/extHost/didResolveAuthorityError/${H}`),q instanceof c.RemoteAuthorityResolverError)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q}}async $getCanonicalURI(N,j){const{authorityPrefix:H,resolver:V}=await this._activateAndGetResolver(N);if(!V)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const q=y.URI.revive(j);if(typeof V.getCanonicalURI=="undefined")return q;const te=await(0,i.asPromise)(()=>V.getCanonicalURI(q));return te||q}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,j){return j===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(N,!1))}async $activate(N,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,j),!0):!1}async $deltaExtensions(N,j){N.forEach(V=>V.extensionLocation=y.URI.revive(V.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(j.map(async V=>{const q=this._registry.getExtensionDescription(V);q&&H.delete(await this._realPathExtensionUri(q.extensionLocation))})),await Promise.all(N.map(async V=>{const q=await this._realPathExtensionUri(V.extensionLocation);H.set(q,V)})),this._registry.deltaExtensions(N,j),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let j=r.VSBuffer.alloc(N),H=Math.random()%256;for(let V=0;V<N;V++)j.writeUInt8(H,V);return j}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};B=Ve([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,d.IExtHostRpcService),He(3,v.IExtHostWorkspace),He(4,a.IExtHostConfiguration),He(5,R.ILogService),He(6,t.IExtHostInitDataService),He(7,s.IExtensionStoragePaths),He(8,h.IExtHostTunnelService),He(9,u.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function U(K,N){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class z{constructor(N,j,H,V){F.set(this,void 0),W.set(this,void 0),M.set(this,void 0),ot(this,F,N,"f"),ot(this,W,j,"f"),ot(this,M,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=V}get isActive(){return Oe(this,F,"f").isActivated(Oe(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,F,"f").getExtensionExports(Oe(this,M,"f"))}activate(){return Oe(this,F,"f").activateByIdWithErrors(Oe(this,M,"f"),{startup:!1,extensionId:Oe(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,F=new WeakMap,W=new WeakMap,M=new WeakMap}),define(ge[55],pe([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let r=class{constructor(l,h,u,b,I,T){this._workspaceService=h,this._extensionService=u,this._editorsService=b,this._configurationService=I,this._editorTabs=T,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=l.getProxy(i.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(O=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,h){const u=l;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let b=`debug:${encodeURIComponent(u.path||"")}`,I="?";return h&&(b+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),b+=`${I}ref=${u.sourceReference}`,L.URI.parse(b)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const h=[];for(const u of l.getAllExtensionDescriptions())if(u.contributes){const b=u.contributes.debuggers;if(b&&b.length>0)for(const I of b)(0,f.isDebuggerMainContribution)(I)&&h.push(I.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(h=>l.push(h)),l}addBreakpoints(l){this.startBreakpoints();const h=l.filter(I=>{const T=I.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,I),!0)});this.fireBreakpointChanges(h,[],[]);const u=[],b=new Map;for(const I of h)if(I instanceof k.SourceBreakpoint){let T=b.get(I.location.uri.toString());T||(T={type:"sourceMulti",uri:I.location.uri,lines:[]},b.set(I.location.uri.toString(),T),u.push(T)),T.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof k.FunctionBreakpoint&&u.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(l){this.startBreakpoints();const h=l.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],h,[]);const u=h.filter(T=>T instanceof k.SourceBreakpoint).map(T=>T.id),b=h.filter(T=>T instanceof k.FunctionBreakpoint).map(T=>T.id),I=h.filter(T=>T instanceof k.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(u,b,I)}startDebugging(l,h,u){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,h,u){if(!h)return new k.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:b,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,b),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(l,h,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(l,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:b,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,b),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(l,h){if(!h)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:u,factory:h}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==h)})}async $runInTerminal(l,h){return Promise.resolve(void 0)}async $substituteVariables(l,h){if(!this._variableResolver){const[I,T]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,T)}let u;const b=await this.getFolder(l);return b&&(u={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,h)}createDebugAdapter(l,h){if(l.type==="implementation")return new t(l.implementation)}createSignService(){}async $startDASession(l,h){const u=this,b=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const T=this.convertToDto(I),x=this.createDebugAdapter(T,b);if(!x)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const O=x;return this._debugAdapters.set(l,O),this.getDebugAdapterTrackers(b).then(F=>(F&&this._debugAdaptersTrackers.set(l,F),O.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const M=W,B={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);B.body={signature:U},O.sendResponse(B)}else throw new Error("no signer")}catch(U){B.success=!1,B.message=U.message,O.sendResponse(B)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(W),W=(0,f.convertToVSCPaths)(W,!0),u._debugServiceProxy.$acceptDAMessage(l,W)}),O.onError(W=>{F&&F.onError&&F.onError(W),this._debugServiceProxy.$acceptDAError(l,W.name,W.message,W.stack)}),O.onExit(W=>{F&&F.onExit&&F.onExit((0,A.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,A.withNullAsUndefined)(W),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),O.startSession()))})}$sendDAMessage(l,h){h=(0,f.convertToDAPaths)(h,!1);const u=this._debugAdaptersTrackers.get(l);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h);const b=this._debugAdapters.get(l);b&&b.sendMessage(h)}$stopDASession(l){const h=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),h&&h.onWillStopSession&&h.onWillStopSession();const u=this._debugAdapters.get(l);return this._debugAdapters.delete(l),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const h=[],u=[],b=[];if(l.added)for(const I of l.added){const T=I.id;if(T&&!this._breakpoints.has(T)){let x;if(I.type==="function")x=new k.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")x=new k.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const O=L.URI.revive(I.uri);x=new k.SourceBreakpoint(new k.Location(O,new k.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}x._id=T,this._breakpoints.set(T,x),h.push(x)}}if(l.removed)for(const I of l.removed){const T=this._breakpoints.get(I);T&&(this._breakpoints.delete(I),u.push(T))}if(l.changed){for(const I of l.changed)if(I.id){const T=this._breakpoints.get(I.id);if(T){if(T instanceof k.FunctionBreakpoint&&I.type==="function"){const x=T;x.enabled=I.enabled,x.condition=I.condition,x.hitCondition=I.hitCondition,x.logMessage=I.logMessage,x.functionName=I.functionName}else if(T instanceof k.SourceBreakpoint&&I.type==="source"){const x=T;x.enabled=I.enabled,x.condition=I.condition,x.hitCondition=I.hitCondition,x.logMessage=I.logMessage,x.location=new k.Location(L.URI.revive(I.uri),new k.Position(I.line,I.character))}b.push(T)}}}this.fireBreakpointChanges(h,u,b)}$provideDebugConfigurations(l,h,u){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(l);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(h);return b.provideDebugConfigurations(I,u)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(l,h,u,b){return(0,C.asPromise)(async()=>{const I=this.getConfigProviderByHandle(l);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(h);return I.resolveDebugConfiguration(T,u,b)})}$resolveDebugConfigurationWithSubstitutedVariables(l,h,u,b){return(0,C.asPromise)(async()=>{const I=this.getConfigProviderByHandle(l);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(h);return I.resolveDebugConfigurationWithSubstitutedVariables(T,u,b)})}async $provideDebugAdapter(l,h){const u=this.getAdapterDescriptorFactoryByHandle(l);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(h);return this.getAdapterDescriptor(u,b).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(l){const h=await this.getSession(l);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(l){const h=await this.getSession(l);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,h){const u=await this.getSession(l);u&&u._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(l,h){const b={session:await this.getSession(l),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(l){if(l instanceof k.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof k.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const h=this._adapterFactories.filter(u=>u.type===l);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(l){const h=this._adapterFactories.filter(u=>u.handle===l);if(h.length>0)return h[0].factory}getConfigProviderByHandle(l){const h=this._configProviders.filter(u=>u.handle===l);if(h.length>0)return h[0].provider}definesDebugType(l,h){if(l.contributes){const u=l.contributes.debuggers;if(u&&u.length>0){for(const b of u)if(b.label&&b.type&&b.type===h)return!0}}return!1}getDebugAdapterTrackers(l){const u=l.configuration.type,b=this._trackerFactories.filter(I=>I.type===u||I.type==="*").map(I=>(0,C.asPromise)(()=>I.factory.createDebugAdapterTracker(l)).then(T=>T,T=>null));return Promise.race([Promise.all(b).then(I=>{const T=I.filter(x=>!!x);if(T.length>0)return new n(T)}),new Promise((I,T)=>{const x=setTimeout(()=>{clearTimeout(x),T(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(l,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(l){const I=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>l.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,I))).then(T=>{if(T)return T})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,b))}daExecutableFromPackage(l,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,h,u){(l.length>0||h.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:h,changed:u}))}async getSession(l){if(l)if(typeof l=="string"){const h=this._debugSessions.get(l);if(h)return h}else{let h=this._debugSessions.get(l.id);if(!h){const u=await this.getFolder(l.folderUri),b=l.parent?this._debugSessions.get(l.parent):void 0;h=new g(this._debugServiceProxy,l.id,l.type,l.name,u,l.configuration,b),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(l){if(l){const h=L.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};r=Ve([He(0,v.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,w.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class g{constructor(l,h,u,b,I,T,x){this._debugServiceProxy=l,this._id=h,this._type=u,this._name=b,this._workspaceFolder=I,this._configuration=T,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,h)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=g;class c{constructor(l){this.value=Object.freeze({append(h){l.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=c;class E extends a.AbstractVariableResolverService{constructor(l,h,u,b,I){function T(){if(h){const x=h.activeEditor();if(x)return x.document.uri;const O=b.tabs.filter(F=>F.isActive);if(O.length>0){const F=O[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:O[0].resource}}}super({getFolderUri:x=>{const O=l.filter(F=>F.name===x);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(x,O)=>u.getConfiguration(void 0,x).get(O),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=T();if(x)return m.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const x=T();if(x){const O=I.getWorkspaceFolder(x);if(O)return m.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(h){const x=h.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(h){const x=h.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=E;class n{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(h=>h.onError?h.onError(l):void 0)}onExit(l,h){this.trackers.forEach(u=>u.onExit?u.onExit(l,h):void 0)}}class t extends S.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends r{constructor(l,h,u,b,I,T){super(l,h,u,b,I,T)}createVariableResolver(l,h,u){return new E(l,h,u,this._editorTabs)}};s=Ve([He(0,v.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,w.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(ge[268],pe([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(o,r,g,c,E,n,t){this._apiFactory=o,this._extensionRegistry=r,this._instaService=g,this._extHostConfiguration=c,this._extHostExtensionService=E,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,r,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(_,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,r,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let r of o.nodeModuleName)this._factories.set(r,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(r=>o.alternativeModuleName(r))}};f=Ve([He(2,R.IInstantiationService),He(3,C.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,y.IExtHostInitDataService),He(6,w.ILogService)],f),e.RequireInterceptor=f;class v{constructor(o,r,g,c,E){this._apiFactory=o,this._extensionPaths=r,this._extensionRegistry=g,this._configProvider=c,this._logService=E,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,r){const g=this._extensionPaths.findSubstr(r);if(g){let c=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return c||(c=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),c)),c}if(!this._defaultApiImpl){let c="";this._extensionPaths.forEach((E,n)=>c+=`	${n} -> ${E.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${c}`),this._defaultApiImpl=this._apiFactory(i.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(o,r,g){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(D.MainContext.MainThreadTelemetry);const{environment:c}=g,E=r.getProxy(D.MainContext.MainThreadKeytar);if(c.appRoot){let n=c.appRoot.fsPath;a.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>E.$getPassword(n,t),setPassword:(n,t,s)=>E.$setPassword(n,t,s),deletePassword:(n,t)=>E.$deletePassword(n,t),findPassword:n=>E.$findPassword(n),findCredentials(n){return E.$findCredentials(n)}}}load(o,r){const g=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const r=o.length;if(r<=7||!this.alternativeNames)return;const g=r-7;if((o.charAt(g)==="/"||o.charAt(g)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};_=Ve([He(1,S.IExtHostRpcService),He(2,y.IExtHostInitDataService)],_);let A=class{constructor(o,r,g){this._extensionPaths=o,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(D.MainContext.MainThreadTelemetry);const c=g.getProxy(D.MainContext.MainThreadWindow);this._impl=(E,n)=>{const t=L.URI.parse(E);return n?this.callOriginal(E,n):t.scheme==="http"||t.scheme==="https"?c.$openUri(t,E,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?c.$openUri(t,E,{}):this.callOriginal(E,n)}}load(o,r,g){const c=this._extensionPaths.findSubstr(r);return c&&(this._extensionId=c.identifier.value,this.sendShimmingTelemetry()),this._original=g(o),this._impl}callOriginal(o,r){return this.sendNoForwardTelemetry(),this._original(o,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=Ve([He(2,S.IExtHostRpcService)],A)}),define(ge[269],pe([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends a.ExtHostDebugServiceBase{constructor(r,g,c,E,n,t,s){super(r,g,c,E,n,s);this._terminalService=t,this._integratedTerminalInstances=new p}createDebugAdapter(r,g){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,g.type)}return super.createDebugAdapter(r,g)}daExecutableFromPackage(r,g){const c=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(c)return new D.DebugAdapterExecutable(c.command,c.args,c.options)}createSignService(){return new w.SignService}async $runInTerminal(r,g){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(T=>{this._integratedTerminalInstances.onTerminalClosed(T)}));const c=await this._configurationService.getConfigProvider(),E=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=r.title||m.localize(0,null),s=JSON.stringify({shell:E,shellArgs:n});let d=await this._integratedTerminalInstances.checkout(s,t),l,h=!1;if(d)l=r.cwd;else{const T={shellPath:E,shellArgs:n,cwd:r.cwd,name:t,iconPath:new D.ThemeIcon("debug")};h=!0,d=this._terminalService.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,s)}d.show(!0);const u=await d.processId;h?await new Promise(T=>setTimeout(T,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0||E.indexOf("cmd.exe")>=0?d.sendText("cls"):E.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const b=(0,v.prepareCommand)(E,r.args,l,r.env);d.sendText(b);const I=this.onDidTerminateDebugSession(T=>{T.id===g&&(this._integratedTerminalInstances.free(d),I.dispose())});return u}else if(r.kind==="external")return(0,v.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,g)}createVariableResolver(r,g,c){return new a.ExtHostVariableResolverService(r,g,c,this._editorTabs,this._workspaceService)}};A=Ve([He(0,P.IExtHostRpcService),He(1,i.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,_.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class p{constructor(){this._terminalInstances=new Map}async checkout(r,g){const E=[...this._terminalInstances.entries()].map(([n,t])=>(0,f.createCancelablePromise)(async s=>{if(n.name!==g||t.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await n.processId))return null;const d=Date.now();return t.lastUsedAt+p.minUseDelay>d||s.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,n)}));return await(0,f.firstParallel)(E,n=>!!n)}insert(r,g){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this._terminalInstances.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}p.minUseDelay=1e3}),define(ge[270],pe([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends w.ExtHostTaskBase{constructor(c,E,n,t,s,d,l,h,u){super(c,E,n,t,s,d,l,h);this.workspaceService=n,this.editorTabs=u,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,E){const n=E;if(!E.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=w.TaskHandleDTO.from(n,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(s,E);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=w.TaskDTO.from(E,c);if(t===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,E,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),E);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(c,E,n,t){const s=[];if(t)for(let d of t){this.checkDeprecation(d,n),(!d.definition||!c[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const l=w.TaskDTO.from(d,n.extension);l&&(s.push(l),w.CustomExecutionDTO.is(l.execution)&&E.push(this.addCustomExecution(l,d,!0)))}return{tasks:s,extension:n.extension}}async resolveTaskInternal(c){return c}async getVariableResolver(c){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new i.ExtHostVariableResolverService(c,this._editorService,E,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(c){let E=c&&c.length>0?c[0]:void 0;if(!E){const n=L.URI.file((0,o.homedir)());E=new y.WorkspaceFolder({uri:n,name:p.basename(n),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,E){const n=L.URI.revive(c),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(n),d=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(d),h=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let u of E.variables)t.variables[u]=await l.resolveAsync(h,u);if(E.process!==void 0){let u;if(E.process.path!==void 0){u=E.process.path.split(m.delimiter);for(let b=0;b<u.length;b++)u[b]=await l.resolveAsync(h,u[b])}t.process=await D.win32.findExecutable(await l.resolveAsync(h,E.process.name),E.process.cwd!==void 0?await l.resolveAsync(h,E.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(c,E,n){return D.win32.findExecutable(c,E,n)}};r=Ve([He(0,P.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,S.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,v.ILogService),He(7,_.IExtHostApiDeprecationService),He(8,A.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(ge[271],pe([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(r,g,c,E){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=c,this._rpcProtocol=new S.RPCProtocol(r,null,E),g=p._transform(g,this._rpcProtocol);const n=new P.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...g}),n.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),n.set(v.IURITransformerService,new v.URITransformerService(E)),n.set(_.IHostUtils,c);const t=new w.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(h=>h.get(A.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(h=>h.get(_.IExtHostExtensionService))),this._logService=t.invokeFunction(h=>h.get(y.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(h=>h.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(u,b)=>{let I="",T,x;for(const O of b)I+=`
	at ${O.toString()}`,x=O.getFileName(),!T&&x&&(T=h.findSubstr(i.URI.file(x)));return s.set(u,T),`${u.name||"Error"}: ${u.message||""}${I}`}});const d=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),l=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(h=>{const u=L.transformErrorForSerialization(h),b=s.get(h);b?d.$onExtensionRuntimeError(b.identifier,u):l.$onUnexpectedError(u)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(c=>{this._logService.error(c)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,g){r.extensions.forEach(E=>E.extensionLocation=i.URI.revive(g.transformIncomingURIs(E.extensionLocation))),r.environment.appRoot=i.URI.revive(g.transformIncomingURIs(r.environment.appRoot));const c=r.environment.extensionDevelopmentLocationURI;return c&&(r.environment.extensionDevelopmentLocationURI=c.map(E=>i.URI.revive(g.transformIncomingURIs(E)))),r.environment.extensionTestsLocationURI=i.URI.revive(g.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=i.URI.revive(g.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=i.URI.revive(g.transformIncomingURIs(r.logsLocation)),r.logFile=i.URI.revive(g.transformIncomingURIs(r.logFile)),r.workspace=g.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=p}),define(ge[272],pe([0,1,9,21,50,31,23,46,33]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(a,w,f){this.config=a,this.provider=w,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&C.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&C.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const w=this.config.folderQueries||[];return new Promise((f,v)=>{const _=A=>{this.resultCount++,a(A)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const p=A.toString(),o=m.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,o)||this.matchFile(_,{base:A,basename:o})}),Promise.all(w.map(A=>this.searchInFolder(A,_))).then(A=>{f({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{v(new Error((0,D.toErrorMessage)(A)))})})}async searchInFolder(a,w){const f=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(a),_=this.initDirectoryTree(),A=new S.QueryGlobTester(this.config,a),p=!A.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(f),o=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,f.token),g=o.elapsed(),c=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(E=>{const n=m.posix.relative(a.folder.path,E.path);if(p){const t=m.basename(E.path);this.matchFile(w,{base:a.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(_,a.folder,n,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,A,w),{providerTime:g,postProcessTime:c.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(a){const w=(0,S.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),f=(0,S.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:f,includes:w,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},w,f,v){if(f===this.filePattern){const A=m.basename(this.filePattern);this.matchFile(v,{base:w,relativePath:this.filePattern,basename:A})}function _(A){const p=m.basename(A),o=m.dirname(A);let r=a[o];r||(r=a[o]=[],_(o)),r.push({base:w,relativePath:A,basename:p})}_(f)}matchDirectoryTree({rootEntries:a,pathToEntries:w},f,v){const _=this,A=this.filePattern;function p(o){const r=C.hasSiblingFn(()=>o.map(g=>g.basename));for(let g=0,c=o.length;g<c;g++){const E=o[g],{relativePath:n,basename:t}=E;if(f.matchesExcludesSync(n,t,A!==t?r:void 0))continue;const s=w[n];if(s)p(s);else{if(n===A)continue;_.matchFile(v,E)}if(_.isLimitHit)break}}p(a)}matchFile(a,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(w))}}class R{constructor(){this.sessions=new Map}fileSearch(a,w,f,v){const _=this.getSessionTokenSource(a.cacheKey),A=new y(a,w,_&&_.token);let p=0;const o=r=>{p+=r.length,f(r.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(A,R.BATCH_SIZE,o,v).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:r.stats}}))}clearCache(a){const w=this.getSessionTokenSource(a);w&&w.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new L.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:i.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,w,f,v){v.onCancellationRequested(()=>{a.cancel()});const _=p=>{p&&(A.push(p),w>0&&A.length>=w&&(f(A),A=[]))};let A=[];return a.search(_).then(p=>(A.length&&f(A),p),p=>(A.length&&f(A),Promise.reject(p)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ge[134],pe([0,1,17,21,50,31,10,9,23,13,2,33]),function(Y,e,m,L,D,C,i,k,S,y,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(o,r,g,c){this.query=o,this.provider=r,this.fileUtils=g,this.processType=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,r){const g=this.query.folderQueries||[],c=new L.CancellationTokenSource;return r.onCancellationRequested(()=>c.cancel()),new Promise((E,n)=>{this.collector=new f(o);let t=!1;const s=(d,l)=>{if(!t&&!this.isLimitHit){const h=this.resultSize(d);_(d)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,t=!0,c.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const u=this.resultSize(d);this.resultCount+=u,(u>0||!_(d))&&this.collector.add(d,l)}};Promise.all(g.map((d,l)=>this.searchInFolder(d,h=>s(h,l),c.token))).then(d=>{c.dispose(),this.collector.flush();const l=d.some(h=>!!h&&!!h.limitHit);E({limitHit:this.isLimitHit||l,messages:(0,m.flatten)(d.map(h=>h?.message?(0,y.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},d=>{c.dispose();const l=(0,D.toErrorMessage)(d);n(new Error(l))})})}resultSize(o){return _(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,r){const g=Array.isArray(o.ranges)?o.ranges:[o.ranges],c=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:g.slice(0,r),preview:{matches:c.slice(0,r),text:o.preview.text},uri:o.uri}}async searchInFolder(o,r,g){const c=new P.QueryGlobTester(this.query,o),E=[],n={report:d=>{if(!this.validateProviderResult(d))return;const l=o.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,h=S.relativePath(o.folder,d.uri);if(h){const u=c.includedInQuery(h,k.basename(h),l);(0,y.isPromise)(u)?E.push(u.then(b=>{b&&r(d)})):u&&r(d)}}},t=this.getSearchOptionsForFolder(o),s=await this.provider.provideTextSearchResults(w(this.query.contentPattern),t,n,g);return E.length&&await Promise.all(E),s}validateProviderResult(o){if(_(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const r=(0,P.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),g=(0,P.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),c={folder:R.URI.from(o.folder),excludes:g,includes:r,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return c.usePCRE2=this.query.usePCRE2,c}}e.TextSearchManager=a;function w(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class f{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,r=>this.sendItems(r))}add(o,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!S.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(v(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=f;function v(p){return _(p)?{preview:{matches:(0,m.mapArrayOrNot)(p.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:p.preview.text},ranges:(0,m.mapArrayOrNot)(p.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function _(p){return!!p.preview}e.extensionResultIsMatch=_;class A{constructor(o,r){this.maxBatchSize=o,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,r){!o||this.addItemToBatch(o,r)}addItems(o,r){!o||this.addItemsToBatch(o,r)}addItemToBatch(o,r){this.batch.push(o),this.batchSize+=r,this.onUpdate()}addItemsToBatch(o,r){this.batch=this.batch.concat(o),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(ge[72],pe([0,1,6,5,4,272,14,64,11,2,134]),function(Y,e,m,L,D,C,i,k,S,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let P=class{constructor(v,_,A){this.extHostRpc=v,this._uriTransformer=_,this._logService=A,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const A=this._handlePool++;return this._textSearchProvider.set(A,_),this._proxy.$registerTextSearchProvider(A,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const A=this._handlePool++;return this._fileSearchProvider.set(A,_),this._proxy.$registerFileSearchProvider(A,this._transformScheme(v)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(v,_,A,p){const o=a(A),r=this._fileSearchProvider.get(v);if(r)return this._fileSearchManager.fileSearch(o,r,g=>{this._proxy.$handleFileMatch(v,_,g.map(c=>c.resource))},p);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,A,p){const o=this._textSearchProvider.get(v);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const r=a(A);return this.createTextSearchManager(r,o).search(c=>this._proxy.$handleTextMatch(v,_,c),p)}$enableExtensionHostSearch(){}createTextSearchManager(v,_){return new R.TextSearchManager(v,_,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};P=Ve([He(0,i.IExtHostRpcService),He(1,k.IURITransformerService),He(2,S.ILogService)],P),e.ExtHostSearch=P;function a(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(v=>y.URI.revive(v))}}e.reviveQuery=a;function w(f){return{...f,folder:y.URI.revive(f.folder)}}}),define(ge[273],pe([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,16,7,254,68,133,35,73,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o,r,g,c,E,n,t,s,d,l,h,u,b,I,T,x,O,F,W,M,B,U,z,K,N,j,H,V,q,te,fe,Ce,ke,Ue,xe,ze,Q,Z,re,ue,J,ie,we,Me,je,Ke,Ze,rt,ut,it,st,Ae,wt,ee,se,Se,Ge,Ye,nt,he,Ie,Be,$e,tt,Te,ye,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ae(de){const ve=de.get(Z.IExtHostInitDataService),Ee=de.get(Ae.IExtHostFileSystemInfo),Fe=de.get(Ze.IExtHostConsumerFileSystem),Qe=de.get(n.IExtHostExtensionService),We=de.get(j.IExtHostWorkspace),Xe=de.get(Ge.IExtHostTelemetry),at=de.get(A.IExtHostConfiguration),lt=de.get(ze.IURITransformerService),le=de.get(Q.IExtHostRpcService),_e=de.get(O.IExtHostStorage),ce=de.get(Ke.IExtensionStoragePaths),X=de.get(xe.ILoggerService),De=de.get(xe.ILogService),Le=de.get(J.IExtHostTunnelService),et=de.get(ie.IExtHostApiDeprecationService),qe=de.get(N.IExtHostWindow),mt=de.get(se.IExtHostSecretState),_t=de.get(Se.IExtHostEditorTabs);le.set(a.ExtHostContext.ExtHostFileSystemInfo,Ee),le.set(a.ExtHostContext.ExtHostLogLevelServiceShape,X),le.set(a.ExtHostContext.ExtHostWorkspace,We),le.set(a.ExtHostContext.ExtHostConfiguration,at),le.set(a.ExtHostContext.ExtHostExtensionService,Qe),le.set(a.ExtHostContext.ExtHostStorage,_e),le.set(a.ExtHostContext.ExtHostTunnelService,Le),le.set(a.ExtHostContext.ExtHostWindow,qe),le.set(a.ExtHostContext.ExtHostSecretState,mt),le.set(a.ExtHostContext.ExtHostTelemetry,Xe),le.set(a.ExtHostContext.ExtHostEditorTabs,_t);const kt=le.set(a.ExtHostContext.ExtHostDecorations,de.get(fe.IExtHostDecorations)),bt=le.set(a.ExtHostContext.ExtHostDocumentsAndEditors,de.get(E.IExtHostDocumentsAndEditors)),gt=le.set(a.ExtHostContext.ExtHostCommands,de.get(v.IExtHostCommands)),Et=le.set(a.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),Ct=le.set(a.ExtHostContext.ExtHostDebugService,de.get(ke.IExtHostDebugService)),Lt=le.set(a.ExtHostContext.ExtHostSearch,de.get(Ue.IExtHostSearch)),yt=le.set(a.ExtHostContext.ExtHostTask,de.get(Ce.IExtHostTask)),At=le.set(a.ExtHostContext.ExtHostOutputService,de.get(u.IExtHostOutputService)),xt=le.set(a.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(le)),Tt=le.set(a.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(le,bt)),Bt=le.set(a.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(le,bt,De)),Ht=le.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(De,Tt,le.getProxy(a.MainContext.MainThreadBulkEdits))),St=le.set(a.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(le,gt,bt,Tt,ce)),Qt=le.set(a.ExtHostContext.ExtHostNotebookDocuments,new tt.ExtHostNotebookDocuments(De,St)),Vt=le.set(a.ExtHostContext.ExtHostNotebookEditors,new $e.ExtHostNotebookEditors(De,le,St)),si=le.set(a.ExtHostContext.ExtHostNotebookKernels,new Ye.ExtHostNotebookKernels(le,ve,St,gt,De)),oi=le.set(a.ExtHostContext.ExtHostNotebookRenderers,new he.ExtHostNotebookRenderers(le,St)),Rt=le.set(a.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(le,bt)),Xt=le.set(a.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(le.getProxy(a.MainContext.MainThreadTreeViews),gt,De)),ai=le.set(a.ExtHostContext.ExtHostEditorInsets,new V.ExtHostEditorInsets(le.getProxy(a.MainContext.MainThreadEditorInsets),Rt,ve)),Yt=le.set(a.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(le,De,Ee)),zt=le.set(a.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(le,Tt,gt.converter,lt)),vt=le.set(a.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(le,lt,Tt,gt,Yt,De,et)),ci=le.set(a.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(le,vt)),Mt=le.set(a.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(le,De,bt)),jt=le.set(a.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(le,We,gt)),Jt=le.set(a.ExtHostContext.ExtHostSCM,new T.ExtHostSCM(le,gt,De)),li=le.set(a.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(le,gt,Tt)),fi=le.set(a.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(le.getProxy(a.MainContext.MainThreadProgress))),Ei=le.set(a.ExtHostContext.ExtHosLabelService,new q.ExtHostLabelService(le)),mi=le.set(a.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(le)),Zt=le.set(a.ExtHostContext.ExtHostAuthentication,new we.ExtHostAuthentication(le)),_i=le.set(a.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(le,gt)),qt=le.set(a.ExtHostContext.ExtHostWebviews,new K.ExtHostWebviews(le,{remote:ve.remote},We,De,et)),Gt=le.set(a.ExtHostContext.ExtHostWebviewPanels,new it.ExtHostWebviewPanels(le,qt,We)),Si=le.set(a.ExtHostContext.ExtHostCustomEditors,new ut.ExtHostCustomEditors(le,Tt,ce,qt,Gt)),Ci=le.set(a.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(le,qt)),Kt=le.set(a.ExtHostContext.ExtHostTesting,new wt.ExtHostTesting(le,gt)),yi=le.set(a.ExtHostContext.ExtHostUriOpeners,new ee.ExtHostUriOpeners(le));le.set(a.ExtHostContext.ExtHostInteractive,new Te.ExtHostInteractive(le,St,bt,gt));const ei=(0,H.values)(a.ExtHostContext);le.assertRegistered(ei);const Di=new st.ExtHostBulkEdits(le,bt),ki=new f.ExtHostClipboard(le),ui=new h.ExtHostMessageService(le,De),ti=new o.ExtHostDialogs(le),gi=new x.ExtHostStatusBar(le,gt.converter);return w.ExtHostApiCommands.register(gt),function(Ne,Ot,pi){const pt=function(){let ne=!Ne.isUnderDevelopment;function me(){ne||(De.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(ht){if(Array.isArray(ht))ht.forEach(Re);else if(typeof ht=="string")me();else{const Dt=ht;typeof Dt.scheme=="undefined"&&me(),typeof Dt.exclusive=="boolean"&&(0,be.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return ht}}(),ii={getSession(ne,me,Re){return Zt.getSession(Ne,ne,me,Re)},async hasSession(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"authSession"),!!await Zt.getSession(Ne,ne,me,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,me,Re,ht){return Zt.registerAuthenticationProvider(ne,me,Re,ht)}},Ii={registerCommand(ne,me,Re){return gt.registerCommand(!0,ne,me,Re,void 0,Ne)},registerTextEditorCommand(ne,me,Re){return gt.registerCommand(!0,ne,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){De.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(It=>{me.apply(Re,[Dt,It,...ht])}).then(It=>{It||De.warn("Edits from command "+ne+" were not applied.")},It=>{De.warn("An error occurred while running command "+ne,It)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ne,me,Re)=>((0,be.checkProposedApiEnabled)(Ne,"diffCommand"),gt.registerCommand(!0,ne,async(...ht)=>{const Dt=bt.activeEditor(!0);if(!Dt){De.warn("Cannot execute "+ne+" because there is no active text editor.");return}const It=await Rt.getDiffInformation(Dt.id);me.apply(Re,[It,...ht])},void 0,void 0,Ne)),executeCommand(ne,...me){return gt.executeCommand(ne,...me)},getCommands(ne=!1){return gt.getCommands(ne)}},vi={get machineId(){return ve.telemetryInfo.machineId},get sessionId(){return ve.telemetryInfo.sessionId},get language(){return ve.environment.appLanguage},get appName(){return ve.environment.appName},get appRoot(){return ve.environment.appRoot?.fsPath??""},get appHost(){return ve.environment.appHost},get uriScheme(){return ve.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return Xe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Xe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(ve.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,me){return qe.openUri(ne,{allowTunneling:!!ve.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ve.environment.appUriScheme)return xt.createAppUri(ne);try{return await qe.asExternalUri(ne,{allowTunneling:!!ve.remote.authority})}catch(me){if((0,Be.matchesScheme)(ne,Ie.Schemas.http)||(0,Be.matchesScheme)(ne,Ie.Schemas.https))return ne;throw me}},get remoteName(){return(0,te.getRemoteName)(ve.remote.authority)},get remoteAuthority(){return(0,be.checkProposedApiEnabled)(Ne,"resolvers"),ve.remote.authority},get uiKind(){return ve.uiKind}};ve.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=ve.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pi={createTestController(ne,me){return Kt.createTestController(ne,me)},createTestObserver(){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.createTestObserver()},runTests(ne){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.runTests(ne)},get onDidChangeTestResults(){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,be.checkProposedApiEnabled)(Ne,"testObserver"),Kt.results}},Ti={getExtension(ne){const me=Ot.getExtensionDescription(ne);if(me)return new n.Extension(Qe,Ne.identifier,me,wi)},get all(){return Ot.getAllExtensionDescriptions().map(ne=>new n.Extension(Qe,Ne.identifier,ne,wi))},get onDidChange(){return Ot.onDidChange}},Ai={createDiagnosticCollection(ne){return Yt.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ne=>Yt.getDiagnostics(ne),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ne,me){return zt.changeLanguage(ne.uri,me)},match(ne,me){return(0,R.score)(B.LanguageSelector.from(ne),me.uri,me.languageId,!0)},registerCodeActionsProvider(ne,me,Re){return vt.registerCodeActionProvider(Ne,pt(ne),me,Re)},registerCodeLensProvider(ne,me){return vt.registerCodeLensProvider(Ne,pt(ne),me)},registerDefinitionProvider(ne,me){return vt.registerDefinitionProvider(Ne,pt(ne),me)},registerDeclarationProvider(ne,me){return vt.registerDeclarationProvider(Ne,pt(ne),me)},registerImplementationProvider(ne,me){return vt.registerImplementationProvider(Ne,pt(ne),me)},registerTypeDefinitionProvider(ne,me){return vt.registerTypeDefinitionProvider(Ne,pt(ne),me)},registerHoverProvider(ne,me){return vt.registerHoverProvider(Ne,pt(ne),me,Ne.identifier)},registerEvaluatableExpressionProvider(ne,me){return vt.registerEvaluatableExpressionProvider(Ne,pt(ne),me,Ne.identifier)},registerInlineValuesProvider(ne,me){return vt.registerInlineValuesProvider(Ne,pt(ne),me,Ne.identifier)},registerDocumentHighlightProvider(ne,me){return vt.registerDocumentHighlightProvider(Ne,pt(ne),me)},registerLinkedEditingRangeProvider(ne,me){return vt.registerLinkedEditingRangeProvider(Ne,pt(ne),me)},registerReferenceProvider(ne,me){return vt.registerReferenceProvider(Ne,pt(ne),me)},registerRenameProvider(ne,me){return vt.registerRenameProvider(Ne,pt(ne),me)},registerDocumentSymbolProvider(ne,me,Re){return vt.registerDocumentSymbolProvider(Ne,pt(ne),me,Re)},registerWorkspaceSymbolProvider(ne){return vt.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,me){return vt.registerDocumentFormattingEditProvider(Ne,pt(ne),me)},registerDocumentRangeFormattingEditProvider(ne,me){return vt.registerDocumentRangeFormattingEditProvider(Ne,pt(ne),me)},registerOnTypeFormattingEditProvider(ne,me,Re,...ht){return vt.registerOnTypeFormattingEditProvider(Ne,pt(ne),me,[Re].concat(ht))},registerDocumentSemanticTokensProvider(ne,me,Re){return vt.registerDocumentSemanticTokensProvider(Ne,pt(ne),me,Re)},registerDocumentRangeSemanticTokensProvider(ne,me,Re){return vt.registerDocumentRangeSemanticTokensProvider(Ne,pt(ne),me,Re)},registerSignatureHelpProvider(ne,me,Re,...ht){return typeof Re=="object"?vt.registerSignatureHelpProvider(Ne,pt(ne),me,Re):vt.registerSignatureHelpProvider(Ne,pt(ne),me,typeof Re=="undefined"?[]:[Re,...ht])},registerCompletionItemProvider(ne,me,...Re){return vt.registerCompletionItemProvider(Ne,pt(ne),me,Re)},registerInlineCompletionItemProvider(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"inlineCompletions"),vt.registerInlineCompletionsProvider(Ne,pt(ne),me)},registerDocumentLinkProvider(ne,me){return vt.registerDocumentLinkProvider(Ne,pt(ne),me)},registerColorProvider(ne,me){return vt.registerColorProvider(Ne,pt(ne),me)},registerFoldingRangeProvider(ne,me){return vt.registerFoldingRangeProvider(Ne,pt(ne),me)},registerSelectionRangeProvider(ne,me){return vt.registerSelectionRangeProvider(Ne,ne,me)},registerCallHierarchyProvider(ne,me){return vt.registerCallHierarchyProvider(Ne,ne,me)},registerTypeHierarchyProvider(ne,me){return vt.registerTypeHierarchyProvider(Ne,ne,me)},setLanguageConfiguration:(ne,me)=>vt.setLanguageConfiguration(Ne,ne,me),getTokenInformationAtPosition(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"tokenInformation"),zt.tokenAtPosition(ne,me)},registerInlayHintsProvider(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"inlayHints"),vt.registerInlayHintsProvider(Ne,ne,me)},createLanguageStatusItem(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"languageStatus"),zt.createLanguageStatusItem(Ne,ne,me)}},Ri={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ne,me,Re){const ht=await(i.URI.isUri(ne)?Promise.resolve(ni.openTextDocument(ne)):Promise.resolve(ne));return Rt.showTextDocument(ht,me,Re)},createTextEditorDecorationType(ne){return Rt.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,me,Re){return Rt.onDidChangeActiveTextEditor(ne,me,Re)},onDidChangeVisibleTextEditors(ne,me,Re){return Rt.onDidChangeVisibleTextEditors(ne,me,Re)},onDidChangeTextEditorSelection(ne,me,Re){return Rt.onDidChangeTextEditorSelection(ne,me,Re)},onDidChangeTextEditorOptions(ne,me,Re){return Rt.onDidChangeTextEditorOptions(ne,me,Re)},onDidChangeTextEditorVisibleRanges(ne,me,Re){return Rt.onDidChangeTextEditorVisibleRanges(ne,me,Re)},onDidChangeTextEditorViewColumn(ne,me,Re){return Rt.onDidChangeTextEditorViewColumn(ne,me,Re)},onDidCloseTerminal(ne,me,Re){return Et.onDidCloseTerminal(ne,me,Re)},onDidOpenTerminal(ne,me,Re){return Et.onDidOpenTerminal(ne,me,Re)},onDidChangeActiveTerminal(ne,me,Re){return Et.onDidChangeActiveTerminal(ne,me,Re)},onDidChangeTerminalDimensions(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"terminalDimensions"),Et.onDidChangeTerminalDimensions(ne,me,Re)},onDidChangeTerminalState(ne,me,Re){return Et.onDidChangeTerminalState(ne,me,Re)},onDidWriteTerminalData(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),Et.onDidWriteTerminalData(ne,me,Re)},get state(){return qe.state},onDidChangeWindowState(ne,me,Re){return qe.onDidChangeWindowState(ne,me,Re)},showInformationMessage(ne,...me){return ui.showMessage(Ne,C.default.Info,ne,me[0],me.slice(1))},showWarningMessage(ne,...me){return ui.showMessage(Ne,C.default.Warning,ne,me[0],me.slice(1))},showErrorMessage(ne,...me){return ui.showMessage(Ne,C.default.Error,ne,me[0],me.slice(1))},showQuickPick(ne,me,Re){return Array.isArray(ne)&&ne.some(ht=>ht.kind!==void 0)&&(0,be.checkProposedApiEnabled)(Ne,"quickPickSeparators"),jt.showQuickPick(ne,me,Re)},showWorkspaceFolderPick(ne){return jt.showWorkspaceFolderPick(ne)},showInputBox(ne,me){return jt.showInput(ne,me)},showOpenDialog(ne){return ti.showOpenDialog(ne)},showSaveDialog(ne){return ti.showSaveDialog(ne)},createStatusBarItem(ne,me,Re){let ht,Dt,It;return typeof ne=="string"?(ht=ne,Dt=me,It=Re):(Dt=ne,It=me),gi.createStatusBarEntry(Ne,ht,Dt,It)},setStatusBarMessage(ne,me){return gi.setStatusBarMessage(ne,me)},withScmProgress(ne){return et.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fi.withProgress(Ne,{location:U.ProgressLocation.SourceControl},(me,Re)=>ne({report(ht){}}))},withProgress(ne,me){return fi.withProgress(Ne,ne,me)},createOutputChannel(ne){return At.createOutputChannel(ne,Ne)},createWebviewPanel(ne,me,Re,ht){return Gt.createWebviewPanel(Ne,ne,me,Re,ht)},createWebviewTextEditorInset(ne,me,Re,ht){return(0,be.checkProposedApiEnabled)(Ne,"editorInsets"),ai.createWebviewEditorInset(ne,me,Re,ht,Ne)},createTerminal(ne,me,Re){return typeof ne=="object"?("location"in ne&&(0,be.checkProposedApiEnabled)(Ne,"terminalLocation"),"pty"in ne?Et.createExtensionTerminal(ne):Et.createTerminalFromOptions(ne)):Et.createTerminal(ne,me,Re)},registerTerminalLinkProvider(ne){return Et.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,me){return Et.registerProfileProvider(Ne,ne,me)},registerTreeDataProvider(ne,me){return Xt.registerTreeDataProvider(ne,me,Ne)},createTreeView(ne,me){return Xt.createTreeView(ne,me,Ne)},registerWebviewPanelSerializer:(ne,me)=>Gt.registerWebviewPanelSerializer(Ne,ne,me),registerCustomEditorProvider:(ne,me,Re={})=>Si.registerCustomEditorProvider(Ne,ne,me,Re),registerFileDecorationProvider(ne){return kt.registerFileDecorationProvider(ne,Ne.identifier)},registerUriHandler(ne){return xt.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return jt.createQuickPick(Ne)},createInputBox(){return jt.createInputBox(Ne.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ne,me,Re){return mi.onDidChangeActiveColorTheme(ne,me,Re)},registerWebviewViewProvider(ne,me,Re){return Ci.registerWebviewViewProvider(Ne,ne,me,Re?.webviewOptions)},get activeNotebookEditor(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeActiveNotebookEditor(ne,me,Re)},get visibleNotebookEditors(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(ne,me,Re)},onDidChangeNotebookEditorVisibleRanges(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(ne,me,Re)},showNotebookDocument(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.showNotebookDocument(ne,me)},registerExternalUriOpener(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"externalUriOpener"),yi.registerExternalUriOpener(Ne.identifier,ne,me,Re)},get tabs(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.tabs},get activeTab(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.activeTab},get onDidChangeTabs(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.onDidChangeTabs},get onDidChangeActiveTab(){return(0,be.checkProposedApiEnabled)(Ne,"tabs"),_t.onDidChangeActiveTab},getInlineCompletionItemController(ne){return(0,be.checkProposedApiEnabled)(Ne,"inlineCompletions"),d.InlineCompletionController.get(ne)}},ni={get rootPath(){return et.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),We.getPath()},set rootPath(ne){throw L.readonly()},getWorkspaceFolder(ne){return We.getWorkspaceFolder(ne)},get workspaceFolders(){return We.getWorkspaceFolders()},get name(){return We.name},set name(ne){throw L.readonly()},get workspaceFile(){return We.workspaceFile},set workspaceFile(ne){throw L.readonly()},updateWorkspaceFolders:(ne,me,...Re)=>We.updateWorkspaceFolders(Ne,ne,me||0,...Re),onDidChangeWorkspaceFolders:function(ne,me,Re){return We.onDidChangeWorkspace(ne,me,Re)},asRelativePath:(ne,me)=>We.getRelativePath(ne,me),findFiles:(ne,me,Re,ht)=>We.findFiles(B.GlobPattern.from(ne),B.GlobPattern.from(me),Re,Ne.identifier,ht),findTextInFiles:(ne,me,Re,ht)=>{(0,be.checkProposedApiEnabled)(Ne,"findTextInFiles");let Dt,It;return typeof me=="object"?(Dt=me,It=Re):(Dt={},It=me,ht=Re),We.findTextInFiles(ne,Dt||{},It,Ne.identifier,ht)},saveAll:ne=>We.saveAll(ne),applyEdit(ne){return Di.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,me,Re,ht)=>Mt.createFileSystemWatcher(B.GlobPattern.from(ne),me,Re,ht),get textDocuments(){return Tt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw L.readonly()},openTextDocument(ne){let me;const Re=ne;if(typeof ne=="string")me=Promise.resolve(i.URI.file(ne));else if(i.URI.isUri(ne))me=Promise.resolve(ne);else if(!Re||typeof Re=="object")me=Tt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ht=>Tt.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,me,Re)=>Tt.onDidAddDocument(ne,me,Re),onDidCloseTextDocument:(ne,me,Re)=>Tt.onDidRemoveDocument(ne,me,Re),onDidChangeTextDocument:(ne,me,Re)=>Tt.onDidChangeDocument(ne,me,Re),onDidSaveTextDocument:(ne,me,Re)=>Tt.onDidSaveDocument(ne,me,Re),onWillSaveTextDocument:(ne,me,Re)=>Ht.getOnWillSaveTextDocumentEvent(Ne)(ne,me,Re),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,me){let Re;if(i.URI.isUri(ne))Re=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Re=i.URI.revive(await St.createNotebookDocument({viewType:ne,content:me}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,me,Re,ht){return St.registerNotebookSerializer(Ne,ne,me,Re,(0,be.isProposedApiEnabled)(Ne,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(ne,me,Re,ht)=>((0,be.checkProposedApiEnabled)(Ne,"notebookContentProvider"),St.registerNotebookContentProvider(Ne,ne,me,Re,(0,be.isProposedApiEnabled)(Ne,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(ne,me,Re)=>pi.onDidChangeConfiguration(ne,me,Re),getConfiguration(ne,me){return me=arguments.length===1?void 0:me,pi.getConfiguration(ne,me,Ne)},registerTextDocumentContentProvider(ne,me){return Bt.registerTextDocumentContentProvider(ne,me)},registerTaskProvider:(ne,me)=>(et.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ne,me)),registerFileSystemProvider(ne,me,Re){return(0,ye.combinedDisposable)(ci.registerFileSystemProvider(Ne,ne,me,Re),Fe.addFileSystemProvider(ne,me))},get fs(){return Fe.value},registerFileSearchProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Lt.registerFileSearchProvider(ne,me)),registerTextSearchProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"textSearchProvider"),Lt.registerTextSearchProvider(ne,me)),registerRemoteAuthorityResolver:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Qe.registerRemoteAuthorityResolver(ne,me)),registerResourceLabelFormatter:ne=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Ei.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,me,Re)=>Mt.onDidCreateFile(ne,me,Re),onDidDeleteFiles:(ne,me,Re)=>Mt.onDidDeleteFile(ne,me,Re),onDidRenameFiles:(ne,me,Re)=>Mt.onDidRenameFile(ne,me,Re),onWillCreateFiles:(ne,me,Re)=>Mt.getOnWillCreateFileEvent(Ne)(ne,me,Re),onWillDeleteFiles:(ne,me,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(ne,me,Re),onWillRenameFiles:(ne,me,Re)=>Mt.getOnWillRenameFileEvent(Ne)(ne,me,Re),openTunnel:ne=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Le.openTunnel(Ne,ne).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,be.checkProposedApiEnabled)(Ne,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(ne,me,Re)=>((0,be.checkProposedApiEnabled)(Ne,"resolvers"),Le.onDidChangeTunnels(ne,me,Re)),registerPortAttributesProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"portsAttributes"),Le.registerPortsAttributesProvider(ne,me)),registerTimelineProvider:(ne,me)=>((0,be.checkProposedApiEnabled)(Ne,"timeline"),_i.registerTimelineProvider(ne,me,Ne.identifier,gt.converter)),get isTrusted(){return We.trusted},requestWorkspaceTrust:ne=>((0,be.checkProposedApiEnabled)(Ne,"workspaceTrust"),We.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,me,Re)=>We.onDidGrantWorkspaceTrust(ne,me,Re)},Li={get inputBox(){return et.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ne)},createSourceControl(ne,me,Re){return Jt.createSourceControl(Ne,ne,me,Re)}},Fi={createCommentController(ne,me){return li.createCommentController(Ne,ne,me)}},Mi={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},onDidStartDebugSession(ne,me,Re){return Ct.onDidStartDebugSession(ne,me,Re)},onDidTerminateDebugSession(ne,me,Re){return Ct.onDidTerminateDebugSession(ne,me,Re)},onDidChangeActiveDebugSession(ne,me,Re){return Ct.onDidChangeActiveDebugSession(ne,me,Re)},onDidReceiveDebugSessionCustomEvent(ne,me,Re){return Ct.onDidReceiveDebugSessionCustomEvent(ne,me,Re)},onDidChangeBreakpoints(ne,me,Re){return Ct.onDidChangeBreakpoints(ne,me,Re)},registerDebugConfigurationProvider(ne,me,Re){return Ct.registerDebugConfigurationProvider(ne,me,Re||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,me){return Ct.registerDebugAdapterDescriptorFactory(Ne,ne,me)},registerDebugAdapterTrackerFactory(ne,me){return Ct.registerDebugAdapterTrackerFactory(ne,me)},startDebugging(ne,me,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Ct.startDebugging(ne,me,{parentSession:Re}):Ct.startDebugging(ne,me,Re||{})},stopDebugging(ne){return Ct.stopDebugging(ne)},addBreakpoints(ne){return Ct.addBreakpoints(ne)},removeBreakpoints(ne){return Ct.removeBreakpoints(ne)},asDebugSourceUri(ne,me){return Ct.asDebugSourceUri(ne,me)}},Oi={registerTaskProvider:(ne,me)=>yt.registerTaskProvider(Ne,ne,me),fetchTasks:ne=>yt.fetchTasks(ne),executeTask:ne=>yt.executeTask(Ne,ne),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ne,me,Re)=>yt.onDidStartTask(ne,me,Re),onDidEndTask:(ne,me,Re)=>yt.onDidEndTask(ne,me,Re),onDidStartTaskProcess:(ne,me,Re)=>yt.onDidStartTaskProcess(ne,me,Re),onDidEndTaskProcess:(ne,me,Re)=>yt.onDidEndTaskProcess(ne,me,Re)},Ni={createNotebookController(ne,me,Re,ht,Dt){return si.createNotebookController(Ne,ne,me,Re,ht,(0,be.isProposedApiEnabled)(Ne,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,me)=>St.registerNotebookCellStatusBarItemProvider(Ne,ne,me),get onDidSaveNotebookDocument(){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return oi.createRendererMessaging(Ne,ne)},onDidChangeNotebookDocumentMetadata(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(ne,me,Re)},onDidChangeNotebookCells(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeNotebookCells(ne,me,Re)},onDidChangeNotebookCellExecutionState(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),St.onDidChangeNotebookCellExecutionState(ne,me,Re)},onDidChangeCellOutputs(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeCellOutputs(ne,me,Re)},onDidChangeCellMetadata(ne,me,Re){return(0,be.checkProposedApiEnabled)(Ne,"notebookEditor"),St.onDidChangeCellMetadata(ne,me,Re)},createConcatTextDocument(ne,me){return(0,be.checkProposedApiEnabled)(Ne,"notebookConcatTextDocument"),new je.ExtHostNotebookConcatDocument(St,Tt,ne,me)}};return{version:ve.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:y.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:a.UIKind,Uri:i.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ae}),define(ge[274],pe([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p,o,r,g,c,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(E.ILoggerService,c.ExtHostLoggerService),(0,m.registerSingleton)(E.ILogService,n.ExtHostLogService),(0,m.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(i.IExtHostConfiguration,i.ExtHostConfiguration),(0,m.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,m.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,m.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage),(0,m.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,m.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,m.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,m.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,m.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(ge[92],pe([0,1,17,11,33,69]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function i(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=i;function k(P,a,w,f){const v=(0,m.mapArrayOrNot)(w,S),_=new D.TextSearchMatch(a,v,f),A=_.preview.matches;return{ranges:(0,m.mapArrayOrNot)(v,y),uri:P,preview:{text:_.preview.text,matches:(0,m.mapArrayOrNot)(A,y)}}}e.createTextSearchResult=k;function S(P){return new D.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function y(P){return new C.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(a,w){this.prefix=a,this.logService=w}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};R=Ve([He(1,L.ILogService)],R),e.OutputChannel=R}),define(ge[275],pe([0,1,95,22]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(E=>E===c)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,i=512,k=512*8,S=512*128;class y{constructor(E){this.iconvLiteDecoder=E}static async create(E){let n;if(E!==e.UTF8)n=(await new Promise((s,d)=>{Y(["iconv-lite-umd"],s,d)})).getDecoder(w(E));else{const t=new TextDecoder;n={write(s){return t.decode(s,{stream:!0})},end(){return t.decode()}}}return new y(n)}write(E){return this.iconvLiteDecoder.write(E)}end(){return this.iconvLiteDecoder.end()}}function R(c,E){const n=E.minBytesRequiredForDetection??E.guessEncoding?k:i;return new Promise((t,s)=>{const d=(0,m.newWriteableStream)(I=>I.join("")),l=[];let h=0,u;const b=async()=>{try{const I=await g({buffer:L.VSBuffer.concat(l),bytesRead:h},E.guessEncoding);I.encoding=await E.overwriteEncoding(I.encoding),u=await y.create(I.encoding);const T=u.write(L.VSBuffer.concat(l).buffer);d.write(T),l.length=0,h=0,t({stream:d,detected:I})}catch(I){s(I)}};(0,m.listenStream)(c,{onData:async I=>{u?d.write(u.write(I.buffer)):(l.push(I),h+=I.byteLength,h>=n&&(c.pause(),await b(),setTimeout(()=>c.resume())))},onError:I=>d.error(I),onEnd:async()=>{u||await b(),d.end(u?.end())}})})}e.toDecodeStream=R;async function P(c,E,n){const s=(await new Promise((h,u)=>{Y(["iconv-lite-umd"],h,u)})).getEncoder(w(E),n);let d=!1,l=!1;return{read(){if(l)return null;const h=c.read();if(typeof h!="string"){if(l=!0,!d&&n?.addBOM)switch(E){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=s.end();return u&&u.length>0?(d=!0,L.VSBuffer.wrap(u)):null}return d=!0,L.VSBuffer.wrap(s.write(h))}}}e.toEncodeReadable=P;async function a(c){return(await new Promise((n,t)=>{Y(["iconv-lite-umd"],n,t)})).encodingExists(w(c))}e.encodingExists=a;function w(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=w;function f(c,E){if(!c||E<e.UTF16be_BOM.length)return null;const n=c.readUInt8(0),t=c.readUInt8(1);if(n===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(E<e.UTF8_BOM.length)return null;const s=c.readUInt8(2);return n===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=f;const v=["ascii","utf-16","utf-32"];async function _(c){const E=await new Promise((l,h)=>{Y(["jschardet"],l,h)}),n=c.slice(0,S),t=o(n.buffer),s=E.detect(t);if(!s||!s.encoding)return null;const d=s.encoding.toLowerCase();return 0<=v.indexOf(d)?null:p(s.encoding)}const A={ibm866:"cp866",big5:"cp950"};function p(c){const E=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return A[E]||E}function o(c){let E="";for(let n=0;n<c.length;n++)E+=String.fromCharCode(c[n]);return E}function r(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const E=c.match(/windows(\d+)/);return E?"windows-"+E[1]:c}}e.toCanonicalName=r;function g({buffer:c,bytesRead:E},n){let t=f(c,E),s=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&c){let d=!0,l=!0,h=!1;for(let u=0;u<E&&u<C;u++){const b=u%2==1,I=c.readUInt8(u)===0;if(I&&(h=!0),d&&(b&&!I||!b&&I)&&(d=!1),l&&(b&&I||!b&&!I)&&(l=!1),I&&!d&&!l)break}h&&(d?t=e.UTF16le:l?t=e.UTF16be:s=!0)}return n&&!s&&!t&&c?_(c.slice(0,E)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:s,encoding:t}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[135],pe([0,1,275,28,134]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends D.TextSearchManager{constructor(k,S,y=L,R="searchProcess"){super(k,S,{readdir:P=>y.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,m.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=C}),define(ge[276],pe([0,1,277,291,292,2,293]),function(Y,e,m,L,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(P,a,w,f,v,_){const A=_.environment.useHostProxy,p=typeof A=="boolean"?A:!_.remote.isRemote,o=(0,i.createProxyResolver)({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(g,c,...E)=>{switch(g){case i.LogLevel.Trace:f.trace(c,...E);break;case i.LogLevel.Debug:f.debug(c,...E);break;case i.LogLevel.Info:f.info(c,...E);break;case i.LogLevel.Warning:f.warn(c,...E);break;case i.LogLevel.Error:f.error(c,...E);break;case i.LogLevel.Critical:f.critical(c,...E);break;case i.LogLevel.Off:break;default:n(g,c,E);break}function n(t,s,...d){f.error("Unknown log level",t),f.error(s,...d)}},getLogLevel:()=>f.getLevel(),proxyResolveTelemetry:g=>{v.$publicLog2("resolveProxy",g)},useHostProxy:p,env:process.env}),r=S(a,o);return R(w,r)}e.connectProxyResolver=k;function S(P,a){const w={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(v=>{w.config=P.getConfiguration("http").get("proxySupport")||"off"});const f={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(v=>{f.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,i.createHttpPatch)(m,a,{config:"off"},f,!0)),on:Object.assign({},m,(0,i.createHttpPatch)(m,a,{config:"on"},f,!0)),override:Object.assign({},m,(0,i.createHttpPatch)(m,a,{config:"override"},f,!0)),onRequest:Object.assign({},m,(0,i.createHttpPatch)(m,a,w,f,!0)),default:Object.assign(m,(0,i.createHttpPatch)(m,a,w,f,!1))},https:{off:Object.assign({},L,(0,i.createHttpPatch)(L,a,{config:"off"},f,!0)),on:Object.assign({},L,(0,i.createHttpPatch)(L,a,{config:"on"},f,!0)),override:Object.assign({},L,(0,i.createHttpPatch)(L,a,{config:"override"},f,!0)),onRequest:Object.assign({},L,(0,i.createHttpPatch)(L,a,w,f,!0)),default:Object.assign(L,(0,i.createHttpPatch)(L,a,w,f,!1))},tls:Object.assign(D,(0,i.createTlsPatch)(D))}}const y=new Map;function R(P,a){return P.getExtensionPathIndex().then(w=>{const f=Y.__$__nodeRequire("module"),v=f._load;f._load=function(A,p,o){if(A==="tls")return a.tls;if(A!=="http"&&A!=="https")return v.apply(this,arguments);const r=a[A],g=w.findSubstr(C.URI.file(p.filename));let c=y.get(g);if(c||y.set(g,c={}),!c[A]){let E=r.default;c[A]={...E}}return c[A]}})}}),define(ge[278],pe([0,1,37,9,79,30,12,8,92,279]),function(Y,e,m,L,D,C,i,k,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(o,r,g,c){const E=a(o,r,g,c),n=r.folder.fsPath;return{cmd:m.spawn(R,E.args,{cwd:n}),rgDiskPath:R,siblingClauses:E.siblingClauses,rgArgs:E,cwd:n}}e.spawnRipgrepCmd=P;function a(o,r,g,c){const E=["--files","--hidden","--case-sensitive"];f([r],g,!1).forEach(t=>{const s=(0,S.anchorGlob)(t);if(E.push("-g",s),i.isMacintosh){const d=(0,D.normalizeNFD)(s);d!==s&&E.push("-g",d)}});const n=w([r],c,void 0,!1);return n.globArgs.forEach(t=>{const s=`!${(0,S.anchorGlob)(t)}`;if(E.push("-g",s),i.isMacintosh){const d=(0,D.normalizeNFD)(s);d!==s&&E.push("-g",d)}}),r.disregardIgnoreFiles!==!1?E.push("--no-ignore"):E.push("--no-ignore-parent"),r.ignoreSymlinks||E.push("--follow"),o.exists&&E.push("--quiet"),E.push("--no-config"),r.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:n.siblingClauses}}function w(o,r,g,c=!0){const E=[];let n={};return o.forEach(t=>{const s=Object.assign({},t.excludePattern||{},r||{}),d=v(s,c?t.folder.fsPath:void 0,g);E.push(...d.globArgs),d.siblingClauses&&(n=Object.assign(n,d.siblingClauses))}),{globArgs:E,siblingClauses:n}}e.foldersToRgExcludeGlobs=w;function f(o,r,g=!0){const c=[];return o.forEach(E=>{const n=Object.assign({},r||{},E.includePattern||{}),t=v(n,g?E.folder.fsPath:void 0);c.push(...t.globArgs)}),c}e.foldersToIncludeGlobs=f;function v(o,r,g){const c=[],E={};return Object.keys(o).forEach(n=>{if(g&&g.has(n)||!n)return;const t=o[n];n=A(r?_(r,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),c.push(p(n))):t&&t.when&&(E[n]=t)}),{globArgs:c,siblingClauses:E}}function _(o,r){return L.isAbsolute(r)?r:L.join(o,r)}e.getAbsoluteGlob=_;function A(o){return o=k.rtrim(o,"\\"),k.rtrim(o,"/")}function p(o){return C.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=p}),define(ge[280],pe([0,1,37,60,9,103,17,50,31,79,30,12,46,8,13,28,33,278,100]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(n=>n())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&S.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&S.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(s=>{const d=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),l=s.folder.fsPath;t.folderQueries.map(h=>h.folder.fsPath).filter(h=>h!==l).forEach(h=>{(0,R.isEqualOrParent)(h,l)&&(d[D.relative(l,h)]=!0)}),this.folderExcludePatterns.set(l,new c(d,l))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,s,d,l,h){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return h(null,this.isLimitHit);s.forEach(u=>{const b=D.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,b)||this.matchFile(d,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(t,(u,b)=>{this.call(this.cmdTraversal,this,u,d,l,I=>{if(I){const T=(0,k.toErrorMessage)(I);console.error(T),this.errors.push(T),b(I,void 0)}else b(null,void 0)})},(u,b)=>{this.fileWalkSW.stop();const I=u?i.coalesce(u)[0]:null;h(I,this.isLimitHit)})}parallel(t,s,d){const l=new Array(t.length),h=new Array(t.length);let u=!1,b=0;if(t.length===0)return d(null,[]);t.forEach((I,T)=>{s(I,(x,O)=>{if(x?(u=!0,l[T]=null,h[T]=x):(l[T]=O,h[T]=null),++b===t.length)return d(u?h:null,l)})})}call(t,s,...d){try{t.apply(s,d)}catch(l){d[d.length-1](l)}}cmdTraversal(t,s,d,l){const h=t.folder.fsPath,u=P.isMacintosh;let b;const I=()=>b&&b.kill();o.add(I);let T=U=>{o.delete(I),T=()=>{},l(U)},x="";const O=this.initDirectoryTree();let F;const W=(0,A.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);b=W.cmd,F=!Object.keys(W.siblingClauses).length;const M=W.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${W.rgDiskPath} ${M}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),d({message:B}),this.cmdResultCount=0,this.collectStdout(b,"utf8",d,(U,z,K)=>{if(U){T(U);return}if(this.isLimitHit){T();return}const j=(x+(u?y.normalizeNFC(z||""):z)).split(`
`);if(K){const H=j.length;j[H-1]=j[H-1].trim(),j[H-1]||j.pop()}else x=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){T(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,F){for(const H of j)if(this.matchFile(s,{base:h,relativePath:H,searchPath:this.getSearchPath(t,H)}),this.isLimitHit){I();break}(K||this.isLimitHit)&&T();return}this.addDirectoryEntries(t,O,h,j,s),K&&(this.matchDirectoryTree(O,h,s),T())})}spawnFindCmd(t){const s=this.folderExcludePatterns.get(t.folder.fsPath),d=s.getBasenameTerms(),l=s.getPathTerms(),h=["-L","."];if(d.length||l.length){h.push("-not","(","(");for(const u of d)h.push("-name",u),h.push("-o");for(const u of l)h.push("-path",u),h.push("-o");h.pop(),h.push(")","-prune",")")}return h.push("-type","f"),m.spawn("find",h,{cwd:t.folder.fsPath})}readStdout(t,s,d){let l="";this.collectStdout(t,s,()=>{},(h,u,b)=>{if(h){d(h);return}l+=u,b&&d(null,l)})}collectStdout(t,s,d,l){let h=(I,T,x)=>{(I||x)&&(h=()=>{},this.cmdSW&&this.cmdSW.stop()),l(I,T,x)},u=!1;t.stdout?(this.forwardData(t.stdout,s,h),t.stdout.once("data",()=>u=!0)):d({message:"stdout is null"});let b;t.stderr?b=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",I=>{h(I)}),t.on("close",I=>{let T;!u&&(T=this.decodeData(b,s))&&E(T)?h(new Error(`command failed with error code ${I}: ${this.decodeData(b,s)}`)):(this.exists&&I===0&&(this.isLimitHit=!0),h(null,"",!0))})}forwardData(t,s,d){const l=new C.StringDecoder(s);return t.on("data",h=>{d(null,l.write(h))}),l}collectData(t){const s=[];return t.on("data",d=>{s.push(d)}),s}decodeData(t,s){const d=new C.StringDecoder(s);return t.map(l=>d.write(l)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:s},d,l,h){l.indexOf(this.filePattern)!==-1&&this.matchFile(h,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=b=>{const I=D.basename(b),T=D.dirname(b);let x=s[T];x||(x=s[T]=[],u(T)),x.push({base:d,relativePath:b,basename:I,searchPath:this.getSearchPath(t,b)})};l.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:s},d,l){const h=this,u=this.folderExcludePatterns.get(d),b=this.filePattern;function I(T){h.directoriesWalked++;const x=S.hasSiblingFn(()=>T.map(O=>O.basename));for(let O=0,F=T.length;O<F;O++){const W=T[O],{relativePath:M,basename:B}=W;if(u.test(M,B,b!==B?x:void 0))continue;const U=s[M];if(U)I(U);else{if(h.filesWalked++,M===b)continue;h.matchFile(l,W)}if(h.isLimitHit)break}}I(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,s,d,l,h){const u=t.folder,b=S.hasSiblingFn(()=>d);this.parallel(d,(I,T)=>{if(this.isCanceled||this.isLimitHit)return T(null);const x=s?[s,I].join(D.sep):I;if(this.folderExcludePatterns.get(t.folder.fsPath).test(x,I,this.config.filePattern!==I?b:void 0))return T(null);const O=[u.fsPath,x].join(D.sep);L.lstat(O,(F,W)=>{if(F||this.isCanceled||this.isLimitHit)return T(null);this.statLinkIfNeeded(O,W,(M,B)=>M||this.isCanceled||this.isLimitHit?T(null):B.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(O,W,(U,z)=>U||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?T(null):(this.walkedPaths[z]=!0,v.Promises.readdir(O).then(K=>{if(this.isCanceled||this.isLimitHit)return T(null);this.doWalk(t,x,K,l,N=>T(N||null))},K=>{T(null)})))):(this.filesWalked++,x===this.filePattern||this.maxFilesize&&f.isNumber(B.size)&&B.size>this.maxFilesize||this.matchFile(l,{base:u.fsPath,relativePath:x,searchPath:this.getSearchPath(t,x)}),T(null,void 0)))})},I=>{const T=I&&i.coalesce(I);return h(T&&T.length>0?T[0]:void 0)})}matchFile(t,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,D.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(s))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,s,d){return s.isSymbolicLink()?L.stat(t,d):d(null,s)}realPathIfNeeded(t,s,d){return s.isSymbolicLink()?L.realpath(t,(l,h)=>l?d(l):d(null,h)):d(null,t)}getSearchPath(t,s){return t.folderName?D.join(t.folderName,s):s}}e.FileWalker=r;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,s,d){this.walker.walk(this.folderQueries,this.extraFiles,t,s,(l,h)=>{d(l,{limitHit:h,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class c{constructor(t,s){this.expression=t,this.root=s,this.init(t)}init(t){let s,d;Object.keys(t).filter(l=>t[l]).forEach(l=>{D.isAbsolute(l)?(s=s||S.getEmptyExpression(),s[l]=t[l]):(d=d||S.getEmptyExpression(),d[l]=t[l])}),this.absoluteParsedExpr=s&&S.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=d&&S.parse(d,{trimForExclusions:!0})}test(t,s,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,s,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),s,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...S.getPathTerms(this.relativeParsedExpr)),t}}function E(n){const t=n.trim().split(`
`),s=t[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return w.uppercaseFirstLetter(t[t.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=E}),define(ge[136],pe([0,1,37,294,103,17,73,31,9,8,2,33,69,295,279,92]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(u){this.outputChannel=u}provideTextSearchResults(u,b,I,T){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((x,O)=>{T.onCancellationRequested(()=>N());const F=E(u,b),W=b.folder.fsPath,M=F.map(te=>te.match(/^-/)?te:`'${te}'`).join(" ");this.outputChannel.appendLine(`${_} ${M}
 - cwd: ${W}`);let B=m.spawn(_,F,{cwd:W});B.on("error",te=>{console.error(te),this.outputChannel.appendLine("Error: "+(te&&te.message)),O((0,P.serializeSearchError)(new P.SearchError(te&&te.message,P.SearchErrorCode.rgProcessError)))});let U=!1;const z=new r(b.maxResults,W,b.previewOptions);z.on("result",te=>{U=!0,H="",I.report(te)});let K=!1;const N=()=>{K=!0,B&&B.kill(),z&&z.cancel()};let j=!1;z.on("hitLimit",()=>{j=!0,N()});let H="";B.stdout.on("data",te=>{z.handleData(te),U||(H+=te)});let V=!1;B.stdout.once("data",()=>V=!0);let q="";B.stderr.on("data",te=>{const fe=te.toString();this.outputChannel.appendLine(fe),q+=fe}),B.on("close",()=>{if(this.outputChannel.appendLine(V?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),K)x({limitHit:j});else{z.flush(),B=null;let te;q&&!V&&(te=p(q))?O((0,P.serializeSearchError)(new P.SearchError(te.message,te.code))):x({limitHit:j})}})})}}e.RipgrepTextSearchEngine=A;function p(h){const u=h.split(`
`),b=u[0].trim();if(u.some(T=>T.startsWith("regex parse error")))return new P.SearchError(o(u),P.SearchErrorCode.regexParseError);const I=b.match(/grep config error: unknown encoding: (.*)/);if(I)return new P.SearchError(`Unknown encoding: ${I[1]}`,P.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new P.SearchError(b.charAt(0).toUpperCase()+b.substr(1),P.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(b,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function o(h){const u=["Regex parse error"],b=h.filter(I=>I.startsWith("PCRE2:"));if(b.length>=1){const I=b[0].replace("PCRE2:","");if(I.indexOf(":")!==-1&&I.split(":").length>=2){const T=I.split(":")[1];u.push(":"+T)}}return u.join("")}e.buildRegexParseError=o;class r extends L.EventEmitter{constructor(u,b,I){super();this.maxResults=u,this.rootFolder=b,this.previewOptions=I,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,b){return super.on(u,b),this}handleData(u){if(this.isDone)return;const b=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(b)}handleDecodedData(u){let b=u.indexOf(`
`);const I=this.remainder+u;if(b>=0)b+=this.remainder.length;else{this.remainder=I;return}let T=0;for(;b>=0;)this.handleLine(I.substring(T,b).trim()),T=b+1,b=I.indexOf(`
`,T);this.remainder=I.substring(T)}handleLine(u){if(this.isDone||!u)return;let b;try{b=JSON.parse(u)}catch(I){throw new Error(`malformed line from rg: ${u}`)}if(b.type==="match"){const I=g(b.data.path),T=R.URI.file(S.join(this.rootFolder,I)),x=this.createTextSearchMatch(b.data,T);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const I=g(b.data.path),T=R.URI.file(S.join(this.rootFolder,I));this.createTextSearchContext(b.data,T).forEach(O=>this.onResult(O))}}createTextSearchMatch(u,b){const I=u.line_number-1,T=g(u.lines),x=Buffer.from(T);let O=0,F=0,W=I;u.submatches.length===0&&u.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(u.submatches.map((B,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=g(B.match),K=x.slice(O,B.start).toString().length,N=F+K,j=c(z),H=W,V=j.numLines+H,q=j.numLines>0?j.lastLineLength:j.lastLineLength+N;return O=B.end,F=q,W=V,new a.Range(H,N,V,q)}));return(0,v.createTextSearchResult)(b,T,M,this.previewOptions)}createTextSearchContext(u,b){const I=g(u.lines),T=u.line_number;return I.replace(/\r?\n$/,"").split(`
`).map((x,O)=>({text:x,uri:b,lineNumber:T+O}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=r;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function c(h){const u=/\n/g;let b=0,I=-1,T;for(;T=u.exec(h);)b++,I=T.index;const x=I>=0?h.length-I-1:h.length;return{numLines:b,lastLineLength:x}}function E(h,u){const b=["--hidden"];b.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:I,otherIncludes:T}=(0,i.groupBy)(u.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const O=new Set;T.forEach(F=>{O.add(F)}),b.push("-g","!*"),O.forEach(F=>{n(F).map(v.anchorGlob).forEach(W=>{b.push("-g",W)})})}I&&I.length&&I.forEach(O=>{b.push("-g",O)}),u.excludes.map(v.anchorGlob).forEach(O=>b.push("-g",`!${O}`)),u.maxFileSize&&b.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?b.push("--no-ignore-parent"):b.push("--no-ignore"),u.followSymlinks&&b.push("--follow"),u.encoding&&u.encoding!=="utf8"&&b.push("--encoding",u.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,y.escapeRegExpCharacters)(h.pattern),h.isRegExp=!0),u.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),h.isRegExp&&(h.pattern=t(h.pattern),b.push("--auto-hybrid-regex"));let x;if(h.isWordMatch){const F=(0,y.createRegExp)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",F)}else if(h.isRegExp){let O=d(h.pattern);O=l(O),b.push("--regexp",O)}else x=h.pattern,b.push("--fixed-strings");return b.push("--no-config"),u.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),h.isMultiline&&b.push("--multiline"),u.beforeContext&&b.push("--before-context",u.beforeContext+""),u.afterContext&&b.push("--after-context",u.afterContext+""),b.push("--"),x&&b.push(x),b.push("."),b}function n(h){const u=(0,k.splitGlobAware)(h,"/");return u.map((b,I)=>u.slice(0,I+1).join("/"))}e.spreadGlobComponents=n;function t(h){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(u);)h=h.replace(u,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(b);)h=h.replace(b,"$1\\x{$2}");return h}e.unicodeEscapesToPCRE2=t;const s=h=>h.type==="Assertion"&&h.kind==="lookbehind";function d(h){let u;try{u=new w.RegExpParser().parsePattern(h)}catch{return h}let b="",I=0;const T=(F,W,M)=>{b+=h.slice(I,F)+M,I=W},x=[];return new w.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const W=x[0];if(!W)T(F.start,F.end,"\\r?\\n");else if(!x.some(s))if(W.type==="CharacterClass")if(W.negate){const M=h.slice(W.start+2,F.start)+h.slice(F.end,W.end-1);if(W.parent?.type==="Quantifier"){const B=W.parent;T(B.start,B.end,(M?`[^${M}]`:".")+(B.greedy?"+":"*"))}else T(W.start,W.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=h.slice(W.start+1,F.start)+h.slice(F.end,W.end-1);T(W.start,W.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else W.type==="Quantifier"&&T(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){x.unshift(F)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(F){x.unshift(F)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(F){x.unshift(F)},onCharacterClassLeave(){x.shift()},onAssertionEnter(F){s(F)&&x.push(F)},onAssertionLeave(F){x[0]===F&&x.shift()}}).visit(u),b+=h.slice(I),b}e.fixRegexNewline=d;function l(h){return h.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(ge[281],pe([0,1,21,136,117,10]),function(Y,e,m,L,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class i{constructor(y){this.outputChannel=y,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(y,R,P,a){const w=new L.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===C.Schemas.userData){const f={...R,folder:R.folder.with({scheme:C.Schemas.file})},v=new D.Progress(_=>P.report({..._,uri:_.uri.with({scheme:R.folder.scheme})}));return this.withToken(a,_=>w.provideTextSearchResults(y,f,v,_))}else return this.withToken(a,f=>w.provideTextSearchResults(y,R,P,f))}async withToken(y,R){const P=k(y);this.inProgress.add(P);const a=await R(P.token);return this.inProgress.delete(P),a}dispose(){this.inProgress.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=i;function k(S){const y=new m.CancellationTokenSource;return S.onCancellationRequested(()=>y.cancel()),y}}),define(ge[282],pe([0,1,28,136,135]),function(Y,e,m,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,y,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(w){R({message:w})}},a=new D.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),m);return new Promise((w,f)=>a.search(v=>{y(v.map(i))},S).then(v=>w({limitHit:v.limitHit,type:"success",stats:v.stats}),f))}}e.TextSearchEngineAdapter=C;function i(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,y)=>{if(y.ranges){const R=y;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(ge[283],pe([0,1,17,18,15,3,100,9,46,2,42,33,280,282]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let g;const c=A(r),E=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(n=>this.doFileSearchWithEngine(a.Engine,c,t=>E.fire(t),n)),g.then(n=>E.fire(n),n=>E.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return E.event}textSearch(r){let g;const c=A(r),E=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(n=>this.ripgrepTextSearch(c,t=>E.fire(t),n)),g.then(n=>E.fire(n),n=>E.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return E.event}ripgrepTextSearch(r,g,c){return r.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(r).search(c,g,g)}doFileSearch(r,g,c){return this.doFileSearchWithEngine(a.Engine,r,g,c)}doFileSearchWithEngine(r,g,c,E,n=f.BATCH_SIZE){let t=0;const s=l=>{Array.isArray(l)?(t+=l.length,c(l.map(h=>this.rawMatchToSearchItem(h)))):l.relativePath?(t++,c(this.rawMatchToSearchItem(l))):c(l)};if(g.sortByScore){let l=this.trySortedSearchFromCache(g,s,E);if(!l){const h=g.maxResults?Object.assign({},g,{maxResults:null}):g,u=new r(h);l=this.doSortedSearch(u,g,c,s,E)}return new Promise((h,u)=>{l.then(([b,I])=>{const T=I.map(x=>this.rawMatchToSearchItem(x));this.sendProgress(T,c,n),h(b)},u)})}const d=new r(g);return this.doSearch(d,s,n,E).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,g,c,E,n){const t=new C.Emitter;let s=(0,L.createCancelablePromise)(l=>{let h=[];const u=b=>{Array.isArray(b)?h=b:(E(b),t.fire(b))};return this.doSearch(r,u,-1,l).then(b=>[b,h])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const l={promise:s,event:t.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=l,s.then(()=>{l.resolved=!0},h=>{delete d.resultsToSearchCache[g.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([l,h])=>{const u=d?d.scorerCache:Object.create(null),b=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(g,h,u,n).then(I=>{const T=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:T,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:I.length},messages:l.messages,limitHit:l.limitHit||typeof g.maxResults=="number"&&h.length>g.maxResults},I]})})}getOrCreateCache(r){const g=this.caches[r];return g||(this.caches[r]=new v)}trySortedSearchFromCache(r,g,c){const E=r.cacheKey&&this.caches[r.cacheKey];if(!E)return;const n=this.getResultsFromCache(E,r.filePattern||"",g,c);if(n)return n.then(([t,s,d])=>{const l=S.StopWatch.create(!1);return this.sortResults(r,s,E.scorerCache,c).then(h=>{const u=l.elapsed(),b={fromCache:!0,detailStats:d,type:this.processType,resultCount:s.length,sortingTime:u};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults,stats:b},h]})})}sortResults(r,g,c,E){const n=(0,i.prepareQuery)(r.filePattern||""),t=(d,l)=>(0,i.compareItemsByFuzzyScore)(d,l,n,!0,_,c),s=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,s,1e4,E)}sendProgress(r,g,c){if(c&&c>0)for(let E=0;E<r.length;E+=c)g(r.slice(E,E+c));else g(r)}getResultsFromCache(r,g,c,E){const n=S.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let s;for(const u in r.resultsToSearchCache)if(g.startsWith(u)){if(t&&u.indexOf(k.sep)<0&&u!=="")continue;const b=r.resultsToSearchCache[u];s={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!s)return null;const d=n.elapsed(),l=S.StopWatch.create(!1),h=s.event(c);return E&&E.onCancellationRequested(()=>{h.dispose()}),s.promise.then(([u,b])=>{if(E&&E.isCancellationRequested)throw(0,D.canceled)();const I=[],T=(0,i.prepareQuery)(g).normalizedLowercase;for(const x of b)!(0,P.isFilePatternMatch)(x,T)||I.push(x);return[u,I,{cacheWasResolved:s.resolved,cacheLookupTime:d,cacheFilterTime:l.elapsed(),cacheEntryCount:b.length}]})}doSearch(r,g,c,E){return new Promise((n,t)=>{let s=[];E&&E.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(c?(s.push(d),c>0&&s.length>=c&&(g(s),s=[])):g(d))},d=>{g(d)},(d,l)=>{s.length&&g(s),d?t(d):n(l)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,c){return r.then(g,c)}catch(g){return this.then(void 0,g)}finally(g){return r.finally(g)}}}}e.SearchService=f,f.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(o){return(0,k.basename)(o.relativePath)}getItemDescription(o){return(0,k.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function A(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(p),extraFileResources:o.extraFileResources&&o.extraFileResources.map(r=>y.URI.revive(r))}}function p(o){return{...o,folder:y.URI.revive(o.folder)}}}),define(ge[284],pe([0,1,6,10,2,28,11,26,14,72,64,33,283,281,92,135]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends y.ExtHostSearch{constructor(p,o,r,g){super(p,r,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const c=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new w.RipgrepSearchProvider(c)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new w.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(L.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,o){const r=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(p,o,r,g){const c=(0,y.reviveQuery)(r);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,o,c,g):super.$provideFileSearchResults(p,o,r,g)}doInternalFileSearch(p,o,r,g){const c=E=>{if((0,P.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(p,o,E.map(n=>D.URI.file(n.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,c,g)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,o){return new v.NativeTextSearchManager(p,o,void 0,"textSearchProvider")}};_=Ve([He(0,S.IExtHostRpcService),He(1,k.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,i.ILogService)],_),e.NativeExtHostSearch=_}),define(ge[137],pe([0,1,296,124,81,22,15,3,6,9,12,32,105,106,297]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(b,I=""){this.debugLabel=I,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=T=>{if(this.traceSocketEvent("error",{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,i.onUnexpectedError)(T)}},this.socket.on("error",this._errorListener)}traceSocketEvent(b,I){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,I)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(b){const I=T=>{this.traceSocketEvent("read",T),b(C.VSBuffer.wrap(T))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(b){const I=T=>{this.traceSocketEvent("close",{hadError:T}),b({type:0,hadError:T,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(b){const I=()=>{this.traceSocketEvent("nodeEndReceived"),b()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(b){if(!this.socket.destroyed)try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,i.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,i.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=v;var _;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var A;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(A||(A={}));class p extends S.Disposable{constructor(b,I,T,x){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:T?.byteLength||0,recordInflateBytes:x}),this._flowManager=this._register(new o(this,I,T,x,this._onData,(O,F)=>this._write(O,F))),this._register(this._flowManager.onError(O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new w.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,I){this.socket.traceSocketEvent(b,I)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._flowManager.writeMessage(b)}_write(b,I){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let T=2;b.byteLength<126?T+=0:b.byteLength<2**16?T+=2:T+=8;const x=C.VSBuffer.alloc(T);if(I?x.writeUInt8(194,0):x.writeUInt8(130,0),b.byteLength<126)x.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){x.writeUInt8(126,1);let O=1;x.writeUInt8(b.byteLength>>>8&255,++O),x.writeUInt8(b.byteLength>>>0&255,++O)}else{x.writeUInt8(127,1);let O=1;x.writeUInt8(0,++O),x.writeUInt8(0,++O),x.writeUInt8(0,++O),x.writeUInt8(0,++O),x.writeUInt8(b.byteLength>>>24&255,++O),x.writeUInt8(b.byteLength>>>16&255,++O),x.writeUInt8(b.byteLength>>>8&255,++O),x.writeUInt8(b.byteLength>>>0&255,++O)}this.socket.write(C.VSBuffer.concat([x,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),T=I.readUInt8(0),x=(T&128)>>>7,O=(T&64)>>>6,F=I.readUInt8(1),W=(F&128)>>>7,M=F&127;this._state.state=2,this._state.readLen=2+(W?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=x,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(x),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),T=I.readUInt8(1),x=(T&128)>>>7;let O=T&127,F=1;O===126?O=I.readUInt8(++F)*2**8+I.readUInt8(++F):O===127&&(O=I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*2**24+I.readUInt8(++F)*2**16+I.readUInt8(++F)*2**8+I.readUInt8(++F));let W=0;x&&(W=I.readUInt8(++F)*2**24+I.readUInt8(++F)*2**16+I.readUInt8(++F)*2**8+I.readUInt8(++F)),this._state.state=3,this._state.readLen=O,this._state.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),c(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class o extends S.Disposable{constructor(b,I,T,x,O,F){super();this._tracer=b,this._onData=O,this._writeFn=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new r(this._tracer,x,T,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(W=>this._onError.fire(W))),this._register(this._zlibDeflateStream.onError(W=>this._onError.fire(W)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const I=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(I,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,I){return new Promise((T,x)=>{b.write(I),b.flush(O=>T(O))})}acceptFrame(b,I,T){this._readQueue.push({data:b,isCompressed:I,isLastFrameOfMessage:T}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1}}_inflateFrame(b,I,T){return new Promise((x,O)=>{b.write(I),T&&b.write(C.VSBuffer.fromByteArray([0,0,255,255])),b.flush(F=>x(F))})}}class r extends S.Disposable{constructor(b,I,T,x){super();this._tracer=b,this._recordInflateBytes=I,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=f.createInflateRaw(x),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(C.VSBuffer.wrap(O))}),T&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",T.buffer),this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(I)})}}class g extends S.Disposable{constructor(b,I){super();this._tracer=b,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibDeflate.on("data",T=>{this._tracer.traceSocketEvent("zlibDeflateData",T),this._pendingDeflateData.push(C.VSBuffer.wrap(T))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),b(I)})}}function c(u,b){if(b===0)return;let I=u.byteLength>>>2;for(let M=0;M<I;M++){const B=u.readUInt32BE(M*4);u.writeUInt32BE(B^b,M*4)}let T=I*4,x=u.byteLength-T;const O=b>>>24&255,F=b>>>16&255,W=b>>>8&255;x>=1&&u.writeUInt8(u.readUInt8(T)^O,T),x>=2&&u.writeUInt8(u.readUInt8(T+1)^F,T+1),x>=3&&u.writeUInt8(u.readUInt8(T+2)^W,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function n(){const u=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):b=(0,y.join)((0,D.tmpdir)(),`vscode-ipc-${u}.sock`),s(b),b}e.createRandomIPCHandle=n;function t(u,b,I){const T=(0,m.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${I}-${b}-sock`;let x;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${I}-${b}.sock`):x=(0,y.join)(u,`${I}-${b}.sock`),s(x),x}e.createStaticIPCHandle=t;function s(u){const b=E[R.platform];typeof b=="number"&&u.length>=b&&console.warn(`WARNING: IPC handle "${u}" is longer than ${b} chars, try a shorter --user-data-dir`)}class d extends a.IPCServer{constructor(b){super(d.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const I=k.Event.fromNodeEventEmitter(b,"connection");return k.Event.map(I,T=>({protocol:new w.Protocol(new v(T,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function l(u){return new Promise((b,I)=>{const T=(0,L.createServer)();T.on("error",I),T.listen(u,()=>{T.removeListener("error",I),b(new d(T))})})}e.serve=l;function h(u,b){return new Promise((I,T)=>{const x=(0,L.createConnection)(u,()=>{x.removeListener("error",T),I(w.Client.fromSocket(new v(x,`ipc-client${b}`),b))});x.once("error",T)})}e.connect=h}),define(ge[285],pe([0,1,137,277,60,38,2,197,11]),function(Y,e,m,L,D,C,i,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(a,w,f){this._commands=a,this.logService=w,this._ipcHandlePath=f,this._server=L.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(w.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,w){const f=[];a.setEncoding("utf8"),a.on("data",v=>f.push(v)),a.on("end",()=>{const v=JSON.parse(f.join(""));switch(v.type){case"open":this.open(v,w);break;case"openExternal":this.openExternal(v,w);break;case"status":this.getStatus(v,w);break;case"extensionManagement":this.manageExtensions(v,w).catch(this.logService.error);break;default:w.writeHead(404),w.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),w.end();break}})}open(a,w){const{fileURIs:f,folderURIs:v,forceNewWindow:_,diffMode:A,addMode:p,forceReuseWindow:o,gotoLineMode:r,waitMarkerFilePath:g,remoteAuthority:c}=a,E=[];if(Array.isArray(v))for(const d of v)try{E.push({folderUri:i.URI.parse(d)})}catch(l){}if(Array.isArray(f))for(const d of f)try{(0,k.hasWorkspaceFileExtension)(d)?E.push({workspaceUri:i.URI.parse(d)}):E.push({fileUri:i.URI.parse(d)})}catch(l){}const n=g?i.URI.file(g):void 0,s={forceNewWindow:_,diffMode:A,addMode:p,gotoLineMode:r,forceReuseWindow:o,preferNewWindow:!o&&!n&&!p,waitMarkerFileURI:n,remoteAuthority:c};this._commands.executeCommand("_remoteCLI.windowOpen",E,s),w.writeHead(200),w.end()}async openExternal(a,w){for(const f of a.uris){const v=i.URI.parse(f),_=v.scheme==="file"?v:f;await this._commands.executeCommand("_remoteCLI.openExternal",_)}w.writeHead(200),w.end()}async manageExtensions(a,w){try{const f=A=>A?.map(p=>/\.vsix$/i.test(p)?i.URI.parse(p):p),v={list:a.list,install:f(a.install),uninstall:f(a.uninstall),force:a.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);w.writeHead(200),w.write(_)}catch(f){w.writeHead(500),w.write(String(f),v=>{v&&this.logService.error(v)})}w.end()}async getStatus(a,w){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");w.writeHead(200),w.write(f),w.end()}catch(f){w.writeHead(500),w.write(String(f),v=>{v&&this.logService.error(v)}),w.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let R=class extends y{constructor(a,w){super(a,w,(0,m.createRandomIPCHandle)())}};R=Ve([He(0,C.IExtHostCommands),He(1,S.ILogService)],R),e.CLIServer=R}),define(ge[286],pe([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends D.RequireInterceptor{_installInterceptor(){const A=this,p=Y.__$__nodeRequire("module"),o=p._load;p._load=function(g,c,E){for(let n of A._alternatives){let t=n(g);if(t){g=t;break}}return A._factories.has(g)?A._factories.get(g).load(g,y.URI.file((0,w.realpathSync)(c.filename)),n=>o.apply(this,[n,c,E])):o.apply(this,arguments)}}}class v extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(f,A,this._registry).install(),m.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,i.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...c)=>c.length===0||!c[0]||c[0].type!=="__$console"?r.apply(process,c):(g.$logExtensionHostMessage(c[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,p,o){if(p.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let r=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{A&&m.mark(`code/extHost/willLoadExtensionCode/${A.value}`),r=Y.__$__nodeRequire(p.fsPath)}catch(g){return Promise.reject(g)}finally{A&&m.mark(`code/extHost/didLoadExtensionCode/${A.value}`),o.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const p in A){const o=A[p];o===null?delete process.env[p]:process.env[p]=o}}}e.ExtHostExtensionService=v}),define(ge[287],pe([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(R.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(p.ILoggerService,A.ExtHostLoggerService),(0,m.registerSingleton)(v.IExtensionStoragePaths,_.ExtensionStoragePaths),(0,m.registerSingleton)(y.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(P.IExtHostSearch,i.NativeExtHostSearch),(0,m.registerSingleton)(a.IExtHostTask,D.ExtHostTask),(0,m.registerSingleton)(w.IExtHostTerminalService,L.ExtHostTerminalService),(0,m.registerSingleton)(f.IExtHostTunnelService,S.ExtHostTunnelService)}),define(ge[288],pe([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(Y,e,m,L,D,C,i,k,S,y,R,P,a,w,f,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const A=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),s=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const p=process.exit.bind(process);function o(t){process.exit=function(s){if(t)p(s);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let r=function(t){p()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,s)=>{let d=null,l=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,u=3e5,b=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),h),I=new v.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),u);process.on("message",(x,O)=>{if(x&&x.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=P.VSBuffer.wrap(Buffer.from(x.initialDataChunk,"base64"));let W;if(x.skipWebSocketFrames)W=new k.NodeSocket(O,"extHost-socket");else{const M=P.VSBuffer.wrap(Buffer.from(x.inflateBytes,"base64"));W=new k.WebSocketNodeSocket(new k.NodeSocket(O,"extHost-socket"),x.permessageDeflate,M,!1)}d?(b.cancel(),I.cancel(),d.beginAcceptReconnection(W,F),d.endAcceptReconnection(),d.sendResume()):(clearTimeout(l),d=new i.PersistentProtocol(W,F),d.sendResume(),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{b.schedule()}))}if(x&&x.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(I.isScheduled())return;b.isScheduled()&&I.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,d)=>{const l=m.createConnection(t,()=>{l.removeListener("error",d),s(new i.PersistentProtocol(new k.NodeSocket(l,"extHost-renderer")))});l.once("error",d),l.on("close",()=>{r("renderer closed the socket")})})}}async function c(){const t=await g();return new class{constructor(){this._onMessage=new i.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(s=>{(0,y.isMessageOfType)(s,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||t.send(s)}drain(){return t.drain()}}}function E(t){return new Promise(s=>{const d=t.onMessage(l=>{d.dispose();const h=JSON.parse(l.toString()),u=h.commit,b=S.default.commit;u&&b&&u!==b&&p(55);let I=0;setInterval(function(){try{process.kill(h.parentPid,0),I=0}catch(x){x&&x.code==="EPERM"?(I++,I>=3&&r(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):r(`parent process ${h.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let T;try{T=Y.__$__nodeRequire("native-watchdog"),T.start(h.parentPid)}catch(x){(0,C.onUnexpectedError)(x)}t.send((0,y.createMessageOfType)(0)),s({protocol:t,initData:h})});t.send((0,y.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(I,T)=>{t.push(T),setTimeout(()=>{const x=t.indexOf(T);x>=0&&T.catch(O=>{t.splice(x,1),(0,C.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),I&&(0,C.onUnexpectedError)(I))})},1e3)}),process.on("rejectionHandled",I=>{const T=t.indexOf(I);T>=0&&t.splice(T,1)}),process.on("uncaughtException",function(I){(0,C.onUnexpectedError)(I)}),D.mark("code/extHost/willConnectToRenderer");const s=await c();D.mark("code/extHost/didConnectToRenderer");const d=await E(s);D.mark("code/extHost/didWaitForInitData");const{initData:l}=d;o(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,_.boolean)(A.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(T){p(T)}exists(T){return w.Promises.exists(T)}realpath(T){return(0,f.realpath)(T)}};let u=null;if(l.remote.authority&&A.uriTransformerPath)try{const T=Y.__$__nodeRequire(A.uriTransformerPath)(l.remote.authority);u=new a.URITransformer(T)}catch(I){console.error(I)}const b=new R.ExtensionHostMain(d.protocol,l,h,u);r=I=>b.terminate(I)}e.startExtensionHostProcess=n}),define(ge[299],pe([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b9cf83f70bb6b4697b544a97c7056dfd28fccc5f/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
